package org.matheclipse.core.expression;

import org.matheclipse.parser.client.ast.IConstantOperators;

/**
 * Default header strings
 * 
 */
public interface IConstantHeaders extends IConstantOperators {
	public final static String AddTo = "AddTo"; // operator +=

	public final static String And = "And"; // operator &&

	public final static String Automatic = "Automatic";

	public final static String Axes = "Axes";

	public final static String AxesOrigin = "AxesOrigin";

	public final static String AxesStyle = "AxesStyle";

	public final static String Background = "Background";

	public final static String BoxRatios = "BoxRatios";

	public final static String ComplexHead = "Complex";

	public final static String ComplexInfinity = "ComplexInfinity";

	public final static String CompoundExpression = "CompoundExpression"; // operator

	// ;

	public final static String Condition = "Condition"; // operator =

	public final static String Constant = "Constant";

	public final static String Decrement = "Decrement"; // operator --

	public final static String DivideBy = "DivideBy"; // operator /=

	public final static String DirectedInfinity = "DirectedInfinity";

	// vector and matrix multiplication
	public final static String Dot = "Dot"; // operator .

	public final static String E = "E"; // euler constant

	public final static String Equal = "Equal"; // operator ==

	public final static String Factorial = "Factorial"; // operator !

	public final static String False = "False"; // false constant

	public final static String Flat = "Flat";

	public final static String Function = "Function";

	public final static String Greater = "Greater"; // operator >

	public final static String GreaterEqual = "GreaterEqual"; // operator >=

	public final static String Hold = "Hold";

	public final static String HoldAll = "HoldAll";

	public final static String HoldFirst = "HoldFirst";

	public final static String HoldRest = "HoldRest";

	public final static String Infinity = "Infinity";

	public final static String Increment = "Increment"; // operator ++

	public final static String IntegerHead = "Integer";

	public final static String Less = "Less"; // operator <

	public final static String LessEqual = "LessEqual"; // operator <=

	public final static String Line = "Line";

	public final static String Listable = "Listable";

	public final static String Log = "Log";
	
	public final static String MethodHead = "MethodHead";
	
	public final static String MeshRange = "MeshRange";

	public final static String Minus = "Minus"; // unary operator -

	public final static String NHoldAll = "NHoldAll";

	public final static String NHoldFirst = "NHoldFirst";

	public final static String NHoldRest = "NHoldRest";

	public final static String Not = "Not"; // operator !

	public final static String Null = "Null"; // null header

	public final static String NumericFunction = "NumericFunction";

	public final static String OneIdentity = "OneIdentity";

	public final static String Or = "Or"; // operator ||

	public final static String Orderless = "Orderless";

	public final static String PatternHead = "Pattern";

	public final static String BlankHead = "Blank";

	public final static String Pi = "Pi"; // pi constant

	public final static String PlotRange = "PlotRange";

	public final static String Plus = "Plus"; // operator +

	public final static String Power = "Power"; // operator ^

	public final static String PreDecrement = "PreDecrement"; // operator --

	public final static String PreIncrement = "PreIncrement"; // operator ++

	public final static String RationalHead = "Rational";

	public final static String RealHead = "Real";

	public final static String ReplaceAll = "ReplaceAll"; // operator /.

	public final static String Rule = "Rule"; // operator ->

	public final static String RuleDelayed = "RuleDelayed"; // operator :>

	public final static String Second = "Second"; // true constant

	public final static String Set = "Set"; // operator =

	public final static String SetDelayed = "SetDelayed"; // operator :=
	
	public final static String StringHead = "String";

	public final static String Subtract = "Subtract"; // binary operator -

	public final static String SubtractFrom = "SubtractFrom"; // operator -=

	public final static String SymbolHead = "Symbol";

	public final static String Times = "Times"; // operator *

	public final static String TimesBy = "TimesBy"; // operator *=

	public final static String True = "True"; // true constant

	public final static String Unequal = "Unequal"; // operator !=

	public final static String UpSet = "UpSet"; // operator ^=

	public final static String UpSetDelayed = "UpSetDelayed"; // operator ^:=

	public final static String White = "White";
}
