package org.matheclipse.core.integrate.rubi;


import static org.matheclipse.core.expression.F.*;
import static org.matheclipse.core.integrate.rubi.UtilityFunctionCtors.*;
import static org.matheclipse.core.integrate.rubi.UtilityFunctions.*;
import org.matheclipse.core.interfaces.IAST;
import org.matheclipse.core.interfaces.IExpr;

/** 
 * IndefiniteIntegrationRules from the <a href="http://www.apmaths.uwo.ca/~arich/">Rubi -
 * rule-based integrator</a>.
 *  
 */
public class IndefiniteIntegrationRules11 { 
  public static IAST RULES = List( 
SetDelayed(Int(Power(Plus($p("a",true),Times($p("b",true),Log(Times($p("c",true),Power(Plus($p("d",true),Times($p("e",true),$p("x"))),$p("n",true)))))),$p("p")),$p("x",$s("Symbol"))),
    Condition(Plus(Times($s("x"),Power(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power(Plus($s("d"),Times($s("e"),$s("x"))),$s("n")))))),$s("p"))),Times(CN1,Dist(Times(Times(Times($s("b"),$s("e")),$s("n")),$s("p")),Int(Times($s("x"),Times(Power(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power(Plus($s("d"),Times($s("e"),$s("x"))),$s("n")))))),Plus($s("p"),Times(CN1,C1))),Power(Plus($s("d"),Times($s("e"),$s("x"))),CN1))),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e"),$s("n")),$s("x")),RationalQ($s("p"))),Greater($s("p"),C0)))),
SetDelayed(Int(Power(Plus($p("a",true),Times($p("b",true),Log(Times($p("c",true),Power($p("x"),$p("n",true)))))),$p("p")),$p("x",$s("Symbol"))),
    Condition(Plus(Times($s("x"),Times(Power(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n")))))),Plus($s("p"),C1)),Power(Times(Times($s("b"),$s("n")),Plus($s("p"),C1)),CN1))),Times(CN1,Dist(Times(C1,Power(Times(Times($s("b"),$s("n")),Plus($s("p"),C1)),CN1)),Int(Power(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n")))))),Plus($s("p"),C1)),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("n")),$s("x")),RationalQ($s("p"))),Less($s("p"),CN1)))),
SetDelayed(Int(Power(Log(Times($p("c",true),Power(Plus($p("d",true),Times($p("e",true),$p("x"))),$p("n",true)))),$p("p")),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Plus($s("d"),Times($s("e"),$s("x"))),Times(Power(Log(Times($s("c"),Power(Plus($s("d"),Times($s("e"),$s("x"))),$s("n")))),Plus($s("p"),C1)),Power(Times(Times($s("e"),$s("n")),Plus($s("p"),C1)),CN1))),Times(CN1,Dist(Times(C1,Power(Times($s("n"),Plus($s("p"),C1)),CN1)),Int(Power(Log(Times($s("c"),Power(Plus($s("d"),Times($s("e"),$s("x"))),$s("n")))),Plus($s("p"),C1)),$s("x"))))),And(And(FreeQ(List($s("c"),$s("d"),$s("e"),$s("n")),$s("x")),RationalQ($s("p"))),Less($s("p"),CN1)))),
SetDelayed(Int(Power(Plus($p("a",true),Times($p("b",true),Log(Times($p("c",true),Power(Plus($p("d",true),Times($p("e",true),$p("x"))),$p("n",true)))))),$p("p")),$p("x",$s("Symbol"))),
    Condition(Times(Times(Plus($s("d"),Times($s("e"),$s("x"))),Gamma(Plus($s("p"),C1),Times(Times(CN1,Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power(Plus($s("d"),Times($s("e"),$s("x"))),$s("n"))))))),Power(Times($s("b"),$s("n")),CN1)))),Times(Power(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power(Plus($s("d"),Times($s("e"),$s("x"))),$s("n")))))),$s("p")),Power(Times(Times(Times($s("e"),Power(Times(Times(CN1,Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power(Plus($s("d"),Times($s("e"),$s("x"))),$s("n"))))))),Power(Times($s("b"),$s("n")),CN1)),$s("p"))),Power(E,Times($s("a"),Power(Times($s("b"),$s("n")),CN1)))),Power(Times($s("c"),Power(Plus($s("d"),Times($s("e"),$s("x"))),$s("n"))),Times(C1,Power($s("n"),CN1)))),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e"),$s("n"),$s("p")),$s("x")),NonzeroQ(Plus($s("p"),C1))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Plus($p("a",true),Times($p("b",true),Log(Times($p("c",true),Power($p("x"),$p("n",true)))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Power($s("x"),Plus($s("m"),C1)),Times(ExpIntegralEi(Times(Plus($s("m"),C1),Times(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n")))))),Power(Times($s("b"),$s("n")),CN1)))),Power(Times(Times(Times($s("b"),$s("n")),Power(E,Times($s("a"),Times(Plus($s("m"),C1),Power(Times($s("b"),$s("n")),CN1))))),Power(Times($s("c"),Power($s("x"),$s("n"))),Times(Plus($s("m"),C1),Power($s("n"),CN1)))),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("m"),$s("n")),$s("x")),NonzeroQ(Plus($s("m"),C1))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Sqrt(Plus($p("a",true),Times($p("b",true),Log(Times($p("c",true),Power($p("x"),$p("n",true))))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Times(Sqrt(Pi),Power($s("x"),Plus($s("m"),C1))),Times(Erfi(Times(Rt(Times(Plus($s("m"),C1),Power(Times($s("b"),$s("n")),CN1)),C2),Sqrt(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))))),Power(Times(Times(Times(Times($s("b"),$s("n")),Rt(Times(Plus($s("m"),C1),Power(Times($s("b"),$s("n")),CN1)),C2)),Power(E,Times($s("a"),Times(Plus($s("m"),C1),Power(Times($s("b"),$s("n")),CN1))))),Power(Times($s("c"),Power($s("x"),$s("n"))),Times(Plus($s("m"),C1),Power($s("n"),CN1)))),CN1))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("m"),$s("n")),$s("x")),NonzeroQ(Plus($s("m"),C1))),PosQ(Times(Plus($s("m"),C1),Power(Times($s("b"),$s("n")),CN1)))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Sqrt(Plus($p("a",true),Times($p("b",true),Log(Times($p("c",true),Power($p("x"),$p("n",true))))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Times(Sqrt(Pi),Power($s("x"),Plus($s("m"),C1))),Times(Erf(Times(Rt(Times(Times(CN1,Plus($s("m"),C1)),Power(Times($s("b"),$s("n")),CN1)),C2),Sqrt(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))))),Power(Times(Times(Times(Times($s("b"),$s("n")),Rt(Times(Times(CN1,Plus($s("m"),C1)),Power(Times($s("b"),$s("n")),CN1)),C2)),Power(E,Times($s("a"),Times(Plus($s("m"),C1),Power(Times($s("b"),$s("n")),CN1))))),Power(Times($s("c"),Power($s("x"),$s("n"))),Times(Plus($s("m"),C1),Power($s("n"),CN1)))),CN1))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("m"),$s("n")),$s("x")),NonzeroQ(Plus($s("m"),C1))),NegQ(Times(Plus($s("m"),C1),Power(Times($s("b"),$s("n")),CN1)))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Plus($p("a",true),Times($p("b",true),Log(Times($p("c",true),Power($p("x"),$p("n",true)))))),$p("p"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Times(Power(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n")))))),$s("p")),Power(Plus($s("m"),C1),CN1))),Times(CN1,Dist(Times(Times($s("b"),$s("n")),Times($s("p"),Power(Plus($s("m"),C1),CN1))),Int(Times(Power($s("x"),$s("m")),Power(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n")))))),Plus($s("p"),Times(CN1,C1)))),$s("x"))))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("m"),$s("n")),$s("x")),RationalQ($s("p"))),Greater($s("p"),C0)),NonzeroQ(Plus($s("m"),C1))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Plus($p("a",true),Times($p("b",true),Log(Times($p("c",true),Power($p("x"),$p("n",true)))))),$p("p"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Times(Power(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n")))))),Plus($s("p"),C1)),Power(Times(Times($s("b"),$s("n")),Plus($s("p"),C1)),CN1))),Times(CN1,Dist(Times(Plus($s("m"),C1),Power(Times(Times($s("b"),$s("n")),Plus($s("p"),C1)),CN1)),Int(Times(Power($s("x"),$s("m")),Power(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n")))))),Plus($s("p"),C1))),$s("x"))))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("m"),$s("n")),$s("x")),RationalQ($s("p"))),Less($s("p"),CN1)),NonzeroQ(Plus($s("m"),C1))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Plus($p("a",true),Times($p("b",true),Log(Times($p("c",true),Power($p("x"),$p("n",true)))))),$p("p"))),$p("x",$s("Symbol"))),
    Condition(Times(Times(Power($s("x"),Plus($s("m"),C1)),Gamma(Plus($s("p"),C1),Times(Times(CN1,Plus($s("m"),C1)),Times(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n")))))),Power(Times($s("b"),$s("n")),CN1))))),Times(Power(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n")))))),$s("p")),Power(Times(Times(Times(Plus($s("m"),C1),Power(E,Times($s("a"),Times(Plus($s("m"),C1),Power(Times($s("b"),$s("n")),CN1))))),Power(Times($s("c"),Power($s("x"),$s("n"))),Times(Plus($s("m"),C1),Power($s("n"),CN1)))),Power(Times(Times(CN1,Plus($s("m"),C1)),Times(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n")))))),Power(Times($s("b"),$s("n")),CN1))),$s("p"))),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("m"),$s("n"),$s("p")),$s("x")),NonzeroQ(Plus($s("m"),C1))))),
SetDelayed(Int(Power(Log(Times($p("a",true),Power(Times($p("b",true),Power($p("x"),$p("n",true))),$p("p")))),$p("q",true)),$p("x",$s("Symbol"))),
    Condition(Subst(Int(Power(Log(Power($s("x"),Times($s("n"),$s("p")))),$s("q")),$s("x")),Power($s("x"),Times($s("n"),$s("p"))),Times($s("a"),Power(Times($s("b"),Power($s("x"),$s("n"))),$s("p")))),FreeQ(List($s("a"),$s("b"),$s("n"),$s("p"),$s("q")),$s("x")))),
SetDelayed(Int(Power(Log(Times($p("a",true),Power(Times($p("b",true),Power(Times($p("c",true),Power($p("x"),$p("n",true))),$p("p"))),$p("q")))),$p("r",true)),$p("x",$s("Symbol"))),
    Condition(Subst(Int(Power(Log(Power($s("x"),Times(Times($s("n"),$s("p")),$s("q")))),$s("r")),$s("x")),Power($s("x"),Times(Times($s("n"),$s("p")),$s("q"))),Times($s("a"),Power(Times($s("b"),Power(Times($s("c"),Power($s("x"),$s("n"))),$s("p"))),$s("q")))),FreeQ(List($s("a"),$s("b"),$s("c"),$s("n"),$s("p"),$s("q"),$s("r")),$s("x")))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Log(Times($p("a",true),Power(Times($p("b",true),Power($p("x"),$p("n",true))),$p("p")))),$p("q",true))),$p("x",$s("Symbol"))),
    Condition(Subst(Int(Times(Power($s("x"),$s("m")),Power(Log(Power($s("x"),Times($s("n"),$s("p")))),$s("q"))),$s("x")),Power($s("x"),Times($s("n"),$s("p"))),Times($s("a"),Power(Times($s("b"),Power($s("x"),$s("n"))),$s("p")))),And(And(FreeQ(List($s("a"),$s("b"),$s("m"),$s("n"),$s("p"),$s("q")),$s("x")),NonzeroQ(Plus($s("m"),C1))),Not(SameQ(Power($s("x"),Times($s("n"),$s("p"))),Times($s("a"),Power(Times($s("b"),Power($s("x"),$s("n"))),$s("p")))))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Log(Times($p("a",true),Power(Times($p("b",true),Power(Times($p("c",true),Power($p("x"),$p("n",true))),$p("p"))),$p("q")))),$p("r",true))),$p("x",$s("Symbol"))),
    Condition(Subst(Int(Times(Power($s("x"),$s("m")),Power(Log(Power($s("x"),Times(Times($s("n"),$s("p")),$s("q")))),$s("r"))),$s("x")),Power($s("x"),Times(Times($s("n"),$s("p")),$s("q"))),Times($s("a"),Power(Times($s("b"),Power(Times($s("c"),Power($s("x"),$s("n"))),$s("p"))),$s("q")))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("m"),$s("n"),$s("p"),$s("q"),$s("r")),$s("x")),NonzeroQ(Plus($s("m"),C1))),Not(SameQ(Power($s("x"),Times(Times($s("n"),$s("p")),$s("q"))),Times($s("a"),Power(Times($s("b"),Power(Times($s("c"),Power($s("x"),$s("n"))),$s("p"))),$s("q")))))))),
SetDelayed(Int(Times(Power(Log(Times($p("c",true),Power(Plus($p("a"),Times($p("b",true),$p("x"))),$p("n",true)))),$p("p",true)),Power(Plus($p("d",true),Times($p("e",true),$p("x"))),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power(Log(Times($s("c"),Power(Plus($s("a"),Times($s("b"),$s("x"))),$s("n")))),$s("p")),Times(Log(Times($s("b"),Times(Plus($s("d"),Times($s("e"),$s("x"))),Power(Plus(Times($s("b"),$s("d")),Times(CN1,Times($s("a"),$s("e")))),CN1)))),Power($s("e"),CN1))),Times(CN1,Dist(Times(Times($s("b"),$s("n")),Times($s("p"),Power($s("e"),CN1))),Int(Times(Power(Log(Times($s("c"),Power(Plus($s("a"),Times($s("b"),$s("x"))),$s("n")))),Plus($s("p"),Times(CN1,C1))),Times(Log(Times($s("b"),Times(Plus($s("d"),Times($s("e"),$s("x"))),Power(Plus(Times($s("b"),$s("d")),Times(CN1,Times($s("a"),$s("e")))),CN1)))),Power(Plus($s("a"),Times($s("b"),$s("x"))),CN1))),$s("x"))))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e"),$s("n")),$s("x")),RationalQ($s("p"))),Greater($s("p"),C0)),NonzeroQ(Plus(Times($s("b"),$s("d")),Times(CN1,Times($s("a"),$s("e")))))))),
SetDelayed(Int(Times(Power(Log(Times($p("c",true),Power(Plus($p("a"),Times($p("b",true),$p("x"))),$p("n",true)))),$p("p",true)),Times(Log(Times($p("h",true),Plus($p("f",true),Times($p("g",true),$p("x"))))),Power(Plus($p("d"),Times($p("e",true),$p("x"))),CN1))),$p("x",$s("Symbol"))),
    Condition(Module(List(Set($s("q"),Simplify(Plus(C1,Times(CN1,Times($s("h"),Plus($s("f"),Times($s("g"),$s("x"))))))))),Plus(Times(Times(CN1,Power(Log(Times($s("c"),Power(Plus($s("a"),Times($s("b"),$s("x"))),$s("n")))),$s("p"))),Times(PolyLog(C2,$s("q")),Power($s("e"),CN1))),Dist(Times(Times($s("b"),$s("n")),Times($s("p"),Power($s("e"),CN1))),Int(Times(Power(Log(Times($s("c"),Power(Plus($s("a"),Times($s("b"),$s("x"))),$s("n")))),Plus($s("p"),Times(CN1,C1))),Times(PolyLog(C2,$s("q")),Power(Plus($s("a"),Times($s("b"),$s("x"))),CN1))),$s("x"))))),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e"),$s("f"),$s("g"),$s("h"),$s("n")),$s("x")),RationalQ($s("p"))),Greater($s("p"),C0)),ZeroQ(Plus(Times($s("a"),$s("e")),Times(CN1,Times($s("b"),$s("d")))))),ZeroQ(Plus(Times(Times($s("a"),$s("g")),$s("h")),Times(CN1,Times($s("b"),Plus(Times($s("f"),$s("h")),Times(CN1,C1))))))))),
SetDelayed(Int(Times(Power(Log(Times($p("c",true),Power(Plus($p("a"),Times($p("b",true),$p("x"))),$p("n",true)))),$p("p",true)),Times(PolyLog($p("m"),Times($p("h",true),Plus($p("f",true),Times($p("g",true),$p("x"))))),Power(Plus($p("d"),Times($p("e",true),$p("x"))),CN1))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power(Log(Times($s("c"),Power(Plus($s("a"),Times($s("b"),$s("x"))),$s("n")))),$s("p")),Times(PolyLog(Plus($s("m"),C1),Times($s("h"),Plus($s("f"),Times($s("g"),$s("x"))))),Power($s("e"),CN1))),Times(CN1,Dist(Times(Times($s("b"),$s("n")),Times($s("p"),Power($s("e"),CN1))),Int(Times(Power(Log(Times($s("c"),Power(Plus($s("a"),Times($s("b"),$s("x"))),$s("n")))),Plus($s("p"),Times(CN1,C1))),Times(PolyLog(Plus($s("m"),C1),Times($s("h"),Plus($s("f"),Times($s("g"),$s("x"))))),Power(Plus($s("a"),Times($s("b"),$s("x"))),CN1))),$s("x"))))),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e"),$s("f"),$s("g"),$s("h"),$s("m"),$s("n")),$s("x")),RationalQ($s("p"))),Greater($s("p"),C0)),ZeroQ(Plus(Times($s("a"),$s("e")),Times(CN1,Times($s("b"),$s("d")))))),ZeroQ(Plus(Times($s("a"),$s("g")),Times(CN1,Times($s("b"),$s("f")))))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Log(Times($p("c",true),Power(Plus($p("a"),Times($p("b",true),$p("x"))),$p("n",true)))),$p("p"))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(Power($s("x"),$s("m")),Plus($s("a"),Times($s("b"),$s("x")))),Times(Power(Log(Times($s("c"),Power(Plus($s("a"),Times($s("b"),$s("x"))),$s("n")))),$s("p")),Power(Times($s("b"),Plus($s("m"),C1)),CN1))),Times(CN1,Dist(Times($s("a"),Times($s("m"),Power(Times($s("b"),Plus($s("m"),C1)),CN1))),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,C1))),Power(Log(Times($s("c"),Power(Plus($s("a"),Times($s("b"),$s("x"))),$s("n")))),$s("p"))),$s("x"))))),Times(CN1,Dist(Times($s("n"),Times($s("p"),Power(Plus($s("m"),C1),CN1))),Int(Times(Power($s("x"),$s("m")),Power(Log(Times($s("c"),Power(Plus($s("a"),Times($s("b"),$s("x"))),$s("n")))),Plus($s("p"),Times(CN1,C1)))),$s("x"))))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("n")),$s("x")),RationalQ(List($s("m"),$s("p")))),Greater($s("m"),C0)),Greater($s("p"),C0)))),
SetDelayed(Int(Times(Power(Log(Times($p("c",true),Power(Plus($p("a"),Times($p("b",true),$p("x"))),$p("n",true)))),$p("p")),Power(Power($p("x"),C2),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Plus($s("a"),Times($s("b"),$s("x")))),Times(Power(Log(Times($s("c"),Power(Plus($s("a"),Times($s("b"),$s("x"))),$s("n")))),$s("p")),Power(Times($s("a"),$s("x")),CN1))),Dist(Times(Times($s("b"),$s("n")),Times($s("p"),Power($s("a"),CN1))),Int(Times(Power(Log(Times($s("c"),Power(Plus($s("a"),Times($s("b"),$s("x"))),$s("n")))),Plus($s("p"),Times(CN1,C1))),Power($s("x"),CN1)),$s("x")))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("n")),$s("x")),RationalQ($s("p"))),Greater($s("p"),C0)))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Log(Times($p("c",true),Power(Plus($p("a"),Times($p("b",true),$p("x"))),$p("n",true)))),$p("p"))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(Power($s("x"),Plus($s("m"),C1)),Plus($s("a"),Times($s("b"),$s("x")))),Times(Power(Log(Times($s("c"),Power(Plus($s("a"),Times($s("b"),$s("x"))),$s("n")))),$s("p")),Power(Times($s("a"),Plus($s("m"),C1)),CN1))),Times(CN1,Dist(Times(Times($s("b"),Plus($s("m"),C2)),Power(Times($s("a"),Plus($s("m"),C1)),CN1)),Int(Times(Power($s("x"),Plus($s("m"),C1)),Power(Log(Times($s("c"),Power(Plus($s("a"),Times($s("b"),$s("x"))),$s("n")))),$s("p"))),$s("x"))))),Times(CN1,Dist(Times(Times($s("b"),$s("n")),Times($s("p"),Power(Times($s("a"),Plus($s("m"),C1)),CN1))),Int(Times(Power($s("x"),Plus($s("m"),C1)),Power(Log(Times($s("c"),Power(Plus($s("a"),Times($s("b"),$s("x"))),$s("n")))),Plus($s("p"),Times(CN1,C1)))),$s("x"))))),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("n")),$s("x")),RationalQ(List($s("m"),$s("p")))),Less($s("m"),CN1)),Unequal($s("m"),integer(-2L))),Greater($s("p"),C0)))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Log(Times($p("c",true),Power(Plus($p("a"),Times($p("b",true),$p("x"))),$p("n",true)))),$p("p"))),$p("x",$s("Symbol"))),
    Condition(Dist(Times(C1,Power($s("b"),CN1)),Subst(Int(Times(Power(Plus(Times(Times(CN1,$s("a")),Power($s("b"),CN1)),Times($s("x"),Power($s("b"),CN1))),$s("m")),Power(Log(Times($s("c"),Power($s("x"),$s("n")))),$s("p"))),$s("x")),$s("x"),Plus($s("a"),Times($s("b"),$s("x"))))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("n"),$s("p")),$s("x")),IntegerQ($s("m"))),Greater($s("m"),C0)),Not(And(RationalQ($s("p")),Greater($s("p"),C0)))))),
SetDelayed(Int(Power(Log(Times($p("c",true),Power(Plus($p("a"),Times($p("b",true),Power($p("x"),CN1))),$p("n",true)))),$p("p")),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Plus($s("b"),Times($s("a"),$s("x"))),Times(Power(Log(Times($s("c"),Power(Plus($s("a"),Times($s("b"),Power($s("x"),CN1))),$s("n")))),$s("p")),Power($s("a"),CN1))),Dist(Times(Times(Times($s("b"),Power($s("a"),CN1)),$s("n")),$s("p")),Int(Times(Power(Log(Times($s("c"),Power(Plus($s("a"),Times($s("b"),Power($s("x"),CN1))),$s("n")))),Plus($s("p"),Times(CN1,C1))),Power($s("x"),CN1)),$s("x")))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("n")),$s("x")),IntegerQ($s("p"))),Greater($s("p"),C0)))),
SetDelayed(Int(Power(Log(Times($p("c",true),Power(Plus($p("a"),Times($p("b",true),Power($p("x"),C2))),$p("n",true)))),C2),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Plus(Times($s("x"),Power(Log(Times($s("c"),Power(Plus($s("a"),Times($s("b"),Power($s("x"),C2))),$s("n")))),C2)),Times(Times(integer(8L),Power($s("n"),C2)),$s("x"))),Times(CN1,Times(Times(Times(C4,$s("n")),$s("x")),Log(Times($s("c"),Power(Plus($s("a"),Times($s("b"),Power($s("x"),C2))),$s("n"))))))),Times(Times($s("n"),Times(Sqrt($s("a")),Power(Sqrt(Times(CN1,$s("b"))),CN1))),Plus(Plus(Plus(Plus(Plus(Plus(Plus(Plus(Times(Times(C4,$s("n")),Log(Times(Plus(Times(CN1,Sqrt($s("a"))),Times(Sqrt(Times(CN1,$s("b"))),$s("x"))),Power(Plus(Sqrt($s("a")),Times(Sqrt(Times(CN1,$s("b"))),$s("x"))),CN1)))),Times(CN1,Times(Times(Times(C4,$s("n")),ArcTanh(Times(Sqrt(Times(CN1,$s("b"))),Times($s("x"),Power(Sqrt($s("a")),CN1))))),Plus(Log(Plus(Times(Times(CN1,Sqrt($s("a"))),Power(Sqrt(Times(CN1,$s("b"))),CN1)),$s("x"))),Log(Plus(Times(Sqrt($s("a")),Power(Sqrt(Times(CN1,$s("b"))),CN1)),$s("x"))))))),Times(CN1,Times($s("n"),Power(Log(Plus(Times(Times(CN1,Sqrt($s("a"))),Power(Sqrt(Times(CN1,$s("b"))),CN1)),$s("x"))),C2)))),Times($s("n"),Power(Log(Plus(Times(Sqrt($s("a")),Power(Sqrt(Times(CN1,$s("b"))),CN1)),$s("x"))),C2))),Times(CN1,Times(Times(Times(C2,$s("n")),Log(Plus(Times(Sqrt($s("a")),Power(Sqrt(Times(CN1,$s("b"))),CN1)),$s("x")))),Log(Plus(C1D2,Times(CN1,Times(Sqrt(Times(CN1,$s("b"))),Times($s("x"),Power(Times(C2,Sqrt($s("a"))),CN1))))))))),Times(Times(Times(C2,$s("n")),Log(Plus(Times(Times(CN1,Sqrt($s("a"))),Power(Sqrt(Times(CN1,$s("b"))),CN1)),$s("x")))),Log(Times(Plus(C1,Times(Sqrt(Times(CN1,$s("b"))),Times($s("x"),Power(Sqrt($s("a")),CN1)))),C1D2)))),Times(Times(C4,ArcTanh(Times(Sqrt(Times(CN1,$s("b"))),Times($s("x"),Power(Sqrt($s("a")),CN1))))),Log(Times($s("c"),Power(Plus($s("a"),Times($s("b"),Power($s("x"),C2))),$s("n")))))),Times(Times(C2,$s("n")),PolyLog(C2,Plus(C1D2,Times(CN1,Times(Sqrt(Times(CN1,$s("b"))),Times($s("x"),Power(Times(C2,Sqrt($s("a"))),CN1)))))))),Times(CN1,Times(Times(C2,$s("n")),PolyLog(C2,Times(Plus(C1,Times(Sqrt(Times(CN1,$s("b"))),Times($s("x"),Power(Sqrt($s("a")),CN1)))),C1D2))))))),FreeQ(List($s("a"),$s("b"),$s("c"),$s("n")),$s("x")))),
SetDelayed(Int(Power(Log(Times($p("d",true),Power(Plus(Plus($p("a",true),Times($p("b",true),$p("x"))),Times($p("c",true),Power($p("x"),C2))),$p("n",true)))),C2),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times($s("x"),Power(Log(Times($s("d"),Power(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))),$s("n")))),C2)),Times(CN1,Dist(Times(Times(C2,$s("b")),$s("n")),Int(Times($s("x"),Times(Log(Times($s("d"),Power(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))),$s("n")))),Power(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))),CN1))),$s("x"))))),Times(CN1,Dist(Times(Times(C4,$s("c")),$s("n")),Int(Times(Power($s("x"),C2),Times(Log(Times($s("d"),Power(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))),$s("n")))),Power(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))),CN1))),$s("x"))))),FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("n")),$s("x")))),
SetDelayed(Int(Log(Times($p("a",true),Power(Log(Times($p("b",true),Power($p("x"),$p("n",true)))),$p("p",true)))),$p("x",$s("Symbol"))),
    Condition(Plus(Times($s("x"),Log(Times($s("a"),Power(Log(Times($s("b"),Power($s("x"),$s("n")))),$s("p"))))),Times(CN1,Dist(Times($s("n"),$s("p")),Int(Times(C1,Power(Log(Times($s("b"),Power($s("x"),$s("n")))),CN1)),$s("x"))))),FreeQ(List($s("a"),$s("b"),$s("n"),$s("p")),$s("x")))),
SetDelayed(Int(Times(Log(Times($p("a",true),Power(Log(Times($p("b",true),Power($p("x"),$p("n",true)))),$p("p",true)))),Power($p("x"),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Log(Times($s("b"),Power($s("x"),$s("n")))),Times(Plus(Times(CN1,$s("p")),Log(Times($s("a"),Power(Log(Times($s("b"),Power($s("x"),$s("n")))),$s("p"))))),Power($s("n"),CN1))),FreeQ(List($s("a"),$s("b"),$s("n"),$s("p")),$s("x")))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Log(Times($p("a",true),Power(Log(Times($p("b",true),Power($p("x"),$p("n",true)))),$p("p",true))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Times(Log(Times($s("a"),Power(Log(Times($s("b"),Power($s("x"),$s("n")))),$s("p")))),Power(Plus($s("m"),C1),CN1))),Times(CN1,Dist(Times($s("n"),Times($s("p"),Power(Plus($s("m"),C1),CN1))),Int(Times(Power($s("x"),$s("m")),Power(Log(Times($s("b"),Power($s("x"),$s("n")))),CN1)),$s("x"))))),And(FreeQ(List($s("a"),$s("b"),$s("m"),$s("n"),$s("p")),$s("x")),NonzeroQ(Plus($s("m"),C1))))),
SetDelayed(Int(Times(Power(Log(Times(Plus($p("a",true),Times($p("b",true),$p("x"))),Power(Plus($p("c"),Times($p("d",true),$p("x"))),CN1))),$p("m",true)),Power($p("x"),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Subst(Int(Times(Power(Log(Plus(Times($s("a"),Power($s("c"),CN1)),Times($s("x"),Power($s("c"),CN1)))),$s("m")),Power($s("x"),CN1)),$s("x")),$s("x"),Times(Plus(Times($s("b"),$s("c")),Times(CN1,Times($s("a"),$s("d")))),Times($s("x"),Power(Plus($s("c"),Times($s("d"),$s("x"))),CN1)))),Times(CN1,Subst(Int(Times(Power(Log(Plus(Times($s("b"),Power($s("d"),CN1)),Times($s("x"),Power($s("d"),CN1)))),$s("m")),Power($s("x"),CN1)),$s("x")),$s("x"),Times(Times(CN1,Plus(Times($s("b"),$s("c")),Times(CN1,Times($s("a"),$s("d"))))),Power(Plus($s("c"),Times($s("d"),$s("x"))),CN1))))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),IntegerQ($s("m"))),Greater($s("m"),C0)),NonzeroQ(Plus(Times($s("b"),$s("c")),Times(CN1,Times($s("a"),$s("d")))))))),
SetDelayed(Int(Times(Plus($p("A",true),Times($p("B",true),Log(Plus($p("c",true),Times($p("d",true),$p("x")))))),Power(Sqrt(Plus($p("a"),Times($p("b",true),Log(Plus($p("c",true),Times($p("d",true),$p("x"))))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Dist(Times(Plus(Times($s("b"),$s("A")),Times(CN1,Times($s("a"),$s("B")))),Power($s("b"),CN1)),Int(Times(C1,Power(Sqrt(Plus($s("a"),Times($s("b"),Log(Plus($s("c"),Times($s("d"),$s("x"))))))),CN1)),$s("x"))),Dist(Times($s("B"),Power($s("b"),CN1)),Int(Sqrt(Plus($s("a"),Times($s("b"),Log(Plus($s("c"),Times($s("d"),$s("x"))))))),$s("x")))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("A"),$s("B")),$s("x")),NonzeroQ(Plus(Times($s("b"),$s("A")),Times(CN1,Times($s("a"),$s("B")))))))),
SetDelayed(Int(Times(Power(Plus($p("a",true),Times($p("b",true),$p("x"))),$p("m",true)),Power(Log(Plus($p("c",true),Times($p("d",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power(Plus($s("a"),Times($s("b"),$s("x"))),Plus($s("m"),C1)),Times(Power(Log(Plus($s("c"),Times($s("d"),$s("x")))),$s("n")),Power(Times($s("b"),Plus($s("m"),C1)),CN1))),Times(CN1,Dist(Times($s("d"),Times($s("n"),Power(Times($s("b"),Plus($s("m"),C1)),CN1))),Int(Regularize(Times(Power(Plus($s("a"),Times($s("b"),$s("x"))),Plus($s("m"),C1)),Times(Power(Log(Plus($s("c"),Times($s("d"),$s("x")))),Plus($s("n"),Times(CN1,C1))),Power(Plus($s("c"),Times($s("d"),$s("x"))),CN1))),$s("x")),$s("x"))))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),IntegerQ(List($s("m"),$s("n")))),Less($s("m"),CN1)),Greater($s("n"),C0)))),
SetDelayed(Int(Power($p("f"),Times($p("a",true),Log($p("u")))),$p("x",$s("Symbol"))),
    Condition(Int(Power($s("u"),Times($s("a"),Log($s("f")))),$s("x")),FreeQ(List($s("a"),$s("f")),$s("x")))),
SetDelayed(Int(Times(C1,Power(Plus(Times($p("a",true),$p("x")),Times(Times($p("b",true),$p("x")),Power(Log(Times($p("c",true),Power($p("x"),$p("n",true)))),$p("m",true)))),CN1)),$p("x",$s("Symbol"))),
    Condition(Dist(Times(C1,Power($s("n"),CN1)),Subst(Int(Times(C1,Power(Plus($s("a"),Times($s("b"),Power($s("x"),$s("m")))),CN1)),$s("x")),$s("x"),Log(Times($s("c"),Power($s("x"),$s("n")))))),FreeQ(List($s("a"),$s("b"),$s("c"),$s("m"),$s("n")),$s("x")))),
SetDelayed(Int(Times($p("u"),Power($p("x"),CN1)),$p("x",$s("Symbol"))),
    Condition(Module(List(Set($s("lst"),FunctionOfLog($s("u"),$s("x")))),Condition(Dist(Times(C1,Power(Part($s("lst"),C3),CN1)),Subst(Int(Part($s("lst"),C1),$s("x")),$s("x"),Log(Part($s("lst"),C2)))),Not(FalseQ($s("lst"))))),NonsumQ($s("u")))),
SetDelayed(Int(Log($p("u")),$p("x",$s("Symbol"))),
    Condition(Plus(Times($s("x"),Log($s("u"))),Times(CN1,Int(Regularize(Times($s("x"),Times(D($s("u"),$s("x")),Power($s("u"),CN1))),$s("x")),$s("x")))),AlgebraicFunctionQ($s("u"),$s("x")))),
SetDelayed(Int(ArcSin(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Plus($s("a"),Times($s("b"),$s("x"))),Times(ArcSin(Plus($s("a"),Times($s("b"),$s("x")))),Power($s("b"),CN1))),Times(Sqrt(Plus(C1,Times(CN1,Power(Plus($s("a"),Times($s("b"),$s("x"))),C2)))),Power($s("b"),CN1))),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(Times(C1,Power(ArcSin(Plus($p("a",true),Times($p("b",true),$p("x")))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(CosIntegral(ArcSin(Plus($s("a"),Times($s("b"),$s("x"))))),Power($s("b"),CN1)),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(Times(C1,Power(Power(ArcSin(Plus($p("a",true),Times($p("b",true),$p("x")))),C2),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Sqrt(Plus(C1,Times(CN1,Power(Plus($s("a"),Times($s("b"),$s("x"))),C2))))),Power(Times($s("b"),ArcSin(Plus($s("a"),Times($s("b"),$s("x"))))),CN1)),Times(CN1,Times(SinIntegral(ArcSin(Plus($s("a"),Times($s("b"),$s("x"))))),Power($s("b"),CN1)))),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(Times(C1,Power(Sqrt(ArcSin(Plus($p("a",true),Times($p("b",true),$p("x"))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Sqrt(Times(C2,Pi)),Times(FresnelC(Times(Sqrt(Times(C2,Power(Pi,CN1))),Sqrt(ArcSin(Plus($s("a"),Times($s("b"),$s("x"))))))),Power($s("b"),CN1))),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(Sqrt(ArcSin(Plus($p("a",true),Times($p("b",true),$p("x"))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Plus($s("a"),Times($s("b"),$s("x"))),Times(Sqrt(ArcSin(Plus($s("a"),Times($s("b"),$s("x"))))),Power($s("b"),CN1))),Times(CN1,Times(Sqrt(Times(Pi,C1D2)),Times(FresnelS(Times(Sqrt(Times(C2,Power(Pi,CN1))),Sqrt(ArcSin(Plus($s("a"),Times($s("b"),$s("x"))))))),Power($s("b"),CN1))))),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(Power(ArcSin(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Plus($s("a"),Times($s("b"),$s("x"))),Times(Power(ArcSin(Plus($s("a"),Times($s("b"),$s("x")))),$s("n")),Power($s("b"),CN1))),Times(Times($s("n"),Sqrt(Plus(C1,Times(CN1,Power(Plus($s("a"),Times($s("b"),$s("x"))),C2))))),Times(Power(ArcSin(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C1))),Power($s("b"),CN1)))),Times(CN1,Dist(Times($s("n"),Plus($s("n"),Times(CN1,C1))),Int(Power(ArcSin(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C2))),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),RationalQ($s("n"))),Greater($s("n"),C1)))),
SetDelayed(Int(Power(ArcSin(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Plus($s("a"),Times($s("b"),$s("x"))),Times(Power(ArcSin(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C2)),Power(Times(Times($s("b"),Plus($s("n"),C1)),Plus($s("n"),C2)),CN1))),Times(Sqrt(Plus(C1,Times(CN1,Power(Plus($s("a"),Times($s("b"),$s("x"))),C2)))),Times(Power(ArcSin(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C1)),Power(Times($s("b"),Plus($s("n"),C1)),CN1)))),Times(CN1,Dist(Times(C1,Power(Times(Plus($s("n"),C1),Plus($s("n"),C2)),CN1)),Int(Power(ArcSin(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C2)),$s("x"))))),And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),RationalQ($s("n"))),Less($s("n"),CN1)),Unequal($s("n"),integer(-2L))))),
SetDelayed(Int(Power(ArcSin(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Times(Times(CI,Power(ArcSin(Plus($s("a"),Times($s("b"),$s("x")))),$s("n"))),Times(Plus(Times(Times(CN1,Power(Times(CI,ArcSin(Plus($s("a"),Times($s("b"),$s("x"))))),$s("n"))),Gamma(Plus($s("n"),C1),Times(Times(CN1,CI),ArcSin(Plus($s("a"),Times($s("b"),$s("x"))))))),Times(Power(Times(Times(CN1,CI),ArcSin(Plus($s("a"),Times($s("b"),$s("x"))))),$s("n")),Gamma(Plus($s("n"),C1),Times(CI,ArcSin(Plus($s("a"),Times($s("b"),$s("x")))))))),Power(Times(Times(C2,$s("b")),Power(Power(ArcSin(Plus($s("a"),Times($s("b"),$s("x")))),C2),$s("n"))),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("n")),$s("x")),Or(Not(RationalQ($s("n"))),Less(Less(CN1,$s("n")),C1))))),
SetDelayed(Int(Times(ArcSin(Times($p("a",true),Power($p("x"),$p("n",true)))),Power($p("x"),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(CN1,CI),Times(Power(ArcSin(Times($s("a"),Power($s("x"),$s("n")))),C2),Power(Times(C2,$s("n")),CN1))),Times(ArcSin(Times($s("a"),Power($s("x"),$s("n")))),Times(Log(Plus(C1,Times(CN1,Power(Plus(Times(Times(CI,$s("a")),Power($s("x"),$s("n"))),Sqrt(Plus(C1,Times(CN1,Times(Power($s("a"),C2),Power($s("x"),Times(C2,$s("n")))))))),C2)))),Power($s("n"),CN1)))),Times(CN1,Times(CI,Times(PolyLog(C2,Power(Plus(Times(Times(CI,$s("a")),Power($s("x"),$s("n"))),Sqrt(Plus(C1,Times(CN1,Times(Power($s("a"),C2),Power($s("x"),Times(C2,$s("n")))))))),C2)),Power(Times(C2,$s("n")),CN1))))),FreeQ(List($s("a"),$s("n")),$s("x")))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),ArcSin(Plus($p("a",true),Times($p("b",true),$p("x"))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Times(ArcSin(Plus($s("a"),Times($s("b"),$s("x")))),Power(Plus($s("m"),C1),CN1))),Times(CN1,Dist(Times($s("b"),Power(Plus($s("m"),C1),CN1)),Int(Times(Power($s("x"),Plus($s("m"),C1)),Power(Sqrt(Plus(Plus(Plus(C1,Times(CN1,Power($s("a"),C2))),Times(CN1,Times(Times(Times(C2,$s("a")),$s("b")),$s("x")))),Times(CN1,Times(Power($s("b"),C2),Power($s("x"),C2))))),CN1)),$s("x"))))),And(FreeQ(List($s("a"),$s("b"),$s("m")),$s("x")),NonzeroQ(Plus($s("m"),C1))))),
SetDelayed(Int(Times(C1,Power(Sqrt(Plus($p("a"),Times($p("b",true),ArcSin(Plus($p("c",true),Times($p("d",true),$p("x"))))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(Sqrt(Times(C2,Pi)),Cos(Times($s("a"),Power($s("b"),CN1)))),Times(FresnelC(Times(Sqrt(Times(C2,Power(Pi,CN1))),Times(Sqrt(Plus($s("a"),Times($s("b"),ArcSin(Plus($s("c"),Times($s("d"),$s("x"))))))),Power(Rt($s("b"),C2),CN1)))),Power(Times($s("d"),Rt($s("b"),C2)),CN1))),Times(Times(Sqrt(Times(C2,Pi)),Sin(Times($s("a"),Power($s("b"),CN1)))),Times(FresnelS(Times(Sqrt(Times(C2,Power(Pi,CN1))),Times(Sqrt(Plus($s("a"),Times($s("b"),ArcSin(Plus($s("c"),Times($s("d"),$s("x"))))))),Power(Rt($s("b"),C2),CN1)))),Power(Times($s("d"),Rt($s("b"),C2)),CN1)))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),PosQ($s("b"))))),
SetDelayed(Int(Times(C1,Power(Sqrt(Plus($p("a"),Times($p("b",true),ArcSin(Plus($p("c",true),Times($p("d",true),$p("x"))))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(Times(CN1,Sqrt(Times(C2,Pi))),Cos(Times($s("a"),Power($s("b"),CN1)))),Times(FresnelC(Times(Times(Sqrt(Times(C2,Power(Pi,CN1))),Sqrt(Plus($s("a"),Times($s("b"),ArcSin(Plus($s("c"),Times($s("d"),$s("x")))))))),Power(Rt(Times(CN1,$s("b")),C2),CN1))),Power(Times($s("d"),Rt(Times(CN1,$s("b")),C2)),CN1))),Times(Times(Sqrt(Times(C2,Pi)),Sin(Times($s("a"),Power($s("b"),CN1)))),Times(FresnelS(Times(Times(Sqrt(Times(C2,Power(Pi,CN1))),Sqrt(Plus($s("a"),Times($s("b"),ArcSin(Plus($s("c"),Times($s("d"),$s("x")))))))),Power(Rt(Times(CN1,$s("b")),C2),CN1))),Power(Times($s("d"),Rt(Times(CN1,$s("b")),C2)),CN1)))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),NegQ($s("b"))))),
SetDelayed(Int(Times(Power(Plus(C1,Times(CN1,Power($p("x"),C2))),$p("m",true)),Power(ArcSin($p("x")),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Module(List(Set($s("u"),Block(List(Set($s("ShowSteps"),False),Set($s("StepCounter"),$s("Null"))),Int(Power(Plus(C1,Times(CN1,Power($s("x"),C2))),$s("m")),$s("x"))))),Plus(Times($s("u"),Power(ArcSin($s("x")),$s("n"))),Times(CN1,Dist($s("n"),Int(Expand(Times($s("u"),Times(Power(ArcSin($s("x")),Plus($s("n"),Times(CN1,C1))),Power(Sqrt(Plus(C1,Times(CN1,Power($s("x"),C2)))),CN1)))),$s("x")))))),And(And(And(HalfIntegerQ($s("m")),Unequal($s("m"),CN1D2)),IntegerQ($s("n"))),Greater($s("n"),C0)))),
SetDelayed(Int(Times($p("x"),Times(Power(ArcSin(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n")),Power(Sqrt($p("u")),CN1))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(CN1,Sqrt($s("u"))),Times(Power(ArcSin(Plus($s("a"),Times($s("b"),$s("x")))),$s("n")),Power(Power($s("b"),C2),CN1))),Dist(Times($s("n"),Power($s("b"),CN1)),Int(Power(ArcSin(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C1))),$s("x")))),Times(CN1,Dist(Times($s("a"),Power($s("b"),CN1)),Int(Times(Power(ArcSin(Plus($s("a"),Times($s("b"),$s("x")))),$s("n")),Power(Sqrt($s("u")),CN1)),$s("x"))))),And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),ZeroQ(Plus(Plus($s("u"),Times(CN1,C1)),Power(Plus($s("a"),Times($s("b"),$s("x"))),C2)))),RationalQ($s("n"))),Greater($s("n"),C1)))),
SetDelayed(Int(Times($p("u",true),Power(ArcSin(Times($p("c",true),Power(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n",true)))),CN1))),$p("m",true))),$p("x",$s("Symbol"))),
    Condition(Int(Times($s("u"),Power(ArcCsc(Plus(Times($s("a"),Power($s("c"),CN1)),Times($s("b"),Times(Power($s("x"),$s("n")),Power($s("c"),CN1))))),$s("m"))),$s("x")),FreeQ(List($s("a"),$s("b"),$s("c"),$s("n"),$s("m")),$s("x")))),
SetDelayed(Int(ArcSin($p("u")),$p("x",$s("Symbol"))),
    Condition(Plus(Times($s("x"),ArcSin($s("u"))),Times(CN1,Int(Regularize(Times($s("x"),Times(D($s("u"),$s("x")),Power(Sqrt(Plus(C1,Times(CN1,Power($s("u"),C2)))),CN1))),$s("x")),$s("x")))),And(InverseFunctionFreeQ($s("u"),$s("x")),Not(MatchQ($s("u"),Condition(Plus($p("c",true),Times($p("d",true),Power($p("f"),Plus($p("a",true),Times($p("b",true),$s("x")))))),FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("f")),$s("x")))))))),
SetDelayed(Int(Power($p("f"),Times($p("c",true),ArcSin(Plus($p("a",true),Times($p("b",true),$p("x")))))),$p("x",$s("Symbol"))),
    Condition(Times(Power($s("f"),Times($s("c"),ArcSin(Plus($s("a"),Times($s("b"),$s("x")))))),Times(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times(Times($s("c"),Sqrt(Plus(C1,Times(CN1,Power(Plus($s("a"),Times($s("b"),$s("x"))),C2))))),Log($s("f")))),Power(Times($s("b"),Plus(C1,Times(Power($s("c"),C2),Power(Log($s("f")),C2)))),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("f")),$s("x")),NonzeroQ(Plus(C1,Times(Power($s("c"),C2),Power(Log($s("f")),C2))))))),
SetDelayed(Int(ArcCos(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Plus($s("a"),Times($s("b"),$s("x"))),Times(ArcCos(Plus($s("a"),Times($s("b"),$s("x")))),Power($s("b"),CN1))),Times(CN1,Times(Sqrt(Plus(C1,Times(CN1,Power(Plus($s("a"),Times($s("b"),$s("x"))),C2)))),Power($s("b"),CN1)))),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(Times(C1,Power(ArcCos(Plus($p("a",true),Times($p("b",true),$p("x")))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Times(CN1,SinIntegral(ArcCos(Plus($s("a"),Times($s("b"),$s("x")))))),Power($s("b"),CN1)),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(Times(C1,Power(Power(ArcCos(Plus($p("a",true),Times($p("b",true),$p("x")))),C2),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Sqrt(Plus(C1,Times(CN1,Power(Plus($s("a"),Times($s("b"),$s("x"))),C2)))),Power(Times($s("b"),ArcCos(Plus($s("a"),Times($s("b"),$s("x"))))),CN1)),Times(CN1,Times(CosIntegral(ArcCos(Plus($s("a"),Times($s("b"),$s("x"))))),Power($s("b"),CN1)))),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(Times(C1,Power(Sqrt(ArcCos(Plus($p("a",true),Times($p("b",true),$p("x"))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Times(CN1,Sqrt(Times(C2,Pi))),Times(FresnelS(Times(Sqrt(Times(C2,Power(Pi,CN1))),Sqrt(ArcCos(Plus($s("a"),Times($s("b"),$s("x"))))))),Power($s("b"),CN1))),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(Sqrt(ArcCos(Plus($p("a",true),Times($p("b",true),$p("x"))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Plus($s("a"),Times($s("b"),$s("x"))),Times(Sqrt(ArcCos(Plus($s("a"),Times($s("b"),$s("x"))))),Power($s("b"),CN1))),Times(CN1,Times(Sqrt(Times(Pi,C1D2)),Times(FresnelC(Times(Sqrt(Times(C2,Power(Pi,CN1))),Sqrt(ArcCos(Plus($s("a"),Times($s("b"),$s("x"))))))),Power($s("b"),CN1))))),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(Power(ArcCos(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Plus($s("a"),Times($s("b"),$s("x"))),Times(Power(ArcCos(Plus($s("a"),Times($s("b"),$s("x")))),$s("n")),Power($s("b"),CN1))),Times(CN1,Times(Times($s("n"),Sqrt(Plus(C1,Times(CN1,Power(Plus($s("a"),Times($s("b"),$s("x"))),C2))))),Times(Power(ArcCos(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C1))),Power($s("b"),CN1))))),Times(CN1,Dist(Times($s("n"),Plus($s("n"),Times(CN1,C1))),Int(Power(ArcCos(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C2))),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),RationalQ($s("n"))),Greater($s("n"),C1)))),
SetDelayed(Int(Power(ArcCos(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Plus($s("a"),Times($s("b"),$s("x"))),Times(Power(ArcCos(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C2)),Power(Times(Times($s("b"),Plus($s("n"),C1)),Plus($s("n"),C2)),CN1))),Times(CN1,Times(Sqrt(Plus(C1,Times(CN1,Power(Plus($s("a"),Times($s("b"),$s("x"))),C2)))),Times(Power(ArcCos(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C1)),Power(Times($s("b"),Plus($s("n"),C1)),CN1))))),Times(CN1,Dist(Times(C1,Power(Times(Plus($s("n"),C1),Plus($s("n"),C2)),CN1)),Int(Power(ArcCos(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C2)),$s("x"))))),And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),RationalQ($s("n"))),Less($s("n"),CN1)),Unequal($s("n"),integer(-2L))))),
SetDelayed(Int(Power(ArcCos(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Times(Power(ArcCos(Plus($s("a"),Times($s("b"),$s("x")))),$s("n")),Times(Plus(Times(Power(Times(CI,ArcCos(Plus($s("a"),Times($s("b"),$s("x"))))),$s("n")),Gamma(Plus($s("n"),C1),Times(Times(CN1,CI),ArcCos(Plus($s("a"),Times($s("b"),$s("x"))))))),Times(Power(Times(Times(CN1,CI),ArcCos(Plus($s("a"),Times($s("b"),$s("x"))))),$s("n")),Gamma(Plus($s("n"),C1),Times(CI,ArcCos(Plus($s("a"),Times($s("b"),$s("x")))))))),Power(Times(Times(C2,$s("b")),Power(Power(ArcCos(Plus($s("a"),Times($s("b"),$s("x")))),C2),$s("n"))),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("n")),$s("x")),Or(Not(RationalQ($s("n"))),Less(Less(CN1,$s("n")),C1))))),
SetDelayed(Int(Times(ArcCos(Times($p("a",true),Power($p("x"),$p("n",true)))),Power($p("x"),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(CN1,CI),Times(Power(ArcCos(Times($s("a"),Power($s("x"),$s("n")))),C2),Power(Times(C2,$s("n")),CN1))),Times(ArcCos(Times($s("a"),Power($s("x"),$s("n")))),Times(Log(Plus(C1,Times(CN1,Times(C1,Power(Power(Plus(Times(Times(CI,$s("a")),Power($s("x"),$s("n"))),Sqrt(Plus(C1,Times(CN1,Times(Power($s("a"),C2),Power($s("x"),Times(C2,$s("n")))))))),C2),CN1))))),Power($s("n"),CN1)))),Times(CN1,Times(CI,Times(PolyLog(C2,Times(C1,Power(Power(Plus(Times(Times(CI,$s("a")),Power($s("x"),$s("n"))),Sqrt(Plus(C1,Times(CN1,Times(Power($s("a"),C2),Power($s("x"),Times(C2,$s("n")))))))),C2),CN1))),Power(Times(C2,$s("n")),CN1))))),FreeQ(List($s("a"),$s("n")),$s("x")))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),ArcCos(Plus($p("a",true),Times($p("b",true),$p("x"))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Times(ArcCos(Plus($s("a"),Times($s("b"),$s("x")))),Power(Plus($s("m"),C1),CN1))),Dist(Times($s("b"),Power(Plus($s("m"),C1),CN1)),Int(Times(Power($s("x"),Plus($s("m"),C1)),Power(Sqrt(Plus(Plus(Plus(C1,Times(CN1,Power($s("a"),C2))),Times(CN1,Times(Times(Times(C2,$s("a")),$s("b")),$s("x")))),Times(CN1,Times(Power($s("b"),C2),Power($s("x"),C2))))),CN1)),$s("x")))),And(FreeQ(List($s("a"),$s("b"),$s("m")),$s("x")),NonzeroQ(Plus($s("m"),C1))))),
SetDelayed(Int(Times(C1,Power(Sqrt(Plus($p("a"),Times($p("b",true),ArcCos(Plus($p("c",true),Times($p("d",true),$p("x"))))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(Times(CN1,Sqrt(Times(C2,Pi))),Cos(Times($s("a"),Power($s("b"),CN1)))),Times(FresnelS(Times(Sqrt(Times(C2,Power(Pi,CN1))),Times(Sqrt(Plus($s("a"),Times($s("b"),ArcCos(Plus($s("c"),Times($s("d"),$s("x"))))))),Power(Rt($s("b"),C2),CN1)))),Power(Times($s("d"),Rt($s("b"),C2)),CN1))),Times(Times(Sqrt(Times(C2,Pi)),Sin(Times($s("a"),Power($s("b"),CN1)))),Times(FresnelC(Times(Sqrt(Times(C2,Power(Pi,CN1))),Times(Sqrt(Plus($s("a"),Times($s("b"),ArcCos(Plus($s("c"),Times($s("d"),$s("x"))))))),Power(Rt($s("b"),C2),CN1)))),Power(Times($s("d"),Rt($s("b"),C2)),CN1)))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),PosQ($s("b"))))),
SetDelayed(Int(Times(C1,Power(Sqrt(Plus($p("a"),Times($p("b",true),ArcCos(Plus($p("c",true),Times($p("d",true),$p("x"))))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(Times(CN1,Sqrt(Times(C2,Pi))),Cos(Times($s("a"),Power($s("b"),CN1)))),Times(FresnelS(Times(Times(Sqrt(Times(C2,Power(Pi,CN1))),Sqrt(Plus($s("a"),Times($s("b"),ArcCos(Plus($s("c"),Times($s("d"),$s("x")))))))),Power(Rt(Times(CN1,$s("b")),C2),CN1))),Power(Times($s("d"),Rt(Times(CN1,$s("b")),C2)),CN1))),Times(CN1,Times(Times(Sqrt(Times(C2,Pi)),Sin(Times($s("a"),Power($s("b"),CN1)))),Times(FresnelC(Times(Times(Sqrt(Times(C2,Power(Pi,CN1))),Sqrt(Plus($s("a"),Times($s("b"),ArcCos(Plus($s("c"),Times($s("d"),$s("x")))))))),Power(Rt(Times(CN1,$s("b")),C2),CN1))),Power(Times($s("d"),Rt(Times(CN1,$s("b")),C2)),CN1))))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),NegQ($s("b"))))),
SetDelayed(Int(Times(Power(Plus(C1,Times(CN1,Power($p("x"),C2))),$p("m",true)),Power(ArcCos($p("x")),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Module(List(Set($s("u"),Block(List(Set($s("ShowSteps"),False),Set($s("StepCounter"),$s("Null"))),Int(Power(Plus(C1,Times(CN1,Power($s("x"),C2))),$s("m")),$s("x"))))),Plus(Times($s("u"),Power(ArcCos($s("x")),$s("n"))),Dist($s("n"),Int(Expand(Times($s("u"),Times(Power(ArcCos($s("x")),Plus($s("n"),Times(CN1,C1))),Power(Sqrt(Plus(C1,Times(CN1,Power($s("x"),C2)))),CN1)))),$s("x"))))),And(And(And(HalfIntegerQ($s("m")),Unequal($s("m"),CN1D2)),IntegerQ($s("n"))),Greater($s("n"),C0)))),
SetDelayed(Int(Times($p("x"),Times(Power(ArcCos(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n")),Power(Sqrt($p("u")),CN1))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(CN1,Sqrt($s("u"))),Times(Power(ArcCos(Plus($s("a"),Times($s("b"),$s("x")))),$s("n")),Power(Power($s("b"),C2),CN1))),Times(CN1,Dist(Times($s("n"),Power($s("b"),CN1)),Int(Power(ArcCos(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C1))),$s("x"))))),Times(CN1,Dist(Times($s("a"),Power($s("b"),CN1)),Int(Times(Power(ArcCos(Plus($s("a"),Times($s("b"),$s("x")))),$s("n")),Power(Sqrt($s("u")),CN1)),$s("x"))))),And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),ZeroQ(Plus(Plus($s("u"),Times(CN1,C1)),Power(Plus($s("a"),Times($s("b"),$s("x"))),C2)))),RationalQ($s("n"))),Greater($s("n"),C1)))),
SetDelayed(Int(Times($p("u",true),Power(ArcCos(Times($p("c",true),Power(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n",true)))),CN1))),$p("m",true))),$p("x",$s("Symbol"))),
    Condition(Int(Times($s("u"),Power(ArcSec(Plus(Times($s("a"),Power($s("c"),CN1)),Times($s("b"),Times(Power($s("x"),$s("n")),Power($s("c"),CN1))))),$s("m"))),$s("x")),FreeQ(List($s("a"),$s("b"),$s("c"),$s("n"),$s("m")),$s("x")))),
SetDelayed(Int(ArcCos($p("u")),$p("x",$s("Symbol"))),
    Condition(Plus(Times($s("x"),ArcCos($s("u"))),Int(Regularize(Times($s("x"),Times(D($s("u"),$s("x")),Power(Sqrt(Plus(C1,Times(CN1,Power($s("u"),C2)))),CN1))),$s("x")),$s("x"))),And(InverseFunctionFreeQ($s("u"),$s("x")),Not(MatchQ($s("u"),Condition(Plus($p("c",true),Times($p("d",true),Power($p("f"),Plus($p("a",true),Times($p("b",true),$s("x")))))),FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("f")),$s("x")))))))),
SetDelayed(Int(Power($p("f"),Times($p("c",true),ArcCos(Plus($p("a",true),Times($p("b",true),$p("x")))))),$p("x",$s("Symbol"))),
    Condition(Times(Power($s("f"),Times($s("c"),ArcCos(Plus($s("a"),Times($s("b"),$s("x")))))),Times(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times(CN1,Times(Times($s("c"),Sqrt(Plus(C1,Times(CN1,Power(Plus($s("a"),Times($s("b"),$s("x"))),C2))))),Log($s("f"))))),Power(Times($s("b"),Plus(C1,Times(Power($s("c"),C2),Power(Log($s("f")),C2)))),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("f")),$s("x")),NonzeroQ(Plus(C1,Times(Power($s("c"),C2),Power(Log($s("f")),C2))))))),
SetDelayed(Int(ArcTan(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Plus($s("a"),Times($s("b"),$s("x"))),Times(ArcTan(Plus($s("a"),Times($s("b"),$s("x")))),Power($s("b"),CN1))),Times(CN1,Times(Log(Plus(C1,Power(Plus($s("a"),Times($s("b"),$s("x"))),C2))),Power(Times(C2,$s("b")),CN1)))),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(ArcTan(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n"))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times($s("x"),ArcTan(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))))),Times(CN1,Dist(Times($s("b"),$s("n")),Int(Times(Power($s("x"),$s("n")),Power(Plus(Plus(Plus(C1,Power($s("a"),C2)),Times(Times(Times(C2,$s("a")),$s("b")),Power($s("x"),$s("n")))),Times(Power($s("b"),C2),Power($s("x"),Times(C2,$s("n"))))),CN1)),$s("x"))))),And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ($s("n"))))),
SetDelayed(Int(Times(ArcTan(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n",true))))),Power($p("x"),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Dist(Times(CI,C1D2),Int(Times(Log(Plus(Plus(C1,Times(CN1,Times(CI,$s("a")))),Times(CN1,Times(Times(CI,$s("b")),Power($s("x"),$s("n")))))),Power($s("x"),CN1)),$s("x"))),Times(CN1,Dist(Times(CI,C1D2),Int(Times(Log(Plus(Plus(C1,Times(CI,$s("a"))),Times(Times(CI,$s("b")),Power($s("x"),$s("n"))))),Power($s("x"),CN1)),$s("x"))))),FreeQ(List($s("a"),$s("b"),$s("n")),$s("x")))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),ArcTan(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n",true)))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Times(ArcTan(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),Power(Plus($s("m"),C1),CN1))),Times(CN1,Dist(Times($s("b"),Times($s("n"),Power(Plus($s("m"),C1),CN1))),Int(Times(Power($s("x"),Plus($s("m"),$s("n"))),Power(Plus(Plus(Plus(C1,Power($s("a"),C2)),Times(Times(Times(C2,$s("a")),$s("b")),Power($s("x"),$s("n")))),Times(Power($s("b"),C2),Power($s("x"),Times(C2,$s("n"))))),CN1)),$s("x"))))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("m")),$s("x")),IntegerQ($s("n"))),NonzeroQ(Plus($s("m"),C1))),NonzeroQ(Plus(Plus($s("m"),Times(CN1,$s("n"))),C1))))),
SetDelayed(Int(Times(Power(Plus(C1,Power($p("x"),C2)),$p("m")),Power(ArcTan($p("x")),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Module(List(Set($s("u"),Block(List(Set($s("ShowSteps"),False),Set($s("StepCounter"),$s("Null"))),Int(Power(Plus(C1,Power($s("x"),C2)),$s("m")),$s("x"))))),Plus(Times($s("u"),Power(ArcTan($s("x")),$s("n"))),Times(CN1,Dist($s("n"),Int(Times($s("u"),Times(Power(ArcTan($s("x")),Plus($s("n"),Times(CN1,C1))),Power(Plus(C1,Power($s("x"),C2)),CN1))),$s("x")))))),And(And(IntegerQ(List($s("m"),$s("n"))),Less($s("m"),CN1)),Greater($s("n"),C0)))),
SetDelayed(Int(Times(C1,Power(Times(Times(Plus(C1,Power($p("x"),C2)),ArcCot($p("x"))),ArcTan($p("x"))),CN1)),$p("x",$s("Symbol"))),
    Times(Plus(Times(CN1,Log(ArcCot($s("x")))),Log(ArcTan($s("x")))),Power(Plus(ArcCot($s("x")),ArcTan($s("x"))),CN1))),
SetDelayed(Int(Times(Power(ArcCot($p("x")),$p("n",true)),Times(Power(ArcTan($p("x")),$p("p",true)),Power(Plus(C1,Power($p("x"),C2)),CN1))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Power(ArcCot($s("x")),Plus($s("n"),C1))),Times(Power(ArcTan($s("x")),$s("p")),Power(Plus($s("n"),C1),CN1))),Dist(Times($s("p"),Power(Plus($s("n"),C1),CN1)),Int(Times(Power(ArcCot($s("x")),Plus($s("n"),C1)),Times(Power(ArcTan($s("x")),Plus($s("p"),Times(CN1,C1))),Power(Plus(C1,Power($s("x"),C2)),CN1))),$s("x")))),And(IntegerQ(List($s("n"),$s("p"))),And(Less(C0,$s("p")),LessEqual($s("p"),$s("n")))))),
SetDelayed(Int(Times($p("x"),Power(ArcTan(Times($p("b",true),$p("x"))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Plus(Power(Times($s("b"),$s("x")),C2),C1),Times(Power(ArcTan(Times($s("b"),$s("x"))),$s("n")),Power(Times(C2,Power($s("b"),C2)),CN1))),Times(CN1,Dist(Times($s("n"),Power(Times(C2,$s("b")),CN1)),Int(Power(ArcTan(Times($s("b"),$s("x"))),Plus($s("n"),Times(CN1,C1))),$s("x"))))),And(And(FreeQ($s("b"),$s("x")),RationalQ($s("n"))),Greater($s("n"),C1)))),
SetDelayed(Int(Times($p("x"),Power(ArcTan(Plus($p("a"),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Plus(Power(Plus($s("a"),Times($s("b"),$s("x"))),C2),C1),Times(Power(ArcTan(Plus($s("a"),Times($s("b"),$s("x")))),$s("n")),Power(Times(C2,Power($s("b"),C2)),CN1))),Times(CN1,Dist(Times($s("n"),Power(Times(C2,$s("b")),CN1)),Int(Power(ArcTan(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C1))),$s("x"))))),Times(CN1,Dist(Times($s("a"),Power($s("b"),CN1)),Int(Power(ArcTan(Plus($s("a"),Times($s("b"),$s("x")))),$s("n")),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),RationalQ($s("n"))),Greater($s("n"),C1)))),
SetDelayed(Int(Times($p("u",true),Power(ArcTan(Times($p("c",true),Power(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n",true)))),CN1))),$p("m",true))),$p("x",$s("Symbol"))),
    Condition(Int(Times($s("u"),Power(ArcCot(Plus(Times($s("a"),Power($s("c"),CN1)),Times($s("b"),Times(Power($s("x"),$s("n")),Power($s("c"),CN1))))),$s("m"))),$s("x")),FreeQ(List($s("a"),$s("b"),$s("c"),$s("n"),$s("m")),$s("x")))),
SetDelayed(Int(Times($p("u"),Power(Plus($p("a"),Times($p("b",true),Power($p("x"),C2))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Dist(Power($s("a"),$s("n")),Subst(Int(Regularize(Times(Power(Cos($s("x")),Times(integer(-2L),Plus($s("n"),C1))),SubstFor(ArcTan($s("x")),$s("u"),$s("x"))),$s("x")),$s("x")),$s("x"),ArcTan($s("x")))),And(And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),FunctionOfQ(ArcTan($s("x")),$s("u"),$s("x"))),ZeroQ(Plus($s("a"),Times(CN1,$s("b"))))),IntegerQ($s("n"))),Less($s("n"),CN1)))),
SetDelayed(Int(Times($p("u"),Power(Plus($p("a"),Times($p("b",true),Power($p("x"),C2))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Dist(Power($s("a"),$s("n")),Subst(Int(Regularize(Times(Power(Cos($s("x")),Times(integer(-2L),Plus($s("n"),C1))),SubstFor(ArcTan($s("x")),$s("u"),$s("x"))),$s("x")),$s("x")),$s("x"),ArcTan($s("x")))),And(And(And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),FunctionOfQ(ArcTan($s("x")),$s("u"),$s("x"))),ZeroQ(Plus($s("a"),Times(CN1,$s("b"))))),HalfIntegerQ($s("n"))),Less($s("n"),CN1)),PositiveQ($s("a"))))),
SetDelayed(Int(Times($p("u"),Power(Plus($p("a"),Times($p("b",true),Power($p("x"),C2))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Dist(Times(C1,Power($s("a"),CN1)),Subst(Int(Regularize(Times(Power(Times($s("a"),Power(Sec($s("x")),C2)),Plus($s("n"),C1)),SubstFor(ArcTan($s("x")),$s("u"),$s("x"))),$s("x")),$s("x")),$s("x"),ArcTan($s("x")))),And(And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),FunctionOfQ(ArcTan($s("x")),$s("u"),$s("x"))),ZeroQ(Plus($s("a"),Times(CN1,$s("b"))))),HalfIntegerQ($s("n"))),Less($s("n"),CN1)))),
SetDelayed(Int(Times(Times(Power($p("x"),$p("m",true)),$p("u")),Power(Plus($p("a"),Times($p("b",true),Power($p("x"),C2))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Dist(Power($s("a"),$s("n")),Subst(Int(Regularize(Times(Times(Power(Tan($s("x")),$s("m")),Power(Cos($s("x")),Times(integer(-2L),Plus($s("n"),C1)))),SubstFor(ArcTan($s("x")),$s("u"),$s("x"))),$s("x")),$s("x")),$s("x"),ArcTan($s("x")))),And(And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),FunctionOfQ(ArcTan($s("x")),$s("u"),$s("x"))),ZeroQ(Plus($s("a"),Times(CN1,$s("b"))))),IntegerQ(List($s("m"),$s("n")))),Less($s("n"),C0)))),
SetDelayed(Int(Times(Times(Power($p("x"),$p("m",true)),$p("u")),Power(Plus($p("a"),Times($p("b",true),Power($p("x"),C2))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Dist(Power($s("a"),$s("n")),Subst(Int(Regularize(Times(Times(Power(Tan($s("x")),$s("m")),Power(Cos($s("x")),Times(integer(-2L),Plus($s("n"),C1)))),SubstFor(ArcTan($s("x")),$s("u"),$s("x"))),$s("x")),$s("x")),$s("x"),ArcTan($s("x")))),And(And(And(And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),FunctionOfQ(ArcTan($s("x")),$s("u"),$s("x"))),ZeroQ(Plus($s("a"),Times(CN1,$s("b"))))),HalfIntegerQ($s("n"))),Less($s("n"),CN1)),PositiveQ($s("a"))),IntegerQ($s("m"))))),
SetDelayed(Int(ArcTan($p("u")),$p("x",$s("Symbol"))),
    Condition(Plus(Times($s("x"),ArcTan($s("u"))),Times(CN1,Int(Regularize(Times($s("x"),Times(D($s("u"),$s("x")),Power(Plus(C1,Power($s("u"),C2)),CN1))),$s("x")),$s("x")))),And(InverseFunctionFreeQ($s("u"),$s("x")),Not(MatchQ($s("u"),Condition(Plus($p("c",true),Times($p("d",true),Power($p("f"),Plus($p("a",true),Times($p("b",true),$s("x")))))),FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("f")),$s("x")))))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),ArcTan($p("u"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Times(ArcTan($s("u")),Power(Plus($s("m"),C1),CN1))),Times(CN1,Dist(Times(C1,Power(Plus($s("m"),C1),CN1)),Int(Regularize(Times(Power($s("x"),Plus($s("m"),C1)),Times(D($s("u"),$s("x")),Power(Plus(C1,Power($s("u"),C2)),CN1))),$s("x")),$s("x"))))),And(And(And(And(FreeQ($s("m"),$s("x")),NonzeroQ(Plus($s("m"),C1))),InverseFunctionFreeQ($s("u"),$s("x"))),Not(FunctionOfQ(Power($s("x"),Plus($s("m"),C1)),$s("u"),$s("x")))),FalseQ(PowerVariableExpn($s("u"),Plus($s("m"),C1),$s("x")))))),
SetDelayed(Int(Times($p("v"),ArcTan($p("u"))),$p("x",$s("Symbol"))),
    Condition(Module(List(Set($s("w"),Block(List(Set($s("ShowSteps"),False),Set($s("StepCounter"),$s("Null"))),Int($s("v"),$s("x"))))),Condition(Plus(Times($s("w"),ArcTan($s("u"))),Times(CN1,Int(Regularize(Times($s("w"),Times(D($s("u"),$s("x")),Power(Plus(C1,Power($s("u"),C2)),CN1))),$s("x")),$s("x")))),InverseFunctionFreeQ($s("w"),$s("x")))),And(And(InverseFunctionFreeQ($s("u"),$s("x")),Not(MatchQ($s("v"),Condition(Power($s("x"),$p("m",true)),FreeQ($s("m"),$s("x")))))),FalseQ(FunctionOfLinear(Times($s("v"),ArcTan($s("u"))),$s("x")))))),
SetDelayed(Int(Times(ArcTan(Times($p("b",true),$p("x"))),Power(Plus($p("c"),Times($p("d",true),Power($p("x"),$p("n",true)))),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Dist(Times(CI,C1D2),Int(Times(Log(Plus(C1,Times(CN1,Times(Times(CI,$s("b")),$s("x"))))),Power(Plus($s("c"),Times($s("d"),Power($s("x"),$s("n")))),CN1)),$s("x"))),Times(CN1,Dist(Times(CI,C1D2),Int(Times(Log(Plus(C1,Times(Times(CI,$s("b")),$s("x")))),Power(Plus($s("c"),Times($s("d"),Power($s("x"),$s("n")))),CN1)),$s("x"))))),And(And(FreeQ(List($s("b"),$s("c"),$s("d")),$s("x")),IntegerQ($s("n"))),Not(And(Equal($s("n"),C2),ZeroQ(Plus(Times(Power($s("b"),C2),$s("c")),Times(CN1,$s("d"))))))))),
SetDelayed(Int(Times(ArcTan(Plus($p("a"),Times($p("b",true),$p("x")))),Power(Plus($p("c"),Times($p("d",true),Power($p("x"),$p("n",true)))),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Dist(Times(CI,C1D2),Int(Times(Log(Plus(Plus(C1,Times(CN1,Times(CI,$s("a")))),Times(CN1,Times(Times(CI,$s("b")),$s("x"))))),Power(Plus($s("c"),Times($s("d"),Power($s("x"),$s("n")))),CN1)),$s("x"))),Times(CN1,Dist(Times(CI,C1D2),Int(Times(Log(Plus(Plus(C1,Times(CI,$s("a"))),Times(Times(CI,$s("b")),$s("x")))),Power(Plus($s("c"),Times($s("d"),Power($s("x"),$s("n")))),CN1)),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),IntegerQ($s("n"))),Not(And(Equal($s("n"),C1),ZeroQ(Plus(Times($s("a"),$s("d")),Times(CN1,Times($s("b"),$s("c")))))))))),
SetDelayed(Int(ArcCot(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Plus($s("a"),Times($s("b"),$s("x"))),Times(ArcCot(Plus($s("a"),Times($s("b"),$s("x")))),Power($s("b"),CN1))),Times(Log(Plus(C1,Power(Plus($s("a"),Times($s("b"),$s("x"))),C2))),Power(Times(C2,$s("b")),CN1))),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(ArcCot(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n"))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times($s("x"),ArcCot(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))))),Dist(Times($s("b"),$s("n")),Int(Times(Power($s("x"),$s("n")),Power(Plus(Plus(Plus(C1,Power($s("a"),C2)),Times(Times(Times(C2,$s("a")),$s("b")),Power($s("x"),$s("n")))),Times(Power($s("b"),C2),Power($s("x"),Times(C2,$s("n"))))),CN1)),$s("x")))),And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ($s("n"))))),
SetDelayed(Int(Times(ArcCot(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n",true))))),Power($p("x"),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Dist(Times(CI,C1D2),Int(Times(Log(Plus(C1,Times(CN1,Times(CI,Power(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))),CN1))))),Power($s("x"),CN1)),$s("x"))),Times(CN1,Dist(Times(CI,C1D2),Int(Times(Log(Plus(C1,Times(CI,Power(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))),CN1)))),Power($s("x"),CN1)),$s("x"))))),FreeQ(List($s("a"),$s("b"),$s("n")),$s("x")))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),ArcCot(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n",true)))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Times(ArcCot(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),Power(Plus($s("m"),C1),CN1))),Dist(Times($s("b"),Times($s("n"),Power(Plus($s("m"),C1),CN1))),Int(Times(Power($s("x"),Plus($s("m"),$s("n"))),Power(Plus(Plus(Plus(C1,Power($s("a"),C2)),Times(Times(Times(C2,$s("a")),$s("b")),Power($s("x"),$s("n")))),Times(Power($s("b"),C2),Power($s("x"),Times(C2,$s("n"))))),CN1)),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("m")),$s("x")),IntegerQ($s("n"))),NonzeroQ(Plus($s("m"),C1))),NonzeroQ(Plus(Plus($s("m"),Times(CN1,$s("n"))),C1))))),
SetDelayed(Int(Times(Power(Plus(C1,Power($p("x"),C2)),$p("m")),Power(ArcCot($p("x")),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Module(List(Set($s("u"),Block(List(Set($s("ShowSteps"),False),Set($s("StepCounter"),$s("Null"))),Int(Power(Plus(C1,Power($s("x"),C2)),$s("m")),$s("x"))))),Plus(Times($s("u"),Power(ArcCot($s("x")),$s("n"))),Dist($s("n"),Int(Times($s("u"),Times(Power(ArcCot($s("x")),Plus($s("n"),Times(CN1,C1))),Power(Plus(C1,Power($s("x"),C2)),CN1))),$s("x"))))),And(And(IntegerQ(List($s("m"),$s("n"))),Less($s("m"),CN1)),Greater($s("n"),C0)))),
SetDelayed(Int(Times(Power(ArcCot($p("x")),$p("n",true)),Times(Power(ArcTan($p("x")),$p("p")),Power(Plus(C1,Power($p("x"),C2)),CN1))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power(ArcCot($s("x")),$s("n")),Times(Power(ArcTan($s("x")),Plus($s("p"),C1)),Power(Plus($s("p"),C1),CN1))),Dist(Times($s("n"),Power(Plus($s("p"),C1),CN1)),Int(Times(Power(ArcCot($s("x")),Plus($s("n"),Times(CN1,C1))),Times(Power(ArcTan($s("x")),Plus($s("p"),C1)),Power(Plus(C1,Power($s("x"),C2)),CN1))),$s("x")))),And(IntegerQ(List($s("n"),$s("p"))),Less(Less(C0,$s("n")),$s("p"))))),
SetDelayed(Int(Times(Times(Power(Plus(C1,Power($p("x"),C2)),$p("m")),Power(ArcCot($p("x")),$p("n",true))),Power(ArcTan($p("x")),$p("p",true))),$p("x",$s("Symbol"))),
    Condition(Module(List(Set($s("u"),Block(List(Set($s("ShowSteps"),False),Set($s("StepCounter"),$s("Null"))),Int(Power(Plus(C1,Power($s("x"),C2)),$s("m")),$s("x"))))),Plus(Plus(Times(Times($s("u"),Power(ArcCot($s("x")),$s("n"))),Power(ArcTan($s("x")),$s("p"))),Times(CN1,Dist($s("p"),Int(Times(Times($s("u"),Power(ArcCot($s("x")),$s("n"))),Times(Power(ArcTan($s("x")),Plus($s("p"),Times(CN1,C1))),Power(Plus(C1,Power($s("x"),C2)),CN1))),$s("x"))))),Dist($s("n"),Int(Times(Times($s("u"),Power(ArcCot($s("x")),Plus($s("n"),Times(CN1,C1)))),Times(Power(ArcTan($s("x")),$s("p")),Power(Plus(C1,Power($s("x"),C2)),CN1))),$s("x"))))),And(And(And(IntegerQ(List($s("m"),$s("p"),$s("n"))),Less($s("m"),CN1)),Greater($s("p"),C0)),Greater($s("n"),C0)))),
SetDelayed(Int(Times($p("x"),Power(ArcCot(Times($p("b",true),$p("x"))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Plus(Power(Times($s("b"),$s("x")),C2),C1),Times(Power(ArcCot(Times($s("b"),$s("x"))),$s("n")),Power(Times(C2,Power($s("b"),C2)),CN1))),Dist(Times($s("n"),Power(Times(C2,$s("b")),CN1)),Int(Power(ArcCot(Times($s("b"),$s("x"))),Plus($s("n"),Times(CN1,C1))),$s("x")))),And(And(FreeQ($s("b"),$s("x")),RationalQ($s("n"))),Greater($s("n"),C1)))),
SetDelayed(Int(Times($p("x"),Power(ArcCot(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Plus(Power(Plus($s("a"),Times($s("b"),$s("x"))),C2),C1),Times(Power(ArcCot(Plus($s("a"),Times($s("b"),$s("x")))),$s("n")),Power(Times(C2,Power($s("b"),C2)),CN1))),Dist(Times($s("n"),Power(Times(C2,$s("b")),CN1)),Int(Power(ArcCot(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C1))),$s("x")))),Times(CN1,Dist(Times($s("a"),Power($s("b"),CN1)),Int(Power(ArcCot(Plus($s("a"),Times($s("b"),$s("x")))),$s("n")),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),RationalQ($s("n"))),Greater($s("n"),C1)))),
SetDelayed(Int(Times($p("u",true),Power(ArcCot(Times($p("c",true),Power(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n",true)))),CN1))),$p("m",true))),$p("x",$s("Symbol"))),
    Condition(Int(Times($s("u"),Power(ArcTan(Plus(Times($s("a"),Power($s("c"),CN1)),Times($s("b"),Times(Power($s("x"),$s("n")),Power($s("c"),CN1))))),$s("m"))),$s("x")),FreeQ(List($s("a"),$s("b"),$s("c"),$s("n"),$s("m")),$s("x")))),
SetDelayed(Int(Times($p("u"),Power(Plus($p("a"),Times($p("b",true),Power($p("x"),C2))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Dist(Times(CN1,Power($s("a"),$s("n"))),Subst(Int(Regularize(Times(Power(Sin($s("x")),Times(integer(-2L),Plus($s("n"),C1))),SubstFor(ArcCot($s("x")),$s("u"),$s("x"))),$s("x")),$s("x")),$s("x"),ArcCot($s("x")))),And(And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),FunctionOfQ(ArcCot($s("x")),$s("u"),$s("x"))),ZeroQ(Plus($s("a"),Times(CN1,$s("b"))))),IntegerQ($s("n"))),Less($s("n"),CN1)))),
SetDelayed(Int(Times($p("u"),Power(Plus($p("a"),Times($p("b",true),Power($p("x"),C2))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Dist(Times(CN1,Power($s("a"),CN1)),Subst(Int(Regularize(Times(Power(Times($s("a"),Power(Csc($s("x")),C2)),Plus($s("n"),C1)),SubstFor(ArcCot($s("x")),$s("u"),$s("x"))),$s("x")),$s("x")),$s("x"),ArcCot($s("x")))),And(And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),FunctionOfQ(ArcCot($s("x")),$s("u"),$s("x"))),ZeroQ(Plus($s("a"),Times(CN1,$s("b"))))),HalfIntegerQ($s("n"))),Less($s("n"),CN1))))
  );
}
