package org.matheclipse.core.integrate.rubi;


import static org.matheclipse.core.expression.F.*;
import static org.matheclipse.core.integrate.rubi.UtilityFunctionCtors.*;
import static org.matheclipse.core.integrate.rubi.UtilityFunctions.*;
import org.matheclipse.core.interfaces.IAST;
import org.matheclipse.core.interfaces.IExpr;

/** 
 * IndefiniteIntegrationRules from the <a href="http://www.apmaths.uwo.ca/~arich/">Rubi -
 * rule-based integrator</a>.
 *  
 */
public class IndefiniteIntegrationRules13 { 
  public static IAST RULES = List( 
SetDelayed(Int(Times($p("u",true),Power(ArcCoth(Times($p("c",true),Power(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n",true)))),CN1))),$p("m",true))),$p("x",$s("Symbol"))),
    Condition(Int(Times($s("u"),Power(ArcTanh(Plus(Times($s("a"),Power($s("c"),CN1)),Times($s("b"),Times(Power($s("x"),$s("n")),Power($s("c"),CN1))))),$s("m"))),$s("x")),FreeQ(List($s("a"),$s("b"),$s("c"),$s("n"),$s("m")),$s("x")))),
SetDelayed(Int(Times($p("u"),Power($p("v"),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Module(List(Set($s("tmp"),InverseFunctionOfLinear($s("u"),$s("x")))),Condition(Dist(Times(Power(Times(Times(CN1,Discriminant($s("v"),$s("x"))),Power(Times(C4,Coefficient($s("v"),$s("x"),C2)),CN1)),$s("n")),Power(Coefficient(Part($s("tmp"),C1),$s("x"),C1),CN1)),Subst(Int(Regularize(Times(SubstForInverseFunction($s("u"),$s("tmp"),$s("x")),Power(Times(CN1,Power(Csch($s("x")),C2)),Plus($s("n"),C1))),$s("x")),$s("x")),$s("x"),$s("tmp"))),And(And(NotFalseQ($s("tmp")),SameQ(Head($s("tmp")),$s("ArcCoth"))),ZeroQ(Plus(Times(Discriminant($s("v"),$s("x")),Power(Part($s("tmp"),C1),C2)),Times(CN1,Power(D($s("v"),$s("x")),C2))))))),And(And(And(QuadraticQ($s("v"),$s("x")),IntegerQ($s("n"))),Less($s("n"),C0)),PosQ(Discriminant($s("v"),$s("x")))))),
SetDelayed(Int(Times($p("u",true),Power(E,Times($p("n",true),ArcCoth($p("v"))))),$p("x",$s("Symbol"))),
    Condition(Int(Times($s("u"),Times(Power(Plus(C1,$s("v")),Times($s("n"),C1D2)),Power(Power(Plus(CN1,$s("v")),Times($s("n"),C1D2)),CN1))),$s("x")),EvenQ($s("n")))),
SetDelayed(Int(Power(E,Times($p("n",true),ArcCoth($p("v")))),$p("x",$s("Symbol"))),
    Condition(Int(Expand(Power(Plus(Times(C1,Power(Sqrt(Plus(C1,Times(CN1,Times(C1,Power(Power($s("v"),C2),CN1))))),CN1)),Times(C1,Power(Times($s("x"),Sqrt(Plus(C1,Times(CN1,Times(C1,Power(Power($s("v"),C2),CN1)))))),CN1))),$s("n"))),$s("x")),OddQ($s("n")))),
SetDelayed(Int(Power(E,Times(ArcCoth(Plus($p("a",true),Times($p("b",true),$p("x")))),C1D2)),$p("x",$s("Symbol"))),
    Condition(Plus(Times($s("x"),Power(E,Times(ArcCoth(Plus($s("a"),Times($s("b"),$s("x")))),C1D2))),Times(CN1,Dist(Times($s("b"),C1D2),Int(Times($s("x"),Times(Power(E,Times(ArcCoth(Plus($s("a"),Times($s("b"),$s("x")))),C1D2)),Power(Plus(C1,Times(CN1,Power(Plus($s("a"),Times($s("b"),$s("x"))),C2))),CN1))),$s("x"))))),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(E,Times(ArcCoth(Plus($p("a",true),Times($p("b",true),$p("x")))),C1D2))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Times(Power(E,Times(ArcCoth(Plus($s("a"),Times($s("b"),$s("x")))),C1D2)),Power(Plus($s("m"),C1),CN1))),Times(CN1,Dist(Times($s("b"),Power(Times(C2,Plus($s("m"),C1)),CN1)),Int(Times(Power($s("x"),Plus($s("m"),C1)),Times(Power(E,Times(ArcCoth(Plus($s("a"),Times($s("b"),$s("x")))),C1D2)),Power(Plus(C1,Times(CN1,Power(Plus($s("a"),Times($s("b"),$s("x"))),C2))),CN1))),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ($s("m"))),Greater($s("m"),C0)))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(E,Times($p("n",true),ArcCoth($p("v"))))),$p("x",$s("Symbol"))),
    Condition(Int(Expand(Times(Power($s("x"),$s("m")),Power(Plus(Times(C1,Power(Sqrt(Plus(C1,Times(CN1,Times(C1,Power(Power($s("v"),C2),CN1))))),CN1)),Times(C1,Power(Times($s("x"),Sqrt(Plus(C1,Times(CN1,Times(C1,Power(Power($s("v"),C2),CN1)))))),CN1))),$s("n")))),$s("x")),And(RationalQ($s("m")),OddQ($s("n"))))),
SetDelayed(Int(Times(Times($p("u",true),Power(E,Times($p("n",true),ArcCoth($p("v"))))),Power(Plus(C1,Times(CN1,Power($p("v"),C2))),$p("m",true))),$p("x",$s("Symbol"))),
    Condition(Times(Times(Times(Times(CN1,Power(CN1,Times(Plus($s("n"),Times(CN1,C1)),C1D2))),$s("v")),Times(Sqrt(Plus(C1,Times(CN1,Times(C1,Power(Power($s("v"),C2),CN1))))),Power(Sqrt(Plus(C1,Times(CN1,Power($s("v"),C2)))),CN1))),Int(Times(Times($s("u"),Power(Plus(C1,Times(CN1,$s("v"))),Plus($s("m"),Times(CN1,Times($s("n"),C1D2))))),Power(Plus(C1,$s("v")),Plus($s("m"),Times($s("n"),C1D2)))),$s("x"))),And(OddQ($s("n")),HalfIntegerQ($s("m"))))),
SetDelayed(Int(Times(Times($p("u",true),Power(E,ArcCoth($p("v")))),Power(Plus(C1,Times(CN1,Power($p("v"),C2))),$p("m",true))),$p("x",$s("Symbol"))),
    Condition(Times(CN1,Int(Expand(Times(Times(Times(Times($s("u"),$s("v")),Plus(C1,$s("v"))),Sqrt(Plus(C1,Times(CN1,Times(C1,Power(Power($s("v"),C2),CN1)))))),Power(Plus(C1,Times(CN1,Power($s("v"),C2))),Plus($s("m"),Times(CN1,C1)))),$s("x")),$s("x"))),And(IntegerQ($s("m")),Greater($s("m"),C0)))),
SetDelayed(Int(Times(Times($p("u",true),Power(E,ArcCoth($p("v")))),Power(Plus($p("a"),Times($p("b",true),Power($p("v"),C2))),$p("m",true))),$p("x",$s("Symbol"))),
    Condition(Times(Times(Power(Plus($s("a"),Times($s("b"),Power($s("v"),C2))),$s("m")),Power(Power(Plus(C1,Times(CN1,Power($s("v"),C2))),$s("m")),CN1)),Int(Times(Times($s("u"),Power(E,ArcCoth($s("v")))),Power(Plus(C1,Times(CN1,Power($s("v"),C2))),$s("m"))),$s("x"))),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),ZeroQ(Plus($s("a"),$s("b")))),NonzeroQ(Plus($s("a"),Times(CN1,C1)))))),
SetDelayed(Int(Times(Times($p("u",true),Power(E,Times($p("n",true),ArcCoth($p("v"))))),Power(Plus(C1,Times(CN1,Times(C1,Power(Power($p("v"),C2),CN1)))),$p("m",true))),$p("x",$s("Symbol"))),
    Condition(Int(Times(Times($s("u"),Power(Plus(C1,$s("v")),Plus($s("m"),Times($s("n"),C1D2)))),Times(Power(Plus(CN1,$s("v")),Plus($s("m"),Times(CN1,Times($s("n"),C1D2)))),Power(Power($s("v"),Times(C2,$s("m"))),CN1))),$s("x")),And(IntegerQ($s("n")),IntegerQ(Plus($s("m"),Times(CN1,Times($s("n"),C1D2))))))),
SetDelayed(Int(Times(Times($p("u",true),Power(E,Times($p("n",true),ArcCoth($p("v"))))),Power(Plus(C1,Times(CN1,Times(C1,Power(Power($p("v"),C2),CN1)))),$p("m",true))),$p("x",$s("Symbol"))),
    Condition(Int(Expand(Times(Times($s("u"),Power(Plus(C1,Times(C1,Power($s("v"),CN1))),$s("n"))),Power(Plus(C1,Times(CN1,Times(C1,Power(Power($s("v"),C2),CN1)))),Plus($s("m"),Times(CN1,Times($s("n"),C1D2))))),$s("x")),$s("x")),And(RationalQ($s("n")),IntegerQ(Times(C2,$s("m")))))),
SetDelayed(Int(Times(Times($p("u",true),Power(E,ArcCoth($p("v")))),Power(Plus($p("a"),Times($p("b",true),Power(Power($p("v"),C2),CN1))),$p("m",true))),$p("x",$s("Symbol"))),
    Condition(Times(Int(Times(Times($s("u"),Plus(C1,Times(C1,Power($s("v"),CN1)))),Power(Plus(C1,Times(CN1,Power($s("v"),integer(-2L)))),Plus($s("m"),Times(CN1,C1D2)))),$s("x")),Times(Power(Plus($s("a"),Times($s("b"),Power($s("v"),integer(-2L)))),$s("m")),Power(Power(Plus(C1,Times(CN1,Power($s("v"),integer(-2L)))),$s("m")),CN1))),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),ZeroQ(Plus($s("a"),$s("b")))),IntegerQ(Times(C2,$s("m")))))),
SetDelayed(Int(Times(Times(Power($p("x"),$p("m",true)),$p("u")),Power(Plus($p("a"),Times($p("b",true),Power($p("x"),C2))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Dist(Times(CN1,Power($s("b"),$s("n"))),Subst(Int(Regularize(Times(Times(Power(Coth($s("x")),$s("m")),Power(Sinh($s("x")),Times(integer(-2L),Plus($s("n"),C1)))),SubstFor(ArcCoth($s("x")),$s("u"),$s("x"))),$s("x")),$s("x")),$s("x"),ArcCoth($s("x")))),And(And(And(And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),FunctionOfQ(ArcCoth($s("x")),$s("u"),$s("x"))),ZeroQ(Plus($s("a"),$s("b")))),HalfIntegerQ($s("n"))),Less($s("n"),CN1)),PositiveQ($s("a"))),IntegerQ($s("m"))))),
SetDelayed(Int(ArcCoth($p("u")),$p("x",$s("Symbol"))),
    Condition(Plus(Times($s("x"),ArcCoth($s("u"))),Times(CN1,Int(Regularize(Times($s("x"),Times(D($s("u"),$s("x")),Power(Plus(C1,Times(CN1,Power($s("u"),C2))),CN1))),$s("x")),$s("x")))),InverseFunctionFreeQ($s("u"),$s("x")))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),ArcCoth($p("u"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Times(ArcCoth($s("u")),Power(Plus($s("m"),C1),CN1))),Times(CN1,Dist(Times(C1,Power(Plus($s("m"),C1),CN1)),Int(Regularize(Times(Power($s("x"),Plus($s("m"),C1)),Times(D($s("u"),$s("x")),Power(Plus(C1,Times(CN1,Power($s("u"),C2))),CN1))),$s("x")),$s("x"))))),And(And(And(And(FreeQ($s("m"),$s("x")),NonzeroQ(Plus($s("m"),C1))),InverseFunctionFreeQ($s("u"),$s("x"))),Not(FunctionOfQ(Power($s("x"),Plus($s("m"),C1)),$s("u"),$s("x")))),FalseQ(PowerVariableExpn($s("u"),Plus($s("m"),C1),$s("x")))))),
SetDelayed(Int(Times($p("v"),ArcCoth($p("u"))),$p("x",$s("Symbol"))),
    Condition(Module(List(Set($s("w"),Block(List(Set($s("ShowSteps"),False),Set($s("StepCounter"),$s("Null"))),Int($s("v"),$s("x"))))),Condition(Plus(Times($s("w"),ArcCoth($s("u"))),Times(CN1,Int(Regularize(Times($s("w"),Times(D($s("u"),$s("x")),Power(Plus(C1,Times(CN1,Power($s("u"),C2))),CN1))),$s("x")),$s("x")))),InverseFunctionFreeQ($s("w"),$s("x")))),And(And(InverseFunctionFreeQ($s("u"),$s("x")),Not(MatchQ($s("v"),Condition(Power($s("x"),$p("m",true)),FreeQ($s("m"),$s("x")))))),FalseQ(FunctionOfLinear(Times($s("v"),ArcCoth($s("u"))),$s("x")))))),
SetDelayed(Int(Times(ArcCoth(Times($p("b",true),$p("x"))),Power(Plus($p("c"),Times($p("d",true),Power($p("x"),$p("n",true)))),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Dist(C1D2,Int(Times(Log(Plus(C1,Times(C1,Power(Times($s("b"),$s("x")),CN1)))),Power(Plus($s("c"),Times($s("d"),Power($s("x"),$s("n")))),CN1)),$s("x"))),Times(CN1,Dist(C1D2,Int(Times(Log(Plus(C1,Times(CN1,Times(C1,Power(Times($s("b"),$s("x")),CN1))))),Power(Plus($s("c"),Times($s("d"),Power($s("x"),$s("n")))),CN1)),$s("x"))))),And(And(FreeQ(List($s("b"),$s("c"),$s("d")),$s("x")),IntegerQ($s("n"))),Not(And(Equal($s("n"),C2),ZeroQ(Plus(Times(Power($s("b"),C2),$s("c")),$s("d")))))))),
SetDelayed(Int(Times(ArcCoth(Plus($p("a"),Times($p("b",true),$p("x")))),Power(Plus($p("c"),Times($p("d",true),Power($p("x"),$p("n",true)))),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Dist(C1D2,Int(Times(Log(Plus(C1,Times(C1,Power(Plus($s("a"),Times($s("b"),$s("x"))),CN1)))),Power(Plus($s("c"),Times($s("d"),Power($s("x"),$s("n")))),CN1)),$s("x"))),Times(CN1,Dist(C1D2,Int(Times(Log(Plus(C1,Times(CN1,Times(C1,Power(Plus($s("a"),Times($s("b"),$s("x"))),CN1))))),Power(Plus($s("c"),Times($s("d"),Power($s("x"),$s("n")))),CN1)),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),IntegerQ($s("n"))),Not(And(Equal($s("n"),C1),ZeroQ(Plus(Times($s("a"),$s("d")),Times(CN1,Times($s("b"),$s("c")))))))))),
SetDelayed(Int(ArcSech(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Plus($s("a"),Times($s("b"),$s("x"))),Times(ArcSech(Plus($s("a"),Times($s("b"),$s("x")))),Power($s("b"),CN1))),Times(CN1,Times(C2,Times(ArcTan(Sqrt(Times(Plus(Plus(C1,Times(CN1,$s("a"))),Times(CN1,Times($s("b"),$s("x")))),Power(Plus(Plus(C1,$s("a")),Times($s("b"),$s("x"))),CN1)))),Power($s("b"),CN1))))),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(Times(ArcSech(Times($p("a",true),Power($p("x"),$p("n",true)))),Power($p("x"),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(CN1,Power(ArcSech(Times($s("a"),Power($s("x"),$s("n")))),C2)),Power(Times(C2,$s("n")),CN1)),Times(CN1,Times(ArcSech(Times($s("a"),Power($s("x"),$s("n")))),Times(Log(Plus(C1,Power(E,Times(integer(-2L),ArcSech(Times($s("a"),Power($s("x"),$s("n")))))))),Power($s("n"),CN1))))),Times(PolyLog(C2,Times(CN1,Power(E,Times(integer(-2L),ArcSech(Times($s("a"),Power($s("x"),$s("n")))))))),Power(Times(C2,$s("n")),CN1))),FreeQ(List($s("a"),$s("n")),$s("x")))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),ArcSech(Plus($p("a"),Times($p("b",true),$p("x"))))),$p("x",$s("Symbol"))),
    Condition(Dist(Times(C1,Power($s("b"),CN1)),Subst(Int(Times(Power(Plus(Times(Times(CN1,$s("a")),Power($s("b"),CN1)),Times($s("x"),Power($s("b"),CN1))),$s("m")),ArcSech($s("x"))),$s("x")),$s("x"),Plus($s("a"),Times($s("b"),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ($s("m"))),Greater($s("m"),C0)))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),ArcSech(Times($p("a",true),$p("x")))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Times(ArcSech(Times($s("a"),$s("x"))),Power(Plus($s("m"),C1),CN1))),Dist(Times(C1,Power(Plus($s("m"),C1),CN1)),Int(Times(Power($s("x"),$s("m")),Power(Times(Sqrt(Times(Plus(C1,Times(CN1,Times($s("a"),$s("x")))),Power(Plus(C1,Times($s("a"),$s("x"))),CN1))),Plus(C1,Times($s("a"),$s("x")))),CN1)),$s("x")))),And(FreeQ(List($s("a"),$s("m")),$s("x")),NonzeroQ(Plus($s("m"),C1))))),
SetDelayed(Int(Times($p("u",true),Power(ArcSech(Times($p("c",true),Power(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n",true)))),CN1))),$p("m",true))),$p("x",$s("Symbol"))),
    Condition(Int(Times($s("u"),Power(ArcCosh(Plus(Times($s("a"),Power($s("c"),CN1)),Times($s("b"),Times(Power($s("x"),$s("n")),Power($s("c"),CN1))))),$s("m"))),$s("x")),FreeQ(List($s("a"),$s("b"),$s("c"),$s("n"),$s("m")),$s("x")))),
SetDelayed(Int(Power(E,Times($p("n",true),ArcSech($p("v")))),$p("x",$s("Symbol"))),
    Condition(Int(Power(Plus(Plus(Times(C1,Power($s("v"),CN1)),Sqrt(Times(Plus(C1,Times(CN1,$s("v"))),Power(Plus(C1,$s("v")),CN1)))),Times(Sqrt(Times(Plus(C1,Times(CN1,$s("v"))),Power(Plus(C1,$s("v")),CN1))),Power($s("v"),CN1))),$s("n")),$s("x")),And(IntegerQ($s("n")),PolynomialQ($s("v"),$s("x"))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(E,Times($p("n",true),ArcSech($p("v"))))),$p("x",$s("Symbol"))),
    Condition(Int(Times(Power($s("x"),$s("m")),Power(Plus(Plus(Times(C1,Power($s("v"),CN1)),Sqrt(Times(Plus(C1,Times(CN1,$s("v"))),Power(Plus(C1,$s("v")),CN1)))),Times(Sqrt(Times(Plus(C1,Times(CN1,$s("v"))),Power(Plus(C1,$s("v")),CN1))),Power($s("v"),CN1))),$s("n"))),$s("x")),And(And(RationalQ($s("m")),IntegerQ($s("n"))),PolynomialQ($s("v"),$s("x"))))),
SetDelayed(Int(ArcCsch(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Plus($s("a"),Times($s("b"),$s("x"))),Times(ArcCsch(Plus($s("a"),Times($s("b"),$s("x")))),Power($s("b"),CN1))),Times(ArcTanh(Sqrt(Plus(C1,Times(C1,Power(Power(Plus($s("a"),Times($s("b"),$s("x"))),C2),CN1))))),Power($s("b"),CN1))),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(Times(ArcCsch(Times($p("a",true),Power($p("x"),$p("n",true)))),Power($p("x"),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(CN1,Power(ArcCsch(Times($s("a"),Power($s("x"),$s("n")))),C2)),Power(Times(C2,$s("n")),CN1)),Times(CN1,Times(ArcCsch(Times($s("a"),Power($s("x"),$s("n")))),Times(Log(Plus(C1,Times(CN1,Power(E,Times(integer(-2L),ArcCsch(Times($s("a"),Power($s("x"),$s("n"))))))))),Power($s("n"),CN1))))),Times(PolyLog(C2,Power(E,Times(integer(-2L),ArcCsch(Times($s("a"),Power($s("x"),$s("n"))))))),Power(Times(C2,$s("n")),CN1))),FreeQ(List($s("a"),$s("n")),$s("x")))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),ArcCsch(Plus($p("a"),Times($p("b",true),$p("x"))))),$p("x",$s("Symbol"))),
    Condition(Dist(Times(C1,Power($s("b"),CN1)),Subst(Int(Times(Power(Plus(Times(Times(CN1,$s("a")),Power($s("b"),CN1)),Times($s("x"),Power($s("b"),CN1))),$s("m")),ArcCsch($s("x"))),$s("x")),$s("x"),Plus($s("a"),Times($s("b"),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ($s("m"))),Greater($s("m"),C0)))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),ArcCsch(Plus($p("a",true),Times($p("b",true),$p("x"))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Times(ArcCsch(Plus($s("a"),Times($s("b"),$s("x")))),Power(Plus($s("m"),C1),CN1))),Dist(Times($s("b"),Power(Plus($s("m"),C1),CN1)),Int(Times(Power($s("x"),Plus($s("m"),C1)),Power(Times(Power(Plus($s("a"),Times($s("b"),$s("x"))),C2),Sqrt(Plus(C1,Times(C1,Power(Power(Plus($s("a"),Times($s("b"),$s("x"))),C2),CN1))))),CN1)),$s("x")))),And(FreeQ(List($s("a"),$s("b"),$s("m")),$s("x")),NonzeroQ(Plus($s("m"),C1))))),
SetDelayed(Int(Times($p("u",true),Power(ArcCsch(Times($p("c",true),Power(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n",true)))),CN1))),$p("m",true))),$p("x",$s("Symbol"))),
    Condition(Int(Times($s("u"),Power(ArcSinh(Plus(Times($s("a"),Power($s("c"),CN1)),Times($s("b"),Times(Power($s("x"),$s("n")),Power($s("c"),CN1))))),$s("m"))),$s("x")),FreeQ(List($s("a"),$s("b"),$s("c"),$s("n"),$s("m")),$s("x")))),
SetDelayed(Int(ArcCsch($p("u")),$p("x",$s("Symbol"))),
    Condition(Plus(Times($s("x"),ArcCsch($s("u"))),Int(Regularize(Times($s("x"),Times(D($s("u"),$s("x")),Power(Times(Power($s("u"),C2),Sqrt(Plus(C1,Times(C1,Power(Power($s("u"),C2),CN1))))),CN1))),$s("x")),$s("x"))),And(InverseFunctionFreeQ($s("u"),$s("x")),Not(MatchQ($s("u"),Condition(Plus($p("c",true),Times($p("d",true),Power($p("f"),Plus($p("a",true),Times($p("b",true),$s("x")))))),FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("f")),$s("x")))))))),
SetDelayed(Int(Power(E,Times($p("n",true),ArcCsch($p("v")))),$p("x",$s("Symbol"))),
    Condition(Int(Power(Plus(Times(C1,Power($s("v"),CN1)),Sqrt(Plus(C1,Times(C1,Power(Power($s("v"),C2),CN1))))),$s("n")),$s("x")),And(IntegerQ($s("n")),PolynomialQ($s("v"),$s("x"))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(E,Times($p("n",true),ArcCsch($p("v"))))),$p("x",$s("Symbol"))),
    Condition(Int(Times(Power($s("x"),$s("m")),Power(Plus(Times(C1,Power($s("v"),CN1)),Sqrt(Plus(C1,Times(C1,Power(Power($s("v"),C2),CN1))))),$s("n"))),$s("x")),And(And(RationalQ($s("m")),IntegerQ($s("n"))),PolynomialQ($s("v"),$s("x"))))),
SetDelayed(Int(Erf(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Plus($s("a"),Times($s("b"),$s("x"))),Times(Erf(Plus($s("a"),Times($s("b"),$s("x")))),Power($s("b"),CN1))),Times(C1,Power(Times(Times($s("b"),Sqrt(Pi)),Exp(Power(Plus($s("a"),Times($s("b"),$s("x"))),C2))),CN1))),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(Power(Erf(Plus($p("a",true),Times($p("b",true),$p("x")))),C2),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Plus($s("a"),Times($s("b"),$s("x"))),Times(Power(Erf(Plus($s("a"),Times($s("b"),$s("x")))),C2),Power($s("b"),CN1))),Times(CN1,Dist(Times(C4,Power(Sqrt(Pi),CN1)),Int(Times(Plus($s("a"),Times($s("b"),$s("x"))),Times(Erf(Plus($s("a"),Times($s("b"),$s("x")))),Power(Power(E,Power(Plus($s("a"),Times($s("b"),$s("x"))),C2)),CN1))),$s("x"))))),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Erf(Plus($p("a",true),Times($p("b",true),$p("x"))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Times(Erf(Plus($s("a"),Times($s("b"),$s("x")))),Power(Plus($s("m"),C1),CN1))),Times(CN1,Dist(Times(C2,Times($s("b"),Power(Times(Sqrt(Pi),Plus($s("m"),C1)),CN1))),Int(Times(Power($s("x"),Plus($s("m"),C1)),Power(Exp(Power(Plus($s("a"),Times($s("b"),$s("x"))),C2)),CN1)),$s("x"))))),And(FreeQ(List($s("a"),$s("b"),$s("m")),$s("x")),NonzeroQ(Plus($s("m"),C1))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Erf(Times($p("b",true),$p("x"))),C2)),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Times(Power(Erf(Times($s("b"),$s("x"))),C2),Power(Plus($s("m"),C1),CN1))),Times(CN1,Dist(Times(C4,Times($s("b"),Power(Times(Sqrt(Pi),Plus($s("m"),C1)),CN1))),Int(Times(Times(Power($s("x"),Plus($s("m"),C1)),Power(E,Times(Times(CN1,Power($s("b"),C2)),Power($s("x"),C2)))),Erf(Times($s("b"),$s("x")))),$s("x"))))),And(And(And(FreeQ($s("b"),$s("x")),IntegerQ($s("m"))),Unequal(Plus($s("m"),C1),C0)),Or(Greater($s("m"),C0),OddQ($s("m")))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Erf(Plus($p("a"),Times($p("b",true),$p("x")))),C2)),$p("x",$s("Symbol"))),
    Condition(Dist(Times(C1,Power($s("b"),CN1)),Subst(Int(Times(Power(Plus(Times(Times(CN1,$s("a")),Power($s("b"),CN1)),Times($s("x"),Power($s("b"),CN1))),$s("m")),Power(Erf($s("x")),C2)),$s("x")),$s("x"),Plus($s("a"),Times($s("b"),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ($s("m"))),Greater($s("m"),C0)))),
SetDelayed(Int(Times(Times($p("x"),Power(E,Times($p("c",true),Power($p("x"),C2)))),Erf(Times($p("b",true),$p("x")))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Power(E,Times(Times(CN1,Power($s("b"),C2)),Power($s("x"),C2)))),Times(Erf(Times($s("b"),$s("x"))),Power(Times(C2,Power($s("b"),C2)),CN1))),Dist(Times(C1,Power(Times($s("b"),Sqrt(Pi)),CN1)),Int(Power(E,Times(Times(integer(-2L),Power($s("b"),C2)),Power($s("x"),C2))),$s("x")))),And(FreeQ(List($s("b"),$s("c")),$s("x")),SameQ($s("c"),Times(CN1,Power($s("b"),C2)))))),
SetDelayed(Int(Times(Times(Power($p("x"),$p("m")),Power(E,Times($p("c",true),Power($p("x"),C2)))),Erf(Times($p("b",true),$p("x")))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(Times(CN1,Power($s("x"),Plus($s("m"),Times(CN1,C1)))),Power(E,Times(Times(CN1,Power($s("b"),C2)),Power($s("x"),C2)))),Times(Erf(Times($s("b"),$s("x"))),Power(Times(C2,Power($s("b"),C2)),CN1))),Dist(Times(C1,Power(Times($s("b"),Sqrt(Pi)),CN1)),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,C1))),Power(E,Times(Times(integer(-2L),Power($s("b"),C2)),Power($s("x"),C2)))),$s("x")))),Dist(Times(Plus($s("m"),Times(CN1,C1)),Power(Times(C2,Power($s("b"),C2)),CN1)),Int(Times(Times(Power($s("x"),Plus($s("m"),Times(CN1,C2))),Power(E,Times(Times(CN1,Power($s("b"),C2)),Power($s("x"),C2)))),Erf(Times($s("b"),$s("x")))),$s("x")))),And(And(And(FreeQ(List($s("b"),$s("c")),$s("x")),SameQ($s("c"),Times(CN1,Power($s("b"),C2)))),IntegerQ($s("m"))),Greater($s("m"),C1)))),
SetDelayed(Int(Times(Times(Power($p("x"),$p("m")),Power(E,Times($p("c",true),Power($p("x"),C2)))),Erf(Times($p("b",true),$p("x")))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(Power($s("x"),Plus($s("m"),C1)),Power(E,Times(Times(CN1,Power($s("b"),C2)),Power($s("x"),C2)))),Times(Erf(Times($s("b"),$s("x"))),Power(Plus($s("m"),C1),CN1))),Times(CN1,Dist(Times(C2,Times($s("b"),Power(Times(Sqrt(Pi),Plus($s("m"),C1)),CN1))),Int(Times(Power($s("x"),Plus($s("m"),C1)),Power(E,Times(Times(integer(-2L),Power($s("b"),C2)),Power($s("x"),C2)))),$s("x"))))),Dist(Times(C2,Times(Power($s("b"),C2),Power(Plus($s("m"),C1),CN1))),Int(Times(Times(Power($s("x"),Plus($s("m"),C2)),Power(E,Times(Times(CN1,Power($s("b"),C2)),Power($s("x"),C2)))),Erf(Times($s("b"),$s("x")))),$s("x")))),And(And(And(FreeQ(List($s("b"),$s("c")),$s("x")),SameQ($s("c"),Times(CN1,Power($s("b"),C2)))),EvenQ($s("m"))),Less($s("m"),CN1)))),
SetDelayed(Int(Erfc(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Plus($s("a"),Times($s("b"),$s("x"))),Times(Erfc(Plus($s("a"),Times($s("b"),$s("x")))),Power($s("b"),CN1))),Times(CN1,Times(C1,Power(Times(Times($s("b"),Sqrt(Pi)),Exp(Power(Plus($s("a"),Times($s("b"),$s("x"))),C2))),CN1)))),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(Power(Erfc(Plus($p("a",true),Times($p("b",true),$p("x")))),C2),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Plus($s("a"),Times($s("b"),$s("x"))),Times(Power(Erfc(Plus($s("a"),Times($s("b"),$s("x")))),C2),Power($s("b"),CN1))),Dist(Times(C4,Power(Sqrt(Pi),CN1)),Int(Times(Plus($s("a"),Times($s("b"),$s("x"))),Times(Erfc(Plus($s("a"),Times($s("b"),$s("x")))),Power(Power(E,Power(Plus($s("a"),Times($s("b"),$s("x"))),C2)),CN1))),$s("x")))),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Erfc(Plus($p("a",true),Times($p("b",true),$p("x"))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Times(Erfc(Plus($s("a"),Times($s("b"),$s("x")))),Power(Plus($s("m"),C1),CN1))),Dist(Times(C2,Times($s("b"),Power(Times(Sqrt(Pi),Plus($s("m"),C1)),CN1))),Int(Times(Power($s("x"),Plus($s("m"),C1)),Power(Exp(Power(Plus($s("a"),Times($s("b"),$s("x"))),C2)),CN1)),$s("x")))),And(FreeQ(List($s("a"),$s("b"),$s("m")),$s("x")),NonzeroQ(Plus($s("m"),C1))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Erfc(Times($p("b",true),$p("x"))),C2)),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Times(Power(Erfc(Times($s("b"),$s("x"))),C2),Power(Plus($s("m"),C1),CN1))),Dist(Times(C4,Times($s("b"),Power(Times(Sqrt(Pi),Plus($s("m"),C1)),CN1))),Int(Times(Times(Power($s("x"),Plus($s("m"),C1)),Power(E,Times(Times(CN1,Power($s("b"),C2)),Power($s("x"),C2)))),Erfc(Times($s("b"),$s("x")))),$s("x")))),And(And(And(FreeQ($s("b"),$s("x")),IntegerQ($s("m"))),Unequal(Plus($s("m"),C1),C0)),Or(Greater($s("m"),C0),OddQ($s("m")))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Erfc(Plus($p("a"),Times($p("b",true),$p("x")))),C2)),$p("x",$s("Symbol"))),
    Condition(Dist(Times(C1,Power($s("b"),CN1)),Subst(Int(Times(Power(Plus(Times(Times(CN1,$s("a")),Power($s("b"),CN1)),Times($s("x"),Power($s("b"),CN1))),$s("m")),Power(Erfc($s("x")),C2)),$s("x")),$s("x"),Plus($s("a"),Times($s("b"),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ($s("m"))),Greater($s("m"),C0)))),
SetDelayed(Int(Times(Times($p("x"),Power(E,Times($p("c",true),Power($p("x"),C2)))),Erfc(Times($p("b",true),$p("x")))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Power(E,Times(Times(CN1,Power($s("b"),C2)),Power($s("x"),C2)))),Times(Erfc(Times($s("b"),$s("x"))),Power(Times(C2,Power($s("b"),C2)),CN1))),Times(CN1,Dist(Times(C1,Power(Times($s("b"),Sqrt(Pi)),CN1)),Int(Power(E,Times(Times(integer(-2L),Power($s("b"),C2)),Power($s("x"),C2))),$s("x"))))),And(FreeQ(List($s("b"),$s("c")),$s("x")),SameQ($s("c"),Times(CN1,Power($s("b"),C2)))))),
SetDelayed(Int(Times(Times(Power($p("x"),$p("m")),Power(E,Times($p("c",true),Power($p("x"),C2)))),Erfc(Times($p("b",true),$p("x")))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(Times(CN1,Power($s("x"),Plus($s("m"),Times(CN1,C1)))),Power(E,Times(Times(CN1,Power($s("b"),C2)),Power($s("x"),C2)))),Times(Erfc(Times($s("b"),$s("x"))),Power(Times(C2,Power($s("b"),C2)),CN1))),Times(CN1,Dist(Times(C1,Power(Times($s("b"),Sqrt(Pi)),CN1)),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,C1))),Power(E,Times(Times(integer(-2L),Power($s("b"),C2)),Power($s("x"),C2)))),$s("x"))))),Dist(Times(Plus($s("m"),Times(CN1,C1)),Power(Times(C2,Power($s("b"),C2)),CN1)),Int(Times(Times(Power($s("x"),Plus($s("m"),Times(CN1,C2))),Power(E,Times(Times(CN1,Power($s("b"),C2)),Power($s("x"),C2)))),Erfc(Times($s("b"),$s("x")))),$s("x")))),And(And(And(FreeQ(List($s("b"),$s("c")),$s("x")),SameQ($s("c"),Times(CN1,Power($s("b"),C2)))),IntegerQ($s("m"))),Greater($s("m"),C1)))),
SetDelayed(Int(Times(Times(Power($p("x"),$p("m")),Power(E,Times($p("c",true),Power($p("x"),C2)))),Erfc(Times($p("b",true),$p("x")))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(Power($s("x"),Plus($s("m"),C1)),Power(E,Times(Times(CN1,Power($s("b"),C2)),Power($s("x"),C2)))),Times(Erfc(Times($s("b"),$s("x"))),Power(Plus($s("m"),C1),CN1))),Dist(Times(C2,Times($s("b"),Power(Times(Sqrt(Pi),Plus($s("m"),C1)),CN1))),Int(Times(Power($s("x"),Plus($s("m"),C1)),Power(E,Times(Times(integer(-2L),Power($s("b"),C2)),Power($s("x"),C2)))),$s("x")))),Dist(Times(C2,Times(Power($s("b"),C2),Power(Plus($s("m"),C1),CN1))),Int(Times(Times(Power($s("x"),Plus($s("m"),C2)),Power(E,Times(Times(CN1,Power($s("b"),C2)),Power($s("x"),C2)))),Erfc(Times($s("b"),$s("x")))),$s("x")))),And(And(And(FreeQ(List($s("b"),$s("c")),$s("x")),SameQ($s("c"),Times(CN1,Power($s("b"),C2)))),EvenQ($s("m"))),Less($s("m"),CN1)))),
SetDelayed(Int(Erfi(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Plus($s("a"),Times($s("b"),$s("x"))),Times(Erfi(Plus($s("a"),Times($s("b"),$s("x")))),Power($s("b"),CN1))),Times(CN1,Times(Exp(Power(Plus($s("a"),Times($s("b"),$s("x"))),C2)),Power(Times($s("b"),Sqrt(Pi)),CN1)))),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(Power(Erfi(Plus($p("a",true),Times($p("b",true),$p("x")))),C2),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Plus($s("a"),Times($s("b"),$s("x"))),Times(Power(Erfi(Plus($s("a"),Times($s("b"),$s("x")))),C2),Power($s("b"),CN1))),Times(CN1,Dist(Times(C4,Power(Sqrt(Pi),CN1)),Int(Times(Times(Plus($s("a"),Times($s("b"),$s("x"))),Power(E,Power(Plus($s("a"),Times($s("b"),$s("x"))),C2))),Erfi(Plus($s("a"),Times($s("b"),$s("x"))))),$s("x"))))),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Erfi(Plus($p("a",true),Times($p("b",true),$p("x"))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Times(Erfi(Plus($s("a"),Times($s("b"),$s("x")))),Power(Plus($s("m"),C1),CN1))),Times(CN1,Dist(Times(C2,Times($s("b"),Power(Times(Sqrt(Pi),Plus($s("m"),C1)),CN1))),Int(Times(Power($s("x"),Plus($s("m"),C1)),Exp(Power(Plus($s("a"),Times($s("b"),$s("x"))),C2))),$s("x"))))),And(FreeQ(List($s("a"),$s("b"),$s("m")),$s("x")),NonzeroQ(Plus($s("m"),C1))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Erfi(Times($p("b",true),$p("x"))),C2)),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Times(Power(Erfi(Times($s("b"),$s("x"))),C2),Power(Plus($s("m"),C1),CN1))),Times(CN1,Dist(Times(C4,Times($s("b"),Power(Times(Sqrt(Pi),Plus($s("m"),C1)),CN1))),Int(Times(Times(Power($s("x"),Plus($s("m"),C1)),Power(E,Times(Power($s("b"),C2),Power($s("x"),C2)))),Erfi(Times($s("b"),$s("x")))),$s("x"))))),And(And(And(FreeQ($s("b"),$s("x")),IntegerQ($s("m"))),Unequal(Plus($s("m"),C1),C0)),Or(Greater($s("m"),C0),OddQ($s("m")))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Erfi(Plus($p("a"),Times($p("b",true),$p("x")))),C2)),$p("x",$s("Symbol"))),
    Condition(Dist(Times(C1,Power($s("b"),CN1)),Subst(Int(Times(Power(Plus(Times(Times(CN1,$s("a")),Power($s("b"),CN1)),Times($s("x"),Power($s("b"),CN1))),$s("m")),Power(Erfi($s("x")),C2)),$s("x")),$s("x"),Plus($s("a"),Times($s("b"),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ($s("m"))),Greater($s("m"),C0)))),
SetDelayed(Int(Times(Times($p("x"),Power(E,Times($p("c",true),Power($p("x"),C2)))),Erfi(Times($p("b",true),$p("x")))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power(E,Times(Power($s("b"),C2),Power($s("x"),C2))),Times(Erfi(Times($s("b"),$s("x"))),Power(Times(C2,Power($s("b"),C2)),CN1))),Times(CN1,Dist(Times(C1,Power(Times($s("b"),Sqrt(Pi)),CN1)),Int(Power(E,Times(Times(C2,Power($s("b"),C2)),Power($s("x"),C2))),$s("x"))))),And(FreeQ(List($s("b"),$s("c")),$s("x")),SameQ($s("c"),Power($s("b"),C2))))),
SetDelayed(Int(Times(Times(Power($p("x"),$p("m")),Power(E,Times($p("c",true),Power($p("x"),C2)))),Erfi(Times($p("b",true),$p("x")))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(Power($s("x"),Plus($s("m"),Times(CN1,C1))),Power(E,Times(Power($s("b"),C2),Power($s("x"),C2)))),Times(Erfi(Times($s("b"),$s("x"))),Power(Times(C2,Power($s("b"),C2)),CN1))),Times(CN1,Dist(Times(C1,Power(Times($s("b"),Sqrt(Pi)),CN1)),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,C1))),Power(E,Times(Times(C2,Power($s("b"),C2)),Power($s("x"),C2)))),$s("x"))))),Times(CN1,Dist(Times(Plus($s("m"),Times(CN1,C1)),Power(Times(C2,Power($s("b"),C2)),CN1)),Int(Times(Times(Power($s("x"),Plus($s("m"),Times(CN1,C2))),Power(E,Times(Power($s("b"),C2),Power($s("x"),C2)))),Erfi(Times($s("b"),$s("x")))),$s("x"))))),And(And(And(FreeQ(List($s("b"),$s("c")),$s("x")),SameQ($s("c"),Power($s("b"),C2))),IntegerQ($s("m"))),Greater($s("m"),C1)))),
SetDelayed(Int(Times(Times(Power($p("x"),$p("m")),Power(E,Times($p("c",true),Power($p("x"),C2)))),Erfi(Times($p("b",true),$p("x")))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(Power($s("x"),Plus($s("m"),C1)),Power(E,Times(Power($s("b"),C2),Power($s("x"),C2)))),Times(Erfi(Times($s("b"),$s("x"))),Power(Plus($s("m"),C1),CN1))),Times(CN1,Dist(Times(C2,Times($s("b"),Power(Times(Sqrt(Pi),Plus($s("m"),C1)),CN1))),Int(Times(Power($s("x"),Plus($s("m"),C1)),Power(E,Times(Times(C2,Power($s("b"),C2)),Power($s("x"),C2)))),$s("x"))))),Times(CN1,Dist(Times(C2,Times(Power($s("b"),C2),Power(Plus($s("m"),C1),CN1))),Int(Times(Times(Power($s("x"),Plus($s("m"),C2)),Power(E,Times(Power($s("b"),C2),Power($s("x"),C2)))),Erfi(Times($s("b"),$s("x")))),$s("x"))))),And(And(And(FreeQ(List($s("b"),$s("c")),$s("x")),SameQ($s("c"),Power($s("b"),C2))),EvenQ($s("m"))),Less($s("m"),CN1)))),
SetDelayed(Int(FresnelS(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Plus($s("a"),Times($s("b"),$s("x"))),Times(FresnelS(Plus($s("a"),Times($s("b"),$s("x")))),Power($s("b"),CN1))),Times(Cos(Times(Times(Pi,C1D2),Power(Plus($s("a"),Times($s("b"),$s("x"))),C2))),Power(Times($s("b"),Pi),CN1))),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(Power(FresnelS(Plus($p("a",true),Times($p("b",true),$p("x")))),C2),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Plus($s("a"),Times($s("b"),$s("x"))),Times(Power(FresnelS(Plus($s("a"),Times($s("b"),$s("x")))),C2),Power($s("b"),CN1))),Times(CN1,Dist(C2,Int(Times(Times(Plus($s("a"),Times($s("b"),$s("x"))),Sin(Times(Times(Pi,C1D2),Power(Plus($s("a"),Times($s("b"),$s("x"))),C2)))),FresnelS(Plus($s("a"),Times($s("b"),$s("x"))))),$s("x"))))),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),FresnelS(Plus($p("a",true),Times($p("b",true),$p("x"))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Times(FresnelS(Plus($s("a"),Times($s("b"),$s("x")))),Power(Plus($s("m"),C1),CN1))),Times(CN1,Dist(Times($s("b"),Power(Plus($s("m"),C1),CN1)),Int(Times(Power($s("x"),Plus($s("m"),C1)),Sin(Times(Times(Pi,C1D2),Power(Plus($s("a"),Times($s("b"),$s("x"))),C2)))),$s("x"))))),And(FreeQ(List($s("a"),$s("b"),$s("m")),$s("x")),NonzeroQ(Plus($s("m"),C1))))),
SetDelayed(Int(Times(Power($p("x"),$p("m")),Power(FresnelS(Times($p("b",true),$p("x"))),C2)),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Times(Power(FresnelS(Times($s("b"),$s("x"))),C2),Power(Plus($s("m"),C1),CN1))),Times(CN1,Dist(Times(C2,Times($s("b"),Power(Plus($s("m"),C1),CN1))),Int(Times(Times(Power($s("x"),Plus($s("m"),C1)),Sin(Times(Times(Times(Pi,C1D2),Power($s("b"),C2)),Power($s("x"),C2)))),FresnelS(Times($s("b"),$s("x")))),$s("x"))))),And(And(And(FreeQ($s("b"),$s("x")),IntegerQ($s("m"))),Unequal(Plus($s("m"),C1),C0)),Or(And(Greater($s("m"),C0),EvenQ($s("m"))),Equal(Mod($s("m"),C4),C3))))),
SetDelayed(Int(Times(Times($p("x"),Sin(Times($p("c",true),Power($p("x"),C2)))),FresnelS(Times($p("b",true),$p("x")))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Cos(Times(Times(Times(Pi,C1D2),Power($s("b"),C2)),Power($s("x"),C2)))),Times(FresnelS(Times($s("b"),$s("x"))),Power(Times(Pi,Power($s("b"),C2)),CN1))),Dist(Times(C1,Power(Times(Times(C2,$s("b")),Pi),CN1)),Int(Sin(Times(Times(Pi,Power($s("b"),C2)),Power($s("x"),C2))),$s("x")))),And(FreeQ(List($s("b"),$s("c")),$s("x")),SameQ($s("c"),Times(Times(Pi,C1D2),Power($s("b"),C2)))))),
SetDelayed(Int(Times(Times(Power($p("x"),$p("m")),Sin(Times($p("c",true),Power($p("x"),C2)))),FresnelS(Times($p("b",true),$p("x")))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(Times(CN1,Power($s("x"),Plus($s("m"),Times(CN1,C1)))),Cos(Times(Times(Times(Pi,C1D2),Power($s("b"),C2)),Power($s("x"),C2)))),Times(FresnelS(Times($s("b"),$s("x"))),Power(Times(Pi,Power($s("b"),C2)),CN1))),Dist(Times(C1,Power(Times(Times(C2,$s("b")),Pi),CN1)),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,C1))),Sin(Times(Times(Pi,Power($s("b"),C2)),Power($s("x"),C2)))),$s("x")))),Dist(Times(Plus($s("m"),Times(CN1,C1)),Power(Times(Pi,Power($s("b"),C2)),CN1)),Int(Times(Times(Power($s("x"),Plus($s("m"),Times(CN1,C2))),Cos(Times(Times(Times(Pi,C1D2),Power($s("b"),C2)),Power($s("x"),C2)))),FresnelS(Times($s("b"),$s("x")))),$s("x")))),And(And(And(And(FreeQ(List($s("b"),$s("c")),$s("x")),SameQ($s("c"),Times(Times(Pi,C1D2),Power($s("b"),C2)))),IntegerQ($s("m"))),Greater($s("m"),C1)),Not(Equal(Mod($s("m"),C4),C2))))),
SetDelayed(Int(Times(Times(Power($p("x"),$p("m")),Sin(Times($p("c",true),Power($p("x"),C2)))),FresnelS(Times($p("b",true),$p("x")))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Plus(Times(Times(Power($s("x"),Plus($s("m"),C1)),Sin(Times(Times(Times(Pi,C1D2),Power($s("b"),C2)),Power($s("x"),C2)))),Times(FresnelS(Times($s("b"),$s("x"))),Power(Plus($s("m"),C1),CN1))),Times(CN1,Times($s("b"),Times(Power($s("x"),Plus($s("m"),C2)),Power(Times(Times(C2,Plus($s("m"),C1)),Plus($s("m"),C2)),CN1))))),Dist(Times($s("b"),Power(Times(C2,Plus($s("m"),C1)),CN1)),Int(Times(Power($s("x"),Plus($s("m"),C1)),Cos(Times(Times(Pi,Power($s("b"),C2)),Power($s("x"),C2)))),$s("x")))),Times(CN1,Dist(Times(Pi,Times(Power($s("b"),C2),Power(Plus($s("m"),C1),CN1))),Int(Times(Times(Power($s("x"),Plus($s("m"),C2)),Cos(Times(Times(Times(Pi,C1D2),Power($s("b"),C2)),Power($s("x"),C2)))),FresnelS(Times($s("b"),$s("x")))),$s("x"))))),And(And(And(And(FreeQ(List($s("b"),$s("c")),$s("x")),SameQ($s("c"),Times(Times(Pi,C1D2),Power($s("b"),C2)))),IntegerQ($s("m"))),Less($s("m"),integer(-2L))),Equal(Mod($s("m"),C4),C0)))),
SetDelayed(Int(Times(Times($p("x"),Cos(Times($p("c",true),Power($p("x"),C2)))),FresnelS(Times($p("b",true),$p("x")))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Sin(Times(Times(Times(Pi,C1D2),Power($s("b"),C2)),Power($s("x"),C2))),Times(FresnelS(Times($s("b"),$s("x"))),Power(Times(Pi,Power($s("b"),C2)),CN1))),Times(CN1,Times($s("x"),Power(Times(Times(C2,$s("b")),Pi),CN1)))),Dist(Times(C1,Power(Times(Times(C2,$s("b")),Pi),CN1)),Int(Cos(Times(Times(Pi,Power($s("b"),C2)),Power($s("x"),C2))),$s("x")))),And(FreeQ(List($s("b"),$s("c")),$s("x")),SameQ($s("c"),Times(Times(Pi,C1D2),Power($s("b"),C2)))))),
SetDelayed(Int(Times(Times(Power($p("x"),$p("m")),Cos(Times($p("c",true),Power($p("x"),C2)))),FresnelS(Times($p("b",true),$p("x")))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Plus(Times(Times(Power($s("x"),Plus($s("m"),Times(CN1,C1))),Sin(Times(Times(Times(Pi,C1D2),Power($s("b"),C2)),Power($s("x"),C2)))),Times(FresnelS(Times($s("b"),$s("x"))),Power(Times(Pi,Power($s("b"),C2)),CN1))),Times(CN1,Times(Power($s("x"),$s("m")),Power(Times(Times(Times(C2,$s("b")),$s("m")),Pi),CN1)))),Dist(Times(C1,Power(Times(Times(C2,$s("b")),Pi),CN1)),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,C1))),Cos(Times(Times(Pi,Power($s("b"),C2)),Power($s("x"),C2)))),$s("x")))),Times(CN1,Dist(Times(Plus($s("m"),Times(CN1,C1)),Power(Times(Pi,Power($s("b"),C2)),CN1)),Int(Times(Times(Power($s("x"),Plus($s("m"),Times(CN1,C2))),Sin(Times(Times(Times(Pi,C1D2),Power($s("b"),C2)),Power($s("x"),C2)))),FresnelS(Times($s("b"),$s("x")))),$s("x"))))),And(And(And(And(FreeQ(List($s("b"),$s("c")),$s("x")),SameQ($s("c"),Times(Times(Pi,C1D2),Power($s("b"),C2)))),IntegerQ($s("m"))),Greater($s("m"),C1)),Not(Equal(Mod($s("m"),C4),C0))))),
SetDelayed(Int(Times(Times(Power($p("x"),$p("m")),Cos(Times($p("c",true),Power($p("x"),C2)))),FresnelS(Times($p("b",true),$p("x")))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(Power($s("x"),Plus($s("m"),C1)),Cos(Times(Times(Times(Pi,C1D2),Power($s("b"),C2)),Power($s("x"),C2)))),Times(FresnelS(Times($s("b"),$s("x"))),Power(Plus($s("m"),C1),CN1))),Times(CN1,Dist(Times($s("b"),Power(Times(C2,Plus($s("m"),C1)),CN1)),Int(Times(Power($s("x"),Plus($s("m"),C1)),Sin(Times(Times(Pi,Power($s("b"),C2)),Power($s("x"),C2)))),$s("x"))))),Dist(Times(Pi,Times(Power($s("b"),C2),Power(Plus($s("m"),C1),CN1))),Int(Times(Times(Power($s("x"),Plus($s("m"),C2)),Sin(Times(Times(Times(Pi,C1D2),Power($s("b"),C2)),Power($s("x"),C2)))),FresnelS(Times($s("b"),$s("x")))),$s("x")))),And(And(And(And(FreeQ(List($s("b"),$s("c")),$s("x")),SameQ($s("c"),Times(Times(Pi,C1D2),Power($s("b"),C2)))),IntegerQ($s("m"))),Less($s("m"),CN1)),Equal(Mod($s("m"),C4),C2)))),
SetDelayed(Int(FresnelC(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Plus($s("a"),Times($s("b"),$s("x"))),Times(FresnelC(Plus($s("a"),Times($s("b"),$s("x")))),Power($s("b"),CN1))),Times(CN1,Times(Sin(Times(Times(Pi,C1D2),Power(Plus($s("a"),Times($s("b"),$s("x"))),C2))),Power(Times($s("b"),Pi),CN1)))),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(Power(FresnelC(Plus($p("a",true),Times($p("b",true),$p("x")))),C2),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Plus($s("a"),Times($s("b"),$s("x"))),Times(Power(FresnelC(Plus($s("a"),Times($s("b"),$s("x")))),C2),Power($s("b"),CN1))),Times(CN1,Dist(C2,Int(Times(Times(Plus($s("a"),Times($s("b"),$s("x"))),Cos(Times(Times(Pi,C1D2),Power(Plus($s("a"),Times($s("b"),$s("x"))),C2)))),FresnelC(Plus($s("a"),Times($s("b"),$s("x"))))),$s("x"))))),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),FresnelC(Plus($p("a",true),Times($p("b",true),$p("x"))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Times(FresnelC(Plus($s("a"),Times($s("b"),$s("x")))),Power(Plus($s("m"),C1),CN1))),Times(CN1,Dist(Times($s("b"),Power(Plus($s("m"),C1),CN1)),Int(Times(Power($s("x"),Plus($s("m"),C1)),Cos(Times(Times(Pi,C1D2),Power(Plus($s("a"),Times($s("b"),$s("x"))),C2)))),$s("x"))))),And(FreeQ(List($s("a"),$s("b"),$s("m")),$s("x")),NonzeroQ(Plus($s("m"),C1))))),
SetDelayed(Int(Times(Power($p("x"),$p("m")),Power(FresnelC(Times($p("b",true),$p("x"))),C2)),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Times(Power(FresnelC(Times($s("b"),$s("x"))),C2),Power(Plus($s("m"),C1),CN1))),Times(CN1,Dist(Times(C2,Times($s("b"),Power(Plus($s("m"),C1),CN1))),Int(Times(Times(Power($s("x"),Plus($s("m"),C1)),Cos(Times(Times(Times(Pi,C1D2),Power($s("b"),C2)),Power($s("x"),C2)))),FresnelC(Times($s("b"),$s("x")))),$s("x"))))),And(And(And(FreeQ($s("b"),$s("x")),IntegerQ($s("m"))),Unequal(Plus($s("m"),C1),C0)),Or(And(Greater($s("m"),C0),EvenQ($s("m"))),Equal(Mod($s("m"),C4),C3))))),
SetDelayed(Int(Times(Times($p("x"),Sin(Times($p("c",true),Power($p("x"),C2)))),FresnelC(Times($p("b",true),$p("x")))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(CN1,Cos(Times(Times(Times(Pi,C1D2),Power($s("b"),C2)),Power($s("x"),C2)))),Times(FresnelC(Times($s("b"),$s("x"))),Power(Times(Pi,Power($s("b"),C2)),CN1))),Times($s("x"),Power(Times(Times(C2,$s("b")),Pi),CN1))),Dist(Times(C1,Power(Times(Times(C2,$s("b")),Pi),CN1)),Int(Cos(Times(Times(Pi,Power($s("b"),C2)),Power($s("x"),C2))),$s("x")))),And(FreeQ(List($s("b"),$s("c")),$s("x")),SameQ($s("c"),Times(Times(Pi,C1D2),Power($s("b"),C2)))))),
SetDelayed(Int(Times(Times(Power($p("x"),$p("m")),Sin(Times($p("c",true),Power($p("x"),C2)))),FresnelC(Times($p("b",true),$p("x")))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Plus(Times(Times(Times(CN1,Power($s("x"),Plus($s("m"),Times(CN1,C1)))),Cos(Times(Times(Times(Pi,C1D2),Power($s("b"),C2)),Power($s("x"),C2)))),Times(FresnelC(Times($s("b"),$s("x"))),Power(Times(Pi,Power($s("b"),C2)),CN1))),Times(Power($s("x"),$s("m")),Power(Times(Times(Times(C2,$s("b")),$s("m")),Pi),CN1))),Dist(Times(C1,Power(Times(Times(C2,$s("b")),Pi),CN1)),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,C1))),Cos(Times(Times(Pi,Power($s("b"),C2)),Power($s("x"),C2)))),$s("x")))),Dist(Times(Plus($s("m"),Times(CN1,C1)),Power(Times(Pi,Power($s("b"),C2)),CN1)),Int(Times(Times(Power($s("x"),Plus($s("m"),Times(CN1,C2))),Cos(Times(Times(Times(Pi,C1D2),Power($s("b"),C2)),Power($s("x"),C2)))),FresnelC(Times($s("b"),$s("x")))),$s("x")))),And(And(And(And(FreeQ(List($s("b"),$s("c")),$s("x")),SameQ($s("c"),Times(Times(Pi,C1D2),Power($s("b"),C2)))),IntegerQ($s("m"))),Greater($s("m"),C1)),Not(Equal(Mod($s("m"),C4),C0))))),
SetDelayed(Int(Times(Times(Power($p("x"),$p("m")),Sin(Times($p("c",true),Power($p("x"),C2)))),FresnelC(Times($p("b",true),$p("x")))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(Power($s("x"),Plus($s("m"),C1)),Sin(Times(Times(Times(Pi,C1D2),Power($s("b"),C2)),Power($s("x"),C2)))),Times(FresnelC(Times($s("b"),$s("x"))),Power(Plus($s("m"),C1),CN1))),Times(CN1,Dist(Times($s("b"),Power(Times(C2,Plus($s("m"),C1)),CN1)),Int(Times(Power($s("x"),Plus($s("m"),C1)),Sin(Times(Times(Pi,Power($s("b"),C2)),Power($s("x"),C2)))),$s("x"))))),Times(CN1,Dist(Times(Pi,Times(Power($s("b"),C2),Power(Plus($s("m"),C1),CN1))),Int(Times(Times(Power($s("x"),Plus($s("m"),C2)),Cos(Times(Times(Times(Pi,C1D2),Power($s("b"),C2)),Power($s("x"),C2)))),FresnelC(Times($s("b"),$s("x")))),$s("x"))))),And(And(And(And(FreeQ(List($s("b"),$s("c")),$s("x")),SameQ($s("c"),Times(Times(Pi,C1D2),Power($s("b"),C2)))),IntegerQ($s("m"))),Less($s("m"),CN1)),Equal(Mod($s("m"),C4),C2)))),
SetDelayed(Int(Times(Times($p("x"),Cos(Times($p("c",true),Power($p("x"),C2)))),FresnelC(Times($p("b",true),$p("x")))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Sin(Times(Times(Times(Pi,C1D2),Power($s("b"),C2)),Power($s("x"),C2))),Times(FresnelC(Times($s("b"),$s("x"))),Power(Times(Pi,Power($s("b"),C2)),CN1))),Times(CN1,Dist(Times(C1,Power(Times(Times(C2,$s("b")),Pi),CN1)),Int(Sin(Times(Times(Pi,Power($s("b"),C2)),Power($s("x"),C2))),$s("x"))))),And(FreeQ(List($s("b"),$s("c")),$s("x")),SameQ($s("c"),Times(Times(Pi,C1D2),Power($s("b"),C2)))))),
SetDelayed(Int(Times(Times(Power($p("x"),$p("m")),Cos(Times($p("c",true),Power($p("x"),C2)))),FresnelC(Times($p("b",true),$p("x")))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(Power($s("x"),Plus($s("m"),Times(CN1,C1))),Sin(Times(Times(Times(Pi,C1D2),Power($s("b"),C2)),Power($s("x"),C2)))),Times(FresnelC(Times($s("b"),$s("x"))),Power(Times(Pi,Power($s("b"),C2)),CN1))),Times(CN1,Dist(Times(C1,Power(Times(Times(C2,$s("b")),Pi),CN1)),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,C1))),Sin(Times(Times(Pi,Power($s("b"),C2)),Power($s("x"),C2)))),$s("x"))))),Times(CN1,Dist(Times(Plus($s("m"),Times(CN1,C1)),Power(Times(Pi,Power($s("b"),C2)),CN1)),Int(Times(Times(Power($s("x"),Plus($s("m"),Times(CN1,C2))),Sin(Times(Times(Times(Pi,C1D2),Power($s("b"),C2)),Power($s("x"),C2)))),FresnelC(Times($s("b"),$s("x")))),$s("x"))))),And(And(And(And(FreeQ(List($s("b"),$s("c")),$s("x")),SameQ($s("c"),Times(Times(Pi,C1D2),Power($s("b"),C2)))),IntegerQ($s("m"))),Greater($s("m"),C1)),Not(Equal(Mod($s("m"),C4),C2))))),
SetDelayed(Int(Times(Times(Power($p("x"),$p("m")),Cos(Times($p("c",true),Power($p("x"),C2)))),FresnelC(Times($p("b",true),$p("x")))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Plus(Times(Times(Power($s("x"),Plus($s("m"),C1)),Cos(Times(Times(Times(Pi,C1D2),Power($s("b"),C2)),Power($s("x"),C2)))),Times(FresnelC(Times($s("b"),$s("x"))),Power(Plus($s("m"),C1),CN1))),Times(CN1,Times($s("b"),Times(Power($s("x"),Plus($s("m"),C2)),Power(Times(Times(C2,Plus($s("m"),C1)),Plus($s("m"),C2)),CN1))))),Times(CN1,Dist(Times($s("b"),Power(Times(C2,Plus($s("m"),C1)),CN1)),Int(Times(Power($s("x"),Plus($s("m"),C1)),Cos(Times(Times(Pi,Power($s("b"),C2)),Power($s("x"),C2)))),$s("x"))))),Dist(Times(Pi,Times(Power($s("b"),C2),Power(Plus($s("m"),C1),CN1))),Int(Times(Times(Power($s("x"),Plus($s("m"),C2)),Sin(Times(Times(Times(Pi,C1D2),Power($s("b"),C2)),Power($s("x"),C2)))),FresnelC(Times($s("b"),$s("x")))),$s("x")))),And(And(And(And(FreeQ(List($s("b"),$s("c")),$s("x")),SameQ($s("c"),Times(Times(Pi,C1D2),Power($s("b"),C2)))),IntegerQ($s("m"))),Less($s("m"),integer(-2L))),Equal(Mod($s("m"),C4),C0)))),
SetDelayed(Int(ExpIntegralE($p("n"),Plus($p("a",true),Times($p("b",true),$p("x")))),$p("x",$s("Symbol"))),
    Condition(Times(Times(CN1,ExpIntegralE(Plus($s("n"),C1),Plus($s("a"),Times($s("b"),$s("x"))))),Power($s("b"),CN1)),FreeQ(List($s("a"),$s("b"),$s("n")),$s("x")))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),ExpIntegralE($p("n"),Plus($p("a",true),Times($p("b",true),$p("x"))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Times(ExpIntegralE($s("n"),Plus($s("a"),Times($s("b"),$s("x")))),Power(Plus($s("m"),C1),CN1))),Dist(Times($s("b"),Power(Plus($s("m"),C1),CN1)),Int(Times(Power($s("x"),Plus($s("m"),C1)),ExpIntegralE(Plus($s("n"),Times(CN1,C1)),Plus($s("a"),Times($s("b"),$s("x"))))),$s("x")))),And(And(FreeQ(List($s("a"),$s("b"),$s("m")),$s("x")),IntegerQ($s("n"))),Greater($s("n"),C0)))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),ExpIntegralE($p("n"),Plus($p("a",true),Times($p("b",true),$p("x"))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Power($s("x"),$s("m"))),Times(ExpIntegralE(Plus($s("n"),C1),Plus($s("a"),Times($s("b"),$s("x")))),Power($s("b"),CN1))),Dist(Times($s("m"),Power($s("b"),CN1)),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,C1))),ExpIntegralE(Plus($s("n"),C1),Plus($s("a"),Times($s("b"),$s("x"))))),$s("x")))),And(And(FreeQ(List($s("a"),$s("b"),$s("m")),$s("x")),IntegerQ($s("n"))),Less($s("n"),C0)))),
SetDelayed(Int(ExpIntegralEi(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Plus($s("a"),Times($s("b"),$s("x"))),Times(ExpIntegralEi(Plus($s("a"),Times($s("b"),$s("x")))),Power($s("b"),CN1))),Times(CN1,Times(Power(E,Plus($s("a"),Times($s("b"),$s("x")))),Power($s("b"),CN1)))),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(Power(ExpIntegralEi(Plus($p("a",true),Times($p("b",true),$p("x")))),C2),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Plus($s("a"),Times($s("b"),$s("x"))),Times(Power(ExpIntegralEi(Plus($s("a"),Times($s("b"),$s("x")))),C2),Power($s("b"),CN1))),Times(CN1,Dist(C2,Int(Times(Power(E,Plus($s("a"),Times($s("b"),$s("x")))),ExpIntegralEi(Plus($s("a"),Times($s("b"),$s("x"))))),$s("x"))))),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),ExpIntegralEi(Plus($p("a",true),Times($p("b",true),$p("x"))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Times(ExpIntegralEi(Plus($s("a"),Times($s("b"),$s("x")))),Power(Plus($s("m"),C1),CN1))),Times(CN1,Dist(Times($s("b"),Power(Plus($s("m"),C1),CN1)),Int(Times(Power($s("x"),Plus($s("m"),C1)),Times(Power(E,Plus($s("a"),Times($s("b"),$s("x")))),Power(Plus($s("a"),Times($s("b"),$s("x"))),CN1))),$s("x"))))),And(FreeQ(List($s("a"),$s("b"),$s("m")),$s("x")),NonzeroQ(Plus($s("m"),C1))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(ExpIntegralEi(Times($p("b",true),$p("x"))),C2)),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Times(Power(ExpIntegralEi(Times($s("b"),$s("x"))),C2),Power(Plus($s("m"),C1),CN1))),Times(CN1,Dist(Times(C2,Power(Plus($s("m"),C1),CN1)),Int(Times(Times(Power($s("x"),$s("m")),Power(E,Times($s("b"),$s("x")))),ExpIntegralEi(Times($s("b"),$s("x")))),$s("x"))))),And(And(FreeQ($s("b"),$s("x")),IntegerQ($s("m"))),Greater($s("m"),C0)))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(ExpIntegralEi(Plus($p("a"),Times($p("b",true),$p("x")))),C2)),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Times(Power(ExpIntegralEi(Plus($s("a"),Times($s("b"),$s("x")))),C2),Power(Plus($s("m"),C1),CN1))),Times(Times($s("a"),Power($s("x"),$s("m"))),Times(Power(ExpIntegralEi(Plus($s("a"),Times($s("b"),$s("x")))),C2),Power(Times($s("b"),Plus($s("m"),C1)),CN1)))),Times(CN1,Dist(Times(C2,Power(Plus($s("m"),C1),CN1)),Int(Times(Times(Power($s("x"),$s("m")),Power(E,Plus($s("a"),Times($s("b"),$s("x"))))),ExpIntegralEi(Plus($s("a"),Times($s("b"),$s("x"))))),$s("x"))))),Times(CN1,Dist(Times($s("a"),Times($s("m"),Power(Times($s("b"),Plus($s("m"),C1)),CN1))),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,C1))),Power(ExpIntegralEi(Plus($s("a"),Times($s("b"),$s("x")))),C2)),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ($s("m"))),Greater($s("m"),C0)))),
SetDelayed(Int(Times(Power(E,Plus($p("a",true),Times($p("b",true),$p("x")))),ExpIntegralEi(Plus($p("c",true),Times($p("d",true),$p("x"))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power(E,Plus($s("a"),Times($s("b"),$s("x")))),Times(ExpIntegralEi(Plus($s("c"),Times($s("d"),$s("x")))),Power($s("b"),CN1))),Times(CN1,Dist(Times($s("d"),Power($s("b"),CN1)),Int(Times(Power(E,Plus($s("a"),Times($s("b"),$s("x")))),Times(Power(E,Plus($s("c"),Times($s("d"),$s("x")))),Power(Plus($s("c"),Times($s("d"),$s("x"))),CN1))),$s("x"))))),FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")))),
SetDelayed(Int(Times(Times(Power($p("x"),$p("m",true)),Power(E,Plus($p("a",true),Times($p("b",true),$p("x"))))),ExpIntegralEi(Plus($p("c",true),Times($p("d",true),$p("x"))))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(Power($s("x"),$s("m")),Power(E,Plus($s("a"),Times($s("b"),$s("x"))))),Times(ExpIntegralEi(Plus($s("c"),Times($s("d"),$s("x")))),Power($s("b"),CN1))),Times(CN1,Dist(Times($s("d"),Power($s("b"),CN1)),Int(Times(Times(Power($s("x"),$s("m")),Power(E,Plus($s("a"),Times($s("b"),$s("x"))))),Times(Power(E,Plus($s("c"),Times($s("d"),$s("x")))),Power(Plus($s("c"),Times($s("d"),$s("x"))),CN1))),$s("x"))))),Times(CN1,Dist(Times($s("m"),Power($s("b"),CN1)),Int(Times(Times(Power($s("x"),Plus($s("m"),Times(CN1,C1))),Power(E,Plus($s("a"),Times($s("b"),$s("x"))))),ExpIntegralEi(Plus($s("c"),Times($s("d"),$s("x"))))),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),IntegerQ($s("m"))),Greater($s("m"),C0)))),
SetDelayed(Int(Times(Times(Power($p("x"),$p("m")),Power(E,Plus($p("a",true),Times($p("b",true),$p("x"))))),ExpIntegralEi(Plus($p("c",true),Times($p("d",true),$p("x"))))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(Power($s("x"),Plus($s("m"),C1)),Power(E,Plus($s("a"),Times($s("b"),$s("x"))))),Times(ExpIntegralEi(Plus($s("c"),Times($s("d"),$s("x")))),Power(Plus($s("m"),C1),CN1))),Times(CN1,Dist(Times($s("d"),Power(Plus($s("m"),C1),CN1)),Int(Times(Times(Power($s("x"),Plus($s("m"),C1)),Power(E,Plus($s("a"),Times($s("b"),$s("x"))))),Times(Power(E,Plus($s("c"),Times($s("d"),$s("x")))),Power(Plus($s("c"),Times($s("d"),$s("x"))),CN1))),$s("x"))))),Times(CN1,Dist(Times($s("b"),Power(Plus($s("m"),C1),CN1)),Int(Times(Times(Power($s("x"),Plus($s("m"),C1)),Power(E,Plus($s("a"),Times($s("b"),$s("x"))))),ExpIntegralEi(Plus($s("c"),Times($s("d"),$s("x"))))),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),IntegerQ($s("m"))),Less($s("m"),CN1)))),
SetDelayed(Int(SinIntegral(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Plus($s("a"),Times($s("b"),$s("x"))),Times(SinIntegral(Plus($s("a"),Times($s("b"),$s("x")))),Power($s("b"),CN1))),Times(Cos(Plus($s("a"),Times($s("b"),$s("x")))),Power($s("b"),CN1))),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(Power(SinIntegral(Plus($p("a",true),Times($p("b",true),$p("x")))),C2),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Plus($s("a"),Times($s("b"),$s("x"))),Times(Power(SinIntegral(Plus($s("a"),Times($s("b"),$s("x")))),C2),Power($s("b"),CN1))),Times(CN1,Dist(C2,Int(Times(Sin(Plus($s("a"),Times($s("b"),$s("x")))),SinIntegral(Plus($s("a"),Times($s("b"),$s("x"))))),$s("x"))))),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),SinIntegral(Plus($p("a",true),Times($p("b",true),$p("x"))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Times(SinIntegral(Plus($s("a"),Times($s("b"),$s("x")))),Power(Plus($s("m"),C1),CN1))),Times(CN1,Dist(Times($s("b"),Power(Plus($s("m"),C1),CN1)),Int(Times(Power($s("x"),Plus($s("m"),C1)),Times(Sin(Plus($s("a"),Times($s("b"),$s("x")))),Power(Plus($s("a"),Times($s("b"),$s("x"))),CN1))),$s("x"))))),And(FreeQ(List($s("a"),$s("b"),$s("m")),$s("x")),NonzeroQ(Plus($s("m"),C1))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(SinIntegral(Times($p("b",true),$p("x"))),C2)),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Times(Power(SinIntegral(Times($s("b"),$s("x"))),C2),Power(Plus($s("m"),C1),CN1))),Times(CN1,Dist(Times(C2,Power(Plus($s("m"),C1),CN1)),Int(Times(Times(Power($s("x"),$s("m")),Sin(Times($s("b"),$s("x")))),SinIntegral(Times($s("b"),$s("x")))),$s("x"))))),And(And(FreeQ($s("b"),$s("x")),IntegerQ($s("m"))),Greater($s("m"),C0)))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(SinIntegral(Plus($p("a"),Times($p("b",true),$p("x")))),C2)),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Times(Power(SinIntegral(Plus($s("a"),Times($s("b"),$s("x")))),C2),Power(Plus($s("m"),C1),CN1))),Times(Times($s("a"),Power($s("x"),$s("m"))),Times(Power(SinIntegral(Plus($s("a"),Times($s("b"),$s("x")))),C2),Power(Times($s("b"),Plus($s("m"),C1)),CN1)))),Times(CN1,Dist(Times(C2,Power(Plus($s("m"),C1),CN1)),Int(Times(Times(Power($s("x"),$s("m")),Sin(Plus($s("a"),Times($s("b"),$s("x"))))),SinIntegral(Plus($s("a"),Times($s("b"),$s("x"))))),$s("x"))))),Times(CN1,Dist(Times($s("a"),Times($s("m"),Power(Times($s("b"),Plus($s("m"),C1)),CN1))),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,C1))),Power(SinIntegral(Plus($s("a"),Times($s("b"),$s("x")))),C2)),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ($s("m"))),Greater($s("m"),C0)))),
SetDelayed(Int(Times(Sin(Plus($p("a",true),Times($p("b",true),$p("x")))),SinIntegral(Plus($p("c",true),Times($p("d",true),$p("x"))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Cos(Plus($s("a"),Times($s("b"),$s("x"))))),Times(SinIntegral(Plus($s("c"),Times($s("d"),$s("x")))),Power($s("b"),CN1))),Dist(Times($s("d"),Power($s("b"),CN1)),Int(Times(Cos(Plus($s("a"),Times($s("b"),$s("x")))),Times(Sin(Plus($s("c"),Times($s("d"),$s("x")))),Power(Plus($s("c"),Times($s("d"),$s("x"))),CN1))),$s("x")))),FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")))),
SetDelayed(Int(Times(Times(Power($p("x"),$p("m",true)),Sin(Plus($p("a",true),Times($p("b",true),$p("x"))))),SinIntegral(Plus($p("c",true),Times($p("d",true),$p("x"))))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(Times(CN1,Power($s("x"),$s("m"))),Cos(Plus($s("a"),Times($s("b"),$s("x"))))),Times(SinIntegral(Plus($s("c"),Times($s("d"),$s("x")))),Power($s("b"),CN1))),Dist(Times($s("d"),Power($s("b"),CN1)),Int(Times(Times(Power($s("x"),$s("m")),Cos(Plus($s("a"),Times($s("b"),$s("x"))))),Times(Sin(Plus($s("c"),Times($s("d"),$s("x")))),Power(Plus($s("c"),Times($s("d"),$s("x"))),CN1))),$s("x")))),Dist(Times($s("m"),Power($s("b"),CN1)),Int(Times(Times(Power($s("x"),Plus($s("m"),Times(CN1,C1))),Cos(Plus($s("a"),Times($s("b"),$s("x"))))),SinIntegral(Plus($s("c"),Times($s("d"),$s("x"))))),$s("x")))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),IntegerQ($s("m"))),Greater($s("m"),C0)))),
SetDelayed(Int(Times(Times(Power($p("x"),$p("m")),Sin(Plus($p("a",true),Times($p("b",true),$p("x"))))),SinIntegral(Plus($p("c",true),Times($p("d",true),$p("x"))))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(Power($s("x"),Plus($s("m"),C1)),Sin(Plus($s("a"),Times($s("b"),$s("x"))))),Times(SinIntegral(Plus($s("c"),Times($s("d"),$s("x")))),Power(Plus($s("m"),C1),CN1))),Times(CN1,Dist(Times($s("d"),Power(Plus($s("m"),C1),CN1)),Int(Times(Times(Power($s("x"),Plus($s("m"),C1)),Sin(Plus($s("a"),Times($s("b"),$s("x"))))),Times(Sin(Plus($s("c"),Times($s("d"),$s("x")))),Power(Plus($s("c"),Times($s("d"),$s("x"))),CN1))),$s("x"))))),Times(CN1,Dist(Times($s("b"),Power(Plus($s("m"),C1),CN1)),Int(Times(Times(Power($s("x"),Plus($s("m"),C1)),Cos(Plus($s("a"),Times($s("b"),$s("x"))))),SinIntegral(Plus($s("c"),Times($s("d"),$s("x"))))),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),IntegerQ($s("m"))),Less($s("m"),CN1)))),
SetDelayed(Int(Times(Cos(Plus($p("a",true),Times($p("b",true),$p("x")))),SinIntegral(Plus($p("c",true),Times($p("d",true),$p("x"))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Sin(Plus($s("a"),Times($s("b"),$s("x")))),Times(SinIntegral(Plus($s("c"),Times($s("d"),$s("x")))),Power($s("b"),CN1))),Times(CN1,Dist(Times($s("d"),Power($s("b"),CN1)),Int(Times(Sin(Plus($s("a"),Times($s("b"),$s("x")))),Times(Sin(Plus($s("c"),Times($s("d"),$s("x")))),Power(Plus($s("c"),Times($s("d"),$s("x"))),CN1))),$s("x"))))),FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")))),
SetDelayed(Int(Times(Times(Power($p("x"),$p("m",true)),Cos(Plus($p("a",true),Times($p("b",true),$p("x"))))),SinIntegral(Plus($p("c",true),Times($p("d",true),$p("x"))))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(Power($s("x"),$s("m")),Sin(Plus($s("a"),Times($s("b"),$s("x"))))),Times(SinIntegral(Plus($s("c"),Times($s("d"),$s("x")))),Power($s("b"),CN1))),Times(CN1,Dist(Times($s("d"),Power($s("b"),CN1)),Int(Times(Times(Power($s("x"),$s("m")),Sin(Plus($s("a"),Times($s("b"),$s("x"))))),Times(Sin(Plus($s("c"),Times($s("d"),$s("x")))),Power(Plus($s("c"),Times($s("d"),$s("x"))),CN1))),$s("x"))))),Times(CN1,Dist(Times($s("m"),Power($s("b"),CN1)),Int(Times(Times(Power($s("x"),Plus($s("m"),Times(CN1,C1))),Sin(Plus($s("a"),Times($s("b"),$s("x"))))),SinIntegral(Plus($s("c"),Times($s("d"),$s("x"))))),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),IntegerQ($s("m"))),Greater($s("m"),C0)))),
SetDelayed(Int(Times(Times(Power($p("x"),$p("m",true)),Cos(Plus($p("a",true),Times($p("b",true),$p("x"))))),SinIntegral(Plus($p("c",true),Times($p("d",true),$p("x"))))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(Power($s("x"),Plus($s("m"),C1)),Cos(Plus($s("a"),Times($s("b"),$s("x"))))),Times(SinIntegral(Plus($s("c"),Times($s("d"),$s("x")))),Power(Plus($s("m"),C1),CN1))),Times(CN1,Dist(Times($s("d"),Power(Plus($s("m"),C1),CN1)),Int(Times(Times(Power($s("x"),Plus($s("m"),C1)),Cos(Plus($s("a"),Times($s("b"),$s("x"))))),Times(Sin(Plus($s("c"),Times($s("d"),$s("x")))),Power(Plus($s("c"),Times($s("d"),$s("x"))),CN1))),$s("x"))))),Dist(Times($s("b"),Power(Plus($s("m"),C1),CN1)),Int(Times(Times(Power($s("x"),Plus($s("m"),C1)),Sin(Plus($s("a"),Times($s("b"),$s("x"))))),SinIntegral(Plus($s("c"),Times($s("d"),$s("x"))))),$s("x")))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),IntegerQ($s("m"))),Less($s("m"),CN1))))
  );
}
