package org.matheclipse.core.integrate.rubi;


import static org.matheclipse.core.expression.F.*;
import static org.matheclipse.core.integrate.rubi.UtilityFunctionCtors.*;
import static org.matheclipse.core.integrate.rubi.UtilityFunctions.*;
import org.matheclipse.core.interfaces.IAST;
import org.matheclipse.core.interfaces.IExpr;

/** 
 * IndefiniteIntegrationRules from the <a href="http://www.apmaths.uwo.ca/~arich/">Rubi -
 * rule-based integrator</a>.
 *  
 */
public class IndefiniteIntegrationRules14 { 
  public static IAST RULES = List( 
SetDelayed(Int(CosIntegral(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Plus($s("a"),Times($s("b"),$s("x"))),Times(CosIntegral(Plus($s("a"),Times($s("b"),$s("x")))),Power($s("b"),CN1))),Times(CN1,Times(Sin(Plus($s("a"),Times($s("b"),$s("x")))),Power($s("b"),CN1)))),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(Power(CosIntegral(Plus($p("a",true),Times($p("b",true),$p("x")))),C2),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Plus($s("a"),Times($s("b"),$s("x"))),Times(Power(CosIntegral(Plus($s("a"),Times($s("b"),$s("x")))),C2),Power($s("b"),CN1))),Times(CN1,Dist(C2,Int(Times(Cos(Plus($s("a"),Times($s("b"),$s("x")))),CosIntegral(Plus($s("a"),Times($s("b"),$s("x"))))),$s("x"))))),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),CosIntegral(Plus($p("a",true),Times($p("b",true),$p("x"))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Times(CosIntegral(Plus($s("a"),Times($s("b"),$s("x")))),Power(Plus($s("m"),C1),CN1))),Times(CN1,Dist(Times($s("b"),Power(Plus($s("m"),C1),CN1)),Int(Times(Power($s("x"),Plus($s("m"),C1)),Times(Cos(Plus($s("a"),Times($s("b"),$s("x")))),Power(Plus($s("a"),Times($s("b"),$s("x"))),CN1))),$s("x"))))),And(FreeQ(List($s("a"),$s("b"),$s("m")),$s("x")),NonzeroQ(Plus($s("m"),C1))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(CosIntegral(Times($p("b",true),$p("x"))),C2)),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Times(Power(CosIntegral(Times($s("b"),$s("x"))),C2),Power(Plus($s("m"),C1),CN1))),Times(CN1,Dist(Times(C2,Power(Plus($s("m"),C1),CN1)),Int(Times(Times(Power($s("x"),$s("m")),Cos(Times($s("b"),$s("x")))),CosIntegral(Times($s("b"),$s("x")))),$s("x"))))),And(And(FreeQ($s("b"),$s("x")),IntegerQ($s("m"))),Greater($s("m"),C0)))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(CosIntegral(Plus($p("a"),Times($p("b",true),$p("x")))),C2)),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Times(Power(CosIntegral(Plus($s("a"),Times($s("b"),$s("x")))),C2),Power(Plus($s("m"),C1),CN1))),Times(Times($s("a"),Power($s("x"),$s("m"))),Times(Power(CosIntegral(Plus($s("a"),Times($s("b"),$s("x")))),C2),Power(Times($s("b"),Plus($s("m"),C1)),CN1)))),Times(CN1,Dist(Times(C2,Power(Plus($s("m"),C1),CN1)),Int(Times(Times(Power($s("x"),$s("m")),Cos(Plus($s("a"),Times($s("b"),$s("x"))))),CosIntegral(Plus($s("a"),Times($s("b"),$s("x"))))),$s("x"))))),Times(CN1,Dist(Times($s("a"),Times($s("m"),Power(Times($s("b"),Plus($s("m"),C1)),CN1))),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,C1))),Power(CosIntegral(Plus($s("a"),Times($s("b"),$s("x")))),C2)),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ($s("m"))),Greater($s("m"),C0)))),
SetDelayed(Int(Times(Sin(Plus($p("a",true),Times($p("b",true),$p("x")))),CosIntegral(Plus($p("c",true),Times($p("d",true),$p("x"))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Cos(Plus($s("a"),Times($s("b"),$s("x"))))),Times(CosIntegral(Plus($s("c"),Times($s("d"),$s("x")))),Power($s("b"),CN1))),Dist(Times($s("d"),Power($s("b"),CN1)),Int(Times(Cos(Plus($s("a"),Times($s("b"),$s("x")))),Times(Cos(Plus($s("c"),Times($s("d"),$s("x")))),Power(Plus($s("c"),Times($s("d"),$s("x"))),CN1))),$s("x")))),FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")))),
SetDelayed(Int(Times(Times(Power($p("x"),$p("m",true)),Sin(Plus($p("a",true),Times($p("b",true),$p("x"))))),CosIntegral(Plus($p("c",true),Times($p("d",true),$p("x"))))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(Times(CN1,Power($s("x"),$s("m"))),Cos(Plus($s("a"),Times($s("b"),$s("x"))))),Times(CosIntegral(Plus($s("c"),Times($s("d"),$s("x")))),Power($s("b"),CN1))),Dist(Times($s("d"),Power($s("b"),CN1)),Int(Times(Times(Power($s("x"),$s("m")),Cos(Plus($s("a"),Times($s("b"),$s("x"))))),Times(Cos(Plus($s("c"),Times($s("d"),$s("x")))),Power(Plus($s("c"),Times($s("d"),$s("x"))),CN1))),$s("x")))),Dist(Times($s("m"),Power($s("b"),CN1)),Int(Times(Times(Power($s("x"),Plus($s("m"),Times(CN1,C1))),Cos(Plus($s("a"),Times($s("b"),$s("x"))))),CosIntegral(Plus($s("c"),Times($s("d"),$s("x"))))),$s("x")))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),IntegerQ($s("m"))),Greater($s("m"),C0)))),
SetDelayed(Int(Times(Times(Power($p("x"),$p("m")),Sin(Plus($p("a",true),Times($p("b",true),$p("x"))))),CosIntegral(Plus($p("c",true),Times($p("d",true),$p("x"))))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(Power($s("x"),Plus($s("m"),C1)),Sin(Plus($s("a"),Times($s("b"),$s("x"))))),Times(CosIntegral(Plus($s("c"),Times($s("d"),$s("x")))),Power(Plus($s("m"),C1),CN1))),Times(CN1,Dist(Times($s("d"),Power(Plus($s("m"),C1),CN1)),Int(Times(Times(Power($s("x"),Plus($s("m"),C1)),Sin(Plus($s("a"),Times($s("b"),$s("x"))))),Times(Cos(Plus($s("c"),Times($s("d"),$s("x")))),Power(Plus($s("c"),Times($s("d"),$s("x"))),CN1))),$s("x"))))),Times(CN1,Dist(Times($s("b"),Power(Plus($s("m"),C1),CN1)),Int(Times(Times(Power($s("x"),Plus($s("m"),C1)),Cos(Plus($s("a"),Times($s("b"),$s("x"))))),CosIntegral(Plus($s("c"),Times($s("d"),$s("x"))))),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),IntegerQ($s("m"))),Less($s("m"),CN1)))),
SetDelayed(Int(Times(Cos(Plus($p("a",true),Times($p("b",true),$p("x")))),CosIntegral(Plus($p("c",true),Times($p("d",true),$p("x"))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Sin(Plus($s("a"),Times($s("b"),$s("x")))),Times(CosIntegral(Plus($s("c"),Times($s("d"),$s("x")))),Power($s("b"),CN1))),Times(CN1,Dist(Times($s("d"),Power($s("b"),CN1)),Int(Times(Sin(Plus($s("a"),Times($s("b"),$s("x")))),Times(Cos(Plus($s("c"),Times($s("d"),$s("x")))),Power(Plus($s("c"),Times($s("d"),$s("x"))),CN1))),$s("x"))))),FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")))),
SetDelayed(Int(Times(Times(Power($p("x"),$p("m",true)),Cos(Plus($p("a",true),Times($p("b",true),$p("x"))))),CosIntegral(Plus($p("c",true),Times($p("d",true),$p("x"))))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(Power($s("x"),$s("m")),Sin(Plus($s("a"),Times($s("b"),$s("x"))))),Times(CosIntegral(Plus($s("c"),Times($s("d"),$s("x")))),Power($s("b"),CN1))),Times(CN1,Dist(Times($s("d"),Power($s("b"),CN1)),Int(Times(Times(Power($s("x"),$s("m")),Sin(Plus($s("a"),Times($s("b"),$s("x"))))),Times(Cos(Plus($s("c"),Times($s("d"),$s("x")))),Power(Plus($s("c"),Times($s("d"),$s("x"))),CN1))),$s("x"))))),Times(CN1,Dist(Times($s("m"),Power($s("b"),CN1)),Int(Times(Times(Power($s("x"),Plus($s("m"),Times(CN1,C1))),Sin(Plus($s("a"),Times($s("b"),$s("x"))))),CosIntegral(Plus($s("c"),Times($s("d"),$s("x"))))),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),IntegerQ($s("m"))),Greater($s("m"),C0)))),
SetDelayed(Int(Times(Times(Power($p("x"),$p("m",true)),Cos(Plus($p("a",true),Times($p("b",true),$p("x"))))),CosIntegral(Plus($p("c",true),Times($p("d",true),$p("x"))))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(Power($s("x"),Plus($s("m"),C1)),Cos(Plus($s("a"),Times($s("b"),$s("x"))))),Times(CosIntegral(Plus($s("c"),Times($s("d"),$s("x")))),Power(Plus($s("m"),C1),CN1))),Times(CN1,Dist(Times($s("d"),Power(Plus($s("m"),C1),CN1)),Int(Times(Times(Power($s("x"),Plus($s("m"),C1)),Cos(Plus($s("a"),Times($s("b"),$s("x"))))),Times(Cos(Plus($s("c"),Times($s("d"),$s("x")))),Power(Plus($s("c"),Times($s("d"),$s("x"))),CN1))),$s("x"))))),Dist(Times($s("b"),Power(Plus($s("m"),C1),CN1)),Int(Times(Times(Power($s("x"),Plus($s("m"),C1)),Sin(Plus($s("a"),Times($s("b"),$s("x"))))),CosIntegral(Plus($s("c"),Times($s("d"),$s("x"))))),$s("x")))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),IntegerQ($s("m"))),Less($s("m"),CN1)))),
SetDelayed(Int(SinhIntegral(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Plus($s("a"),Times($s("b"),$s("x"))),Times(SinhIntegral(Plus($s("a"),Times($s("b"),$s("x")))),Power($s("b"),CN1))),Times(CN1,Times(Cosh(Plus($s("a"),Times($s("b"),$s("x")))),Power($s("b"),CN1)))),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(Power(SinhIntegral(Plus($p("a",true),Times($p("b",true),$p("x")))),C2),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Plus($s("a"),Times($s("b"),$s("x"))),Times(Power(SinhIntegral(Plus($s("a"),Times($s("b"),$s("x")))),C2),Power($s("b"),CN1))),Times(CN1,Dist(C2,Int(Times(Sinh(Plus($s("a"),Times($s("b"),$s("x")))),SinhIntegral(Plus($s("a"),Times($s("b"),$s("x"))))),$s("x"))))),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),SinhIntegral(Plus($p("a",true),Times($p("b",true),$p("x"))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Times(SinhIntegral(Plus($s("a"),Times($s("b"),$s("x")))),Power(Plus($s("m"),C1),CN1))),Times(CN1,Dist(Times($s("b"),Power(Plus($s("m"),C1),CN1)),Int(Times(Power($s("x"),Plus($s("m"),C1)),Times(Sinh(Plus($s("a"),Times($s("b"),$s("x")))),Power(Plus($s("a"),Times($s("b"),$s("x"))),CN1))),$s("x"))))),And(FreeQ(List($s("a"),$s("b"),$s("m")),$s("x")),NonzeroQ(Plus($s("m"),C1))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(SinhIntegral(Times($p("b",true),$p("x"))),C2)),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Times(Power(SinhIntegral(Times($s("b"),$s("x"))),C2),Power(Plus($s("m"),C1),CN1))),Times(CN1,Dist(Times(C2,Power(Plus($s("m"),C1),CN1)),Int(Times(Times(Power($s("x"),$s("m")),Sinh(Times($s("b"),$s("x")))),SinhIntegral(Times($s("b"),$s("x")))),$s("x"))))),And(And(FreeQ($s("b"),$s("x")),IntegerQ($s("m"))),Greater($s("m"),C0)))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(SinhIntegral(Plus($p("a"),Times($p("b",true),$p("x")))),C2)),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Times(Power(SinhIntegral(Plus($s("a"),Times($s("b"),$s("x")))),C2),Power(Plus($s("m"),C1),CN1))),Times(Times($s("a"),Power($s("x"),$s("m"))),Times(Power(SinhIntegral(Plus($s("a"),Times($s("b"),$s("x")))),C2),Power(Times($s("b"),Plus($s("m"),C1)),CN1)))),Times(CN1,Dist(Times(C2,Power(Plus($s("m"),C1),CN1)),Int(Times(Times(Power($s("x"),$s("m")),Sinh(Plus($s("a"),Times($s("b"),$s("x"))))),SinhIntegral(Plus($s("a"),Times($s("b"),$s("x"))))),$s("x"))))),Times(CN1,Dist(Times($s("a"),Times($s("m"),Power(Times($s("b"),Plus($s("m"),C1)),CN1))),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,C1))),Power(SinhIntegral(Plus($s("a"),Times($s("b"),$s("x")))),C2)),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ($s("m"))),Greater($s("m"),C0)))),
SetDelayed(Int(Times(Sinh(Plus($p("a",true),Times($p("b",true),$p("x")))),SinhIntegral(Plus($p("c",true),Times($p("d",true),$p("x"))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Cosh(Plus($s("a"),Times($s("b"),$s("x")))),Times(SinhIntegral(Plus($s("c"),Times($s("d"),$s("x")))),Power($s("b"),CN1))),Times(CN1,Dist(Times($s("d"),Power($s("b"),CN1)),Int(Times(Cosh(Plus($s("a"),Times($s("b"),$s("x")))),Times(Sinh(Plus($s("c"),Times($s("d"),$s("x")))),Power(Plus($s("c"),Times($s("d"),$s("x"))),CN1))),$s("x"))))),FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")))),
SetDelayed(Int(Times(Times(Power($p("x"),$p("m",true)),Sinh(Plus($p("a",true),Times($p("b",true),$p("x"))))),SinhIntegral(Plus($p("c",true),Times($p("d",true),$p("x"))))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(Power($s("x"),$s("m")),Cosh(Plus($s("a"),Times($s("b"),$s("x"))))),Times(SinhIntegral(Plus($s("c"),Times($s("d"),$s("x")))),Power($s("b"),CN1))),Times(CN1,Dist(Times($s("d"),Power($s("b"),CN1)),Int(Times(Times(Power($s("x"),$s("m")),Cosh(Plus($s("a"),Times($s("b"),$s("x"))))),Times(Sinh(Plus($s("c"),Times($s("d"),$s("x")))),Power(Plus($s("c"),Times($s("d"),$s("x"))),CN1))),$s("x"))))),Times(CN1,Dist(Times($s("m"),Power($s("b"),CN1)),Int(Times(Times(Power($s("x"),Plus($s("m"),Times(CN1,C1))),Cosh(Plus($s("a"),Times($s("b"),$s("x"))))),SinhIntegral(Plus($s("c"),Times($s("d"),$s("x"))))),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),IntegerQ($s("m"))),Greater($s("m"),C0)))),
SetDelayed(Int(Times(Times(Power($p("x"),$p("m")),Sinh(Plus($p("a",true),Times($p("b",true),$p("x"))))),SinhIntegral(Plus($p("c",true),Times($p("d",true),$p("x"))))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(Power($s("x"),Plus($s("m"),C1)),Sinh(Plus($s("a"),Times($s("b"),$s("x"))))),Times(SinhIntegral(Plus($s("c"),Times($s("d"),$s("x")))),Power(Plus($s("m"),C1),CN1))),Times(CN1,Dist(Times($s("d"),Power(Plus($s("m"),C1),CN1)),Int(Times(Times(Power($s("x"),Plus($s("m"),C1)),Sinh(Plus($s("a"),Times($s("b"),$s("x"))))),Times(Sinh(Plus($s("c"),Times($s("d"),$s("x")))),Power(Plus($s("c"),Times($s("d"),$s("x"))),CN1))),$s("x"))))),Times(CN1,Dist(Times($s("b"),Power(Plus($s("m"),C1),CN1)),Int(Times(Times(Power($s("x"),Plus($s("m"),C1)),Cosh(Plus($s("a"),Times($s("b"),$s("x"))))),SinhIntegral(Plus($s("c"),Times($s("d"),$s("x"))))),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),IntegerQ($s("m"))),Less($s("m"),CN1)))),
SetDelayed(Int(Times(Cosh(Plus($p("a",true),Times($p("b",true),$p("x")))),SinhIntegral(Plus($p("c",true),Times($p("d",true),$p("x"))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Sinh(Plus($s("a"),Times($s("b"),$s("x")))),Times(SinhIntegral(Plus($s("c"),Times($s("d"),$s("x")))),Power($s("b"),CN1))),Times(CN1,Dist(Times($s("d"),Power($s("b"),CN1)),Int(Times(Sinh(Plus($s("a"),Times($s("b"),$s("x")))),Times(Sinh(Plus($s("c"),Times($s("d"),$s("x")))),Power(Plus($s("c"),Times($s("d"),$s("x"))),CN1))),$s("x"))))),FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")))),
SetDelayed(Int(Times(Times(Power($p("x"),$p("m",true)),Cosh(Plus($p("a",true),Times($p("b",true),$p("x"))))),SinhIntegral(Plus($p("c",true),Times($p("d",true),$p("x"))))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(Power($s("x"),$s("m")),Sinh(Plus($s("a"),Times($s("b"),$s("x"))))),Times(SinhIntegral(Plus($s("c"),Times($s("d"),$s("x")))),Power($s("b"),CN1))),Times(CN1,Dist(Times($s("d"),Power($s("b"),CN1)),Int(Times(Times(Power($s("x"),$s("m")),Sinh(Plus($s("a"),Times($s("b"),$s("x"))))),Times(Sinh(Plus($s("c"),Times($s("d"),$s("x")))),Power(Plus($s("c"),Times($s("d"),$s("x"))),CN1))),$s("x"))))),Times(CN1,Dist(Times($s("m"),Power($s("b"),CN1)),Int(Times(Times(Power($s("x"),Plus($s("m"),Times(CN1,C1))),Sinh(Plus($s("a"),Times($s("b"),$s("x"))))),SinhIntegral(Plus($s("c"),Times($s("d"),$s("x"))))),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),IntegerQ($s("m"))),Greater($s("m"),C0)))),
SetDelayed(Int(Times(Times(Power($p("x"),$p("m",true)),Cosh(Plus($p("a",true),Times($p("b",true),$p("x"))))),SinhIntegral(Plus($p("c",true),Times($p("d",true),$p("x"))))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(Power($s("x"),Plus($s("m"),C1)),Cosh(Plus($s("a"),Times($s("b"),$s("x"))))),Times(SinhIntegral(Plus($s("c"),Times($s("d"),$s("x")))),Power(Plus($s("m"),C1),CN1))),Times(CN1,Dist(Times($s("d"),Power(Plus($s("m"),C1),CN1)),Int(Times(Times(Power($s("x"),Plus($s("m"),C1)),Cosh(Plus($s("a"),Times($s("b"),$s("x"))))),Times(Sinh(Plus($s("c"),Times($s("d"),$s("x")))),Power(Plus($s("c"),Times($s("d"),$s("x"))),CN1))),$s("x"))))),Times(CN1,Dist(Times($s("b"),Power(Plus($s("m"),C1),CN1)),Int(Times(Times(Power($s("x"),Plus($s("m"),C1)),Sinh(Plus($s("a"),Times($s("b"),$s("x"))))),SinhIntegral(Plus($s("c"),Times($s("d"),$s("x"))))),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),IntegerQ($s("m"))),Less($s("m"),CN1)))),
SetDelayed(Int(CoshIntegral(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Plus($s("a"),Times($s("b"),$s("x"))),Times(CoshIntegral(Plus($s("a"),Times($s("b"),$s("x")))),Power($s("b"),CN1))),Times(CN1,Times(Sinh(Plus($s("a"),Times($s("b"),$s("x")))),Power($s("b"),CN1)))),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(Power(CoshIntegral(Plus($p("a",true),Times($p("b",true),$p("x")))),C2),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Plus($s("a"),Times($s("b"),$s("x"))),Times(Power(CoshIntegral(Plus($s("a"),Times($s("b"),$s("x")))),C2),Power($s("b"),CN1))),Times(CN1,Dist(C2,Int(Times(Cosh(Plus($s("a"),Times($s("b"),$s("x")))),CoshIntegral(Plus($s("a"),Times($s("b"),$s("x"))))),$s("x"))))),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),CoshIntegral(Plus($p("a",true),Times($p("b",true),$p("x"))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Times(CoshIntegral(Plus($s("a"),Times($s("b"),$s("x")))),Power(Plus($s("m"),C1),CN1))),Times(CN1,Dist(Times($s("b"),Power(Plus($s("m"),C1),CN1)),Int(Times(Power($s("x"),Plus($s("m"),C1)),Times(Cosh(Plus($s("a"),Times($s("b"),$s("x")))),Power(Plus($s("a"),Times($s("b"),$s("x"))),CN1))),$s("x"))))),And(FreeQ(List($s("a"),$s("b"),$s("m")),$s("x")),NonzeroQ(Plus($s("m"),C1))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(CoshIntegral(Times($p("b",true),$p("x"))),C2)),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Times(Power(CoshIntegral(Times($s("b"),$s("x"))),C2),Power(Plus($s("m"),C1),CN1))),Times(CN1,Dist(Times(C2,Power(Plus($s("m"),C1),CN1)),Int(Times(Times(Power($s("x"),$s("m")),Cosh(Times($s("b"),$s("x")))),CoshIntegral(Times($s("b"),$s("x")))),$s("x"))))),And(And(FreeQ($s("b"),$s("x")),IntegerQ($s("m"))),Greater($s("m"),C0)))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(CoshIntegral(Plus($p("a"),Times($p("b",true),$p("x")))),C2)),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Times(Power(CoshIntegral(Plus($s("a"),Times($s("b"),$s("x")))),C2),Power(Plus($s("m"),C1),CN1))),Times(Times($s("a"),Power($s("x"),$s("m"))),Times(Power(CoshIntegral(Plus($s("a"),Times($s("b"),$s("x")))),C2),Power(Times($s("b"),Plus($s("m"),C1)),CN1)))),Times(CN1,Dist(Times(C2,Power(Plus($s("m"),C1),CN1)),Int(Times(Times(Power($s("x"),$s("m")),Cosh(Plus($s("a"),Times($s("b"),$s("x"))))),CoshIntegral(Plus($s("a"),Times($s("b"),$s("x"))))),$s("x"))))),Times(CN1,Dist(Times($s("a"),Times($s("m"),Power(Times($s("b"),Plus($s("m"),C1)),CN1))),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,C1))),Power(CoshIntegral(Plus($s("a"),Times($s("b"),$s("x")))),C2)),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ($s("m"))),Greater($s("m"),C0)))),
SetDelayed(Int(Times(Sinh(Plus($p("a",true),Times($p("b",true),$p("x")))),CoshIntegral(Plus($p("c",true),Times($p("d",true),$p("x"))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Cosh(Plus($s("a"),Times($s("b"),$s("x")))),Times(CoshIntegral(Plus($s("c"),Times($s("d"),$s("x")))),Power($s("b"),CN1))),Times(CN1,Dist(Times($s("d"),Power($s("b"),CN1)),Int(Times(Cosh(Plus($s("a"),Times($s("b"),$s("x")))),Times(Cosh(Plus($s("c"),Times($s("d"),$s("x")))),Power(Plus($s("c"),Times($s("d"),$s("x"))),CN1))),$s("x"))))),FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")))),
SetDelayed(Int(Times(Times(Power($p("x"),$p("m",true)),Sinh(Plus($p("a",true),Times($p("b",true),$p("x"))))),CoshIntegral(Plus($p("c",true),Times($p("d",true),$p("x"))))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(Power($s("x"),$s("m")),Cosh(Plus($s("a"),Times($s("b"),$s("x"))))),Times(CoshIntegral(Plus($s("c"),Times($s("d"),$s("x")))),Power($s("b"),CN1))),Times(CN1,Dist(Times($s("d"),Power($s("b"),CN1)),Int(Times(Times(Power($s("x"),$s("m")),Cosh(Plus($s("a"),Times($s("b"),$s("x"))))),Times(Cosh(Plus($s("c"),Times($s("d"),$s("x")))),Power(Plus($s("c"),Times($s("d"),$s("x"))),CN1))),$s("x"))))),Times(CN1,Dist(Times($s("m"),Power($s("b"),CN1)),Int(Times(Times(Power($s("x"),Plus($s("m"),Times(CN1,C1))),Cosh(Plus($s("a"),Times($s("b"),$s("x"))))),CoshIntegral(Plus($s("c"),Times($s("d"),$s("x"))))),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),IntegerQ($s("m"))),Greater($s("m"),C0)))),
SetDelayed(Int(Times(Times(Power($p("x"),$p("m")),Sinh(Plus($p("a",true),Times($p("b",true),$p("x"))))),CoshIntegral(Plus($p("c",true),Times($p("d",true),$p("x"))))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(Power($s("x"),Plus($s("m"),C1)),Sinh(Plus($s("a"),Times($s("b"),$s("x"))))),Times(CoshIntegral(Plus($s("c"),Times($s("d"),$s("x")))),Power(Plus($s("m"),C1),CN1))),Times(CN1,Dist(Times($s("d"),Power(Plus($s("m"),C1),CN1)),Int(Times(Times(Power($s("x"),Plus($s("m"),C1)),Sinh(Plus($s("a"),Times($s("b"),$s("x"))))),Times(Cosh(Plus($s("c"),Times($s("d"),$s("x")))),Power(Plus($s("c"),Times($s("d"),$s("x"))),CN1))),$s("x"))))),Times(CN1,Dist(Times($s("b"),Power(Plus($s("m"),C1),CN1)),Int(Times(Times(Power($s("x"),Plus($s("m"),C1)),Cosh(Plus($s("a"),Times($s("b"),$s("x"))))),CoshIntegral(Plus($s("c"),Times($s("d"),$s("x"))))),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),IntegerQ($s("m"))),Less($s("m"),CN1)))),
SetDelayed(Int(Times(Cosh(Plus($p("a",true),Times($p("b",true),$p("x")))),CoshIntegral(Plus($p("c",true),Times($p("d",true),$p("x"))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Sinh(Plus($s("a"),Times($s("b"),$s("x")))),Times(CoshIntegral(Plus($s("c"),Times($s("d"),$s("x")))),Power($s("b"),CN1))),Times(CN1,Dist(Times($s("d"),Power($s("b"),CN1)),Int(Times(Sinh(Plus($s("a"),Times($s("b"),$s("x")))),Times(Cosh(Plus($s("c"),Times($s("d"),$s("x")))),Power(Plus($s("c"),Times($s("d"),$s("x"))),CN1))),$s("x"))))),FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")))),
SetDelayed(Int(Times(Times(Power($p("x"),$p("m",true)),Cosh(Plus($p("a",true),Times($p("b",true),$p("x"))))),CoshIntegral(Plus($p("c",true),Times($p("d",true),$p("x"))))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(Power($s("x"),$s("m")),Sinh(Plus($s("a"),Times($s("b"),$s("x"))))),Times(CoshIntegral(Plus($s("c"),Times($s("d"),$s("x")))),Power($s("b"),CN1))),Times(CN1,Dist(Times($s("d"),Power($s("b"),CN1)),Int(Times(Times(Power($s("x"),$s("m")),Sinh(Plus($s("a"),Times($s("b"),$s("x"))))),Times(Cosh(Plus($s("c"),Times($s("d"),$s("x")))),Power(Plus($s("c"),Times($s("d"),$s("x"))),CN1))),$s("x"))))),Times(CN1,Dist(Times($s("m"),Power($s("b"),CN1)),Int(Times(Times(Power($s("x"),Plus($s("m"),Times(CN1,C1))),Sinh(Plus($s("a"),Times($s("b"),$s("x"))))),CoshIntegral(Plus($s("c"),Times($s("d"),$s("x"))))),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),IntegerQ($s("m"))),Greater($s("m"),C0)))),
SetDelayed(Int(Times(Times(Power($p("x"),$p("m",true)),Cosh(Plus($p("a",true),Times($p("b",true),$p("x"))))),CoshIntegral(Plus($p("c",true),Times($p("d",true),$p("x"))))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(Power($s("x"),Plus($s("m"),C1)),Cosh(Plus($s("a"),Times($s("b"),$s("x"))))),Times(CoshIntegral(Plus($s("c"),Times($s("d"),$s("x")))),Power(Plus($s("m"),C1),CN1))),Times(CN1,Dist(Times($s("d"),Power(Plus($s("m"),C1),CN1)),Int(Times(Times(Power($s("x"),Plus($s("m"),C1)),Cosh(Plus($s("a"),Times($s("b"),$s("x"))))),Times(Cosh(Plus($s("c"),Times($s("d"),$s("x")))),Power(Plus($s("c"),Times($s("d"),$s("x"))),CN1))),$s("x"))))),Times(CN1,Dist(Times($s("b"),Power(Plus($s("m"),C1),CN1)),Int(Times(Times(Power($s("x"),Plus($s("m"),C1)),Sinh(Plus($s("a"),Times($s("b"),$s("x"))))),CoshIntegral(Plus($s("c"),Times($s("d"),$s("x"))))),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),IntegerQ($s("m"))),Less($s("m"),CN1)))),
SetDelayed(Int(LogIntegral(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Plus($s("a"),Times($s("b"),$s("x"))),Times(LogIntegral(Plus($s("a"),Times($s("b"),$s("x")))),Power($s("b"),CN1))),Times(CN1,Times(ExpIntegralEi(Times(C2,Log(Plus($s("a"),Times($s("b"),$s("x")))))),Power($s("b"),CN1)))),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),LogIntegral(Plus($p("a",true),Times($p("b",true),$p("x"))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Times(LogIntegral(Plus($s("a"),Times($s("b"),$s("x")))),Power(Plus($s("m"),C1),CN1))),Times(CN1,Dist(Times($s("b"),Power(Plus($s("m"),C1),CN1)),Int(Times(Power($s("x"),Plus($s("m"),C1)),Power(Log(Plus($s("a"),Times($s("b"),$s("x")))),CN1)),$s("x"))))),And(FreeQ(List($s("a"),$s("b"),$s("m")),$s("x")),NonzeroQ(Plus($s("m"),C1))))),
SetDelayed(Int(Gamma($p("n"),Plus($p("a",true),Times($p("b",true),$p("x")))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Plus($s("a"),Times($s("b"),$s("x"))),Times(Gamma($s("n"),Plus($s("a"),Times($s("b"),$s("x")))),Power($s("b"),CN1))),Times(CN1,Times(Gamma(Plus($s("n"),C1),Plus($s("a"),Times($s("b"),$s("x")))),Power($s("b"),CN1)))),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Gamma($p("n"),Times($p("a",true),$p("x")))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Times(Gamma($s("n"),Times($s("a"),$s("x"))),Power(Plus($s("m"),C1),CN1))),Times(CN1,Times(Gamma(Plus(Plus($s("m"),$s("n")),C1),Times($s("a"),$s("x"))),Power(Times(Plus($s("m"),C1),Power($s("a"),Plus($s("m"),C1))),CN1)))),And(FreeQ(List($s("a"),$s("n")),$s("x")),Or(IntegerQ($s("m")),PositiveQ($s("a")))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Gamma($p("n"),Times($p("a"),$p("x")))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Times(Gamma($s("n"),Times($s("a"),$s("x"))),Power(Plus($s("m"),C1),CN1))),Times(CN1,Times(Power($s("x"),Plus($s("m"),C1)),Times(Gamma(Plus(Plus($s("m"),$s("n")),C1),Times($s("a"),$s("x"))),Power(Times(Plus($s("m"),C1),Power(Times($s("a"),$s("x")),Plus($s("m"),C1))),CN1))))),FreeQ(List($s("a"),$s("m"),$s("n")),$s("x")))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Gamma($p("n"),Plus($p("a"),Times($p("b",true),$p("x"))))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Plus(Times(Times(Power($s("x"),$s("m")),Plus($s("a"),Times($s("b"),$s("x")))),Times(Gamma($s("n"),Plus($s("a"),Times($s("b"),$s("x")))),Power(Times($s("b"),Plus($s("m"),C1)),CN1))),Times(CN1,Times(Power($s("x"),$s("m")),Times(Gamma(Plus($s("n"),C1),Plus($s("a"),Times($s("b"),$s("x")))),Power(Times($s("b"),Plus($s("m"),C1)),CN1))))),Times(CN1,Dist(Times($s("a"),Times($s("m"),Power(Times($s("b"),Plus($s("m"),C1)),CN1))),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,C1))),Gamma($s("n"),Plus($s("a"),Times($s("b"),$s("x"))))),$s("x"))))),Dist(Times($s("m"),Power(Times($s("b"),Plus($s("m"),C1)),CN1)),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,C1))),Gamma(Plus($s("n"),C1),Plus($s("a"),Times($s("b"),$s("x"))))),$s("x")))),And(And(FreeQ(List($s("a"),$s("b"),$s("n")),$s("x")),RationalQ($s("m"))),Greater($s("m"),C0)))),
SetDelayed(Int(LogGamma(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("x",$s("Symbol"))),
    Condition(Times(PolyGamma(integer(-2L),Plus($s("a"),Times($s("b"),$s("x")))),Power($s("b"),CN1)),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),LogGamma(Plus($p("a",true),Times($p("b",true),$p("x"))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),$s("m")),Times(PolyGamma(integer(-2L),Plus($s("a"),Times($s("b"),$s("x")))),Power($s("b"),CN1))),Times(CN1,Dist(Times($s("m"),Power($s("b"),CN1)),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,C1))),PolyGamma(integer(-2L),Plus($s("a"),Times($s("b"),$s("x"))))),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),RationalQ($s("m"))),Greater($s("m"),C0)))),
SetDelayed(Int(PolyGamma($p("n"),Plus($p("a",true),Times($p("b",true),$p("x")))),$p("x",$s("Symbol"))),
    Condition(Times(PolyGamma(Plus($s("n"),Times(CN1,C1)),Plus($s("a"),Times($s("b"),$s("x")))),Power($s("b"),CN1)),FreeQ(List($s("a"),$s("b"),$s("n")),$s("x")))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),PolyGamma($p("n"),Plus($p("a",true),Times($p("b",true),$p("x"))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),$s("m")),Times(PolyGamma(Plus($s("n"),Times(CN1,C1)),Plus($s("a"),Times($s("b"),$s("x")))),Power($s("b"),CN1))),Times(CN1,Dist(Times($s("m"),Power($s("b"),CN1)),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,C1))),PolyGamma(Plus($s("n"),Times(CN1,C1)),Plus($s("a"),Times($s("b"),$s("x"))))),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b"),$s("n")),$s("x")),RationalQ($s("m"))),Greater($s("m"),C0)))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),PolyGamma($p("n"),Plus($p("a",true),Times($p("b",true),$p("x"))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Times(PolyGamma($s("n"),Plus($s("a"),Times($s("b"),$s("x")))),Power(Plus($s("m"),C1),CN1))),Times(CN1,Dist(Times($s("b"),Power(Plus($s("m"),C1),CN1)),Int(Times(Power($s("x"),Plus($s("m"),C1)),PolyGamma(Plus($s("n"),C1),Plus($s("a"),Times($s("b"),$s("x"))))),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b"),$s("n")),$s("x")),RationalQ($s("m"))),Less($s("m"),CN1)))),
SetDelayed(Int(Times(Power(Gamma(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n",true)),PolyGamma(C0,Plus($p("a",true),Times($p("b",true),$p("x"))))),$p("x",$s("Symbol"))),
    Condition(Times(Power(Gamma(Plus($s("a"),Times($s("b"),$s("x")))),$s("n")),Power(Times($s("b"),$s("n")),CN1)),FreeQ(List($s("a"),$s("b"),$s("n")),$s("x")))),
SetDelayed(Int(Times(Power(Factorial(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n",true)),PolyGamma(C0,Plus($p("c",true),Times($p("b",true),$p("x"))))),$p("x",$s("Symbol"))),
    Condition(Times(Power(Factorial(Plus($s("a"),Times($s("b"),$s("x")))),$s("n")),Power(Times($s("b"),$s("n")),CN1)),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("n")),$s("x")),ZeroQ(Plus(Plus($s("a"),Times(CN1,$s("c"))),C1))))),
SetDelayed(Int(Zeta(C2,Plus($p("a",true),Times($p("b",true),$p("x")))),$p("x",$s("Symbol"))),
    Condition(Int(PolyGamma(C1,Plus($s("a"),Times($s("b"),$s("x")))),$s("x")),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(Zeta($p("s"),Plus($p("a",true),Times($p("b",true),$p("x")))),$p("x",$s("Symbol"))),
    Condition(Times(Times(CN1,Zeta(Plus($s("s"),Times(CN1,C1)),Plus($s("a"),Times($s("b"),$s("x"))))),Power(Times($s("b"),Plus($s("s"),Times(CN1,C1))),CN1)),And(And(FreeQ(List($s("a"),$s("b"),$s("s")),$s("x")),NonzeroQ(Plus($s("s"),Times(CN1,C1)))),NonzeroQ(Plus($s("s"),Times(CN1,C2)))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Zeta(C2,Plus($p("a",true),Times($p("b",true),$p("x"))))),$p("x",$s("Symbol"))),
    Condition(Int(Times(Power($s("x"),$s("m")),PolyGamma(C1,Plus($s("a"),Times($s("b"),$s("x"))))),$s("x")),And(FreeQ(List($s("a"),$s("b")),$s("x")),RationalQ($s("m"))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Zeta($p("s"),Plus($p("a",true),Times($p("b",true),$p("x"))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Power($s("x"),$s("m"))),Times(Zeta(Plus($s("s"),Times(CN1,C1)),Plus($s("a"),Times($s("b"),$s("x")))),Power(Times($s("b"),Plus($s("s"),Times(CN1,C1))),CN1))),Dist(Times($s("m"),Power(Times($s("b"),Plus($s("s"),Times(CN1,C1))),CN1)),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,C1))),Zeta(Plus($s("s"),Times(CN1,C1)),Plus($s("a"),Times($s("b"),$s("x"))))),$s("x")))),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("s")),$s("x")),RationalQ($s("m"))),Greater($s("m"),C0)),NonzeroQ(Plus($s("s"),Times(CN1,C1)))),NonzeroQ(Plus($s("s"),Times(CN1,C2)))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Zeta($p("s"),Plus($p("a",true),Times($p("b",true),$p("x"))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Times(Zeta($s("s"),Plus($s("a"),Times($s("b"),$s("x")))),Power(Plus($s("m"),C1),CN1))),Dist(Times($s("b"),Times($s("s"),Power(Plus($s("m"),C1),CN1))),Int(Times(Power($s("x"),Plus($s("m"),C1)),Zeta(Plus($s("s"),C1),Plus($s("a"),Times($s("b"),$s("x"))))),$s("x")))),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("s")),$s("x")),RationalQ($s("m"))),Less($s("m"),CN1)),NonzeroQ(Plus($s("s"),Times(CN1,C1)))),NonzeroQ(Plus($s("s"),Times(CN1,C2)))))),
SetDelayed(Int(PolyLog($p("n"),Times($p("a",true),Power(Times($p("b",true),Power($p("x"),$p("p",true))),$p("q",true)))),$p("x",$s("Symbol"))),
    Condition(Plus(Times($s("x"),PolyLog($s("n"),Times($s("a"),Power(Times($s("b"),Power($s("x"),$s("p"))),$s("q"))))),Times(CN1,Dist(Times($s("p"),$s("q")),Int(PolyLog(Plus($s("n"),Times(CN1,C1)),Times($s("a"),Power(Times($s("b"),Power($s("x"),$s("p"))),$s("q")))),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b"),$s("p"),$s("q")),$s("x")),RationalQ($s("n"))),Greater($s("n"),C0)))),
SetDelayed(Int(PolyLog($p("n"),Times($p("a",true),Power(Times($p("b",true),Power($p("x"),$p("p",true))),$p("q",true)))),$p("x",$s("Symbol"))),
    Condition(Plus(Times($s("x"),Times(PolyLog(Plus($s("n"),C1),Times($s("a"),Power(Times($s("b"),Power($s("x"),$s("p"))),$s("q")))),Power(Times($s("p"),$s("q")),CN1))),Times(CN1,Dist(Times(C1,Power(Times($s("p"),$s("q")),CN1)),Int(PolyLog(Plus($s("n"),C1),Times($s("a"),Power(Times($s("b"),Power($s("x"),$s("p"))),$s("q")))),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b"),$s("p"),$s("q")),$s("x")),RationalQ($s("n"))),Less($s("n"),CN1)))),
SetDelayed(Int(Times(PolyLog($p("n"),Times($p("a",true),Power(Times($p("b",true),Power($p("x"),$p("p",true))),$p("q",true)))),Power($p("x"),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(PolyLog(Plus($s("n"),C1),Times($s("a"),Power(Times($s("b"),Power($s("x"),$s("p"))),$s("q")))),Power(Times($s("p"),$s("q")),CN1)),FreeQ(List($s("a"),$s("b"),$s("n"),$s("p"),$s("q")),$s("x")))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),PolyLog($p("n"),Times($p("a",true),Power(Times($p("b",true),Power($p("x"),$p("p",true))),$p("q",true))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Times(PolyLog($s("n"),Times($s("a"),Power(Times($s("b"),Power($s("x"),$s("p"))),$s("q")))),Power(Plus($s("m"),C1),CN1))),Times(CN1,Dist(Times($s("p"),Times($s("q"),Power(Plus($s("m"),C1),CN1))),Int(Times(Power($s("x"),$s("m")),PolyLog(Plus($s("n"),Times(CN1,C1)),Times($s("a"),Power(Times($s("b"),Power($s("x"),$s("p"))),$s("q"))))),$s("x"))))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("m"),$s("p"),$s("q")),$s("x")),RationalQ($s("n"))),Greater($s("n"),C0)),NonzeroQ(Plus($s("m"),C1))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),PolyLog($p("n"),Times($p("a",true),Power(Times($p("b",true),Power($p("x"),$p("p",true))),$p("q",true))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Times(PolyLog(Plus($s("n"),C1),Times($s("a"),Power(Times($s("b"),Power($s("x"),$s("p"))),$s("q")))),Power(Times($s("p"),$s("q")),CN1))),Times(CN1,Dist(Times(Plus($s("m"),C1),Power(Times($s("p"),$s("q")),CN1)),Int(Times(Power($s("x"),$s("m")),PolyLog(Plus($s("n"),C1),Times($s("a"),Power(Times($s("b"),Power($s("x"),$s("p"))),$s("q"))))),$s("x"))))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("m"),$s("p"),$s("q")),$s("x")),RationalQ($s("n"))),Less($s("n"),CN1)),NonzeroQ(Plus($s("m"),C1))))),
SetDelayed(Int(Times(PolyLog($p("n"),$p("u")),Power(Plus($p("a"),Times($p("b",true),$p("x"))),CN1)),$p("x",$s("Symbol"))),
    Condition(Dist(Times(C1,Power($s("b"),CN1)),Subst(Int(Times(PolyLog($s("n"),Regularize(Subst($s("u"),$s("x"),Plus(Times(Times(CN1,$s("a")),Power($s("b"),CN1)),Times($s("x"),Power($s("b"),CN1)))),$s("x"))),Power($s("x"),CN1)),$s("x")),$s("x"),Plus($s("a"),Times($s("b"),$s("x"))))),FreeQ(List($s("a"),$s("b"),$s("n")),$s("x")))),
SetDelayed(Int(PolyLog($p("n"),Times($p("c",true),Power(Plus($p("a",true),Times($p("b",true),$p("x"))),$p("p",true)))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times($s("x"),PolyLog($s("n"),Times($s("c"),Power(Plus($s("a"),Times($s("b"),$s("x"))),$s("p"))))),Times(CN1,Dist($s("p"),Int(PolyLog(Plus($s("n"),Times(CN1,C1)),Times($s("c"),Power(Plus($s("a"),Times($s("b"),$s("x"))),$s("p")))),$s("x"))))),Dist(Times($s("a"),$s("p")),Int(Times(PolyLog(Plus($s("n"),Times(CN1,C1)),Times($s("c"),Power(Plus($s("a"),Times($s("b"),$s("x"))),$s("p")))),Power(Plus($s("a"),Times($s("b"),$s("x"))),CN1)),$s("x")))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("p")),$s("x")),RationalQ($s("n"))),Greater($s("n"),C0)))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),PolyLog($p("n"),Times($p("c",true),Power(Plus($p("a",true),Times($p("b",true),$p("x"))),$p("p",true))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Times(PolyLog($s("n"),Times($s("c"),Power(Plus($s("a"),Times($s("b"),$s("x"))),$s("p")))),Power(Plus($s("m"),C1),CN1))),Times(CN1,Dist(Times($s("b"),Times($s("p"),Power(Plus($s("m"),C1),CN1))),Int(Times(Power($s("x"),Plus($s("m"),C1)),Times(PolyLog(Plus($s("n"),Times(CN1,C1)),Times($s("c"),Power(Plus($s("a"),Times($s("b"),$s("x"))),$s("p")))),Power(Plus($s("a"),Times($s("b"),$s("x"))),CN1))),$s("x"))))),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("m"),$s("p")),$s("x")),RationalQ($s("n"))),Greater($s("n"),C0)),IntegerQ($s("m"))),Greater($s("m"),C0)))),
SetDelayed(Int(Times(Power(Log(Times($p("a",true),Power($p("x"),$p("n",true)))),$p("p",true)),Times(PolyLog($p("q"),Times($p("b",true),Power($p("x"),$p("m",true)))),Power($p("x"),CN1))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power(Log(Times($s("a"),Power($s("x"),$s("n")))),$s("p")),Times(PolyLog(Plus($s("q"),C1),Times($s("b"),Power($s("x"),$s("m")))),Power($s("m"),CN1))),Times(CN1,Dist(Times($s("n"),Times($s("p"),Power($s("m"),CN1))),Int(Times(Power(Log(Times($s("a"),Power($s("x"),$s("n")))),Plus($s("p"),Times(CN1,C1))),Times(PolyLog(Plus($s("q"),C1),Times($s("b"),Power($s("x"),$s("m")))),Power($s("x"),CN1))),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b"),$s("m"),$s("n"),$s("q")),$s("x")),RationalQ($s("p"))),Greater($s("p"),C0)))),
SetDelayed(Int(Power(ProductLog(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("p",true)),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Plus($s("a"),Times($s("b"),$s("x"))),Times(Power(ProductLog(Plus($s("a"),Times($s("b"),$s("x")))),$s("p")),Power($s("b"),CN1))),Times(CN1,Dist($s("p"),Int(Times(Power(ProductLog(Plus($s("a"),Times($s("b"),$s("x")))),$s("p")),Power(Plus(C1,ProductLog(Plus($s("a"),Times($s("b"),$s("x"))))),CN1)),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),RationalQ($s("p"))),GreaterEqual($s("p"),CN1)))),
SetDelayed(Int(Power(ProductLog(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("p")),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Plus($s("a"),Times($s("b"),$s("x"))),Times(Power(ProductLog(Plus($s("a"),Times($s("b"),$s("x")))),$s("p")),Power(Times($s("b"),Plus($s("p"),C1)),CN1))),Dist(Times($s("p"),Power(Plus($s("p"),C1),CN1)),Int(Times(Power(ProductLog(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("p"),C1)),Power(Plus(C1,ProductLog(Plus($s("a"),Times($s("b"),$s("x"))))),CN1)),$s("x")))),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),RationalQ($s("p"))),Less($s("p"),CN1)))),
SetDelayed(Int(Power(ProductLog(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("p")),$p("x",$s("Symbol"))),
    Condition(Times(Times(Power(ProductLog(Plus($s("a"),Times($s("b"),$s("x")))),$s("p")),Power(Power(Times(CN1,ProductLog(Plus($s("a"),Times($s("b"),$s("x"))))),$s("p")),CN1)),Int(Power(Times(CN1,ProductLog(Plus($s("a"),Times($s("b"),$s("x"))))),$s("p")),$s("x"))),And(FreeQ(List($s("a"),$s("b"),$s("p")),$s("x")),Not(RationalQ($s("p")))))),
SetDelayed(Int(Times(C1,Power(Plus(C1,ProductLog(Plus($p("a",true),Times($p("b",true),$p("x"))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Plus($s("a"),Times($s("b"),$s("x"))),Power(Times($s("b"),ProductLog(Plus($s("a"),Times($s("b"),$s("x"))))),CN1)),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(Times(ProductLog(Plus($p("a",true),Times($p("b",true),$p("x")))),Power(Plus(C1,ProductLog(Plus($p("a",true),Times($p("b",true),$p("x"))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus($s("x"),Times(CN1,Int(Times(C1,Power(Plus(C1,ProductLog(Plus($s("a"),Times($s("b"),$s("x"))))),CN1)),$s("x")))),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(Times(C1,Power(Times(ProductLog(Plus($p("a",true),Times($p("b",true),$p("x")))),Plus(C1,ProductLog(Plus($p("a",true),Times($p("b",true),$p("x")))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(ExpIntegralEi(ProductLog(Plus($s("a"),Times($s("b"),$s("x"))))),Power($s("b"),CN1)),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(Times(C1,Power(Times(Sqrt(ProductLog(Plus($p("a",true),Times($p("b",true),$p("x"))))),Plus(C1,ProductLog(Plus($p("a",true),Times($p("b",true),$p("x")))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Sqrt(Pi),Times(Erfi(Sqrt(ProductLog(Plus($s("a"),Times($s("b"),$s("x")))))),Power($s("b"),CN1))),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(Times(Power(ProductLog(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("p")),Power(Plus(C1,ProductLog(Plus($p("a",true),Times($p("b",true),$p("x"))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Plus($s("a"),Times($s("b"),$s("x"))),Times(Power(ProductLog(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("p"),Times(CN1,C1))),Power($s("b"),CN1))),Times(CN1,Dist($s("p"),Int(Times(Power(ProductLog(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("p"),Times(CN1,C1))),Power(Plus(C1,ProductLog(Plus($s("a"),Times($s("b"),$s("x"))))),CN1)),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),RationalQ($s("p"))),Greater($s("p"),C0)))),
SetDelayed(Int(Times(Power(ProductLog(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("p",true)),Power(Plus(C1,ProductLog(Plus($p("a",true),Times($p("b",true),$p("x"))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Plus($s("a"),Times($s("b"),$s("x"))),Times(Power(ProductLog(Plus($s("a"),Times($s("b"),$s("x")))),$s("p")),Power(Times($s("b"),Plus($s("p"),C1)),CN1))),Times(CN1,Dist(Times(C1,Power(Plus($s("p"),C1),CN1)),Int(Times(Power(ProductLog(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("p"),C1)),Power(Plus(C1,ProductLog(Plus($s("a"),Times($s("b"),$s("x"))))),CN1)),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),RationalQ($s("p"))),Less($s("p"),CN1)))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(ProductLog(Times($p("a",true),$p("x"))),$p("p",true))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Times(Power(ProductLog(Times($s("a"),$s("x"))),$s("p")),Power(Plus($s("m"),C1),CN1))),Times(CN1,Dist(Times($s("p"),Power(Plus($s("m"),C1),CN1)),Int(Times(Power($s("x"),$s("m")),Times(Power(ProductLog(Times($s("a"),$s("x"))),$s("p")),Power(Plus(C1,ProductLog(Times($s("a"),$s("x")))),CN1))),$s("x"))))),And(And(And(FreeQ($s("a"),$s("x")),RationalQ(List($s("m"),$s("p")))),NonzeroQ(Plus($s("m"),C1))),GreaterEqual(Plus(Plus($s("m"),$s("p")),C1),C0)))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(ProductLog(Times($p("a",true),$p("x"))),$p("p",true))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Times(Power(ProductLog(Times($s("a"),$s("x"))),$s("p")),Power(Plus(Plus($s("m"),$s("p")),C1),CN1))),Dist(Times($s("p"),Power(Plus(Plus($s("m"),$s("p")),C1),CN1)),Int(Times(Power($s("x"),$s("m")),Times(Power(ProductLog(Times($s("a"),$s("x"))),Plus($s("p"),C1)),Power(Plus(C1,ProductLog(Times($s("a"),$s("x")))),CN1))),$s("x")))),And(And(And(FreeQ($s("a"),$s("x")),RationalQ(List($s("m"),$s("p")))),NonzeroQ(Plus($s("m"),C1))),Less(Plus(Plus($s("m"),$s("p")),C1),C0)))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(ProductLog(Times($p("a",true),$p("x"))),$p("p",true))),$p("x",$s("Symbol"))),
    Condition(Plus(Int(Times(Power($s("x"),$s("m")),Times(Power(ProductLog(Times($s("a"),$s("x"))),$s("p")),Power(Plus(C1,ProductLog(Times($s("a"),$s("x")))),CN1))),$s("x")),Int(Times(Power($s("x"),$s("m")),Times(Power(ProductLog(Times($s("a"),$s("x"))),Plus($s("p"),C1)),Power(Plus(C1,ProductLog(Times($s("a"),$s("x")))),CN1))),$s("x"))),And(FreeQ($s("a"),$s("x")),NonzeroQ(Plus($s("m"),C1))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(ProductLog(Plus($p("a"),Times($p("b",true),$p("x")))),$p("p",true))),$p("x",$s("Symbol"))),
    Condition(Dist(Times(C1,Power($s("b"),CN1)),Subst(Int(Times(Power(Plus(Times(Times(CN1,$s("a")),Power($s("b"),CN1)),Times($s("x"),Power($s("b"),CN1))),$s("m")),Power(ProductLog($s("x")),$s("p"))),$s("x")),$s("x"),Plus($s("a"),Times($s("b"),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b"),$s("p")),$s("x")),IntegerQ($s("m"))),Greater($s("m"),C0)))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Plus(C1,ProductLog(Times($p("a",true),$p("x")))),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Power(Times(Plus($s("m"),C1),ProductLog(Times($s("a"),$s("x")))),CN1)),Times(CN1,Dist(Times($s("m"),Power(Plus($s("m"),C1),CN1)),Int(Times(Power($s("x"),$s("m")),Power(Times(ProductLog(Times($s("a"),$s("x"))),Plus(C1,ProductLog(Times($s("a"),$s("x"))))),CN1)),$s("x"))))),And(And(FreeQ($s("a"),$s("x")),RationalQ($s("m"))),Greater($s("m"),C0)))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Plus(C1,ProductLog(Times($p("a",true),$p("x")))),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Power(Plus($s("m"),C1),CN1)),Times(CN1,Int(Times(Power($s("x"),$s("m")),Times(ProductLog(Times($s("a"),$s("x"))),Power(Plus(C1,ProductLog(Times($s("a"),$s("x")))),CN1))),$s("x")))),And(And(FreeQ($s("a"),$s("x")),RationalQ($s("m"))),Less($s("m"),CN1)))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Plus(C1,ProductLog(Times($p("a",true),$p("x")))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Power($s("x"),$s("m")),Times(Gamma(Plus($s("m"),C1),Times(Times(CN1,Plus($s("m"),C1)),ProductLog(Times($s("a"),$s("x"))))),Power(Times(Times(Times($s("a"),Plus($s("m"),C1)),Power(E,Times($s("m"),ProductLog(Times($s("a"),$s("x")))))),Power(Times(Times(CN1,Plus($s("m"),C1)),ProductLog(Times($s("a"),$s("x")))),$s("m"))),CN1))),And(FreeQ($s("a"),$s("x")),NonzeroQ(Plus($s("m"),C1))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Plus(C1,ProductLog(Plus($p("a"),Times($p("b",true),$p("x"))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Dist(Times(C1,Power($s("b"),CN1)),Subst(Int(Times(Power(Plus(Times(Times(CN1,$s("a")),Power($s("b"),CN1)),Times($s("x"),Power($s("b"),CN1))),$s("m")),Power(Plus(C1,ProductLog($s("x"))),CN1)),$s("x")),$s("x"),Plus($s("a"),Times($s("b"),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ($s("m"))),Greater($s("m"),C0)))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Times(Power(ProductLog(Times($p("a",true),$p("x"))),$p("p",true)),Power(Plus(C1,ProductLog(Times($p("a",true),$p("x")))),CN1))),$p("x",$s("Symbol"))),
    Condition(Times(Power($s("x"),Plus($s("m"),C1)),Times(Power(ProductLog(Times($s("a"),$s("x"))),Plus($s("p"),Times(CN1,C1))),Power(Plus($s("m"),C1),CN1))),And(And(FreeQ(List($s("a"),$s("m"),$s("p")),$s("x")),ZeroQ(Plus(Plus($s("m"),Plus($s("p"),Times(CN1,C1))),C1))),NonzeroQ(Plus($s("m"),C1))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Times(Power(ProductLog(Times($p("a",true),$p("x"))),$p("p",true)),Power(Plus(C1,ProductLog(Times($p("a",true),$p("x")))),CN1))),$p("x",$s("Symbol"))),
    Condition(Times(Power($s("a"),$s("p")),ExpIntegralEi(Times(Times(CN1,$s("p")),ProductLog(Times($s("a"),$s("x")))))),And(And(FreeQ(List($s("a"),$s("m")),$s("x")),IntegerQ($s("p"))),ZeroQ(Plus(Plus($s("m"),$s("p")),C1))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Times(Power(ProductLog(Times($p("a",true),$p("x"))),$p("p")),Power(Plus(C1,ProductLog(Times($p("a",true),$p("x")))),CN1))),$p("x",$s("Symbol"))),
    Condition(Times(Times(Power($s("a"),Plus($s("p"),Times(CN1,C1D2))),Sqrt(Times(Pi,Power(Plus($s("p"),Times(CN1,C1D2)),CN1)))),Erf(Sqrt(Times(Plus($s("p"),Times(CN1,C1D2)),ProductLog(Times($s("a"),$s("x"))))))),And(And(And(FreeQ(List($s("a"),$s("m")),$s("x")),IntegerQ(Plus($s("p"),Times(CN1,C1D2)))),Greater($s("p"),C1)),ZeroQ(Plus(Plus($s("m"),Plus($s("p"),Times(CN1,C1D2))),C1))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Times(Power(ProductLog(Times($p("a",true),$p("x"))),$p("p")),Power(Plus(C1,ProductLog(Times($p("a",true),$p("x")))),CN1))),$p("x",$s("Symbol"))),
    Condition(Times(Times(Power($s("a"),Plus($s("p"),Times(CN1,C1D2))),Sqrt(Times(Times(CN1,Pi),Power(Plus($s("p"),Times(CN1,C1D2)),CN1)))),Erfi(Sqrt(Times(Times(CN1,Plus($s("p"),Times(CN1,C1D2))),ProductLog(Times($s("a"),$s("x"))))))),And(And(And(FreeQ(List($s("a"),$s("m")),$s("x")),IntegerQ(Plus($s("p"),Times(CN1,C1D2)))),Less($s("p"),C0)),ZeroQ(Plus(Plus($s("m"),Plus($s("p"),Times(CN1,C1D2))),C1))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Times(Power(ProductLog(Times($p("a",true),$p("x"))),$p("p",true)),Power(Plus(C1,ProductLog(Times($p("a",true),$p("x")))),CN1))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Times(Power(ProductLog(Times($s("a"),$s("x"))),Plus($s("p"),Times(CN1,C1))),Power(Plus($s("m"),C1),CN1))),Times(CN1,Dist(Times(Plus(Plus($s("m"),Plus($s("p"),Times(CN1,C1))),C1),Power(Plus($s("m"),C1),CN1)),Int(Times(Power($s("x"),$s("m")),Times(Power(ProductLog(Times($s("a"),$s("x"))),Plus($s("p"),Times(CN1,C1))),Power(Plus(C1,ProductLog(Times($s("a"),$s("x")))),CN1))),$s("x"))))),And(And(And(FreeQ($s("a"),$s("x")),RationalQ(List($s("m"),$s("p")))),NonzeroQ(Plus($s("m"),C1))),Greater(Plus($s("m"),$s("p")),C0)))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Times(Power(ProductLog(Times($p("a",true),$p("x"))),$p("p",true)),Power(Plus(C1,ProductLog(Times($p("a",true),$p("x")))),CN1))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Times(Power(ProductLog(Times($s("a"),$s("x"))),$s("p")),Power(Plus(Plus($s("m"),$s("p")),C1),CN1))),Times(CN1,Dist(Times(Plus($s("m"),C1),Power(Plus(Plus($s("m"),$s("p")),C1),CN1)),Int(Times(Power($s("x"),$s("m")),Times(Power(ProductLog(Times($s("a"),$s("x"))),Plus($s("p"),C1)),Power(Plus(C1,ProductLog(Times($s("a"),$s("x")))),CN1))),$s("x"))))),And(And(And(FreeQ($s("a"),$s("x")),RationalQ(List($s("m"),$s("p")))),NonzeroQ(Plus($s("m"),C1))),Less(Plus($s("m"),$s("p")),CN1)))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Times(Power(ProductLog(Times($p("a",true),$p("x"))),$p("p",true)),Power(Plus(C1,ProductLog(Times($p("a",true),$p("x")))),CN1))),$p("x",$s("Symbol"))),
    Condition(Times(Times(Power($s("x"),$s("m")),Gamma(Plus(Plus($s("m"),$s("p")),C1),Times(Times(CN1,Plus($s("m"),C1)),ProductLog(Times($s("a"),$s("x")))))),Times(Power(ProductLog(Times($s("a"),$s("x"))),$s("p")),Power(Times(Times(Times($s("a"),Plus($s("m"),C1)),Power(E,Times($s("m"),ProductLog(Times($s("a"),$s("x")))))),Power(Times(Times(CN1,Plus($s("m"),C1)),ProductLog(Times($s("a"),$s("x")))),Plus($s("m"),$s("p")))),CN1))),And(FreeQ($s("a"),$s("x")),NonzeroQ(Plus($s("m"),C1))))),
SetDelayed(Int(Power(ProductLog(Times($p("a",true),Power($p("x"),$p("n")))),$p("p",true)),$p("x",$s("Symbol"))),
    Condition(Plus(Times($s("x"),Power(ProductLog(Times($s("a"),Power($s("x"),$s("n")))),$s("p"))),Times(CN1,Dist(Times($s("n"),$s("p")),Int(Times(Power(ProductLog(Times($s("a"),Power($s("x"),$s("n")))),$s("p")),Power(Plus(C1,ProductLog(Times($s("a"),Power($s("x"),$s("n"))))),CN1)),$s("x"))))),And(FreeQ(List($s("a"),$s("n"),$s("p")),$s("x")),Or(ZeroQ(Plus(Times($s("n"),Plus($s("p"),Times(CN1,C1))),C1)),And(IntegerQ(Plus($s("p"),Times(CN1,C1D2))),ZeroQ(Plus(Times($s("n"),Plus($s("p"),Times(CN1,C1D2))),C1))))))),
SetDelayed(Int(Power(ProductLog(Times($p("a",true),Power($p("x"),$p("n")))),$p("p",true)),$p("x",$s("Symbol"))),
    Condition(Plus(Times($s("x"),Times(Power(ProductLog(Times($s("a"),Power($s("x"),$s("n")))),$s("p")),Power(Plus(Times($s("n"),$s("p")),C1),CN1))),Dist(Times($s("n"),Times($s("p"),Power(Plus(Times($s("n"),$s("p")),C1),CN1))),Int(Times(Power(ProductLog(Times($s("a"),Power($s("x"),$s("n")))),Plus($s("p"),C1)),Power(Plus(C1,ProductLog(Times($s("a"),Power($s("x"),$s("n"))))),CN1)),$s("x")))),And(FreeQ(List($s("a"),$s("n")),$s("x")),Or(And(IntegerQ($s("p")),ZeroQ(Plus(Times($s("n"),Plus($s("p"),C1)),C1))),And(IntegerQ(Plus($s("p"),Times(CN1,C1D2))),ZeroQ(Plus(Times($s("n"),Plus($s("p"),C1D2)),C1))))))),
SetDelayed(Int(Power(ProductLog(Times($p("a",true),Power($p("x"),$p("n")))),$p("p",true)),$p("x",$s("Symbol"))),
    Condition(Times(CN1,Subst(Int(Times(Power(ProductLog(Times($s("a"),Power($s("x"),Times(CN1,$s("n"))))),$s("p")),Power(Power($s("x"),C2),CN1)),$s("x")),$s("x"),Times(C1,Power($s("x"),CN1)))),And(And(FreeQ(List($s("a"),$s("p")),$s("x")),IntegerQ($s("n"))),Less($s("n"),C0)))),
SetDelayed(Int(Times(Power(ProductLog(Times($p("a",true),Power($p("x"),$p("n")))),$p("p",true)),Power(Plus(C1,ProductLog(Times($p("a",true),Power($p("x"),$p("n"))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times($s("x"),Power(ProductLog(Times($s("a"),Power($s("x"),$s("n")))),Plus($s("p"),Times(CN1,C1)))),And(FreeQ(List($s("a"),$s("n"),$s("p")),$s("x")),ZeroQ(Plus(Times($s("n"),Plus($s("p"),Times(CN1,C1))),C1))))),
SetDelayed(Int(Times(Power(ProductLog(Times($p("a",true),Power($p("x"),$p("n")))),$p("p",true)),Power(Plus(C1,ProductLog(Times($p("a",true),Power($p("x"),$p("n"))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Power($s("a"),$s("p")),Times(ExpIntegralEi(Times(Times(CN1,$s("p")),ProductLog(Times($s("a"),Power($s("x"),$s("n")))))),Power($s("n"),CN1))),And(And(FreeQ(List($s("a"),$s("n")),$s("x")),IntegerQ($s("p"))),ZeroQ(Plus(Times($s("n"),$s("p")),C1))))),
SetDelayed(Int(Times(Power(ProductLog(Times($p("a",true),Power($p("x"),$p("n")))),$p("p")),Power(Plus(C1,ProductLog(Times($p("a",true),Power($p("x"),$p("n"))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Times(Power($s("a"),Plus($s("p"),Times(CN1,C1D2))),Sqrt(Times(Pi,Power(Plus($s("p"),Times(CN1,C1D2)),CN1)))),Times(Erf(Sqrt(Times(Plus($s("p"),Times(CN1,C1D2)),ProductLog(Times($s("a"),Power($s("x"),$s("n"))))))),Power($s("n"),CN1))),And(And(And(FreeQ(List($s("a"),$s("n")),$s("x")),IntegerQ(Plus($s("p"),Times(CN1,C1D2)))),Greater($s("p"),C1)),ZeroQ(Plus(Times($s("n"),Plus($s("p"),Times(CN1,C1D2))),C1))))),
SetDelayed(Int(Times(Power(ProductLog(Times($p("a",true),Power($p("x"),$p("n")))),$p("p")),Power(Plus(C1,ProductLog(Times($p("a",true),Power($p("x"),$p("n"))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Times(Power($s("a"),Plus($s("p"),Times(CN1,C1D2))),Sqrt(Times(Times(CN1,Pi),Power(Plus($s("p"),Times(CN1,C1D2)),CN1)))),Times(Erfi(Sqrt(Times(Times(CN1,Plus($s("p"),Times(CN1,C1D2))),ProductLog(Times($s("a"),Power($s("x"),$s("n"))))))),Power($s("n"),CN1))),And(And(And(FreeQ(List($s("a"),$s("n")),$s("x")),IntegerQ(Plus($s("p"),Times(CN1,C1D2)))),Less($s("p"),C0)),ZeroQ(Plus(Times($s("n"),Plus($s("p"),Times(CN1,C1D2))),C1))))),
SetDelayed(Int(Times(Power(ProductLog(Times($p("a",true),Power($p("x"),$p("n")))),$p("p",true)),Power(Plus(C1,ProductLog(Times($p("a",true),Power($p("x"),$p("n"))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(CN1,Subst(Int(Times(Power(ProductLog(Times($s("a"),Power($s("x"),Times(CN1,$s("n"))))),$s("p")),Power(Times(Power($s("x"),C2),Plus(C1,ProductLog(Times($s("a"),Power($s("x"),Times(CN1,$s("n"))))))),CN1)),$s("x")),$s("x"),Times(C1,Power($s("x"),CN1)))),And(And(FreeQ(List($s("a"),$s("p")),$s("x")),IntegerQ($s("n"))),Less($s("n"),C0)))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(ProductLog(Times($p("a",true),Power($p("x"),$p("n")))),$p("p",true))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Times(Power(ProductLog(Times($s("a"),Power($s("x"),$s("n")))),$s("p")),Power(Plus($s("m"),C1),CN1))),Times(CN1,Dist(Times($s("n"),Times($s("p"),Power(Plus($s("m"),C1),CN1))),Int(Times(Power($s("x"),$s("m")),Times(Power(ProductLog(Times($s("a"),Power($s("x"),$s("n")))),$s("p")),Power(Plus(C1,ProductLog(Times($s("a"),Power($s("x"),$s("n"))))),CN1))),$s("x"))))),And(And(FreeQ(List($s("a"),$s("m"),$s("n"),$s("p")),$s("x")),NonzeroQ(Plus($s("m"),C1))),Or(Or(ZeroQ(Plus(Plus($s("m"),Times($s("n"),Plus($s("p"),Times(CN1,C1)))),C1)),And(IntegerQ($s("p")),ZeroQ(Plus(Plus($s("m"),Times($s("n"),$s("p"))),C1)))),And(IntegerQ(Plus($s("p"),Times(CN1,C1D2))),ZeroQ(Plus(Plus($s("m"),Times($s("n"),Plus($s("p"),Times(CN1,C1D2)))),C1))))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(ProductLog(Times($p("a",true),Power($p("x"),$p("n")))),$p("p",true))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Times(Power(ProductLog(Times($s("a"),Power($s("x"),$s("n")))),$s("p")),Power(Plus(Plus($s("m"),Times($s("n"),$s("p"))),C1),CN1))),Dist(Times($s("n"),Times($s("p"),Power(Plus(Plus($s("m"),Times($s("n"),$s("p"))),C1),CN1))),Int(Times(Power($s("x"),$s("m")),Times(Power(ProductLog(Times($s("a"),Power($s("x"),$s("n")))),Plus($s("p"),C1)),Power(Plus(C1,ProductLog(Times($s("a"),Power($s("x"),$s("n"))))),CN1))),$s("x")))),And(And(FreeQ(List($s("a"),$s("m"),$s("n"),$s("p")),$s("x")),NonzeroQ(Plus($s("m"),C1))),Or(And(IntegerQ($s("p")),ZeroQ(Plus(Plus($s("m"),Times($s("n"),Plus($s("p"),C1))),C1))),And(IntegerQ(Plus($s("p"),Times(CN1,C1D2))),ZeroQ(Plus(Plus($s("m"),Times($s("n"),Plus($s("p"),C1D2))),C1))))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(ProductLog(Times($p("a",true),Power($p("x"),$p("n")))),$p("p",true))),$p("x",$s("Symbol"))),
    Condition(Times(CN1,Subst(Int(Times(Power(ProductLog(Times($s("a"),Power($s("x"),Times(CN1,$s("n"))))),$s("p")),Power(Power($s("x"),Plus($s("m"),C2)),CN1)),$s("x")),$s("x"),Times(C1,Power($s("x"),CN1)))),And(And(And(FreeQ(List($s("a"),$s("p")),$s("x")),IntegerQ(List($s("m"),$s("n")))),Less($s("n"),C0)),NonzeroQ(Plus($s("m"),C1))))),
SetDelayed(Int(Times(C1,Power(Plus(C1,ProductLog(Times($p("a",true),Power($p("x"),$p("n"))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(CN1,Subst(Int(Times(C1,Power(Times(Power($s("x"),C2),Plus(C1,ProductLog(Times($s("a"),Power($s("x"),Times(CN1,$s("n"))))))),CN1)),$s("x")),$s("x"),Times(C1,Power($s("x"),CN1)))),And(And(FreeQ($s("a"),$s("x")),IntegerQ($s("n"))),Less($s("n"),C0)))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Plus(C1,ProductLog(Times($p("a",true),Power($p("x"),$p("n"))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(CN1,Subst(Int(Times(C1,Power(Times(Power($s("x"),Plus($s("m"),C2)),Plus(C1,ProductLog(Times($s("a"),Power($s("x"),Times(CN1,$s("n"))))))),CN1)),$s("x")),$s("x"),Times(C1,Power($s("x"),CN1)))),And(And(And(FreeQ($s("a"),$s("x")),IntegerQ(List($s("m"),$s("n")))),Less($s("n"),C0)),NonzeroQ(Plus($s("m"),C1))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Times(Power(ProductLog(Times($p("a",true),Power($p("x"),$p("n")))),$p("p",true)),Power(Plus(C1,ProductLog(Times($p("a",true),Power($p("x"),$p("n"))))),CN1))),$p("x",$s("Symbol"))),
    Condition(Times(Power($s("x"),Plus($s("m"),C1)),Times(Power(ProductLog(Times($s("a"),Power($s("x"),$s("n")))),Plus($s("p"),Times(CN1,C1))),Power(Plus($s("m"),C1),CN1))),And(And(FreeQ(List($s("a"),$s("m"),$s("n"),$s("p")),$s("x")),ZeroQ(Plus(Plus($s("m"),Times($s("n"),Plus($s("p"),Times(CN1,C1)))),C1))),NonzeroQ(Plus($s("m"),C1))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Times(Power(ProductLog(Times($p("a",true),Power($p("x"),$p("n")))),$p("p",true)),Power(Plus(C1,ProductLog(Times($p("a",true),Power($p("x"),$p("n"))))),CN1))),$p("x",$s("Symbol"))),
    Condition(Times(Power($s("a"),$s("p")),Times(ExpIntegralEi(Times(Times(CN1,$s("p")),ProductLog(Times($s("a"),Power($s("x"),$s("n")))))),Power($s("n"),CN1))),And(And(FreeQ(List($s("a"),$s("m"),$s("n")),$s("x")),IntegerQ($s("p"))),ZeroQ(Plus(Plus($s("m"),Times($s("n"),$s("p"))),C1))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Times(Power(ProductLog(Times($p("a",true),Power($p("x"),$p("n")))),$p("p")),Power(Plus(C1,ProductLog(Times($p("a",true),Power($p("x"),$p("n"))))),CN1))),$p("x",$s("Symbol"))),
    Condition(Times(Times(Power($s("a"),Plus($s("p"),Times(CN1,C1D2))),Sqrt(Times(Pi,Power(Plus($s("p"),Times(CN1,C1D2)),CN1)))),Times(Erf(Sqrt(Times(Plus($s("p"),Times(CN1,C1D2)),ProductLog(Times($s("a"),Power($s("x"),$s("n"))))))),Power($s("n"),CN1))),And(And(And(FreeQ(List($s("a"),$s("m"),$s("n")),$s("x")),IntegerQ(Plus($s("p"),Times(CN1,C1D2)))),Greater($s("p"),C1)),ZeroQ(Plus(Plus($s("m"),Times($s("n"),Plus($s("p"),Times(CN1,C1D2)))),C1)))))
  );
}
