package org.matheclipse.core.integrate.rubi;


import static org.matheclipse.core.expression.F.*;
import static org.matheclipse.core.integrate.rubi.UtilityFunctionCtors.*;
import static org.matheclipse.core.integrate.rubi.UtilityFunctions.*;
import org.matheclipse.core.interfaces.IAST;
import org.matheclipse.core.interfaces.IExpr;

/** 
 * IndefiniteIntegrationRules from the <a href="http://www.apmaths.uwo.ca/~arich/">Rubi -
 * rule-based integrator</a>.
 *  
 */
public class IndefiniteIntegrationRules3 { 
  public static IAST RULES = List( 
SetDelayed(Int(Times($p("u",true),Power(Plus(Times($p("e",true),Sqrt(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n",true)))))),Times($p("f",true),Sqrt(Plus($p("c",true),Times($p("d",true),Power($p("x"),$p("n",true))))))),$p("m"))),$p("x",$s("Symbol"))),
    Condition(Dist(Power(Plus(Times($s("b"),Power($s("e"),C2)),Times(CN1,Times($s("d"),Power($s("f"),C2)))),$s("m")),Int(Times(Times($s("u"),Power(Plus(Times($s("e"),Sqrt(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))))),Times(CN1,Times($s("f"),Sqrt(Plus($s("c"),Times($s("d"),Power($s("x"),$s("n")))))))),Times(CN1,$s("m")))),Power($s("x"),Times($s("m"),$s("n")))),$s("x"))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e"),$s("f"),$s("n")),$s("x")),IntegerQ($s("m"))),Less($s("m"),C0)),ZeroQ(Plus(Times($s("a"),Power($s("e"),C2)),Times(CN1,Times($s("c"),Power($s("f"),C2)))))))),
SetDelayed(Int(Times($p("u",true),Power(Plus($p("a"),Times($p("b",true),Sqrt(Plus($p("c"),Times($p("d",true),Power($p("x"),$p("n"))))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Dist(Times(Times(CN1,$s("a")),Power(Times(Power($s("b"),C2),$s("d")),CN1)),Int(Times($s("u"),Power(Power($s("x"),$s("n")),CN1)),$s("x"))),Dist(Times(C1,Power(Times($s("b"),$s("d")),CN1)),Int(Times($s("u"),Times(Sqrt(Plus($s("c"),Times($s("d"),Power($s("x"),$s("n"))))),Power(Power($s("x"),$s("n")),CN1))),$s("x")))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("n")),$s("x")),SameQ(Power($s("a"),C2),Times(Power($s("b"),C2),$s("c")))))),
SetDelayed(Int(Times($p("u",true),Power(Plus(Times($p("a",true),Power($p("x"),$p("m",true))),Times($p("b",true),Sqrt(Plus($p("c"),Times($p("d",true),Power($p("x"),$p("n"))))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Dist(Times(Times(CN1,$s("a")),Power(Times(Power($s("b"),C2),$s("c")),CN1)),Int(Times($s("u"),Power($s("x"),$s("m"))),$s("x"))),Dist(Times(C1,Power(Times($s("b"),$s("c")),CN1)),Int(Times($s("u"),Sqrt(Plus($s("c"),Times($s("d"),Power($s("x"),$s("n")))))),$s("x")))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("m"),$s("n")),$s("x")),SameQ($s("n"),Times(C2,$s("m")))),SameQ(Power($s("a"),C2),Times(Power($s("b"),C2),$s("d")))))),
SetDelayed(Int(Times($p("u",true),Power(Plus(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("m",true)))),Times($p("c",true),Sqrt(Plus($p("d"),Times($p("e",true),Power($p("x"),$p("n"))))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Dist(Times(C1,Power(Times(C2,$s("b")),CN1)),Int(Times($s("u"),Power(Power($s("x"),$s("m")),CN1)),$s("x"))),Dist(Times(C1,Power(Times(C2,$s("a")),CN1)),Int($s("u"),$s("x")))),Times(CN1,Dist(Times($s("c"),Power(Times(Times(C2,$s("a")),$s("b")),CN1)),Int(Times($s("u"),Times(Sqrt(Plus($s("d"),Times($s("e"),Power($s("x"),$s("n"))))),Power(Power($s("x"),$s("m")),CN1))),$s("x"))))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("m"),$s("n")),$s("x")),SameQ($s("n"),Times(C2,$s("m")))),SameQ(Power($s("a"),C2),Times(Power($s("c"),C2),$s("d")))),SameQ(Power($s("b"),C2),Times(Power($s("c"),C2),$s("e")))))),
SetDelayed(Int(Times($p("u",true),Power(Plus(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("m",true)))),Times($p("c",true),Sqrt(Plus($p("d"),Times($p("e",true),Power($p("x"),$p("n"))))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Dist(Times($s("a"),Power(Power($s("b"),C2),CN1)),Int(Times($s("u"),Power(Power($s("x"),Times(C2,$s("m"))),CN1)),$s("x"))),Dist(Times(C1,Power($s("b"),CN1)),Int(Times($s("u"),Power(Power($s("x"),$s("m")),CN1)),$s("x")))),Times(CN1,Dist(Times($s("c"),Power(Power($s("b"),C2),CN1)),Int(Times($s("u"),Times(Sqrt(Plus($s("d"),Times($s("e"),Power($s("x"),$s("n"))))),Power(Power($s("x"),Times(C2,$s("m"))),CN1))),$s("x"))))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("m"),$s("n")),$s("x")),SameQ($s("n"),$s("m"))),SameQ(Power($s("a"),C2),Times(Power($s("c"),C2),$s("d")))),SameQ(Times(Times(C2,$s("a")),$s("b")),Times(Power($s("c"),C2),$s("e")))))),
SetDelayed(Int(Times($p("u",true),Power(Plus(Times($p("a",true),$p("x")),Times($p("b",true),Sqrt(Plus($p("c",true),Times($p("d",true),Power($p("x"),C2)))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Dist($s("a"),Int(Times($s("x"),Times($s("u"),Power(Plus(Times(Times(CN1,Power($s("b"),C2)),$s("c")),Times(Plus(Power($s("a"),C2),Times(CN1,Times(Power($s("b"),C2),$s("d")))),Power($s("x"),C2))),CN1))),$s("x"))),Times(CN1,Dist($s("b"),Int(Times($s("u"),Times(Sqrt(Plus($s("c"),Times($s("d"),Power($s("x"),C2)))),Power(Plus(Times(Times(CN1,Power($s("b"),C2)),$s("c")),Times(Plus(Power($s("a"),C2),Times(CN1,Times(Power($s("b"),C2),$s("d")))),Power($s("x"),C2))),CN1))),$s("x"))))),FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")))),
SetDelayed(Int(Times($p("u",true),Power(Plus(Times($p("e",true),Sqrt(Power(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n",true)))),$p("p",true)))),Times($p("f",true),Sqrt(Power(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n",true)))),$p("q",true))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Int(Times($s("u"),Times(Plus(Times($s("e"),Sqrt(Power(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))),$s("p")))),Times(CN1,Times($s("f"),Sqrt(Power(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))),$s("q")))))),Power(Plus(Times(Power($s("e"),C2),Power(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))),$s("p"))),Times(CN1,Times(Power($s("f"),C2),Power(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))),$s("q"))))),CN1))),$s("x")),And(FreeQ(List($s("a"),$s("b"),$s("e"),$s("f")),$s("x")),IntegerQ(List($s("n"),$s("p"),$s("q")))))),
SetDelayed(Int(Times($p("u",true),Times(Sqrt(Plus($p("c"),Times($p("d",true),Power($p("x"),C2)))),Power(Plus($p("a"),Times($p("b",true),$p("x"))),CN1))),$p("x",$s("Symbol"))),
    Condition(Plus(Times($s("a"),Int(Times($s("u"),Power(Sqrt(Plus($s("c"),Times($s("d"),Power($s("x"),C2)))),CN1)),$s("x"))),Times(CN1,Times($s("b"),Int(Times($s("x"),Times($s("u"),Power(Sqrt(Plus($s("c"),Times($s("d"),Power($s("x"),C2)))),CN1))),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),SameQ($s("c"),Power($s("a"),C2))),SameQ($s("d"),Times(CN1,Power($s("b"),C2)))))),
SetDelayed(Int(Times(Sqrt(Plus(Times($p("b",true),Power($p("x"),C2)),Sqrt(Plus($p("a"),Times($p("c",true),Power($p("x"),C4)))))),Power(Sqrt(Plus($p("a"),Times($p("c",true),Power($p("x"),C4)))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(ArcTanh(Times(Rt(Times(C2,$s("b")),C2),Times($s("x"),Power(Sqrt(Plus(Times($s("b"),Power($s("x"),C2)),Sqrt(Plus($s("a"),Times($s("c"),Power($s("x"),C4)))))),CN1)))),Power(Rt(Times(C2,$s("b")),C2),CN1)),And(And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),ZeroQ(Plus(Power($s("b"),C2),Times(CN1,$s("c"))))),PosQ($s("b"))))),
SetDelayed(Int(Times(Sqrt(Plus(Times($p("b",true),Power($p("x"),C2)),Sqrt(Plus($p("a"),Times($p("c",true),Power($p("x"),C4)))))),Power(Sqrt(Plus($p("a"),Times($p("c",true),Power($p("x"),C4)))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(ArcTan(Times(Rt(Times(integer(-2L),$s("b")),C2),Times($s("x"),Power(Sqrt(Plus(Times($s("b"),Power($s("x"),C2)),Sqrt(Plus($s("a"),Times($s("c"),Power($s("x"),C4)))))),CN1)))),Power(Rt(Times(integer(-2L),$s("b")),C2),CN1)),And(And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),ZeroQ(Plus(Power($s("b"),C2),Times(CN1,$s("c"))))),NegQ($s("b"))))),
SetDelayed(Int(Times($p("u",true),Times(Sqrt(Plus($p("v"),Sqrt(Plus($p("a"),$p("w"))))),Power(Sqrt(Plus($p("a"),$p("w"))),CN1))),$p("x",$s("Symbol"))),
    Condition(Plus(Dist(Times(Plus(C1,Times(CN1,CI)),C1D2),Int(Times($s("u"),Power(Sqrt(Plus(Sqrt($s("a")),Times(CN1,Times(CI,$s("v"))))),CN1)),$s("x"))),Dist(Times(Plus(C1,CI),C1D2),Int(Times($s("u"),Power(Sqrt(Plus(Sqrt($s("a")),Times(CI,$s("v")))),CN1)),$s("x")))),And(And(And(FreeQ($s("a"),$s("x")),ZeroQ(Plus($s("w"),Times(CN1,Power($s("v"),C2))))),PositiveQ($s("a"))),Not(LinearQ($s("v"),$s("x")))))),
SetDelayed(Int(Times(C1,Power(Plus($p("a"),Times($p("b",true),$p("u"))),CN1)),$p("x",$s("Symbol"))),
    Condition(Module(List(Set($s("lst"),ConstantFactor(Plus($s("a"),Times($s("b"),$s("u"))),$s("x")))),Condition(Dist(Times(C1,Power(Part($s("lst"),C1),CN1)),Int(Times(C1,Power(Part($s("lst"),C2),CN1)),$s("x"))),UnsameQ(Part($s("lst"),C1),C1))),And(FreeQ(List($s("a"),$s("b")),$s("x")),Or(MatchQ($s("u"),Condition(Power($p("f"),Plus($p("c",true),Times($p("d",true),$s("x")))),FreeQ(List($s("c"),$s("d"),$s("f")),$s("x")))),MatchQ($s("u"),Condition($($p("f"),Plus($p("c",true),Times($p("d",true),$s("x")))),And(FreeQ(List($s("c"),$s("d")),$s("x")),MemberQ(List($s("Tan"),$s("Cot"),$s("Tanh"),$s("Coth")),$s("f"))))))))),
SetDelayed(Int(Power(E,Plus($p("a",true),Times($p("b",true),$p("x")))),$p("x",$s("Symbol"))),
    Condition(Times(Power(E,Plus($s("a"),Times($s("b"),$s("x")))),Power($s("b"),CN1)),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(Power($p("f"),Plus($p("a",true),Times($p("b",true),$p("x")))),$p("x",$s("Symbol"))),
    Condition(Times(Power($s("f"),Plus($s("a"),Times($s("b"),$s("x")))),Power(Times($s("b"),Log($s("f"))),CN1)),FreeQ(List($s("a"),$s("b"),$s("f")),$s("x")))),
SetDelayed(Int(Power(E,Plus($p("a",true),Times($p("b",true),Power($p("x"),C2)))),$p("x",$s("Symbol"))),
    Condition(Times(Times(Power(E,$s("a")),Sqrt(Pi)),Times(Erfi(Times($s("x"),Rt($s("b"),C2))),Power(Times(C2,Rt($s("b"),C2)),CN1))),And(FreeQ(List($s("a"),$s("b")),$s("x")),PosQ($s("b"))))),
SetDelayed(Int(Power($p("f"),Plus($p("a",true),Times($p("b",true),Power($p("x"),C2)))),$p("x",$s("Symbol"))),
    Condition(Times(Times(Power($s("f"),$s("a")),Sqrt(Pi)),Times(Erfi(Times($s("x"),Rt(Times($s("b"),Log($s("f"))),C2))),Power(Times(C2,Rt(Times($s("b"),Log($s("f"))),C2)),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("f")),$s("x")),PosQ(Times($s("b"),Log($s("f"))))))),
SetDelayed(Int(Power(E,Plus($p("a",true),Times($p("b",true),Power($p("x"),C2)))),$p("x",$s("Symbol"))),
    Condition(Times(Times(Power(E,$s("a")),Sqrt(Pi)),Times(Erf(Times($s("x"),Rt(Times(CN1,$s("b")),C2))),Power(Times(C2,Rt(Times(CN1,$s("b")),C2)),CN1))),And(FreeQ(List($s("a"),$s("b")),$s("x")),NegQ($s("b"))))),
SetDelayed(Int(Power($p("f"),Plus($p("a",true),Times($p("b",true),Power($p("x"),C2)))),$p("x",$s("Symbol"))),
    Condition(Times(Times(Power($s("f"),$s("a")),Sqrt(Pi)),Times(Erf(Times($s("x"),Rt(Times(Times(CN1,$s("b")),Log($s("f"))),C2))),Power(Times(C2,Rt(Times(Times(CN1,$s("b")),Log($s("f"))),C2)),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("f")),$s("x")),NegQ(Times($s("b"),Log($s("f"))))))),
SetDelayed(Int(Power(E,Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n"))))),$p("x",$s("Symbol"))),
    Condition(Times(Times(Times(CN1,Power(E,$s("a"))),$s("x")),Times(Gamma(Times(C1,Power($s("n"),CN1)),Times(Times(CN1,$s("b")),Power($s("x"),$s("n")))),Power(Times($s("n"),Power(Times(Times(CN1,$s("b")),Power($s("x"),$s("n"))),Times(C1,Power($s("n"),CN1)))),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("n")),$s("x")),Not(FractionOrNegativeQ($s("n")))))),
SetDelayed(Int(Power($p("f"),Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n"))))),$p("x",$s("Symbol"))),
    Condition(Times(Times(Times(CN1,Power($s("f"),$s("a"))),$s("x")),Times(Gamma(Times(C1,Power($s("n"),CN1)),Times(Times(Times(CN1,$s("b")),Power($s("x"),$s("n"))),Log($s("f")))),Power(Times($s("n"),Power(Times(Times(Times(CN1,$s("b")),Power($s("x"),$s("n"))),Log($s("f"))),Times(C1,Power($s("n"),CN1)))),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("f"),$s("n")),$s("x")),Not(FractionOrNegativeQ($s("n")))))),
SetDelayed(Int(Power(E,Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n",true))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times($s("x"),Power(E,Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))))),Times(CN1,Dist(Times($s("b"),$s("n")),Int(Times(Power($s("x"),$s("n")),Power(E,Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))))),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ($s("n"))),Less($s("n"),C0)))),
SetDelayed(Int(Power($p("f"),Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n",true))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times($s("x"),Power($s("f"),Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))))),Times(CN1,Dist(Times(Times($s("b"),$s("n")),Log($s("f"))),Int(Times(Power($s("x"),$s("n")),Power($s("f"),Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))))),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b"),$s("f")),$s("x")),IntegerQ($s("n"))),Less($s("n"),C0)))),
SetDelayed(Int(Times(Power(E,Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n",true))))),Power($p("x"),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Power(E,$s("a")),Times(ExpIntegralEi(Times($s("b"),Power($s("x"),$s("n")))),Power($s("n"),CN1))),FreeQ(List($s("a"),$s("b"),$s("n")),$s("x")))),
SetDelayed(Int(Times(Power($p("f"),Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n",true))))),Power($p("x"),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Power($s("f"),$s("a")),Times(ExpIntegralEi(Times(Times($s("b"),Power($s("x"),$s("n"))),Log($s("f")))),Power($s("n"),CN1))),FreeQ(List($s("a"),$s("b"),$s("f"),$s("n")),$s("x")))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power($p("f"),Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n",true)))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus(Plus($s("m"),Times(CN1,$s("n"))),C1)),Times(Power($s("f"),Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),Power(Times(Times($s("b"),$s("n")),Log($s("f"))),CN1))),Times(CN1,Dist(Times(Plus(Plus($s("m"),Times(CN1,$s("n"))),C1),Power(Times(Times($s("b"),$s("n")),Log($s("f"))),CN1)),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,$s("n")))),Power($s("f"),Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))))),$s("x"))))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("f")),$s("x")),IntegerQ($s("n"))),RationalQ($s("m"))),And(Less(C0,$s("n")),LessEqual($s("n"),$s("m")))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power($p("f"),Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n",true)))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Times(Power($s("f"),Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),Power(Plus($s("m"),C1),CN1))),Times(CN1,Dist(Times(Times($s("b"),$s("n")),Times(Log($s("f")),Power(Plus($s("m"),C1),CN1))),Int(Times(Power($s("x"),Plus($s("m"),$s("n"))),Power($s("f"),Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))))),$s("x"))))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("f")),$s("x")),IntegerQ($s("n"))),RationalQ($s("m"))),Or(And(Greater($s("n"),C0),Less($s("m"),CN1)),And(Less(C0,Times(CN1,$s("n"))),LessEqual(Times(CN1,$s("n")),Plus($s("m"),C1))))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power($p("f"),Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n",true)))))),$p("x",$s("Symbol"))),
    Condition(Times(Times(Times(CN1,Power($s("f"),$s("a"))),Power($s("x"),Plus($s("m"),C1))),Times(Gamma(Times(Plus($s("m"),C1),Power($s("n"),CN1)),Times(Times(Times(CN1,$s("b")),Power($s("x"),$s("n"))),Log($s("f")))),Power(Times($s("n"),Power(Times(Times(Times(CN1,$s("b")),Power($s("x"),$s("n"))),Log($s("f"))),Times(Plus($s("m"),C1),Power($s("n"),CN1)))),CN1))),And(And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("f"),$s("m"),$s("n")),$s("x")),NonzeroQ(Plus($s("m"),C1))),NonzeroQ(Plus(Plus($s("m"),Times(CN1,$s("n"))),C1))),Not(And(SameQ($s("m"),CN1D2),ZeroQ(Plus($s("n"),Times(CN1,C1)))))),Not(And(And(IntegerQ(List($s("m"),$s("n"))),Greater($s("n"),C0)),Or(Less($s("m"),CN1),GreaterEqual($s("m"),$s("n")))))),Not(And(RationalQ(List($s("m"),$s("n"))),Or(FractionQ($s("m")),FractionOrNegativeQ($s("n")))))))),
SetDelayed(Int(Power($p("f"),Plus(Plus($p("a",true),Times($p("b",true),$p("x"))),Times($p("c",true),Power($p("x"),C2)))),$p("x",$s("Symbol"))),
    Condition(Int(Power($s("f"),Times(Power(Plus($s("b"),Times(Times(C2,$s("c")),$s("x"))),C2),Power(Times(C4,$s("c")),CN1))),$s("x")),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("f")),$s("x")),ZeroQ(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c")))))))),
SetDelayed(Int(Power($p("f"),Plus(Plus($p("a",true),Times($p("b",true),$p("x"))),Times($p("c",true),Power($p("x"),C2)))),$p("x",$s("Symbol"))),
    Condition(Times(Power($s("f"),Plus($s("a"),Times(CN1,Times(Power($s("b"),C2),Power(Times(C4,$s("c")),CN1))))),Int(Power($s("f"),Times(Power(Plus($s("b"),Times(Times(C2,$s("c")),$s("x"))),C2),Power(Times(C4,$s("c")),CN1))),$s("x"))),FreeQ(List($s("a"),$s("b"),$s("c"),$s("f")),$s("x")))),
SetDelayed(Int(Times(Plus($p("d",true),Times($p("e",true),$p("x"))),Power($p("f"),Plus(Plus($p("a",true),Times($p("b",true),$p("x"))),Times($p("c",true),Power($p("x"),C2))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times($s("e"),Times(Power($s("f"),Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2)))),Power(Times(Times(C2,$s("c")),Log($s("f"))),CN1))),Times(CN1,Dist(Times(Plus(Times($s("b"),$s("e")),Times(CN1,Times(Times(C2,$s("c")),$s("d")))),Power(Times(C2,$s("c")),CN1)),Int(Power($s("f"),Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2)))),$s("x"))))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e"),$s("f")),$s("x")),NonzeroQ(Plus(Times($s("b"),$s("e")),Times(CN1,Times(Times(C2,$s("c")),$s("d")))))))),
SetDelayed(Int(Times(Power(Plus($p("d",true),Times($p("e",true),$p("x"))),$p("m")),Power($p("f"),Plus(Plus($p("a",true),Times($p("b",true),$p("x"))),Times($p("c",true),Power($p("x"),C2))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times($s("e"),Power(Plus($s("d"),Times($s("e"),$s("x"))),Plus($s("m"),Times(CN1,C1)))),Times(Power($s("f"),Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2)))),Power(Times(Times(C2,$s("c")),Log($s("f"))),CN1))),Times(CN1,Dist(Times(Plus($s("m"),Times(CN1,C1)),Times(Power($s("e"),C2),Power(Times(Times(C2,$s("c")),Log($s("f"))),CN1))),Int(Times(Power(Plus($s("d"),Times($s("e"),$s("x"))),Plus($s("m"),Times(CN1,C2))),Power($s("f"),Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))))),$s("x"))))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e"),$s("f")),$s("x")),RationalQ($s("m"))),Greater($s("m"),C1)),ZeroQ(Plus(Times($s("b"),$s("e")),Times(CN1,Times(Times(C2,$s("c")),$s("d")))))))),
SetDelayed(Int(Times(Power(Plus($p("d",true),Times($p("e",true),$p("x"))),$p("m")),Power($p("f"),Plus(Plus($p("a",true),Times($p("b",true),$p("x"))),Times($p("c",true),Power($p("x"),C2))))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times($s("e"),Power(Plus($s("d"),Times($s("e"),$s("x"))),Plus($s("m"),Times(CN1,C1)))),Times(Power($s("f"),Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2)))),Power(Times(Times(C2,$s("c")),Log($s("f"))),CN1))),Times(CN1,Dist(Times(Plus(Times($s("b"),$s("e")),Times(CN1,Times(Times(C2,$s("c")),$s("d")))),Power(Times(C2,$s("c")),CN1)),Int(Times(Power(Plus($s("d"),Times($s("e"),$s("x"))),Plus($s("m"),Times(CN1,C1))),Power($s("f"),Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))))),$s("x"))))),Times(CN1,Dist(Times(Plus($s("m"),Times(CN1,C1)),Times(Power($s("e"),C2),Power(Times(Times(C2,$s("c")),Log($s("f"))),CN1))),Int(Times(Power(Plus($s("d"),Times($s("e"),$s("x"))),Plus($s("m"),Times(CN1,C2))),Power($s("f"),Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))))),$s("x"))))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e"),$s("f")),$s("x")),RationalQ($s("m"))),Greater($s("m"),C1)),NonzeroQ(Plus(Times($s("b"),$s("e")),Times(CN1,Times(Times(C2,$s("c")),$s("d")))))))),
SetDelayed(Int(Times(Power(Plus($p("d",true),Times($p("e",true),$p("x"))),$p("m")),Power($p("f"),Plus(Plus($p("a",true),Times($p("b",true),$p("x"))),Times($p("c",true),Power($p("x"),C2))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power(Plus($s("d"),Times($s("e"),$s("x"))),Plus($s("m"),C1)),Times(Power($s("f"),Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2)))),Power(Times($s("e"),Plus($s("m"),C1)),CN1))),Times(CN1,Dist(Times(Times(C2,$s("c")),Times(Log($s("f")),Power(Times(Power($s("e"),C2),Plus($s("m"),C1)),CN1))),Int(Times(Power(Plus($s("d"),Times($s("e"),$s("x"))),Plus($s("m"),C2)),Power($s("f"),Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))))),$s("x"))))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e"),$s("f")),$s("x")),RationalQ($s("m"))),Less($s("m"),CN1)),ZeroQ(Plus(Times($s("b"),$s("e")),Times(CN1,Times(Times(C2,$s("c")),$s("d")))))))),
SetDelayed(Int(Times(Power(Plus($p("d",true),Times($p("e",true),$p("x"))),$p("m")),Power($p("f"),Plus(Plus($p("a",true),Times($p("b",true),$p("x"))),Times($p("c",true),Power($p("x"),C2))))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Power(Plus($s("d"),Times($s("e"),$s("x"))),Plus($s("m"),C1)),Times(Power($s("f"),Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2)))),Power(Times($s("e"),Plus($s("m"),C1)),CN1))),Times(CN1,Dist(Times(Plus(Times($s("b"),$s("e")),Times(CN1,Times(Times(C2,$s("c")),$s("d")))),Times(Log($s("f")),Power(Times(Power($s("e"),C2),Plus($s("m"),C1)),CN1))),Int(Times(Power(Plus($s("d"),Times($s("e"),$s("x"))),Plus($s("m"),C1)),Power($s("f"),Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))))),$s("x"))))),Times(CN1,Dist(Times(Times(C2,$s("c")),Times(Log($s("f")),Power(Times(Power($s("e"),C2),Plus($s("m"),C1)),CN1))),Int(Times(Power(Plus($s("d"),Times($s("e"),$s("x"))),Plus($s("m"),C2)),Power($s("f"),Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))))),$s("x"))))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e"),$s("f")),$s("x")),RationalQ($s("m"))),Less($s("m"),CN1)),NonzeroQ(Plus(Times($s("b"),$s("e")),Times(CN1,Times(Times(C2,$s("c")),$s("d")))))))),
SetDelayed(Int(Times(Power(Plus($p("a",true),Times($p("b",true),$p("x"))),$p("m")),Power($p("f"),Power(Plus($p("c",true),Times($p("d",true),$p("x"))),$p("n",true)))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power(Plus($s("a"),Times($s("b"),$s("x"))),Plus($s("m"),C1)),Times(Power($s("f"),Power(Plus($s("c"),Times($s("d"),$s("x"))),$s("n"))),Power(Times($s("b"),Plus($s("m"),C1)),CN1))),Times(CN1,Dist(Times(Times($s("d"),$s("n")),Times(Log($s("f")),Power(Times($s("b"),Plus($s("m"),C1)),CN1))),Int(Times(Times(Power(Plus($s("a"),Times($s("b"),$s("x"))),Plus($s("m"),C1)),Power($s("f"),Power(Plus($s("c"),Times($s("d"),$s("x"))),$s("n")))),Power(Plus($s("c"),Times($s("d"),$s("x"))),Plus($s("n"),Times(CN1,C1)))),$s("x"))))),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),RationalQ($s("m"))),Less($s("m"),CN1)),IntegerQ($s("n"))),Greater($s("n"),C1)))),
SetDelayed(Int(Times(C1,Power(Plus($p("a"),Times($p("b",true),Power($p("f"),Plus($p("c",true),Times($p("d",true),$p("x")))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Times(CN1,Log(Plus($s("b"),Times($s("a"),Power($s("f"),Plus(Times(CN1,$s("c")),Times(CN1,Times($s("d"),$s("x"))))))))),Power(Times(Times($s("a"),$s("d")),Log($s("f"))),CN1)),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("f")),$s("x")),NegativeCoefficientQ($s("d"))))),
SetDelayed(Int(Times(C1,Power(Plus($p("a"),Times($p("b",true),Power($p("f"),Plus($p("c",true),Times($p("d",true),$p("x")))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Times($s("x"),Power($s("a"),CN1)),Times(CN1,Times(Log(Plus($s("a"),Times($s("b"),Power($s("f"),Plus($s("c"),Times($s("d"),$s("x"))))))),Power(Times(Times($s("a"),$s("d")),Log($s("f"))),CN1)))),FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("f")),$s("x")))),
SetDelayed(Int(Times(C1,Power(Sqrt(Plus($p("a"),Times($p("b",true),Power($p("f"),Plus($p("c",true),Times($p("d",true),$p("x"))))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(integer(-2L),Times(ArcTanh(Times(Sqrt(Plus($s("a"),Times($s("b"),Power($s("f"),Plus($s("c"),Times($s("d"),$s("x"))))))),Power(Sqrt($s("a")),CN1))),Power(Times(Times(Sqrt($s("a")),$s("d")),Log($s("f"))),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("f")),$s("x")),PosQ($s("a"))))),
SetDelayed(Int(Times(C1,Power(Sqrt(Plus($p("a"),Times($p("b",true),Power($p("f"),Plus($p("c",true),Times($p("d",true),$p("x"))))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(C2,Times(ArcTan(Times(Sqrt(Plus($s("a"),Times($s("b"),Power($s("f"),Plus($s("c"),Times($s("d"),$s("x"))))))),Power(Sqrt(Times(CN1,$s("a"))),CN1))),Power(Times(Times(Sqrt(Times(CN1,$s("a"))),$s("d")),Log($s("f"))),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("f")),$s("x")),NegQ($s("a"))))),
SetDelayed(Int(Power(Plus($p("a"),Times($p("b",true),Power($p("f"),Plus($p("c",true),Times($p("d",true),$p("x")))))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power(Plus($s("a"),Times($s("b"),Power($s("f"),Plus($s("c"),Times($s("d"),$s("x")))))),$s("n")),Power(Times(Times($s("n"),$s("d")),Log($s("f"))),CN1)),Dist($s("a"),Int(Power(Plus($s("a"),Times($s("b"),Power($s("f"),Plus($s("c"),Times($s("d"),$s("x")))))),Plus($s("n"),Times(CN1,C1))),$s("x")))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("f")),$s("x")),FractionQ($s("n"))),Greater($s("n"),C0)))),
SetDelayed(Int(Power(Plus($p("a"),Times($p("b",true),Power($p("f"),Plus($p("c",true),Times($p("d",true),$p("x")))))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Power(Plus($s("a"),Times($s("b"),Power($s("f"),Plus($s("c"),Times($s("d"),$s("x")))))),Plus($s("n"),C1))),Power(Times(Times(Times(Plus($s("n"),C1),$s("a")),$s("d")),Log($s("f"))),CN1)),Dist(Times(C1,Power($s("a"),CN1)),Int(Power(Plus($s("a"),Times($s("b"),Power($s("f"),Plus($s("c"),Times($s("d"),$s("x")))))),Plus($s("n"),C1)),$s("x")))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("f")),$s("x")),RationalQ($s("n"))),Less($s("n"),CN1)))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Plus($p("a"),Times($p("b",true),Power($p("f"),Plus($p("c",true),Times($p("d",true),$p("x")))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Power(Times($s("a"),Plus($s("m"),C1)),CN1)),Times(CN1,Dist(Times($s("b"),Power($s("a"),CN1)),Int(Times(Power($s("x"),$s("m")),Times(Power($s("f"),Plus($s("c"),Times($s("d"),$s("x")))),Power(Plus($s("a"),Times($s("b"),Power($s("f"),Plus($s("c"),Times($s("d"),$s("x")))))),CN1))),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("f")),$s("x")),RationalQ($s("m"))),Greater($s("m"),C0)))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Plus($p("a"),Times($p("b",true),Power($p("f"),Plus($p("c",true),Times($p("d",true),$p("x")))))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Module(List(Set($s("u"),Block(List(Set($s("ShowSteps"),False),Set($s("StepCounter"),$s("Null"))),Int(Power(Plus($s("a"),Times($s("b"),Power($s("f"),Plus($s("c"),Times($s("d"),$s("x")))))),$s("n")),$s("x"))))),Plus(Times(Power($s("x"),$s("m")),$s("u")),Times(CN1,Dist($s("m"),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,C1))),$s("u")),$s("x")))))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("f")),$s("x")),RationalQ(List($s("m"),$s("n")))),Greater($s("m"),C0)),Less($s("n"),CN1)))),
SetDelayed(Int(Times(Power($p("x"),$p("m")),Power($p("f"),Times($p("c",true),Power(Plus($p("a"),Times($p("b",true),$p("x"))),C2)))),$p("x",$s("Symbol"))),
    Condition(Int(Times(Power($s("x"),$s("m")),Power($s("f"),Plus(Plus(Times(Power($s("a"),C2),$s("c")),Times(Times(Times(Times(C2,$s("a")),$s("b")),$s("c")),$s("x"))),Times(Times(Power($s("b"),C2),$s("c")),Power($s("x"),C2))))),$s("x")),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("f")),$s("x")),FractionQ($s("m"))),Greater($s("m"),C1)))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power($p("f"),Times($p("c",true),Power(Plus($p("a"),Times($p("b",true),$p("x"))),$p("n"))))),$p("x",$s("Symbol"))),
    Condition(Plus(Dist(Times(C1,Power(Power($s("b"),$s("m")),CN1)),Int(Times(Expand(Plus(Times(Power($s("b"),$s("m")),Power($s("x"),$s("m"))),Times(CN1,Power(Plus($s("a"),Times($s("b"),$s("x"))),$s("m")))),$s("x")),Power($s("f"),Times($s("c"),Power(Plus($s("a"),Times($s("b"),$s("x"))),$s("n"))))),$s("x"))),Dist(Times(C1,Power(Power($s("b"),Plus($s("m"),C1)),CN1)),Subst(Int(Times(Power($s("x"),$s("m")),Power($s("f"),Times($s("c"),Power($s("x"),$s("n"))))),$s("x")),$s("x"),Plus($s("a"),Times($s("b"),$s("x")))))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("f"),$s("n")),$s("x")),IntegerQ($s("m"))),Greater($s("m"),C0)))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Times(Power($p("f"),Plus($p("c",true),Times($p("d",true),$p("x")))),Power(Plus($p("a"),Times($p("b",true),Power($p("f"),Plus($p("c",true),Times($p("d",true),$p("x")))))),CN1))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),$s("m")),Times(Log(Plus(C1,Times($s("b"),Times(Power($s("f"),Plus($s("c"),Times($s("d"),$s("x")))),Power($s("a"),CN1))))),Power(Times(Times($s("b"),$s("d")),Log($s("f"))),CN1))),Times(CN1,Dist(Times($s("m"),Power(Times(Times($s("b"),$s("d")),Log($s("f"))),CN1)),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,C1))),Log(Plus(C1,Times(Times($s("b"),Power($s("a"),CN1)),Power($s("f"),Plus($s("c"),Times($s("d"),$s("x")))))))),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("f")),$s("x")),RationalQ($s("m"))),Greater($s("m"),C0)))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Times(Power($p("f"),Plus($p("c",true),Times($p("d",true),$p("x")))),Power(Plus($p("a",true),Times($p("b",true),Power($p("f"),$p("v")))),CN1))),$p("x",$s("Symbol"))),
    Condition(Module(List(Set($s("u"),Block(List(Set($s("ShowSteps"),False),Set($s("StepCounter"),$s("Null"))),Int(Times(Power($s("f"),Plus($s("c"),Times($s("d"),$s("x")))),Power(Plus($s("a"),Times($s("b"),Power($s("f"),$s("v")))),CN1)),$s("x"))))),Plus(Times(Power($s("x"),$s("m")),$s("u")),Times(CN1,Dist($s("m"),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,C1))),$s("u")),$s("x")))))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("f")),$s("x")),ZeroQ(Plus(Times(C2,Plus($s("c"),Times($s("d"),$s("x")))),Times(CN1,$s("v"))))),RationalQ($s("m"))),Greater($s("m"),C0)))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Plus(Times($p("a",true),Power($p("f"),Plus($p("c",true),Times($p("d",true),$p("x"))))),Times($p("b",true),Power($p("f"),$p("v")))),CN1)),$p("x",$s("Symbol"))),
    Condition(Module(List(Set($s("u"),Block(List(Set($s("ShowSteps"),False),Set($s("StepCounter"),$s("Null"))),Int(Times(C1,Power(Plus(Times($s("a"),Power($s("f"),Plus($s("c"),Times($s("d"),$s("x"))))),Times($s("b"),Power($s("f"),$s("v")))),CN1)),$s("x"))))),Plus(Times(Power($s("x"),$s("m")),$s("u")),Times(CN1,Dist($s("m"),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,C1))),$s("u")),$s("x")))))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("f")),$s("x")),ZeroQ(Plus(Plus($s("c"),Times($s("d"),$s("x"))),$s("v")))),RationalQ($s("m"))),Greater($s("m"),C0)))),
SetDelayed(Int(Log(Plus(C1,Times($p("c",true),Power($p("f"),Plus($p("a",true),Times($p("b",true),$p("x"))))))),$p("x",$s("Symbol"))),
    Condition(Times(Times(CN1,PolyLog(C2,Times(Times(CN1,$s("c")),Power($s("f"),Plus($s("a"),Times($s("b"),$s("x"))))))),Power(Times($s("b"),Log($s("f"))),CN1)),FreeQ(List($s("a"),$s("b"),$s("c"),$s("f")),$s("x")))),
SetDelayed(Int(Log(Plus($p("c"),Times($p("d",true),Power($p("f"),Plus($p("a",true),Times($p("b",true),$p("x"))))))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times($s("x"),Log(Plus($s("c"),Times($s("d"),Power($s("f"),Plus($s("a"),Times($s("b"),$s("x")))))))),Times(CN1,Times($s("x"),Log(Plus(C1,Times(Times($s("d"),Power($s("c"),CN1)),Power($s("f"),Plus($s("a"),Times($s("b"),$s("x")))))))))),Int(Log(Plus(C1,Times(Times($s("d"),Power($s("c"),CN1)),Power($s("f"),Plus($s("a"),Times($s("b"),$s("x"))))))),$s("x"))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("f")),$s("x")),NonzeroQ(Plus($s("c"),Times(CN1,C1)))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Log(Plus(C1,Times($p("c",true),Power($p("f"),Plus($p("a",true),Times($p("b",true),$p("x")))))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Power($s("x"),$s("m"))),Times(PolyLog(C2,Times(Times(CN1,$s("c")),Power($s("f"),Plus($s("a"),Times($s("b"),$s("x")))))),Power(Times($s("b"),Log($s("f"))),CN1))),Dist(Times($s("m"),Power(Times($s("b"),Log($s("f"))),CN1)),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,C1))),PolyLog(C2,Times(Times(CN1,$s("c")),Power($s("f"),Plus($s("a"),Times($s("b"),$s("x"))))))),$s("x")))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("f")),$s("x")),RationalQ($s("m"))),Greater($s("m"),C0)))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Log(Plus($p("c"),Times($p("d",true),Power($p("f"),Plus($p("a",true),Times($p("b",true),$p("x")))))))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Times(Log(Plus($s("c"),Times($s("d"),Power($s("f"),Plus($s("a"),Times($s("b"),$s("x"))))))),Power(Plus($s("m"),C1),CN1))),Times(CN1,Times(Power($s("x"),Plus($s("m"),C1)),Times(Log(Plus(C1,Times(Times($s("d"),Power($s("c"),CN1)),Power($s("f"),Plus($s("a"),Times($s("b"),$s("x"))))))),Power(Plus($s("m"),C1),CN1))))),Int(Times(Power($s("x"),$s("m")),Log(Plus(C1,Times(Times($s("d"),Power($s("c"),CN1)),Power($s("f"),Plus($s("a"),Times($s("b"),$s("x")))))))),$s("x"))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("f")),$s("x")),NonzeroQ(Plus($s("c"),Times(CN1,C1)))),RationalQ($s("m"))),Greater($s("m"),C0)))),
SetDelayed(Int(PolyLog($p("n"),Times($p("c",true),Power($p("f"),Plus($p("a",true),Times($p("b",true),$p("x")))))),$p("x",$s("Symbol"))),
    Condition(Times(PolyLog(Plus($s("n"),C1),Times($s("c"),Power($s("f"),Plus($s("a"),Times($s("b"),$s("x")))))),Power(Times($s("b"),Log($s("f"))),CN1)),FreeQ(List($s("a"),$s("b"),$s("c"),$s("n")),$s("x")))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),PolyLog($p("n"),Times($p("c",true),Power($p("f"),Plus($p("a",true),Times($p("b",true),$p("x"))))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),$s("m")),Times(PolyLog(Plus($s("n"),C1),Times($s("c"),Power($s("f"),Plus($s("a"),Times($s("b"),$s("x")))))),Power(Times($s("b"),Log($s("f"))),CN1))),Times(CN1,Dist(Times($s("m"),Power(Times($s("b"),Log($s("f"))),CN1)),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,C1))),PolyLog(Plus($s("n"),C1),Times($s("c"),Power($s("f"),Plus($s("a"),Times($s("b"),$s("x"))))))),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("n")),$s("x")),RationalQ($s("m"))),Greater($s("m"),C0)))),
SetDelayed(Int(ArcTanh(Times($p("b",true),Power($p("f"),Plus($p("c",true),Times($p("d",true),$p("x")))))),$p("x",$s("Symbol"))),
    Condition(Plus(Dist(C1D2,Int(Log(Plus(C1,Times($s("b"),Power($s("f"),Plus($s("c"),Times($s("d"),$s("x"))))))),$s("x"))),Times(CN1,Dist(C1D2,Int(Log(Plus(C1,Times(CN1,Times($s("b"),Power($s("f"),Plus($s("c"),Times($s("d"),$s("x")))))))),$s("x"))))),FreeQ(List($s("b"),$s("c"),$s("d"),$s("f")),$s("x")))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),ArcTanh(Times($p("b",true),Power($p("f"),Plus($p("c",true),Times($p("d",true),$p("x"))))))),$p("x",$s("Symbol"))),
    Condition(Plus(Dist(C1D2,Int(Times(Power($s("x"),$s("m")),Log(Plus(C1,Times($s("b"),Power($s("f"),Plus($s("c"),Times($s("d"),$s("x")))))))),$s("x"))),Times(CN1,Dist(C1D2,Int(Times(Power($s("x"),$s("m")),Log(Plus(C1,Times(CN1,Times($s("b"),Power($s("f"),Plus($s("c"),Times($s("d"),$s("x"))))))))),$s("x"))))),And(And(FreeQ(List($s("b"),$s("c"),$s("d"),$s("f")),$s("x")),IntegerQ($s("m"))),Greater($s("m"),C0)))),
SetDelayed(Int(ArcCoth(Times($p("b",true),Power($p("f"),Plus($p("c",true),Times($p("d",true),$p("x")))))),$p("x",$s("Symbol"))),
    Condition(Plus(Dist(C1D2,Int(Log(Plus(C1,Times(C1,Power(Times($s("b"),Power($s("f"),Plus($s("c"),Times($s("d"),$s("x"))))),CN1)))),$s("x"))),Times(CN1,Dist(C1D2,Int(Log(Plus(C1,Times(CN1,Times(C1,Power(Times($s("b"),Power($s("f"),Plus($s("c"),Times($s("d"),$s("x"))))),CN1))))),$s("x"))))),FreeQ(List($s("b"),$s("c"),$s("d"),$s("f")),$s("x")))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),ArcCoth(Times($p("b",true),Power($p("f"),Plus($p("c",true),Times($p("d",true),$p("x"))))))),$p("x",$s("Symbol"))),
    Condition(Plus(Dist(C1D2,Int(Times(Power($s("x"),$s("m")),Log(Plus(C1,Times(C1,Power(Times($s("b"),Power($s("f"),Plus($s("c"),Times($s("d"),$s("x"))))),CN1))))),$s("x"))),Times(CN1,Dist(C1D2,Int(Times(Power($s("x"),$s("m")),Log(Plus(C1,Times(CN1,Times(C1,Power(Times($s("b"),Power($s("f"),Plus($s("c"),Times($s("d"),$s("x"))))),CN1)))))),$s("x"))))),And(And(FreeQ(List($s("b"),$s("c"),$s("d"),$s("f")),$s("x")),IntegerQ($s("m"))),Greater($s("m"),C0)))),
SetDelayed(Int(ArcTan(Times($p("b",true),Power($p("f"),Plus($p("c",true),Times($p("d",true),$p("x")))))),$p("x",$s("Symbol"))),
    Condition(Plus(Dist(Times(CI,C1D2),Int(Log(Plus(C1,Times(CN1,Times(Times($s("b"),CI),Power($s("f"),Plus($s("c"),Times($s("d"),$s("x")))))))),$s("x"))),Times(CN1,Dist(Times(CI,C1D2),Int(Log(Plus(C1,Times(Times($s("b"),CI),Power($s("f"),Plus($s("c"),Times($s("d"),$s("x"))))))),$s("x"))))),FreeQ(List($s("b"),$s("c"),$s("d"),$s("f")),$s("x")))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),ArcTan(Plus($p("a",true),Times($p("b",true),Power($p("f"),Plus($p("c",true),Times($p("d",true),$p("x")))))))),$p("x",$s("Symbol"))),
    Condition(Plus(Dist(Times(CI,C1D2),Int(Times(Power($s("x"),$s("m")),Log(Plus(Plus(C1,Times(CN1,Times($s("a"),CI))),Times(CN1,Times(Times($s("b"),CI),Power($s("f"),Plus($s("c"),Times($s("d"),$s("x"))))))))),$s("x"))),Times(CN1,Dist(Times(CI,C1D2),Int(Times(Power($s("x"),$s("m")),Log(Plus(Plus(C1,Times($s("a"),CI)),Times(Times($s("b"),CI),Power($s("f"),Plus($s("c"),Times($s("d"),$s("x")))))))),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("f")),$s("x")),IntegerQ($s("m"))),Greater($s("m"),C0)))),
SetDelayed(Int(ArcCot(Times($p("b",true),Power($p("f"),Plus($p("c",true),Times($p("d",true),$p("x")))))),$p("x",$s("Symbol"))),
    Condition(Plus(Dist(Times(CI,C1D2),Int(Log(Plus(C1,Times(CN1,Times(CI,Power(Times($s("b"),Power($s("f"),Plus($s("c"),Times($s("d"),$s("x"))))),CN1))))),$s("x"))),Times(CN1,Dist(Times(CI,C1D2),Int(Log(Plus(C1,Times(CI,Power(Times($s("b"),Power($s("f"),Plus($s("c"),Times($s("d"),$s("x"))))),CN1)))),$s("x"))))),FreeQ(List($s("b"),$s("c"),$s("d"),$s("f")),$s("x")))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),ArcCot(Plus($p("a",true),Times($p("b",true),Power($p("f"),Plus($p("c",true),Times($p("d",true),$p("x")))))))),$p("x",$s("Symbol"))),
    Condition(Plus(Dist(Times(CI,C1D2),Int(Times(Power($s("x"),$s("m")),Log(Plus(C1,Times(CN1,Times(CI,Power(Plus($s("a"),Times($s("b"),Power($s("f"),Plus($s("c"),Times($s("d"),$s("x")))))),CN1)))))),$s("x"))),Times(CN1,Dist(Times(CI,C1D2),Int(Times(Power($s("x"),$s("m")),Log(Plus(C1,Times(CI,Power(Plus($s("a"),Times($s("b"),Power($s("f"),Plus($s("c"),Times($s("d"),$s("x")))))),CN1))))),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("f")),$s("x")),IntegerQ($s("m"))),Greater($s("m"),C0)))),
SetDelayed(Int(Times(Power(Plus($p("a",true),Times($p("b",true),$p("x"))),$p("m",true)),Power(Power($p("f"),Times($p("e",true),Power(Plus($p("c",true),Times($p("d",true),$p("x"))),$p("n",true)))),$p("p",true))),$p("x",$s("Symbol"))),
    Condition(Dist(Times(C1,Power($s("b"),CN1)),Subst(Int(Times(Power($s("x"),$s("m")),Power(Power($s("f"),Times($s("e"),Power(Plus(Plus($s("c"),Times(CN1,Times($s("a"),Times($s("d"),Power($s("b"),CN1))))),Times($s("d"),Times($s("x"),Power($s("b"),CN1)))),$s("n")))),$s("p"))),$s("x")),$s("x"),Plus($s("a"),Times($s("b"),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e"),$s("f"),$s("m"),$s("n")),$s("x")),RationalQ($s("p"))),Not(And(SameQ($s("a"),C0),SameQ($s("b"),C1)))))),
SetDelayed(Int(Power($p("f"),Times(Plus($p("a",true),Times($p("b",true),Power($p("x"),C4))),Power(Power($p("x"),C2),CN1))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(Sqrt(Pi),Exp(Times(Times(C2,Sqrt(Times(Times(CN1,$s("a")),Log($s("f"))))),Sqrt(Times(Times(CN1,$s("b")),Log($s("f"))))))),Times(Erf(Times(Plus(Sqrt(Times(Times(CN1,$s("a")),Log($s("f")))),Times(Sqrt(Times(Times(CN1,$s("b")),Log($s("f")))),Power($s("x"),C2))),Power($s("x"),CN1))),Power(Times(C4,Sqrt(Times(Times(CN1,$s("b")),Log($s("f"))))),CN1))),Times(CN1,Times(Times(Sqrt(Pi),Exp(Times(Times(integer(-2L),Sqrt(Times(Times(CN1,$s("a")),Log($s("f"))))),Sqrt(Times(Times(CN1,$s("b")),Log($s("f"))))))),Times(Erf(Times(Plus(Sqrt(Times(Times(CN1,$s("a")),Log($s("f")))),Times(CN1,Times(Sqrt(Times(Times(CN1,$s("b")),Log($s("f")))),Power($s("x"),C2)))),Power($s("x"),CN1))),Power(Times(C4,Sqrt(Times(Times(CN1,$s("b")),Log($s("f"))))),CN1))))),FreeQ(List($s("a"),$s("b"),$s("f")),$s("x")))),
SetDelayed(Int(Times(C1,Power(Plus(Plus($p("a"),Times($p("b",true),Power($p("f"),$p("u")))),Times($p("c",true),Power($p("f"),$p("v")))),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Times($s("x"),Power($s("a"),CN1)),Times(CN1,Dist(Times(C1,Power($s("a"),CN1)),Int(Times(Power($s("f"),$s("u")),Times(Plus($s("b"),Times($s("c"),Power($s("f"),$s("u")))),Power(Plus(Plus($s("a"),Times($s("b"),Power($s("f"),$s("u")))),Times($s("c"),Power($s("f"),$s("v")))),CN1))),$s("x"))))),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("f")),$s("x")),LinearQ($s("u"),$s("x"))),LinearQ($s("v"),$s("x"))),ZeroQ(Plus(Times(C2,$s("u")),Times(CN1,$s("v"))))),Not(RationalQ(Rt(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c")))),C2)))))),
SetDelayed(Int(Times(Plus($p("d"),Times($p("e",true),Power($p("f"),$p("u")))),Power(Plus(Plus($p("a"),Times($p("b",true),Power($p("f"),$p("u")))),Times($p("c",true),Power($p("f"),$p("v")))),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Times($s("d"),Times($s("x"),Power($s("a"),CN1))),Times(CN1,Dist(Times(C1,Power($s("a"),CN1)),Int(Times(Power($s("f"),$s("u")),Times(Plus(Plus(Times($s("b"),$s("d")),Times(CN1,Times($s("a"),$s("e")))),Times(Times($s("c"),$s("d")),Power($s("f"),$s("u")))),Power(Plus(Plus($s("a"),Times($s("b"),Power($s("f"),$s("u")))),Times($s("c"),Power($s("f"),$s("v")))),CN1))),$s("x"))))),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e"),$s("f")),$s("x")),LinearQ($s("u"),$s("x"))),LinearQ($s("v"),$s("x"))),ZeroQ(Plus(Times(C2,$s("u")),Times(CN1,$s("v"))))),Not(RationalQ(Rt(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c")))),C2)))))),
SetDelayed(Int(Times($p("u"),Power(Plus(Plus($p("a"),Times($p("b",true),Power($p("f"),$p("v")))),Times($p("c",true),Power($p("f"),$p("w")))),CN1)),$p("x",$s("Symbol"))),
    Condition(Int(Times($s("u"),Times(Power($s("f"),$s("v")),Power(Plus(Plus($s("c"),Times($s("a"),Power($s("f"),$s("v")))),Times($s("b"),Power($s("f"),Times(C2,$s("v"))))),CN1))),$s("x")),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("f")),$s("x")),LinearQ($s("v"),$s("x"))),LinearQ($s("w"),$s("x"))),ZeroQ(Plus($s("v"),$s("w")))),If(RationalQ(Coefficient($s("v"),$s("x"),C1)),Greater(Coefficient($s("v"),$s("x"),C1),C0),Less(LeafCount($s("v")),LeafCount($s("w"))))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Plus(Power(E,$p("x")),Power($p("x"),$p("m",true))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(CN1,Power(Plus(Power(E,$s("x")),Power($s("x"),$s("m"))),Plus($s("n"),C1))),Power(Plus($s("n"),C1),CN1)),Int(Power(Plus(Power(E,$s("x")),Power($s("x"),$s("m"))),Plus($s("n"),C1)),$s("x"))),Dist($s("m"),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,C1))),Power(Plus(Power(E,$s("x")),Power($s("x"),$s("m"))),$s("n"))),$s("x")))),And(And(RationalQ(List($s("m"),$s("n"))),Greater($s("m"),C0)),NonzeroQ(Plus($s("n"),C1))))),
SetDelayed(Int(Sin(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("x",$s("Symbol"))),
    Condition(Times(Times(CN1,Cos(Plus($s("a"),Times($s("b"),$s("x"))))),Power($s("b"),CN1)),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(Power(Sin(Plus($p("a",true),Times($p("b",true),$p("x")))),C2),$p("x",$s("Symbol"))),
    Condition(Plus(Times($s("x"),C1D2),Times(CN1,Times(Cos(Plus($s("a"),Times($s("b"),$s("x")))),Times(Sin(Plus($s("a"),Times($s("b"),$s("x")))),Power(Times(C2,$s("b")),CN1))))),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(Power(Sin(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Dist(Times(CN1,Power($s("b"),CN1)),Subst(Int(Regularize(Power(Plus(C1,Times(CN1,Power($s("x"),C2))),Times(Plus($s("n"),Times(CN1,C1)),C1D2)),$s("x")),$s("x")),$s("x"),Cos(Plus($s("a"),Times($s("b"),$s("x")))))),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),OddQ($s("n"))),Greater($s("n"),C1)))),
SetDelayed(Int(Power(Times($p("c",true),Sin(Plus($p("a",true),Times($p("b",true),$p("x"))))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(Times(CN1,$s("c")),Cos(Plus($s("a"),Times($s("b"),$s("x"))))),Times(Power(Times($s("c"),Sin(Plus($s("a"),Times($s("b"),$s("x"))))),Plus($s("n"),Times(CN1,C1))),Power(Times($s("b"),$s("n")),CN1))),Dist(Times(Plus($s("n"),Times(CN1,C1)),Times(Power($s("c"),C2),Power($s("n"),CN1))),Int(Power(Times($s("c"),Sin(Plus($s("a"),Times($s("b"),$s("x"))))),Plus($s("n"),Times(CN1,C2))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),RationalQ($s("n"))),Greater($s("n"),C1)),Not(OddQ($s("n")))))),
SetDelayed(Int(Power(Times($p("c",true),Sin(Plus($p("a",true),Times($p("b",true),$p("x"))))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Cos(Plus($s("a"),Times($s("b"),$s("x")))),Times(Power(Times($s("c"),Sin(Plus($s("a"),Times($s("b"),$s("x"))))),Plus($s("n"),C1)),Power(Times(Times($s("c"),$s("b")),Plus($s("n"),C1)),CN1))),Dist(Times(Plus($s("n"),C2),Power(Times(Plus($s("n"),C1),Power($s("c"),C2)),CN1)),Int(Power(Times($s("c"),Sin(Plus($s("a"),Times($s("b"),$s("x"))))),Plus($s("n"),C2)),$s("x")))),And(And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),RationalQ($s("n"))),Less($s("n"),CN1)))),
SetDelayed(Int(Power(Times($p("c"),Sin(Plus($p("a",true),Times($p("b",true),$p("x"))))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Times(Times(Power(Times($s("c"),Sin(Plus($s("a"),Times($s("b"),$s("x"))))),$s("n")),Power(Power(Sin(Plus($s("a"),Times($s("b"),$s("x")))),$s("n")),CN1)),Int(Power(Sin(Plus($s("a"),Times($s("b"),$s("x")))),$s("n")),$s("x"))),And(And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),RationalQ($s("n"))),Less(Less(CN1,$s("n")),C1)))),
SetDelayed(Int(Times(C1,Power(Plus($p("a"),Times($p("b",true),Sin(Plus($p("c",true),Times($p("d",true),$p("x")))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Times(CN1,Cos(Plus($s("c"),Times($s("d"),$s("x"))))),Power(Times($s("d"),Plus($s("b"),Times($s("a"),Sin(Plus($s("c"),Times($s("d"),$s("x"))))))),CN1)),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),ZeroQ(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))))))),
SetDelayed(Int(Times(C1,Power(Plus($p("a"),Times($p("b",true),Sin(Plus($p("c",true),Times($p("d",true),$p("x")))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(C2,Times(ArcTan(Times(Plus($s("b"),Times($s("a"),Tan(Times(Plus($s("c"),Times($s("d"),$s("x"))),C1D2)))),Power(Rt(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))),C2),CN1))),Power(Times($s("d"),Rt(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))),C2)),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),PosQ(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))))))),
SetDelayed(Int(Times(C1,Power(Plus($p("a"),Times($p("b",true),Sin(Plus($p("c",true),Times($p("d",true),$p("x")))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(integer(-2L),Times(ArcTanh(Times(Plus($s("b"),Times($s("a"),Tan(Times(Plus($s("c"),Times($s("d"),$s("x"))),C1D2)))),Power(Rt(Plus(Power($s("b"),C2),Times(CN1,Power($s("a"),C2))),C2),CN1))),Power(Times($s("d"),Rt(Plus(Power($s("b"),C2),Times(CN1,Power($s("a"),C2))),C2)),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),NegQ(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))))))),
SetDelayed(Int(Sqrt(Plus($p("a"),Times($p("b",true),Sin(Plus($p("c",true),Times($p("d",true),$p("x"))))))),$p("x",$s("Symbol"))),
    Condition(Times(Times(integer(-2L),$s("b")),Times(Cos(Plus($s("c"),Times($s("d"),$s("x")))),Power(Times($s("d"),Sqrt(Plus($s("a"),Times($s("b"),Sin(Plus($s("c"),Times($s("d"),$s("x")))))))),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),ZeroQ(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))))))),
SetDelayed(Int(Sqrt(Plus($p("a",true),Times($p("b",true),Sin(Plus($p("c",true),Times($p("d",true),$p("x"))))))),$p("x",$s("Symbol"))),
    Condition(Times(Times(C2,Sqrt(Plus($s("a"),$s("b")))),Times(EllipticE(Times(Plus(Plus(Times(Times(CN1,Pi),C1D2),$s("c")),Times($s("d"),$s("x"))),C1D2),Times(C2,Times($s("b"),Power(Plus($s("a"),$s("b")),CN1)))),Power($s("d"),CN1))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),NonzeroQ(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))))),PositiveQ(Plus($s("a"),$s("b")))))),
SetDelayed(Int(Sqrt(Plus($p("a",true),Times($p("b",true),Sin(Plus($p("c",true),Times($p("d",true),$p("x"))))))),$p("x",$s("Symbol"))),
    Condition(Times(Times(Sqrt(Plus($s("a"),Times($s("b"),Sin(Plus($s("c"),Times($s("d"),$s("x"))))))),Power(Sqrt(Times(Plus($s("a"),Times($s("b"),Sin(Plus($s("c"),Times($s("d"),$s("x")))))),Power(Plus($s("a"),$s("b")),CN1))),CN1)),Int(Sqrt(Plus(Times($s("a"),Power(Plus($s("a"),$s("b")),CN1)),Times(Times($s("b"),Power(Plus($s("a"),$s("b")),CN1)),Sin(Plus($s("c"),Times($s("d"),$s("x"))))))),$s("x"))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),NonzeroQ(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))))),Not(PositiveQ(Plus($s("a"),$s("b"))))))),
SetDelayed(Int(Times(C1,Power(Sqrt(Plus($p("a"),Times($p("b",true),Sin(Plus($p("c",true),Times($p("d",true),$p("x"))))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Times(integer(-2L),ArcTanh(Cos(Times(Plus(Plus($s("c"),Times(CN1,Times(Pi,C1D2))),Times($s("d"),$s("x"))),C1D2)))),Times(Sin(Times(Plus(Plus($s("c"),Times(CN1,Times(Pi,C1D2))),Times($s("d"),$s("x"))),C1D2)),Power(Times($s("d"),Sqrt(Plus($s("a"),Times($s("b"),Sin(Plus($s("c"),Times($s("d"),$s("x")))))))),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),ZeroQ(Plus($s("a"),$s("b")))))),
SetDelayed(Int(Times(C1,Power(Sqrt(Plus($p("a"),Times($p("b",true),Sin(Plus($p("c",true),Times($p("d",true),$p("x"))))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Times(C2,ArcTanh(Sin(Times(Plus(Plus($s("c"),Times(CN1,Times(Pi,C1D2))),Times($s("d"),$s("x"))),C1D2)))),Times(Cos(Times(Plus(Plus($s("c"),Times(CN1,Times(Pi,C1D2))),Times($s("d"),$s("x"))),C1D2)),Power(Times($s("d"),Sqrt(Plus($s("a"),Times($s("b"),Sin(Plus($s("c"),Times($s("d"),$s("x")))))))),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),ZeroQ(Plus($s("a"),Times(CN1,$s("b"))))))),
SetDelayed(Int(Times(C1,Power(Sqrt(Plus($p("a",true),Times($p("b",true),Sin(Plus($p("c",true),Times($p("d",true),$p("x"))))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(C2,Times(EllipticF(Times(Plus(Plus(Times(Times(CN1,Pi),C1D2),$s("c")),Times($s("d"),$s("x"))),C1D2),Times(C2,Times($s("b"),Power(Plus($s("a"),$s("b")),CN1)))),Power(Times($s("d"),Sqrt(Plus($s("a"),$s("b")))),CN1))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),NonzeroQ(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))))),PositiveQ(Plus($s("a"),$s("b")))))),
SetDelayed(Int(Times(C1,Power(Sqrt(Plus($p("a"),Times($p("b",true),Sin(Plus($p("c",true),Times($p("d",true),$p("x"))))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Times(Sqrt(Times(Plus($s("a"),Times($s("b"),Sin(Plus($s("c"),Times($s("d"),$s("x")))))),Power(Plus($s("a"),$s("b")),CN1))),Power(Sqrt(Plus($s("a"),Times($s("b"),Sin(Plus($s("c"),Times($s("d"),$s("x"))))))),CN1)),Int(Times(C1,Power(Sqrt(Plus(Times($s("a"),Power(Plus($s("a"),$s("b")),CN1)),Times(Times($s("b"),Power(Plus($s("a"),$s("b")),CN1)),Sin(Plus($s("c"),Times($s("d"),$s("x"))))))),CN1)),$s("x"))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),NonzeroQ(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))))),Not(PositiveQ(Plus($s("a"),$s("b"))))))),
SetDelayed(Int(Power(Plus($p("a"),Times($p("b",true),Sin(Plus($p("c",true),Times($p("d",true),$p("x")))))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(Times(CN1,$s("b")),Cos(Plus($s("c"),Times($s("d"),$s("x"))))),Times(Power(Plus($s("a"),Times($s("b"),Sin(Plus($s("c"),Times($s("d"),$s("x")))))),Plus($s("n"),Times(CN1,C1))),Power(Times($s("d"),$s("n")),CN1))),Dist(Times($s("a"),Times(Plus(Times(C2,$s("n")),Times(CN1,C1)),Power($s("n"),CN1))),Int(Power(Plus($s("a"),Times($s("b"),Sin(Plus($s("c"),Times($s("d"),$s("x")))))),Plus($s("n"),Times(CN1,C1))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),FractionQ($s("n"))),Greater($s("n"),C1)),ZeroQ(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))))))),
SetDelayed(Int(Power(Plus($p("a"),Times($p("b",true),Sin(Plus($p("c",true),Times($p("d",true),$p("x")))))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times($s("b"),Cos(Plus($s("c"),Times($s("d"),$s("x"))))),Times(Power(Plus($s("a"),Times($s("b"),Sin(Plus($s("c"),Times($s("d"),$s("x")))))),$s("n")),Power(Times(Times($s("a"),$s("d")),Plus(Times(C2,$s("n")),C1)),CN1))),Dist(Times(Plus($s("n"),C1),Power(Times($s("a"),Plus(Times(C2,$s("n")),C1)),CN1)),Int(Power(Plus($s("a"),Times($s("b"),Sin(Plus($s("c"),Times($s("d"),$s("x")))))),Plus($s("n"),C1)),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),RationalQ($s("n"))),Less($s("n"),CN1)),ZeroQ(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))))))),
SetDelayed(Int(Times(C1,Power(Power(Plus($p("a"),Times($p("b",true),Sin(Plus($p("c",true),Times($p("d",true),$p("x")))))),C2),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Times($s("b"),Times(Cos(Plus($s("c"),Times($s("d"),$s("x")))),Power(Times(Times($s("d"),Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2)))),Plus($s("a"),Times($s("b"),Sin(Plus($s("c"),Times($s("d"),$s("x"))))))),CN1))),Dist(Times($s("a"),Power(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))),CN1)),Int(Times(C1,Power(Plus($s("a"),Times($s("b"),Sin(Plus($s("c"),Times($s("d"),$s("x")))))),CN1)),$s("x")))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),NonzeroQ(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))))))),
SetDelayed(Int(Power(Plus($p("a"),Times($p("b",true),Sin(Plus($p("c",true),Times($p("d",true),$p("x")))))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(Times(CN1,$s("b")),Cos(Plus($s("c"),Times($s("d"),$s("x"))))),Times(Power(Plus($s("a"),Times($s("b"),Sin(Plus($s("c"),Times($s("d"),$s("x")))))),Plus($s("n"),C1)),Power(Times(Times($s("d"),Plus($s("n"),C1)),Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2)))),CN1))),Dist(Times(C1,Power(Times(Plus($s("n"),C1),Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2)))),CN1)),Int(Times(Plus(Times($s("a"),Plus($s("n"),C1)),Times(CN1,Times(Times($s("b"),Plus($s("n"),C2)),Sin(Plus($s("c"),Times($s("d"),$s("x"))))))),Power(Plus($s("a"),Times($s("b"),Sin(Plus($s("c"),Times($s("d"),$s("x")))))),Plus($s("n"),C1))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),RationalQ($s("n"))),Less($s("n"),CN1)),NonzeroQ(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Plus($p("a"),Times($p("b",true),Sin(Plus($p("c",true),Times($p("d",true),$p("x")))))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Dist(Power(Times(C2,$s("a")),$s("n")),Int(Times(Power($s("x"),$s("m")),Power(Cos(Plus(Plus(Times(Times(CN1,Pi),C1D4),Times($s("c"),C1D2)),Times($s("d"),Times($s("x"),C1D2)))),Times(C2,$s("n")))),$s("x"))),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),RationalQ($s("m"))),IntegerQ($s("n"))),Less($s("n"),C0)),ZeroQ(Plus($s("a"),Times(CN1,$s("b"))))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Plus($p("a"),Times($p("b",true),Sin(Plus($p("c",true),Times($p("d",true),$p("x")))))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Dist(Power(C2,$s("n")),Int(Times(Power($s("x"),$s("m")),Power(Times($s("a"),Power(Cos(Plus(Plus(Times(Times(CN1,Pi),C1D4),Times($s("c"),C1D2)),Times($s("d"),Times($s("x"),C1D2)))),C2)),$s("n"))),$s("x"))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),RationalQ(List($s("m"),$s("n")))),ZeroQ(Plus($s("a"),Times(CN1,$s("b"))))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Plus($p("a"),Times($p("b",true),Sin(Plus($p("c",true),Times($p("d",true),$p("x")))))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Dist(Power(Times(C2,$s("a")),$s("n")),Int(Times(Power($s("x"),$s("m")),Power(Cos(Plus(Plus(Times(Pi,C1D4),Times($s("c"),C1D2)),Times($s("d"),Times($s("x"),C1D2)))),Times(C2,$s("n")))),$s("x"))),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),RationalQ($s("m"))),IntegerQ($s("n"))),Less($s("n"),C0)),ZeroQ(Plus($s("a"),$s("b")))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Plus($p("a"),Times($p("b",true),Sin(Plus($p("c",true),Times($p("d",true),$p("x")))))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Dist(Power(C2,$s("n")),Int(Times(Power($s("x"),$s("m")),Power(Times($s("a"),Power(Cos(Plus(Plus(Times(Pi,C1D4),Times($s("c"),C1D2)),Times($s("d"),Times($s("x"),C1D2)))),C2)),$s("n"))),$s("x"))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),RationalQ(List($s("m"),$s("n")))),ZeroQ(Plus($s("a"),$s("b")))))),
SetDelayed(Int(Times($p("x"),Power(Power(Plus($p("a"),Times($p("b",true),Sin(Plus($p("c",true),Times($p("d",true),$p("x")))))),C2),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Dist(Times($s("a"),Power(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))),CN1)),Int(Times($s("x"),Power(Plus($s("a"),Times($s("b"),Sin(Plus($s("c"),Times($s("d"),$s("x")))))),CN1)),$s("x"))),Times(CN1,Dist(Times($s("b"),Power(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))),CN1)),Int(Times($s("x"),Times(Plus($s("b"),Times($s("a"),Sin(Plus($s("c"),Times($s("d"),$s("x")))))),Power(Power(Plus($s("a"),Times($s("b"),Sin(Plus($s("c"),Times($s("d"),$s("x")))))),C2),CN1))),$s("x"))))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),NonzeroQ(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Plus($p("a"),Times($p("b",true),Sin(Plus($p("c",true),Times($p("d",true),$p("x")))))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Dist(Times(C1,Power(Power(C2,$s("n")),CN1)),Int(Times(Power($s("x"),$s("m")),Times(Power(Plus(Plus(Times(CI,$s("b")),Times(Times(C2,$s("a")),Power(E,Plus(Times(CI,$s("c")),Times(Times(CI,$s("d")),$s("x")))))),Times(CN1,Times(Times(CI,$s("b")),Power(E,Times(C2,Plus(Times(CI,$s("c")),Times(Times(CI,$s("d")),$s("x")))))))),$s("n")),Power(Power(E,Times($s("n"),Plus(Times(CI,$s("c")),Times(Times(CI,$s("d")),$s("x"))))),CN1))),$s("x"))),And(And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),NonzeroQ(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))))),IntegerQ($s("n"))),Less($s("n"),C0)),RationalQ($s("m"))),Greater($s("m"),C0)))),
SetDelayed(Int(Times(Plus($p("A",true),Times($p("B",true),Sin(Plus($p("c",true),Times($p("d",true),$p("x")))))),Power(Sqrt(Plus($p("a"),Times($p("b",true),Sin(Plus($p("c",true),Times($p("d",true),$p("x"))))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Dist(Times(Plus(Times($s("b"),$s("A")),Times(CN1,Times($s("a"),$s("B")))),Power($s("b"),CN1)),Int(Times(C1,Power(Sqrt(Plus($s("a"),Times($s("b"),Sin(Plus($s("c"),Times($s("d"),$s("x"))))))),CN1)),$s("x"))),Dist(Times($s("B"),Power($s("b"),CN1)),Int(Sqrt(Plus($s("a"),Times($s("b"),Sin(Plus($s("c"),Times($s("d"),$s("x"))))))),$s("x")))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("A"),$s("B")),$s("x")),NonzeroQ(Plus(Times($s("b"),$s("A")),Times(CN1,Times($s("a"),$s("B")))))))),
SetDelayed(Int(Times(Plus($p("A",true),Times($p("B",true),Sin(Plus($p("c",true),Times($p("d",true),$p("x")))))),Power(Plus($p("a"),Times($p("b",true),Sin(Plus($p("c",true),Times($p("d",true),$p("x")))))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(Times(CN1,$s("B")),Cos(Plus($s("c"),Times($s("d"),$s("x"))))),Times(Power(Plus($s("a"),Times($s("b"),Sin(Plus($s("c"),Times($s("d"),$s("x")))))),$s("n")),Power(Times($s("d"),Plus($s("n"),C1)),CN1))),Dist(Times(C1,Power(Plus($s("n"),C1),CN1)),Int(Times(Plus(Plus(Times(Times($s("b"),$s("B")),$s("n")),Times(Times($s("a"),$s("A")),Plus($s("n"),C1))),Times(Plus(Times(Times($s("a"),$s("B")),$s("n")),Times(Times($s("b"),$s("A")),Plus($s("n"),C1))),Sin(Plus($s("c"),Times($s("d"),$s("x")))))),Power(Plus($s("a"),Times($s("b"),Sin(Plus($s("c"),Times($s("d"),$s("x")))))),Plus($s("n"),Times(CN1,C1)))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("A"),$s("B")),$s("x")),RationalQ($s("n"))),Greater($s("n"),C1)),NonzeroQ(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))))))),
SetDelayed(Int(Times(Plus($p("A"),Times($p("B",true),Sin(Plus($p("c",true),Times($p("d",true),$p("x")))))),Power(Power(Plus($p("a"),Times($p("b",true),Sin(Plus($p("c",true),Times($p("d",true),$p("x")))))),C2),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Times(CN1,$s("B")),Times(Cos(Plus($s("c"),Times($s("d"),$s("x")))),Power(Times(Times($s("a"),$s("d")),Plus($s("a"),Times($s("b"),Sin(Plus($s("c"),Times($s("d"),$s("x"))))))),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("A"),$s("B")),$s("x")),ZeroQ(Plus(Times($s("a"),$s("A")),Times(CN1,Times($s("b"),$s("B")))))))),
SetDelayed(Int(Times($p("x"),Times(Plus($p("A"),Times($p("B",true),Sin(Plus($p("c",true),Times($p("d",true),$p("x")))))),Power(Power(Plus($p("a"),Times($p("b",true),Sin(Plus($p("c",true),Times($p("d",true),$p("x")))))),C2),CN1))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(Times(CN1,$s("B")),$s("x")),Times(Cos(Plus($s("c"),Times($s("d"),$s("x")))),Power(Times(Times($s("a"),$s("d")),Plus($s("a"),Times($s("b"),Sin(Plus($s("c"),Times($s("d"),$s("x"))))))),CN1))),Dist(Times($s("B"),Power(Times($s("a"),$s("d")),CN1)),Int(Times(Cos(Plus($s("c"),Times($s("d"),$s("x")))),Power(Plus($s("a"),Times($s("b"),Sin(Plus($s("c"),Times($s("d"),$s("x")))))),CN1)),$s("x")))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("A"),$s("B")),$s("x")),ZeroQ(Plus(Times($s("a"),$s("A")),Times(CN1,Times($s("b"),$s("B")))))))),
SetDelayed(Int(Times(Plus($p("A",true),Times($p("B",true),Sin(Plus($p("c",true),Times($p("d",true),$p("x")))))),Power(Plus($p("a",true),Times($p("b",true),Sin(Plus($p("c",true),Times($p("d",true),$p("x")))))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(Plus(Times($s("a"),$s("B")),Times(CN1,Times($s("b"),$s("A")))),Cos(Plus($s("c"),Times($s("d"),$s("x"))))),Times(Power(Plus($s("a"),Times($s("b"),Sin(Plus($s("c"),Times($s("d"),$s("x")))))),Plus($s("n"),C1)),Power(Times(Times($s("d"),Plus($s("n"),C1)),Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2)))),CN1))),Dist(Times(C1,Power(Times(Plus($s("n"),C1),Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2)))),CN1)),Int(Times(Plus(Times(Plus($s("n"),C1),Plus(Times($s("a"),$s("A")),Times(CN1,Times($s("b"),$s("B"))))),Times(Times(Plus($s("n"),C2),Plus(Times($s("a"),$s("B")),Times(CN1,Times($s("b"),$s("A"))))),Sin(Plus($s("c"),Times($s("d"),$s("x")))))),Power(Plus($s("a"),Times($s("b"),Sin(Plus($s("c"),Times($s("d"),$s("x")))))),Plus($s("n"),C1))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("A"),$s("B")),$s("x")),RationalQ($s("n"))),Less($s("n"),CN1)),NonzeroQ(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Plus($p("a"),Times($p("b",true),Power(Sin(Plus($p("c",true),Times($p("d",true),$p("x")))),C2))),CN1)),$p("x",$s("Symbol"))),
    Condition(Dist(C2,Int(Times(Power($s("x"),$s("m")),Power(Plus(Plus(Times(C2,$s("a")),$s("b")),Times(CN1,Times($s("b"),Cos(Plus(Times(C2,$s("c")),Times(Times(C2,$s("d")),$s("x"))))))),CN1)),$s("x"))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),IntegerQ($s("m"))),Greater($s("m"),C0)),NonzeroQ(Plus($s("a"),$s("b"))))))
  );
}
