package org.matheclipse.core.integrate.rubi;


import static org.matheclipse.core.expression.F.*;
import static org.matheclipse.core.integrate.rubi.UtilityFunctionCtors.*;
import static org.matheclipse.core.integrate.rubi.UtilityFunctions.*;
import org.matheclipse.core.interfaces.IAST;
import org.matheclipse.core.interfaces.IExpr;

/** 
 * IndefiniteIntegrationRules from the <a href="http://www.apmaths.uwo.ca/~arich/">Rubi -
 * rule-based integrator</a>.
 *  
 */
public class IndefiniteIntegrationRules9 { 
  public static IAST RULES = List( 
SetDelayed(Int(Times(Times($p("u",true),Cosh($p("v"))),Power(Tanh($p("w")),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Plus(Int(Times(Times($s("u"),Sinh($s("v"))),Power(Tanh($s("w")),Plus($s("n"),Times(CN1,C1)))),$s("x")),Times(CN1,Times(Sinh(Plus($s("v"),Times(CN1,$s("w")))),Int(Times(Times($s("u"),Sech($s("w"))),Power(Tanh($s("w")),Plus($s("n"),Times(CN1,C1)))),$s("x"))))),And(And(And(RationalQ($s("n")),Greater($s("n"),C0)),FreeQ(Plus($s("v"),Times(CN1,$s("w"))),$s("x"))),NonzeroQ(Plus($s("v"),Times(CN1,$s("w"))))))),
SetDelayed(Int(Times(Times($p("u",true),Cosh($p("v"))),Power(Coth($p("w")),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Plus(Int(Times(Times($s("u"),Sinh($s("v"))),Power(Coth($s("w")),Plus($s("n"),Times(CN1,C1)))),$s("x")),Times(Cosh(Plus($s("v"),Times(CN1,$s("w")))),Int(Times(Times($s("u"),Csch($s("w"))),Power(Coth($s("w")),Plus($s("n"),Times(CN1,C1)))),$s("x")))),And(And(And(RationalQ($s("n")),Greater($s("n"),C0)),FreeQ(Plus($s("v"),Times(CN1,$s("w"))),$s("x"))),NonzeroQ(Plus($s("v"),Times(CN1,$s("w"))))))),
SetDelayed(Int(Times(Times($p("u",true),Cosh($p("v"))),Power(Sech($p("w")),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Sinh(Plus($s("v"),Times(CN1,$s("w")))),Int(Times(Times($s("u"),Tanh($s("w"))),Power(Sech($s("w")),Plus($s("n"),Times(CN1,C1)))),$s("x"))),Times(Cosh(Plus($s("v"),Times(CN1,$s("w")))),Int(Times($s("u"),Power(Sech($s("w")),Plus($s("n"),Times(CN1,C1)))),$s("x")))),And(And(And(RationalQ($s("n")),Greater($s("n"),C0)),FreeQ(Plus($s("v"),Times(CN1,$s("w"))),$s("x"))),NonzeroQ(Plus($s("v"),Times(CN1,$s("w"))))))),
SetDelayed(Int(Times(Times($p("u",true),Cosh($p("v"))),Power(Csch($p("w")),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Cosh(Plus($s("v"),Times(CN1,$s("w")))),Int(Times(Times($s("u"),Coth($s("w"))),Power(Csch($s("w")),Plus($s("n"),Times(CN1,C1)))),$s("x"))),Times(Sinh(Plus($s("v"),Times(CN1,$s("w")))),Int(Times($s("u"),Power(Csch($s("w")),Plus($s("n"),Times(CN1,C1)))),$s("x")))),And(And(And(RationalQ($s("n")),Greater($s("n"),C0)),FreeQ(Plus($s("v"),Times(CN1,$s("w"))),$s("x"))),NonzeroQ(Plus($s("v"),Times(CN1,$s("w"))))))),
SetDelayed(Int(Tanh(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("x",$s("Symbol"))),
    Condition(Times(Log(Cosh(Plus($s("a"),Times($s("b"),$s("x"))))),Power($s("b"),CN1)),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(Power(Tanh(Plus($p("a",true),Times($p("b",true),$p("x")))),C2),$p("x",$s("Symbol"))),
    Condition(Plus($s("x"),Times(CN1,Times(Tanh(Plus($s("a"),Times($s("b"),$s("x")))),Power($s("b"),CN1)))),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(Power(Times($p("c",true),Tanh(Plus($p("a",true),Times($p("b",true),$p("x"))))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,$s("c")),Times(Power(Times($s("c"),Tanh(Plus($s("a"),Times($s("b"),$s("x"))))),Plus($s("n"),Times(CN1,C1))),Power(Times($s("b"),Plus($s("n"),Times(CN1,C1))),CN1))),Dist(Power($s("c"),C2),Int(Power(Times($s("c"),Tanh(Plus($s("a"),Times($s("b"),$s("x"))))),Plus($s("n"),Times(CN1,C2))),$s("x")))),And(And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),RationalQ($s("n"))),Greater($s("n"),C1)))),
SetDelayed(Int(Power(Times($p("c",true),Tanh(Plus($p("a",true),Times($p("b",true),$p("x"))))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power(Times($s("c"),Tanh(Plus($s("a"),Times($s("b"),$s("x"))))),Plus($s("n"),C1)),Power(Times(Times($s("b"),$s("c")),Plus($s("n"),C1)),CN1)),Dist(Times(C1,Power(Power($s("c"),C2),CN1)),Int(Power(Times($s("c"),Tanh(Plus($s("a"),Times($s("b"),$s("x"))))),Plus($s("n"),C2)),$s("x")))),And(And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),RationalQ($s("n"))),Less($s("n"),CN1)))),
SetDelayed(Int(Sqrt(Plus($p("a"),Times($p("b",true),Tanh(Plus($p("c",true),Times($p("d",true),$p("x"))))))),$p("x",$s("Symbol"))),
    Condition(Times(Times(Times(Sqrt(C2),$s("b")),ArcTanh(Times(Sqrt(Plus($s("a"),Times($s("b"),Tanh(Plus($s("c"),Times($s("d"),$s("x"))))))),Power(Times(Sqrt(C2),Rt($s("a"),C2)),CN1)))),Power(Times($s("d"),Rt($s("a"),C2)),CN1)),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),ZeroQ(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))))),PosQ($s("a"))))),
SetDelayed(Int(Sqrt(Plus($p("a"),Times($p("b",true),Tanh(Plus($p("c",true),Times($p("d",true),$p("x"))))))),$p("x",$s("Symbol"))),
    Condition(Times(Times(CN1,Times(Times(Sqrt(C2),$s("b")),ArcTan(Times(Sqrt(Plus($s("a"),Times($s("b"),Tanh(Plus($s("c"),Times($s("d"),$s("x"))))))),Power(Times(Sqrt(C2),Rt(Times(CN1,$s("a")),C2)),CN1))))),Power(Times($s("d"),Rt(Times(CN1,$s("a")),C2)),CN1)),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),ZeroQ(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))))),NegQ($s("a"))))),
SetDelayed(Int(Power(Plus($p("a"),Times($p("b",true),Tanh(Plus($p("c",true),Times($p("d",true),$p("x")))))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Power($s("a"),C2)),Times(Power(Plus($s("a"),Times($s("b"),Tanh(Plus($s("c"),Times($s("d"),$s("x")))))),Plus($s("n"),Times(CN1,C1))),Power(Times(Times($s("b"),$s("d")),Plus($s("n"),Times(CN1,C1))),CN1))),Dist(Times(C2,$s("a")),Int(Power(Plus($s("a"),Times($s("b"),Tanh(Plus($s("c"),Times($s("d"),$s("x")))))),Plus($s("n"),Times(CN1,C1))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),FractionQ($s("n"))),Greater($s("n"),C1)),ZeroQ(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))))))),
SetDelayed(Int(Times(C1,Power(Plus($p("a"),Times($p("b",true),Tanh(Plus($p("c",true),Times($p("d",true),$p("x")))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Times($s("x"),Power(Times(C2,$s("a")),CN1)),Times(CN1,Times($s("a"),Power(Times(Times(Times(C2,$s("b")),$s("d")),Plus($s("a"),Times($s("b"),Tanh(Plus($s("c"),Times($s("d"),$s("x"))))))),CN1)))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),ZeroQ(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))))))),
SetDelayed(Int(Power(Plus($p("a"),Times($p("b",true),Tanh(Plus($p("c",true),Times($p("d",true),$p("x")))))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Plus(Times($s("a"),Times(Power(Plus($s("a"),Times($s("b"),Tanh(Plus($s("c"),Times($s("d"),$s("x")))))),$s("n")),Power(Times(Times(Times(C2,$s("b")),$s("d")),$s("n")),CN1))),Dist(Times(C1,Power(Times(C2,$s("a")),CN1)),Int(Power(Plus($s("a"),Times($s("b"),Tanh(Plus($s("c"),Times($s("d"),$s("x")))))),Plus($s("n"),C1)),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),RationalQ($s("n"))),Less($s("n"),C0)),ZeroQ(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))))))),
SetDelayed(Int(Times(C1,Power(Plus($p("a"),Times($p("b",true),Tanh(Plus($p("c",true),Times($p("d",true),$p("x")))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Times($s("a"),Times($s("x"),Power(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))),CN1))),Times(CN1,Times($s("b"),Times(Log(Plus(Times($s("a"),Cosh(Plus($s("c"),Times($s("d"),$s("x"))))),Times($s("b"),Sinh(Plus($s("c"),Times($s("d"),$s("x"))))))),Power(Times($s("d"),Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2)))),CN1))))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),NonzeroQ(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))))))),
SetDelayed(Int(Times(C1,Power(Plus($p("a"),Times($p("b",true),Power(Tanh(Plus($p("c",true),Times($p("d",true),$p("x")))),C2))),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Times($s("x"),Power(Plus($s("a"),$s("b")),CN1)),Times(Sqrt($s("b")),Times(ArcTan(Times(Times(Sqrt($s("b")),Tanh(Plus($s("c"),Times($s("d"),$s("x"))))),Power(Sqrt($s("a")),CN1))),Power(Times(Times(Sqrt($s("a")),$s("d")),Plus($s("a"),$s("b"))),CN1)))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),NonzeroQ(Plus($s("a"),$s("b")))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Tanh(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n",true)))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Power(Plus($s("m"),C1),CN1)),Times(CN1,Dist(C2,Int(Times(Power($s("x"),$s("m")),Power(Plus(C1,Power(E,Plus(Times(C2,$s("a")),Times(Times(C2,$s("b")),Power($s("x"),$s("n")))))),CN1)),$s("x"))))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("m"),$s("n")),$s("x")),NonzeroQ(Plus(Plus($s("m"),Times(CN1,$s("n"))),C1))),IntegerQ($s("m"))),Greater($s("m"),C0)))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Tanh(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n",true))))),$p("p"))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(CN1,Power($s("x"),Plus(Plus($s("m"),Times(CN1,$s("n"))),C1))),Times(Power(Tanh(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),Plus($s("p"),Times(CN1,C1))),Power(Times(Times($s("b"),$s("n")),Plus($s("p"),Times(CN1,C1))),CN1))),Dist(Times(Plus(Plus($s("m"),Times(CN1,$s("n"))),C1),Power(Times(Times($s("b"),$s("n")),Plus($s("p"),Times(CN1,C1))),CN1)),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,$s("n")))),Power(Tanh(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),Plus($s("p"),Times(CN1,C1)))),$s("x")))),Int(Times(Power($s("x"),$s("m")),Power(Tanh(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),Plus($s("p"),Times(CN1,C2)))),$s("x"))),And(And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),RationalQ(List($s("m"),$s("n"),$s("p")))),Greater($s("p"),C1)),NonzeroQ(Plus(Plus($s("m"),Times(CN1,$s("n"))),C1))),And(Less(C0,$s("n")),LessEqual($s("n"),$s("m")))))),
SetDelayed(Int(Times($p("x"),Tanh(Plus(Plus($p("a",true),Times($p("b",true),$p("x"))),Times($p("c",true),Power($p("x"),C2))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Log(Cosh(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))))),Power(Times(C2,$s("c")),CN1)),Times(CN1,Dist(Times($s("b"),Power(Times(C2,$s("c")),CN1)),Int(Tanh(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2)))),$s("x"))))),FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")))),
SetDelayed(Int(Coth(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("x",$s("Symbol"))),
    Condition(Times(Log(Sinh(Plus($s("a"),Times($s("b"),$s("x"))))),Power($s("b"),CN1)),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(Power(Coth(Plus($p("a",true),Times($p("b",true),$p("x")))),C2),$p("x",$s("Symbol"))),
    Condition(Plus($s("x"),Times(CN1,Times(Coth(Plus($s("a"),Times($s("b"),$s("x")))),Power($s("b"),CN1)))),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(Power(Times($p("c",true),Coth(Plus($p("a",true),Times($p("b",true),$p("x"))))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,$s("c")),Times(Power(Times($s("c"),Coth(Plus($s("a"),Times($s("b"),$s("x"))))),Plus($s("n"),Times(CN1,C1))),Power(Times($s("b"),Plus($s("n"),Times(CN1,C1))),CN1))),Dist(Power($s("c"),C2),Int(Power(Times($s("c"),Coth(Plus($s("a"),Times($s("b"),$s("x"))))),Plus($s("n"),Times(CN1,C2))),$s("x")))),And(And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),RationalQ($s("n"))),Greater($s("n"),C1)))),
SetDelayed(Int(Power(Times($p("c",true),Coth(Plus($p("a",true),Times($p("b",true),$p("x"))))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power(Times($s("c"),Coth(Plus($s("a"),Times($s("b"),$s("x"))))),Plus($s("n"),C1)),Power(Times(Times($s("b"),$s("c")),Plus($s("n"),C1)),CN1)),Dist(Times(C1,Power(Power($s("c"),C2),CN1)),Int(Power(Times($s("c"),Coth(Plus($s("a"),Times($s("b"),$s("x"))))),Plus($s("n"),C2)),$s("x")))),And(And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),RationalQ($s("n"))),Less($s("n"),CN1)))),
SetDelayed(Int(Sqrt(Plus($p("a"),Times($p("b",true),Coth(Plus($p("c",true),Times($p("d",true),$p("x"))))))),$p("x",$s("Symbol"))),
    Condition(Times(Times(Times(Sqrt(C2),$s("b")),ArcCoth(Times(Sqrt(Plus($s("a"),Times($s("b"),Coth(Plus($s("c"),Times($s("d"),$s("x"))))))),Power(Times(Sqrt(C2),Rt($s("a"),C2)),CN1)))),Power(Times($s("d"),Rt($s("a"),C2)),CN1)),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),ZeroQ(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))))),PosQ($s("a"))))),
SetDelayed(Int(Sqrt(Plus($p("a"),Times($p("b",true),Coth(Plus($p("c",true),Times($p("d",true),$p("x"))))))),$p("x",$s("Symbol"))),
    Condition(Times(Times(Times(Sqrt(C2),$s("b")),ArcCot(Times(Sqrt(Plus($s("a"),Times($s("b"),Coth(Plus($s("c"),Times($s("d"),$s("x"))))))),Power(Times(Sqrt(C2),Rt(Times(CN1,$s("a")),C2)),CN1)))),Power(Times($s("d"),Rt(Times(CN1,$s("a")),C2)),CN1)),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),ZeroQ(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))))),NegQ($s("a"))))),
SetDelayed(Int(Power(Plus($p("a"),Times($p("b",true),Coth(Plus($p("c",true),Times($p("d",true),$p("x")))))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Power($s("a"),C2)),Times(Power(Plus($s("a"),Times($s("b"),Coth(Plus($s("c"),Times($s("d"),$s("x")))))),Plus($s("n"),Times(CN1,C1))),Power(Times(Times($s("b"),$s("d")),Plus($s("n"),Times(CN1,C1))),CN1))),Dist(Times(C2,$s("a")),Int(Power(Plus($s("a"),Times($s("b"),Coth(Plus($s("c"),Times($s("d"),$s("x")))))),Plus($s("n"),Times(CN1,C1))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),FractionQ($s("n"))),Greater($s("n"),C1)),ZeroQ(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))))))),
SetDelayed(Int(Times(C1,Power(Plus($p("a"),Times($p("b",true),Coth(Plus($p("c",true),Times($p("d",true),$p("x")))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Times($s("x"),Power(Times(C2,$s("a")),CN1)),Times(CN1,Times($s("a"),Power(Times(Times(Times(C2,$s("b")),$s("d")),Plus($s("a"),Times($s("b"),Coth(Plus($s("c"),Times($s("d"),$s("x"))))))),CN1)))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),ZeroQ(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))))))),
SetDelayed(Int(Power(Plus($p("a"),Times($p("b",true),Coth(Plus($p("c",true),Times($p("d",true),$p("x")))))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Plus(Times($s("a"),Times(Power(Plus($s("a"),Times($s("b"),Coth(Plus($s("c"),Times($s("d"),$s("x")))))),$s("n")),Power(Times(Times(Times(C2,$s("b")),$s("d")),$s("n")),CN1))),Dist(Times(C1,Power(Times(C2,$s("a")),CN1)),Int(Power(Plus($s("a"),Times($s("b"),Coth(Plus($s("c"),Times($s("d"),$s("x")))))),Plus($s("n"),C1)),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),RationalQ($s("n"))),Less($s("n"),C0)),ZeroQ(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))))))),
SetDelayed(Int(Times(C1,Power(Plus($p("a"),Times($p("b",true),Coth(Plus($p("c",true),Times($p("d",true),$p("x")))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Times($s("a"),Times($s("x"),Power(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))),CN1))),Times(CN1,Times($s("b"),Times(Log(Plus(Times($s("b"),Cosh(Plus($s("c"),Times($s("d"),$s("x"))))),Times($s("a"),Sinh(Plus($s("c"),Times($s("d"),$s("x"))))))),Power(Times($s("d"),Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2)))),CN1))))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),NonzeroQ(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))))))),
SetDelayed(Int(Times(C1,Power(Plus($p("a"),Times($p("b",true),Power(Coth(Plus($p("c",true),Times($p("d",true),$p("x")))),C2))),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Times($s("x"),Power(Plus($s("a"),$s("b")),CN1)),Times(Sqrt($s("b")),Times(ArcTan(Times(Times(Sqrt($s("b")),Coth(Plus($s("c"),Times($s("d"),$s("x"))))),Power(Sqrt($s("a")),CN1))),Power(Times(Times(Sqrt($s("a")),$s("d")),Plus($s("a"),$s("b"))),CN1)))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),NonzeroQ(Plus($s("a"),$s("b")))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Coth(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n",true)))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Power(Plus($s("m"),C1),CN1)),Times(CN1,Dist(C2,Int(Times(Power($s("x"),$s("m")),Power(Plus(C1,Times(CN1,Power(E,Plus(Times(C2,$s("a")),Times(Times(C2,$s("b")),Power($s("x"),$s("n"))))))),CN1)),$s("x"))))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("m"),$s("n")),$s("x")),NonzeroQ(Plus(Plus($s("m"),Times(CN1,$s("n"))),C1))),IntegerQ($s("m"))),Greater($s("m"),C0)))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Coth(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n",true))))),$p("p"))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(CN1,Power($s("x"),Plus(Plus($s("m"),Times(CN1,$s("n"))),C1))),Times(Power(Coth(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),Plus($s("p"),Times(CN1,C1))),Power(Times(Times($s("b"),$s("n")),Plus($s("p"),Times(CN1,C1))),CN1))),Dist(Times(Plus(Plus($s("m"),Times(CN1,$s("n"))),C1),Power(Times(Times($s("b"),$s("n")),Plus($s("p"),Times(CN1,C1))),CN1)),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,$s("n")))),Power(Coth(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),Plus($s("p"),Times(CN1,C1)))),$s("x")))),Int(Times(Power($s("x"),$s("m")),Power(Coth(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),Plus($s("p"),Times(CN1,C2)))),$s("x"))),And(And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),RationalQ(List($s("m"),$s("n"),$s("p")))),Greater($s("p"),C1)),NonzeroQ(Plus(Plus($s("m"),Times(CN1,$s("n"))),C1))),And(Less(C0,$s("n")),LessEqual($s("n"),$s("m")))))),
SetDelayed(Int(Times($p("x"),Coth(Plus(Plus($p("a",true),Times($p("b",true),$p("x"))),Times($p("c",true),Power($p("x"),C2))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Log(Sinh(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))))),Power(Times(C2,$s("c")),CN1)),Times(CN1,Dist(Times($s("b"),Power(Times(C2,$s("c")),CN1)),Int(Coth(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2)))),$s("x"))))),FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")))),
SetDelayed(Int(Sech(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("x",$s("Symbol"))),
    Condition(Times(ArcTan(Sinh(Plus($s("a"),Times($s("b"),$s("x"))))),Power($s("b"),CN1)),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(Times(C1,Power(Sqrt(Sech(Plus($p("a",true),Times($p("b",true),$p("x"))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Times(Sqrt(Cosh(Plus($s("a"),Times($s("b"),$s("x"))))),Sqrt(Sech(Plus($s("a"),Times($s("b"),$s("x")))))),Int(Sqrt(Cosh(Plus($s("a"),Times($s("b"),$s("x"))))),$s("x"))),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(Power(Times($p("c",true),Sech(Plus($p("a",true),Times($p("b",true),$p("x"))))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Times(Times(Power(Times($s("c"),Sech(Plus($s("a"),Times($s("b"),$s("x"))))),$s("n")),Power(Cosh(Plus($s("a"),Times($s("b"),$s("x")))),$s("n"))),Int(Times(C1,Power(Power(Cosh(Plus($s("a"),Times($s("b"),$s("x")))),$s("n")),CN1)),$s("x"))),And(And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),RationalQ($s("n"))),Less(Less(CN1,$s("n")),C1)))),
SetDelayed(Int(Power(Sech(Plus($p("a",true),Times($p("b",true),$p("x")))),C2),$p("x",$s("Symbol"))),
    Condition(Times(Tanh(Plus($s("a"),Times($s("b"),$s("x")))),Power($s("b"),CN1)),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(Power(Sech(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Dist(Times(C1,Power($s("b"),CN1)),Subst(Int(Regularize(Power(Plus(C1,Times(CN1,Power($s("x"),C2))),Times(Plus($s("n"),Times(CN1,C2)),C1D2)),$s("x")),$s("x")),$s("x"),Tanh(Plus($s("a"),Times($s("b"),$s("x")))))),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),EvenQ($s("n"))),Greater($s("n"),C1)))),
SetDelayed(Int(Power(Times($p("c",true),Sech(Plus($p("a",true),Times($p("b",true),$p("x"))))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times($s("c"),Sinh(Plus($s("a"),Times($s("b"),$s("x"))))),Times(Power(Times($s("c"),Sech(Plus($s("a"),Times($s("b"),$s("x"))))),Plus($s("n"),Times(CN1,C1))),Power(Times($s("b"),Plus($s("n"),Times(CN1,C1))),CN1))),Dist(Times(Plus($s("n"),Times(CN1,C2)),Times(Power($s("c"),C2),Power(Plus($s("n"),Times(CN1,C1)),CN1))),Int(Power(Times($s("c"),Sech(Plus($s("a"),Times($s("b"),$s("x"))))),Plus($s("n"),Times(CN1,C2))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),RationalQ($s("n"))),Greater($s("n"),C1)),Not(EvenQ($s("n")))))),
SetDelayed(Int(Power(Times($p("c",true),Sech(Plus($p("a",true),Times($p("b",true),$p("x"))))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Sinh(Plus($s("a"),Times($s("b"),$s("x"))))),Times(Power(Times($s("c"),Sech(Plus($s("a"),Times($s("b"),$s("x"))))),Plus($s("n"),C1)),Power(Times(Times($s("b"),$s("c")),$s("n")),CN1))),Dist(Times(Plus($s("n"),C1),Power(Times(Power($s("c"),C2),$s("n")),CN1)),Int(Power(Times($s("c"),Sech(Plus($s("a"),Times($s("b"),$s("x"))))),Plus($s("n"),C2)),$s("x")))),And(And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),RationalQ($s("n"))),Less($s("n"),CN1)))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Sech(Plus($p("a",true),Times($p("b",true),$p("x"))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(C2,Power($s("x"),$s("m"))),Times(ArcTan(Power(E,Plus($s("a"),Times($s("b"),$s("x"))))),Power($s("b"),CN1))),Times(CN1,Dist(Times(C2,Times($s("m"),Power($s("b"),CN1))),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,C1))),ArcTan(Power(E,Plus($s("a"),Times($s("b"),$s("x")))))),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ($s("m"))),Greater($s("m"),C0)))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Sech(Plus($p("a",true),Times($p("b",true),$p("x")))),C2)),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),$s("m")),Times(Tanh(Plus($s("a"),Times($s("b"),$s("x")))),Power($s("b"),CN1))),Times(CN1,Dist(Times($s("m"),Power($s("b"),CN1)),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,C1))),Tanh(Plus($s("a"),Times($s("b"),$s("x"))))),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),RationalQ($s("m"))),Greater($s("m"),C0)))),
SetDelayed(Int(Times($p("x"),Power(Sech(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times($s("x"),Tanh(Plus($s("a"),Times($s("b"),$s("x"))))),Times(Power(Sech(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C2))),Power(Times($s("b"),Plus($s("n"),Times(CN1,C1))),CN1))),Times(Power(Sech(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C2))),Power(Times(Times(Power($s("b"),C2),Plus($s("n"),Times(CN1,C1))),Plus($s("n"),Times(CN1,C2))),CN1))),Dist(Times(Plus($s("n"),Times(CN1,C2)),Power(Plus($s("n"),Times(CN1,C1)),CN1)),Int(Times($s("x"),Power(Sech(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C2)))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),RationalQ($s("n"))),Greater($s("n"),C1)),Unequal($s("n"),C2)))),
SetDelayed(Int(Times(Power($p("x"),$p("m")),Power(Sech(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Plus(Times(Times(Power($s("x"),$s("m")),Tanh(Plus($s("a"),Times($s("b"),$s("x"))))),Times(Power(Sech(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C2))),Power(Times($s("b"),Plus($s("n"),Times(CN1,C1))),CN1))),Times(Times($s("m"),Power($s("x"),Plus($s("m"),Times(CN1,C1)))),Times(Power(Sech(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C2))),Power(Times(Times(Power($s("b"),C2),Plus($s("n"),Times(CN1,C1))),Plus($s("n"),Times(CN1,C2))),CN1)))),Dist(Times(Plus($s("n"),Times(CN1,C2)),Power(Plus($s("n"),Times(CN1,C1)),CN1)),Int(Times(Power($s("x"),$s("m")),Power(Sech(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C2)))),$s("x")))),Times(CN1,Dist(Times($s("m"),Times(Plus($s("m"),Times(CN1,C1)),Power(Times(Times(Power($s("b"),C2),Plus($s("n"),Times(CN1,C1))),Plus($s("n"),Times(CN1,C2))),CN1))),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,C2))),Power(Sech(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C2)))),$s("x"))))),And(And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),RationalQ(List($s("m"),$s("n")))),Greater($s("n"),C1)),Unequal($s("n"),C2)),Greater($s("m"),C1)))),
SetDelayed(Int(Times($p("x"),Power(Sech(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(CN1,Power(Sech(Plus($s("a"),Times($s("b"),$s("x")))),$s("n"))),Power(Times(Power($s("b"),C2),Power($s("n"),C2)),CN1)),Times(CN1,Times(Times($s("x"),Sinh(Plus($s("a"),Times($s("b"),$s("x"))))),Times(Power(Sech(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C1)),Power(Times($s("b"),$s("n")),CN1))))),Dist(Times(Plus($s("n"),C1),Power($s("n"),CN1)),Int(Times($s("x"),Power(Sech(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C2))),$s("x")))),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),RationalQ($s("n"))),Less($s("n"),CN1)))),
SetDelayed(Int(Times(Power($p("x"),$p("m")),Power(Sech(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Plus(Times(Times(Times(CN1,$s("m")),Power($s("x"),Plus($s("m"),Times(CN1,C1)))),Times(Power(Sech(Plus($s("a"),Times($s("b"),$s("x")))),$s("n")),Power(Times(Power($s("b"),C2),Power($s("n"),C2)),CN1))),Times(CN1,Times(Times(Power($s("x"),$s("m")),Sinh(Plus($s("a"),Times($s("b"),$s("x"))))),Times(Power(Sech(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C1)),Power(Times($s("b"),$s("n")),CN1))))),Dist(Times(Plus($s("n"),C1),Power($s("n"),CN1)),Int(Times(Power($s("x"),$s("m")),Power(Sech(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C2))),$s("x")))),Dist(Times($s("m"),Times(Plus($s("m"),Times(CN1,C1)),Power(Times(Power($s("b"),C2),Power($s("n"),C2)),CN1))),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,C2))),Power(Sech(Plus($s("a"),Times($s("b"),$s("x")))),$s("n"))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),RationalQ(List($s("m"),$s("n")))),Less($s("n"),CN1)),Greater($s("m"),C1)))),
SetDelayed(Int(Sqrt(Plus($p("a"),Times($p("b",true),Sech(Plus($p("c",true),Times($p("d",true),$p("x"))))))),$p("x",$s("Symbol"))),
    Condition(Times(Times(Times(C2,$s("a")),ArcTan(Sqrt(Plus(CN1,Times(Times($s("a"),Power($s("b"),CN1)),Sech(Plus($s("c"),Times($s("d"),$s("x"))))))))),Times(Tanh(Plus($s("c"),Times($s("d"),$s("x")))),Power(Times(Times($s("d"),Sqrt(Plus(CN1,Times(Times($s("a"),Power($s("b"),CN1)),Sech(Plus($s("c"),Times($s("d"),$s("x")))))))),Sqrt(Plus($s("a"),Times($s("b"),Sech(Plus($s("c"),Times($s("d"),$s("x")))))))),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),ZeroQ(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))))))),
SetDelayed(Int(Times(C1,Power(Sqrt(Plus($p("a"),Times($p("b",true),Sech(Plus($p("c",true),Times($p("d",true),$p("x"))))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Times(Times(Times(CN1,Plus(Times(Sqrt(C2),ArcTan(Times(Times(Sqrt(C2),Sqrt($s("a"))),Power(Sqrt(Plus(Times(CN1,$s("a")),Times($s("b"),Sech($s("x"))))),CN1)))),Times(C2,ArcTan(Times(Sqrt(Plus(Times(CN1,$s("a")),Times($s("b"),Sech($s("x"))))),Power(Sqrt($s("a")),CN1)))))),Sqrt(Plus(Times(CN1,$s("a")),Times($s("b"),Sech($s("x")))))),Sqrt(Plus($s("a"),Times($s("b"),Sech($s("x")))))),Times(Coth($s("x")),Power(Power($s("a"),fraction(3L,2L)),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),ZeroQ(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))))))),
SetDelayed(Int(Power(Plus($p("a"),Times($p("b",true),Power(Sech($p("v")),$p("n",true)))),$p("m")),$p("x",$s("Symbol"))),
    Condition(Int(Times(Power(Plus($s("b"),Times($s("a"),Power(Cosh($s("v")),$s("n")))),$s("m")),Power(Power(Cosh($s("v")),Times($s("m"),$s("n"))),CN1)),$s("x")),And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ(List($s("m"),$s("n")))),Less($s("m"),C0)),Greater($s("n"),C0)))),
SetDelayed(Int(Times(Power(Cosh($p("v")),$p("p",true)),Power(Plus($p("a"),Times($p("b",true),Power(Sech($p("v")),$p("n",true)))),$p("m"))),$p("x",$s("Symbol"))),
    Condition(Int(Times(Power(Cosh($s("v")),Plus($s("p"),Times(CN1,Times($s("m"),$s("n"))))),Power(Plus($s("b"),Times($s("a"),Power(Cosh($s("v")),$s("n")))),$s("m"))),$s("x")),And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ(List($s("m"),$s("n"),$s("p")))),Less($s("m"),C0)),Greater($s("n"),C0)))),
SetDelayed(Int(Times(Csch(Plus($p("a",true),Times($p("b",true),$p("x")))),Sech(Plus($p("a",true),Times($p("b",true),$p("x"))))),$p("x",$s("Symbol"))),
    Condition(Times(Log(Tanh(Plus($s("a"),Times($s("b"),$s("x"))))),Power($s("b"),CN1)),And(FreeQ(List($s("a"),$s("b")),$s("x")),PosQ($s("b"))))),
SetDelayed(Int(Times(Power(Csch(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m")),Power(Sech(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Times(Power(Csch(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),Times(CN1,C1))),Times(Power(Sech(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C1))),Power(Times($s("b"),Plus($s("n"),Times(CN1,C1))),CN1))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("m"),$s("n")),$s("x")),ZeroQ(Plus(Plus($s("m"),$s("n")),Times(CN1,C2)))),NonzeroQ(Plus($s("n"),Times(CN1,C1)))),PosQ($s("n"))))),
SetDelayed(Int(Times(Power(Csch(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m",true)),Power(Sech(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Dist(Times(C1,Power($s("b"),CN1)),Subst(Int(Regularize(Times(Power(Plus(C1,Times(CN1,Power($s("x"),C2))),Plus(Times(Plus($s("m"),$s("n")),C1D2),Times(CN1,C1))),Power(Power($s("x"),$s("m")),CN1)),$s("x")),$s("x")),$s("x"),Tanh(Plus($s("a"),Times($s("b"),$s("x")))))),And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ(List($s("m"),$s("n")))),EvenQ(Plus($s("m"),$s("n")))),And(Less(C0,$s("m")),LessEqual($s("m"),$s("n")))))),
SetDelayed(Int(Times(Power(Csch(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m")),Power(Sech(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Power(Csch(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),C1))),Times(Power(Sech(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C1))),Power(Times($s("b"),Plus($s("n"),Times(CN1,C1))),CN1))),Times(CN1,Dist(Times(Plus($s("m"),C1),Power(Plus($s("n"),Times(CN1,C1)),CN1)),Int(Times(Power(Csch(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),C2)),Power(Sech(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C2)))),$s("x"))))),And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),RationalQ(List($s("m"),$s("n")))),Less($s("m"),CN1)),Greater($s("n"),C1)))),
SetDelayed(Int(Times(Power(Csch(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m",true)),Power(Sech(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power(Csch(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),Times(CN1,C1))),Times(Power(Sech(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C1))),Power(Times($s("b"),Plus($s("n"),Times(CN1,C1))),CN1))),Dist(Times(Plus(Plus($s("m"),$s("n")),Times(CN1,C2)),Power(Plus($s("n"),Times(CN1,C1)),CN1)),Int(Times(Power(Csch(Plus($s("a"),Times($s("b"),$s("x")))),$s("m")),Power(Sech(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C2)))),$s("x")))),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("m")),$s("x")),RationalQ($s("n"))),Greater($s("n"),C1)),Not(EvenQ(Plus($s("m"),$s("n"))))),Not(And(And(EvenQ($s("n")),OddQ($s("m"))),Greater($s("m"),C1)))))),
SetDelayed(Int(Times(Power(Csch(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m",true)),Power(Sech(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Power(Csch(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),Times(CN1,C1)))),Times(Power(Sech(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C1)),Power(Times($s("b"),Plus($s("m"),$s("n"))),CN1))),Dist(Times(Plus($s("n"),C1),Power(Plus($s("m"),$s("n")),CN1)),Int(Times(Power(Csch(Plus($s("a"),Times($s("b"),$s("x")))),$s("m")),Power(Sech(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C2))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("m")),$s("x")),RationalQ($s("n"))),Less($s("n"),CN1)),NonzeroQ(Plus($s("m"),$s("n")))))),
SetDelayed(Int(Times(Power(Sech(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m",true)),Power(Tanh(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Times(Times(CN1,Power(Sech(Plus($s("a"),Times($s("b"),$s("x")))),$s("m"))),Power(Times($s("b"),$s("m")),CN1)),And(FreeQ(List($s("a"),$s("b"),$s("m")),$s("x")),SameQ($s("n"),C1)))),
SetDelayed(Int(Times(Power(Sech(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m")),Power(Tanh(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Dist(Times(C1,Power($s("b"),CN1)),Subst(Int(Regularize(Times(Power($s("x"),$s("n")),Power(Plus(C1,Times(CN1,Power($s("x"),C2))),Times(Plus($s("m"),Times(CN1,C2)),C1D2))),$s("x")),$s("x")),$s("x"),Tanh(Plus($s("a"),Times($s("b"),$s("x")))))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("n")),$s("x")),EvenQ($s("m"))),Greater($s("m"),C2)),Not(And(OddQ($s("n")),Less(Less(C0,$s("n")),Plus($s("m"),Times(CN1,C1)))))))),
SetDelayed(Int(Times(Power(Sech(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m",true)),Power(Tanh(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Dist(Times(CN1,Power($s("b"),CN1)),Subst(Int(Regularize(Times(Power($s("x"),Plus($s("m"),Times(CN1,C1))),Power(Plus(C1,Times(CN1,Power($s("x"),C2))),Times(Plus($s("n"),Times(CN1,C1)),C1D2))),$s("x")),$s("x")),$s("x"),Sech(Plus($s("a"),Times($s("b"),$s("x")))))),And(And(FreeQ(List($s("a"),$s("b"),$s("m")),$s("x")),OddQ($s("n"))),Not(And(EvenQ($s("m")),And(Less(C0,$s("m")),LessEqual($s("m"),Plus($s("n"),C1)))))))),
SetDelayed(Int(Times(Power(Sech(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m")),Power(Tanh(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power(Sech(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),Times(CN1,C2))),Times(Power(Tanh(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C1)),Power(Times($s("b"),Plus($s("n"),C1)),CN1))),Dist(Times(Plus($s("m"),Times(CN1,C2)),Power(Plus($s("n"),C1),CN1)),Int(Times(Power(Sech(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),Times(CN1,C2))),Power(Tanh(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C2))),$s("x")))),And(And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),RationalQ(List($s("m"),$s("n")))),Greater($s("m"),C1)),Less($s("n"),CN1)),Not(EvenQ($s("m")))))),
SetDelayed(Int(Times(Power(Sech(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m")),Power(Tanh(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Power(Sech(Plus($s("a"),Times($s("b"),$s("x")))),$s("m"))),Times(Power(Tanh(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C1))),Power(Times($s("b"),$s("m")),CN1))),Dist(Times(Plus($s("n"),Times(CN1,C1)),Power($s("m"),CN1)),Int(Times(Power(Sech(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),C2)),Power(Tanh(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C2)))),$s("x")))),And(And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),RationalQ(List($s("m"),$s("n")))),Less($s("m"),CN1)),Greater($s("n"),C1)),Not(EvenQ($s("m")))))),
SetDelayed(Int(Times(Power(Sech(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m")),Power(Tanh(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Times(Times(CN1,Power(Sech(Plus($s("a"),Times($s("b"),$s("x")))),$s("m"))),Times(Power(Tanh(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C1)),Power(Times($s("b"),$s("m")),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("m"),$s("n")),$s("x")),ZeroQ(Plus(Plus($s("m"),$s("n")),C1))))),
SetDelayed(Int(Times(Power(Sech(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m")),Power(Tanh(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Power(Sech(Plus($s("a"),Times($s("b"),$s("x")))),$s("m"))),Times(Power(Tanh(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C1)),Power(Times($s("b"),$s("m")),CN1))),Dist(Times(Plus(Plus($s("m"),$s("n")),C1),Power($s("m"),CN1)),Int(Times(Power(Sech(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),C2)),Power(Tanh(Plus($s("a"),Times($s("b"),$s("x")))),$s("n"))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("n")),$s("x")),RationalQ($s("m"))),Less($s("m"),CN1)),Not(EvenQ($s("m")))))),
SetDelayed(Int(Times(Power(Sech(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m")),Power(Tanh(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power(Sech(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),Times(CN1,C2))),Times(Power(Tanh(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C1)),Power(Times($s("b"),Plus(Plus($s("m"),$s("n")),Times(CN1,C1))),CN1))),Dist(Times(Plus($s("m"),Times(CN1,C2)),Power(Plus(Plus($s("m"),$s("n")),Times(CN1,C1)),CN1)),Int(Times(Power(Sech(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),Times(CN1,C2))),Power(Tanh(Plus($s("a"),Times($s("b"),$s("x")))),$s("n"))),$s("x")))),And(And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("n")),$s("x")),RationalQ($s("m"))),Greater($s("m"),C1)),NonzeroQ(Plus(Plus($s("m"),$s("n")),Times(CN1,C1)))),Not(EvenQ($s("m")))),Not(OddQ($s("n")))))),
SetDelayed(Int(Times(Power(Sech(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m",true)),Power(Tanh(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Power(Sech(Plus($s("a"),Times($s("b"),$s("x")))),$s("m"))),Times(Power(Tanh(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C1))),Power(Times($s("b"),Plus(Plus($s("m"),$s("n")),Times(CN1,C1))),CN1))),Dist(Times(Plus($s("n"),Times(CN1,C1)),Power(Plus(Plus($s("m"),$s("n")),Times(CN1,C1)),CN1)),Int(Times(Power(Sech(Plus($s("a"),Times($s("b"),$s("x")))),$s("m")),Power(Tanh(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C2)))),$s("x")))),And(And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("m")),$s("x")),RationalQ($s("n"))),Greater($s("n"),C1)),NonzeroQ(Plus(Plus($s("m"),$s("n")),Times(CN1,C1)))),Not(EvenQ($s("m")))),Not(OddQ($s("n")))))),
SetDelayed(Int(Times(Power(Sech(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m")),Power(Tanh(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power(Sech(Plus($s("a"),Times($s("b"),$s("x")))),$s("m")),Times(Power(Tanh(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C1)),Power(Times($s("b"),Plus($s("n"),C1)),CN1))),Dist(Times(Plus(Plus($s("m"),$s("n")),C1),Power(Plus($s("n"),C1),CN1)),Int(Times(Power(Sech(Plus($s("a"),Times($s("b"),$s("x")))),$s("m")),Power(Tanh(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C2))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("m")),$s("x")),RationalQ($s("n"))),Less($s("n"),CN1)),Not(EvenQ($s("m")))))),
SetDelayed(Int(Times(Times(Power($p("x"),$p("m",true)),Power(Sech(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n",true))))),$p("p"))),Sinh(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n",true)))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Power($s("x"),Plus(Plus($s("m"),Times(CN1,$s("n"))),C1))),Times(Power(Sech(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),Plus($s("p"),Times(CN1,C1))),Power(Times(Times($s("b"),$s("n")),Plus($s("p"),Times(CN1,C1))),CN1))),Dist(Times(Plus(Plus($s("m"),Times(CN1,$s("n"))),C1),Power(Times(Times($s("b"),$s("n")),Plus($s("p"),Times(CN1,C1))),CN1)),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,$s("n")))),Power(Sech(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),Plus($s("p"),Times(CN1,C1)))),$s("x")))),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("p")),$s("x")),RationalQ($s("m"))),IntegerQ($s("n"))),GreaterEqual(Plus($s("m"),Times(CN1,$s("n"))),C0)),NonzeroQ(Plus($s("p"),Times(CN1,C1)))))),
SetDelayed(Int(Times(Times(Power($p("x"),$p("m",true)),Power(Sech(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n",true))))),$p("p",true))),Power(Tanh(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n",true))))),$p("q",true))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Power($s("x"),Plus(Plus($s("m"),Times(CN1,$s("n"))),C1))),Times(Power(Sech(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),$s("p")),Power(Times(Times($s("b"),$s("n")),$s("p")),CN1))),Dist(Times(Plus(Plus($s("m"),Times(CN1,$s("n"))),C1),Power(Times(Times($s("b"),$s("n")),$s("p")),CN1)),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,$s("n")))),Power(Sech(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),$s("p"))),$s("x")))),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("p")),$s("x")),RationalQ($s("m"))),IntegerQ($s("n"))),GreaterEqual(Plus($s("m"),Times(CN1,$s("n"))),C0)),SameQ($s("q"),C1)))),
SetDelayed(Int(Power(Sech(Times($p("b",true),Log(Times($p("c",true),Power($p("x"),$p("n",true)))))),$p("p",true)),$p("x",$s("Symbol"))),
    Condition(Int(Power(Times(C2,Power(Plus(Power(Times($s("c"),Power($s("x"),$s("n"))),$s("b")),Times(C1,Power(Power(Times($s("c"),Power($s("x"),$s("n"))),$s("b")),CN1))),CN1)),$s("p")),$s("x")),And(FreeQ($s("c"),$s("x")),RationalQ(List($s("b"),$s("n"),$s("p")))))),
SetDelayed(Int(Power(Sech(Plus($p("a",true),Times($p("b",true),Log(Times($p("c",true),Power($p("x"),$p("n",true))))))),$p("p")),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times($s("x"),Tanh(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n")))))))),Times(Power(Sech(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),Times(CN1,C2))),Power(Times(Times($s("b"),$s("n")),Plus($s("p"),Times(CN1,C1))),CN1))),Times($s("x"),Times(Power(Sech(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),Times(CN1,C2))),Power(Times(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Plus($s("p"),Times(CN1,C1))),Plus($s("p"),Times(CN1,C2))),CN1)))),Times(CN1,Dist(Times(Plus(C1,Times(CN1,Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Power(Plus($s("p"),Times(CN1,C2)),C2)))),Power(Times(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Plus($s("p"),Times(CN1,C1))),Plus($s("p"),Times(CN1,C2))),CN1)),Int(Power(Sech(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),Times(CN1,C2))),$s("x"))))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("n")),$s("x")),RationalQ($s("p"))),Greater($s("p"),C1)),Unequal($s("p"),C2)))),
SetDelayed(Int(Power(Sech(Plus($p("a",true),Times($p("b",true),Log(Times($p("c",true),Power($p("x"),$p("n",true))))))),$p("p")),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times($s("x"),Times(Power(Sech(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),$s("p")),Power(Plus(C1,Times(CN1,Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Power($s("p"),C2)))),CN1))),Times(Times(Times(Times(Times($s("b"),$s("n")),$s("p")),$s("x")),Power(Sech(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),C1))),Times(Sinh(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Power(Plus(C1,Times(CN1,Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Power($s("p"),C2)))),CN1)))),Times(CN1,Dist(Times(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),$s("p")),Times(Plus($s("p"),C1),Power(Plus(C1,Times(CN1,Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Power($s("p"),C2)))),CN1))),Int(Power(Sech(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),C2)),$s("x"))))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("n")),$s("x")),RationalQ($s("p"))),Less($s("p"),CN1)),NonzeroQ(Plus(C1,Times(CN1,Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Power($s("p"),C2)))))))),
SetDelayed(Int(Power($p("x"),Power($($p("m",$s("Sech"),true),Times($p("b",true),Log(Times($p("c",true),Power($p("x"),$p("n",true)))))),$p("p",true))),$p("x",$s("Symbol"))),
    Condition(Int(Times(Power($s("x"),$s("m")),Power(Times(C2,Power(Plus(Power(Times($s("c"),Power($s("x"),$s("n"))),$s("b")),Times(C1,Power(Power(Times($s("c"),Power($s("x"),$s("n"))),$s("b")),CN1))),CN1)),$s("p"))),$s("x")),And(FreeQ($s("c"),$s("x")),RationalQ(List($s("b"),$s("m"),$s("n"),$s("p")))))),
SetDelayed(Int(Times(Power(Sech(Plus($p("a",true),Times($p("b",true),Log(Times($p("c",true),Power($p("x"),$p("n",true))))))),C2),Power($p("x"),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Tanh(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Power(Times($s("b"),$s("n")),CN1)),FreeQ(List($s("a"),$s("b"),$s("c"),$s("n")),$s("x")))),
SetDelayed(Int(Times(Power(Sech(Plus($p("a",true),Times($p("b",true),Log(Times($p("c",true),Power($p("x"),$p("n",true))))))),$p("p")),Power($p("x"),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Tanh(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Times(Power(Sech(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),Times(CN1,C2))),Power(Times(Times($s("b"),$s("n")),Plus($s("p"),Times(CN1,C1))),CN1))),Dist(Times(Plus($s("p"),Times(CN1,C2)),Power(Plus($s("p"),Times(CN1,C1)),CN1)),Int(Times(Power(Sech(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),Times(CN1,C2))),Power($s("x"),CN1)),$s("x")))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("n")),$s("x")),RationalQ($s("p"))),Greater($s("p"),C1)))),
SetDelayed(Int(Times(Power(Sech(Plus($p("a",true),Times($p("b",true),Log(Times($p("c",true),Power($p("x"),$p("n",true))))))),$p("p")),Power($p("x"),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Power(Sech(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),C1))),Times(Sinh(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Power(Times(Times($s("b"),$s("n")),$s("p")),CN1))),Dist(Times(Plus($s("p"),C1),Power($s("p"),CN1)),Int(Times(Power(Sech(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),C2)),Power($s("x"),CN1)),$s("x")))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("n")),$s("x")),RationalQ($s("p"))),Less($s("p"),CN1)))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Sech(Plus($p("a",true),Times($p("b",true),Log(Times($p("c",true),Power($p("x"),$p("n",true))))))),$p("p"))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(Power($s("x"),Plus($s("m"),C1)),Tanh(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n")))))))),Times(Power(Sech(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),Times(CN1,C2))),Power(Times(Times($s("b"),$s("n")),Plus($s("p"),Times(CN1,C1))),CN1))),Times(Times(Plus($s("m"),C1),Power($s("x"),Plus($s("m"),C1))),Times(Power(Sech(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),Times(CN1,C2))),Power(Times(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Plus($s("p"),Times(CN1,C1))),Plus($s("p"),Times(CN1,C2))),CN1)))),Times(CN1,Dist(Times(Plus(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Power(Plus($s("p"),Times(CN1,C2)),C2)),Times(CN1,Power(Plus($s("m"),C1),C2))),Power(Times(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Plus($s("p"),Times(CN1,C1))),Plus($s("p"),Times(CN1,C2))),CN1)),Int(Times(Power($s("x"),$s("m")),Power(Sech(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),Times(CN1,C2)))),$s("x"))))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("m"),$s("n")),$s("x")),RationalQ($s("p"))),Greater($s("p"),C1)),Unequal($s("p"),C2)))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Sech(Plus($p("a",true),Times($p("b",true),Log(Times($p("c",true),Power($p("x"),$p("n",true))))))),$p("p"))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(Times(CN1,Plus($s("m"),C1)),Power($s("x"),Plus($s("m"),C1))),Times(Power(Sech(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),$s("p")),Power(Plus(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Power($s("p"),C2)),Times(CN1,Power(Plus($s("m"),C1),C2))),CN1))),Times(CN1,Times(Times(Times(Times(Times($s("b"),$s("n")),$s("p")),Power($s("x"),Plus($s("m"),C1))),Power(Sech(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),C1))),Times(Sinh(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Power(Plus(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Power($s("p"),C2)),Times(CN1,Power(Plus($s("m"),C1),C2))),CN1))))),Dist(Times(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),$s("p")),Times(Plus($s("p"),C1),Power(Plus(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Power($s("p"),C2)),Times(CN1,Power(Plus($s("m"),C1),C2))),CN1))),Int(Times(Power($s("x"),$s("m")),Power(Sech(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),C2))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("m"),$s("n")),$s("x")),RationalQ($s("p"))),Less($s("p"),CN1)),NonzeroQ(Plus(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Power($s("p"),C2)),Times(CN1,Power(Plus($s("m"),C1),C2))))))),
SetDelayed(Int(Csch(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("x",$s("Symbol"))),
    Condition(Times(Times(CN1,ArcCoth(Cosh(Plus($s("a"),Times($s("b"),$s("x")))))),Power($s("b"),CN1)),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(Times(C1,Power(Sqrt(Csch(Plus($p("a",true),Times($p("b",true),$p("x"))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Times(Sqrt(Csch(Plus($s("a"),Times($s("b"),$s("x"))))),Sqrt(Sinh(Plus($s("a"),Times($s("b"),$s("x")))))),Int(Sqrt(Sinh(Plus($s("a"),Times($s("b"),$s("x"))))),$s("x"))),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(Power(Times($p("c",true),Csch(Plus($p("a",true),Times($p("b",true),$p("x"))))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Times(Times(Power(Times($s("c"),Csch(Plus($s("a"),Times($s("b"),$s("x"))))),$s("n")),Power(Sinh(Plus($s("a"),Times($s("b"),$s("x")))),$s("n"))),Int(Times(C1,Power(Power(Sinh(Plus($s("a"),Times($s("b"),$s("x")))),$s("n")),CN1)),$s("x"))),And(And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),RationalQ($s("n"))),Less(Less(CN1,$s("n")),C1)))),
SetDelayed(Int(Power(Csch(Plus($p("a",true),Times($p("b",true),$p("x")))),C2),$p("x",$s("Symbol"))),
    Condition(Times(Times(CN1,Coth(Plus($s("a"),Times($s("b"),$s("x"))))),Power($s("b"),CN1)),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(Power(Csch(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Dist(Times(CN1,Power($s("b"),CN1)),Subst(Int(Regularize(Power(Plus(CN1,Power($s("x"),C2)),Times(Plus($s("n"),Times(CN1,C2)),C1D2)),$s("x")),$s("x")),$s("x"),Coth(Plus($s("a"),Times($s("b"),$s("x")))))),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),EvenQ($s("n"))),Greater($s("n"),C1)))),
SetDelayed(Int(Power(Times($p("c",true),Csch(Plus($p("a",true),Times($p("b",true),$p("x"))))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(Times(CN1,$s("c")),Cosh(Plus($s("a"),Times($s("b"),$s("x"))))),Times(Power(Times($s("c"),Csch(Plus($s("a"),Times($s("b"),$s("x"))))),Plus($s("n"),Times(CN1,C1))),Power(Times($s("b"),Plus($s("n"),Times(CN1,C1))),CN1))),Times(CN1,Dist(Times(Plus($s("n"),Times(CN1,C2)),Times(Power($s("c"),C2),Power(Plus($s("n"),Times(CN1,C1)),CN1))),Int(Power(Times($s("c"),Csch(Plus($s("a"),Times($s("b"),$s("x"))))),Plus($s("n"),Times(CN1,C2))),$s("x"))))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),RationalQ($s("n"))),Greater($s("n"),C1)),Not(EvenQ($s("n")))))),
SetDelayed(Int(Power(Times($p("c",true),Csch(Plus($p("a",true),Times($p("b",true),$p("x"))))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Cosh(Plus($s("a"),Times($s("b"),$s("x"))))),Times(Power(Times($s("c"),Csch(Plus($s("a"),Times($s("b"),$s("x"))))),Plus($s("n"),C1)),Power(Times(Times($s("b"),$s("c")),$s("n")),CN1))),Times(CN1,Dist(Times(Plus($s("n"),C1),Power(Times(Power($s("c"),C2),$s("n")),CN1)),Int(Power(Times($s("c"),Csch(Plus($s("a"),Times($s("b"),$s("x"))))),Plus($s("n"),C2)),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),RationalQ($s("n"))),Less($s("n"),CN1)))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Csch(Plus($p("a",true),Times($p("b",true),$p("x"))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(integer(-2L),Power($s("x"),$s("m"))),Times(ArcTanh(Power(E,Plus($s("a"),Times($s("b"),$s("x"))))),Power($s("b"),CN1))),Dist(Times(C2,Times($s("m"),Power($s("b"),CN1))),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,C1))),ArcTanh(Power(E,Plus($s("a"),Times($s("b"),$s("x")))))),$s("x")))),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ($s("m"))),Greater($s("m"),C0)))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Csch(Plus($p("a",true),Times($p("b",true),$p("x")))),C2)),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Power($s("x"),$s("m"))),Times(Coth(Plus($s("a"),Times($s("b"),$s("x")))),Power($s("b"),CN1))),Dist(Times($s("m"),Power($s("b"),CN1)),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,C1))),Coth(Plus($s("a"),Times($s("b"),$s("x"))))),$s("x")))),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),RationalQ($s("m"))),Greater($s("m"),C0)))),
SetDelayed(Int(Times($p("x"),Power(Csch(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(Times(CN1,$s("x")),Coth(Plus($s("a"),Times($s("b"),$s("x"))))),Times(Power(Csch(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C2))),Power(Times($s("b"),Plus($s("n"),Times(CN1,C1))),CN1))),Times(CN1,Times(Power(Csch(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C2))),Power(Times(Times(Power($s("b"),C2),Plus($s("n"),Times(CN1,C1))),Plus($s("n"),Times(CN1,C2))),CN1)))),Times(CN1,Dist(Times(Plus($s("n"),Times(CN1,C2)),Power(Plus($s("n"),Times(CN1,C1)),CN1)),Int(Times($s("x"),Power(Csch(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C2)))),$s("x"))))),And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),RationalQ($s("n"))),Greater($s("n"),C1)),Unequal($s("n"),C2)))),
SetDelayed(Int(Times(Power($p("x"),$p("m")),Power(Csch(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Plus(Times(Times(Times(CN1,Power($s("x"),$s("m"))),Coth(Plus($s("a"),Times($s("b"),$s("x"))))),Times(Power(Csch(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C2))),Power(Times($s("b"),Plus($s("n"),Times(CN1,C1))),CN1))),Times(CN1,Times(Times($s("m"),Power($s("x"),Plus($s("m"),Times(CN1,C1)))),Times(Power(Csch(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C2))),Power(Times(Times(Power($s("b"),C2),Plus($s("n"),Times(CN1,C1))),Plus($s("n"),Times(CN1,C2))),CN1))))),Times(CN1,Dist(Times(Plus($s("n"),Times(CN1,C2)),Power(Plus($s("n"),Times(CN1,C1)),CN1)),Int(Times(Power($s("x"),$s("m")),Power(Csch(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C2)))),$s("x"))))),Dist(Times($s("m"),Times(Plus($s("m"),Times(CN1,C1)),Power(Times(Times(Power($s("b"),C2),Plus($s("n"),Times(CN1,C1))),Plus($s("n"),Times(CN1,C2))),CN1))),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,C2))),Power(Csch(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C2)))),$s("x")))),And(And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),RationalQ(List($s("m"),$s("n")))),Greater($s("n"),C1)),Unequal($s("n"),C2)),Greater($s("m"),C1)))),
SetDelayed(Int(Times($p("x"),Power(Csch(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(CN1,Power(Csch(Plus($s("a"),Times($s("b"),$s("x")))),$s("n"))),Power(Times(Power($s("b"),C2),Power($s("n"),C2)),CN1)),Times(CN1,Times(Times($s("x"),Cosh(Plus($s("a"),Times($s("b"),$s("x"))))),Times(Power(Csch(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C1)),Power(Times($s("b"),$s("n")),CN1))))),Times(CN1,Dist(Times(Plus($s("n"),C1),Power($s("n"),CN1)),Int(Times($s("x"),Power(Csch(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C2))),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),RationalQ($s("n"))),Less($s("n"),CN1)))),
SetDelayed(Int(Times(Power($p("x"),$p("m")),Power(Csch(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Plus(Times(Times(Times(CN1,$s("m")),Power($s("x"),Plus($s("m"),Times(CN1,C1)))),Times(Power(Csch(Plus($s("a"),Times($s("b"),$s("x")))),$s("n")),Power(Times(Power($s("b"),C2),Power($s("n"),C2)),CN1))),Times(CN1,Times(Times(Power($s("x"),$s("m")),Cosh(Plus($s("a"),Times($s("b"),$s("x"))))),Times(Power(Csch(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C1)),Power(Times($s("b"),$s("n")),CN1))))),Times(CN1,Dist(Times(Plus($s("n"),C1),Power($s("n"),CN1)),Int(Times(Power($s("x"),$s("m")),Power(Csch(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C2))),$s("x"))))),Dist(Times($s("m"),Times(Plus($s("m"),Times(CN1,C1)),Power(Times(Power($s("b"),C2),Power($s("n"),C2)),CN1))),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,C2))),Power(Csch(Plus($s("a"),Times($s("b"),$s("x")))),$s("n"))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),RationalQ(List($s("m"),$s("n")))),Less($s("n"),CN1)),Greater($s("m"),C1)))),
SetDelayed(Int(Sqrt(Plus($p("a"),Times($p("b",true),Csch(Plus($p("c",true),Times($p("d",true),$p("x"))))))),$p("x",$s("Symbol"))),
    Condition(Times(Times(Times(C2,$s("a")),ArcTan(Sqrt(Plus(CN1,Times(CN1,Times(Times($s("a"),Power($s("b"),CN1)),Csch(Plus($s("c"),Times($s("d"),$s("x")))))))))),Times(Coth(Plus($s("c"),Times($s("d"),$s("x")))),Power(Times(Times($s("d"),Sqrt(Plus(CN1,Times(CN1,Times(Times($s("a"),Power($s("b"),CN1)),Csch(Plus($s("c"),Times($s("d"),$s("x"))))))))),Sqrt(Plus($s("a"),Times($s("b"),Csch(Plus($s("c"),Times($s("d"),$s("x")))))))),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),ZeroQ(Plus(Power($s("a"),C2),Power($s("b"),C2)))))),
SetDelayed(Int(Times(C1,Power(Sqrt(Plus($p("a"),Times($p("b",true),Csch(Plus($p("c",true),Times($p("d",true),$p("x"))))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Times(Times(Times(CN1,Plus(Times(Sqrt(C2),ArcTan(Times(Times(Sqrt(C2),Sqrt($s("a"))),Power(Sqrt(Plus(Times(CN1,$s("a")),Times($s("b"),Csch($s("x"))))),CN1)))),Times(C2,ArcTan(Times(Sqrt(Plus(Times(CN1,$s("a")),Times($s("b"),Csch($s("x"))))),Power(Sqrt($s("a")),CN1)))))),Sqrt(Plus(Times(CN1,$s("a")),Times($s("b"),Csch($s("x")))))),Sqrt(Plus($s("a"),Times($s("b"),Csch($s("x")))))),Times(Tanh($s("x")),Power(Power($s("a"),fraction(3L,2L)),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),ZeroQ(Plus(Power($s("a"),C2),Power($s("b"),C2)))))),
SetDelayed(Int(Power(Plus($p("a"),Times($p("b",true),Power(Csch($p("v")),$p("n",true)))),$p("m")),$p("x",$s("Symbol"))),
    Condition(Int(Times(Power(Plus($s("b"),Times($s("a"),Power(Sinh($s("v")),$s("n")))),$s("m")),Power(Power(Sinh($s("v")),Times($s("m"),$s("n"))),CN1)),$s("x")),And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ(List($s("m"),$s("n")))),Less($s("m"),C0)),Greater($s("n"),C0)))),
SetDelayed(Int(Times(Power(Sinh($p("v")),$p("p",true)),Power(Plus($p("a"),Times($p("b",true),Power(Csch($p("v")),$p("n",true)))),$p("m"))),$p("x",$s("Symbol"))),
    Condition(Int(Times(Power(Sinh($s("v")),Plus($s("p"),Times(CN1,Times($s("m"),$s("n"))))),Power(Plus($s("b"),Times($s("a"),Power(Sinh($s("v")),$s("n")))),$s("m"))),$s("x")),And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ(List($s("m"),$s("n"),$s("p")))),Less($s("m"),C0)),Greater($s("n"),C0)))),
SetDelayed(Int(Times(Csch(Plus($p("a",true),Times($p("b",true),$p("x")))),Sech(Plus($p("a",true),Times($p("b",true),$p("x"))))),$p("x",$s("Symbol"))),
    Condition(Times(Times(CN1,Log(Coth(Plus($s("a"),Times($s("b"),$s("x")))))),Power($s("b"),CN1)),And(FreeQ(List($s("a"),$s("b")),$s("x")),NegQ($s("b"))))),
SetDelayed(Int(Times(Power(Csch(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m")),Power(Sech(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Times(Times(CN1,Power(Csch(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),Times(CN1,C1)))),Times(Power(Sech(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C1))),Power(Times($s("b"),Plus($s("m"),Times(CN1,C1))),CN1))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("m"),$s("n")),$s("x")),ZeroQ(Plus(Plus($s("m"),$s("n")),Times(CN1,C2)))),NonzeroQ(Plus($s("m"),Times(CN1,C1)))),PosQ($s("m"))))),
SetDelayed(Int(Times(Power(Csch(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m")),Power(Sech(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Dist(Times(CN1,Power($s("b"),CN1)),Subst(Int(Regularize(Times(Power(Plus(CN1,Power($s("x"),C2)),Plus(Times(Plus($s("m"),$s("n")),C1D2),Times(CN1,C1))),Power(Power($s("x"),$s("n")),CN1)),$s("x")),$s("x")),$s("x"),Coth(Plus($s("a"),Times($s("b"),$s("x")))))),And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ(List($s("m"),$s("n")))),EvenQ(Plus($s("m"),$s("n")))),Less(Less(C0,$s("n")),$s("m"))))),
SetDelayed(Int(Times(Power(Csch(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m")),Power(Sech(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Power(Csch(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),Times(CN1,C1)))),Times(Power(Sech(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C1)),Power(Times($s("b"),Plus($s("m"),Times(CN1,C1))),CN1))),Times(CN1,Dist(Times(Plus($s("n"),C1),Power(Plus($s("m"),Times(CN1,C1)),CN1)),Int(Times(Power(Csch(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),Times(CN1,C2))),Power(Sech(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C2))),$s("x"))))),And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),RationalQ(List($s("m"),$s("n")))),Greater($s("m"),C1)),Less($s("n"),CN1)))),
SetDelayed(Int(Times(Power(Csch(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m")),Power(Sech(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Power(Csch(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),Times(CN1,C1)))),Times(Power(Sech(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C1))),Power(Times($s("b"),Plus($s("m"),Times(CN1,C1))),CN1))),Times(CN1,Dist(Times(Plus(Plus($s("m"),$s("n")),Times(CN1,C2)),Power(Plus($s("m"),Times(CN1,C1)),CN1)),Int(Times(Power(Csch(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),Times(CN1,C2))),Power(Sech(Plus($s("a"),Times($s("b"),$s("x")))),$s("n"))),$s("x"))))),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("n")),$s("x")),RationalQ($s("m"))),Greater($s("m"),C1)),Not(EvenQ(Plus($s("m"),$s("n"))))),Not(And(And(EvenQ($s("m")),OddQ($s("n"))),Greater($s("n"),C1)))))),
SetDelayed(Int(Times(Power(Csch(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m")),Power(Sech(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Power(Csch(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),C1))),Times(Power(Sech(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C1))),Power(Times($s("b"),Plus($s("m"),$s("n"))),CN1))),Times(CN1,Dist(Times(Plus($s("m"),C1),Power(Plus($s("m"),$s("n")),CN1)),Int(Times(Power(Csch(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),C2)),Power(Sech(Plus($s("a"),Times($s("b"),$s("x")))),$s("n"))),$s("x"))))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("n")),$s("x")),RationalQ($s("m"))),Less($s("m"),CN1)),NonzeroQ(Plus($s("m"),$s("n")))))),
SetDelayed(Int(Times(Power(Csch(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m",true)),Power(Coth(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Times(Times(CN1,Power(Csch(Plus($s("a"),Times($s("b"),$s("x")))),$s("m"))),Power(Times($s("b"),$s("m")),CN1)),And(FreeQ(List($s("a"),$s("b"),$s("m")),$s("x")),SameQ($s("n"),C1))))
  );
}
