package org.matheclipse.core.integrate.rubi;


import static org.matheclipse.core.expression.F.*;
import static org.matheclipse.core.integrate.rubi.UtilityFunctionCtors.*;
import static org.matheclipse.core.integrate.rubi.UtilityFunctions.*;
import org.matheclipse.core.interfaces.IAST;
import org.matheclipse.core.interfaces.IExpr;

/** 
 * IndefiniteIntegrationRules from the <a href="http://www.apmaths.uwo.ca/~arich/">Rubi -
 * rule-based integrator</a>.
 *  
 */
public class IndefiniteIntegrationRules0 { 
  public static IAST RULES = List( 
SetDelayed(Int($p("a"),$p("x",$s("Symbol"))),
    Condition(Times($s("a"),$s("x")),IndependentQ($s("a"),$s("x")))),
SetDelayed(Int(Times($p("c"),Plus($p("a"),Times($p("b",true),$p("x")))),$p("x",$s("Symbol"))),
    Condition(Times($s("c"),Times(Power(Plus($s("a"),Times($s("b"),$s("x"))),C2),Power(Times(C2,$s("b")),CN1))),FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")))),
SetDelayed(Int(Times($p("c"),Power(Plus($p("a"),Times($p("b",true),$p("x"))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Dist($s("c"),Int(Power(Plus($s("a"),Times($s("b"),$s("x"))),$s("n")),$s("x"))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("n")),$s("x")),NonzeroQ(Plus($s("n"),C1))))),
SetDelayed(Int(Times($p("a"),$p("u")),$p("x",$s("Symbol"))),
    Condition(Module(List(Set($s("lst"),ConstantFactor($s("u"),$s("x")))),Dist(Times($s("a"),Part($s("lst"),C1)),Int(Part($s("lst"),C2),$s("x")))),And(FreeQ($s("a"),$s("x")),Not(MatchQ($s("u"),Condition(Times($p("b"),$p("v")),FreeQ($s("b"),$s("x")))))))),
SetDelayed(Int($p("u"),$p("x",$s("Symbol"))),
    Condition(Module(List(Set($s("lst"),ConstantFactor(Simplify(Denominator($s("u"))),$s("x")))),Condition(Dist(Times(C1,Power(Part($s("lst"),C1),CN1)),Int(Times(Numerator($s("u")),Power(Part($s("lst"),C2),CN1)),$s("x"))),UnsameQ(Part($s("lst"),C1),C1))),Or(Or(Or(Or(MatchQ($s("u"),Condition(Times(C1,Power(Plus($p("a"),Times($p("b",true),$s("x"))),CN1)),FreeQ(List($s("a"),$s("b")),$s("x")))),MatchQ($s("u"),Condition(Times(Power($s("x"),$p("m",true)),Power(Plus($p("a"),Times($p("b",true),Power($s("x"),$p("n")))),CN1)),And(FreeQ(List($s("a"),$s("b"),$s("m"),$s("n")),$s("x")),ZeroQ(Plus(Plus($s("m"),Times(CN1,$s("n"))),C1)))))),MatchQ($s("u"),Condition(Times(C1,Power(Times(Plus($p("a",true),Times($p("b",true),$s("x"))),Plus($p("c"),Times($p("d",true),$s("x")))),CN1)),FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x"))))),MatchQ($s("u"),Condition(Times(Plus($p("d",true),Times($p("e",true),$s("x"))),Power(Plus(Plus($p("a"),Times($p("b",true),$s("x"))),Times($p("c",true),Power($s("x"),C2))),CN1)),FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e")),$s("x"))))),MatchQ($s("u"),Condition(Power(Times($p("c",true),Power(Plus($p("a",true),Times($p("b",true),$s("x"))),$p("n"))),$p("m")),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("m"),$s("n")),$s("x")),ZeroQ(Plus(Times($s("m"),$s("n")),C1)))))))),
SetDelayed(Int(Times($p("u"),Power($p("v"),CN1)),$p("x",$s("Symbol"))),
    Condition(Module(List(Set($s("lst"),ConstantFactor($s("v"),$s("x")))),Condition(Dist(Times(C1,Power(Part($s("lst"),C1),CN1)),Int(Times($s("u"),Power(Part($s("lst"),C2),CN1)),$s("x"))),UnsameQ(Part($s("lst"),C1),C1))),Not(FalseQ(DerivativeDivides($s("v"),$s("u"),$s("x")))))),
SetDelayed(Int(Times(Times($p("u",true),Power($p("v"),$p("m"))),Power($p("w"),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Times(Times(Power($s("v"),$s("m")),Power($s("w"),$s("n"))),Int($s("u"),$s("x"))),And(And(FreeQ(List($s("m"),$s("n")),$s("x")),ZeroQ(Plus($s("m"),$s("n")))),ZeroQ(Plus($s("v"),$s("w")))))),
SetDelayed(Int(Times(Times($p("u",true),Power(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("m",true)))),$p("p",true))),Power(Plus($p("c",true),Times($p("d",true),Power($p("x"),$p("n",true)))),$p("q",true))),$p("x",$s("Symbol"))),
    Condition(Times(Times(Power(Plus($s("a"),Times($s("b"),Power($s("x"),$s("m")))),$s("p")),Times(Power(Plus($s("c"),Times($s("d"),Power($s("x"),$s("n")))),$s("q")),Power(Power($s("x"),Times($s("m"),$s("p"))),CN1))),Int(Times($s("u"),Power($s("x"),Times($s("m"),$s("p")))),$s("x"))),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("m"),$s("n"),$s("p"),$s("q")),$s("x")),ZeroQ(Plus($s("a"),$s("d")))),ZeroQ(Plus($s("b"),$s("c")))),ZeroQ(Plus($s("m"),$s("n")))),ZeroQ(Plus($s("p"),$s("q")))))),
SetDelayed(Int(Times(C1,Power(Plus($p("a"),Times($p("b",true),$p("x"))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Log(Plus(Times(CN1,$s("a")),Times(CN1,Times($s("b"),$s("x"))))),Power($s("b"),CN1)),And(FreeQ(List($s("a"),$s("b")),$s("x")),NegativeCoefficientQ($s("a"))))),
SetDelayed(Int(Times(C1,Power(Plus($p("a",true),Times($p("b",true),$p("x"))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Log(Plus($s("a"),Times($s("b"),$s("x")))),Power($s("b"),CN1)),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(Power($p("x"),$p("n",true)),$p("x",$s("Symbol"))),
    Condition(Times(Power($s("x"),Plus($s("n"),C1)),Power(Plus($s("n"),C1),CN1)),And(IndependentQ($s("n"),$s("x")),NonzeroQ(Plus($s("n"),C1))))),
SetDelayed(Int(Power(Plus($p("a",true),Times($p("b",true),$p("x"))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Times(Power(Plus($s("a"),Times($s("b"),$s("x"))),Plus($s("n"),C1)),Power(Times($s("b"),Plus($s("n"),C1)),CN1)),And(FreeQ(List($s("a"),$s("b"),$s("n")),$s("x")),NonzeroQ(Plus($s("n"),C1))))),
SetDelayed(Int($p("u"),$p("x",$s("Symbol"))),
    Condition(IntegrateMonomialSum($s("u"),$s("x")),MonomialSumQ($s("u"),$s("x")))),
SetDelayed(IntegrateMonomialSum($p("u"),$p("x",$s("Symbol"))),
    Module(List(Set($s("lst"),Map(Function(If(FreeQ(Slot1,$s("x")),List(Slot1,C0),List(C0,Times(Times(Slot1,$s("x")),If(SameQ(Exponent(Slot1,$s("x")),CN1),Log($s("x")),Times(C1,Power(Plus(Exponent(Slot1,$s("x")),C1),CN1))))))),$s("u")))),Plus(Times(Part($s("lst"),C1),$s("x")),Part($s("lst"),C2)))),
SetDelayed(Int($p("u"),$p("x",$s("Symbol"))),
    Condition(Module(List(Set($s("lst"),SplitMonomialTerms($s("u"),$s("x")))),Condition(Plus(Int(Part($s("lst"),C1),$s("x")),SplitFreeIntegrate(Part($s("lst"),C2),$s("x"))),And(And(SumQ(Part($s("lst"),C1)),Not(FreeQ(Part($s("lst"),C1),$s("x")))),UnsameQ(Part($s("lst"),C2),C0)))),SumQ($s("u")))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),$p("u")),$p("x",$s("Symbol"))),
    Condition(Int(Map(Function(Times(Power($s("x"),$s("m")),Slot1)),$s("u")),$s("x")),And(IntegerQ($s("m")),SumQ($s("u"))))),
SetDelayed(Int(Times(C1,Power(Times($p("x"),Plus($p("a"),Times($p("b",true),Power($p("x"),$p("n",true))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(integer(-2L),Times(ArcTanh(Plus(C1,Times(Times(C2,$s("b")),Times(Power($s("x"),$s("n")),Power($s("a"),CN1))))),Power(Times($s("a"),$s("n")),CN1))),And(And(FreeQ(List($s("a"),$s("b"),$s("n")),$s("x")),PosQ($s("n"))),RationalQ(Times($s("b"),Power($s("a"),CN1)))))),
SetDelayed(Int(Times(C1,Power(Times($p("x"),Plus($p("a"),Times($p("b",true),Power($p("x"),$p("n",true))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Log($s("x")),Power($s("a"),CN1)),Times(CN1,Times(Log(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),Power(Times($s("a"),$s("n")),CN1)))),And(And(FreeQ(List($s("a"),$s("b"),$s("n")),$s("x")),PosQ($s("n"))),Not(RationalQ(Times($s("b"),Power($s("a"),CN1))))))),
SetDelayed(Int(Times(C1,Power(Times($p("x"),Plus($p("a"),Times($p("b",true),Power($p("x"),$p("n",true))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Times(CN1,Log(Plus($s("b"),Times($s("a"),Power($s("x"),Times(CN1,$s("n"))))))),Power(Times($s("a"),$s("n")),CN1)),And(FreeQ(List($s("a"),$s("b"),$s("n")),$s("x")),NegQ($s("n"))))),
SetDelayed(Int(Times(C1,Power(Plus(Times($p("a",true),$p("x")),Times($p("b",true),Power($p("x"),$p("n")))),CN1)),$p("x",$s("Symbol"))),
    Condition(Int(Times(C1,Power(Times($s("x"),Plus($s("a"),Times($s("b"),Power($s("x"),Plus($s("n"),Times(CN1,C1)))))),CN1)),$s("x")),FreeQ(List($s("a"),$s("b"),$s("n")),$s("x")))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Plus($p("a"),Times($p("b",true),$p("x"))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Times(Times(CN1,Power($s("x"),Plus($s("m"),C1))),Times(Power(Plus($s("a"),Times($s("b"),$s("x"))),Plus($s("n"),C1)),Power(Times($s("a"),Plus($s("n"),C1)),CN1))),And(And(FreeQ(List($s("a"),$s("b"),$s("m"),$s("n")),$s("x")),ZeroQ(Plus(Plus($s("m"),$s("n")),C2))),NonzeroQ(Plus($s("n"),C1))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Plus($p("a"),Times($p("b",true),$p("x"))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Power($s("x"),Plus($s("m"),C1))),Times(Power(Plus($s("a"),Times($s("b"),$s("x"))),Plus($s("n"),C1)),Power(Times($s("a"),Plus($s("n"),C1)),CN1))),Dist(Times(Plus(Plus($s("m"),$s("n")),C2),Power(Times($s("a"),Plus($s("n"),C1)),CN1)),Int(Times(Power($s("x"),$s("m")),Power(Plus($s("a"),Times($s("b"),$s("x"))),Plus($s("n"),C1))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ(List($s("m"),$s("n")))),Less(Less(C0,$s("m")),Plus(Times(CN1,$s("n")),Times(CN1,C2)))),Greater(Plus(Plus(Times(C2,$s("m")),$s("n")),C1),C0)))),
SetDelayed(Int(Times(Power($p("x"),$p("m")),Power(Plus($p("a",true),Times($p("b",true),$p("x"))),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Times(Power(Plus($s("a"),Times($s("b"),$s("x"))),$s("n")),Power(Plus(Plus($s("m"),$s("n")),C1),CN1))),Dist(Times($s("a"),Times($s("n"),Power(Plus(Plus($s("m"),$s("n")),C1),CN1))),Int(Times(Power($s("x"),$s("m")),Power(Plus($s("a"),Times($s("b"),$s("x"))),Plus($s("n"),Times(CN1,C1)))),$s("x")))),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ(List($s("m"),$s("n")))),Less(Less(C0,$s("n")),Times($s("m"),C1D2))))),
SetDelayed(Int(Times(Power($p("x"),$p("m")),Power(Plus($p("a",true),Times($p("b",true),$p("x"))),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Times(Power(Plus($s("a"),Times($s("b"),$s("x"))),Plus($s("n"),C1)),Power(Times($s("a"),Plus($s("m"),C1)),CN1))),Times(CN1,Dist(Times($s("b"),Times(Plus(Plus($s("m"),$s("n")),C2),Power(Times($s("a"),Plus($s("m"),C1)),CN1))),Int(Times(Power($s("x"),Plus($s("m"),C1)),Power(Plus($s("a"),Times($s("b"),$s("x"))),$s("n"))),$s("x"))))),And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ(List($s("m"),$s("n")))),Less(Less(C0,$s("n")),Plus(Times(CN1,$s("m")),Times(CN1,C2)))),Greater(Plus(Plus($s("m"),Times(C2,$s("n"))),Times(CN1,C1)),C0)))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Plus($p("a",true),Times($p("b",true),$p("x"))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),$s("m")),Times(Power(Plus($s("a"),Times($s("b"),$s("x"))),Plus($s("n"),C1)),Power(Times($s("b"),Plus(Plus($s("m"),$s("n")),C1)),CN1))),Times(CN1,Dist(Times($s("a"),Times($s("m"),Power(Times($s("b"),Plus(Plus($s("m"),$s("n")),C1)),CN1))),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,C1))),Power(Plus($s("a"),Times($s("b"),$s("x"))),$s("n"))),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ(List($s("m"),$s("n")))),Less(Less(C0,$s("m")),Times($s("n"),C1D2))))),
SetDelayed(Int(Times(Power(Plus($p("a"),Times($p("b",true),$p("x"))),$p("n",true)),Power(Plus($p("c"),Times($p("d",true),$p("x"))),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Int(Power(Plus(Times($s("a"),$s("c")),Times(Times($s("b"),$s("d")),Power($s("x"),C2))),$s("n")),$s("x")),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),IntegerQ($s("n"))),ZeroQ(Plus(Times($s("b"),$s("c")),Times($s("a"),$s("d"))))))),
SetDelayed(Int(Times(Power(Plus($p("a"),Times($p("b",true),$p("x"))),$p("m",true)),Power(Plus($p("c"),Times($p("d",true),$p("x"))),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Dist(Power(Times($s("d"),Power($s("b"),CN1)),$s("n")),Int(Power(Plus($s("a"),Times($s("b"),$s("x"))),Plus($s("m"),$s("n"))),$s("x"))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("m")),$s("x")),ZeroQ(Plus(Times($s("b"),$s("c")),Times(CN1,Times($s("a"),$s("d")))))),IntegerQ($s("n"))),Or(Not(IntegerQ($s("m"))),LessEqual(LeafCount(Plus($s("a"),Times($s("b"),$s("x")))),LeafCount(Plus($s("c"),Times($s("d"),$s("x"))))))))),
SetDelayed(Int(Times(C1,Power(Times(Plus($p("a"),Times($p("b",true),$p("x"))),Plus($p("c"),Times($p("d",true),$p("x")))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(integer(-2L),Times(ArcTanh(Plus(Times(Plus(Times($s("b"),$s("c")),Times($s("a"),$s("d"))),Power(Plus(Times($s("b"),$s("c")),Times(CN1,Times($s("a"),$s("d")))),CN1)),Times(Times(Times(C2,$s("b")),$s("d")),Times($s("x"),Power(Plus(Times($s("b"),$s("c")),Times(CN1,Times($s("a"),$s("d")))),CN1))))),Power(Plus(Times($s("b"),$s("c")),Times(CN1,Times($s("a"),$s("d")))),CN1))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),RationalQ(Plus(Times($s("b"),$s("c")),Times(CN1,Times($s("a"),$s("d")))))),Unequal(Plus(Times($s("b"),$s("c")),Times(CN1,Times($s("a"),$s("d")))),C0)))),
SetDelayed(Int(Times(Power(Plus($p("a"),Times($p("b",true),$p("x"))),$p("m",true)),Power(Plus($p("c"),Times($p("d",true),$p("x"))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Times(Times(CN1,Power(Plus($s("a"),Times($s("b"),$s("x"))),Plus($s("m"),C1))),Times(Power(Plus($s("c"),Times($s("d"),$s("x"))),Plus($s("n"),C1)),Power(Times(Plus($s("n"),C1),Plus(Times($s("b"),$s("c")),Times(CN1,Times($s("a"),$s("d"))))),CN1))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("m"),$s("n")),$s("x")),ZeroQ(Plus(Plus($s("m"),$s("n")),C2))),NonzeroQ(Plus(Times($s("b"),$s("c")),Times(CN1,Times($s("a"),$s("d")))))),NonzeroQ(Plus($s("n"),C1))))),
SetDelayed(Int(Times(Power(Plus($p("a"),Times($p("b",true),$p("x"))),$p("m",true)),Power(Plus($p("c"),Times($p("d",true),$p("x"))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Power(Plus($s("a"),Times($s("b"),$s("x"))),Plus($s("m"),C1))),Times(Power(Plus($s("c"),Times($s("d"),$s("x"))),Plus($s("n"),C1)),Power(Times(Plus($s("n"),C1),Plus(Times($s("b"),$s("c")),Times(CN1,Times($s("a"),$s("d"))))),CN1))),Dist(Times($s("b"),Times(Plus(Plus($s("m"),$s("n")),C2),Power(Times(Plus($s("n"),C1),Plus(Times($s("b"),$s("c")),Times(CN1,Times($s("a"),$s("d"))))),CN1))),Int(Times(Power(Plus($s("a"),Times($s("b"),$s("x"))),$s("m")),Power(Plus($s("c"),Times($s("d"),$s("x"))),Plus($s("n"),C1))),$s("x")))),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),IntegerQ(List($s("m"),$s("n")))),NonzeroQ(Plus(Times($s("b"),$s("c")),Times(CN1,Times($s("a"),$s("d")))))),Less(Less(C0,$s("m")),Plus(Times(CN1,$s("n")),Times(CN1,C2)))),Greater(Plus(Plus(Times(C2,$s("m")),$s("n")),C1),C0)))),
SetDelayed(Int(Times(Power(Plus($p("a"),Times($p("b",true),$p("x"))),$p("m")),Power(Plus($p("c"),Times($p("d",true),$p("x"))),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power(Plus($s("a"),Times($s("b"),$s("x"))),Plus($s("m"),C1)),Times(Power(Plus($s("c"),Times($s("d"),$s("x"))),$s("n")),Power(Times($s("b"),Plus(Plus($s("m"),$s("n")),C1)),CN1))),Dist(Times($s("n"),Times(Plus(Times($s("b"),$s("c")),Times(CN1,Times($s("a"),$s("d")))),Power(Times($s("b"),Plus(Plus($s("m"),$s("n")),C1)),CN1))),Int(Times(Power(Plus($s("a"),Times($s("b"),$s("x"))),$s("m")),Power(Plus($s("c"),Times($s("d"),$s("x"))),Plus($s("n"),Times(CN1,C1)))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),IntegerQ(List($s("m"),$s("n")))),NonzeroQ(Plus(Times($s("b"),$s("c")),Times(CN1,Times($s("a"),$s("d")))))),And(Less(C0,$s("n")),LessEqual($s("n"),$s("m")))))),
SetDelayed(Int(Times(Times(Power($p("x"),$p("m",true)),Power(Plus($p("a"),Times($p("b",true),$p("x"))),$p("n",true))),Power(Plus($p("c"),Times($p("d",true),$p("x"))),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Int(Times(Power($s("x"),$s("m")),Power(Plus(Times($s("a"),$s("c")),Times(Times($s("b"),$s("d")),Power($s("x"),C2))),$s("n"))),$s("x")),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("m")),$s("x")),IntegerQ($s("n"))),ZeroQ(Plus(Times($s("b"),$s("c")),Times($s("a"),$s("d"))))))),
SetDelayed(Int(Times(Power(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("n",true)))),$p("p",true)),Plus($p("c"),Times($p("d",true),Power($p("x"),$p("n",true))))),$p("x",$s("Symbol"))),
    Condition(Times(Times($s("c"),$s("x")),Times(Power(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))),Plus($s("p"),C1)),Power($s("a"),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("n"),$s("p")),$s("x")),ZeroQ(Plus(Times($s("a"),$s("d")),Times(CN1,Times(Times($s("b"),$s("c")),Plus(Times($s("n"),Plus($s("p"),C1)),C1)))))))),
SetDelayed(Int(Times(Times(Power($p("x"),$p("m",true)),Power(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("n",true)))),$p("p",true))),Plus($p("c"),Times($p("d",true),Power($p("x"),$p("n",true))))),$p("x",$s("Symbol"))),
    Condition(Times(Times($s("c"),Power($s("x"),Plus($s("m"),C1))),Times(Power(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))),Plus($s("p"),C1)),Power(Times($s("a"),Plus($s("m"),C1)),CN1))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("m"),$s("n"),$s("p")),$s("x")),NonzeroQ(Plus($s("m"),C1))),ZeroQ(Plus(Times(Times($s("a"),$s("d")),Plus($s("m"),C1)),Times(CN1,Times(Times($s("b"),$s("c")),Plus(Plus($s("m"),Times($s("n"),Plus($s("p"),C1))),C1)))))))),
SetDelayed(Int(Times(Times(Power($p("x"),$p("m",true)),Power(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("n",true)))),$p("p",true))),Plus(Times($p("c",true),Power($p("x"),$p("q",true))),Times($p("d",true),Power($p("x"),$p("r",true))))),$p("x",$s("Symbol"))),
    Condition(Times(Times($s("c"),Power($s("x"),Plus(Plus($s("m"),$s("q")),C1))),Times(Power(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))),Plus($s("p"),C1)),Power(Times($s("a"),Plus(Plus($s("m"),$s("q")),C1)),CN1))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("m"),$s("n"),$s("p"),$s("q"),$s("r")),$s("x")),NonzeroQ(Plus(Plus($s("m"),$s("q")),C1))),ZeroQ(Plus(Plus($s("n"),Times(CN1,$s("r"))),$s("q")))),ZeroQ(Plus(Times(Times($s("a"),$s("d")),Plus(Plus($s("m"),$s("q")),C1)),Times(CN1,Times(Times($s("b"),$s("c")),Plus(Plus(Plus($s("m"),$s("q")),Times($s("n"),Plus($s("p"),C1))),C1)))))))),
SetDelayed(Int(Times(Times(Power(Plus($p("a"),Times($p("b",true),$p("x"))),$p("m",true)),Power(Plus($p("c"),Times($p("d",true),$p("x"))),$p("n",true))),Plus($p("e"),Times($p("f",true),$p("x")))),$p("x",$s("Symbol"))),
    Condition(Times(Times($s("f"),Power(Plus($s("a"),Times($s("b"),$s("x"))),Plus($s("m"),C1))),Times(Power(Plus($s("c"),Times($s("d"),$s("x"))),Plus($s("n"),C1)),Power(Times(Times($s("b"),$s("d")),Plus(Plus($s("m"),$s("n")),C2)),CN1))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e"),$s("f"),$s("m"),$s("n")),$s("x")),NonzeroQ(Plus(Plus($s("m"),$s("n")),C2))),ZeroQ(Plus(Times($s("f"),Plus(Times(Times($s("b"),$s("c")),Plus($s("m"),C1)),Times(Times($s("a"),$s("d")),Plus($s("n"),C1)))),Times(CN1,Times(Times(Times($s("b"),$s("d")),$s("e")),Plus(Plus($s("m"),$s("n")),C2)))))))),
SetDelayed(Int(Times(Times($p("x"),Power(Plus($p("a"),Times($p("b",true),$p("x"))),$p("n",true))),Power(Plus($p("c"),Times($p("d",true),$p("x"))),$p("p",true))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power(Plus($s("a"),Times($s("b"),$s("x"))),Plus($s("n"),C1)),Times(Power(Plus($s("c"),Times($s("d"),$s("x"))),Plus($s("p"),C1)),Power(Times(Times($s("b"),$s("d")),Plus(Plus(C2,$s("n")),$s("p"))),CN1))),Times(CN1,Dist(Times(Plus(Times(Times($s("b"),$s("c")),Plus($s("n"),C1)),Times(Times($s("a"),$s("d")),Plus($s("p"),C1))),Power(Times(Times($s("b"),$s("d")),Plus(Plus(C2,$s("n")),$s("p"))),CN1)),Int(Times(Power(Plus($s("a"),Times($s("b"),$s("x"))),$s("n")),Power(Plus($s("c"),Times($s("d"),$s("x"))),$s("p"))),$s("x"))))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("n"),$s("p")),$s("x")),IntegerQ(List($s("n"),$s("p")))),And(Less(C0,$s("n")),LessEqual($s("n"),C2))),Greater($s("p"),C5)))),
SetDelayed(Int(Times(Times(Power($p("x"),$p("m")),Power(Plus($p("a"),Times($p("b",true),$p("x"))),$p("n",true))),Power(Plus($p("c"),Times($p("d",true),$p("x"))),$p("p",true))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(Power($s("x"),Plus($s("m"),Times(CN1,C1))),Power(Plus($s("a"),Times($s("b"),$s("x"))),Plus($s("n"),C1))),Times(Power(Plus($s("c"),Times($s("d"),$s("x"))),Plus($s("p"),C1)),Power(Times(Times($s("b"),$s("d")),Plus(Plus(Plus(C1,$s("m")),$s("n")),$s("p"))),CN1))),Times(CN1,Dist(Times(Times($s("a"),$s("c")),Times(Plus($s("m"),Times(CN1,C1)),Power(Times(Times($s("b"),$s("d")),Plus(Plus(Plus(C1,$s("m")),$s("n")),$s("p"))),CN1))),Int(Times(Times(Power($s("x"),Plus($s("m"),Times(CN1,C2))),Power(Plus($s("a"),Times($s("b"),$s("x"))),$s("n"))),Power(Plus($s("c"),Times($s("d"),$s("x"))),$s("p"))),$s("x"))))),Times(CN1,Dist(Times(Plus(Times(Times($s("b"),$s("c")),Plus($s("m"),$s("n"))),Times(Times($s("a"),$s("d")),Plus($s("m"),$s("p")))),Power(Times(Times($s("b"),$s("d")),Plus(Plus(Plus(C1,$s("m")),$s("n")),$s("p"))),CN1)),Int(Times(Times(Power($s("x"),Plus($s("m"),Times(CN1,C1))),Power(Plus($s("a"),Times($s("b"),$s("x"))),$s("n"))),Power(Plus($s("c"),Times($s("d"),$s("x"))),$s("p"))),$s("x"))))),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("n"),$s("p")),$s("x")),IntegerQ(List($s("m"),$s("n"),$s("p")))),And(Less(C0,$s("m")),LessEqual($s("m"),C2))),And(Less(C0,$s("n")),LessEqual($s("n"),C2))),Greater($s("p"),C5)))),
SetDelayed(Int(Times(C1,Power(Plus($p("a"),Times($p("b",true),Power($p("x"),C2))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Rt(Times($s("b"),Power($s("a"),CN1)),C2),Times(ArcTan(Times(Rt(Times($s("b"),Power($s("a"),CN1)),C2),$s("x"))),Power($s("b"),CN1))),And(FreeQ(List($s("a"),$s("b")),$s("x")),PosQ(Times($s("a"),Power($s("b"),CN1)))))),
SetDelayed(Int(Times(C1,Power(Plus($p("a"),Times($p("b",true),Power($p("x"),C2))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Times(CN1,Rt(Times(Times(CN1,$s("b")),Power($s("a"),CN1)),C2)),Times(ArcTanh(Times(Rt(Times(Times(CN1,$s("b")),Power($s("a"),CN1)),C2),$s("x"))),Power($s("b"),CN1))),And(FreeQ(List($s("a"),$s("b")),$s("x")),NegQ(Times($s("a"),Power($s("b"),CN1)))))),
SetDelayed(Int(Times(C1,Power(Plus($p("a"),Times($p("b",true),Power($p("x"),C3))),CN1)),$p("x",$s("Symbol"))),
    Condition(Module(List(Set($s("r"),Numerator(Rt(Times($s("a"),Power($s("b"),CN1)),C3))),Set($s("s"),Denominator(Rt(Times($s("a"),Power($s("b"),CN1)),C3)))),Plus(Dist(Times($s("r"),Power(Times(C3,$s("a")),CN1)),Int(Times(C1,Power(Plus($s("r"),Times($s("s"),$s("x"))),CN1)),$s("x"))),Dist(Times($s("r"),Power(Times(C3,$s("a")),CN1)),Int(Times(Plus(Times(C2,$s("r")),Times(CN1,Times($s("s"),$s("x")))),Power(Plus(Plus(Power($s("r"),C2),Times(CN1,Times(Times($s("r"),$s("s")),$s("x")))),Times(Power($s("s"),C2),Power($s("x"),C2))),CN1)),$s("x"))))),And(FreeQ(List($s("a"),$s("b")),$s("x")),PosQ(Times($s("a"),Power($s("b"),CN1)))))),
SetDelayed(Int(Times(C1,Power(Plus($p("a"),Times($p("b",true),Power($p("x"),C3))),CN1)),$p("x",$s("Symbol"))),
    Condition(Module(List(Set($s("r"),Numerator(Rt(Times(Times(CN1,$s("a")),Power($s("b"),CN1)),C3))),Set($s("s"),Denominator(Rt(Times(Times(CN1,$s("a")),Power($s("b"),CN1)),C3)))),Plus(Dist(Times($s("r"),Power(Times(C3,$s("a")),CN1)),Int(Times(C1,Power(Plus($s("r"),Times(CN1,Times($s("s"),$s("x")))),CN1)),$s("x"))),Dist(Times($s("r"),Power(Times(C3,$s("a")),CN1)),Int(Times(Plus(Times(C2,$s("r")),Times($s("s"),$s("x"))),Power(Plus(Plus(Power($s("r"),C2),Times(Times($s("r"),$s("s")),$s("x"))),Times(Power($s("s"),C2),Power($s("x"),C2))),CN1)),$s("x"))))),And(FreeQ(List($s("a"),$s("b")),$s("x")),NegQ(Times($s("a"),Power($s("b"),CN1)))))),
SetDelayed(Int(Times(C1,Power(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("n")))),CN1)),$p("x",$s("Symbol"))),
    Condition(Module(List(Set($s("r"),Numerator(Rt(Times($s("a"),Power($s("b"),CN1)),C4))),Set($s("s"),Denominator(Rt(Times($s("a"),Power($s("b"),CN1)),C4)))),Plus(Dist(Times($s("r"),Power(Times(Times(C2,Sqrt(C2)),$s("a")),CN1)),Int(Times(Plus(Times(Sqrt(C2),$s("r")),Times(CN1,Times($s("s"),Power($s("x"),Times($s("n"),C1D4))))),Power(Plus(Plus(Power($s("r"),C2),Times(CN1,Times(Times(Times(Sqrt(C2),$s("r")),$s("s")),Power($s("x"),Times($s("n"),C1D4))))),Times(Power($s("s"),C2),Power($s("x"),Times($s("n"),C1D2)))),CN1)),$s("x"))),Dist(Times($s("r"),Power(Times(Times(C2,Sqrt(C2)),$s("a")),CN1)),Int(Times(Plus(Times(Sqrt(C2),$s("r")),Times($s("s"),Power($s("x"),Times($s("n"),C1D4)))),Power(Plus(Plus(Power($s("r"),C2),Times(Times(Times(Sqrt(C2),$s("r")),$s("s")),Power($s("x"),Times($s("n"),C1D4)))),Times(Power($s("s"),C2),Power($s("x"),Times($s("n"),C1D2)))),CN1)),$s("x"))))),And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),EvenQ(Times($s("n"),C1D2))),Greater($s("n"),C2)),PosQ(Times($s("a"),Power($s("b"),CN1)))))),
SetDelayed(Int(Times(C1,Power(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("n")))),CN1)),$p("x",$s("Symbol"))),
    Condition(Module(List(Set($s("r"),Numerator(Rt(Times(Times(CN1,$s("a")),Power($s("b"),CN1)),C2))),Set($s("s"),Denominator(Rt(Times(Times(CN1,$s("a")),Power($s("b"),CN1)),C2)))),Plus(Dist(Times($s("r"),Power(Times(C2,$s("a")),CN1)),Int(Times(C1,Power(Plus($s("r"),Times(CN1,Times($s("s"),Power($s("x"),Times($s("n"),C1D2))))),CN1)),$s("x"))),Dist(Times($s("r"),Power(Times(C2,$s("a")),CN1)),Int(Times(C1,Power(Plus($s("r"),Times($s("s"),Power($s("x"),Times($s("n"),C1D2)))),CN1)),$s("x"))))),And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),EvenQ(Times($s("n"),C1D2))),Greater($s("n"),C2)),NegQ(Times($s("a"),Power($s("b"),CN1)))))),
SetDelayed(Int(Times(C1,Power(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("n")))),CN1)),$p("x",$s("Symbol"))),
    Condition(Module(List(Set($s("r"),Numerator(Rt(Times($s("a"),Power($s("b"),CN1)),Times($s("n"),C1D2)))),Set($s("s"),Denominator(Rt(Times($s("a"),Power($s("b"),CN1)),Times($s("n"),C1D2))))),Plus(Dist(Times(C2,Times($s("r"),Power(Times($s("a"),$s("n")),CN1))),Int(Times(C1,Power(Plus($s("r"),Times($s("s"),Power($s("x"),C2))),CN1)),$s("x"))),Dist(Times(C4,Times($s("r"),Power(Times($s("a"),$s("n")),CN1))),Int(Sum(Times(Plus($s("r"),Times(CN1,Times(Times($s("s"),Cos(Times(Times(C2,Plus(Times(C2,$s("k")),Times(CN1,C1))),Times(Pi,Power($s("n"),CN1))))),Power($s("x"),C2)))),Power(Plus(Plus(Power($s("r"),C2),Times(CN1,Times(Times(Times(Times(C2,$s("r")),$s("s")),Cos(Times(Times(C2,Plus(Times(C2,$s("k")),Times(CN1,C1))),Times(Pi,Power($s("n"),CN1))))),Power($s("x"),C2)))),Times(Power($s("s"),C2),Power($s("x"),C4))),CN1)),List($s("k"),C1,Times(Plus(Times($s("n"),C1D2),Times(CN1,C1)),C1D2))),$s("x"))))),And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),OddQ(Times($s("n"),C1D2))),Greater($s("n"),C2)),PosQ(Times($s("a"),Power($s("b"),CN1)))))),
SetDelayed(Int(Times(C1,Power(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("n")))),CN1)),$p("x",$s("Symbol"))),
    Condition(Module(List(Set($s("r"),Numerator(Rt(Times(Times(CN1,$s("a")),Power($s("b"),CN1)),Times($s("n"),C1D2)))),Set($s("s"),Denominator(Rt(Times(Times(CN1,$s("a")),Power($s("b"),CN1)),Times($s("n"),C1D2))))),Plus(Dist(Times(C2,Times($s("r"),Power(Times($s("a"),$s("n")),CN1))),Int(Times(C1,Power(Plus($s("r"),Times(CN1,Times($s("s"),Power($s("x"),C2)))),CN1)),$s("x"))),Dist(Times(C4,Times($s("r"),Power(Times($s("a"),$s("n")),CN1))),Int(Sum(Times(Plus($s("r"),Times(CN1,Times(Times($s("s"),Cos(Times(Times(C4,$s("k")),Times(Pi,Power($s("n"),CN1))))),Power($s("x"),C2)))),Power(Plus(Plus(Power($s("r"),C2),Times(CN1,Times(Times(Times(Times(C2,$s("r")),$s("s")),Cos(Times(Times(C4,$s("k")),Times(Pi,Power($s("n"),CN1))))),Power($s("x"),C2)))),Times(Power($s("s"),C2),Power($s("x"),C4))),CN1)),List($s("k"),C1,Times(Plus(Times($s("n"),C1D2),Times(CN1,C1)),C1D2))),$s("x"))))),And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),OddQ(Times($s("n"),C1D2))),Greater($s("n"),C2)),NegQ(Times($s("a"),Power($s("b"),CN1)))))),
SetDelayed(Int(Times(C1,Power(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("n")))),CN1)),$p("x",$s("Symbol"))),
    Condition(Module(List(Set($s("r"),Numerator(Rt(Times($s("a"),Power($s("b"),CN1)),$s("n")))),Set($s("s"),Denominator(Rt(Times($s("a"),Power($s("b"),CN1)),$s("n"))))),Int(Plus(Times($s("r"),Power(Times(Times($s("a"),$s("n")),Plus($s("r"),Times($s("s"),$s("x")))),CN1)),Sum(Times(Times(C2,$s("r")),Times(Plus($s("r"),Times(CN1,Times(Times($s("s"),Cos(Times(Plus(Times(C2,$s("k")),Times(CN1,C1)),Times(Pi,Power($s("n"),CN1))))),$s("x")))),Power(Times(Times($s("a"),$s("n")),Plus(Plus(Power($s("r"),C2),Times(CN1,Times(Times(Times(Times(C2,$s("r")),$s("s")),Cos(Times(Plus(Times(C2,$s("k")),Times(CN1,C1)),Times(Pi,Power($s("n"),CN1))))),$s("x")))),Times(Power($s("s"),C2),Power($s("x"),C2)))),CN1))),List($s("k"),C1,Times(Plus($s("n"),Times(CN1,C1)),C1D2)))),$s("x"))),And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),OddQ($s("n"))),Greater($s("n"),C1)),PosQ(Times($s("a"),Power($s("b"),CN1)))))),
SetDelayed(Int(Times(C1,Power(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("n")))),CN1)),$p("x",$s("Symbol"))),
    Condition(Module(List(Set($s("r"),Numerator(Rt(Times(Times(CN1,$s("a")),Power($s("b"),CN1)),$s("n")))),Set($s("s"),Denominator(Rt(Times(Times(CN1,$s("a")),Power($s("b"),CN1)),$s("n"))))),Int(Plus(Times($s("r"),Power(Times(Times($s("a"),$s("n")),Plus($s("r"),Times(CN1,Times($s("s"),$s("x"))))),CN1)),Sum(Times(Times(C2,$s("r")),Times(Plus($s("r"),Times(Times($s("s"),Cos(Times(Plus(Times(C2,$s("k")),Times(CN1,C1)),Times(Pi,Power($s("n"),CN1))))),$s("x"))),Power(Times(Times($s("a"),$s("n")),Plus(Plus(Power($s("r"),C2),Times(Times(Times(Times(C2,$s("r")),$s("s")),Cos(Times(Plus(Times(C2,$s("k")),Times(CN1,C1)),Times(Pi,Power($s("n"),CN1))))),$s("x"))),Times(Power($s("s"),C2),Power($s("x"),C2)))),CN1))),List($s("k"),C1,Times(Plus($s("n"),Times(CN1,C1)),C1D2)))),$s("x"))),And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),OddQ($s("n"))),Greater($s("n"),C1)),NegQ(Times($s("a"),Power($s("b"),CN1)))))),
SetDelayed(Int(Times($p("x"),Power(Plus($p("a"),Times($p("b",true),Power($p("x"),C3))),CN1)),$p("x",$s("Symbol"))),
    Condition(Module(List(Set($s("r"),Numerator(Rt(Times($s("a"),Power($s("b"),CN1)),C3))),Set($s("s"),Denominator(Rt(Times($s("a"),Power($s("b"),CN1)),C3)))),Plus(Dist(Times(Times(CN1,Power($s("r"),C2)),Power(Times(Times(C3,$s("a")),$s("s")),CN1)),Int(Times(C1,Power(Plus($s("r"),Times($s("s"),$s("x"))),CN1)),$s("x"))),Dist(Times(Power($s("r"),C2),Power(Times(Times(C3,$s("a")),$s("s")),CN1)),Int(Times(Plus($s("r"),Times($s("s"),$s("x"))),Power(Plus(Plus(Power($s("r"),C2),Times(CN1,Times(Times($s("r"),$s("s")),$s("x")))),Times(Power($s("s"),C2),Power($s("x"),C2))),CN1)),$s("x"))))),And(FreeQ(List($s("a"),$s("b")),$s("x")),PosQ(Times($s("a"),Power($s("b"),CN1)))))),
SetDelayed(Int(Times($p("x"),Power(Plus($p("a"),Times($p("b",true),Power($p("x"),C3))),CN1)),$p("x",$s("Symbol"))),
    Condition(Module(List(Set($s("r"),Numerator(Rt(Times(Times(CN1,$s("a")),Power($s("b"),CN1)),C3))),Set($s("s"),Denominator(Rt(Times(Times(CN1,$s("a")),Power($s("b"),CN1)),C3)))),Plus(Dist(Times(Power($s("r"),C2),Power(Times(Times(C3,$s("a")),$s("s")),CN1)),Int(Times(C1,Power(Plus($s("r"),Times(CN1,Times($s("s"),$s("x")))),CN1)),$s("x"))),Times(CN1,Dist(Times(Power($s("r"),C2),Power(Times(Times(C3,$s("a")),$s("s")),CN1)),Int(Times(Plus($s("r"),Times(CN1,Times($s("s"),$s("x")))),Power(Plus(Plus(Power($s("r"),C2),Times(Times($s("r"),$s("s")),$s("x"))),Times(Power($s("s"),C2),Power($s("x"),C2))),CN1)),$s("x")))))),And(FreeQ(List($s("a"),$s("b")),$s("x")),NegQ(Times($s("a"),Power($s("b"),CN1)))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("n")))),CN1)),$p("x",$s("Symbol"))),
    Condition(Module(List(Set($s("g"),GCD(Plus($s("m"),C1),$s("n")))),Condition(Dist(Times(C1,Power($s("g"),CN1)),Subst(Int(Times(Power($s("x"),Plus(Times(Plus($s("m"),C1),Power($s("g"),CN1)),Times(CN1,C1))),Power(Plus($s("a"),Times($s("b"),Power($s("x"),Times($s("n"),Power($s("g"),CN1))))),CN1)),$s("x")),$s("x"),Power($s("x"),$s("g")))),Greater($s("g"),C1))),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ(List($s("m"),$s("n")))),Less(Less(C0,Plus($s("m"),C1)),$s("n"))))),
SetDelayed(Int(Times(Power($p("x"),$p("m")),Power(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("n")))),CN1)),$p("x",$s("Symbol"))),
    Condition(Module(List(Set($s("r"),Numerator(Rt(Times($s("a"),Power($s("b"),CN1)),C4))),Set($s("s"),Denominator(Rt(Times($s("a"),Power($s("b"),CN1)),C4)))),Plus(Dist(Times(Power($s("s"),C3),Power(Times(Times(Times(C2,Sqrt(C2)),$s("b")),$s("r")),CN1)),Int(Times(Power($s("x"),Times($s("m"),C1D2)),Power(Plus(Plus(Power($s("r"),C2),Times(CN1,Times(Times(Times(Sqrt(C2),$s("r")),$s("s")),Power($s("x"),Times($s("m"),C1D2))))),Times(Power($s("s"),C2),Power($s("x"),$s("m")))),CN1)),$s("x"))),Times(CN1,Dist(Times(Power($s("s"),C3),Power(Times(Times(Times(C2,Sqrt(C2)),$s("b")),$s("r")),CN1)),Int(Times(Power($s("x"),Times($s("m"),C1D2)),Power(Plus(Plus(Power($s("r"),C2),Times(Times(Times(Sqrt(C2),$s("r")),$s("s")),Power($s("x"),Times($s("m"),C1D2)))),Times(Power($s("s"),C2),Power($s("x"),$s("m")))),CN1)),$s("x")))))),And(And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),EvenQ($s("m"))),Greater($s("m"),C0)),SameQ($s("n"),Times(C2,$s("m")))),PosQ(Times($s("a"),Power($s("b"),CN1)))))),
SetDelayed(Int(Times(Power($p("x"),$p("m")),Power(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("n")))),CN1)),$p("x",$s("Symbol"))),
    Condition(Module(List(Set($s("r"),Numerator(Rt(Times(Times(CN1,$s("a")),Power($s("b"),CN1)),C2))),Set($s("s"),Denominator(Rt(Times(Times(CN1,$s("a")),Power($s("b"),CN1)),C2)))),Plus(Dist(Times($s("s"),Power(Times(C2,$s("b")),CN1)),Int(Times(C1,Power(Plus($s("r"),Times($s("s"),Power($s("x"),$s("m")))),CN1)),$s("x"))),Times(CN1,Dist(Times($s("s"),Power(Times(C2,$s("b")),CN1)),Int(Times(C1,Power(Plus($s("r"),Times(CN1,Times($s("s"),Power($s("x"),$s("m"))))),CN1)),$s("x")))))),And(And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),EvenQ($s("m"))),Greater($s("m"),C0)),SameQ($s("n"),Times(C2,$s("m")))),NegQ(Times($s("a"),Power($s("b"),CN1)))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("n")))),CN1)),$p("x",$s("Symbol"))),
    Condition(Module(List(Set($s("r"),Numerator(Rt(Times($s("a"),Power($s("b"),CN1)),Times($s("n"),C1D2)))),Set($s("s"),Denominator(Rt(Times($s("a"),Power($s("b"),CN1)),Times($s("n"),C1D2))))),Plus(Dist(Times(integer(-2L),Times(Power(Times(CN1,$s("r")),Plus(Times($s("m"),C1D2),C1)),Power(Times(Times($s("a"),$s("n")),Power($s("s"),Times($s("m"),C1D2))),CN1))),Int(Times(C1,Power(Plus($s("r"),Times($s("s"),Power($s("x"),C2))),CN1)),$s("x"))),Dist(Times(C4,Times(Power($s("r"),Plus(Times($s("m"),C1D2),C1)),Power(Times(Times($s("a"),$s("n")),Power($s("s"),Times($s("m"),C1D2))),CN1))),Int(Sum(Times(Plus(Times($s("r"),Cos(Times(Times(Plus(Times(C2,$s("k")),Times(CN1,C1)),$s("m")),Times(Pi,Power($s("n"),CN1))))),Times(CN1,Times(Times($s("s"),Cos(Times(Times(Plus(Times(C2,$s("k")),Times(CN1,C1)),Plus($s("m"),C2)),Times(Pi,Power($s("n"),CN1))))),Power($s("x"),C2)))),Power(Plus(Plus(Power($s("r"),C2),Times(CN1,Times(Times(Times(Times(C2,$s("r")),$s("s")),Cos(Times(Times(C2,Plus(Times(C2,$s("k")),Times(CN1,C1))),Times(Pi,Power($s("n"),CN1))))),Power($s("x"),C2)))),Times(Power($s("s"),C2),Power($s("x"),C4))),CN1)),List($s("k"),C1,Times(Plus(Times($s("n"),C1D2),Times(CN1,C1)),C1D2))),$s("x"))))),And(And(And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),OddQ(Times($s("n"),C1D2))),EvenQ($s("m"))),Less(Less(C0,$s("m")),$s("n"))),Equal(GCD(Plus($s("m"),C1),$s("n")),C1)),PosQ(Times($s("a"),Power($s("b"),CN1)))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("n")))),CN1)),$p("x",$s("Symbol"))),
    Condition(Module(List(Set($s("r"),Numerator(Rt(Times(Times(CN1,$s("a")),Power($s("b"),CN1)),Times($s("n"),C1D2)))),Set($s("s"),Denominator(Rt(Times(Times(CN1,$s("a")),Power($s("b"),CN1)),Times($s("n"),C1D2))))),Plus(Dist(Times(C2,Times(Power($s("r"),Plus(Times($s("m"),C1D2),C1)),Power(Times(Times($s("a"),$s("n")),Power($s("s"),Times($s("m"),C1D2))),CN1))),Int(Times(C1,Power(Plus($s("r"),Times(CN1,Times($s("s"),Power($s("x"),C2)))),CN1)),$s("x"))),Dist(Times(C4,Times(Power($s("r"),Plus(Times($s("m"),C1D2),C1)),Power(Times(Times($s("a"),$s("n")),Power($s("s"),Times($s("m"),C1D2))),CN1))),Int(Sum(Times(Plus(Times($s("r"),Cos(Times(Times(Times(C2,$s("k")),$s("m")),Times(Pi,Power($s("n"),CN1))))),Times(CN1,Times(Times($s("s"),Cos(Times(Times(Times(C2,$s("k")),Plus($s("m"),C2)),Times(Pi,Power($s("n"),CN1))))),Power($s("x"),C2)))),Power(Plus(Plus(Power($s("r"),C2),Times(CN1,Times(Times(Times(Times(C2,$s("r")),$s("s")),Cos(Times(Times(C4,$s("k")),Times(Pi,Power($s("n"),CN1))))),Power($s("x"),C2)))),Times(Power($s("s"),C2),Power($s("x"),C4))),CN1)),List($s("k"),C1,Times(Plus(Times($s("n"),C1D2),Times(CN1,C1)),C1D2))),$s("x"))))),And(And(And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),OddQ(Times($s("n"),C1D2))),EvenQ($s("m"))),Less(Less(C0,$s("m")),$s("n"))),Equal(GCD(Plus($s("m"),C1),$s("n")),C1)),NegQ(Times($s("a"),Power($s("b"),CN1)))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("n")))),CN1)),$p("x",$s("Symbol"))),
    Condition(Module(List(Set($s("r"),Numerator(Rt(Times($s("a"),Power($s("b"),CN1)),$s("n")))),Set($s("s"),Denominator(Rt(Times($s("a"),Power($s("b"),CN1)),$s("n"))))),Int(Plus(Times(Times(Times(CN1,Power(Times(CN1,$s("r")),Plus($s("m"),C1))),Power(Power($s("s"),$s("m")),CN1)),Power(Times(Times($s("a"),$s("n")),Plus($s("r"),Times($s("s"),$s("x")))),CN1)),Sum(Times(Times(C2,Times(Power($s("r"),Plus($s("m"),C1)),Power(Power($s("s"),$s("m")),CN1))),Times(Plus(Times($s("r"),Cos(Times(Times(Plus(Times(C2,$s("k")),Times(CN1,C1)),$s("m")),Times(Pi,Power($s("n"),CN1))))),Times(CN1,Times(Times($s("s"),Cos(Times(Times(Plus(Times(C2,$s("k")),Times(CN1,C1)),Plus($s("m"),C1)),Times(Pi,Power($s("n"),CN1))))),$s("x")))),Power(Times(Times($s("a"),$s("n")),Plus(Plus(Power($s("r"),C2),Times(CN1,Times(Times(Times(Times(C2,$s("r")),$s("s")),Cos(Times(Plus(Times(C2,$s("k")),Times(CN1,C1)),Times(Pi,Power($s("n"),CN1))))),$s("x")))),Times(Power($s("s"),C2),Power($s("x"),C2)))),CN1))),List($s("k"),C1,Times(Plus($s("n"),Times(CN1,C1)),C1D2)))),$s("x"))),And(And(And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),OddQ($s("n"))),IntegerQ($s("m"))),Less(Less(C0,$s("m")),$s("n"))),Equal(GCD(Plus($s("m"),C1),$s("n")),C1)),PosQ(Times($s("a"),Power($s("b"),CN1)))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("n")))),CN1)),$p("x",$s("Symbol"))),
    Condition(Module(List(Set($s("r"),Numerator(Rt(Times(Times(CN1,$s("a")),Power($s("b"),CN1)),$s("n")))),Set($s("s"),Denominator(Rt(Times(Times(CN1,$s("a")),Power($s("b"),CN1)),$s("n"))))),Int(Plus(Times(Power($s("r"),Plus($s("m"),C1)),Power(Times(Times(Times($s("a"),$s("n")),Power($s("s"),$s("m"))),Plus($s("r"),Times(CN1,Times($s("s"),$s("x"))))),CN1)),Times(CN1,Sum(Times(Times(C2,Times(Power(Times(CN1,$s("r")),Plus($s("m"),C1)),Power(Power($s("s"),$s("m")),CN1))),Times(Plus(Times($s("r"),Cos(Times(Times(Plus(Times(C2,$s("k")),Times(CN1,C1)),$s("m")),Times(Pi,Power($s("n"),CN1))))),Times(Times($s("s"),Cos(Times(Times(Plus(Times(C2,$s("k")),Times(CN1,C1)),Plus($s("m"),C1)),Times(Pi,Power($s("n"),CN1))))),$s("x"))),Power(Times(Times($s("a"),$s("n")),Plus(Plus(Power($s("r"),C2),Times(Times(Times(Times(C2,$s("r")),$s("s")),Cos(Times(Plus(Times(C2,$s("k")),Times(CN1,C1)),Times(Pi,Power($s("n"),CN1))))),$s("x"))),Times(Power($s("s"),C2),Power($s("x"),C2)))),CN1))),List($s("k"),C1,Times(Plus($s("n"),Times(CN1,C1)),C1D2))))),$s("x"))),And(And(And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),OddQ($s("n"))),IntegerQ($s("m"))),Less(Less(C0,$s("m")),$s("n"))),Equal(GCD(Plus($s("m"),C1),$s("n")),C1)),NegQ(Times($s("a"),Power($s("b"),CN1)))))),
SetDelayed(Int(Times(Plus($p("c",true),Times($p("d",true),Power($p("x"),$p("m")))),Power(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("n")))),CN1)),$p("x",$s("Symbol"))),
    Condition(Module(List(Set($s("q"),Rt(Times($s("a"),Power($s("b"),CN1)),C4))),Plus(Dist(Times($s("q"),Power(Times(Times(C2,Sqrt(C2)),$s("a")),CN1)),Int(Times(Plus(Times(Times(Sqrt(C2),$s("c")),$s("q")),Times(Plus($s("c"),Times(CN1,Times($s("d"),Power($s("q"),C2)))),Power($s("x"),Times($s("m"),C1D2)))),Power(Plus(Plus(Power($s("q"),C2),Times(Times(Sqrt(C2),$s("q")),Power($s("x"),Times($s("m"),C1D2)))),Power($s("x"),$s("m"))),CN1)),$s("x"))),Dist(Times($s("q"),Power(Times(Times(C2,Sqrt(C2)),$s("a")),CN1)),Int(Times(Plus(Times(Times(Sqrt(C2),$s("c")),$s("q")),Times(CN1,Times(Plus($s("c"),Times(CN1,Times($s("d"),Power($s("q"),C2)))),Power($s("x"),Times($s("m"),C1D2))))),Power(Plus(Plus(Power($s("q"),C2),Times(CN1,Times(Times(Sqrt(C2),$s("q")),Power($s("x"),Times($s("m"),C1D2))))),Power($s("x"),$s("m"))),CN1)),$s("x"))))),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),EvenQ($s("m"))),Greater($s("m"),C0)),SameQ($s("n"),Times(C2,$s("m")))),PosQ(Times($s("a"),Power($s("b"),CN1)))))),
SetDelayed(Int(Times(Plus($p("c",true),Times($p("d",true),Power($p("x"),$p("m")))),Power(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("n")))),CN1)),$p("x",$s("Symbol"))),
    Condition(Module(List(Set($s("q"),Rt(Times(Times(CN1,$s("a")),Power($s("b"),CN1)),C2))),Plus(Dist(Times(Plus($s("c"),Times($s("d"),$s("q"))),C1D2),Int(Times(C1,Power(Plus($s("a"),Times(Times($s("b"),$s("q")),Power($s("x"),$s("m")))),CN1)),$s("x"))),Dist(Times(Plus($s("c"),Times(CN1,Times($s("d"),$s("q")))),C1D2),Int(Times(C1,Power(Plus($s("a"),Times(CN1,Times(Times($s("b"),$s("q")),Power($s("x"),$s("m"))))),CN1)),$s("x"))))),And(And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),EvenQ($s("m"))),Greater($s("m"),C0)),SameQ($s("n"),Times(C2,$s("m")))),NegQ(Times($s("a"),Power($s("b"),CN1)))),NonzeroQ(Plus(Times($s("b"),Power($s("c"),C2)),Times($s("a"),Power($s("d"),C2))))))),
SetDelayed(Int(Power(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("n")))),$p("p")),$p("x",$s("Symbol"))),
    Condition(Times($s("x"),Times(Power(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))),Plus($s("p"),C1)),Power($s("a"),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("n"),$s("p")),$s("x")),ZeroQ(Plus(Times($s("n"),Plus($s("p"),C1)),C1))))),
SetDelayed(Int(Power(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("n")))),$p("p")),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,$s("x")),Times(Power(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))),Plus($s("p"),C1)),Power(Times(Times($s("a"),$s("n")),Plus($s("p"),C1)),CN1))),Dist(Times(Plus(Times($s("n"),Plus($s("p"),C1)),C1),Power(Times(Times($s("a"),$s("n")),Plus($s("p"),C1)),CN1)),Int(Power(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))),Plus($s("p"),C1)),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ(List($s("n"),$s("p")))),Greater($s("n"),C1)),Less($s("p"),CN1)))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("n")))),$p("p"))),$p("x",$s("Symbol"))),
    Condition(Times(Power($s("x"),Plus($s("m"),C1)),Times(Power(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))),Plus($s("p"),C1)),Power(Times($s("a"),Plus($s("m"),C1)),CN1))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("m"),$s("n"),$s("p")),$s("x")),ZeroQ(Plus(Plus($s("m"),Times($s("n"),Plus($s("p"),C1))),C1))),NonzeroQ(Plus($s("m"),C1))),NonzeroQ(Plus($s("p"),C2))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("n")))),$p("p"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus(Plus($s("m"),Times(CN1,$s("n"))),C1)),Times(Power(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))),Plus($s("p"),C1)),Power(Times(Times($s("b"),$s("n")),Plus($s("p"),C1)),CN1))),Times(CN1,Dist(Times(Plus(Plus($s("m"),Times(CN1,$s("n"))),C1),Power(Times(Times($s("b"),$s("n")),Plus($s("p"),C1)),CN1)),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,$s("n")))),Power(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))),Plus($s("p"),C1))),$s("x"))))),And(And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ(List($s("m"),$s("n"),$s("p")))),Greater($s("n"),C1)),Less($s("p"),CN1)),And(LessEqual($s("n"),$s("m")),Less($s("m"),Plus(Times(C2,$s("n")),Times(CN1,C1))))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("n")))),$p("p"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Power($s("x"),Plus($s("m"),C1))),Times(Power(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))),Plus($s("p"),C1)),Power(Times(Times($s("a"),$s("n")),Plus($s("p"),C1)),CN1))),Dist(Times(Plus(Plus($s("m"),Times($s("n"),Plus($s("p"),C1))),C1),Power(Times(Times($s("a"),$s("n")),Plus($s("p"),C1)),CN1)),Int(Times(Power($s("x"),$s("m")),Power(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))),Plus($s("p"),C1))),$s("x")))),And(And(And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ(List($s("m"),$s("n"),$s("p")))),Less($s("p"),CN1)),Greater($s("n"),C1)),Less(Less(C0,Plus($s("m"),C1)),$s("n"))),NonzeroQ(Plus(Plus($s("m"),Times($s("n"),Plus($s("p"),C1))),C1))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("n")))),$p("p"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Times(Power(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))),Plus($s("p"),C1)),Power(Times($s("a"),Plus($s("m"),C1)),CN1))),Times(CN1,Dist(Times($s("b"),Times(Plus(Plus($s("m"),Times($s("n"),Plus($s("p"),C1))),C1),Power(Times($s("a"),Plus($s("m"),C1)),CN1))),Int(Times(Power($s("x"),Plus($s("m"),$s("n"))),Power(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))),$s("p"))),$s("x"))))),And(And(And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ(List($s("m"),$s("n"),$s("p")))),Less($s("m"),CN1)),Greater($s("n"),C0)),IntegerQ(Times(Plus(Plus($s("m"),Times($s("n"),Plus($s("p"),C1))),C1),Power($s("n"),CN1)))),Less(Less(C0,Plus($s("n"),Times(CN1,Times(C2,Plus(Plus($s("m"),Times($s("n"),Plus($s("p"),C1))),C1))))),Times($s("n"),$s("p")))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("n")))),$p("p"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus(Plus($s("m"),Times(CN1,$s("n"))),C1)),Times(Power(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))),Plus($s("p"),C1)),Power(Times($s("b"),Plus(Plus($s("m"),Times($s("n"),$s("p"))),C1)),CN1))),Times(CN1,Dist(Times($s("a"),Times(Plus(Plus($s("m"),Times(CN1,$s("n"))),C1),Power(Times($s("b"),Plus(Plus($s("m"),Times($s("n"),$s("p"))),C1)),CN1))),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,$s("n")))),Power(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))),$s("p"))),$s("x"))))),And(And(And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ(List($s("m"),$s("n"),$s("p")))),NonzeroQ(Plus(Plus($s("m"),Times($s("n"),$s("p"))),C1))),And(IntegerQ(Times(Plus($s("m"),C1),Power($s("n"),CN1))),Less(C0,Times(Plus($s("m"),C1),Power($s("n"),CN1))))),Less(Times(C2,Times($s("m"),Power($s("n"),CN1))),Plus($s("p"),C1))),And(Less(C0,$s("n")),LessEqual($s("n"),$s("m")))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("n",true)))),$p("p",true))),$p("x",$s("Symbol"))),
    Condition(Int(Expand(Times(Power($s("x"),$s("m")),Power(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))),$s("p")))),$s("x")),And(And(And(FreeQ(List($s("a"),$s("b"),$s("m"),$s("n")),$s("x")),IntegerQ($s("p"))),Greater($s("p"),C0)),ExpandIntegrandQ($s("m"),$s("n"),$s("p"))))),
SetDelayed(Int(Times(Power(Plus($p("c"),Times($p("d",true),$p("x"))),$p("m",true)),Power(Plus($p("a"),Times($p("b",true),Power(Plus($p("c"),Times($p("d",true),$p("x"))),$p("n")))),$p("p"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power(Plus($s("c"),Times($s("d"),$s("x"))),Plus(Plus($s("m"),Times(CN1,$s("n"))),C1)),Times(Power(Plus($s("a"),Times($s("b"),Power(Plus($s("c"),Times($s("d"),$s("x"))),$s("n")))),Plus($s("p"),C1)),Power(Times(Times(Times($s("b"),$s("d")),$s("n")),Plus($s("p"),C1)),CN1))),Times(CN1,Dist(Times(Plus(Plus($s("m"),Times(CN1,$s("n"))),C1),Power(Times(Times($s("b"),$s("n")),Plus($s("p"),C1)),CN1)),Int(Times(Power(Plus($s("c"),Times($s("d"),$s("x"))),Plus($s("m"),Times(CN1,$s("n")))),Power(Plus($s("a"),Times($s("b"),Power(Plus($s("c"),Times($s("d"),$s("x"))),$s("n")))),Plus($s("p"),C1))),$s("x"))))),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),IntegerQ(List($s("m"),$s("n"),$s("p")))),Greater($s("n"),C1)),Less($s("p"),CN1)),And(LessEqual($s("n"),$s("m")),Less($s("m"),Plus(Times(C2,$s("n")),Times(CN1,C1))))))),
SetDelayed(Int(Times(Power(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("n",true)))),$p("m")),Power(Plus($p("b"),Times($p("a",true),Power($p("x"),$p("p",true)))),CN1)),$p("x",$s("Symbol"))),
    Condition(Int(Times(Power($s("x"),$s("n")),Power(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))),Plus($s("m"),Times(CN1,C1)))),$s("x")),And(FreeQ(List($s("a"),$s("b"),$s("m"),$s("n"),$s("p")),$s("x")),ZeroQ(Plus($s("n"),$s("p")))))),
SetDelayed(Int(Power(Plus(Plus($p("a"),Times($p("b",true),$p("x"))),Times($p("c",true),Power($p("x"),C2))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Times(Int(Power(Plus(Times($s("b"),C1D2),Times($s("c"),$s("x"))),Times(C2,$s("n"))),$s("x")),Power(Power($s("c"),$s("n")),CN1)),And(And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),IntegerQ($s("n"))),ZeroQ(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c")))))))),
SetDelayed(Int(Times(C1,Power(Plus(Plus($p("a"),Times($p("b",true),$p("x"))),Times($p("c",true),Power($p("x"),C2))),CN1)),$p("x",$s("Symbol"))),
    Condition(Module(List(Set($s("q"),Rt(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c")))),C2))),Condition(Times(integer(-2L),Times(ArcTanh(Plus(Times($s("b"),Power($s("q"),CN1)),Times(Times(C2,$s("c")),Times($s("x"),Power($s("q"),CN1))))),Power($s("q"),CN1))),And(SqrtNumberQ($s("q")),RationalQ(Times($s("b"),Power($s("q"),CN1)))))),And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),PosQ(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c")))))))),
SetDelayed(Int(Times(C1,Power(Plus(Plus($p("a"),Times($p("b",true),$p("x"))),Times($p("c",true),Power($p("x"),C2))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(integer(-2L),Times(ArcTanh(Times(Plus($s("b"),Times(Times(C2,$s("c")),$s("x"))),Power(Rt(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c")))),C2),CN1))),Power(Rt(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c")))),C2),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),PosQ(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c")))))))),
SetDelayed(Int(Times(C1,Power(Plus(Plus($p("a"),Times($p("b",true),$p("x"))),Times($p("c",true),Power($p("x"),C2))),CN1)),$p("x",$s("Symbol"))),
    Condition(Module(List(Set($s("q"),Rt(Plus(Times(Times(C4,$s("a")),$s("c")),Times(CN1,Power($s("b"),C2))),C2))),Condition(Times(C2,Times(ArcTan(Plus(Times($s("b"),Power($s("q"),CN1)),Times(Times(C2,$s("c")),Times($s("x"),Power($s("q"),CN1))))),Power($s("q"),CN1))),And(SqrtNumberQ($s("q")),RationalQ(Times($s("b"),Power($s("q"),CN1)))))),And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),NegQ(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c")))))))),
SetDelayed(Int(Times(C1,Power(Plus(Plus($p("a"),Times($p("b",true),$p("x"))),Times($p("c",true),Power($p("x"),C2))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(C2,Times(ArcTan(Times(Plus($s("b"),Times(Times(C2,$s("c")),$s("x"))),Power(Rt(Plus(Times(Times(C4,$s("a")),$s("c")),Times(CN1,Power($s("b"),C2))),C2),CN1))),Power(Rt(Plus(Times(Times(C4,$s("a")),$s("c")),Times(CN1,Power($s("b"),C2))),C2),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),NegQ(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c")))))))),
SetDelayed(Int(Times(C1,Power(Power(Plus(Plus($p("a",true),Times($p("b",true),$p("x"))),Times($p("c",true),Power($p("x"),C2))),fraction(3L,2L)),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(integer(-2L),Times(Plus($s("b"),Times(Times(C2,$s("c")),$s("x"))),Power(Times(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c")))),Sqrt(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))))),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),NonzeroQ(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c")))))))),
SetDelayed(Int(Power(Plus(Plus($p("a",true),Times($p("b",true),$p("x"))),Times($p("c",true),Power($p("x"),C2))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Plus($s("b"),Times(Times(C2,$s("c")),$s("x"))),Times(Power(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))),Plus($s("n"),C1)),Power(Times(Plus($s("n"),C1),Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c"))))),CN1))),Times(CN1,Dist(Times(Times(C2,$s("c")),Times(Plus(Times(C2,$s("n")),C3),Power(Times(Plus($s("n"),C1),Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c"))))),CN1))),Int(Power(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))),Plus($s("n"),C1)),$s("x"))))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),RationalQ($s("n"))),Less($s("n"),CN1)),NonzeroQ(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c")))))))),
SetDelayed(Int(Times(Plus($p("d",true),Times($p("e",true),$p("x"))),Power(Plus(Plus($p("a"),Times($p("b",true),$p("x"))),Times($p("c",true),Power($p("x"),C2))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times($s("e"),Times(Log(Plus(Plus(Times(CN1,$s("a")),Times(CN1,Times($s("b"),$s("x")))),Times(CN1,Times($s("c"),Power($s("x"),C2))))),Power(Times(C2,$s("c")),CN1))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e")),$s("x")),ZeroQ(Plus(Times(Times(C2,$s("c")),$s("d")),Times(CN1,Times($s("b"),$s("e")))))),NegativeCoefficientQ($s("a"))))),
SetDelayed(Int(Times(Plus($p("d",true),Times($p("e",true),$p("x"))),Power(Plus(Plus($p("a"),Times($p("b",true),$p("x"))),Times($p("c",true),Power($p("x"),C2))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times($s("e"),Times(Log(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2)))),Power(Times(C2,$s("c")),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e")),$s("x")),ZeroQ(Plus(Times(Times(C2,$s("c")),$s("d")),Times(CN1,Times($s("b"),$s("e")))))))),
SetDelayed(Int(Times(Plus($p("d",true),Times($p("e",true),$p("x"))),Power(Plus(Plus($p("a"),Times($p("b",true),$p("x"))),Times($p("c",true),Power($p("x"),C2))),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Times($s("e"),Times(Log(Plus(Plus(Times(CN1,$s("a")),Times(CN1,Times($s("b"),$s("x")))),Times(CN1,Times($s("c"),Power($s("x"),C2))))),Power(Times(C2,$s("c")),CN1))),Dist(Simplify(Times(Plus(Times(Times(C2,$s("c")),$s("d")),Times(CN1,Times($s("b"),$s("e")))),Power(Times(C2,$s("c")),CN1))),Int(Times(C1,Power(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))),CN1)),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e")),$s("x")),Not(RationalQ(Rt(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c")))),C2)))),NonzeroQ(Plus(Plus(Times($s("a"),Power($s("e"),C2)),Times($s("c"),Power($s("d"),C2))),Times(CN1,Times(Times($s("b"),$s("d")),$s("e")))))),NegativeCoefficientQ($s("a"))))),
SetDelayed(Int(Times(Plus($p("d",true),Times($p("e",true),$p("x"))),Power(Plus(Plus($p("a"),Times($p("b",true),$p("x"))),Times($p("c",true),Power($p("x"),C2))),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Times($s("e"),Times(Log(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2)))),Power(Times(C2,$s("c")),CN1))),Dist(Simplify(Times(Plus(Times(Times(C2,$s("c")),$s("d")),Times(CN1,Times($s("b"),$s("e")))),Power(Times(C2,$s("c")),CN1))),Int(Times(C1,Power(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))),CN1)),$s("x")))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e")),$s("x")),Not(RationalQ(Rt(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c")))),C2)))),NonzeroQ(Plus(Plus(Times($s("a"),Power($s("e"),C2)),Times($s("c"),Power($s("d"),C2))),Times(CN1,Times(Times($s("b"),$s("d")),$s("e")))))))),
SetDelayed(Int(Times(Power(Plus($p("d"),Times($p("e",true),$p("x"))),$p("m",true)),Power(Plus($p("a"),Times($p("c",true),Power($p("x"),C2))),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Int(Times(Power(Plus($s("d"),Times($s("e"),$s("x"))),Plus($s("m"),$s("n"))),Power(Plus(Times($s("a"),Power($s("d"),CN1)),Times(Times($s("c"),Power($s("e"),CN1)),$s("x"))),$s("n"))),$s("x")),And(And(FreeQ(List($s("a"),$s("c"),$s("d"),$s("e"),$s("m")),$s("x")),IntegerQ($s("n"))),ZeroQ(Plus(Times($s("a"),Power($s("e"),C2)),Times($s("c"),Power($s("d"),C2))))))),
SetDelayed(Int(Times(Plus($p("d"),Times($p("e",true),$p("x"))),Power(Plus($p("a",true),Times($p("c",true),Power($p("x"),C2))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times($s("e"),Times(Power(Plus($s("a"),Times($s("c"),Power($s("x"),C2))),Plus($s("n"),C1)),Power(Times(Times(C2,$s("c")),Plus($s("n"),C1)),CN1))),Dist($s("d"),Int(Power(Plus($s("a"),Times($s("c"),Power($s("x"),C2))),$s("n")),$s("x")))),And(And(FreeQ(List($s("a"),$s("c"),$s("d"),$s("e"),$s("n")),$s("x")),NonzeroQ(Plus($s("n"),C1))),Not(And(IntegerQ($s("n")),Greater($s("n"),C0)))))),
SetDelayed(Int(Times(Power(Plus($p("d"),Times($p("e",true),$p("x"))),$p("m")),Power(Plus($p("a",true),Times($p("c",true),Power($p("x"),C2))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times($s("e"),Power(Plus($s("d"),Times($s("e"),$s("x"))),Plus($s("m"),Times(CN1,C1)))),Times(Power(Plus($s("a"),Times($s("c"),Power($s("x"),C2))),Plus($s("n"),C1)),Power(Times($s("c"),Plus(Plus($s("m"),Times(C2,$s("n"))),C1)),CN1))),Times(CN1,Dist(Times(Plus(Times($s("a"),Power($s("e"),C2)),Times($s("c"),Power($s("d"),C2))),Times(Plus($s("m"),Times(CN1,C1)),Power(Times($s("c"),Plus(Plus($s("m"),Times(C2,$s("n"))),C1)),CN1))),Int(Times(Power(Plus($s("d"),Times($s("e"),$s("x"))),Plus($s("m"),Times(CN1,C2))),Power(Plus($s("a"),Times($s("c"),Power($s("x"),C2))),$s("n"))),$s("x"))))),And(And(And(FreeQ(List($s("a"),$s("c"),$s("d"),$s("e")),$s("x")),RationalQ(List($s("m"),$s("n")))),Greater($s("m"),C1)),ZeroQ(Plus($s("m"),$s("n")))))),
SetDelayed(Int(Times(Power(Plus($p("d"),Times($p("e",true),$p("x"))),$p("m",true)),Power(Plus($p("a",true),Times($p("c",true),Power($p("x"),C2))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times($s("e"),Power(Plus($s("d"),Times($s("e"),$s("x"))),Plus($s("m"),Times(CN1,C1)))),Times(Power(Plus($s("a"),Times($s("c"),Power($s("x"),C2))),Plus($s("n"),C1)),Power(Times($s("c"),Plus(Plus($s("m"),Times(C2,$s("n"))),C1)),CN1))),Dist(Times(Times(Times(C2,$s("c")),$s("d")),Times(Plus($s("m"),$s("n")),Power(Times($s("c"),Plus(Plus($s("m"),Times(C2,$s("n"))),C1)),CN1))),Int(Times(Power(Plus($s("d"),Times($s("e"),$s("x"))),Plus($s("m"),Times(CN1,C1))),Power(Plus($s("a"),Times($s("c"),Power($s("x"),C2))),$s("n"))),$s("x")))),And(And(And(And(And(FreeQ(List($s("a"),$s("c"),$s("d"),$s("e"),$s("n")),$s("x")),RationalQ($s("m"))),Greater($s("m"),C1)),NonzeroQ(Plus(Plus($s("m"),Times(C2,$s("n"))),C1))),Not(And(IntegerQ($s("n")),GreaterEqual($s("n"),CN1)))),ZeroQ(Plus(Times($s("a"),Power($s("e"),C2)),Times($s("c"),Power($s("d"),C2))))))),
SetDelayed(Int(Times(Power(Plus($p("d"),Times($p("e",true),$p("x"))),$p("m")),Power(Plus($p("a"),Times($p("c",true),Power($p("x"),C2))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Times(Times($s("e"),Power(Plus($s("d"),Times($s("e"),$s("x"))),$s("m"))),Times(Power(Plus($s("a"),Times($s("c"),Power($s("x"),C2))),Plus($s("n"),C1)),Power(Times(Times(Times(C2,$s("c")),$s("d")),Plus($s("n"),C1)),CN1))),And(And(And(FreeQ(List($s("a"),$s("c"),$s("d"),$s("e"),$s("n")),$s("x")),ZeroQ(Plus(Times($s("c"),Power($s("d"),C2)),Times($s("a"),Power($s("e"),C2))))),ZeroQ(Plus($s("m"),Times(C2,Plus($s("n"),C1))))),NonzeroQ(Plus($s("n"),C1))))),
SetDelayed(Int(Times(Power(Plus($p("d"),Times($p("e",true),$p("x"))),$p("m")),Power(Plus($p("a"),Times($p("c",true),Power($p("x"),C2))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(Times(CN1,$s("e")),Power(Plus($s("d"),Times($s("e"),$s("x"))),$s("m"))),Times(Power(Plus($s("a"),Times($s("c"),Power($s("x"),C2))),Plus($s("n"),C1)),Power(Times(Times(Times(C2,$s("c")),$s("d")),Plus(Plus($s("m"),$s("n")),C1)),CN1))),Dist(Times(Plus($s("m"),Times(C2,Plus($s("n"),C1))),Power(Times(Times(C2,$s("d")),Plus(Plus($s("m"),$s("n")),C1)),CN1)),Int(Times(Power(Plus($s("d"),Times($s("e"),$s("x"))),Plus($s("m"),C1)),Power(Plus($s("a"),Times($s("c"),Power($s("x"),C2))),$s("n"))),$s("x")))),And(And(And(And(FreeQ(List($s("a"),$s("c"),$s("d"),$s("e"),$s("n")),$s("x")),RationalQ($s("m"))),Less($s("m"),CN1)),ZeroQ(Plus(Times($s("c"),Power($s("d"),C2)),Times($s("a"),Power($s("e"),C2))))),NonzeroQ(Plus(Plus($s("m"),$s("n")),C1))))),
SetDelayed(Int(Times(Power(Plus($p("d"),Times($p("e",true),$p("x"))),$p("m")),Power(Plus($p("a"),Times($p("c",true),Power($p("x"),C2))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times($s("e"),Power(Plus($s("d"),Times($s("e"),$s("x"))),Plus($s("m"),C1))),Times(Power(Plus($s("a"),Times($s("c"),Power($s("x"),C2))),Plus($s("n"),C1)),Power(Times(Plus($s("m"),C1),Plus(Times($s("c"),Power($s("d"),C2)),Times($s("a"),Power($s("e"),C2)))),CN1))),Dist(Times(Times(Times(C2,$s("c")),$s("d")),Times(Plus(Plus($s("m"),$s("n")),C2),Power(Times(Plus($s("m"),C1),Plus(Times($s("c"),Power($s("d"),C2)),Times($s("a"),Power($s("e"),C2)))),CN1))),Int(Times(Power(Plus($s("d"),Times($s("e"),$s("x"))),Plus($s("m"),C1)),Power(Plus($s("a"),Times($s("c"),Power($s("x"),C2))),$s("n"))),$s("x")))),And(And(And(And(And(FreeQ(List($s("a"),$s("c"),$s("d"),$s("e"),$s("n")),$s("x")),RationalQ($s("m"))),Less($s("m"),CN1)),NonzeroQ(Plus(Times($s("c"),Power($s("d"),C2)),Times($s("a"),Power($s("e"),C2))))),Not(And(IntegerQ($s("n")),GreaterEqual($s("n"),CN1)))),ZeroQ(Plus(Plus($s("m"),Times(C2,$s("n"))),C3))))),
SetDelayed(Int(Times(Power(Plus($p("d"),Times($p("e",true),$p("x"))),$p("m",true)),Power(Plus(Plus($p("a",true),Times($p("b",true),$p("x"))),Times($p("c",true),Power($p("x"),C2))),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Int(Times(Power(Plus($s("d"),Times($s("e"),$s("x"))),Plus($s("m"),$s("n"))),Power(Plus(Times($s("a"),Power($s("d"),CN1)),Times(Times($s("c"),Power($s("e"),CN1)),$s("x"))),$s("n"))),$s("x")),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e"),$s("m")),$s("x")),IntegerQ($s("n"))),ZeroQ(Plus(Plus(Times($s("a"),Power($s("e"),C2)),Times($s("c"),Power($s("d"),C2))),Times(CN1,Times(Times($s("b"),$s("d")),$s("e")))))))),
SetDelayed(Int(Times(Power(Plus($p("d",true),Times($p("e",true),$p("x"))),$p("m")),Power(Plus(Plus($p("a",true),Times($p("b",true),$p("x"))),Times($p("c",true),Power($p("x"),C2))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(Times(CN1,$s("e")),Power(Plus($s("d"),Times($s("e"),$s("x"))),Plus($s("m"),Times(CN1,C1)))),Times(Power(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))),Plus($s("n"),C1)),Power(Times($s("c"),Plus($s("m"),Times(CN1,C1))),CN1))),Dist(Times(Power($s("e"),C2),Power($s("c"),CN1)),Int(Times(Power(Plus($s("d"),Times($s("e"),$s("x"))),Plus($s("m"),Times(CN1,C2))),Power(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))),Plus($s("n"),C1))),$s("x")))),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e")),$s("x")),RationalQ(List($s("m"),$s("n")))),Less($s("n"),CN1)),ZeroQ(Plus(Plus($s("m"),Times(C2,$s("n"))),C1))),ZeroQ(Plus(Times(Times(C2,$s("c")),$s("d")),Times(CN1,Times($s("b"),$s("e")))))))),
SetDelayed(Int(Times(Plus($p("d",true),Times($p("e",true),$p("x"))),Power(Plus(Plus($p("a",true),Times($p("b",true),$p("x"))),Times($p("c",true),Power($p("x"),C2))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Times($s("e"),Times(Power(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))),Plus($s("n"),C1)),Power(Times(Times(C2,$s("c")),Plus($s("n"),C1)),CN1))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e"),$s("n")),$s("x")),ZeroQ(Plus(Times(Times(C2,$s("c")),$s("d")),Times(CN1,Times($s("b"),$s("e")))))),NonzeroQ(Plus($s("n"),C1))))),
SetDelayed(Int(Times(Plus($p("d",true),Times($p("e",true),$p("x"))),Power(Plus(Plus($p("a",true),Times($p("b",true),$p("x"))),Times($p("c",true),Power($p("x"),C2))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times($s("e"),Times(Power(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))),Plus($s("n"),C1)),Power(Times(Times(C2,$s("c")),Plus($s("n"),C1)),CN1))),Dist(Times(Plus(Times(Times(C2,$s("c")),$s("d")),Times(CN1,Times($s("b"),$s("e")))),Power(Times(C2,$s("c")),CN1)),Int(Power(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))),$s("n")),$s("x")))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e"),$s("n")),$s("x")),NonzeroQ(Plus($s("n"),C1))),Not(And(IntegerQ($s("n")),Greater($s("n"),C0)))))),
SetDelayed(Int(Times(Power(Plus($p("d",true),Times($p("e",true),$p("x"))),$p("m")),Power(Plus(Plus($p("a",true),Times($p("b",true),$p("x"))),Times($p("c",true),Power($p("x"),C2))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times($s("e"),Power(Plus($s("d"),Times($s("e"),$s("x"))),Plus($s("m"),Times(CN1,C1)))),Times(Power(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))),Plus($s("n"),C1)),Power(Times($s("c"),Plus(Plus($s("m"),Times(C2,$s("n"))),C1)),CN1))),Times(CN1,Dist(Times(Plus(Times($s("e"),Plus(Times($s("a"),$s("e")),Times(CN1,Times($s("b"),$s("d"))))),Times($s("c"),Power($s("d"),C2))),Times(Plus($s("m"),Times(CN1,C1)),Power(Times($s("c"),Plus(Plus($s("m"),Times(C2,$s("n"))),C1)),CN1))),Int(Times(Power(Plus($s("d"),Times($s("e"),$s("x"))),Plus($s("m"),Times(CN1,C2))),Power(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))),$s("n"))),$s("x"))))),And(And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e"),$s("n")),$s("x")),RationalQ($s("m"))),Greater($s("m"),C1)),NonzeroQ(Plus(Plus($s("m"),Times(C2,$s("n"))),C1))),Not(And(IntegerQ($s("n")),GreaterEqual($s("n"),CN1)))),Or(ZeroQ(Plus($s("m"),$s("n"))),ZeroQ(Plus(Times(Times(C2,$s("c")),$s("d")),Times(CN1,Times($s("b"),$s("e"))))))))),
SetDelayed(Int(Times(Power(Plus($p("d",true),Times($p("e",true),$p("x"))),$p("m",true)),Power(Plus(Plus($p("a",true),Times($p("b",true),$p("x"))),Times($p("c",true),Power($p("x"),C2))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times($s("e"),Power(Plus($s("d"),Times($s("e"),$s("x"))),Plus($s("m"),Times(CN1,C1)))),Times(Power(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))),Plus($s("n"),C1)),Power(Times($s("c"),Plus(Plus($s("m"),Times(C2,$s("n"))),C1)),CN1))),Dist(Times(Plus(Times(Times(C2,$s("c")),$s("d")),Times(CN1,Times($s("b"),$s("e")))),Times(Plus($s("m"),$s("n")),Power(Times($s("c"),Plus(Plus($s("m"),Times(C2,$s("n"))),C1)),CN1))),Int(Times(Power(Plus($s("d"),Times($s("e"),$s("x"))),Plus($s("m"),Times(CN1,C1))),Power(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))),$s("n"))),$s("x")))),And(And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e"),$s("n")),$s("x")),RationalQ($s("m"))),Greater($s("m"),C1)),NonzeroQ(Plus(Plus($s("m"),Times(C2,$s("n"))),C1))),Not(And(IntegerQ($s("n")),GreaterEqual($s("n"),CN1)))),ZeroQ(Plus(Times($s("e"),Times(Plus(Times($s("a"),$s("e")),Times(CN1,Times($s("b"),$s("d")))),Power($s("c"),CN1))),Power($s("d"),C2)))))),
SetDelayed(Int(Times(Power($p("x"),$p("m")),Power(Plus(Times($p("b",true),$p("x")),Times($p("c",true),Power($p("x"),C2))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Times(Power($s("x"),$s("m")),Times(Power(Plus(Times($s("b"),$s("x")),Times($s("c"),Power($s("x"),C2))),Plus($s("n"),C1)),Power(Times($s("b"),Plus(Plus($s("m"),$s("n")),C1)),CN1))),And(And(FreeQ(List($s("b"),$s("c"),$s("m"),$s("n")),$s("x")),NonzeroQ(Plus(Plus($s("m"),$s("n")),C1))),ZeroQ(Plus($s("m"),Times(C2,Plus($s("n"),C1))))))),
SetDelayed(Int(Times(Power($p("x"),$p("m")),Power(Plus(Times($p("b",true),$p("x")),Times($p("c",true),Power($p("x"),C2))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),$s("m")),Times(Power(Plus(Times($s("b"),$s("x")),Times($s("c"),Power($s("x"),C2))),Plus($s("n"),C1)),Power(Times($s("b"),Plus(Plus($s("m"),$s("n")),C1)),CN1))),Times(CN1,Dist(Times($s("c"),Times(Plus($s("m"),Times(C2,Plus($s("n"),C1))),Power(Times($s("b"),Plus(Plus($s("m"),$s("n")),C1)),CN1))),Int(Times(Power($s("x"),Plus($s("m"),C1)),Power(Plus(Times($s("b"),$s("x")),Times($s("c"),Power($s("x"),C2))),$s("n"))),$s("x"))))),And(And(And(And(FreeQ(List($s("b"),$s("c"),$s("n")),$s("x")),RationalQ($s("m"))),Less($s("m"),CN1)),NonzeroQ(Plus(Plus($s("m"),$s("n")),C1))),Not(And(IntegerQ($s("n")),GreaterEqual($s("n"),CN1)))))),
SetDelayed(Int(Times(Power(Plus($p("d",true),Times($p("e",true),$p("x"))),$p("m")),Power(Plus(Plus($p("a"),Times($p("b",true),$p("x"))),Times($p("c",true),Power($p("x"),C2))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times($s("e"),Power(Plus($s("d"),Times($s("e"),$s("x"))),Plus($s("m"),C1))),Times(Power(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))),Plus($s("n"),C1)),Power(Times(Plus($s("m"),C1),Plus(Plus(Times($s("c"),Power($s("d"),C2)),Times($s("a"),Power($s("e"),C2))),Times(CN1,Times(Times($s("b"),$s("d")),$s("e"))))),CN1))),Dist(Times(Plus(Times(Times(C2,$s("c")),$s("d")),Times(CN1,Times($s("b"),$s("e")))),Times(Plus(Plus($s("m"),$s("n")),C2),Power(Times(Plus($s("m"),C1),Plus(Plus(Times($s("c"),Power($s("d"),C2)),Times($s("a"),Power($s("e"),C2))),Times(CN1,Times(Times($s("b"),$s("d")),$s("e"))))),CN1))),Int(Times(Power(Plus($s("d"),Times($s("e"),$s("x"))),Plus($s("m"),C1)),Power(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))),$s("n"))),$s("x")))),And(And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e"),$s("n")),$s("x")),RationalQ($s("m"))),Less($s("m"),CN1)),NonzeroQ(Plus(Plus(Times($s("c"),Power($s("d"),C2)),Times($s("a"),Power($s("e"),C2))),Times(CN1,Times(Times($s("b"),$s("d")),$s("e")))))),Not(And(IntegerQ($s("n")),GreaterEqual($s("n"),CN1)))),ZeroQ(Plus(Plus($s("m"),Times(C2,$s("n"))),C3))))),
SetDelayed(Int(Times($p("u",true),Power(Plus(Plus($p("a"),Times($p("b",true),Power($p("x"),C2))),Times($p("c",true),Power($p("x"),C4))),CN1)),$p("x",$s("Symbol"))),
    Condition(Dist($s("c"),Int(Times($s("u"),Power(Power(Plus(Times($s("b"),C1D2),Times($s("c"),Power($s("x"),C2))),C2),CN1)),$s("x"))),And(And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),ZeroQ(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c")))))),PolynomialQ($s("u"),$s("x"))))),
SetDelayed(Int(Times(Plus($p("d"),Times($p("e",true),Power($p("x"),C2))),Power(Plus(Plus($p("a"),Times($p("b",true),Power($p("x"),C2))),Times($p("c",true),Power($p("x"),C4))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Times($s("d"),Power(Times($s("a"),Rt(Times(Plus(Times($s("d"),$s("b")),Times(Times(C2,$s("e")),$s("a"))),Power(Times($s("d"),$s("a")),CN1)),C2)),CN1)),ArcTan(Times(Times($s("d"),Rt(Times(Plus(Times($s("d"),$s("b")),Times(Times(C2,$s("e")),$s("a"))),Power(Times($s("d"),$s("a")),CN1)),C2)),Times($s("x"),Power(Plus($s("d"),Times(CN1,Times($s("e"),Power($s("x"),C2)))),CN1))))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e")),$s("x")),ZeroQ(Plus(Times(Power($s("d"),C2),$s("c")),Times(CN1,Times(Power($s("e"),C2),$s("a")))))),PosQ(Times(Plus(Times($s("d"),$s("b")),Times(Times(C2,$s("e")),$s("a"))),Power(Times($s("d"),$s("a")),CN1)))))),
SetDelayed(Int(Times(Plus($p("d"),Times($p("e",true),Power($p("x"),C2))),Power(Plus(Plus($p("a"),Times($p("b",true),Power($p("x"),C2))),Times($p("c",true),Power($p("x"),C4))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Times($s("d"),Power(Times($s("a"),Rt(Times(Times(CN1,Plus(Times($s("d"),$s("b")),Times(Times(C2,$s("e")),$s("a")))),Power(Times($s("d"),$s("a")),CN1)),C2)),CN1)),ArcTanh(Times(Times($s("d"),Rt(Times(Times(CN1,Plus(Times($s("d"),$s("b")),Times(Times(C2,$s("e")),$s("a")))),Power(Times($s("d"),$s("a")),CN1)),C2)),Times($s("x"),Power(Plus($s("d"),Times(CN1,Times($s("e"),Power($s("x"),C2)))),CN1))))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e")),$s("x")),ZeroQ(Plus(Times(Power($s("d"),C2),$s("c")),Times(CN1,Times(Power($s("e"),C2),$s("a")))))),NegQ(Times(Plus(Times($s("d"),$s("b")),Times(Times(C2,$s("e")),$s("a"))),Power(Times($s("d"),$s("a")),CN1)))))),
SetDelayed(Int(Times(C1,Power(Plus(Plus($p("a"),Times($p("b",true),Power($p("x"),C2))),Times($p("c",true),Power($p("x"),C4))),CN1)),$p("x",$s("Symbol"))),
    Condition(Module(List(Set($s("q"),Rt(Times($s("a"),Power($s("c"),CN1)),C2))),Plus(Dist(Times($s("c"),Times($s("q"),Power(Times(C2,$s("a")),CN1))),Int(Times(Plus($s("q"),Power($s("x"),C2)),Power(Plus(Plus($s("a"),Times($s("b"),Power($s("x"),C2))),Times($s("c"),Power($s("x"),C4))),CN1)),$s("x"))),Dist(Times($s("c"),Times($s("q"),Power(Times(C2,$s("a")),CN1))),Int(Times(Plus($s("q"),Times(CN1,Power($s("x"),C2))),Power(Plus(Plus($s("a"),Times($s("b"),Power($s("x"),C2))),Times($s("c"),Power($s("x"),C4))),CN1)),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),PosQ(Times($s("a"),Power($s("c"),CN1)))),Or(NegativeQ(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c"))))),And(RationalQ(Times($s("a"),Power($s("c"),CN1))),Not(PositiveQ(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c")))))))))))
  );
}
