package org.matheclipse.core.integrate.rubi;


import static org.matheclipse.core.expression.F.*;
import static org.matheclipse.core.integrate.rubi.UtilityFunctionCtors.*;
import static org.matheclipse.core.integrate.rubi.UtilityFunctions.*;
import org.matheclipse.core.interfaces.IAST;
import org.matheclipse.core.interfaces.IExpr;

/** 
 * IndefiniteIntegrationRules from the <a href="http://www.apmaths.uwo.ca/~arich/">Rubi -
 * rule-based integrator</a>.
 *  
 */
public class IndefiniteIntegrationRules1 { 
  public static IAST RULES = List( 
SetDelayed(Int(Times(C1,Power(Plus(Plus($p("a"),Times($p("b",true),Power($p("x"),C2))),Times($p("c",true),Power($p("x"),C4))),CN1)),$p("x",$s("Symbol"))),
    Condition(Module(List(Set($s("q"),Rt(Times(Times(CN1,$s("a")),Power($s("c"),CN1)),C2))),Plus(Times(CN1,Dist(Times($s("c"),Times($s("q"),Power(Times(C2,$s("a")),CN1))),Int(Times(Plus($s("q"),Power($s("x"),C2)),Power(Plus(Plus($s("a"),Times($s("b"),Power($s("x"),C2))),Times($s("c"),Power($s("x"),C4))),CN1)),$s("x")))),Times(CN1,Dist(Times($s("c"),Times($s("q"),Power(Times(C2,$s("a")),CN1))),Int(Times(Plus($s("q"),Times(CN1,Power($s("x"),C2))),Power(Plus(Plus($s("a"),Times($s("b"),Power($s("x"),C2))),Times($s("c"),Power($s("x"),C4))),CN1)),$s("x")))))),And(And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),NegQ(Times($s("a"),Power($s("c"),CN1)))),Or(NegativeQ(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c"))))),And(RationalQ(Times($s("a"),Power($s("c"),CN1))),Not(PositiveQ(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c"))))))))))),
SetDelayed(Int(Times(Power($p("x"),C2),Power(Plus(Plus($p("a"),Times($p("b",true),Power($p("x"),C2))),Times($p("c",true),Power($p("x"),C4))),CN1)),$p("x",$s("Symbol"))),
    Condition(Module(List(Set($s("q"),Rt(Times($s("a"),Power($s("c"),CN1)),C2))),Plus(Dist(C1D2,Int(Times(Plus($s("q"),Power($s("x"),C2)),Power(Plus(Plus($s("a"),Times($s("b"),Power($s("x"),C2))),Times($s("c"),Power($s("x"),C4))),CN1)),$s("x"))),Times(CN1,Dist(C1D2,Int(Times(Plus($s("q"),Times(CN1,Power($s("x"),C2))),Power(Plus(Plus($s("a"),Times($s("b"),Power($s("x"),C2))),Times($s("c"),Power($s("x"),C4))),CN1)),$s("x")))))),And(And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),PosQ(Times($s("a"),Power($s("c"),CN1)))),Or(NegativeQ(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c"))))),And(RationalQ(Times($s("a"),Power($s("c"),CN1))),Not(PositiveQ(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c"))))))))))),
SetDelayed(Int(Times(Power($p("x"),C2),Power(Plus(Plus($p("a"),Times($p("b",true),Power($p("x"),C2))),Times($p("c",true),Power($p("x"),C4))),CN1)),$p("x",$s("Symbol"))),
    Condition(Module(List(Set($s("q"),Rt(Times(Times(CN1,$s("a")),Power($s("c"),CN1)),C2))),Plus(Dist(C1D2,Int(Times(Plus($s("q"),Power($s("x"),C2)),Power(Plus(Plus($s("a"),Times($s("b"),Power($s("x"),C2))),Times($s("c"),Power($s("x"),C4))),CN1)),$s("x"))),Times(CN1,Dist(C1D2,Int(Times(Plus($s("q"),Times(CN1,Power($s("x"),C2))),Power(Plus(Plus($s("a"),Times($s("b"),Power($s("x"),C2))),Times($s("c"),Power($s("x"),C4))),CN1)),$s("x")))))),And(And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),NegQ(Times($s("a"),Power($s("c"),CN1)))),Or(NegativeQ(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c"))))),And(RationalQ(Times($s("a"),Power($s("c"),CN1))),Not(PositiveQ(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c"))))))))))),
SetDelayed(Int(Times(Plus($p("d"),Times($p("e",true),Power($p("x"),C2))),Power(Plus(Plus($p("a"),Times($p("b",true),Power($p("x"),C2))),Times($p("c",true),Power($p("x"),C4))),CN1)),$p("x",$s("Symbol"))),
    Condition(Module(List(Set($s("q"),Rt(Times($s("a"),Power($s("c"),CN1)),C2))),Plus(Dist(Times(Plus(Times(Times($s("q"),$s("c")),$s("d")),Times($s("a"),$s("e"))),Power(Times(C2,$s("a")),CN1)),Int(Times(Plus($s("q"),Power($s("x"),C2)),Power(Plus(Plus($s("a"),Times($s("b"),Power($s("x"),C2))),Times($s("c"),Power($s("x"),C4))),CN1)),$s("x"))),Dist(Times(Plus(Times(Times($s("q"),$s("c")),$s("d")),Times(CN1,Times($s("a"),$s("e")))),Power(Times(C2,$s("a")),CN1)),Int(Times(Plus($s("q"),Times(CN1,Power($s("x"),C2))),Power(Plus(Plus($s("a"),Times($s("b"),Power($s("x"),C2))),Times($s("c"),Power($s("x"),C4))),CN1)),$s("x"))))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e")),$s("x")),NonzeroQ(Plus(Times(Power($s("d"),C2),$s("c")),Times(CN1,Times(Power($s("e"),C2),$s("a")))))),PosQ(Times($s("a"),Power($s("c"),CN1)))),Or(NegativeQ(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c"))))),And(RationalQ(Times($s("a"),Power($s("c"),CN1))),Not(PositiveQ(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c"))))))))))),
SetDelayed(Int(Times(Plus($p("d"),Times($p("e",true),Power($p("x"),C2))),Power(Plus(Plus($p("a"),Times($p("b",true),Power($p("x"),C2))),Times($p("c",true),Power($p("x"),C4))),CN1)),$p("x",$s("Symbol"))),
    Condition(Module(List(Set($s("q"),Rt(Times(Times(CN1,$s("a")),Power($s("c"),CN1)),C2))),Plus(Dist(Times(Times(CN1,Plus(Times(Times($s("q"),$s("c")),$s("d")),Times(CN1,Times($s("a"),$s("e"))))),Power(Times(C2,$s("a")),CN1)),Int(Times(Plus($s("q"),Power($s("x"),C2)),Power(Plus(Plus($s("a"),Times($s("b"),Power($s("x"),C2))),Times($s("c"),Power($s("x"),C4))),CN1)),$s("x"))),Times(CN1,Dist(Times(Plus(Times(Times($s("q"),$s("c")),$s("d")),Times($s("a"),$s("e"))),Power(Times(C2,$s("a")),CN1)),Int(Times(Plus($s("q"),Times(CN1,Power($s("x"),C2))),Power(Plus(Plus($s("a"),Times($s("b"),Power($s("x"),C2))),Times($s("c"),Power($s("x"),C4))),CN1)),$s("x")))))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e")),$s("x")),NonzeroQ(Plus(Times(Power($s("d"),C2),$s("c")),Times(CN1,Times(Power($s("e"),C2),$s("a")))))),NegQ(Times($s("a"),Power($s("c"),CN1)))),Or(NegativeQ(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c"))))),And(RationalQ(Times($s("a"),Power($s("c"),CN1))),Not(PositiveQ(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c"))))))))))),
SetDelayed(Int(Times(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("k")))),Power(Plus(Plus(Plus($p("c"),Times($p("d",true),Power($p("x"),C2))),Times($p("e",true),Power($p("x"),$p("k")))),Times($p("f",true),Power($p("x"),$p("j")))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Times($s("a"),Power(Rt(Times($s("c"),$s("d")),C2),CN1)),ArcTan(Times(Times(Times($s("a"),Plus($s("k"),Times(CN1,C1))),Rt(Times($s("c"),$s("d")),C2)),Times($s("x"),Power(Times($s("c"),Plus(Times($s("a"),Plus($s("k"),Times(CN1,C1))),Times(CN1,Times($s("b"),Power($s("x"),$s("k")))))),CN1))))),And(And(And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e"),$s("f")),$s("x")),IntegerQ(List($s("j"),$s("k")))),Greater($s("k"),C0)),Equal($s("j"),Times(C2,$s("k")))),ZeroQ(Plus(Times(Times(Power(Plus($s("k"),Times(CN1,C1)),C2),Power($s("a"),C2)),$s("f")),Times(CN1,Times(Power($s("b"),C2),$s("c")))))),ZeroQ(Plus(Times($s("b"),$s("e")),Times(Times(Times(C2,$s("a")),Plus($s("k"),Times(CN1,C1))),$s("f"))))),PosQ(Times($s("c"),$s("d")))))),
SetDelayed(Int(Times(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("k")))),Power(Plus(Plus(Plus($p("c"),Times($p("d",true),Power($p("x"),C2))),Times($p("e",true),Power($p("x"),$p("k")))),Times($p("f",true),Power($p("x"),$p("j")))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Times($s("a"),Power(Rt(Times(Times(CN1,$s("c")),$s("d")),C2),CN1)),ArcTanh(Times(Times(Times($s("a"),Plus($s("k"),Times(CN1,C1))),Rt(Times(Times(CN1,$s("c")),$s("d")),C2)),Times($s("x"),Power(Times($s("c"),Plus(Times($s("a"),Plus($s("k"),Times(CN1,C1))),Times(CN1,Times($s("b"),Power($s("x"),$s("k")))))),CN1))))),And(And(And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e"),$s("f")),$s("x")),IntegerQ(List($s("j"),$s("k")))),Greater($s("k"),C0)),Equal($s("j"),Times(C2,$s("k")))),ZeroQ(Plus(Times(Times(Power(Plus($s("k"),Times(CN1,C1)),C2),Power($s("a"),C2)),$s("f")),Times(CN1,Times(Power($s("b"),C2),$s("c")))))),ZeroQ(Plus(Times($s("b"),$s("e")),Times(Times(Times(C2,$s("a")),Plus($s("k"),Times(CN1,C1))),$s("f"))))),NegQ(Times($s("c"),$s("d")))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Times(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("k",true)))),Power(Plus(Plus(Plus($p("c"),Times($p("d",true),Power($p("x"),$p("n",true)))),Times($p("e",true),Power($p("x"),$p("k",true)))),Times($p("f",true),Power($p("x"),$p("j")))),CN1))),$p("x",$s("Symbol"))),
    Condition(Times($s("a"),Times(ArcTan(Times(Times(Times($s("a"),Plus(Plus($s("m"),Times(CN1,$s("k"))),C1)),Rt(Times($s("c"),$s("d")),C2)),Times(Power($s("x"),Plus($s("m"),C1)),Power(Times($s("c"),Plus(Times($s("a"),Plus(Plus($s("m"),Times(CN1,$s("k"))),C1)),Times(Times($s("b"),Plus($s("m"),C1)),Power($s("x"),$s("k"))))),CN1)))),Power(Times(Plus($s("m"),C1),Rt(Times($s("c"),$s("d")),C2)),CN1))),And(And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e"),$s("f"),$s("j"),$s("k"),$s("m"),$s("n")),$s("x")),ZeroQ(Plus($s("n"),Times(CN1,Times(C2,Plus($s("m"),C1)))))),ZeroQ(Plus($s("j"),Times(CN1,Times(C2,$s("k")))))),ZeroQ(Plus(Times(Times(Power($s("a"),C2),$s("f")),Power(Plus(Plus($s("m"),Times(CN1,$s("k"))),C1),C2)),Times(CN1,Times(Times(Power($s("b"),C2),$s("c")),Power(Plus($s("m"),C1),C2)))))),ZeroQ(Plus(Times(Times($s("b"),$s("e")),Plus($s("m"),C1)),Times(CN1,Times(Times(Times(C2,$s("a")),$s("f")),Plus(Plus($s("m"),Times(CN1,$s("k"))),C1)))))),PosQ(Times($s("c"),$s("d")))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Times(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("k",true)))),Power(Plus(Plus(Plus($p("c"),Times($p("d",true),Power($p("x"),$p("n",true)))),Times($p("e",true),Power($p("x"),$p("k",true)))),Times($p("f",true),Power($p("x"),$p("j")))),CN1))),$p("x",$s("Symbol"))),
    Condition(Times($s("a"),Times(ArcTanh(Times(Times(Times($s("a"),Plus(Plus($s("m"),Times(CN1,$s("k"))),C1)),Rt(Times(Times(CN1,$s("c")),$s("d")),C2)),Times(Power($s("x"),Plus($s("m"),C1)),Power(Times($s("c"),Plus(Times($s("a"),Plus(Plus($s("m"),Times(CN1,$s("k"))),C1)),Times(Times($s("b"),Plus($s("m"),C1)),Power($s("x"),$s("k"))))),CN1)))),Power(Times(Plus($s("m"),C1),Rt(Times(Times(CN1,$s("c")),$s("d")),C2)),CN1))),And(And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e"),$s("f"),$s("j"),$s("k"),$s("m"),$s("n")),$s("x")),ZeroQ(Plus($s("n"),Times(CN1,Times(C2,Plus($s("m"),C1)))))),ZeroQ(Plus($s("j"),Times(CN1,Times(C2,$s("k")))))),ZeroQ(Plus(Times(Times(Power($s("a"),C2),$s("f")),Power(Plus(Plus($s("m"),Times(CN1,$s("k"))),C1),C2)),Times(CN1,Times(Times(Power($s("b"),C2),$s("c")),Power(Plus($s("m"),C1),C2)))))),ZeroQ(Plus(Times(Times($s("b"),$s("e")),Plus($s("m"),C1)),Times(CN1,Times(Times(Times(C2,$s("a")),$s("f")),Plus(Plus($s("m"),Times(CN1,$s("k"))),C1)))))),NegQ(Times($s("c"),$s("d")))))),
SetDelayed(Int(Times(C1,Power(Plus(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("k")))),Times($p("c",true),Power($p("x"),$p("j")))),CN1)),$p("x",$s("Symbol"))),
    Condition(Module(List(Set($s("q"),Plus(Times(C2,Rt(Times($s("a"),Power($s("c"),CN1)),C2)),Times(CN1,Times($s("b"),Power($s("c"),CN1)))))),Condition(Plus(Dist(Times(C1,Power(Times(Times(Times(C2,$s("c")),Rt(Times($s("a"),Power($s("c"),CN1)),C2)),Rt($s("q"),C2)),CN1)),Int(Times(Plus(Rt($s("q"),C2),Power($s("x"),Times($s("k"),C1D2))),Power(Plus(Plus(Rt(Times($s("a"),Power($s("c"),CN1)),C2),Times(Rt($s("q"),C2),Power($s("x"),Times($s("k"),C1D2)))),Power($s("x"),$s("k"))),CN1)),$s("x"))),Dist(Times(C1,Power(Times(Times(Times(C2,$s("c")),Rt(Times($s("a"),Power($s("c"),CN1)),C2)),Rt($s("q"),C2)),CN1)),Int(Times(Plus(Rt($s("q"),C2),Times(CN1,Power($s("x"),Times($s("k"),C1D2)))),Power(Plus(Plus(Rt(Times($s("a"),Power($s("c"),CN1)),C2),Times(CN1,Times(Rt($s("q"),C2),Power($s("x"),Times($s("k"),C1D2))))),Power($s("x"),$s("k"))),CN1)),$s("x")))),Not(NegativeQ($s("q"))))),And(And(And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),IntegerQ(List($s("j"),$s("k")))),Greater($s("k"),C0)),Equal($s("j"),Times(C2,$s("k")))),EvenQ($s("k"))),PosQ(Times($s("a"),Power($s("c"),CN1)))),NegativeQ(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c")))))))),
SetDelayed(Int(Times(C1,Power(Plus(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("k")))),Times($p("c",true),Power($p("x"),$p("j",true)))),CN1)),$p("x",$s("Symbol"))),
    Condition(Module(List(Set($s("q"),Rt(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c")))),C2))),Plus(Dist(Times(C2,Times($s("c"),Power($s("q"),CN1))),Int(Times(C1,Power(Plus(Plus($s("b"),Times(CN1,$s("q"))),Times(Times(C2,$s("c")),Power($s("x"),$s("k")))),CN1)),$s("x"))),Times(CN1,Dist(Times(C2,Times($s("c"),Power($s("q"),CN1))),Int(Times(C1,Power(Plus(Plus($s("b"),$s("q")),Times(Times(C2,$s("c")),Power($s("x"),$s("k")))),CN1)),$s("x")))))),And(And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),IntegerQ(List($s("j"),$s("k")))),Greater($s("k"),C0)),Equal($s("j"),Times(C2,$s("k")))),NonzeroQ(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c")))))),Or(OddQ($s("k")),Not(NegativeQ(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c")))))))))),
SetDelayed(Int(Power(Plus(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("k")))),Times($p("c",true),Power($p("x"),$p("j",true)))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(Times(CN1,$s("x")),Plus(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C2,$s("a")),$s("c")))),Times(Times($s("b"),$s("c")),Power($s("x"),$s("k"))))),Times(Power(Plus(Plus($s("a"),Times($s("b"),Power($s("x"),$s("k")))),Times($s("c"),Power($s("x"),$s("j")))),Plus($s("n"),C1)),Power(Times(Times(Times($s("k"),$s("a")),Plus($s("n"),C1)),Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c"))))),CN1))),Dist(Times(Plus(Plus(Times(Times($s("k"),Plus($s("n"),C1)),Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c"))))),Power($s("b"),C2)),Times(CN1,Times(Times(C2,$s("a")),$s("c")))),Power(Times(Times(Times($s("k"),$s("a")),Plus($s("n"),C1)),Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c"))))),CN1)),Int(Power(Plus(Plus($s("a"),Times($s("b"),Power($s("x"),$s("k")))),Times($s("c"),Power($s("x"),$s("j")))),Plus($s("n"),C1)),$s("x")))),Dist(Times(Times(Plus(Times($s("k"),Plus(Times(C2,$s("n")),C3)),C1),$s("b")),Times($s("c"),Power(Times(Times(Times($s("k"),$s("a")),Plus($s("n"),C1)),Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c"))))),CN1))),Int(Times(Power($s("x"),$s("k")),Power(Plus(Plus($s("a"),Times($s("b"),Power($s("x"),$s("k")))),Times($s("c"),Power($s("x"),$s("j")))),Plus($s("n"),C1))),$s("x")))),And(And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),IntegerQ(List($s("j"),$s("k"),$s("n")))),Greater($s("k"),C0)),Equal($s("j"),Times(C2,$s("k")))),NonzeroQ(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c")))))),Less($s("n"),CN1)))),
SetDelayed(Int(Times(C1,Power(Times($p("x"),Plus(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("k")))),Times($p("c",true),Power($p("x"),$p("j",true))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Log($s("x")),Power($s("a"),CN1)),Times(CN1,Dist(Times(C1,Power(Times($s("a"),$s("k")),CN1)),Subst(Int(Times(Plus($s("b"),Times($s("c"),$s("x"))),Power(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))),CN1)),$s("x")),$s("x"),Power($s("x"),$s("k")))))),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),IntegerQ(List($s("j"),$s("k")))),Greater($s("k"),C0)),Equal($s("j"),Times(C2,$s("k")))),NonzeroQ(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c")))))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Plus(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("k")))),Times($p("c",true),Power($p("x"),$p("j")))),CN1)),$p("x",$s("Symbol"))),
    Condition(Module(List(Set($s("q"),Plus(Times(C2,Rt(Times($s("a"),Power($s("c"),CN1)),C2)),Times(CN1,Times($s("b"),Power($s("c"),CN1)))))),Condition(Plus(Dist(Times(C1,Power(Times(Times(C2,$s("c")),Rt($s("q"),C2)),CN1)),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,Times($s("k"),C1D2)))),Power(Plus(Plus(Rt(Times($s("a"),Power($s("c"),CN1)),C2),Times(CN1,Times(Rt($s("q"),C2),Power($s("x"),Times($s("k"),C1D2))))),Power($s("x"),$s("k"))),CN1)),$s("x"))),Times(CN1,Dist(Times(C1,Power(Times(Times(C2,$s("c")),Rt($s("q"),C2)),CN1)),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,Times($s("k"),C1D2)))),Power(Plus(Plus(Rt(Times($s("a"),Power($s("c"),CN1)),C2),Times(Rt($s("q"),C2),Power($s("x"),Times($s("k"),C1D2)))),Power($s("x"),$s("k"))),CN1)),$s("x"))))),PosQ($s("q")))),And(And(And(And(And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),IntegerQ(List($s("j"),$s("k"),$s("m")))),Greater($s("k"),C0)),Equal($s("j"),Times(C2,$s("k")))),EvenQ($s("m"))),EvenQ($s("k"))),Less(And(Less(C0,Times($s("k"),C1D2)),LessEqual(Times($s("k"),C1D2),$s("m"))),$s("j"))),PosQ(Times($s("a"),Power($s("c"),CN1)))),NegativeQ(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c")))))))),
SetDelayed(Int(Times(Power($p("x"),$p("k")),Power(Plus(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("k")))),Times($p("c",true),Power($p("x"),$p("j",true)))),CN1)),$p("x",$s("Symbol"))),
    Condition(Module(List(Set($s("q"),Rt(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c")))),C2))),Plus(Dist(Plus(C1,Times(CN1,Times($s("b"),Power($s("q"),CN1)))),Int(Times(C1,Power(Plus(Plus($s("b"),Times(CN1,$s("q"))),Times(Times(C2,$s("c")),Power($s("x"),$s("k")))),CN1)),$s("x"))),Dist(Plus(C1,Times($s("b"),Power($s("q"),CN1))),Int(Times(C1,Power(Plus(Plus($s("b"),$s("q")),Times(Times(C2,$s("c")),Power($s("x"),$s("k")))),CN1)),$s("x"))))),And(And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),IntegerQ(List($s("j"),$s("k")))),Greater($s("k"),C0)),Equal($s("j"),Times(C2,$s("k")))),NonzeroQ(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c")))))),Or(OddQ($s("k")),Not(NegativeQ(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c")))))))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Plus(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("k")))),Times($p("c",true),Power($p("x"),$p("j")))),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus(Plus($s("m"),Times(CN1,$s("j"))),C1)),Power(Times($s("c"),Plus(Plus($s("m"),Times(CN1,$s("j"))),C1)),CN1)),Times(CN1,Dist(Times(C1,Power($s("c"),CN1)),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,$s("j")))),Times(Plus($s("a"),Times($s("b"),Power($s("x"),$s("k")))),Power(Plus(Plus($s("a"),Times($s("b"),Power($s("x"),$s("k")))),Times($s("c"),Power($s("x"),Times(C2,$s("k"))))),CN1))),$s("x"))))),And(And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),IntegerQ(List($s("j"),$s("k"),$s("m")))),Greater($s("k"),C0)),Equal($s("j"),Times(C2,$s("k")))),NonzeroQ(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c")))))),Less(Less(C0,$s("j")),Plus($s("m"),C1))))),
SetDelayed(Int(Times(Power($p("x"),$p("m")),Power(Plus(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("k")))),Times($p("c",true),Power($p("x"),$p("j")))),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Power(Times($s("a"),Plus($s("m"),C1)),CN1)),Times(CN1,Dist(Times(C1,Power($s("a"),CN1)),Int(Times(Power($s("x"),Plus($s("m"),$s("k"))),Times(Plus($s("b"),Times($s("c"),Power($s("x"),$s("k")))),Power(Plus(Plus($s("a"),Times($s("b"),Power($s("x"),$s("k")))),Times($s("c"),Power($s("x"),$s("j")))),CN1))),$s("x"))))),And(And(And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),IntegerQ(List($s("j"),$s("k"),$s("m")))),Greater($s("k"),C0)),Equal($s("j"),Times(C2,$s("k")))),NonzeroQ(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c")))))),Less($s("m"),CN1)),Greater($s("k"),C0)))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Plus(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("k")))),Times($p("c",true),Power($p("x"),$p("j")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Dist(Times(C1,Power($s("k"),CN1)),Subst(Int(Times(Power($s("x"),Plus(Times(Plus($s("m"),C1),Power($s("k"),CN1)),Times(CN1,C1))),Power(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))),$s("n"))),$s("x")),$s("x"),Power($s("x"),$s("k")))),And(And(And(And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),IntegerQ(List($s("j"),$s("k"),$s("m"),$s("n")))),Greater($s("k"),C0)),Equal($s("j"),Times(C2,$s("k")))),Greater($s("m"),C0)),Less($s("n"),C0)),IntegerQ(Times(Plus($s("m"),C1),Power($s("k"),CN1)))),NonzeroQ(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c")))))))),
SetDelayed(Int(Times(Power($p("x"),$p("m")),Power(Plus(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("k")))),Times($p("c",true),Power($p("x"),$p("j",true)))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Times(Power(Plus(Plus($s("a"),Times($s("b"),Power($s("x"),$s("k")))),Times($s("c"),Power($s("x"),$s("j")))),$s("n")),Power(Plus(Plus($s("m"),Times($s("j"),$s("n"))),C1),CN1))),Dist(Times(Times($s("a"),$s("j")),Times($s("n"),Power(Plus(Plus($s("m"),Times($s("j"),$s("n"))),C1),CN1))),Int(Times(Power($s("x"),$s("m")),Power(Plus(Plus($s("a"),Times($s("b"),Power($s("x"),$s("k")))),Times($s("c"),Power($s("x"),$s("j")))),Plus($s("n"),Times(CN1,C1)))),$s("x")))),Dist(Times(Times($s("b"),$s("k")),Times($s("n"),Power(Plus(Plus($s("m"),Times($s("j"),$s("n"))),C1),CN1))),Int(Times(Power($s("x"),Plus($s("m"),$s("k"))),Power(Plus(Plus($s("a"),Times($s("b"),Power($s("x"),$s("k")))),Times($s("c"),Power($s("x"),$s("j")))),Plus($s("n"),Times(CN1,C1)))),$s("x")))),And(And(And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),IntegerQ(List($s("j"),$s("k"),$s("m"),$s("n")))),Greater($s("k"),C0)),Equal($s("j"),Times(C2,$s("k")))),Less($s("m"),CN1)),Greater($s("n"),C1)),NonzeroQ(Plus(Plus($s("m"),Times($s("j"),$s("n"))),C1))))),
SetDelayed(Int(Times(Power($p("x"),$p("m")),Power(Plus(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("k")))),Times($p("c",true),Power($p("x"),$p("j",true)))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus(Plus($s("m"),Times(CN1,$s("j"))),C1)),Times(Power(Plus(Plus($s("a"),Times($s("b"),Power($s("x"),$s("k")))),Times($s("c"),Power($s("x"),$s("j")))),Plus($s("n"),C1)),Power(Times(Times($s("c"),$s("k")),Plus($s("n"),C1)),CN1))),Dist(Times($s("a"),Power($s("c"),CN1)),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,$s("j")))),Power(Plus(Plus($s("a"),Times($s("b"),Power($s("x"),$s("k")))),Times($s("c"),Power($s("x"),$s("j")))),$s("n"))),$s("x")))),And(And(And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),IntegerQ(List($s("j"),$s("k"),$s("m"),$s("n")))),Greater($s("k"),C0)),Equal($s("j"),Times(C2,$s("k")))),GreaterEqual(Plus($s("m"),Times(CN1,$s("j"))),C0)),Less($s("n"),CN1)),ZeroQ(Plus(Plus($s("m"),Times($s("k"),Plus($s("n"),Times(CN1,C1)))),C1))))),
SetDelayed(Int(Times(Power($p("x"),$p("m")),Power(Plus(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("k")))),Times($p("c",true),Power($p("x"),$p("j",true)))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Power($s("x"),Plus(Plus($s("m"),Times(CN1,$s("j"))),C1)),Times(Power(Plus(Plus($s("a"),Times($s("b"),Power($s("x"),$s("k")))),Times($s("c"),Power($s("x"),$s("j")))),Plus($s("n"),C1)),Power(Times($s("c"),Plus(Plus($s("m"),Times($s("j"),$s("n"))),C1)),CN1))),Times(CN1,Dist(Times($s("b"),Times(Plus(Plus($s("m"),Times($s("k"),Plus($s("n"),Times(CN1,C1)))),C1),Power(Times($s("c"),Plus(Plus($s("m"),Times($s("j"),$s("n"))),C1)),CN1))),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,$s("k")))),Power(Plus(Plus($s("a"),Times($s("b"),Power($s("x"),$s("k")))),Times($s("c"),Power($s("x"),$s("j")))),$s("n"))),$s("x"))))),Times(CN1,Dist(Times($s("a"),Times(Plus(Plus($s("m"),Times(CN1,$s("j"))),C1),Power(Times($s("c"),Plus(Plus($s("m"),Times($s("j"),$s("n"))),C1)),CN1))),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,$s("j")))),Power(Plus(Plus($s("a"),Times($s("b"),Power($s("x"),$s("k")))),Times($s("c"),Power($s("x"),$s("j")))),$s("n"))),$s("x"))))),And(And(And(And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),IntegerQ(List($s("j"),$s("k"),$s("m"),$s("n")))),Greater($s("k"),C0)),Equal($s("j"),Times(C2,$s("k")))),GreaterEqual(Plus($s("m"),Times(CN1,$s("j"))),C0)),Less($s("n"),CN1)),NonzeroQ(Plus(Plus($s("m"),Times($s("j"),$s("n"))),C1))),NonzeroQ(Plus(Plus($s("m"),Times($s("k"),Plus($s("n"),Times(CN1,C1)))),C1))))),
SetDelayed(Int(Times(Power($p("x"),$p("m")),Power(Plus(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("k")))),Times($p("c",true),Power($p("x"),$p("j",true)))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Times(Power(Plus(Plus($s("a"),Times($s("b"),Power($s("x"),$s("k")))),Times($s("c"),Power($s("x"),$s("j")))),$s("n")),Power(Plus($s("m"),C1),CN1))),Times(CN1,Dist(Times(Times($s("b"),$s("k")),Times($s("n"),Power(Plus($s("m"),C1),CN1))),Int(Times(Power($s("x"),Plus($s("m"),$s("k"))),Power(Plus(Plus($s("a"),Times($s("b"),Power($s("x"),$s("k")))),Times($s("c"),Power($s("x"),$s("j")))),Plus($s("n"),Times(CN1,C1)))),$s("x"))))),Times(CN1,Dist(Times(Times($s("c"),$s("j")),Times($s("n"),Power(Plus($s("m"),C1),CN1))),Int(Times(Power($s("x"),Plus($s("m"),$s("j"))),Power(Plus(Plus($s("a"),Times($s("b"),Power($s("x"),$s("k")))),Times($s("c"),Power($s("x"),$s("j")))),Plus($s("n"),Times(CN1,C1)))),$s("x"))))),And(And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),IntegerQ(List($s("j"),$s("k"),$s("m"),$s("n")))),Greater($s("k"),C0)),Equal($s("j"),Times(C2,$s("k")))),Less($s("m"),CN1)),Greater($s("n"),C1)))),
SetDelayed(Int(Times(Power($p("x"),$p("m")),Power(Plus(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("k")))),Times($p("c",true),Power($p("x"),$p("j",true)))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Times(Power(Plus(Plus($s("a"),Times($s("b"),Power($s("x"),$s("k")))),Times($s("c"),Power($s("x"),$s("j")))),Plus($s("n"),C1)),Power(Times($s("a"),Plus($s("m"),C1)),CN1))),Times(CN1,Dist(Times($s("b"),Times(Plus(Plus($s("m"),C1),Times($s("k"),Plus($s("n"),C1))),Power(Times($s("a"),Plus($s("m"),C1)),CN1))),Int(Times(Power($s("x"),Plus($s("m"),$s("k"))),Power(Plus(Plus($s("a"),Times($s("b"),Power($s("x"),$s("k")))),Times($s("c"),Power($s("x"),$s("j")))),$s("n"))),$s("x"))))),Times(CN1,Dist(Times($s("c"),Times(Plus(Plus($s("m"),C1),Times($s("j"),Plus($s("n"),C1))),Power(Times($s("a"),Plus($s("m"),C1)),CN1))),Int(Times(Power($s("x"),Plus($s("m"),$s("j"))),Power(Plus(Plus($s("a"),Times($s("b"),Power($s("x"),$s("k")))),Times($s("c"),Power($s("x"),$s("j")))),$s("n"))),$s("x"))))),And(And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),IntegerQ(List($s("j"),$s("k"),$s("m"),$s("n")))),Greater($s("k"),C0)),Equal($s("j"),Times(C2,$s("k")))),Less($s("m"),CN1)),LessEqual($s("n"),C1)))),
SetDelayed(Int(Times(Power($p("x"),$p("k")),Power(Plus(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("k")))),Times($p("c",true),Power($p("x"),$p("j",true)))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times($s("x"),Plus($s("b"),Times(Times(C2,$s("c")),Power($s("x"),$s("k"))))),Times(Power(Plus(Plus($s("a"),Times($s("b"),Power($s("x"),$s("k")))),Times($s("c"),Power($s("x"),$s("j")))),$s("n")),Power(Times(Times(C2,$s("c")),Plus(Times($s("k"),Plus(Times(C2,$s("n")),C1)),C1)),CN1))),Times(CN1,Dist(Times($s("b"),Power(Times(Times(C2,$s("c")),Plus(Times($s("k"),Plus(Times(C2,$s("n")),C1)),C1)),CN1)),Int(Power(Plus(Plus($s("a"),Times($s("b"),Power($s("x"),$s("k")))),Times($s("c"),Power($s("x"),$s("j")))),$s("n")),$s("x"))))),Times(CN1,Dist(Times(Times($s("k"),$s("n")),Times(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c")))),Power(Times(Times(C2,$s("c")),Plus(Times($s("k"),Plus(Times(C2,$s("n")),C1)),C1)),CN1))),Int(Times(Power($s("x"),$s("k")),Power(Plus(Plus($s("a"),Times($s("b"),Power($s("x"),$s("k")))),Times($s("c"),Power($s("x"),$s("j")))),Plus($s("n"),Times(CN1,C1)))),$s("x"))))),And(And(And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),IntegerQ(List($s("j"),$s("k"),$s("n")))),Greater($s("k"),C0)),Equal($s("j"),Times(C2,$s("k")))),Greater($s("n"),C0)),NonzeroQ(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c")))))),NonzeroQ(Plus(Times($s("k"),Plus(Times(C2,$s("n")),C1)),C1))))),
SetDelayed(Int(Times(Power($p("x"),$p("k")),Power(Plus(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("k")))),Times($p("c",true),Power($p("x"),$p("j",true)))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times($s("x"),Plus($s("b"),Times(Times(C2,$s("c")),Power($s("x"),$s("k"))))),Times(Power(Plus(Plus($s("a"),Times($s("b"),Power($s("x"),$s("k")))),Times($s("c"),Power($s("x"),$s("j")))),Plus($s("n"),C1)),Power(Times(Times($s("k"),Plus($s("n"),C1)),Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c"))))),CN1))),Times(CN1,Dist(Times($s("b"),Power(Times(Times($s("k"),Plus($s("n"),C1)),Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c"))))),CN1)),Int(Power(Plus(Plus($s("a"),Times($s("b"),Power($s("x"),$s("k")))),Times($s("c"),Power($s("x"),$s("j")))),Plus($s("n"),C1)),$s("x"))))),Times(CN1,Dist(Times(Times(C2,$s("c")),Times(Plus(Times($s("k"),Plus(Times(C2,$s("n")),C3)),C1),Power(Times(Times($s("k"),Plus($s("n"),C1)),Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c"))))),CN1))),Int(Times(Power($s("x"),$s("k")),Power(Plus(Plus($s("a"),Times($s("b"),Power($s("x"),$s("k")))),Times($s("c"),Power($s("x"),$s("j")))),Plus($s("n"),C1))),$s("x"))))),And(And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),IntegerQ(List($s("j"),$s("k"),$s("n")))),Greater($s("k"),C0)),Equal($s("j"),Times(C2,$s("k")))),Less($s("n"),CN1)),NonzeroQ(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c")))))))),
SetDelayed(Int(Times(Plus($p("d"),Times($p("e",true),Power($p("x"),$p("k")))),Power(Plus(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("k")))),Times($p("c",true),Power($p("x"),$p("j",true)))),CN1)),$p("x",$s("Symbol"))),
    Condition(Module(List(Set($s("q"),Rt(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c")))),C2))),Plus(Dist(Plus($s("e"),Times(Plus(Times(Times(C2,$s("c")),$s("d")),Times(CN1,Times($s("b"),$s("e")))),Power($s("q"),CN1))),Int(Times(C1,Power(Plus(Plus($s("b"),Times(CN1,$s("q"))),Times(Times(C2,$s("c")),Power($s("x"),$s("k")))),CN1)),$s("x"))),Dist(Plus($s("e"),Times(CN1,Times(Plus(Times(Times(C2,$s("c")),$s("d")),Times(CN1,Times($s("b"),$s("e")))),Power($s("q"),CN1)))),Int(Times(C1,Power(Plus(Plus($s("b"),$s("q")),Times(Times(C2,$s("c")),Power($s("x"),$s("k")))),CN1)),$s("x"))))),And(And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e")),$s("x")),IntegerQ(List($s("j"),$s("k")))),Greater($s("k"),C0)),Equal($s("j"),Times(C2,$s("k")))),NonzeroQ(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c")))))),Not(NegativeQ(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c"))))))))),
SetDelayed(Int(Times(Plus($p("d",true),Times($p("e",true),Power($p("x"),$p("k")))),Power(Times($p("x"),Plus(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("k")))),Times($p("c",true),Power($p("x"),$p("j",true))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Times($s("d"),Times(Log($s("x")),Power($s("a"),CN1))),Times(CN1,Dist(Times(C1,Power(Times($s("a"),$s("k")),CN1)),Subst(Int(Times(Plus(Plus(Times($s("b"),$s("d")),Times(CN1,Times($s("a"),$s("e")))),Times(Times($s("c"),$s("d")),$s("x"))),Power(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))),CN1)),$s("x")),$s("x"),Power($s("x"),$s("k")))))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e")),$s("x")),IntegerQ(List($s("j"),$s("k")))),Greater($s("k"),C0)),Equal($s("j"),Times(C2,$s("k")))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Times(Plus($p("d",true),Times($p("e",true),Power($p("x"),$p("k")))),Power(Plus(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("k")))),Times($p("c",true),Power($p("x"),$p("j",true)))),CN1))),$p("x",$s("Symbol"))),
    Condition(Plus(Times($s("e"),Times(Power($s("x"),Plus(Plus($s("m"),Times(CN1,$s("k"))),C1)),Power(Times($s("c"),Plus(Plus($s("m"),Times(CN1,$s("k"))),C1)),CN1))),Times(CN1,Dist(Times(C1,Power($s("c"),CN1)),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,$s("k")))),Times(Plus(Times($s("a"),$s("e")),Times(Plus(Times($s("b"),$s("e")),Times(CN1,Times($s("c"),$s("d")))),Power($s("x"),$s("k")))),Power(Plus(Plus($s("a"),Times($s("b"),Power($s("x"),$s("k")))),Times($s("c"),Power($s("x"),$s("j")))),CN1))),$s("x"))))),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e")),$s("x")),IntegerQ(List($s("j"),$s("k"),$s("m")))),Greater($s("k"),C0)),Equal($s("j"),Times(C2,$s("k")))),Less($s("k"),Plus($s("m"),C1))))),
SetDelayed(Int(Times(Power($p("x"),$p("m")),Times(Plus($p("d",true),Times($p("e",true),Power($p("x"),$p("k")))),Power(Plus(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("k")))),Times($p("c",true),Power($p("x"),$p("j",true)))),CN1))),$p("x",$s("Symbol"))),
    Condition(Plus(Times($s("d"),Times(Power($s("x"),Plus($s("m"),C1)),Power(Times($s("a"),Plus($s("m"),C1)),CN1))),Times(CN1,Dist(Times(C1,Power($s("a"),CN1)),Int(Times(Power($s("x"),Plus($s("m"),$s("k"))),Times(Plus(Plus(Times($s("b"),$s("d")),Times(CN1,Times($s("a"),$s("e")))),Times(Times($s("c"),$s("d")),Power($s("x"),$s("k")))),Power(Plus(Plus($s("a"),Times($s("b"),Power($s("x"),$s("k")))),Times($s("c"),Power($s("x"),$s("j")))),CN1))),$s("x"))))),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e")),$s("x")),IntegerQ(List($s("j"),$s("k"),$s("m")))),Greater($s("k"),C0)),Equal($s("j"),Times(C2,$s("k")))),Less($s("m"),CN1)))),
SetDelayed(Int(Times(Plus(Plus(Plus($p("d",true),Times($p("e",true),$p("x"))),Times($p("f",true),Power($p("x"),C2))),Times($p("g",true),Power($p("x"),C3))),Power(Plus(Plus(Plus(Plus($p("a"),Times($p("b",true),$p("x"))),Times($p("c",true),Power($p("x"),C2))),Times($p("b",true),Power($p("x"),C3))),Times($p("a",true),Power($p("x"),C4))),CN1)),$p("x",$s("Symbol"))),
    Condition(Module(List(Set($s("q"),Sqrt(Plus(Plus(Times(integer(8L),Power($s("a"),C2)),Power($s("b"),C2)),Times(CN1,Times(Times(C4,$s("a")),$s("c"))))))),Plus(Dist(Times(C1,Power($s("q"),CN1)),Int(Times(Plus(Plus(Plus(Plus(Times($s("b"),$s("d")),Times(CN1,Times(Times(C2,$s("a")),$s("e")))),Times(Times(C2,$s("a")),$s("g"))),Times($s("d"),$s("q"))),Times(Plus(Plus(Plus(Times(Times(C2,$s("a")),$s("d")),Times(CN1,Times(Times(C2,$s("a")),$s("f")))),Times($s("b"),$s("g"))),Times($s("g"),$s("q"))),$s("x"))),Power(Plus(Plus(Times(C2,$s("a")),Times(Plus($s("b"),$s("q")),$s("x"))),Times(Times(C2,$s("a")),Power($s("x"),C2))),CN1)),$s("x"))),Times(CN1,Dist(Times(C1,Power($s("q"),CN1)),Int(Times(Plus(Plus(Plus(Plus(Times($s("b"),$s("d")),Times(CN1,Times(Times(C2,$s("a")),$s("e")))),Times(Times(C2,$s("a")),$s("g"))),Times(CN1,Times($s("d"),$s("q")))),Times(Plus(Plus(Plus(Times(Times(C2,$s("a")),$s("d")),Times(CN1,Times(Times(C2,$s("a")),$s("f")))),Times($s("b"),$s("g"))),Times(CN1,Times($s("g"),$s("q")))),$s("x"))),Power(Plus(Plus(Times(C2,$s("a")),Times(Plus($s("b"),Times(CN1,$s("q"))),$s("x"))),Times(Times(C2,$s("a")),Power($s("x"),C2))),CN1)),$s("x")))))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e"),$s("f"),$s("g")),$s("x")),PosQ(Plus(Plus(Times(integer(8L),Power($s("a"),C2)),Power($s("b"),C2)),Times(CN1,Times(Times(C4,$s("a")),$s("c")))))))),
SetDelayed(Int(Times(Plus(Plus($p("d",true),Times($p("e",true),$p("x"))),Times($p("g",true),Power($p("x"),C3))),Power(Plus(Plus(Plus(Plus($p("a"),Times($p("b",true),$p("x"))),Times($p("c",true),Power($p("x"),C2))),Times($p("b",true),Power($p("x"),C3))),Times($p("a",true),Power($p("x"),C4))),CN1)),$p("x",$s("Symbol"))),
    Condition(Module(List(Set($s("q"),Sqrt(Plus(Plus(Times(integer(8L),Power($s("a"),C2)),Power($s("b"),C2)),Times(CN1,Times(Times(C4,$s("a")),$s("c"))))))),Plus(Dist(Times(C1,Power($s("q"),CN1)),Int(Times(Plus(Plus(Plus(Plus(Times($s("b"),$s("d")),Times(CN1,Times(Times(C2,$s("a")),$s("e")))),Times(Times(C2,$s("a")),$s("g"))),Times($s("d"),$s("q"))),Times(Plus(Plus(Times(Times(C2,$s("a")),$s("d")),Times($s("b"),$s("g"))),Times($s("g"),$s("q"))),$s("x"))),Power(Plus(Plus(Times(C2,$s("a")),Times(Plus($s("b"),$s("q")),$s("x"))),Times(Times(C2,$s("a")),Power($s("x"),C2))),CN1)),$s("x"))),Times(CN1,Dist(Times(C1,Power($s("q"),CN1)),Int(Times(Plus(Plus(Plus(Plus(Times($s("b"),$s("d")),Times(CN1,Times(Times(C2,$s("a")),$s("e")))),Times(Times(C2,$s("a")),$s("g"))),Times(CN1,Times($s("d"),$s("q")))),Times(Plus(Plus(Times(Times(C2,$s("a")),$s("d")),Times($s("b"),$s("g"))),Times(CN1,Times($s("g"),$s("q")))),$s("x"))),Power(Plus(Plus(Times(C2,$s("a")),Times(Plus($s("b"),Times(CN1,$s("q"))),$s("x"))),Times(Times(C2,$s("a")),Power($s("x"),C2))),CN1)),$s("x")))))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e"),$s("g")),$s("x")),PosQ(Plus(Plus(Times(integer(8L),Power($s("a"),C2)),Power($s("b"),C2)),Times(CN1,Times(Times(C4,$s("a")),$s("c")))))))),
SetDelayed(Int(Power(Plus(Times($p("a",true),Power($p("x"),$p("p",true))),Times($p("b",true),Power($p("x"),$p("q",true)))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Int(Times(Power($s("x"),Times($s("n"),$s("p"))),Power(Plus($s("a"),Times($s("b"),Power($s("x"),Plus($s("q"),Times(CN1,$s("p")))))),$s("n"))),$s("x")),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("p"),$s("q")),$s("x")),IntegerQ($s("n"))),Not(FractionQ($s("p")))),Not(FractionQ($s("q")))),Not(NegativeQ(Plus($s("q"),Times(CN1,$s("p")))))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Plus(Times($p("a",true),Power($p("x"),$p("p",true))),Times($p("b",true),Power($p("x"),$p("q",true)))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Int(Times(Power($s("x"),Plus($s("m"),Times($s("n"),$s("p")))),Power(Plus($s("a"),Times($s("b"),Power($s("x"),Plus($s("q"),Times(CN1,$s("p")))))),$s("n"))),$s("x")),And(And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("m"),$s("p"),$s("q")),$s("x")),IntegerQ($s("n"))),Not(FractionQ($s("p")))),Not(FractionQ($s("q")))),Not(FractionQ($s("m")))),Not(NegativeQ(Plus($s("q"),Times(CN1,$s("p")))))))),
SetDelayed(Int(Times($p("u"),Power($p("v"),$p("p"))),$p("x",$s("Symbol"))),
    Condition(Module(List(Set($s("m"),Exponent($s("u"),$s("x"))),Set($s("n"),Exponent($s("v"),$s("x")))),Condition(Module(List(Set($s("c"),Times(Coefficient($s("u"),$s("x"),$s("m")),Power(Times(Coefficient($s("v"),$s("x"),$s("n")),Plus(Plus($s("m"),C1),Times($s("n"),$s("p")))),CN1))),$s("w")),CompoundExpression(CompoundExpression(Set($s("c"),Times(Coefficient($s("u"),$s("x"),$s("m")),Power(Times(Coefficient($s("v"),$s("x"),$s("n")),Plus(Plus($s("m"),C1),Times($s("n"),$s("p")))),CN1))),Set($s("w"),Apart(Plus($s("u"),Times(CN1,Times(Times($s("c"),Power($s("x"),Plus($s("m"),Times(CN1,$s("n"))))),Plus(Times(Plus(Plus($s("m"),Times(CN1,$s("n"))),C1),$s("v")),Times(Times(Plus($s("p"),C1),$s("x")),D($s("v"),$s("x"))))))),$s("x")))),If(ZeroQ($s("w")),Times(Times($s("c"),Power($s("x"),Plus(Plus($s("m"),Times(CN1,$s("n"))),C1))),Power($s("v"),Plus($s("p"),C1))),Plus(Times(Times($s("c"),Power($s("x"),Plus(Plus($s("m"),Times(CN1,$s("n"))),C1))),Power($s("v"),Plus($s("p"),C1))),Int(Times($s("w"),Power($s("v"),$s("p"))),$s("x")))))),And(And(And(GreaterEqual(Plus($s("m"),C1),$s("n")),Greater($s("n"),C1)),Less(Plus($s("m"),Times($s("n"),$s("p"))),CN1)),FalseQ(DerivativeDivides($s("v"),$s("u"),$s("x")))))),And(And(And(And(And(RationalQ($s("p")),Less($s("p"),CN1)),PolynomialQ(List($s("u"),$s("v")),$s("x"))),SumQ($s("v"))),Not(And(MonomialQ($s("u"),$s("x")),BinomialQ($s("v"),$s("x"))))),Not(And(ZeroQ(Coefficient($s("u"),$s("x"),C0)),ZeroQ(Coefficient($s("v"),$s("x"),C0))))))),
SetDelayed(Int($p("u"),$p("x",$s("Symbol"))),
    Condition(SplitFreeIntegrate($s("u"),$s("x")),SumQ($s("u")))),
SetDelayed(SplitFreeIntegrate($p("u"),$p("x",$s("Symbol"))),
    If(SumQ($s("u")),Map(Function(SplitFreeIntegrate(Slot1,$s("x"))),$s("u")),If(FreeQ($s("u"),$s("x")),Times($s("u"),$s("x")),If(MatchQ($s("u"),Condition(Times($p("c"),Plus($p("a"),Times($p("b",true),$s("x")))),FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")))),Int($s("u"),$s("x")),Module(List(Set($s("lst"),SplitFreeFactors($s("u"),$s("x")))),Dist(Part($s("lst"),C1),Int(Part($s("lst"),C2),$s("x")))))))),
SetDelayed(Int(Power(Times($p("c",true),Power(Plus($p("a",true),Times($p("b",true),$p("x"))),$p("n",true))),$p("m")),$p("x",$s("Symbol"))),
    Condition(Times(Times(Plus($s("a"),Times($s("b"),$s("x"))),Power(Times($s("c"),Power(Plus($s("a"),Times($s("b"),$s("x"))),$s("n"))),$s("m"))),Times(Log(Plus($s("a"),Times($s("b"),$s("x")))),Power($s("b"),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("m"),$s("n")),$s("x")),ZeroQ(Plus(Times($s("m"),$s("n")),C1))))),
SetDelayed(Int(Power(Times($p("c",true),Power(Plus($p("a",true),Times($p("b",true),$p("x"))),$p("n"))),$p("m")),$p("x",$s("Symbol"))),
    Condition(Times(Plus($s("a"),Times($s("b"),$s("x"))),Times(Power(Times($s("c"),Power(Plus($s("a"),Times($s("b"),$s("x"))),$s("n"))),$s("m")),Power(Times($s("b"),Plus(Times($s("m"),$s("n")),C1)),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("m"),$s("n")),$s("x")),NonzeroQ(Plus(Times($s("m"),$s("n")),C1))))),
SetDelayed(Int(Times($p("u",true),Power(Times($p("a",true),Power($p("v"),$p("m"))),$p("p"))),$p("x",$s("Symbol"))),
    Condition(Module(List(Set($s("q"),FractionalPart($s("p")))),Times(Times(Power($s("a"),Plus($s("p"),Times(CN1,$s("q")))),Times(Power(Times($s("a"),Power($s("v"),$s("m"))),$s("q")),Power(Power($s("v"),Times($s("m"),$s("q"))),CN1))),Int(Times($s("u"),Power($s("v"),Times($s("m"),$s("p")))),$s("x")))),And(FreeQ(List($s("a"),$s("m"),$s("p")),$s("x")),IntegerQ(Times($s("m"),$s("p")))))),
SetDelayed(Int(Times($p("u",true),Power(Times(Times($p("a",true),Power($p("v"),$p("m",true))),Power($p("w"),$p("n",true))),$p("p"))),$p("x",$s("Symbol"))),
    Condition(Module(List(Set($s("q"),FractionalPart($s("p")))),Times(Times(Power($s("a"),Plus($s("p"),Times(CN1,$s("q")))),Times(Power(Times(Times($s("a"),Power($s("v"),$s("m"))),Power($s("w"),$s("n"))),$s("q")),Power(Times(Power($s("v"),Times($s("m"),$s("q"))),Power($s("w"),Times($s("n"),$s("q")))),CN1))),Int(Times(Times($s("u"),Power($s("v"),Times($s("m"),$s("p")))),Power($s("w"),Times($s("n"),$s("p")))),$s("x")))),And(And(FreeQ(List($s("a"),$s("m"),$s("n"),$s("p")),$s("x")),IntegerQ(Times($s("m"),$s("p")))),IntegerQ(Times($s("n"),$s("p")))))),
SetDelayed(Int(Power(Plus(Times($p("a",true),Power($p("x"),$p("m",true))),Times($p("b",true),Power($p("x"),$p("n",true)))),$p("p")),$p("x",$s("Symbol"))),
    Condition(Int(Times(Power($s("x"),Times($s("m"),$s("p"))),Power(Plus($s("a"),Times($s("b"),Power($s("x"),Plus($s("n"),Times(CN1,$s("m")))))),$s("p"))),$s("x")),And(And(And(FreeQ(List($s("a"),$s("b"),$s("m"),$s("n")),$s("x")),IntegerQ($s("p"))),ZeroQ(Plus(Plus(Times($s("m"),Plus($s("p"),C1)),Times(CN1,$s("n"))),C1))),Not(IntegerQ(List($s("m"),$s("n"))))))),
SetDelayed(Int(Power(Plus(Times($p("a",true),Power($p("x"),$p("m",true))),Times($p("b",true),Power($p("x"),$p("n",true)))),$p("p")),$p("x",$s("Symbol"))),
    Condition(Int(Power(Times(Power($s("x"),$s("m")),Plus($s("a"),Times($s("b"),Power($s("x"),Plus($s("n"),Times(CN1,$s("m"))))))),$s("p")),$s("x")),And(And(FreeQ(List($s("a"),$s("b"),$s("m"),$s("n")),$s("x")),FractionQ($s("p"))),ZeroQ(Plus(Plus(Times($s("m"),Plus($s("p"),C1)),Times(CN1,$s("n"))),C1))))),
SetDelayed(Int(Power(Plus(Plus(Times($p("a",true),Power($p("x"),$p("m",true))),Times($p("b",true),Power($p("x"),$p("n",true)))),Times($p("c",true),Power($p("x"),$p("q",true)))),$p("p")),$p("x",$s("Symbol"))),
    Condition(Int(Power(Times(Power($s("x"),$s("m")),Plus(Plus($s("a"),Times($s("b"),Power($s("x"),Plus($s("n"),Times(CN1,$s("m")))))),Times($s("c"),Power($s("x"),Plus($s("q"),Times(CN1,$s("m"))))))),$s("p")),$s("x")),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),IntegerQ(List($s("m"),$s("n"),$s("q")))),FractionQ($s("p"))),LessEqual(LessEqual($s("m"),$s("n")),$s("q"))))),
SetDelayed(Int(Times($p("u",true),Times(Power($p("x"),$p("m",true)),Power(Plus(Times($p("a",true),Power($p("x"),$p("n",true))),Times($p("b",true),Power($p("x"),$p("p")))),CN1))),$p("x",$s("Symbol"))),
    Condition(Int(Times($s("u"),Times(Power($s("x"),Plus($s("m"),Times(CN1,$s("n")))),Power(Plus($s("a"),Times($s("b"),Power($s("x"),Plus($s("p"),Times(CN1,$s("n")))))),CN1))),$s("x")),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),FractionQ(List($s("m"),$s("n"),$s("p")))),And(Less(C0,$s("n")),LessEqual($s("n"),$s("p")))))),
SetDelayed(Int(Times(Plus(Times($p("u",true),Power($p("x"),$p("m",true))),$p("v")),Power(Plus(Times($p("a",true),Power($p("x"),$p("n",true))),Times($p("b",true),Power($p("x"),$p("p")))),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Int(Times($s("u"),Times(Power($s("x"),Plus($s("m"),Times(CN1,$s("n")))),Power(Plus($s("a"),Times($s("b"),Power($s("x"),Plus($s("p"),Times(CN1,$s("n")))))),CN1))),$s("x")),Int(Times($s("v"),Power(Plus(Times($s("a"),Power($s("x"),$s("n"))),Times($s("b"),Power($s("x"),$s("p")))),CN1)),$s("x"))),And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),FractionQ(List($s("m"),$s("n"),$s("p")))),And(Less(C0,$s("n")),LessEqual($s("n"),$s("p")))),Not(PolynomialQ($s("v"),$s("x")))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),$p("u")),$p("x",$s("Symbol"))),
    Condition(Int(Map(Function(Times(Power($s("x"),$s("m")),Slot1)),$s("u")),$s("x")),And(FreeQ($s("m"),$s("x")),SumQ($s("u"))))),
SetDelayed(Int(Times(C1,Power(Times($p("x"),Sqrt(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("n",true)))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(integer(-2L),Times(ArcTanh(Times(Sqrt(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),Power(Rt($s("a"),C2),CN1))),Power(Times($s("n"),Rt($s("a"),C2)),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("n")),$s("x")),PosQ($s("a"))))),
SetDelayed(Int(Times(C1,Power(Times($p("x"),Sqrt(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("n",true)))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(C2,Times(ArcTan(Times(Sqrt(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),Power(Rt(Times(CN1,$s("a")),C2),CN1))),Power(Times($s("n"),Rt(Times(CN1,$s("a")),C2)),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("n")),$s("x")),NegQ($s("a"))))),
SetDelayed(Int(Times(Power(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("n",true)))),$p("p")),Power($p("x"),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))),$s("p")),Power(Times($s("n"),$s("p")),CN1)),Dist($s("a"),Int(Times(Power(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))),Plus($s("p"),Times(CN1,C1))),Power($s("x"),CN1)),$s("x")))),And(And(FreeQ(List($s("a"),$s("b"),$s("n")),$s("x")),FractionQ($s("p"))),Greater($s("p"),C0)))),
SetDelayed(Int(Times(Power(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("n",true)))),$p("p")),Power($p("x"),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Power(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))),Plus($s("p"),C1))),Power(Times(Times($s("a"),$s("n")),Plus($s("p"),C1)),CN1)),Dist(Times(C1,Power($s("a"),CN1)),Int(Times(Power(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))),Plus($s("p"),C1)),Power($s("x"),CN1)),$s("x")))),And(And(FreeQ(List($s("a"),$s("b"),$s("n")),$s("x")),FractionQ($s("p"))),Less($s("p"),CN1)))),
SetDelayed(Int(Times(Times($p("u",true),Power(Plus($p("a"),Times($p("b",true),$p("x"))),$p("m"))),Power(Plus($p("c"),Times($p("d",true),$p("x"))),$p("m"))),$p("x",$s("Symbol"))),
    Condition(Int(Times($s("u"),Power(Plus(Plus(Times($s("a"),$s("c")),Times(Plus(Times($s("a"),$s("d")),Times($s("b"),$s("c"))),$s("x"))),Times(Times($s("b"),$s("d")),Power($s("x"),C2))),$s("m"))),$s("x")),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),FractionQ($s("m"))),ZeroQ(Plus($s("b"),$s("d")))),PositiveQ(Plus($s("a"),$s("c")))))),
SetDelayed(Int(Times(C1,Power(Times(Plus($p("a",true),Times($p("b",true),$p("x"))),Sqrt(Plus($p("c",true),Times($p("d",true),$p("x"))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(integer(-2L),Times(ArcTanh(Times(Sqrt(Plus($s("c"),Times($s("d"),$s("x")))),Power(Rt(Times(Plus(Times($s("b"),$s("c")),Times(CN1,Times($s("a"),$s("d")))),Power($s("b"),CN1)),C2),CN1))),Power(Times($s("b"),Rt(Times(Plus(Times($s("b"),$s("c")),Times(CN1,Times($s("a"),$s("d")))),Power($s("b"),CN1)),C2)),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),PosQ(Times(Plus(Times($s("b"),$s("c")),Times(CN1,Times($s("a"),$s("d")))),Power($s("b"),CN1)))))),
SetDelayed(Int(Times(C1,Power(Times(Plus($p("a",true),Times($p("b",true),$p("x"))),Sqrt(Plus($p("c",true),Times($p("d",true),$p("x"))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(C2,Times(ArcTan(Times(Sqrt(Plus($s("c"),Times($s("d"),$s("x")))),Power(Rt(Times(Plus(Times($s("a"),$s("d")),Times(CN1,Times($s("b"),$s("c")))),Power($s("b"),CN1)),C2),CN1))),Power(Times($s("b"),Rt(Times(Plus(Times($s("a"),$s("d")),Times(CN1,Times($s("b"),$s("c")))),Power($s("b"),CN1)),C2)),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),NegQ(Times(Plus(Times($s("b"),$s("c")),Times(CN1,Times($s("a"),$s("d")))),Power($s("b"),CN1)))))),
SetDelayed(Int(Times(C1,Power(Times(Sqrt(Plus($p("a"),Times($p("b",true),$p("x")))),Sqrt(Plus($p("c"),Times($p("b",true),$p("x"))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(ArcCosh(Times($s("b"),Times($s("x"),Power($s("a"),CN1)))),Power($s("b"),CN1)),And(And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),ZeroQ(Plus($s("a"),$s("c")))),PositiveQ($s("a"))))),
SetDelayed(Int(Times(C1,Power(Times(Sqrt(Plus($p("a",true),Times($p("b",true),$p("x")))),Sqrt(Plus($p("c",true),Times($p("d",true),$p("x"))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Times(C2,Rt(Times($s("b"),Power($s("d"),CN1)),C2)),Times(ArcSinh(Times(Sqrt(Plus($s("a"),Times($s("b"),$s("x")))),Power(Rt(Times($s("b"),Power($s("d"),CN1)),C2),CN1))),Power($s("b"),CN1))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),PosQ(Times($s("b"),Power($s("d"),CN1)))),ZeroQ(Plus(Plus(Times($s("a"),$s("d")),Times(CN1,Times($s("b"),$s("c")))),$s("b")))))),
SetDelayed(Int(Times(C1,Power(Times(Sqrt(Plus($p("a",true),Times($p("b",true),$p("x")))),Sqrt(Plus($p("c",true),Times($p("d",true),$p("x"))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Times(C2,Rt(Times(Times(CN1,$s("b")),Power($s("d"),CN1)),C2)),Times(ArcSin(Times(Sqrt(Plus($s("a"),Times($s("b"),$s("x")))),Power(Rt(Times(Times(CN1,$s("b")),Power($s("d"),CN1)),C2),CN1))),Power($s("b"),CN1))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),NegQ(Times($s("b"),Power($s("d"),CN1)))),ZeroQ(Plus(Plus(Times($s("a"),$s("d")),Times(CN1,Times($s("b"),$s("c")))),$s("b")))))),
SetDelayed(Int(Times(C1,Power(Times(Sqrt(Plus($p("a",true),Times($p("b",true),$p("x")))),Sqrt(Plus($p("c",true),Times($p("d",true),$p("x"))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Times(C2,Rt(Times($s("b"),Power($s("d"),CN1)),C2)),Times(ArcSinh(Times(Rt(Times($s("b"),Power(Plus(Times($s("a"),$s("d")),Times(CN1,Times($s("b"),$s("c")))),CN1)),C2),Sqrt(Plus($s("c"),Times($s("d"),$s("x")))))),Power($s("b"),CN1))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),PosQ(Times($s("b"),Power($s("d"),CN1)))),PositiveQ(Times(Plus(Times($s("a"),$s("d")),Times(CN1,Times($s("b"),$s("c")))),Power($s("d"),CN1)))))),
SetDelayed(Int(Times(C1,Power(Times(Sqrt(Plus($p("a",true),Times($p("b",true),$p("x")))),Sqrt(Plus($p("c",true),Times($p("d",true),$p("x"))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Times(integer(-2L),Rt(Times(Times(CN1,$s("b")),Power($s("d"),CN1)),C2)),Times(ArcSin(Times(Rt(Times($s("b"),Power(Plus(Times($s("b"),$s("c")),Times(CN1,Times($s("a"),$s("d")))),CN1)),C2),Sqrt(Plus($s("c"),Times($s("d"),$s("x")))))),Power($s("b"),CN1))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),NegQ(Times($s("b"),Power($s("d"),CN1)))),PositiveQ(Times(Plus(Times($s("a"),$s("d")),Times(CN1,Times($s("b"),$s("c")))),Power($s("d"),CN1)))))),
SetDelayed(Int(Times(C1,Power(Times(Sqrt(Plus($p("a",true),Times($p("b",true),$p("x")))),Sqrt(Plus($p("c",true),Times($p("d",true),$p("x"))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Times(C2,Rt(Times($s("d"),Power($s("b"),CN1)),C2)),Times(ArcTanh(Times(Rt(Times($s("d"),Power($s("b"),CN1)),C2),Times(Sqrt(Plus($s("a"),Times($s("b"),$s("x")))),Power(Sqrt(Plus($s("c"),Times($s("d"),$s("x")))),CN1)))),Power($s("d"),CN1))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),PosQ(Times($s("d"),Power($s("b"),CN1)))),NonzeroQ(Plus(Times($s("a"),$s("d")),Times(CN1,Times($s("b"),$s("c")))))))),
SetDelayed(Int(Times(C1,Power(Times(Sqrt(Plus($p("a",true),Times($p("b",true),$p("x")))),Sqrt(Plus($p("c",true),Times($p("d",true),$p("x"))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Times(integer(-2L),Rt(Times(Times(CN1,$s("d")),Power($s("b"),CN1)),C2)),Times(ArcTan(Times(Rt(Times(Times(CN1,$s("d")),Power($s("b"),CN1)),C2),Times(Sqrt(Plus($s("a"),Times($s("b"),$s("x")))),Power(Sqrt(Plus($s("c"),Times($s("d"),$s("x")))),CN1)))),Power($s("d"),CN1))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),NegQ(Times($s("d"),Power($s("b"),CN1)))),NonzeroQ(Plus(Times($s("a"),$s("d")),Times(CN1,Times($s("b"),$s("c")))))))),
SetDelayed(Int(Times(Power(Plus($p("a",true),Times($p("b",true),$p("x"))),$p("m",true)),Power(Plus($p("c",true),Times($p("d",true),$p("x"))),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Dist(Power(Times($s("d"),Power($s("b"),CN1)),$s("n")),Int(Power(Plus($s("a"),Times($s("b"),$s("x"))),Plus($s("m"),$s("n"))),$s("x"))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("m")),$s("x")),IntegerQ($s("n"))),ZeroQ(Plus(Times($s("b"),$s("c")),Times(CN1,Times($s("a"),$s("d")))))),Not(IntegerQ($s("m")))))),
SetDelayed(Int(Times(Power(Plus($p("a",true),Times($p("b",true),$p("x"))),$p("m")),Power(Plus($p("c",true),Times($p("d",true),$p("x"))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Times(Times(Power(Plus($s("a"),Times($s("b"),$s("x"))),Plus($s("m"),C1)),Power(Plus($s("c"),Times($s("d"),$s("x"))),$s("n"))),Times(Log(Plus($s("a"),Times($s("b"),$s("x")))),Power($s("b"),CN1))),And(And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("m"),$s("n")),$s("x")),Not(IntegerQ($s("m")))),Not(IntegerQ($s("n")))),ZeroQ(Plus(Times($s("b"),$s("c")),Times(CN1,Times($s("a"),$s("d")))))),ZeroQ(Plus(Plus($s("m"),$s("n")),C1))),Or(Less(LeafCount(Plus($s("a"),Times($s("b"),$s("x")))),LeafCount(Plus($s("c"),Times($s("d"),$s("x"))))),And(Equal(LeafCount(Plus($s("a"),Times($s("b"),$s("x")))),LeafCount(Plus($s("c"),Times($s("d"),$s("x"))))),PosQ($s("a"))))))),
SetDelayed(Int(Times(Power(Plus($p("a",true),Times($p("b",true),$p("x"))),$p("m")),Power(Plus($p("c",true),Times($p("d",true),$p("x"))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Times(Power(Plus($s("a"),Times($s("b"),$s("x"))),Plus($s("m"),C1)),Times(Power(Plus($s("c"),Times($s("d"),$s("x"))),$s("n")),Power(Times($s("b"),Plus(Plus($s("m"),$s("n")),C1)),CN1))),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("m"),$s("n")),$s("x")),Not(IntegerQ($s("m")))),Not(IntegerQ($s("n")))),ZeroQ(Plus(Times($s("b"),$s("c")),Times(CN1,Times($s("a"),$s("d")))))),NonzeroQ(Plus(Plus($s("m"),$s("n")),C1))))),
SetDelayed(Int(Times(Power(Plus($p("a",true),Times($p("b",true),$p("x"))),$p("m",true)),Power(Plus($p("c",true),Times($p("d",true),$p("x",true))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Times(Times(CN1,Power(Plus($s("a"),Times($s("b"),$s("x"))),Plus($s("m"),C1))),Times(Power(Plus($s("c"),Times($s("d"),$s("x"))),Plus($s("n"),C1)),Power(Times(Plus($s("n"),C1),Plus(Times($s("b"),$s("c")),Times(CN1,Times($s("a"),$s("d"))))),CN1))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("m"),$s("n")),$s("x")),ZeroQ(Plus(Plus($s("m"),$s("n")),C2))),NonzeroQ(Plus(Times($s("b"),$s("c")),Times(CN1,Times($s("a"),$s("d")))))),NonzeroQ(Plus($s("n"),C1))))),
SetDelayed(Int(Times(Power(Plus($p("c",true),Times($p("d",true),$p("x"))),$p("n",true)),Power(Plus($p("a",true),Times($p("b",true),$p("x"))),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power(Plus($s("c"),Times($s("d"),$s("x"))),$s("n")),Power(Times($s("b"),$s("n")),CN1)),Dist(Times(Plus(Times($s("b"),$s("c")),Times(CN1,Times($s("a"),$s("d")))),Power($s("b"),CN1)),Int(Times(Power(Plus($s("c"),Times($s("d"),$s("x"))),Plus($s("n"),Times(CN1,C1))),Power(Plus($s("a"),Times($s("b"),$s("x"))),CN1)),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),NonzeroQ(Plus(Times($s("b"),$s("c")),Times(CN1,Times($s("a"),$s("d")))))),FractionQ($s("n"))),Greater($s("n"),C0)))),
SetDelayed(Int(Times(Power(Plus($p("a",true),Times($p("b",true),$p("x"))),$p("m")),Plus($p("c",true),Times($p("d",true),$p("x")))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power(Plus($s("a"),Times($s("b"),$s("x"))),Plus($s("m"),C1)),Times(Plus($s("c"),Times($s("d"),$s("x"))),Power(Times($s("b"),Plus($s("m"),C2)),CN1))),Dist(Times(Plus(Times($s("b"),$s("c")),Times(CN1,Times($s("a"),$s("d")))),Power(Times($s("b"),Plus($s("m"),C2)),CN1)),Int(Power(Plus($s("a"),Times($s("b"),$s("x"))),$s("m")),$s("x")))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("m")),$s("x")),Not(IntegerQ($s("m")))),NonzeroQ(Plus(Times($s("b"),$s("c")),Times(CN1,Times($s("a"),$s("d")))))))),
SetDelayed(Int(Times(Power(Plus($p("a",true),Times($p("b",true),$p("x"))),$p("m")),Power(Plus($p("c",true),Times($p("d",true),$p("x"))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power(Plus($s("a"),Times($s("b"),$s("x"))),Plus($s("m"),C1)),Times(Power(Plus($s("c"),Times($s("d"),$s("x"))),$s("n")),Power(Times($s("b"),Plus(Plus($s("m"),$s("n")),C1)),CN1))),Dist(Times(Times($s("n"),Power(Plus(Plus($s("m"),$s("n")),C1),CN1)),Times(Plus(Times($s("b"),$s("c")),Times(CN1,Times($s("a"),$s("d")))),Power($s("b"),CN1))),Int(Times(Power(Plus($s("a"),Times($s("b"),$s("x"))),$s("m")),Power(Plus($s("c"),Times($s("d"),$s("x"))),Plus($s("n"),Times(CN1,C1)))),$s("x")))),And(And(And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("m")),$s("x")),NonzeroQ(Plus(Times($s("b"),$s("c")),Times(CN1,Times($s("a"),$s("d")))))),NonzeroQ(Plus(Plus($s("m"),$s("n")),C1))),RationalQ($s("n"))),Greater($s("n"),C0)),Not(IntegerQ($s("m")))),Or(IntegerQ($s("n")),And(FractionQ($s("m")),Or(LessEqual($s("n"),$s("m")),And(LessEqual(CN1,$s("m")),Less($s("m"),C0)))))))),
SetDelayed(Int(Times(Power(Plus($p("a",true),Times($p("b",true),$p("x"))),$p("m",true)),Power(Plus($p("c",true),Times($p("d",true),$p("x"))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Power(Plus($s("a"),Times($s("b"),$s("x"))),Plus($s("m"),C1))),Times(Power(Plus($s("c"),Times($s("d"),$s("x"))),Plus($s("n"),C1)),Power(Times(Plus($s("n"),C1),Plus(Times($s("b"),$s("c")),Times(CN1,Times($s("a"),$s("d"))))),CN1))),Dist(Times(Times(Plus(Plus($s("m"),$s("n")),C2),Power(Plus($s("n"),C1),CN1)),Times($s("b"),Power(Plus(Times($s("b"),$s("c")),Times(CN1,Times($s("a"),$s("d")))),CN1))),Int(Times(Power(Plus($s("a"),Times($s("b"),$s("x"))),$s("m")),Power(Plus($s("c"),Times($s("d"),$s("x"))),Plus($s("n"),C1))),$s("x")))),And(And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("m")),$s("x")),NonzeroQ(Plus(Times($s("b"),$s("c")),Times(CN1,Times($s("a"),$s("d")))))),RationalQ($s("n"))),Less($s("n"),CN1)),Not(IntegerQ(List($s("m"),$s("n"))))),Or(Or(Not(RationalQ($s("m"))),GreaterEqual($s("n"),$s("m"))),And(LessEqual(CN1,$s("m")),Less($s("m"),C0)))))),
SetDelayed(Int(Times(Power(Plus($p("a",true),Times($p("b",true),$p("x"))),$p("m",true)),Power(Plus($p("c",true),Times($p("d",true),$p("x"))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Power(Plus($s("a"),Times($s("b"),$s("x"))),Plus($s("m"),C1))),Times(Power(Plus($s("c"),Times($s("d"),$s("x"))),Plus($s("n"),C1)),Power(Times(Plus($s("n"),C1),Plus(Times($s("b"),$s("c")),Times(CN1,Times($s("a"),$s("d"))))),CN1))),Dist(Times(Times(Plus(Plus($s("m"),$s("n")),C2),Power(Plus($s("n"),C1),CN1)),Times($s("b"),Power(Plus(Times($s("b"),$s("c")),Times(CN1,Times($s("a"),$s("d")))),CN1))),Int(Times(Power(Plus($s("a"),Times($s("b"),$s("x"))),$s("m")),Power(Plus($s("c"),Times($s("d"),$s("x"))),Plus($s("n"),C1))),$s("x")))),And(And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("m"),$s("n")),$s("x")),NonzeroQ(Plus(Times($s("b"),$s("c")),Times(CN1,Times($s("a"),$s("d")))))),NonzeroQ(Plus($s("n"),C1))),Not(RationalQ($s("n")))),RationalQ(Plus($s("m"),$s("n")))),Less(Simplify(Plus($s("m"),$s("n"))),CN1)))),
SetDelayed(Int(Times(Plus($p("a",true),Times($p("b",true),$p("x"))),Power(Plus($p("c",true),Times($p("d",true),$p("x"))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Plus($s("a"),Times($s("b"),$s("x"))),Times(Power(Plus($s("c"),Times($s("d"),$s("x"))),Plus($s("n"),C1)),Power(Times($s("d"),Plus($s("n"),C1)),CN1))),Times(CN1,Dist(Times($s("b"),Power(Times($s("d"),Plus($s("n"),C1)),CN1)),Int(Power(Plus($s("c"),Times($s("d"),$s("x"))),Plus($s("n"),C1)),$s("x"))))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("n")),$s("x")),Not(IntegerQ($s("n")))))),
SetDelayed(Int(Times(Power(Plus($p("a",true),Times($p("b",true),$p("x"))),$p("m")),Power(Plus($p("c",true),Times($p("d",true),$p("x"))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power(Plus($s("a"),Times($s("b"),$s("x"))),$s("m")),Times(Power(Plus($s("c"),Times($s("d"),$s("x"))),Plus($s("n"),C1)),Power(Times($s("d"),Plus($s("n"),C1)),CN1))),Times(CN1,Dist(Times(Times($s("m"),Power(Plus($s("n"),C1),CN1)),Times($s("b"),Power($s("d"),CN1))),Int(Times(Power(Plus($s("a"),Times($s("b"),$s("x"))),Plus($s("m"),Times(CN1,C1))),Power(Plus($s("c"),Times($s("d"),$s("x"))),Plus($s("n"),C1))),$s("x"))))),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),RationalQ(List($s("m"),$s("n")))),Not(IntegerQ(List($s("m"),$s("n"))))),Greater($s("m"),C0)),Less($s("n"),CN1)))),
SetDelayed(Int(Times(Power(Plus($p("a",true),Times($p("b",true),$p("x"))),$p("m")),Power(Plus($p("c"),Times($p("d",true),$p("x"))),CN1)),$p("x",$s("Symbol"))),
    Condition(Module(List(Set($s("p"),Denominator($s("m")))),Dist($s("p"),Subst(Int(Times(Power($s("x"),Plus(Plus(Times($s("m"),$s("p")),$s("p")),Times(CN1,C1))),Power(Plus(Plus(Times($s("b"),$s("c")),Times(CN1,Times($s("a"),$s("d")))),Times($s("d"),Power($s("x"),$s("p")))),CN1)),$s("x")),$s("x"),Power(Plus($s("a"),Times($s("b"),$s("x"))),Times(C1,Power($s("p"),CN1)))))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),FractionQ($s("m"))),Less(Less(CN1,$s("m")),C0)))),
SetDelayed(Int(Times(Power(Plus($p("a",true),Times($p("b",true),$p("x"))),$p("m")),Power(Plus($p("c",true),Times($p("d",true),$p("x"))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Module(List(Set($s("p"),Denominator($s("m")))),Dist($s("p"),Subst(Int(Times(Power($s("x"),Plus(Plus(Times($s("m"),$s("p")),$s("p")),Times(CN1,C1))),Power(Plus($s("b"),Times(CN1,Times($s("d"),Power($s("x"),$s("p"))))),CN1)),$s("x")),$s("x"),Times(Power(Plus($s("a"),Times($s("b"),$s("x"))),Times(C1,Power($s("p"),CN1))),Power(Power(Plus($s("c"),Times($s("d"),$s("x"))),Times(C1,Power($s("p"),CN1))),CN1))))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),FractionQ(List($s("m"),$s("n")))),Less(Less(CN1,$s("m")),C0)),Equal(Plus($s("m"),$s("n")),CN1)))),
SetDelayed(Int(Times(C1,Power(Times(Times($p("x"),Sqrt(Plus($p("a"),Times($p("b",true),$p("x"))))),Sqrt(Plus($p("c"),Times($p("d",true),$p("x"))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(integer(-2L),Times(ArcTanh(Times(Rt(Times($s("c"),Power($s("a"),CN1)),C2),Times(Sqrt(Plus($s("a"),Times($s("b"),$s("x")))),Power(Sqrt(Plus($s("c"),Times($s("d"),$s("x")))),CN1)))),Power(Times($s("a"),Rt(Times($s("c"),Power($s("a"),CN1)),C2)),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),PosQ(Times($s("c"),Power($s("a"),CN1)))))),
SetDelayed(Int(Times(C1,Power(Times(Times($p("x"),Sqrt(Plus($p("a"),Times($p("b",true),$p("x"))))),Sqrt(Plus($p("c"),Times($p("d",true),$p("x"))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(integer(-2L),Times(ArcTan(Times(Rt(Times(Times(CN1,$s("c")),Power($s("a"),CN1)),C2),Times(Sqrt(Plus($s("a"),Times($s("b"),$s("x")))),Power(Sqrt(Plus($s("c"),Times($s("d"),$s("x")))),CN1)))),Power(Times($s("a"),Rt(Times(Times(CN1,$s("c")),Power($s("a"),CN1)),C2)),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),NegQ(Times($s("c"),Power($s("a"),CN1)))))),
SetDelayed(Int(Times(Power(Plus($p("a"),Times($p("b",true),$p("x"))),$p("n")),Times(Power(Plus($p("c"),Times($p("d",true),$p("x"))),$p("n")),Power($p("x"),CN1))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power(Plus($s("a"),Times($s("b"),$s("x"))),$s("n")),Times(Power(Plus($s("c"),Times($s("d"),$s("x"))),$s("n")),Power(Times(C2,$s("n")),CN1))),Dist(Times($s("a"),$s("c")),Int(Times(Power(Plus($s("a"),Times($s("b"),$s("x"))),Plus($s("n"),Times(CN1,C1))),Times(Power(Plus($s("c"),Times($s("d"),$s("x"))),Plus($s("n"),Times(CN1,C1))),Power($s("x"),CN1))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),FractionQ($s("n"))),Greater($s("n"),C0)),ZeroQ(Plus(Times($s("a"),$s("d")),Times($s("b"),$s("c"))))))),
SetDelayed(Int(Times(Power(Plus($p("a"),Times($p("b",true),$p("x"))),$p("n")),Times(Power(Plus($p("c"),Times($p("d",true),$p("x"))),$p("n")),Power($p("x"),CN1))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Power(Plus($s("a"),Times($s("b"),$s("x"))),$s("n")),Times(Power(Plus($s("c"),Times($s("d"),$s("x"))),$s("n")),Power(Times(C2,$s("n")),CN1))),Dist(Times(Plus(Times($s("a"),$s("d")),Times($s("b"),$s("c"))),C1D2),Int(Times(Power(Plus($s("a"),Times($s("b"),$s("x"))),Plus($s("n"),Times(CN1,C1))),Power(Plus($s("c"),Times($s("d"),$s("x"))),Plus($s("n"),Times(CN1,C1)))),$s("x")))),Dist(Times($s("a"),$s("c")),Int(Times(Power(Plus($s("a"),Times($s("b"),$s("x"))),Plus($s("n"),Times(CN1,C1))),Times(Power(Plus($s("c"),Times($s("d"),$s("x"))),Plus($s("n"),Times(CN1,C1))),Power($s("x"),CN1))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),FractionQ($s("n"))),Greater($s("n"),C0)),NonzeroQ(Plus(Times($s("a"),$s("d")),Times($s("b"),$s("c"))))))),
SetDelayed(Int(Times(Power(Plus($p("a"),Times($p("b",true),$p("x"))),$p("n")),Times(Power(Plus($p("c"),Times($p("d",true),$p("x"))),$p("n")),Power($p("x"),CN1))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Power(Plus($s("a"),Times($s("b"),$s("x"))),Plus($s("n"),C1))),Times(Power(Plus($s("c"),Times($s("d"),$s("x"))),Plus($s("n"),C1)),Power(Times(Times(Times(C2,$s("a")),$s("c")),Plus($s("n"),C1)),CN1))),Dist(Times(C1,Power(Times($s("a"),$s("c")),CN1)),Int(Times(Power(Plus($s("a"),Times($s("b"),$s("x"))),Plus($s("n"),C1)),Times(Power(Plus($s("c"),Times($s("d"),$s("x"))),Plus($s("n"),C1)),Power($s("x"),CN1))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),FractionQ($s("n"))),Less($s("n"),CN1)),ZeroQ(Plus(Times($s("a"),$s("d")),Times($s("b"),$s("c"))))))),
SetDelayed(Int(Times(Power(Plus($p("a"),Times($p("b",true),$p("x"))),$p("n")),Times(Power(Plus($p("c"),Times($p("d",true),$p("x"))),$p("n")),Power($p("x"),CN1))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(CN1,Power(Plus($s("a"),Times($s("b"),$s("x"))),Plus($s("n"),C1))),Times(Power(Plus($s("c"),Times($s("d"),$s("x"))),Plus($s("n"),C1)),Power(Times(Times(Times(C2,$s("a")),$s("c")),Plus($s("n"),C1)),CN1))),Times(CN1,Dist(Times(Plus(Times($s("a"),$s("d")),Times($s("b"),$s("c"))),Power(Times(Times(C2,$s("a")),$s("c")),CN1)),Int(Times(Power(Plus($s("a"),Times($s("b"),$s("x"))),$s("n")),Power(Plus($s("c"),Times($s("d"),$s("x"))),$s("n"))),$s("x"))))),Dist(Times(C1,Power(Times($s("a"),$s("c")),CN1)),Int(Times(Power(Plus($s("a"),Times($s("b"),$s("x"))),Plus($s("n"),C1)),Times(Power(Plus($s("c"),Times($s("d"),$s("x"))),Plus($s("n"),C1)),Power($s("x"),CN1))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),FractionQ($s("n"))),Less($s("n"),CN1)),NonzeroQ(Plus(Times($s("a"),$s("d")),Times($s("b"),$s("c"))))))),
SetDelayed(Int(Times(Times(Power($p("x"),$p("m")),Power(Plus($p("a",true),Times($p("b",true),$p("x"))),$p("n"))),Power(Plus($p("c",true),Times($p("d",true),$p("x"))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(Power($s("x"),Plus($s("m"),Times(CN1,C1))),Power(Plus($s("a"),Times($s("b"),$s("x"))),Plus($s("n"),C1))),Times(Power(Plus($s("c"),Times($s("d"),$s("x"))),Plus($s("n"),C1)),Power(Times(Times(Times(C2,$s("b")),$s("d")),Plus($s("n"),C1)),CN1))),Dist(Times(C1,Power(Times($s("b"),$s("d")),CN1)),Int(Times(Times(Power($s("x"),Plus($s("m"),Times(CN1,C2))),Power(Plus($s("a"),Times($s("b"),$s("x"))),Plus($s("n"),C1))),Power(Plus($s("c"),Times($s("d"),$s("x"))),Plus($s("n"),C1))),$s("x")))),And(And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),FractionQ($s("n"))),RationalQ($s("m"))),Equal(Plus(Plus($s("m"),Times(C2,$s("n"))),C1),C0)),Greater($s("m"),C1)),ZeroQ(Plus(Times($s("a"),$s("d")),Times($s("b"),$s("c"))))))),
SetDelayed(Int(Times(Times(Power($p("x"),$p("m")),Power(Plus($p("a",true),Times($p("b",true),$p("x"))),$p("n"))),Power(Plus($p("c",true),Times($p("d",true),$p("x"))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(Power($s("x"),Plus($s("m"),Times(CN1,C1))),Power(Plus($s("a"),Times($s("b"),$s("x"))),Plus($s("n"),C1))),Times(Power(Plus($s("c"),Times($s("d"),$s("x"))),Plus($s("n"),C1)),Power(Times(Times(Times(C2,$s("b")),$s("d")),Plus($s("n"),C1)),CN1))),Times(CN1,Dist(Times(Plus(Times($s("a"),$s("d")),Times($s("b"),$s("c"))),Power(Times(Times(C2,$s("b")),$s("d")),CN1)),Int(Times(Times(Power($s("x"),Plus($s("m"),Times(CN1,C1))),Power(Plus($s("a"),Times($s("b"),$s("x"))),$s("n"))),Power(Plus($s("c"),Times($s("d"),$s("x"))),$s("n"))),$s("x"))))),Dist(Times(C1,Power(Times($s("b"),$s("d")),CN1)),Int(Times(Times(Power($s("x"),Plus($s("m"),Times(CN1,C2))),Power(Plus($s("a"),Times($s("b"),$s("x"))),Plus($s("n"),C1))),Power(Plus($s("c"),Times($s("d"),$s("x"))),Plus($s("n"),C1))),$s("x")))),And(And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),FractionQ($s("n"))),RationalQ($s("m"))),Equal(Plus(Plus($s("m"),Times(C2,$s("n"))),C1),C0)),Greater($s("m"),C1)),NonzeroQ(Plus(Times($s("a"),$s("d")),Times($s("b"),$s("c"))))))),
SetDelayed(Int(Times(Times($p("x"),Power(Plus($p("a",true),Times($p("b",true),$p("x"))),$p("n"))),Power(Plus($p("c",true),Times($p("d",true),$p("x"))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Times(Power(Plus($s("a"),Times($s("b"),$s("x"))),Plus($s("n"),C1)),Times(Power(Plus($s("c"),Times($s("d"),$s("x"))),Plus($s("n"),C1)),Power(Times(Times(Times(C2,$s("b")),$s("d")),Plus($s("n"),C1)),CN1))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("n")),$s("x")),NonzeroQ(Plus($s("n"),C1))),ZeroQ(Plus(Times($s("a"),$s("d")),Times($s("b"),$s("c"))))))),
SetDelayed(Int(Times(Times($p("x"),Power(Plus($p("a",true),Times($p("b",true),$p("x"))),$p("n"))),Power(Plus($p("c",true),Times($p("d",true),$p("x"))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power(Plus($s("a"),Times($s("b"),$s("x"))),Plus($s("n"),C1)),Times(Power(Plus($s("c"),Times($s("d"),$s("x"))),Plus($s("n"),C1)),Power(Times(Times(Times(C2,$s("b")),$s("d")),Plus($s("n"),C1)),CN1))),Times(CN1,Dist(Times(Plus(Times($s("a"),$s("d")),Times($s("b"),$s("c"))),Power(Times(Times(C2,$s("b")),$s("d")),CN1)),Int(Times(Power(Plus($s("a"),Times($s("b"),$s("x"))),$s("n")),Power(Plus($s("c"),Times($s("d"),$s("x"))),$s("n"))),$s("x"))))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),FractionQ($s("n"))))),
SetDelayed(Int(Times(Times(Power($p("x"),$p("m")),Power(Plus($p("a",true),Times($p("b",true),$p("x"))),$p("n"))),Power(Plus($p("c",true),Times($p("d",true),$p("x"))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(Power($s("x"),Plus($s("m"),Times(CN1,C1))),Power(Plus($s("a"),Times($s("b"),$s("x"))),Plus($s("n"),C1))),Times(Power(Plus($s("c"),Times($s("d"),$s("x"))),Plus($s("n"),C1)),Power(Times(Times($s("b"),$s("d")),Plus(Plus($s("m"),Times(C2,$s("n"))),C1)),CN1))),Times(CN1,Dist(Times(Times($s("a"),$s("c")),Times(Plus($s("m"),Times(CN1,C1)),Power(Times(Times($s("b"),$s("d")),Plus(Plus($s("m"),Times(C2,$s("n"))),C1)),CN1))),Int(Times(Times(Power($s("x"),Plus($s("m"),Times(CN1,C2))),Power(Plus($s("a"),Times($s("b"),$s("x"))),$s("n"))),Power(Plus($s("c"),Times($s("d"),$s("x"))),$s("n"))),$s("x"))))),And(And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),FractionQ($s("n"))),RationalQ($s("m"))),NonzeroQ(Plus(Plus($s("m"),Times(C2,$s("n"))),C1))),Greater($s("m"),C1)),Or(ZeroQ(Plus($s("m"),$s("n"))),ZeroQ(Plus(Times($s("a"),$s("d")),Times($s("b"),$s("c")))))))),
SetDelayed(Int(Times(Times(Power($p("x"),$p("m")),Power(Plus($p("a",true),Times($p("b",true),$p("x"))),$p("n"))),Power(Plus($p("c",true),Times($p("d",true),$p("x"))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(Power($s("x"),Plus($s("m"),Times(CN1,C1))),Power(Plus($s("a"),Times($s("b"),$s("x"))),Plus($s("n"),C1))),Times(Power(Plus($s("c"),Times($s("d"),$s("x"))),Plus($s("n"),C1)),Power(Times(Times($s("b"),$s("d")),Plus(Plus($s("m"),Times(C2,$s("n"))),C1)),CN1))),Times(CN1,Dist(Times(Plus($s("m"),$s("n")),Times(Plus(Times($s("a"),$s("d")),Times($s("b"),$s("c"))),Power(Times(Times($s("b"),$s("d")),Plus(Plus($s("m"),Times(C2,$s("n"))),C1)),CN1))),Int(Times(Times(Power($s("x"),Plus($s("m"),Times(CN1,C1))),Power(Plus($s("a"),Times($s("b"),$s("x"))),$s("n"))),Power(Plus($s("c"),Times($s("d"),$s("x"))),$s("n"))),$s("x"))))),Times(CN1,Dist(Times(Times($s("a"),$s("c")),Times(Plus($s("m"),Times(CN1,C1)),Power(Times(Times($s("b"),$s("d")),Plus(Plus($s("m"),Times(C2,$s("n"))),C1)),CN1))),Int(Times(Times(Power($s("x"),Plus($s("m"),Times(CN1,C2))),Power(Plus($s("a"),Times($s("b"),$s("x"))),$s("n"))),Power(Plus($s("c"),Times($s("d"),$s("x"))),$s("n"))),$s("x"))))),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),FractionQ($s("n"))),RationalQ($s("m"))),NonzeroQ(Plus(Plus($s("m"),Times(C2,$s("n"))),C1))),Greater($s("m"),C1)))),
SetDelayed(Int(Times(Times(Power($p("x"),$p("m")),Power(Plus($p("a"),Times($p("b",true),$p("x"))),$p("n"))),Power(Plus($p("c"),Times($p("d",true),$p("x"))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Times(Times(Power($s("x"),Plus($s("m"),C1)),Power(Plus($s("a"),Times($s("b"),$s("x"))),Plus($s("n"),C1))),Times(Power(Plus($s("c"),Times($s("d"),$s("x"))),Plus($s("n"),C1)),Power(Times(Times($s("a"),$s("c")),Plus($s("m"),C1)),CN1))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("n")),$s("x")),NonzeroQ(Plus($s("m"),C1))),ZeroQ(Plus(Plus($s("m"),Times(C2,$s("n"))),C3))),ZeroQ(Plus(Times($s("a"),$s("d")),Times($s("b"),$s("c"))))))),
SetDelayed(Int(Times(Times(Power($p("x"),$p("m")),Power(Plus($p("a"),Times($p("b",true),$p("x"))),$p("n"))),Power(Plus($p("c"),Times($p("d",true),$p("x"))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(Power($s("x"),Plus($s("m"),C1)),Power(Plus($s("a"),Times($s("b"),$s("x"))),Plus($s("n"),C1))),Times(Power(Plus($s("c"),Times($s("d"),$s("x"))),Plus($s("n"),C1)),Power(Times(Times($s("a"),$s("c")),Plus($s("m"),C1)),CN1))),Times(CN1,Dist(Times(Times(Plus(Plus($s("m"),$s("n")),C2),Power(Plus($s("m"),C1),CN1)),Times(Plus(Times($s("a"),$s("d")),Times($s("b"),$s("c"))),Power(Times($s("a"),$s("c")),CN1))),Int(Times(Times(Power($s("x"),Plus($s("m"),C1)),Power(Plus($s("a"),Times($s("b"),$s("x"))),$s("n"))),Power(Plus($s("c"),Times($s("d"),$s("x"))),$s("n"))),$s("x"))))),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),FractionQ($s("n"))),RationalQ($s("m"))),Less($s("m"),CN1)),ZeroQ(Plus(Plus($s("m"),Times(C2,$s("n"))),C3))))),
SetDelayed(Int(Times(Times(Power($p("x"),$p("m")),Power(Plus($p("a"),Times($p("b",true),$p("x"))),$p("n"))),Power(Plus($p("c"),Times($p("d",true),$p("x"))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(Power($s("x"),Plus($s("m"),C1)),Power(Plus($s("a"),Times($s("b"),$s("x"))),Plus($s("n"),C1))),Times(Power(Plus($s("c"),Times($s("d"),$s("x"))),Plus($s("n"),C1)),Power(Times(Times($s("a"),$s("c")),Plus($s("m"),C1)),CN1))),Times(CN1,Dist(Times(Times(Plus(Plus($s("m"),Times(C2,$s("n"))),C3),Power(Plus($s("m"),C1),CN1)),Times($s("b"),Times($s("d"),Power(Times($s("a"),$s("c")),CN1)))),Int(Times(Times(Power($s("x"),Plus($s("m"),C2)),Power(Plus($s("a"),Times($s("b"),$s("x"))),$s("n"))),Power(Plus($s("c"),Times($s("d"),$s("x"))),$s("n"))),$s("x"))))),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),FractionQ($s("n"))),RationalQ($s("m"))),Less($s("m"),CN1)),Or(ZeroQ(Plus(Plus($s("m"),$s("n")),C2)),ZeroQ(Plus(Times($s("a"),$s("d")),Times($s("b"),$s("c")))))))),
SetDelayed(Int(Times(Times(Power($p("x"),$p("m")),Power(Plus($p("a"),Times($p("b",true),$p("x"))),$p("n"))),Power(Plus($p("c"),Times($p("d",true),$p("x"))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(Power($s("x"),Plus($s("m"),C1)),Power(Plus($s("a"),Times($s("b"),$s("x"))),Plus($s("n"),C1))),Times(Power(Plus($s("c"),Times($s("d"),$s("x"))),Plus($s("n"),C1)),Power(Times(Times($s("a"),$s("c")),Plus($s("m"),C1)),CN1))),Times(CN1,Dist(Times(Times(Plus(Plus($s("m"),$s("n")),C2),Power(Plus($s("m"),C1),CN1)),Times(Plus(Times($s("a"),$s("d")),Times($s("b"),$s("c"))),Power(Times($s("a"),$s("c")),CN1))),Int(Times(Times(Power($s("x"),Plus($s("m"),C1)),Power(Plus($s("a"),Times($s("b"),$s("x"))),$s("n"))),Power(Plus($s("c"),Times($s("d"),$s("x"))),$s("n"))),$s("x"))))),Times(CN1,Dist(Times(Times(Plus(Plus($s("m"),Times(C2,$s("n"))),C3),Power(Plus($s("m"),C1),CN1)),Times($s("b"),Times($s("d"),Power(Times($s("a"),$s("c")),CN1)))),Int(Times(Times(Power($s("x"),Plus($s("m"),C2)),Power(Plus($s("a"),Times($s("b"),$s("x"))),$s("n"))),Power(Plus($s("c"),Times($s("d"),$s("x"))),$s("n"))),$s("x"))))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),FractionQ($s("n"))),RationalQ($s("m"))),Less($s("m"),CN1)))),
SetDelayed(Int(Times(Power(Plus($p("a"),Times($p("b",true),$p("x"))),$p("n")),Times(Power(Plus($p("c"),Times($p("d",true),$p("x"))),$p("p")),Power($p("x"),CN1))),$p("x",$s("Symbol"))),
    Condition(Plus(Dist($s("b"),Int(Times(Power(Plus($s("a"),Times($s("b"),$s("x"))),Plus($s("n"),Times(CN1,C1))),Power(Plus($s("c"),Times($s("d"),$s("x"))),$s("p"))),$s("x"))),Dist($s("a"),Int(Times(Power(Plus($s("a"),Times($s("b"),$s("x"))),Plus($s("n"),Times(CN1,C1))),Times(Power(Plus($s("c"),Times($s("d"),$s("x"))),$s("p")),Power($s("x"),CN1))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),FractionQ(List($s("n"),$s("p")))),Greater($s("n"),C0)),IntegerQ(Plus($s("n"),Times(CN1,$s("p"))))))),
SetDelayed(Int(Times(Power(Plus($p("a"),Times($p("b",true),$p("x"))),$p("n")),Times(Power(Plus($p("c"),Times($p("d",true),$p("x"))),$p("p")),Power($p("x"),CN1))),$p("x",$s("Symbol"))),
    Condition(Plus(Dist(Times(C1,Power($s("a"),CN1)),Int(Times(Power(Plus($s("a"),Times($s("b"),$s("x"))),Plus($s("n"),C1)),Times(Power(Plus($s("c"),Times($s("d"),$s("x"))),$s("p")),Power($s("x"),CN1))),$s("x"))),Times(CN1,Dist(Times($s("b"),Power($s("a"),CN1)),Int(Times(Power(Plus($s("a"),Times($s("b"),$s("x"))),$s("n")),Power(Plus($s("c"),Times($s("d"),$s("x"))),$s("p"))),$s("x"))))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),FractionQ(List($s("n"),$s("p")))),Less($s("n"),CN1)),IntegerQ(Plus($s("n"),Times(CN1,$s("p"))))))),
SetDelayed(Int(Times(Times(Power($p("x"),$p("m",true)),Power(Plus($p("a"),Times($p("b",true),$p("x"))),$p("n"))),Power(Plus($p("c",true),Times($p("d",true),$p("x"))),$p("p",true))),$p("x",$s("Symbol"))),
    Condition(Sum(Dist(Times(Times(Power(Times(CN1,$s("a")),Plus($s("m"),Times(CN1,$s("k")))),Power(Power($s("b"),$s("m")),CN1)),Binomial($s("m"),Plus($s("m"),Times(CN1,$s("k"))))),Int(Times(Power(Plus($s("a"),Times($s("b"),$s("x"))),Plus($s("n"),$s("k"))),Power(Plus($s("c"),Times($s("d"),$s("x"))),$s("p"))),$s("x"))),List($s("k"),C0,$s("m"))),And(And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("n"),$s("p")),$s("x")),IntegerQ(List($s("m"),Plus($s("p"),Times(CN1,$s("n")))))),Greater($s("m"),C0)),Not(IntegerQ($s("n")))),Less(Plus($s("p"),Times(CN1,$s("n"))),C0)),Or(Greater($s("m"),C3),UnsameQ($s("n"),CN1D2))))),
SetDelayed(Int(Times(Times(Power($p("x"),$p("m",true)),Power(Plus($p("a"),Times($p("b",true),$p("x"))),$p("n"))),Power(Plus($p("c",true),Times($p("d",true),$p("x"))),$p("p"))),$p("x",$s("Symbol"))),
    Condition(Plus(Sum(Dist(Times(Times(Power(Times(CN1,$s("a")),Plus($s("m"),Times(CN1,$s("k")))),Power(Power($s("b"),$s("m")),CN1)),Binomial($s("m"),Plus($s("m"),Times(CN1,$s("k"))))),Int(Times(Power(Plus($s("a"),Times($s("b"),$s("x"))),Plus($s("n"),$s("k"))),Power(Plus($s("c"),Times($s("d"),$s("x"))),$s("p"))),$s("x"))),List($s("k"),C0,Plus(Plus($s("p"),Times(CN1,$s("n"))),Times(CN1,C1)))),Sum(Dist(Times(Times(Power(Times(Times(CN1,$s("a")),Power($s("b"),CN1)),Plus($s("m"),Times(CN1,$s("k")))),Power(Power(Times(CN1,$s("a")),Plus($s("p"),Times(CN1,$s("n")))),CN1)),Binomial(Plus(Plus($s("m"),Times(CN1,$s("k"))),Times(CN1,C1)),Plus(Plus($s("p"),Times(CN1,$s("n"))),Times(CN1,C1)))),Int(Times(Times(Power($s("x"),$s("k")),Power(Plus($s("a"),Times($s("b"),$s("x"))),$s("p"))),Power(Plus($s("c"),Times($s("d"),$s("x"))),$s("p"))),$s("x"))),List($s("k"),C0,Plus(Plus($s("m"),Times(CN1,$s("p"))),$s("n"))))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("n"),$s("p")),$s("x")),IntegerQ(List($s("m"),Plus($s("p"),Times(CN1,$s("n")))))),And(Less(C0,Plus($s("p"),Times(CN1,$s("n")))),LessEqual(Plus($s("p"),Times(CN1,$s("n"))),$s("m")))),Not(IntegerQ($s("n")))))),
SetDelayed(Int(Times(Times(Power($p("x"),$p("m",true)),Power(Plus($p("a"),Times($p("b",true),$p("x"))),$p("n"))),Power(Plus($p("c",true),Times($p("d",true),$p("x"))),$p("p"))),$p("x",$s("Symbol"))),
    Condition(Plus(Sum(Dist(Times(Times(Power($s("a"),Plus($s("m"),Times(CN1,$s("k")))),Power(Power(Times(CN1,$s("b")),$s("m")),CN1)),Binomial(Plus(Plus($s("k"),Times(CN1,$s("m"))),Times(CN1,C1)),Plus(Times(CN1,$s("m")),Times(CN1,C1)))),Int(Times(Power(Plus($s("a"),Times($s("b"),$s("x"))),Plus($s("n"),$s("k"))),Power(Plus($s("c"),Times($s("d"),$s("x"))),$s("p"))),$s("x"))),List($s("k"),C0,Plus(Plus($s("p"),Times(CN1,$s("n"))),Times(CN1,C1)))),Sum(Dist(Times(Times(Power(Times(Times(CN1,$s("b")),Power($s("a"),CN1)),$s("k")),Power(Power($s("a"),Plus($s("p"),Times(CN1,$s("n")))),CN1)),Binomial(Plus(Plus(Plus($s("p"),Times(CN1,$s("n"))),$s("k")),Times(CN1,C1)),Plus(Plus($s("p"),Times(CN1,$s("n"))),Times(CN1,C1)))),Int(Times(Times(Power($s("x"),Plus($s("m"),$s("k"))),Power(Plus($s("a"),Times($s("b"),$s("x"))),$s("p"))),Power(Plus($s("c"),Times($s("d"),$s("x"))),$s("p"))),$s("x"))),List($s("k"),C0,Plus(Times(CN1,$s("m")),Times(CN1,C1))))),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("n"),$s("p")),$s("x")),IntegerQ(List($s("m"),Plus($s("p"),Times(CN1,$s("n")))))),Less($s("m"),C0)),Greater(Plus($s("p"),Times(CN1,$s("n"))),C0)),Not(IntegerQ($s("n")))))),
SetDelayed(Int(Times(C1,Power(Plus($p("a"),Times($p("b",true),Power(Power($p("x"),$p("m")),$p("n")))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Times(Rt(Times($s("b"),Power($s("a"),CN1)),C2),$s("x")),Times(ArcTan(Times(Rt(Times($s("b"),Power($s("a"),CN1)),C2),Power(Power($s("x"),$s("m")),Times(C1,Power($s("m"),CN1))))),Power(Times($s("b"),Power(Power($s("x"),$s("m")),Times(C1,Power($s("m"),CN1)))),CN1))),And(And(FreeQ(List($s("a"),$s("b"),$s("m"),$s("n")),$s("x")),SameQ(Times($s("m"),$s("n")),C2)),PosQ(Times($s("a"),Power($s("b"),CN1)))))),
SetDelayed(Int(Times(C1,Power(Plus($p("a"),Times($p("b",true),Power(Power($p("x"),$p("m")),$p("n")))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Times(Times(CN1,Rt(Times(Times(CN1,$s("b")),Power($s("a"),CN1)),C2)),$s("x")),Times(ArcTanh(Times(Rt(Times(Times(CN1,$s("b")),Power($s("a"),CN1)),C2),Power(Power($s("x"),$s("m")),Times(C1,Power($s("m"),CN1))))),Power(Times($s("b"),Power(Power($s("x"),$s("m")),Times(C1,Power($s("m"),CN1)))),CN1))),And(And(FreeQ(List($s("a"),$s("b"),$s("m"),$s("n")),$s("x")),SameQ(Times($s("m"),$s("n")),C2)),NegQ(Times($s("a"),Power($s("b"),CN1)))))),
SetDelayed(Int(Times(C1,Power(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("n")))),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Times($s("x"),Power($s("a"),CN1)),Times(CN1,Dist(Times($s("b"),Power($s("a"),CN1)),Int(Times(C1,Power(Plus($s("b"),Times($s("a"),Power($s("x"),Times(CN1,$s("n"))))),CN1)),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),FractionQ($s("n"))),Less($s("n"),C0)))),
SetDelayed(Int(Times(C1,Power(Sqrt(Plus($p("a"),Times($p("b",true),Power($p("x"),C2)))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(ArcSinh(Times(Rt($s("b"),C2),Times($s("x"),Power(Sqrt($s("a")),CN1)))),Power(Rt($s("b"),C2),CN1)),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),PositiveQ($s("a"))),PosQ($s("b"))))),
SetDelayed(Int(Times(C1,Power(Sqrt(Plus($p("a"),Times($p("b",true),Power($p("x"),C2)))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(ArcSin(Times(Rt(Times(CN1,$s("b")),C2),Times($s("x"),Power(Sqrt($s("a")),CN1)))),Power(Rt(Times(CN1,$s("b")),C2),CN1)),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),PositiveQ($s("a"))),NegQ($s("b")))))
  );
}
