package org.matheclipse.core.integrate.rubi;


import static org.matheclipse.core.expression.F.*;
import static org.matheclipse.core.integrate.rubi.UtilityFunctionCtors.*;
import static org.matheclipse.core.integrate.rubi.UtilityFunctions.*;
import org.matheclipse.core.interfaces.IAST;
import org.matheclipse.core.interfaces.IExpr;

/** 
 * IndefiniteIntegrationRules from the <a href="http://www.apmaths.uwo.ca/~arich/">Rubi -
 * rule-based integrator</a>.
 *  
 */
public class IndefiniteIntegrationRules10 { 
  public static IAST RULES = List( 
SetDelayed(Int(Times(Power(Csch(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m")),Power(Coth(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Dist(Times(CN1,Power($s("b"),CN1)),Subst(Int(Regularize(Times(Power($s("x"),$s("n")),Power(Plus(CN1,Power($s("x"),C2)),Times(Plus($s("m"),Times(CN1,C2)),C1D2))),$s("x")),$s("x")),$s("x"),Coth(Plus($s("a"),Times($s("b"),$s("x")))))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("n")),$s("x")),EvenQ($s("m"))),Greater($s("m"),C2)),Not(And(OddQ($s("n")),Less(Less(C0,$s("n")),Plus($s("m"),Times(CN1,C1)))))))),
SetDelayed(Int(Times(Power(Csch(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m",true)),Power(Coth(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Dist(Times(CN1,Power($s("b"),CN1)),Subst(Int(Regularize(Times(Power($s("x"),Plus($s("m"),Times(CN1,C1))),Power(Plus(C1,Power($s("x"),C2)),Times(Plus($s("n"),Times(CN1,C1)),C1D2))),$s("x")),$s("x")),$s("x"),Csch(Plus($s("a"),Times($s("b"),$s("x")))))),And(And(FreeQ(List($s("a"),$s("b"),$s("m")),$s("x")),OddQ($s("n"))),Not(And(EvenQ($s("m")),And(Less(C0,$s("m")),LessEqual($s("m"),Plus($s("n"),C1)))))))),
SetDelayed(Int(Times(Power(Csch(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m",true)),Power(Coth(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Power(Csch(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),Times(CN1,C2)))),Times(Power(Coth(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C1)),Power(Times($s("b"),Plus($s("n"),C1)),CN1))),Times(CN1,Dist(Times(Plus($s("m"),Times(CN1,C2)),Power(Plus($s("n"),C1),CN1)),Int(Times(Power(Csch(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),Times(CN1,C2))),Power(Coth(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C2))),$s("x"))))),And(And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),RationalQ(List($s("m"),$s("n")))),Greater($s("m"),C1)),Less($s("n"),CN1)),Not(EvenQ($s("m")))))),
SetDelayed(Int(Times(Power(Csch(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m")),Power(Coth(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Power(Csch(Plus($s("a"),Times($s("b"),$s("x")))),$s("m"))),Times(Power(Coth(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C1))),Power(Times($s("b"),$s("m")),CN1))),Times(CN1,Dist(Times(Plus($s("n"),Times(CN1,C1)),Power($s("m"),CN1)),Int(Times(Power(Csch(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),C2)),Power(Coth(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C2)))),$s("x"))))),And(And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),RationalQ(List($s("m"),$s("n")))),Less($s("m"),CN1)),Greater($s("n"),C1)),Not(EvenQ($s("m")))))),
SetDelayed(Int(Times(Power(Csch(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m",true)),Power(Coth(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Times(Times(CN1,Power(Csch(Plus($s("a"),Times($s("b"),$s("x")))),$s("m"))),Times(Power(Coth(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C1)),Power(Times($s("b"),$s("m")),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("m"),$s("n")),$s("x")),ZeroQ(Plus(Plus($s("m"),$s("n")),C1))))),
SetDelayed(Int(Times(Power(Csch(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m")),Power(Coth(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Power(Csch(Plus($s("a"),Times($s("b"),$s("x")))),$s("m"))),Times(Power(Coth(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C1)),Power(Times($s("b"),$s("m")),CN1))),Times(CN1,Dist(Times(Plus(Plus($s("m"),$s("n")),C1),Power($s("m"),CN1)),Int(Times(Power(Csch(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),C2)),Power(Coth(Plus($s("a"),Times($s("b"),$s("x")))),$s("n"))),$s("x"))))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("n")),$s("x")),RationalQ($s("m"))),Less($s("m"),CN1)),Not(EvenQ($s("m")))))),
SetDelayed(Int(Times(Power(Csch(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m")),Power(Coth(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Power(Csch(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),Times(CN1,C2)))),Times(Power(Coth(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C1)),Power(Times($s("b"),Plus(Plus($s("m"),$s("n")),Times(CN1,C1))),CN1))),Times(CN1,Dist(Times(Plus($s("m"),Times(CN1,C2)),Power(Plus(Plus($s("m"),$s("n")),Times(CN1,C1)),CN1)),Int(Times(Power(Csch(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),Times(CN1,C2))),Power(Coth(Plus($s("a"),Times($s("b"),$s("x")))),$s("n"))),$s("x"))))),And(And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("n")),$s("x")),RationalQ($s("m"))),Greater($s("m"),C1)),NonzeroQ(Plus(Plus($s("m"),$s("n")),Times(CN1,C1)))),Not(EvenQ($s("m")))),Not(OddQ($s("n")))))),
SetDelayed(Int(Times(Power(Csch(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m",true)),Power(Coth(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Power(Csch(Plus($s("a"),Times($s("b"),$s("x")))),$s("m"))),Times(Power(Coth(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C1))),Power(Times($s("b"),Plus(Plus($s("m"),$s("n")),Times(CN1,C1))),CN1))),Dist(Times(Plus($s("n"),Times(CN1,C1)),Power(Plus(Plus($s("m"),$s("n")),Times(CN1,C1)),CN1)),Int(Times(Power(Csch(Plus($s("a"),Times($s("b"),$s("x")))),$s("m")),Power(Coth(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C2)))),$s("x")))),And(And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("m")),$s("x")),RationalQ($s("n"))),Greater($s("n"),C1)),NonzeroQ(Plus(Plus($s("m"),$s("n")),Times(CN1,C1)))),Not(EvenQ($s("m")))),Not(OddQ($s("n")))))),
SetDelayed(Int(Times(Power(Csch(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m",true)),Power(Coth(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power(Csch(Plus($s("a"),Times($s("b"),$s("x")))),$s("m")),Times(Power(Coth(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C1)),Power(Times($s("b"),Plus($s("n"),C1)),CN1))),Dist(Times(Plus(Plus($s("m"),$s("n")),C1),Power(Plus($s("n"),C1),CN1)),Int(Times(Power(Csch(Plus($s("a"),Times($s("b"),$s("x")))),$s("m")),Power(Coth(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C2))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("m")),$s("x")),RationalQ($s("n"))),Less($s("n"),CN1)),Not(EvenQ($s("m")))))),
SetDelayed(Int(Times(Times(Power($p("x"),$p("m",true)),Power(Csch(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n",true))))),$p("p"))),Cosh(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n",true)))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Power($s("x"),Plus(Plus($s("m"),Times(CN1,$s("n"))),C1))),Times(Power(Csch(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),Plus($s("p"),Times(CN1,C1))),Power(Times(Times($s("b"),$s("n")),Plus($s("p"),Times(CN1,C1))),CN1))),Dist(Times(Plus(Plus($s("m"),Times(CN1,$s("n"))),C1),Power(Times(Times($s("b"),$s("n")),Plus($s("p"),Times(CN1,C1))),CN1)),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,$s("n")))),Power(Csch(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),Plus($s("p"),Times(CN1,C1)))),$s("x")))),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("p")),$s("x")),RationalQ($s("m"))),IntegerQ($s("n"))),GreaterEqual(Plus($s("m"),Times(CN1,$s("n"))),C0)),NonzeroQ(Plus($s("p"),Times(CN1,C1)))))),
SetDelayed(Int(Times(Times(Power($p("x"),$p("m",true)),Power(Csch(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n",true))))),$p("p",true))),Power(Coth(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n",true))))),$p("q",true))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Power($s("x"),Plus(Plus($s("m"),Times(CN1,$s("n"))),C1))),Times(Power(Csch(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),$s("p")),Power(Times(Times($s("b"),$s("n")),$s("p")),CN1))),Dist(Times(Plus(Plus($s("m"),Times(CN1,$s("n"))),C1),Power(Times(Times($s("b"),$s("n")),$s("p")),CN1)),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,$s("n")))),Power(Csch(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),$s("p"))),$s("x")))),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("p")),$s("x")),RationalQ($s("m"))),IntegerQ($s("n"))),GreaterEqual(Plus($s("m"),Times(CN1,$s("n"))),C0)),SameQ($s("q"),C1)))),
SetDelayed(Int(Power(Csch(Times($p("b",true),Log(Times($p("c",true),Power($p("x"),$p("n",true)))))),$p("p",true)),$p("x",$s("Symbol"))),
    Condition(Int(Power(Times(C2,Power(Plus(Power(Times($s("c"),Power($s("x"),$s("n"))),$s("b")),Times(CN1,Times(C1,Power(Power(Times($s("c"),Power($s("x"),$s("n"))),$s("b")),CN1)))),CN1)),$s("p")),$s("x")),And(FreeQ($s("c"),$s("x")),RationalQ(List($s("b"),$s("n"),$s("p")))))),
SetDelayed(Int(Power(Csch(Plus($p("a",true),Times($p("b",true),Log(Times($p("c",true),Power($p("x"),$p("n",true))))))),$p("p")),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(Times(CN1,$s("x")),Coth(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n")))))))),Times(Power(Csch(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),Times(CN1,C2))),Power(Times(Times($s("b"),$s("n")),Plus($s("p"),Times(CN1,C1))),CN1))),Times(CN1,Times($s("x"),Times(Power(Csch(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),Times(CN1,C2))),Power(Times(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Plus($s("p"),Times(CN1,C1))),Plus($s("p"),Times(CN1,C2))),CN1))))),Dist(Times(Plus(C1,Times(CN1,Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Power(Plus($s("p"),Times(CN1,C2)),C2)))),Power(Times(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Plus($s("p"),Times(CN1,C1))),Plus($s("p"),Times(CN1,C2))),CN1)),Int(Power(Csch(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),Times(CN1,C2))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("n")),$s("x")),RationalQ($s("p"))),Greater($s("p"),C1)),Unequal($s("p"),C2)))),
SetDelayed(Int(Power(Csch(Plus($p("a",true),Times($p("b",true),Log(Times($p("c",true),Power($p("x"),$p("n",true))))))),$p("p")),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times($s("x"),Times(Power(Csch(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),$s("p")),Power(Plus(C1,Times(CN1,Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Power($s("p"),C2)))),CN1))),Times(Times(Times(Times(Times($s("b"),$s("n")),$s("p")),$s("x")),Cosh(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n")))))))),Times(Power(Csch(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),C1)),Power(Plus(C1,Times(CN1,Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Power($s("p"),C2)))),CN1)))),Dist(Times(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),$s("p")),Times(Plus($s("p"),C1),Power(Plus(C1,Times(CN1,Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Power($s("p"),C2)))),CN1))),Int(Power(Csch(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),C2)),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("n")),$s("x")),RationalQ($s("p"))),Less($s("p"),CN1)),NonzeroQ(Plus(C1,Times(CN1,Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Power($s("p"),C2)))))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Csch(Times($p("b",true),Log(Times($p("c",true),Power($p("x"),$p("n",true)))))),$p("p",true))),$p("x",$s("Symbol"))),
    Condition(Int(Times(Power($s("x"),$s("m")),Power(Times(C2,Power(Plus(Power(Times($s("c"),Power($s("x"),$s("n"))),$s("b")),Times(CN1,Times(C1,Power(Power(Times($s("c"),Power($s("x"),$s("n"))),$s("b")),CN1)))),CN1)),$s("p"))),$s("x")),And(FreeQ($s("c"),$s("x")),RationalQ(List($s("b"),$s("m"),$s("n"),$s("p")))))),
SetDelayed(Int(Times(Power(Csch(Plus($p("a",true),Times($p("b",true),Log(Times($p("c",true),Power($p("x"),$p("n",true))))))),C2),Power($p("x"),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Times(CN1,Coth(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n")))))))),Power(Times($s("b"),$s("n")),CN1)),FreeQ(List($s("a"),$s("b"),$s("c"),$s("n")),$s("x")))),
SetDelayed(Int(Times(Power(Csch(Plus($p("a",true),Times($p("b",true),Log(Times($p("c",true),Power($p("x"),$p("n",true))))))),$p("p")),Power($p("x"),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Coth(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n")))))))),Times(Power(Csch(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),Times(CN1,C2))),Power(Times(Times($s("b"),$s("n")),Plus($s("p"),Times(CN1,C1))),CN1))),Times(CN1,Dist(Times(Plus($s("p"),Times(CN1,C2)),Power(Plus($s("p"),Times(CN1,C1)),CN1)),Int(Times(Power(Csch(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),Times(CN1,C2))),Power($s("x"),CN1)),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("n")),$s("x")),RationalQ($s("p"))),Greater($s("p"),C1)))),
SetDelayed(Int(Times(Power(Csch(Plus($p("a",true),Times($p("b",true),Log(Times($p("c",true),Power($p("x"),$p("n",true))))))),$p("p")),Power($p("x"),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Cosh(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n")))))))),Times(Power(Csch(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),C1)),Power(Times(Times($s("b"),$s("n")),$s("p")),CN1))),Times(CN1,Dist(Times(Plus($s("p"),C1),Power($s("p"),CN1)),Int(Times(Power(Csch(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),C2)),Power($s("x"),CN1)),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("n")),$s("x")),RationalQ($s("p"))),Less($s("p"),CN1)))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Csch(Plus($p("a",true),Times($p("b",true),Log(Times($p("c",true),Power($p("x"),$p("n",true))))))),$p("p"))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(Times(CN1,Power($s("x"),Plus($s("m"),C1))),Coth(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n")))))))),Times(Power(Csch(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),Times(CN1,C2))),Power(Times(Times($s("b"),$s("n")),Plus($s("p"),Times(CN1,C1))),CN1))),Times(CN1,Times(Times(Plus($s("m"),C1),Power($s("x"),Plus($s("m"),C1))),Times(Power(Csch(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),Times(CN1,C2))),Power(Times(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Plus($s("p"),Times(CN1,C1))),Plus($s("p"),Times(CN1,C2))),CN1))))),Times(CN1,Dist(Times(Plus(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Power(Plus($s("p"),Times(CN1,C2)),C2)),Times(CN1,Power(Plus($s("m"),C1),C2))),Power(Times(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Plus($s("p"),Times(CN1,C1))),Plus($s("p"),Times(CN1,C2))),CN1)),Int(Times(Power($s("x"),$s("m")),Power(Csch(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),Times(CN1,C2)))),$s("x"))))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("m"),$s("n")),$s("x")),RationalQ($s("p"))),Greater($s("p"),C1)),Unequal($s("p"),C2)))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Csch(Plus($p("a",true),Times($p("b",true),Log(Times($p("c",true),Power($p("x"),$p("n",true))))))),$p("p"))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(Times(CN1,Plus($s("m"),C1)),Power($s("x"),Plus($s("m"),C1))),Times(Power(Csch(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),$s("p")),Power(Plus(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Power($s("p"),C2)),Times(CN1,Power(Plus($s("m"),C1),C2))),CN1))),Times(CN1,Times(Times(Times(Times(Times($s("b"),$s("n")),$s("p")),Power($s("x"),Plus($s("m"),C1))),Cosh(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n")))))))),Times(Power(Csch(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),C1)),Power(Plus(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Power($s("p"),C2)),Times(CN1,Power(Plus($s("m"),C1),C2))),CN1))))),Times(CN1,Dist(Times(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),$s("p")),Times(Plus($s("p"),C1),Power(Plus(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Power($s("p"),C2)),Times(CN1,Power(Plus($s("m"),C1),C2))),CN1))),Int(Times(Power($s("x"),$s("m")),Power(Csch(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),C2))),$s("x"))))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("m"),$s("n")),$s("x")),RationalQ($s("p"))),Less($s("p"),CN1)),NonzeroQ(Plus(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Power($s("p"),C2)),Times(CN1,Power(Plus($s("m"),C1),C2))))))),
SetDelayed(Int(Power(Plus(Times($p("a",true),Cosh(Plus($p("c",true),Times($p("d",true),$p("x"))))),Times($p("b",true),Sinh(Plus($p("c",true),Times($p("d",true),$p("x")))))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Times($s("a"),Times(Power(Plus(Times($s("a"),Cosh(Plus($s("c"),Times($s("d"),$s("x"))))),Times($s("b"),Sinh(Plus($s("c"),Times($s("d"),$s("x")))))),$s("n")),Power(Times(Times($s("b"),$s("d")),$s("n")),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("n")),$s("x")),ZeroQ(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))))))),
SetDelayed(Int(Times(C1,Power(Power(Plus(Times($p("a",true),Cosh(Plus($p("c",true),Times($p("d",true),$p("x"))))),Times($p("b",true),Sinh(Plus($p("c",true),Times($p("d",true),$p("x")))))),C2),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Sinh(Plus($s("c"),Times($s("d"),$s("x")))),Power(Times(Times($s("a"),$s("d")),Plus(Times($s("a"),Cosh(Plus($s("c"),Times($s("d"),$s("x"))))),Times($s("b"),Sinh(Plus($s("c"),Times($s("d"),$s("x"))))))),CN1)),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),NonzeroQ(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))))))),
SetDelayed(Int(Sqrt(Plus(Times($p("a",true),Cosh(Plus($p("c",true),Times($p("d",true),$p("x"))))),Times($p("b",true),Sinh(Plus($p("c",true),Times($p("d",true),$p("x"))))))),$p("x",$s("Symbol"))),
    Condition(Times(Times(Times(C2,CI),EllipticE(Times(Plus(Times(Pi,C1D2),Times(CN1,Times(CI,Plus(Plus($s("c"),Times($s("d"),$s("x"))),Times(CI,ArcTan(Times(CI,$s("b")),$s("a"))))))),C1D2),C2)),Times(Sqrt(Plus(Times($s("a"),Cosh(Plus($s("c"),Times($s("d"),$s("x"))))),Times($s("b"),Sinh(Plus($s("c"),Times($s("d"),$s("x"))))))),Power(Times($s("d"),Sqrt(Times(Times(CN1,Plus(Times($s("a"),Cosh(Plus($s("c"),Times($s("d"),$s("x"))))),Times($s("b"),Sinh(Plus($s("c"),Times($s("d"),$s("x"))))))),Power(Sqrt(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2)))),CN1)))),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),NonzeroQ(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))))))),
SetDelayed(Int(Times(C1,Power(Sqrt(Plus(Times($p("a",true),Cosh(Plus($p("c",true),Times($p("d",true),$p("x"))))),Times($p("b",true),Sinh(Plus($p("c",true),Times($p("d",true),$p("x"))))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Times(Times(C2,CI),EllipticF(Times(Plus(Times(Pi,C1D2),Times(CN1,Times(CI,Plus(Plus($s("c"),Times($s("d"),$s("x"))),Times(CI,ArcTan(Times(CI,$s("b")),$s("a"))))))),C1D2),C2)),Times(Sqrt(Times(Times(CN1,Plus(Times($s("a"),Cosh(Plus($s("c"),Times($s("d"),$s("x"))))),Times($s("b"),Sinh(Plus($s("c"),Times($s("d"),$s("x"))))))),Power(Sqrt(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2)))),CN1))),Power(Times($s("d"),Sqrt(Plus(Times($s("a"),Cosh(Plus($s("c"),Times($s("d"),$s("x"))))),Times($s("b"),Sinh(Plus($s("c"),Times($s("d"),$s("x")))))))),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),NonzeroQ(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))))))),
SetDelayed(Int(Power(Plus(Times($p("a",true),Cosh(Plus($p("c",true),Times($p("d",true),$p("x"))))),Times($p("b",true),Sinh(Plus($p("c",true),Times($p("d",true),$p("x")))))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Dist(Times(C1,Power($s("d"),CN1)),Subst(Int(Regularize(Power(Plus(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))),Power($s("x"),C2)),Times(Plus($s("n"),Times(CN1,C1)),C1D2)),$s("x")),$s("x")),$s("x"),Plus(Times($s("b"),Cosh(Plus($s("c"),Times($s("d"),$s("x"))))),Times($s("a"),Sinh(Plus($s("c"),Times($s("d"),$s("x")))))))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),OddQ($s("n"))),GreaterEqual($s("n"),CN1)),NonzeroQ(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))))))),
SetDelayed(Int(Power(Plus(Times($p("a",true),Cosh(Plus($p("c",true),Times($p("d",true),$p("x"))))),Times($p("b",true),Sinh(Plus($p("c",true),Times($p("d",true),$p("x")))))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Plus(Times($s("b"),Cosh(Plus($s("c"),Times($s("d"),$s("x"))))),Times($s("a"),Sinh(Plus($s("c"),Times($s("d"),$s("x")))))),Times(Power(Plus(Times($s("a"),Cosh(Plus($s("c"),Times($s("d"),$s("x"))))),Times($s("b"),Sinh(Plus($s("c"),Times($s("d"),$s("x")))))),Plus($s("n"),Times(CN1,C1))),Power(Times($s("d"),$s("n")),CN1))),Dist(Times(Plus($s("n"),Times(CN1,C1)),Times(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))),Power($s("n"),CN1))),Int(Power(Plus(Times($s("a"),Cosh(Plus($s("c"),Times($s("d"),$s("x"))))),Times($s("b"),Sinh(Plus($s("c"),Times($s("d"),$s("x")))))),Plus($s("n"),Times(CN1,C2))),$s("x")))),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),RationalQ($s("n"))),Greater($s("n"),C1)),NonzeroQ(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))))),Not(OddQ($s("n")))))),
SetDelayed(Int(Power(Plus(Times($p("a",true),Cosh(Plus($p("c",true),Times($p("d",true),$p("x"))))),Times($p("b",true),Sinh(Plus($p("c",true),Times($p("d",true),$p("x")))))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Plus(Times($s("b"),Cosh(Plus($s("c"),Times($s("d"),$s("x"))))),Times($s("a"),Sinh(Plus($s("c"),Times($s("d"),$s("x"))))))),Times(Power(Plus(Times($s("a"),Cosh(Plus($s("c"),Times($s("d"),$s("x"))))),Times($s("b"),Sinh(Plus($s("c"),Times($s("d"),$s("x")))))),Plus($s("n"),C1)),Power(Times(Times($s("d"),Plus($s("n"),C1)),Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2)))),CN1))),Dist(Times(Plus($s("n"),C2),Power(Times(Plus($s("n"),C1),Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2)))),CN1)),Int(Power(Plus(Times($s("a"),Cosh(Plus($s("c"),Times($s("d"),$s("x"))))),Times($s("b"),Sinh(Plus($s("c"),Times($s("d"),$s("x")))))),Plus($s("n"),C2)),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),RationalQ($s("n"))),Less($s("n"),CN1)),NonzeroQ(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))))))),
SetDelayed(Int(Power(Plus(Times($p("a",true),Csch(Plus($p("c",true),Times($p("d",true),$p("x"))))),Times($p("b",true),Sinh(Plus($p("c",true),Times($p("d",true),$p("x")))))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Int(Power(Times(Times($s("a"),Cosh(Plus($s("c"),Times($s("d"),$s("x"))))),Coth(Plus($s("c"),Times($s("d"),$s("x"))))),$s("n")),$s("x")),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("n")),$s("x")),ZeroQ(Plus($s("a"),Times(CN1,$s("b"))))))),
SetDelayed(Int(Power(Plus(Times($p("a",true),Sech(Plus($p("c",true),Times($p("d",true),$p("x"))))),Times($p("b",true),Cosh(Plus($p("c",true),Times($p("d",true),$p("x")))))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Int(Power(Times(Times(Times(CN1,$s("a")),Sinh(Plus($s("c"),Times($s("d"),$s("x"))))),Tanh(Plus($s("c"),Times($s("d"),$s("x"))))),$s("n")),$s("x")),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("n")),$s("x")),ZeroQ(Plus($s("a"),$s("b")))))),
SetDelayed(Int(Times($p("u",true),Times(Power(Sinh(Plus($p("c",true),Times($p("d",true),$p("x")))),$p("n")),Power(Plus(Times($p("a",true),Cosh(Plus($p("c",true),Times($p("d",true),$p("x"))))),Times($p("b",true),Sinh(Plus($p("c",true),Times($p("d",true),$p("x")))))),CN1))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Dist(Times(Times(CN1,$s("b")),Power(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))),CN1)),Int(Times($s("u"),Power(Sinh(Plus($s("c"),Times($s("d"),$s("x")))),Plus($s("n"),Times(CN1,C1)))),$s("x"))),Dist(Times($s("a"),Power(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))),CN1)),Int(Times(Times($s("u"),Power(Sinh(Plus($s("c"),Times($s("d"),$s("x")))),Plus($s("n"),Times(CN1,C2)))),Cosh(Plus($s("c"),Times($s("d"),$s("x"))))),$s("x")))),Times(CN1,Dist(Times(Power($s("a"),C2),Power(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))),CN1)),Int(Times($s("u"),Times(Power(Sinh(Plus($s("c"),Times($s("d"),$s("x")))),Plus($s("n"),Times(CN1,C2))),Power(Plus(Times($s("a"),Cosh(Plus($s("c"),Times($s("d"),$s("x"))))),Times($s("b"),Sinh(Plus($s("c"),Times($s("d"),$s("x")))))),CN1))),$s("x"))))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),NonzeroQ(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))))),IntegerQ($s("n"))),Greater($s("n"),C1)))),
SetDelayed(Int(Times($p("u",true),Times(Power(Cosh(Plus($p("c",true),Times($p("d",true),$p("x")))),$p("n")),Power(Plus(Times($p("a",true),Cosh(Plus($p("c",true),Times($p("d",true),$p("x"))))),Times($p("b",true),Sinh(Plus($p("c",true),Times($p("d",true),$p("x")))))),CN1))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Dist(Times($s("a"),Power(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))),CN1)),Int(Times($s("u"),Power(Cosh(Plus($s("c"),Times($s("d"),$s("x")))),Plus($s("n"),Times(CN1,C1)))),$s("x"))),Times(CN1,Dist(Times($s("b"),Power(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))),CN1)),Int(Times(Times($s("u"),Power(Cosh(Plus($s("c"),Times($s("d"),$s("x")))),Plus($s("n"),Times(CN1,C2)))),Sinh(Plus($s("c"),Times($s("d"),$s("x"))))),$s("x"))))),Times(CN1,Dist(Times(Power($s("b"),C2),Power(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))),CN1)),Int(Times($s("u"),Times(Power(Cosh(Plus($s("c"),Times($s("d"),$s("x")))),Plus($s("n"),Times(CN1,C2))),Power(Plus(Times($s("a"),Cosh(Plus($s("c"),Times($s("d"),$s("x"))))),Times($s("b"),Sinh(Plus($s("c"),Times($s("d"),$s("x")))))),CN1))),$s("x"))))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),NonzeroQ(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))))),IntegerQ($s("n"))),Greater($s("n"),C1)))),
SetDelayed(Int(Times(C1,Power(Plus(Plus($p("a"),Times($p("b",true),Cosh(Plus($p("d",true),Times($p("e",true),$p("x")))))),Times($p("c",true),Sinh(Plus($p("d",true),Times($p("e",true),$p("x")))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(integer(-2L),Power(Times($s("e"),Plus($s("c"),Times(CN1,Times(Plus($s("a"),Times(CN1,$s("b"))),Tanh(Times(Plus($s("d"),Times($s("e"),$s("x"))),C1D2)))))),CN1)),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e")),$s("x")),ZeroQ(Plus(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))),Power($s("c"),C2)))))),
SetDelayed(Int(Sqrt(Plus(Plus($p("a"),Times($p("b",true),Cosh(Plus($p("d",true),Times($p("e",true),$p("x")))))),Times($p("c",true),Sinh(Plus($p("d",true),Times($p("e",true),$p("x"))))))),$p("x",$s("Symbol"))),
    Condition(Times(C2,Times(Plus(Times($s("c"),Cosh(Plus($s("d"),Times($s("e"),$s("x"))))),Times($s("b"),Sinh(Plus($s("d"),Times($s("e"),$s("x")))))),Power(Times($s("e"),Sqrt(Plus(Plus($s("a"),Times($s("b"),Cosh(Plus($s("d"),Times($s("e"),$s("x")))))),Times($s("c"),Sinh(Plus($s("d"),Times($s("e"),$s("x")))))))),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e")),$s("x")),ZeroQ(Plus(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))),Power($s("c"),C2)))))),
SetDelayed(Int(Power(Plus(Plus($p("a"),Times($p("b",true),Cosh(Plus($p("d",true),Times($p("e",true),$p("x")))))),Times($p("c",true),Sinh(Plus($p("d",true),Times($p("e",true),$p("x")))))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Plus(Times($s("c"),Cosh(Plus($s("d"),Times($s("e"),$s("x"))))),Times($s("b"),Sinh(Plus($s("d"),Times($s("e"),$s("x")))))),Times(Power(Plus(Plus($s("a"),Times($s("b"),Cosh(Plus($s("d"),Times($s("e"),$s("x")))))),Times($s("c"),Sinh(Plus($s("d"),Times($s("e"),$s("x")))))),Plus($s("n"),Times(CN1,C1))),Power(Times($s("e"),$s("n")),CN1))),Dist(Times($s("a"),Times(Plus(Times(C2,$s("n")),Times(CN1,C1)),Power($s("n"),CN1))),Int(Power(Plus(Plus($s("a"),Times($s("b"),Cosh(Plus($s("d"),Times($s("e"),$s("x")))))),Times($s("c"),Sinh(Plus($s("d"),Times($s("e"),$s("x")))))),Plus($s("n"),Times(CN1,C1))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e")),$s("x")),RationalQ($s("n"))),Greater($s("n"),C1)),ZeroQ(Plus(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))),Power($s("c"),C2)))))),
SetDelayed(Int(Power(Plus(Plus($p("a"),Times($p("b",true),Cosh(Plus($p("d",true),Times($p("e",true),$p("x")))))),Times($p("c",true),Sinh(Plus($p("d",true),Times($p("e",true),$p("x")))))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Plus(Times($s("c"),Cosh(Plus($s("d"),Times($s("e"),$s("x"))))),Times($s("b"),Sinh(Plus($s("d"),Times($s("e"),$s("x"))))))),Times(Power(Plus(Plus($s("a"),Times($s("b"),Cosh(Plus($s("d"),Times($s("e"),$s("x")))))),Times($s("c"),Sinh(Plus($s("d"),Times($s("e"),$s("x")))))),$s("n")),Power(Times(Times($s("a"),$s("e")),Plus(Times(C2,$s("n")),C1)),CN1))),Dist(Times(Plus($s("n"),C1),Power(Times($s("a"),Plus(Times(C2,$s("n")),C1)),CN1)),Int(Power(Plus(Plus($s("a"),Times($s("b"),Cosh(Plus($s("d"),Times($s("e"),$s("x")))))),Times($s("c"),Sinh(Plus($s("d"),Times($s("e"),$s("x")))))),Plus($s("n"),C1)),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e")),$s("x")),RationalQ($s("n"))),Less($s("n"),CN1)),ZeroQ(Plus(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))),Power($s("c"),C2)))))),
SetDelayed(Int(Times(C1,Power(Plus(Plus($p("a"),Times($p("b",true),Cosh(Plus($p("d",true),Times($p("e",true),$p("x")))))),Times($p("c",true),Sinh(Plus($p("d",true),Times($p("e",true),$p("x")))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Log(Plus($s("a"),Times($s("c"),Tanh(Times(Plus($s("d"),Times($s("e"),$s("x"))),C1D2))))),Power(Times($s("c"),$s("e")),CN1)),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e")),$s("x")),ZeroQ(Plus($s("a"),Times(CN1,$s("b"))))))),
SetDelayed(Int(Times(C1,Power(Plus(Plus($p("a"),Times($p("b",true),Cosh(Plus($p("d",true),Times($p("e",true),$p("x")))))),Times($p("c",true),Sinh(Plus($p("d",true),Times($p("e",true),$p("x")))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Times(CN1,Log(Plus($s("a"),Times(CN1,Times($s("c"),Coth(Times(Plus($s("d"),Times($s("e"),$s("x"))),C1D2))))))),Power(Times($s("c"),$s("e")),CN1)),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e")),$s("x")),ZeroQ(Plus($s("a"),$s("b")))))),
SetDelayed(Int(Times(C1,Power(Plus(Plus($p("a"),Times($p("b",true),Cosh(Plus($p("d",true),Times($p("e",true),$p("x")))))),Times($p("c",true),Sinh(Plus($p("d",true),Times($p("e",true),$p("x")))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(C2,Times(ArcTan(Times(Plus($s("c"),Times(CN1,Times(Plus($s("a"),Times(CN1,$s("b"))),Tanh(Times(Plus($s("d"),Times($s("e"),$s("x"))),C1D2))))),Power(Rt(Plus(Plus(Times(CN1,Power($s("a"),C2)),Power($s("b"),C2)),Times(CN1,Power($s("c"),C2))),C2),CN1))),Power(Times($s("e"),Rt(Plus(Plus(Times(CN1,Power($s("a"),C2)),Power($s("b"),C2)),Times(CN1,Power($s("c"),C2))),C2)),CN1))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e")),$s("x")),NonzeroQ(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))))),NegQ(Plus(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))),Power($s("c"),C2)))))),
SetDelayed(Int(Times(C1,Power(Plus(Plus($p("a"),Times($p("b",true),Cosh(Plus($p("d",true),Times($p("e",true),$p("x")))))),Times($p("c",true),Sinh(Plus($p("d",true),Times($p("e",true),$p("x")))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(integer(-2L),Times(ArcTanh(Times(Plus($s("c"),Times(CN1,Times(Plus($s("a"),Times(CN1,$s("b"))),Tanh(Times(Plus($s("d"),Times($s("e"),$s("x"))),C1D2))))),Power(Rt(Plus(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))),Power($s("c"),C2)),C2),CN1))),Power(Times($s("e"),Rt(Plus(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))),Power($s("c"),C2)),C2)),CN1))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e")),$s("x")),NonzeroQ(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))))),PosQ(Plus(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))),Power($s("c"),C2)))))),
SetDelayed(Int(Sqrt(Plus(Plus($p("a",true),Times($p("b",true),Cosh(Plus($p("d",true),Times($p("e",true),$p("x")))))),Times($p("c",true),Sinh(Plus($p("d",true),Times($p("e",true),$p("x"))))))),$p("x",$s("Symbol"))),
    Condition(Times(Times(Times(C2,CI),EllipticE(Times(Plus(Times(Pi,C1D2),Times(CN1,Times(CI,Plus(Plus($s("d"),Times($s("e"),$s("x"))),Times(CI,ArcTan(Times(CI,$s("c")),$s("b"))))))),C1D2),Times(C2,Power(Plus(C1,Times(CN1,Times($s("a"),Power(Sqrt(Plus(Power($s("b"),C2),Times(CN1,Power($s("c"),C2)))),CN1)))),CN1)))),Times(Sqrt(Plus(Plus($s("a"),Times($s("b"),Cosh(Plus($s("d"),Times($s("e"),$s("x")))))),Times($s("c"),Sinh(Plus($s("d"),Times($s("e"),$s("x"))))))),Power(Times($s("e"),Sqrt(Times(Plus(Plus($s("a"),Times($s("b"),Cosh(Plus($s("d"),Times($s("e"),$s("x")))))),Times($s("c"),Sinh(Plus($s("d"),Times($s("e"),$s("x")))))),Power(Plus($s("a"),Times(CN1,Sqrt(Plus(Power($s("b"),C2),Times(CN1,Power($s("c"),C2)))))),CN1)))),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),NonzeroQ(Plus(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))),Power($s("c"),C2)))))),
SetDelayed(Int(Times(C1,Power(Sqrt(Plus(Plus($p("a",true),Times($p("b",true),Cosh(Plus($p("d",true),Times($p("e",true),$p("x")))))),Times($p("c",true),Sinh(Plus($p("d",true),Times($p("e",true),$p("x"))))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Times(Times(C2,CI),EllipticF(Times(Plus(Times(Pi,C1D2),Times(CN1,Times(CI,Plus(Plus($s("d"),Times($s("e"),$s("x"))),Times(CI,ArcTan(Times(CI,$s("c")),$s("b"))))))),C1D2),Times(C2,Power(Plus(C1,Times(CN1,Times($s("a"),Power(Sqrt(Plus(Power($s("b"),C2),Times(CN1,Power($s("c"),C2)))),CN1)))),CN1)))),Times(Sqrt(Times(Plus(Plus($s("a"),Times($s("b"),Cosh(Plus($s("d"),Times($s("e"),$s("x")))))),Times($s("c"),Sinh(Plus($s("d"),Times($s("e"),$s("x")))))),Power(Plus($s("a"),Times(CN1,Sqrt(Plus(Power($s("b"),C2),Times(CN1,Power($s("c"),C2)))))),CN1))),Power(Times($s("e"),Sqrt(Plus(Plus($s("a"),Times($s("b"),Cosh(Plus($s("d"),Times($s("e"),$s("x")))))),Times($s("c"),Sinh(Plus($s("d"),Times($s("e"),$s("x")))))))),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e")),$s("x")),NonzeroQ(Plus(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))),Power($s("c"),C2)))))),
SetDelayed(Int(Power(Plus(Plus($p("a"),Times($p("b",true),Cosh(Plus($p("d",true),Times($p("e",true),$p("x")))))),Times($p("c",true),Sinh(Plus($p("d",true),Times($p("e",true),$p("x")))))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Plus(Times($s("c"),Cosh(Plus($s("d"),Times($s("e"),$s("x"))))),Times($s("b"),Sinh(Plus($s("d"),Times($s("e"),$s("x")))))),Times(Power(Plus(Plus($s("a"),Times($s("b"),Cosh(Plus($s("d"),Times($s("e"),$s("x")))))),Times($s("c"),Sinh(Plus($s("d"),Times($s("e"),$s("x")))))),Plus($s("n"),C1)),Power(Times(Times($s("e"),Plus($s("n"),C1)),Plus(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))),Power($s("c"),C2))),CN1))),Times(Times(C1,Power(Times(Plus($s("n"),C1),Plus(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))),Power($s("c"),C2))),CN1)),Int(Times(Plus(Plus(Times(Plus($s("n"),C1),$s("a")),Times(CN1,Times(Times(Plus($s("n"),C2),$s("b")),Cosh(Plus($s("d"),Times($s("e"),$s("x"))))))),Times(CN1,Times(Times(Plus($s("n"),C2),$s("c")),Sinh(Plus($s("d"),Times($s("e"),$s("x"))))))),Power(Plus(Plus($s("a"),Times($s("b"),Cosh(Plus($s("d"),Times($s("e"),$s("x")))))),Times($s("c"),Sinh(Plus($s("d"),Times($s("e"),$s("x")))))),Plus($s("n"),C1))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e")),$s("x")),RationalQ($s("n"))),Less($s("n"),CN1)),NonzeroQ(Plus(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))),Power($s("c"),C2)))))),
SetDelayed(Int(Times(Plus($p("A",true),Times($p("C",true),Sinh(Plus($p("d",true),Times($p("e",true),$p("x")))))),Power(Plus(Plus($p("a",true),Times($p("b",true),Cosh(Plus($p("d",true),Times($p("e",true),$p("x")))))),Times($p("c",true),Sinh(Plus($p("d",true),Times($p("e",true),$p("x")))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times($s("b"),$s("C")),Times(Log(Plus(Plus($s("a"),Times($s("b"),Cosh(Plus($s("d"),Times($s("e"),$s("x")))))),Times($s("c"),Sinh(Plus($s("d"),Times($s("e"),$s("x"))))))),Power(Times($s("e"),Plus(Power($s("b"),C2),Times(CN1,Power($s("c"),C2)))),CN1))),Times(CN1,Times(Times($s("c"),$s("C")),Times(Plus($s("d"),Times($s("e"),$s("x"))),Power(Times($s("e"),Plus(Power($s("b"),C2),Times(CN1,Power($s("c"),C2)))),CN1))))),Dist(Plus($s("A"),Times(Times($s("a"),$s("c")),Times($s("C"),Power(Plus(Power($s("b"),C2),Times(CN1,Power($s("c"),C2))),CN1)))),Int(Times(C1,Power(Plus(Plus($s("a"),Times($s("b"),Cosh(Plus($s("d"),Times($s("e"),$s("x")))))),Times($s("c"),Sinh(Plus($s("d"),Times($s("e"),$s("x")))))),CN1)),$s("x")))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e"),$s("A"),$s("C")),$s("x")),NonzeroQ(Plus(Power($s("b"),C2),Times(CN1,Power($s("c"),C2))))),NonzeroQ(Plus($s("A"),Times(Times($s("a"),$s("c")),Times($s("C"),Power(Plus(Power($s("b"),C2),Times(CN1,Power($s("c"),C2))),CN1)))))))),
SetDelayed(Int(Times(Plus($p("A",true),Times($p("B",true),Cosh(Plus($p("d",true),Times($p("e",true),$p("x")))))),Power(Plus(Plus($p("a",true),Times($p("b",true),Cosh(Plus($p("d",true),Times($p("e",true),$p("x")))))),Times($p("c",true),Sinh(Plus($p("d",true),Times($p("e",true),$p("x")))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(Times(CN1,$s("c")),$s("B")),Times(Log(Plus(Plus($s("a"),Times($s("b"),Cosh(Plus($s("d"),Times($s("e"),$s("x")))))),Times($s("c"),Sinh(Plus($s("d"),Times($s("e"),$s("x"))))))),Power(Times($s("e"),Plus(Power($s("b"),C2),Times(CN1,Power($s("c"),C2)))),CN1))),Times(Times($s("b"),$s("B")),Times(Plus($s("d"),Times($s("e"),$s("x"))),Power(Times($s("e"),Plus(Power($s("b"),C2),Times(CN1,Power($s("c"),C2)))),CN1)))),Dist(Plus($s("A"),Times(CN1,Times(Times($s("a"),$s("b")),Times($s("B"),Power(Plus(Power($s("b"),C2),Times(CN1,Power($s("c"),C2))),CN1))))),Int(Times(C1,Power(Plus(Plus($s("a"),Times($s("b"),Cosh(Plus($s("d"),Times($s("e"),$s("x")))))),Times($s("c"),Sinh(Plus($s("d"),Times($s("e"),$s("x")))))),CN1)),$s("x")))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e"),$s("A"),$s("B")),$s("x")),NonzeroQ(Plus(Power($s("b"),C2),Times(CN1,Power($s("c"),C2))))),NonzeroQ(Plus($s("A"),Times(CN1,Times(Times($s("a"),$s("b")),Times($s("B"),Power(Plus(Power($s("b"),C2),Times(CN1,Power($s("c"),C2))),CN1))))))))),
SetDelayed(Int(Times(Plus(Plus($p("A",true),Times($p("B",true),Cosh(Plus($p("d",true),Times($p("e",true),$p("x")))))),Times($p("C",true),Sinh(Plus($p("d",true),Times($p("e",true),$p("x")))))),Power(Plus(Plus($p("a",true),Times($p("b",true),Cosh(Plus($p("d",true),Times($p("e",true),$p("x")))))),Times($p("c",true),Sinh(Plus($p("d",true),Times($p("e",true),$p("x")))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(CN1,Plus(Times($s("c"),$s("B")),Times(CN1,Times($s("b"),$s("C"))))),Times(Log(Plus(Plus($s("a"),Times($s("b"),Cosh(Plus($s("d"),Times($s("e"),$s("x")))))),Times($s("c"),Sinh(Plus($s("d"),Times($s("e"),$s("x"))))))),Power(Times($s("e"),Plus(Power($s("b"),C2),Times(CN1,Power($s("c"),C2)))),CN1))),Times(Plus(Times($s("b"),$s("B")),Times(CN1,Times($s("c"),$s("C")))),Times(Plus($s("d"),Times($s("e"),$s("x"))),Power(Times($s("e"),Plus(Power($s("b"),C2),Times(CN1,Power($s("c"),C2)))),CN1)))),Dist(Plus($s("A"),Times(CN1,Times($s("a"),Times(Plus(Times($s("b"),$s("B")),Times(CN1,Times($s("c"),$s("C")))),Power(Plus(Power($s("b"),C2),Times(CN1,Power($s("c"),C2))),CN1))))),Int(Times(C1,Power(Plus(Plus($s("a"),Times($s("b"),Cosh(Plus($s("d"),Times($s("e"),$s("x")))))),Times($s("c"),Sinh(Plus($s("d"),Times($s("e"),$s("x")))))),CN1)),$s("x")))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e"),$s("A"),$s("B"),$s("C")),$s("x")),NonzeroQ(Plus(Power($s("b"),C2),Times(CN1,Power($s("c"),C2))))),NonzeroQ(Plus($s("A"),Times(CN1,Times($s("a"),Times(Plus(Times($s("b"),$s("B")),Times(CN1,Times($s("c"),$s("C")))),Power(Plus(Power($s("b"),C2),Times(CN1,Power($s("c"),C2))),CN1))))))))),
SetDelayed(Int(Times(Plus($p("A",true),Times($p("C",true),Sinh(Plus($p("d",true),Times($p("e",true),$p("x")))))),Power(Plus(Plus($p("a",true),Times($p("b",true),Cosh(Plus($p("d",true),Times($p("e",true),$p("x")))))),Times($p("c",true),Sinh(Plus($p("d",true),Times($p("e",true),$p("x")))))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Plus(Plus(Times(Times(CN1,$s("b")),$s("C")),Times(Plus(Times($s("c"),$s("A")),Times(CN1,Times($s("a"),$s("C")))),Cosh(Plus($s("d"),Times($s("e"),$s("x")))))),Times(Times($s("b"),$s("A")),Sinh(Plus($s("d"),Times($s("e"),$s("x")))))),Times(Power(Plus(Plus($s("a"),Times($s("b"),Cosh(Plus($s("d"),Times($s("e"),$s("x")))))),Times($s("c"),Sinh(Plus($s("d"),Times($s("e"),$s("x")))))),Plus($s("n"),C1)),Power(Times(Times($s("e"),Plus($s("n"),C1)),Plus(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))),Power($s("c"),C2))),CN1))),Dist(Times(C1,Power(Times(Plus($s("n"),C1),Plus(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))),Power($s("c"),C2))),CN1)),Int(Times(Plus(Plus(Times(Plus($s("n"),C1),Plus(Times($s("a"),$s("A")),Times($s("c"),$s("C")))),Times(CN1,Times(Times(Times(Plus($s("n"),C2),$s("b")),$s("A")),Cosh(Plus($s("d"),Times($s("e"),$s("x"))))))),Times(CN1,Times(Times(Plus($s("n"),C2),Plus(Times($s("c"),$s("A")),Times(CN1,Times($s("a"),$s("C"))))),Sinh(Plus($s("d"),Times($s("e"),$s("x"))))))),Power(Plus(Plus($s("a"),Times($s("b"),Cosh(Plus($s("d"),Times($s("e"),$s("x")))))),Times($s("c"),Sinh(Plus($s("d"),Times($s("e"),$s("x")))))),Plus($s("n"),C1))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e"),$s("A"),$s("C")),$s("x")),RationalQ($s("n"))),Less($s("n"),CN1)),NonzeroQ(Plus(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))),Power($s("c"),C2)))))),
SetDelayed(Int(Times(Plus($p("A",true),Times($p("B",true),Cosh(Plus($p("d",true),Times($p("e",true),$p("x")))))),Power(Plus(Plus($p("a",true),Times($p("b",true),Cosh(Plus($p("d",true),Times($p("e",true),$p("x")))))),Times($p("c",true),Sinh(Plus($p("d",true),Times($p("e",true),$p("x")))))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Plus(Plus(Times($s("c"),$s("B")),Times(Times($s("c"),$s("A")),Cosh(Plus($s("d"),Times($s("e"),$s("x")))))),Times(Plus(Times($s("b"),$s("A")),Times(CN1,Times($s("a"),$s("B")))),Sinh(Plus($s("d"),Times($s("e"),$s("x")))))),Times(Power(Plus(Plus($s("a"),Times($s("b"),Cosh(Plus($s("d"),Times($s("e"),$s("x")))))),Times($s("c"),Sinh(Plus($s("d"),Times($s("e"),$s("x")))))),Plus($s("n"),C1)),Power(Times(Times($s("e"),Plus($s("n"),C1)),Plus(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))),Power($s("c"),C2))),CN1))),Dist(Times(C1,Power(Times(Plus($s("n"),C1),Plus(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))),Power($s("c"),C2))),CN1)),Int(Times(Plus(Plus(Times(Plus($s("n"),C1),Plus(Times($s("a"),$s("A")),Times(CN1,Times($s("b"),$s("B"))))),Times(CN1,Times(Times(Plus($s("n"),C2),Plus(Times($s("b"),$s("A")),Times(CN1,Times($s("a"),$s("B"))))),Cosh(Plus($s("d"),Times($s("e"),$s("x"))))))),Times(CN1,Times(Times(Times(Plus($s("n"),C2),$s("c")),$s("A")),Sinh(Plus($s("d"),Times($s("e"),$s("x"))))))),Power(Plus(Plus($s("a"),Times($s("b"),Cosh(Plus($s("d"),Times($s("e"),$s("x")))))),Times($s("c"),Sinh(Plus($s("d"),Times($s("e"),$s("x")))))),Plus($s("n"),C1))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e"),$s("A"),$s("B")),$s("x")),RationalQ($s("n"))),Less($s("n"),CN1)),NonzeroQ(Plus(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))),Power($s("c"),C2)))))),
SetDelayed(Int(Times(Plus(Plus($p("A",true),Times($p("B",true),Cosh(Plus($p("d",true),Times($p("e",true),$p("x")))))),Times($p("C",true),Sinh(Plus($p("d",true),Times($p("e",true),$p("x")))))),Power(Plus(Plus($p("a",true),Times($p("b",true),Cosh(Plus($p("d",true),Times($p("e",true),$p("x")))))),Times($p("c",true),Sinh(Plus($p("d",true),Times($p("e",true),$p("x")))))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Plus(Plus(Plus(Times($s("c"),$s("B")),Times(CN1,Times($s("b"),$s("C")))),Times(Plus(Times($s("c"),$s("A")),Times(CN1,Times($s("a"),$s("C")))),Cosh(Plus($s("d"),Times($s("e"),$s("x")))))),Times(Plus(Times($s("b"),$s("A")),Times(CN1,Times($s("a"),$s("B")))),Sinh(Plus($s("d"),Times($s("e"),$s("x")))))),Times(Power(Plus(Plus($s("a"),Times($s("b"),Cosh(Plus($s("d"),Times($s("e"),$s("x")))))),Times($s("c"),Sinh(Plus($s("d"),Times($s("e"),$s("x")))))),Plus($s("n"),C1)),Power(Times(Times($s("e"),Plus($s("n"),C1)),Plus(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))),Power($s("c"),C2))),CN1))),Dist(Times(C1,Power(Times(Plus($s("n"),C1),Plus(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))),Power($s("c"),C2))),CN1)),Int(Times(Plus(Plus(Times(Plus($s("n"),C1),Plus(Plus(Times($s("a"),$s("A")),Times(CN1,Times($s("b"),$s("B")))),Times($s("c"),$s("C")))),Times(CN1,Times(Times(Plus($s("n"),C2),Plus(Times($s("b"),$s("A")),Times(CN1,Times($s("a"),$s("B"))))),Cosh(Plus($s("d"),Times($s("e"),$s("x"))))))),Times(CN1,Times(Times(Plus($s("n"),C2),Plus(Times($s("c"),$s("A")),Times(CN1,Times($s("a"),$s("C"))))),Sinh(Plus($s("d"),Times($s("e"),$s("x"))))))),Power(Plus(Plus($s("a"),Times($s("b"),Cosh(Plus($s("d"),Times($s("e"),$s("x")))))),Times($s("c"),Sinh(Plus($s("d"),Times($s("e"),$s("x")))))),Plus($s("n"),C1))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e"),$s("A"),$s("B"),$s("C")),$s("x")),RationalQ($s("n"))),Less($s("n"),CN1)),NonzeroQ(Plus(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))),Power($s("c"),C2)))))),
SetDelayed(Int(Times(Power(Sech($p("v")),$p("m",true)),Power(Plus($p("a"),Times($p("b",true),Tanh($p("v")))),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Int(Power(Plus(Times($s("a"),Cosh($s("v"))),Times($s("b"),Sinh($s("v")))),$s("n")),$s("x")),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ(List($s("m"),$s("n")))),Equal(Plus($s("m"),$s("n")),C0)))),
SetDelayed(Int(Times(Power(Csch($p("v")),$p("m",true)),Power(Plus($p("a"),Times($p("b",true),Coth($p("v")))),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Int(Power(Plus(Times($s("b"),Cosh($s("v"))),Times($s("a"),Sinh($s("v")))),$s("n")),$s("x")),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ(List($s("m"),$s("n")))),Equal(Plus($s("m"),$s("n")),C0)))),
SetDelayed(Int(Times(Power(E,Plus($p("a",true),Times($p("b",true),$p("x")))),Sinh(Plus($p("c",true),Times($p("d",true),$p("x"))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(Times(CN1,$s("d")),Power(E,Plus($s("a"),Times($s("b"),$s("x"))))),Times(Cosh(Plus($s("c"),Times($s("d"),$s("x")))),Power(Plus(Power($s("b"),C2),Times(CN1,Power($s("d"),C2))),CN1))),Times(Times($s("b"),Power(E,Plus($s("a"),Times($s("b"),$s("x"))))),Times(Sinh(Plus($s("c"),Times($s("d"),$s("x")))),Power(Plus(Power($s("b"),C2),Times(CN1,Power($s("d"),C2))),CN1)))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),NonzeroQ(Plus(Power($s("b"),C2),Times(CN1,Power($s("d"),C2))))))),
SetDelayed(Int(Times(Power(E,Plus($p("a",true),Times($p("b",true),$p("x")))),Power(Sinh(Plus($p("c",true),Times($p("d",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(Times(Times(Times(CN1,$s("d")),$s("n")),Power(E,Plus($s("a"),Times($s("b"),$s("x"))))),Cosh(Plus($s("c"),Times($s("d"),$s("x"))))),Times(Power(Sinh(Plus($s("c"),Times($s("d"),$s("x")))),Plus($s("n"),Times(CN1,C1))),Power(Plus(Power($s("b"),C2),Times(CN1,Times(Power($s("d"),C2),Power($s("n"),C2)))),CN1))),Times(Times($s("b"),Power(E,Plus($s("a"),Times($s("b"),$s("x"))))),Times(Power(Sinh(Plus($s("c"),Times($s("d"),$s("x")))),$s("n")),Power(Plus(Power($s("b"),C2),Times(CN1,Times(Power($s("d"),C2),Power($s("n"),C2)))),CN1)))),Dist(Times(Times($s("n"),Plus($s("n"),Times(CN1,C1))),Times(Power($s("d"),C2),Power(Plus(Power($s("b"),C2),Times(CN1,Times(Power($s("d"),C2),Power($s("n"),C2)))),CN1))),Int(Times(Power(E,Plus($s("a"),Times($s("b"),$s("x")))),Power(Sinh(Plus($s("c"),Times($s("d"),$s("x")))),Plus($s("n"),Times(CN1,C2)))),$s("x")))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),FractionQ($s("n"))),Greater($s("n"),C1)))),
SetDelayed(Int(Times(Power(E,Plus($p("a",true),Times($p("b",true),$p("x")))),Cosh(Plus($p("c",true),Times($p("d",true),$p("x"))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times($s("b"),Power(E,Plus($s("a"),Times($s("b"),$s("x"))))),Times(Cosh(Plus($s("c"),Times($s("d"),$s("x")))),Power(Plus(Power($s("b"),C2),Times(CN1,Power($s("d"),C2))),CN1))),Times(CN1,Times(Times($s("d"),Power(E,Plus($s("a"),Times($s("b"),$s("x"))))),Times(Sinh(Plus($s("c"),Times($s("d"),$s("x")))),Power(Plus(Power($s("b"),C2),Times(CN1,Power($s("d"),C2))),CN1))))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),NonzeroQ(Plus(Power($s("b"),C2),Times(CN1,Power($s("d"),C2))))))),
SetDelayed(Int(Times(Power(E,Plus($p("a",true),Times($p("b",true),$p("x")))),Power(Cosh(Plus($p("c",true),Times($p("d",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times($s("b"),Power(E,Plus($s("a"),Times($s("b"),$s("x"))))),Times(Power(Cosh(Plus($s("c"),Times($s("d"),$s("x")))),$s("n")),Power(Plus(Power($s("b"),C2),Times(CN1,Times(Power($s("d"),C2),Power($s("n"),C2)))),CN1))),Times(CN1,Times(Times(Times(Times($s("d"),$s("n")),Power(E,Plus($s("a"),Times($s("b"),$s("x"))))),Power(Cosh(Plus($s("c"),Times($s("d"),$s("x")))),Plus($s("n"),Times(CN1,C1)))),Times(Sinh(Plus($s("c"),Times($s("d"),$s("x")))),Power(Plus(Power($s("b"),C2),Times(CN1,Times(Power($s("d"),C2),Power($s("n"),C2)))),CN1))))),Times(CN1,Dist(Times(Times($s("n"),Plus($s("n"),Times(CN1,C1))),Times(Power($s("d"),C2),Power(Plus(Power($s("b"),C2),Times(CN1,Times(Power($s("d"),C2),Power($s("n"),C2)))),CN1))),Int(Times(Power(E,Plus($s("a"),Times($s("b"),$s("x")))),Power(Cosh(Plus($s("c"),Times($s("d"),$s("x")))),Plus($s("n"),Times(CN1,C2)))),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),FractionQ($s("n"))),Greater($s("n"),C1)))),
SetDelayed(Int(Times(Power(E,Plus($p("a",true),Times($p("b",true),$p("x")))),Power(Sech(Plus($p("c",true),Times($p("d",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times($s("b"),Power(E,Plus($s("a"),Times($s("b"),$s("x"))))),Times(Power(Sech(Plus($s("c"),Times($s("d"),$s("x")))),Plus($s("n"),Times(CN1,C2))),Power(Times(Times(Power($s("d"),C2),Plus($s("n"),Times(CN1,C2))),Plus($s("n"),Times(CN1,C1))),CN1))),Times(Times(Power(E,Plus($s("a"),Times($s("b"),$s("x")))),Power(Sech(Plus($s("c"),Times($s("d"),$s("x")))),Plus($s("n"),Times(CN1,C1)))),Times(Sinh(Plus($s("c"),Times($s("d"),$s("x")))),Power(Times($s("d"),Plus($s("n"),Times(CN1,C1))),CN1)))),Times(CN1,Dist(Times(Plus(Power($s("b"),C2),Times(CN1,Times(Power($s("d"),C2),Power(Plus($s("n"),Times(CN1,C2)),C2)))),Power(Times(Times(Power($s("d"),C2),Plus($s("n"),Times(CN1,C1))),Plus($s("n"),Times(CN1,C2))),CN1)),Int(Times(Power(E,Plus($s("a"),Times($s("b"),$s("x")))),Power(Sech(Plus($s("c"),Times($s("d"),$s("x")))),Plus($s("n"),Times(CN1,C2)))),$s("x"))))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),FractionQ($s("n"))),Greater($s("n"),C1)),Unequal($s("n"),C2)))),
SetDelayed(Int(Times(Power(E,Plus($p("a",true),Times($p("b",true),$p("x")))),Power(Csch(Plus($p("c",true),Times($p("d",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(Times(CN1,$s("b")),Power(E,Plus($s("a"),Times($s("b"),$s("x"))))),Times(Power(Csch(Plus($s("c"),Times($s("d"),$s("x")))),Plus($s("n"),Times(CN1,C2))),Power(Times(Times(Power($s("d"),C2),Plus($s("n"),Times(CN1,C1))),Plus($s("n"),Times(CN1,C2))),CN1))),Times(CN1,Times(Times(Power(E,Plus($s("a"),Times($s("b"),$s("x")))),Cosh(Plus($s("c"),Times($s("d"),$s("x"))))),Times(Power(Csch(Plus($s("c"),Times($s("d"),$s("x")))),Plus($s("n"),Times(CN1,C1))),Power(Times($s("d"),Plus($s("n"),Times(CN1,C1))),CN1))))),Dist(Times(Plus(Power($s("b"),C2),Times(CN1,Times(Power($s("d"),C2),Power(Plus($s("n"),Times(CN1,C2)),C2)))),Power(Times(Times(Power($s("d"),C2),Plus($s("n"),Times(CN1,C1))),Plus($s("n"),Times(CN1,C2))),CN1)),Int(Times(Power(E,Plus($s("a"),Times($s("b"),$s("x")))),Power(Csch(Plus($s("c"),Times($s("d"),$s("x")))),Plus($s("n"),Times(CN1,C2)))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),FractionQ($s("n"))),Greater($s("n"),C1)),Unequal($s("n"),C2)))),
SetDelayed(Int(Times(Times(Power($p("x"),$p("m",true)),Power(E,Plus($p("a",true),Times($p("b",true),$p("x"))))),Power(Sinh(Plus($p("c",true),Times($p("d",true),$p("x")))),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Module(List(Set($s("u"),Block(List(Set($s("ShowSteps"),False),Set($s("StepCounter"),$s("Null"))),Int(Times(Power(E,Plus($s("a"),Times($s("b"),$s("x")))),Power(Sinh(Plus($s("c"),Times($s("d"),$s("x")))),$s("n"))),$s("x"))))),Plus(Times(Power($s("x"),$s("m")),$s("u")),Times(CN1,Dist($s("m"),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,C1))),$s("u")),$s("x")))))),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),RationalQ($s("m"))),IntegerQ($s("n"))),Greater($s("m"),C0)),Greater($s("n"),C0)))),
SetDelayed(Int(Times(Times(Power($p("x"),$p("m",true)),Power(E,Plus($p("a",true),Times($p("b",true),$p("x"))))),Power(Cosh(Plus($p("c",true),Times($p("d",true),$p("x")))),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Module(List(Set($s("u"),Block(List(Set($s("ShowSteps"),False),Set($s("StepCounter"),$s("Null"))),Int(Times(Power(E,Plus($s("a"),Times($s("b"),$s("x")))),Power(Cosh(Plus($s("c"),Times($s("d"),$s("x")))),$s("n"))),$s("x"))))),Plus(Times(Power($s("x"),$s("m")),$s("u")),Times(CN1,Dist($s("m"),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,C1))),$s("u")),$s("x")))))),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),RationalQ($s("m"))),IntegerQ($s("n"))),Greater($s("m"),C0)),Greater($s("n"),C0)))),
SetDelayed(Int(Times(Power($p("f"),$p("v")),Sinh($p("w"))),$p("x",$s("Symbol"))),
    Condition(Plus(Dist(C1D2,Int(Times(Power($s("f"),$s("v")),Power(E,$s("w"))),$s("x"))),Times(CN1,Dist(C1D2,Int(Times(Power($s("f"),$s("v")),Power(Power(E,$s("w")),CN1)),$s("x"))))),And(And(And(And(FreeQ($s("f"),$s("x")),PolynomialQ($s("v"),$s("x"))),LessEqual(Exponent($s("v"),$s("x")),C2)),PolynomialQ($s("w"),$s("x"))),LessEqual(Exponent($s("w"),$s("x")),C2)))),
SetDelayed(Int(Times(Power($p("f"),$p("v")),Power(Sinh($p("w")),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Dist(Times(C1,Power(Power(C2,$s("n")),CN1)),Int(Times(Power($s("f"),$s("v")),Power(Plus(Power(E,$s("w")),Times(CN1,Times(C1,Power(Power(E,$s("w")),CN1)))),$s("n"))),$s("x"))),And(And(And(And(And(And(FreeQ($s("f"),$s("x")),IntegerQ($s("n"))),Greater($s("n"),C0)),PolynomialQ($s("v"),$s("x"))),LessEqual(Exponent($s("v"),$s("x")),C2)),PolynomialQ($s("w"),$s("x"))),LessEqual(Exponent($s("w"),$s("x")),C2)))),
SetDelayed(Int(Times(Power($p("f"),$p("v")),Cosh($p("w"))),$p("x",$s("Symbol"))),
    Condition(Plus(Dist(C1D2,Int(Times(Power($s("f"),$s("v")),Power(E,$s("w"))),$s("x"))),Dist(C1D2,Int(Times(Power($s("f"),$s("v")),Power(Power(E,$s("w")),CN1)),$s("x")))),And(And(And(And(FreeQ($s("f"),$s("x")),PolynomialQ($s("v"),$s("x"))),LessEqual(Exponent($s("v"),$s("x")),C2)),PolynomialQ($s("w"),$s("x"))),LessEqual(Exponent($s("w"),$s("x")),C2)))),
SetDelayed(Int(Times(Power($p("f"),$p("v")),Power(Cosh($p("w")),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Dist(Times(C1,Power(Power(C2,$s("n")),CN1)),Int(Times(Power($s("f"),$s("v")),Power(Plus(Power(E,$s("w")),Times(C1,Power(Power(E,$s("w")),CN1))),$s("n"))),$s("x"))),And(And(And(And(And(And(FreeQ($s("f"),$s("x")),IntegerQ($s("n"))),Greater($s("n"),C0)),PolynomialQ($s("v"),$s("x"))),LessEqual(Exponent($s("v"),$s("x")),C2)),PolynomialQ($s("w"),$s("x"))),LessEqual(Exponent($s("w"),$s("x")),C2)))),
SetDelayed(Int(Times($p("u",true),Power(Plus($p("a"),Times($p("b",true),Power(Sinh($p("v")),C2))),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Dist(Power($s("a"),$s("n")),Int(Times($s("u"),Power(Cosh($s("v")),Times(C2,$s("n")))),$s("x"))),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ($s("n"))),ZeroQ(Plus($s("a"),Times(CN1,$s("b"))))))),
SetDelayed(Int(Times($p("u",true),Power(Plus($p("a"),Times($p("b",true),Power(Cosh($p("v")),C2))),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Dist(Power($s("b"),$s("n")),Int(Times($s("u"),Power(Sinh($s("v")),Times(C2,$s("n")))),$s("x"))),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ($s("n"))),ZeroQ(Plus($s("a"),$s("b")))))),
SetDelayed(Int(Times($p("u",true),Power(Plus($p("a"),Times($p("b",true),Power(Tanh($p("v")),C2))),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Dist(Power($s("a"),$s("n")),Int(Times($s("u"),Power(Sech($s("v")),Times(C2,$s("n")))),$s("x"))),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ($s("n"))),ZeroQ(Plus($s("a"),$s("b")))))),
SetDelayed(Int(Times($p("u",true),Power(Plus($p("a"),Times($p("b",true),Power(Coth($p("v")),C2))),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Dist(Power($s("b"),$s("n")),Int(Times($s("u"),Power(Csch($s("v")),Times(C2,$s("n")))),$s("x"))),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ($s("n"))),ZeroQ(Plus($s("a"),$s("b")))))),
SetDelayed(Int(Times($p("u",true),Power(Plus($p("a"),Times($p("b",true),Power(Sech($p("v")),C2))),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Dist(Power($s("a"),$s("n")),Int(Times($s("u"),Power(Tanh($s("v")),Times(C2,$s("n")))),$s("x"))),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ($s("n"))),ZeroQ(Plus($s("a"),$s("b")))))),
SetDelayed(Int(Times($p("u",true),Power(Plus($p("a"),Times($p("b",true),Power(Csch($p("v")),C2))),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Dist(Power($s("a"),$s("n")),Int(Times($s("u"),Power(Coth($s("v")),Times(C2,$s("n")))),$s("x"))),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ($s("n"))),ZeroQ(Plus($s("a"),Times(CN1,$s("b"))))))),
SetDelayed(Int(Times($p("u",true),Power(Plus(Times($p("a",true),Power(Sech($p("v")),$p("m",true))),Times($p("b",true),Power(Tanh($p("v")),$p("m",true)))),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Int(Times($s("u"),Times(Power(Plus($s("a"),Times($s("b"),Power(Sinh($s("v")),$s("m")))),$s("n")),Power(Power(Cosh($s("v")),Times($s("m"),$s("n"))),CN1))),$s("x")),And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ(List($s("m"),$s("n")))),Or(OddQ(Times($s("m"),$s("n"))),Less(Times($s("m"),$s("n")),C0))),Not(And(Equal($s("m"),C2),ZeroQ(Plus($s("a"),Times(CN1,$s("b"))))))))),
SetDelayed(Int(Power(Plus(Times($p("a",true),Coth($p("v"))),Times($p("b",true),Csch($p("v")))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Dist(Power($s("a"),$s("n")),Int(Power(Coth(Plus(Times($s("v"),C1D2),Times(Times(Plus(Times($s("a"),Power($s("b"),CN1)),Times(CN1,C1)),Pi),Times(CI,C1D4)))),$s("n")),$s("x"))),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),ZeroQ(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))))),EvenQ($s("n"))))),
SetDelayed(Int(Times($p("u",true),Power(Plus(Times($p("a",true),Power(Csch($p("v")),$p("m",true))),Times($p("b",true),Power(Coth($p("v")),$p("m",true)))),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Int(Times($s("u"),Times(Power(Plus($s("a"),Times($s("b"),Power(Cosh($s("v")),$s("m")))),$s("n")),Power(Power(Sinh($s("v")),Times($s("m"),$s("n"))),CN1))),$s("x")),And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ(List($s("m"),$s("n")))),Or(OddQ(Times($s("m"),$s("n"))),Less(Times($s("m"),$s("n")),C0))),Not(And(Equal($s("m"),C2),ZeroQ(Plus($s("a"),$s("b")))))))),
SetDelayed(Int(Times(Times(Power($p("x"),$p("m",true)),Power(Sech($p("v")),$p("n",true))),Power(Csch($p("v")),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Dist(Power(C2,$s("n")),Int(Times(Power($s("x"),$s("m")),Power(Csch(Dist(C2,$s("v"))),$s("n"))),$s("x"))),And(IntegerQ(List($s("m"),$s("n"))),Greater($s("m"),C0)))),
SetDelayed(Int(Times($p("u"),Cosh(Times($p("c",true),Plus($p("a",true),Times($p("b",true),$p("x")))))),$p("x",$s("Symbol"))),
    Condition(Dist(Times(C1,Power(Times($s("b"),$s("c")),CN1)),Subst(Int(Regularize(SubstFor(Sinh(Times($s("c"),Plus($s("a"),Times($s("b"),$s("x"))))),$s("u"),$s("x")),$s("x")),$s("x")),$s("x"),Sinh(Times($s("c"),Plus($s("a"),Times($s("b"),$s("x"))))))),And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),FunctionOfQ(Sinh(Times($s("c"),Plus($s("a"),Times($s("b"),$s("x"))))),$s("u"),$s("x"),True)))),
SetDelayed(Int(Times($p("u"),Coth(Times($p("c",true),Plus($p("a",true),Times($p("b",true),$p("x")))))),$p("x",$s("Symbol"))),
    Condition(Dist(Times(C1,Power(Times($s("b"),$s("c")),CN1)),Subst(Int(Regularize(Times(SubstFor(Sinh(Times($s("c"),Plus($s("a"),Times($s("b"),$s("x"))))),$s("u"),$s("x")),Power($s("x"),CN1)),$s("x")),$s("x")),$s("x"),Sinh(Times($s("c"),Plus($s("a"),Times($s("b"),$s("x"))))))),And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),FunctionOfQ(Sinh(Times($s("c"),Plus($s("a"),Times($s("b"),$s("x"))))),$s("u"),$s("x"),True)))),
SetDelayed(Int(Times($p("u"),Sinh(Times($p("c",true),Plus($p("a",true),Times($p("b",true),$p("x")))))),$p("x",$s("Symbol"))),
    Condition(Dist(Times(C4,Power(Times($s("b"),$s("c")),CN1)),Subst(Int(Regularize(Times($s("x"),SubstFor(Sinh(Times($s("c"),Times(Plus($s("a"),Times($s("b"),$s("x"))),C1D2))),$s("u"),$s("x"))),$s("x")),$s("x")),$s("x"),Sinh(Times($s("c"),Times(Plus($s("a"),Times($s("b"),$s("x"))),C1D2))))),And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),FunctionOfQ(Sinh(Times($s("c"),Times(Plus($s("a"),Times($s("b"),$s("x"))),C1D2))),$s("u"),$s("x"),True)))),
SetDelayed(Int(Times($p("u"),Sinh(Times($p("c",true),Plus($p("a",true),Times($p("b",true),$p("x")))))),$p("x",$s("Symbol"))),
    Condition(Dist(Times(C1,Power(Times($s("b"),$s("c")),CN1)),Subst(Int(Regularize(SubstFor(Cosh(Times($s("c"),Plus($s("a"),Times($s("b"),$s("x"))))),$s("u"),$s("x")),$s("x")),$s("x")),$s("x"),Cosh(Times($s("c"),Plus($s("a"),Times($s("b"),$s("x"))))))),And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),FunctionOfQ(Cosh(Times($s("c"),Plus($s("a"),Times($s("b"),$s("x"))))),$s("u"),$s("x"),True)))),
SetDelayed(Int(Times($p("u"),Tanh(Times($p("c",true),Plus($p("a",true),Times($p("b",true),$p("x")))))),$p("x",$s("Symbol"))),
    Condition(Dist(Times(C1,Power(Times($s("b"),$s("c")),CN1)),Subst(Int(Regularize(Times(SubstFor(Cosh(Times($s("c"),Plus($s("a"),Times($s("b"),$s("x"))))),$s("u"),$s("x")),Power($s("x"),CN1)),$s("x")),$s("x")),$s("x"),Cosh(Times($s("c"),Plus($s("a"),Times($s("b"),$s("x"))))))),And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),FunctionOfQ(Cosh(Times($s("c"),Plus($s("a"),Times($s("b"),$s("x"))))),$s("u"),$s("x"),True)))),
SetDelayed(Int(Times($p("u"),Sinh(Times($p("c",true),Plus($p("a",true),Times($p("b",true),$p("x")))))),$p("x",$s("Symbol"))),
    Condition(Dist(Times(C4,Power(Times($s("b"),$s("c")),CN1)),Subst(Int(Regularize(Times($s("x"),SubstFor(Cosh(Times($s("c"),Times(Plus($s("a"),Times($s("b"),$s("x"))),C1D2))),$s("u"),$s("x"))),$s("x")),$s("x")),$s("x"),Cosh(Times($s("c"),Times(Plus($s("a"),Times($s("b"),$s("x"))),C1D2))))),And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),FunctionOfQ(Cosh(Times($s("c"),Times(Plus($s("a"),Times($s("b"),$s("x"))),C1D2))),$s("u"),$s("x"),True)))),
SetDelayed(Int(Times($p("u"),Power(Tanh(Times($p("c",true),Plus($p("a",true),Times($p("b",true),$p("x"))))),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Dist(Times(C1,Power(Times($s("b"),$s("c")),CN1)),Subst(Int(Regularize(Times(SubstFor(Coth(Times($s("c"),Plus($s("a"),Times($s("b"),$s("x"))))),$s("u"),$s("x")),Power(Times(Power($s("x"),$s("n")),Plus(C1,Times(CN1,Power($s("x"),C2)))),CN1)),$s("x")),$s("x")),$s("x"),Coth(Times($s("c"),Plus($s("a"),Times($s("b"),$s("x"))))))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),IntegerQ($s("n"))),FunctionOfQ(Coth(Times($s("c"),Plus($s("a"),Times($s("b"),$s("x"))))),$s("u"),$s("x"),True)),TryPureTanhSubst(Times($s("u"),Power(Tanh(Times($s("c"),Plus($s("a"),Times($s("b"),$s("x"))))),$s("n"))),$s("x"))))),
SetDelayed(Int($p("u"),$p("x",$s("Symbol"))),
    Module(List(Set($s("v"),FunctionOfHyperbolic($s("u"),$s("x")))),Condition(Dist(Times(C1,Power(Coefficient($s("v"),$s("x"),C1),CN1)),Subst(Int(Regularize(Times(SubstFor(Coth($s("v")),$s("u"),$s("x")),Power(Plus(C1,Times(CN1,Power($s("x"),C2))),CN1)),$s("x")),$s("x")),$s("x"),Coth($s("v")))),And(And(NotFalseQ($s("v")),FunctionOfQ(Coth($s("v")),$s("u"),$s("x"),True)),TryPureTanhSubst($s("u"),$s("x")))))),
SetDelayed(Int(Times($p("u"),Power(Coth(Times($p("c",true),Plus($p("a",true),Times($p("b",true),$p("x"))))),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Dist(Times(C1,Power(Times($s("b"),$s("c")),CN1)),Subst(Int(Regularize(Times(SubstFor(Tanh(Times($s("c"),Plus($s("a"),Times($s("b"),$s("x"))))),$s("u"),$s("x")),Power(Times(Power($s("x"),$s("n")),Plus(C1,Times(CN1,Power($s("x"),C2)))),CN1)),$s("x")),$s("x")),$s("x"),Tanh(Times($s("c"),Plus($s("a"),Times($s("b"),$s("x"))))))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),IntegerQ($s("n"))),FunctionOfQ(Tanh(Times($s("c"),Plus($s("a"),Times($s("b"),$s("x"))))),$s("u"),$s("x"),True)),TryPureTanhSubst(Times($s("u"),Power(Coth(Times($s("c"),Plus($s("a"),Times($s("b"),$s("x"))))),$s("n"))),$s("x"))))),
SetDelayed(Int($p("u"),$p("x",$s("Symbol"))),
    Module(List(Set($s("v"),FunctionOfHyperbolic($s("u"),$s("x")))),Condition(Dist(Times(C1,Power(Coefficient($s("v"),$s("x"),C1),CN1)),Subst(Int(Regularize(Times(SubstFor(Tanh($s("v")),$s("u"),$s("x")),Power(Plus(C1,Times(CN1,Power($s("x"),C2))),CN1)),$s("x")),$s("x")),$s("x"),Tanh($s("v")))),And(And(NotFalseQ($s("v")),FunctionOfQ(Tanh($s("v")),$s("u"),$s("x"),True)),TryPureTanhSubst($s("u"),$s("x")))))),
SetDelayed(TryPureTanhSubst($p("u"),$p("x",$s("Symbol"))),
    And(And(And(And(Not(MatchQ($s("u"),Condition(ArcTanh(Times($p("a",true),Tanh($p("v")))),FreeQ($s("a"),$s("x"))))),Not(MatchQ($s("u"),Condition(ArcTanh(Times($p("a",true),Coth($p("v")))),FreeQ($s("a"),$s("x")))))),Not(MatchQ($s("u"),Condition(ArcCoth(Times($p("a",true),Tanh($p("v")))),FreeQ($s("a"),$s("x")))))),Not(MatchQ($s("u"),Condition(ArcCoth(Times($p("a",true),Coth($p("v")))),FreeQ($s("a"),$s("x")))))),SameQ($s("u"),ExpnExpand($s("u"),$s("x"))))),
SetDelayed(Int(Log(Times($p("c",true),Power(Plus($p("a",true),Times($p("b",true),$p("x"))),$p("n",true)))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Plus($s("a"),Times($s("b"),$s("x"))),Times(Log(Times($s("c"),Power(Plus($s("a"),Times($s("b"),$s("x"))),$s("n")))),Power($s("b"),CN1))),Times(CN1,Times($s("n"),$s("x")))),FreeQ(List($s("a"),$s("b"),$s("c"),$s("n")),$s("x")))),
SetDelayed(Int(Times(Log(Times($p("c",true),Plus($p("a",true),Times($p("b",true),$p("x"))))),Power(Plus($p("d"),Times($p("e",true),$p("x"))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Times(CN1,PolyLog(C2,Plus(Plus(C1,Times(CN1,Times($s("a"),$s("c")))),Times(CN1,Times(Times($s("b"),$s("c")),$s("x")))))),Power($s("e"),CN1)),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e")),$s("x")),ZeroQ(Plus(Plus(Times(Times($s("a"),$s("c")),$s("e")),Times(CN1,Times(Times($s("b"),$s("c")),$s("d")))),Times(CN1,$s("e"))))))),
SetDelayed(Int(Times(Log(Times($p("c",true),Power(Plus($p("a",true),Times($p("b",true),$p("x"))),$p("n",true)))),Power(Plus($p("d"),Times($p("e",true),$p("x"))),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Log(Times($s("c"),Power(Plus($s("a"),Times($s("b"),$s("x"))),$s("n")))),Times(Log(Times($s("b"),Times(Plus($s("d"),Times($s("e"),$s("x"))),Power(Plus(Times($s("b"),$s("d")),Times(CN1,Times($s("a"),$s("e")))),CN1)))),Power($s("e"),CN1))),Times($s("n"),Times(PolyLog(C2,Times(Times(CN1,$s("e")),Times(Plus($s("a"),Times($s("b"),$s("x"))),Power(Plus(Times($s("b"),$s("d")),Times(CN1,Times($s("a"),$s("e")))),CN1)))),Power($s("e"),CN1)))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e"),$s("n")),$s("x")),NonzeroQ(Plus(Times($s("b"),$s("d")),Times(CN1,Times($s("a"),$s("e")))))))),
SetDelayed(Int(Log(Times($p("c",true),Power(Times($p("b",true),Power($p("x"),$p("n"))),$p("p",true)))),$p("x",$s("Symbol"))),
    Condition(Plus(Times($s("x"),Log(Times($s("c"),Power(Times($s("b"),Power($s("x"),$s("n"))),$s("p"))))),Times(CN1,Times(Times($s("n"),$s("p")),$s("x")))),FreeQ(List($s("b"),$s("c"),$s("n"),$s("p")),$s("x")))),
SetDelayed(Int(Log(Times($p("c",true),Power(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("n")))),$p("p",true)))),$p("x",$s("Symbol"))),
    Condition(Plus(Times($s("x"),Log(Times($s("c"),Power(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))),$s("p"))))),Times(CN1,Dist(Times(Times($s("b"),$s("n")),$s("p")),Int(Times(C1,Power(Plus($s("b"),Times($s("a"),Power($s("x"),Times(CN1,$s("n"))))),CN1)),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("p")),$s("x")),RationalQ($s("n"))),Less($s("n"),C0)))),
SetDelayed(Int(Log(Times($p("c",true),Power(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("n")))),$p("p",true)))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times($s("x"),Log(Times($s("c"),Power(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))),$s("p"))))),Times(CN1,Times(Times($s("n"),$s("p")),$s("x")))),Dist(Times(Times($s("a"),$s("n")),$s("p")),Int(Times(C1,Power(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))),CN1)),$s("x")))),FreeQ(List($s("a"),$s("b"),$s("c"),$s("n"),$s("p")),$s("x")))),
SetDelayed(Int(Times(Log(Plus(C1,Times($p("b",true),Power($p("x"),$p("n",true))))),Power($p("x"),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Times(CN1,PolyLog(C2,Times(Times(CN1,$s("b")),Power($s("x"),$s("n"))))),Power($s("n"),CN1)),FreeQ(List($s("b"),$s("n")),$s("x")))),
SetDelayed(Int(Times(Log(Times($p("c",true),Plus($p("a"),Times($p("b",true),Power($p("x"),$p("n",true)))))),Power($p("x"),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Log(Times($s("a"),$s("c"))),Log($s("x"))),Int(Times(Log(Plus(C1,Times($s("b"),Times(Power($s("x"),$s("n")),Power($s("a"),CN1))))),Power($s("x"),CN1)),$s("x"))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("n")),$s("x")),PositiveQ(Times($s("a"),$s("c")))))),
SetDelayed(Int(Times(Log(Times($p("c",true),Power(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("n",true)))),$p("p",true)))),Power($p("x"),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Log(Times($s("c"),Power(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))),$s("p")))),Times(Log(Times(Times(CN1,$s("b")),Times(Power($s("x"),$s("n")),Power($s("a"),CN1)))),Power($s("n"),CN1))),Times(CN1,Dist(Times($s("b"),$s("p")),Int(Times(Power($s("x"),Plus($s("n"),Times(CN1,C1))),Times(Log(Times(Times(CN1,$s("b")),Times(Power($s("x"),$s("n")),Power($s("a"),CN1)))),Power(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))),CN1))),$s("x"))))),FreeQ(List($s("a"),$s("b"),$s("c"),$s("n"),$s("p")),$s("x")))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Log(Times($p("c",true),Power(Times($p("b",true),Power($p("x"),$p("n",true))),$p("p",true))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Times(Log(Times($s("c"),Power(Times($s("b"),Power($s("x"),$s("n"))),$s("p")))),Power(Plus($s("m"),C1),CN1))),Times(CN1,Times(Times($s("n"),$s("p")),Times(Power($s("x"),Plus($s("m"),C1)),Power(Power(Plus($s("m"),C1),C2),CN1))))),And(FreeQ(List($s("b"),$s("c"),$s("m"),$s("n"),$s("p")),$s("x")),NonzeroQ(Plus($s("m"),C1))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Log(Times($p("c",true),Power(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("n",true)))),$p("p",true))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Times(Log(Times($s("c"),Power(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))),$s("p")))),Power(Plus($s("m"),C1),CN1))),Times(CN1,Dist(Times(Times($s("b"),$s("n")),Times($s("p"),Power(Plus($s("m"),C1),CN1))),Int(Times(Power($s("x"),Plus($s("m"),$s("n"))),Power(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))),CN1)),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("m"),$s("n"),$s("p")),$s("x")),NonzeroQ(Plus($s("m"),C1))),NonzeroQ(Plus(Plus($s("m"),Times(CN1,$s("n"))),C1))))),
SetDelayed(Int(Times(C1,Power(Log(Times($p("c",true),Plus($p("d",true),Times($p("e",true),$p("x"))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(LogIntegral(Times($s("c"),Plus($s("d"),Times($s("e"),$s("x"))))),Power(Times($s("c"),$s("e")),CN1)),FreeQ(List($s("c"),$s("d"),$s("e")),$s("x")))),
SetDelayed(Int(Times(C1,Power(Plus($p("a",true),Times($p("b",true),Log(Times($p("c",true),Power(Plus($p("d",true),Times($p("e",true),$p("x"))),$p("n",true)))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Plus($s("d"),Times($s("e"),$s("x"))),Times(ExpIntegralEi(Times(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power(Plus($s("d"),Times($s("e"),$s("x"))),$s("n")))))),Power(Times($s("b"),$s("n")),CN1))),Power(Times(Times(Times(Times($s("b"),$s("e")),$s("n")),Power(E,Times($s("a"),Power(Times($s("b"),$s("n")),CN1)))),Power(Times($s("c"),Power(Plus($s("d"),Times($s("e"),$s("x"))),$s("n"))),Times(C1,Power($s("n"),CN1)))),CN1))),FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e"),$s("n")),$s("x")))),
SetDelayed(Int(Times(C1,Power(Sqrt(Plus($p("a",true),Times($p("b",true),Log(Times($p("c",true),Power(Plus($p("d",true),Times($p("e",true),$p("x"))),$p("n",true))))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Times(Sqrt(Pi),Plus($s("d"),Times($s("e"),$s("x")))),Times(Erfi(Times(Rt(Times(C1,Power(Times($s("b"),$s("n")),CN1)),C2),Sqrt(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power(Plus($s("d"),Times($s("e"),$s("x"))),$s("n"))))))))),Power(Times(Times(Times(Times(Times($s("b"),$s("e")),$s("n")),Rt(Times(C1,Power(Times($s("b"),$s("n")),CN1)),C2)),Power(E,Times($s("a"),Power(Times($s("b"),$s("n")),CN1)))),Power(Times($s("c"),Power(Plus($s("d"),Times($s("e"),$s("x"))),$s("n"))),Times(C1,Power($s("n"),CN1)))),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e"),$s("n")),$s("x")),PosQ(Times(C1,Power(Times($s("b"),$s("n")),CN1)))))),
SetDelayed(Int(Times(C1,Power(Sqrt(Plus($p("a",true),Times($p("b",true),Log(Times($p("c",true),Power(Plus($p("d",true),Times($p("e",true),$p("x"))),$p("n",true))))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Times(Sqrt(Pi),Plus($s("d"),Times($s("e"),$s("x")))),Times(Erf(Times(Rt(Times(CN1,Power(Times($s("b"),$s("n")),CN1)),C2),Sqrt(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power(Plus($s("d"),Times($s("e"),$s("x"))),$s("n"))))))))),Power(Times(Times(Times(Times(Times($s("b"),$s("e")),$s("n")),Rt(Times(CN1,Power(Times($s("b"),$s("n")),CN1)),C2)),Power(E,Times($s("a"),Power(Times($s("b"),$s("n")),CN1)))),Power(Times($s("c"),Power(Plus($s("d"),Times($s("e"),$s("x"))),$s("n"))),Times(C1,Power($s("n"),CN1)))),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e"),$s("n")),$s("x")),NegQ(Times(C1,Power(Times($s("b"),$s("n")),CN1)))))),
SetDelayed(Int(Power(Plus($p("a",true),Times($p("b",true),Log(Times($p("c",true),Power($p("x"),$p("n",true)))))),$p("p")),$p("x",$s("Symbol"))),
    Condition(Plus(Times($s("x"),Power(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n")))))),$s("p"))),Times(CN1,Dist(Times(Times($s("b"),$s("n")),$s("p")),Int(Power(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n")))))),Plus($s("p"),Times(CN1,C1))),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("n")),$s("x")),RationalQ($s("p"))),Greater($s("p"),C0)))),
SetDelayed(Int(Power(Log(Times($p("c",true),Power(Plus($p("d",true),Times($p("e",true),$p("x"))),$p("n",true)))),$p("p")),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Plus($s("d"),Times($s("e"),$s("x"))),Times(Power(Log(Times($s("c"),Power(Plus($s("d"),Times($s("e"),$s("x"))),$s("n")))),$s("p")),Power($s("e"),CN1))),Times(CN1,Dist(Times($s("n"),$s("p")),Int(Power(Log(Times($s("c"),Power(Plus($s("d"),Times($s("e"),$s("x"))),$s("n")))),Plus($s("p"),Times(CN1,C1))),$s("x"))))),And(And(FreeQ(List($s("c"),$s("d"),$s("e"),$s("n")),$s("x")),RationalQ($s("p"))),Greater($s("p"),C0))))
  );
}
