package org.matheclipse.core.integrate.rubi;


import static org.matheclipse.core.expression.F.*;
import static org.matheclipse.core.integrate.rubi.UtilityFunctionCtors.*;
import static org.matheclipse.core.integrate.rubi.UtilityFunctions.*;
import org.matheclipse.core.interfaces.IAST;
import org.matheclipse.core.interfaces.IExpr;

/** 
 * IndefiniteIntegrationRules from the <a href="http://www.apmaths.uwo.ca/~arich/">Rubi -
 * rule-based integrator</a>.
 *  
 */
public class IndefiniteIntegrationRules2 { 
  public static IAST RULES = List( 
SetDelayed(Int(Times(C1,Power(Sqrt(Plus($p("a"),Times($p("b",true),Power($p("x"),C2)))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(ArcTanh(Times(Sqrt(Plus($s("a"),Times($s("b"),Power($s("x"),C2)))),Power(Times(Rt($s("b"),C2),$s("x")),CN1))),Power(Rt($s("b"),C2),CN1)),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),Not(PositiveQ($s("a")))),PosQ($s("b"))))),
SetDelayed(Int(Times(C1,Power(Sqrt(Plus($p("a"),Times($p("b",true),Power($p("x"),C2)))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Times(CN1,ArcTan(Times(Sqrt(Plus($s("a"),Times($s("b"),Power($s("x"),C2)))),Power(Times(Rt(Times(CN1,$s("b")),C2),$s("x")),CN1)))),Power(Rt(Times(CN1,$s("b")),C2),CN1)),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),Not(PositiveQ($s("a")))),NegQ($s("b"))))),
SetDelayed(Int(Times(C1,Power(Sqrt(Plus($p("a"),Times($p("b",true),Power($p("x"),C4)))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(EllipticF(ArcSin(Times(Rt(Times(Times(CN1,$s("b")),Power($s("a"),CN1)),C4),$s("x"))),CN1),Power(Times(Rt(Times(Times(CN1,$s("b")),Power($s("a"),CN1)),C4),Sqrt($s("a"))),CN1)),And(FreeQ(List($s("a"),$s("b")),$s("x")),PositiveQ($s("a"))))),
SetDelayed(Int(Times(C1,Power(Sqrt(Plus($p("a"),Times($p("b",true),Power($p("x"),C4)))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Sqrt(Times(Plus($s("a"),Times($s("b"),Power($s("x"),C4))),Power($s("a"),CN1))),Times(EllipticF(ArcSin(Times(Rt(Times(Times(CN1,$s("b")),Power($s("a"),CN1)),C4),$s("x"))),CN1),Power(Times(Rt(Times(Times(CN1,$s("b")),Power($s("a"),CN1)),C4),Sqrt(Plus($s("a"),Times($s("b"),Power($s("x"),C4))))),CN1))),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(Sqrt(Plus($p("a",true),Times($p("b",true),Power(Power($p("x"),C2),CN1)))),$p("x",$s("Symbol"))),
    Condition(Times(CN1,Subst(Int(Times(Sqrt(Plus($s("a"),Times($s("b"),Power($s("x"),C2)))),Power(Power($s("x"),C2),CN1)),$s("x")),$s("x"),Times(C1,Power($s("x"),CN1)))),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(Power(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("n")))),$p("p")),$p("x",$s("Symbol"))),
    Condition(Times($s("x"),Times(Power(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))),Plus($s("p"),C1)),Power($s("a"),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("n"),$s("p")),$s("x")),ZeroQ(Plus(Times($s("n"),Plus($s("p"),C1)),C1))))),
SetDelayed(Int(Power(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("n")))),$p("p")),$p("x",$s("Symbol"))),
    Condition(Plus(Times($s("x"),Times(Power(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))),$s("p")),Power(Plus(Times($s("n"),$s("p")),C1),CN1))),Dist(Times(Times($s("n"),$s("p")),Times($s("a"),Power(Plus(Times($s("n"),$s("p")),C1),CN1))),Int(Power(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))),Plus($s("p"),Times(CN1,C1))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("n")),$s("x")),FractionQ($s("p"))),Greater($s("p"),C0)),NonzeroQ(Plus(Times($s("n"),$s("p")),C1))))),
SetDelayed(Int(Power(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("n")))),$p("p")),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,$s("x")),Times(Power(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))),Plus($s("p"),C1)),Power(Times(Times($s("n"),Plus($s("p"),C1)),$s("a")),CN1))),Dist(Times(Plus(Times($s("n"),Plus($s("p"),C1)),C1),Power(Times(Times($s("n"),Plus($s("p"),C1)),$s("a")),CN1)),Int(Power(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))),Plus($s("p"),C1)),$s("x")))),And(And(FreeQ(List($s("a"),$s("b"),$s("n")),$s("x")),FractionQ($s("p"))),Less($s("p"),CN1)))),
SetDelayed(Int(Power(Plus($p("a"),Times($p("b",true),Power($p("x"),CN1))),$p("p")),$p("x",$s("Symbol"))),
    Condition(Plus(Times($s("x"),Times(Power(Plus($s("a"),Times($s("b"),Power($s("x"),CN1))),Plus($s("p"),C1)),Power($s("a"),CN1))),Dist(Times($s("b"),Times($s("p"),Power($s("a"),CN1))),Int(Times(Power(Plus($s("a"),Times($s("b"),Power($s("x"),CN1))),$s("p")),Power($s("x"),CN1)),$s("x")))),And(FreeQ(List($s("a"),$s("b"),$s("p")),$s("x")),Not(IntegerQ($s("p")))))),
SetDelayed(Int(Power(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("n")))),$p("p")),$p("x",$s("Symbol"))),
    Condition(Module(List(Set($s("q"),Denominator($s("p")))),Dist(Times($s("q"),Times(Power($s("a"),Plus($s("p"),Times(C1,Power($s("n"),CN1)))),Power($s("n"),CN1))),Subst(Int(Times(Power($s("x"),Plus(Times($s("q"),Power($s("n"),CN1)),Times(CN1,C1))),Power(Power(Plus(C1,Times(CN1,Times($s("b"),Power($s("x"),$s("q"))))),Plus(Plus($s("p"),Times(C1,Power($s("n"),CN1))),C1)),CN1)),$s("x")),$s("x"),Times(Power($s("x"),Times($s("n"),Power($s("q"),CN1))),Power(Power(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))),Times(C1,Power($s("q"),CN1))),CN1))))),And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),RationalQ(List($s("p"),$s("n")))),Less(Less(CN1,$s("p")),C0)),IntegerQ(Plus($s("p"),Times(C1,Power($s("n"),CN1))))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n")))),$p("p",true))),$p("x",$s("Symbol"))),
    Condition(Dist(Times(C1,Power(Plus($s("m"),C1),CN1)),Subst(Int(Power(Plus($s("a"),Times($s("b"),Power($s("x"),Times($s("n"),Power(Plus($s("m"),C1),CN1))))),$s("p")),$s("x")),$s("x"),Power($s("x"),Plus($s("m"),C1)))),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("m"),$s("n"),$s("p")),$s("x")),NonzeroQ(Plus($s("m"),C1))),IntegerQ(Times($s("n"),Power(Plus($s("m"),C1),CN1)))),Greater(Times($s("n"),Power(Plus($s("m"),C1),CN1)),C1)),Not(IntegerQ(List($s("m"),$s("n"),$s("p"))))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("n")))),$p("p"))),$p("x",$s("Symbol"))),
    Condition(Int(Times(Power($s("x"),Plus($s("m"),Times($s("n"),$s("p")))),Power(Plus($s("b"),Times($s("a"),Power(Power($s("x"),$s("n")),CN1))),$s("p"))),$s("x")),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("m")),$s("x")),FractionQ($s("n"))),Less($s("n"),C0)),IntegerQ($s("p"))),Less($s("p"),C0)))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("n")))),$p("p"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Times(Power(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))),$s("p")),Power(Plus($s("m"),C1),CN1))),Times(CN1,Dist(Times(Times($s("b"),$s("n")),Times($s("p"),Power(Plus($s("m"),C1),CN1))),Int(Times(Power($s("x"),Plus($s("m"),$s("n"))),Power(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))),Plus($s("p"),Times(CN1,C1)))),$s("x"))))),And(And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ(List($s("m"),$s("n")))),FractionQ($s("p"))),Greater($s("p"),C0)),Or(And(Greater($s("n"),C0),Less($s("m"),CN1)),And(Less(C0,Times(CN1,$s("n"))),LessEqual(Times(CN1,$s("n")),Plus($s("m"),C1))))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("n")))),$p("p"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus(Plus($s("m"),Times(CN1,$s("n"))),C1)),Times(Power(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))),Plus($s("p"),C1)),Power(Times(Times($s("b"),$s("n")),Plus($s("p"),C1)),CN1))),Times(CN1,Dist(Times(Plus(Plus($s("m"),Times(CN1,$s("n"))),C1),Power(Times(Times($s("b"),$s("n")),Plus($s("p"),C1)),CN1)),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,$s("n")))),Power(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))),Plus($s("p"),C1))),$s("x"))))),And(And(And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ(List($s("m"),$s("n")))),FractionQ($s("p"))),Or(And(Less(C0,$s("n")),LessEqual($s("n"),$s("m"))),And(LessEqual($s("m"),$s("n")),Less($s("n"),C0)))),Less($s("p"),CN1)),NonzeroQ(Plus(Plus($s("m"),Times(CN1,$s("n"))),C1))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("n")))),$p("p"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Times(Power(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))),$s("p")),Power(Plus(Plus($s("m"),Times($s("n"),$s("p"))),C1),CN1))),Dist(Times(Times($s("n"),$s("p")),Times($s("a"),Power(Plus(Plus($s("m"),Times($s("n"),$s("p"))),C1),CN1))),Int(Times(Power($s("x"),$s("m")),Power(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))),Plus($s("p"),Times(CN1,C1)))),$s("x")))),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("m"),$s("n"),$s("p")),$s("x")),NonzeroQ(Plus(Plus($s("m"),Times($s("n"),$s("p"))),C1))),FractionQ($s("p"))),Greater($s("p"),C0)),Not(And(IntegerQ(Times(Plus($s("m"),C1),Power($s("n"),CN1))),Greater(Times(Plus($s("m"),C1),Power($s("n"),CN1)),C0)))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("n")))),$p("p"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Power($s("x"),Plus($s("m"),C1))),Times(Power(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))),Plus($s("p"),C1)),Power(Times(Times($s("a"),$s("n")),Plus($s("p"),C1)),CN1))),Dist(Times(Plus(Plus($s("m"),Times($s("n"),Plus($s("p"),C1))),C1),Power(Times(Times($s("a"),$s("n")),Plus($s("p"),C1)),CN1)),Int(Times(Power($s("x"),$s("m")),Power(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))),Plus($s("p"),C1))),$s("x")))),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("m"),$s("n")),$s("x")),FractionQ($s("p"))),Less($s("p"),CN1)),NonzeroQ(Plus(Plus($s("m"),Times($s("n"),Plus($s("p"),C1))),C1))),NonzeroQ(Plus(Plus($s("m"),Times(CN1,$s("n"))),C1))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("n",true)))),$p("p"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus(Plus($s("m"),Times(CN1,$s("n"))),C1)),Times(Power(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))),Plus($s("p"),C1)),Power(Times($s("b"),Plus(Plus($s("m"),Times($s("n"),$s("p"))),C1)),CN1))),Times(CN1,Dist(Times($s("a"),Times(Plus(Plus($s("m"),Times(CN1,$s("n"))),C1),Power(Times($s("b"),Plus(Plus($s("m"),Times($s("n"),$s("p"))),C1)),CN1))),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,$s("n")))),Power(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))),$s("p"))),$s("x"))))),And(And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("m"),$s("n"),$s("p")),$s("x")),NonzeroQ(Plus(Plus($s("m"),Times($s("n"),$s("p"))),C1))),NonzeroQ(Plus(Plus($s("m"),Times(CN1,$s("n"))),C1))),NonzeroQ(Plus($s("m"),C1))),Not(IntegerQ(List($s("m"),$s("n"),$s("p"))))),Or(Or(Or(Or(And(And(IntegerQ(List($s("m"),$s("n"))),Or(And(Less(C0,$s("n")),LessEqual($s("n"),$s("m"))),And(LessEqual($s("m"),$s("n")),Less($s("n"),C0)))),Or(Not(RationalQ($s("p"))),Less(Less(CN1,$s("p")),C0))),And(And(IntegerQ(Times(Plus($s("m"),C1),Power($s("n"),CN1))),Less(C0,Times(Plus($s("m"),C1),Power($s("n"),CN1)))),Not(FractionQ($s("n"))))),And(Not(RationalQ($s("m"))),RationalQ(Plus($s("m"),Times(CN1,$s("n")))))),And(RationalQ($s("n")),MatchQ($s("m"),Condition(Plus($p("u"),$p("q")),And(RationalQ($s("q")),Or(And(Less(C0,$s("n")),LessEqual($s("n"),$s("q"))),And(Less($s("n"),C0),Less($s("q"),C0)))))))),MatchQ($s("m"),Condition(Plus($p("u"),Times($p("q",true),$s("n"))),And(RationalQ($s("q")),GreaterEqual($s("q"),C1)))))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("n",true)))),$p("p"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Times(Power(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))),Plus($s("p"),C1)),Power(Times($s("a"),Plus($s("m"),C1)),CN1))),Times(CN1,Dist(Times($s("b"),Times(Plus(Plus($s("m"),Times($s("n"),Plus($s("p"),C1))),C1),Power(Times($s("a"),Plus($s("m"),C1)),CN1))),Int(Times(Power($s("x"),Plus($s("m"),$s("n"))),Power(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))),$s("p"))),$s("x"))))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("m"),$s("n"),$s("p")),$s("x")),NonzeroQ(Plus($s("m"),C1))),Not(IntegerQ(List($s("m"),$s("n"),$s("p"))))),Or(Or(Or(And(IntegerQ(List($s("m"),$s("n"))),Or(And(Greater($s("n"),C0),Less($s("m"),CN1)),And(Less(C0,Times(CN1,$s("n"))),LessEqual(Times(CN1,$s("n")),Plus($s("m"),C1))))),And(Not(RationalQ($s("m"))),RationalQ(Plus($s("m"),$s("n"))))),And(RationalQ($s("n")),MatchQ($s("m"),Condition(Plus($p("u"),$p("q")),And(RationalQ($s("q")),Or(And(Greater($s("n"),C0),Less($s("q"),C0)),And(Less(C0,Times(CN1,$s("n"))),LessEqual(Times(CN1,$s("n")),$s("q"))))))))),MatchQ($s("m"),Condition(Plus($p("u"),Times($p("q"),$s("n"))),And(RationalQ($s("q")),Less($s("q"),C0)))))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("n")))),$p("p"))),$p("x",$s("Symbol"))),
    Condition(Module(List(Set($s("q"),Denominator($s("p")))),Times(Times($s("q"),Times(Power($s("a"),Plus($s("p"),Times(Plus($s("m"),C1),Power($s("n"),CN1)))),Power($s("n"),CN1))),Subst(Int(Times(Power($s("x"),Plus(Times($s("q"),Times(Plus($s("m"),C1),Power($s("n"),CN1))),Times(CN1,C1))),Power(Power(Plus(C1,Times(CN1,Times($s("b"),Power($s("x"),$s("q"))))),Plus(Plus($s("p"),Times(Plus($s("m"),C1),Power($s("n"),CN1))),C1)),CN1)),$s("x")),$s("x"),Times(Power($s("x"),Times($s("n"),Power($s("q"),CN1))),Power(Power(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))),Times(C1,Power($s("q"),CN1))),CN1))))),And(And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),RationalQ(List($s("m"),$s("n"),$s("p")))),Less(Less(CN1,$s("p")),C0)),IntegerQ(Plus($s("p"),Times(Plus($s("m"),C1),Power($s("n"),CN1))))),Equal(GCD(Plus($s("m"),C1),$s("n")),C1)))),
SetDelayed(Int(Times(Times($p("u",true),Power($p("x"),$p("m",true))),Plus(Times($p("v",true),Power($p("x"),$p("n",true))),$p("w"))),$p("x",$s("Symbol"))),
    Condition(Plus(Int(Times(Times($s("u"),$s("v")),Power($s("x"),Plus($s("m"),$s("n")))),$s("x")),Int(Times(Times($s("u"),$s("w")),Power($s("x"),$s("m"))),$s("x"))),And(FreeQ(List($s("m"),$s("n")),$s("x")),Not(PolynomialQ($s("w"),$s("x")))))),
SetDelayed(Int(Times(C1,Power(Sqrt(Times(Power($p("x"),$p("m",true)),Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n",true)))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(C2,Times(ArcTanh(Times($s("x"),Times(Rt($s("b"),C2),Power(Sqrt(Times(Power($s("x"),$s("m")),Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))))),CN1)))),Power(Times($s("n"),Rt($s("b"),C2)),CN1))),And(And(FreeQ(List($s("a"),$s("b"),$s("n"),$s("m")),$s("x")),ZeroQ(Plus(Plus($s("m"),$s("n")),Times(CN1,C2)))),PosQ($s("b"))))),
SetDelayed(Int(Times(C1,Power(Sqrt(Times(Power($p("x"),$p("m")),Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n",true)))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(C2,Times(ArcTan(Times($s("x"),Times(Rt(Times(CN1,$s("b")),C2),Power(Sqrt(Times(Power($s("x"),$s("m")),Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))))),CN1)))),Power(Times($s("n"),Rt(Times(CN1,$s("b")),C2)),CN1))),And(And(FreeQ(List($s("a"),$s("b"),$s("n"),$s("m")),$s("x")),ZeroQ(Plus(Plus($s("m"),$s("n")),Times(CN1,C2)))),NegQ($s("b"))))),
SetDelayed(Int(Power(Times(Power($p("x"),$p("m",true)),Plus($p("a"),Times($p("b",true),Power($p("x"),$p("n",true))))),$p("p")),$p("x",$s("Symbol"))),
    Condition(Times(Power(Times(Power($s("x"),$s("m")),Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),Plus($s("p"),C1)),Power(Times(Times(Times($s("b"),$s("n")),Plus($s("p"),C1)),Power($s("x"),Times($s("m"),Plus($s("p"),C1)))),CN1)),And(And(FreeQ(List($s("a"),$s("b"),$s("m"),$s("n"),$s("p")),$s("x")),ZeroQ(Plus(Plus(Times($s("m"),$s("p")),Times(CN1,$s("n"))),C1))),NonzeroQ(Plus($s("p"),C1))))),
SetDelayed(Int(Times(Power($p("x"),$p("q",true)),Power(Times(Power($p("x"),$p("m",true)),Plus($p("a"),Times($p("b",true),Power($p("x"),$p("n",true))))),$p("p"))),$p("x",$s("Symbol"))),
    Condition(Times(Power(Times(Power($s("x"),$s("m")),Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),Plus($s("p"),C1)),Power(Times(Times(Times($s("b"),$s("n")),Plus($s("p"),C1)),Power($s("x"),Times($s("m"),Plus($s("p"),C1)))),CN1)),And(And(FreeQ(List($s("a"),$s("b"),$s("m"),$s("n"),$s("p")),$s("x")),ZeroQ(Plus(Plus(Plus($s("q"),Times($s("m"),$s("p"))),Times(CN1,$s("n"))),C1))),NonzeroQ(Plus($s("p"),C1))))),
SetDelayed(Int(Power(Times(Power($p("x"),$p("m",true)),Plus($p("a"),Times($p("b",true),Power($p("x"),$p("n",true))))),$p("p",true)),$p("x",$s("Symbol"))),
    Condition(Times(Times(CN1,Power(Times(Power($s("x"),$s("m")),Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),Plus($s("p"),C1))),Power(Times(Times(Times($s("a"),$s("n")),Plus($s("p"),C1)),Power($s("x"),Plus($s("m"),Times(CN1,C1)))),CN1)),And(And(FreeQ(List($s("a"),$s("b"),$s("m"),$s("n"),$s("p")),$s("x")),ZeroQ(Plus(Plus(Times($s("m"),$s("p")),Times($s("n"),Plus($s("p"),C1))),C1))),NonzeroQ(Plus($s("p"),C1))))),
SetDelayed(Int(Times(Power($p("x"),$p("q",true)),Power(Times(Power($p("x"),$p("m",true)),Plus($p("a"),Times($p("b",true),Power($p("x"),$p("n",true))))),$p("p",true))),$p("x",$s("Symbol"))),
    Condition(Times(Times(CN1,Power(Times(Power($s("x"),$s("m")),Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),Plus($s("p"),C1))),Power(Times(Times(Times($s("a"),$s("n")),Plus($s("p"),C1)),Power($s("x"),Plus(Plus($s("m"),Times(CN1,C1)),Times(CN1,$s("q"))))),CN1)),And(And(FreeQ(List($s("a"),$s("b"),$s("m"),$s("n"),$s("p"),$s("q")),$s("x")),ZeroQ(Plus(Plus(Plus(C1,$s("q")),Times($s("m"),$s("p"))),Times($s("n"),Plus($s("p"),C1))))),NonzeroQ(Plus($s("p"),C1))))),
SetDelayed(Int(Times(C1,Power(Times(Plus($p("a",true),Times($p("b",true),Power($p("x"),C2))),Sqrt(Plus($p("c"),Times($p("d",true),Power($p("x"),C2))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times($s("x"),Power(Sqrt(Plus($s("c"),Times($s("d"),Power($s("x"),C2)))),CN1)),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),ZeroQ(Plus(Times($s("a"),$s("d")),Times(CN1,Times($s("b"),$s("c")))))))),
SetDelayed(Int(Times(C1,Power(Times(Plus($p("a"),Times($p("b",true),Power($p("x"),C2))),Sqrt(Plus($p("c"),Times($p("d",true),Power($p("x"),C2))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(ArcTanh(Times($s("x"),Times(Rt(Times(Plus(Times($s("a"),$s("d")),Times(CN1,Times($s("b"),$s("c")))),Power($s("a"),CN1)),C2),Power(Sqrt(Plus($s("c"),Times($s("d"),Power($s("x"),C2)))),CN1)))),Power(Times($s("a"),Rt(Times(Plus(Times($s("a"),$s("d")),Times(CN1,Times($s("b"),$s("c")))),Power($s("a"),CN1)),C2)),CN1)),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),PosQ(Times(Plus(Times($s("a"),$s("d")),Times(CN1,Times($s("b"),$s("c")))),Power($s("a"),CN1)))))),
SetDelayed(Int(Times(C1,Power(Times(Plus($p("a"),Times($p("b",true),Power($p("x"),C2))),Sqrt(Plus($p("c"),Times($p("d",true),Power($p("x"),C2))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(ArcTan(Times($s("x"),Times(Rt(Times(Plus(Times($s("b"),$s("c")),Times(CN1,Times($s("a"),$s("d")))),Power($s("a"),CN1)),C2),Power(Sqrt(Plus($s("c"),Times($s("d"),Power($s("x"),C2)))),CN1)))),Power(Times($s("a"),Rt(Times(Plus(Times($s("b"),$s("c")),Times(CN1,Times($s("a"),$s("d")))),Power($s("a"),CN1)),C2)),CN1)),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),NegQ(Times(Plus(Times($s("a"),$s("d")),Times(CN1,Times($s("b"),$s("c")))),Power($s("a"),CN1)))))),
SetDelayed(Int(Times(C1,Power(Times(Sqrt(Plus($p("a"),Times($p("b",true),Power($p("x"),C2)))),Sqrt(Plus($p("c"),Times($p("d",true),Power($p("x"),C2))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(EllipticF(ArcSin(Times(Rt(Times(Times(CN1,$s("d")),Power($s("c"),CN1)),C2),$s("x"))),Times($s("b"),Times($s("c"),Power(Times($s("a"),$s("d")),CN1)))),Power(Times(Rt(Times(Times(CN1,$s("d")),Power($s("c"),CN1)),C2),Sqrt(Times($s("a"),$s("c")))),CN1)),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),PositiveQ($s("a"))),PositiveQ($s("c"))),Or(And(PositiveQ(Times(Times(CN1,$s("d")),Power($s("c"),CN1))),NonzeroQ(Plus($s("a"),$s("b")))),Not(And(PositiveQ(Times(Times(CN1,$s("b")),Power($s("a"),CN1))),NonzeroQ(Plus($s("c"),$s("d"))))))))),
SetDelayed(Int(Times(C1,Power(Times(Sqrt(Plus($p("a"),Times($p("b",true),Power($p("x"),C2)))),Sqrt(Plus($p("c"),Times($p("d",true),Power($p("x"),C2))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Times(Sqrt(Times(Plus($s("a"),Times($s("b"),Power($s("x"),C2))),Power($s("a"),CN1))),Sqrt(Times(Plus($s("c"),Times($s("d"),Power($s("x"),C2))),Power($s("c"),CN1)))),Times(EllipticF(ArcSin(Times(Rt(Times(Times(CN1,$s("d")),Power($s("c"),CN1)),C2),$s("x"))),Times($s("b"),Times($s("c"),Power(Times($s("a"),$s("d")),CN1)))),Power(Times(Times(Rt(Times(Times(CN1,$s("d")),Power($s("c"),CN1)),C2),Sqrt(Plus($s("a"),Times($s("b"),Power($s("x"),C2))))),Sqrt(Plus($s("c"),Times($s("d"),Power($s("x"),C2))))),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),Or(And(PositiveQ(Times(Times(CN1,$s("d")),Power($s("c"),CN1))),NonzeroQ(Plus($s("a"),$s("b")))),Not(And(PositiveQ(Times(Times(CN1,$s("b")),Power($s("a"),CN1))),NonzeroQ(Plus($s("c"),$s("d"))))))))),
SetDelayed(Int(Times(Sqrt(Plus($p("a"),Times($p("b",true),Power($p("x"),C2)))),Power(Sqrt(Plus($p("c"),Times($p("d",true),Power($p("x"),C2)))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Sqrt(Times($s("a"),Power($s("c"),CN1))),Times(EllipticE(ArcSin(Times(Rt(Times(Times(CN1,$s("d")),Power($s("c"),CN1)),C2),$s("x"))),Times($s("b"),Times($s("c"),Power(Times($s("a"),$s("d")),CN1)))),Power(Rt(Times(Times(CN1,$s("d")),Power($s("c"),CN1)),C2),CN1))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),PositiveQ($s("a"))),PositiveQ($s("c"))))),
SetDelayed(Int(Times(Sqrt(Plus($p("a"),Times($p("b",true),Power($p("x"),C2)))),Power(Sqrt(Plus($p("c"),Times($p("d",true),Power($p("x"),C2)))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Times(Sqrt(Plus($s("a"),Times($s("b"),Power($s("x"),C2)))),Sqrt(Times(Plus($s("c"),Times($s("d"),Power($s("x"),C2))),Power($s("c"),CN1)))),Times(EllipticE(ArcSin(Times(Rt(Times(Times(CN1,$s("d")),Power($s("c"),CN1)),C2),$s("x"))),Times($s("b"),Times($s("c"),Power(Times($s("a"),$s("d")),CN1)))),Power(Times(Times(Rt(Times(Times(CN1,$s("d")),Power($s("c"),CN1)),C2),Sqrt(Times(Plus($s("a"),Times($s("b"),Power($s("x"),C2))),Power($s("a"),CN1)))),Sqrt(Plus($s("c"),Times($s("d"),Power($s("x"),C2))))),CN1))),FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")))),
SetDelayed(Int(Times(Power(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n")))),$p("p")),Power(Plus($p("c",true),Times($p("d",true),Power($p("x"),$p("n")))),$p("q",true))),$p("x",$s("Symbol"))),
    Condition(Dist(Times($s("b"),Power($s("d"),CN1)),Int(Times(Power(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))),Plus($s("p"),Times(CN1,C1))),Power(Plus($s("c"),Times($s("d"),Power($s("x"),$s("n")))),Plus($s("q"),C1))),$s("x"))),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("n")),$s("x")),RationalQ(List($s("p"),$s("q")))),Greater($s("p"),C0)),LessEqual($s("q"),CN1)),ZeroQ(Plus(Times($s("a"),$s("d")),Times(CN1,Times($s("b"),$s("c")))))))),
SetDelayed(Int(Times(Power(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n")))),$p("p")),Power(Plus($p("c",true),Times($p("d",true),Power($p("x"),$p("n")))),$p("q",true))),$p("x",$s("Symbol"))),
    Condition(Plus(Dist(Times(Plus(Times($s("a"),$s("d")),Times(CN1,Times($s("b"),$s("c")))),Power($s("d"),CN1)),Int(Times(Power(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))),Plus($s("p"),Times(CN1,C1))),Power(Plus($s("c"),Times($s("d"),Power($s("x"),$s("n")))),$s("q"))),$s("x"))),Dist(Times($s("b"),Power($s("d"),CN1)),Int(Times(Power(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))),Plus($s("p"),Times(CN1,C1))),Power(Plus($s("c"),Times($s("d"),Power($s("x"),$s("n")))),Plus($s("q"),C1))),$s("x")))),And(And(And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("n")),$s("x")),RationalQ(List($s("p"),$s("q")))),Greater($s("p"),C0)),LessEqual($s("q"),CN1)),NonzeroQ(Plus(Times($s("a"),$s("d")),Times(CN1,Times($s("b"),$s("c")))))),IntegerQ($s("n"))),Greater($s("n"),C0)))),
SetDelayed(Int(Times(Power(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n")))),$p("p",true)),Power(Plus($p("c",true),Times($p("d",true),Power($p("x"),$p("n")))),$p("q",true))),$p("x",$s("Symbol"))),
    Condition(Plus(Dist(Times($s("b"),Power(Plus(Times($s("b"),$s("c")),Times(CN1,Times($s("a"),$s("d")))),CN1)),Int(Times(Power(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))),$s("p")),Power(Plus($s("c"),Times($s("d"),Power($s("x"),$s("n")))),Plus($s("q"),C1))),$s("x"))),Times(CN1,Dist(Times($s("d"),Power(Plus(Times($s("b"),$s("c")),Times(CN1,Times($s("a"),$s("d")))),CN1)),Int(Times(Power(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))),Plus($s("p"),C1)),Power(Plus($s("c"),Times($s("d"),Power($s("x"),$s("n")))),$s("q"))),$s("x"))))),And(And(And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("n")),$s("x")),RationalQ(List($s("p"),$s("q")))),Less($s("p"),CN1)),LessEqual($s("q"),CN1)),NonzeroQ(Plus(Times($s("b"),$s("c")),Times(CN1,Times($s("a"),$s("d")))))),IntegerQ($s("n"))),Greater($s("n"),C0)))),
SetDelayed(Int(Times(Power($p("x"),C2),Power(Times(Sqrt(Plus($p("a"),Times($p("b",true),Power($p("x"),C2)))),Sqrt(Plus($p("c"),Times($p("d",true),Power($p("x"),C2))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Dist(Times(C1,Power($s("b"),CN1)),Int(Times(Sqrt(Plus($s("a"),Times($s("b"),Power($s("x"),C2)))),Power(Sqrt(Plus($s("c"),Times($s("d"),Power($s("x"),C2)))),CN1)),$s("x"))),Times(CN1,Dist(Times($s("a"),Power($s("b"),CN1)),Int(Times(C1,Power(Times(Sqrt(Plus($s("a"),Times($s("b"),Power($s("x"),C2)))),Sqrt(Plus($s("c"),Times($s("d"),Power($s("x"),C2))))),CN1)),$s("x"))))),FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")))),
SetDelayed(Int(Times(Power($p("x"),C2),Times(Sqrt(Plus($p("a"),Times($p("b",true),Power($p("x"),C2)))),Power(Sqrt(Plus($p("c"),Times($p("d",true),Power($p("x"),C2)))),CN1))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times($s("x"),Sqrt(Plus($s("a"),Times($s("b"),Power($s("x"),C2))))),Times(Sqrt(Plus($s("c"),Times($s("d"),Power($s("x"),C2)))),Power(Times(C3,$s("d")),CN1))),Times(CN1,Dist(Times(C1,Power(Times(C3,$s("d")),CN1)),Int(Times(Plus(Times($s("a"),$s("c")),Times(Plus(Times(Times(C2,$s("b")),$s("c")),Times(CN1,Times($s("a"),$s("d")))),Power($s("x"),C2))),Power(Times(Sqrt(Plus($s("a"),Times($s("b"),Power($s("x"),C2)))),Sqrt(Plus($s("c"),Times($s("d"),Power($s("x"),C2))))),CN1)),$s("x"))))),FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")))),
SetDelayed(Int(Times(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n",true)))),Power(Times($p("x"),Plus($p("c"),Times($p("d",true),Power($p("x"),$p("p",true))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Times($s("a"),Times(Log($s("x")),Power($s("c"),CN1))),Dist(Times(C1,Power($s("c"),CN1)),Int(Times(Power($s("x"),Plus($s("n"),Times(CN1,C1))),Times(Plus(Times($s("b"),$s("c")),Times(CN1,Times(Times($s("a"),$s("d")),Power($s("x"),Plus($s("p"),Times(CN1,$s("n"))))))),Power(Plus($s("c"),Times($s("d"),Power($s("x"),$s("p")))),CN1))),$s("x")))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),FractionQ(List($s("n"),$s("p")))),And(Less(C0,$s("n")),LessEqual($s("n"),$s("p")))))),
SetDelayed(Int(Times(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n",true)))),Power(Times($p("x"),Plus($p("c"),Times($p("d",true),Power($p("x"),$p("p",true))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Times($s("a"),Times(Log($s("x")),Power($s("c"),CN1))),Dist(Times(C1,Power($s("c"),CN1)),Int(Times(Power($s("x"),Plus($s("p"),Times(CN1,C1))),Times(Plus(Times(Times(CN1,$s("a")),$s("d")),Times(Times($s("b"),$s("c")),Power($s("x"),Plus($s("n"),Times(CN1,$s("p")))))),Power(Plus($s("c"),Times($s("d"),Power($s("x"),$s("p")))),CN1))),$s("x")))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),FractionQ(List($s("n"),$s("p")))),Less(Less(C0,$s("p")),$s("n"))))),
SetDelayed(Int(Times(Power($p("x"),$p("m")),Times(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n",true)))),Power(Plus($p("c"),Times($p("d",true),Power($p("x"),$p("p",true)))),CN1))),$p("x",$s("Symbol"))),
    Condition(Plus(Times($s("a"),Times(Power($s("x"),Plus($s("m"),C1)),Power(Times($s("c"),Plus($s("m"),C1)),CN1))),Dist(Times(C1,Power($s("c"),CN1)),Int(Times(Power($s("x"),Plus($s("m"),$s("n"))),Times(Plus(Times($s("b"),$s("c")),Times(CN1,Times(Times($s("a"),$s("d")),Power($s("x"),Plus($s("p"),Times(CN1,$s("n"))))))),Power(Plus($s("c"),Times($s("d"),Power($s("x"),$s("p")))),CN1))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),FractionQ(List($s("m"),$s("n"),$s("p")))),Less($s("m"),CN1)),And(Less(C0,$s("n")),LessEqual($s("n"),$s("p")))))),
SetDelayed(Int(Times(Power($p("x"),$p("m")),Times(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n",true)))),Power(Plus($p("c"),Times($p("d",true),Power($p("x"),$p("p",true)))),CN1))),$p("x",$s("Symbol"))),
    Condition(Plus(Times($s("a"),Times(Power($s("x"),Plus($s("m"),C1)),Power(Times($s("c"),Plus($s("m"),C1)),CN1))),Dist(Times(C1,Power($s("c"),CN1)),Int(Times(Power($s("x"),Plus($s("m"),$s("p"))),Times(Plus(Times(Times(CN1,$s("a")),$s("d")),Times(Times($s("b"),$s("c")),Power($s("x"),Plus($s("n"),Times(CN1,$s("p")))))),Power(Plus($s("c"),Times($s("d"),Power($s("x"),$s("p")))),CN1))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),FractionQ(List($s("m"),$s("n"),$s("p")))),Less($s("m"),CN1)),And(Less(C0,$s("p")),LessEqual($s("p"),$s("n")))))),
SetDelayed(Int(Power(Plus(Plus($p("a"),Times($p("b",true),$p("x"))),Times($p("c",true),Power($p("x"),C2))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Int(Regularize(Power(Times(Power(Plus(Times($s("b"),C1D2),Times($s("c"),$s("x"))),C2),Power($s("c"),CN1)),$s("n")),$s("x")),$s("x")),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("n")),$s("x")),Not(IntegerQ($s("n")))),ZeroQ(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c")))))))),
SetDelayed(Int(Times($p("u"),Power(Plus(Plus($p("a"),Times($p("b",true),$p("x"))),Times($p("c",true),Power($p("x"),C2))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Int(Regularize(Times($s("u"),Power(Times(Power(Plus(Times($s("b"),C1D2),Times($s("c"),$s("x"))),C2),Power($s("c"),CN1)),$s("n"))),$s("x")),$s("x")),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("n")),$s("x")),Not(IntegerQ($s("n")))),ZeroQ(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c")))))),Or(MonomialQ($s("u"),$s("x")),LinearQ($s("u"),$s("x")))))),
SetDelayed(Int(Times(C1,Power(Sqrt(Plus(Plus($p("a",true),Times($p("b",true),$p("x"))),Times($p("c",true),Power($p("x"),C2)))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(ArcSinh(Times(Plus($s("b"),Times(Times(C2,$s("c")),$s("x"))),Power(Times(Sqrt(Plus(Times(C4,$s("a")),Times(CN1,Times(Power($s("b"),C2),Power($s("c"),CN1))))),Rt($s("c"),C2)),CN1))),Power(Rt($s("c"),C2),CN1)),And(And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),PositiveQ(Plus(Times(C4,$s("a")),Times(CN1,Times(Power($s("b"),C2),Power($s("c"),CN1)))))),PosQ($s("c"))))),
SetDelayed(Int(Times(C1,Power(Sqrt(Plus(Plus($p("a",true),Times($p("b",true),$p("x"))),Times($p("c",true),Power($p("x"),C2)))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Times(CN1,ArcSin(Times(Plus($s("b"),Times(Times(C2,$s("c")),$s("x"))),Power(Times(Sqrt(Plus(Times(C4,$s("a")),Times(CN1,Times(Power($s("b"),C2),Power($s("c"),CN1))))),Rt(Times(CN1,$s("c")),C2)),CN1)))),Power(Rt(Times(CN1,$s("c")),C2),CN1)),And(And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),PositiveQ(Plus(Times(C4,$s("a")),Times(CN1,Times(Power($s("b"),C2),Power($s("c"),CN1)))))),NegQ($s("c"))))),
SetDelayed(Int(Times(C1,Power(Sqrt(Plus(Plus($p("a",true),Times($p("b",true),$p("x"))),Times($p("c",true),Power($p("x"),C2)))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(ArcTanh(Times(Times(Times(C2,Rt($s("c"),C2)),Sqrt(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))))),Power(Plus($s("b"),Times(Times(C2,$s("c")),$s("x"))),CN1))),Power(Rt($s("c"),C2),CN1)),And(And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),PosQ($s("c"))),NonzeroQ(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c")))))))),
SetDelayed(Int(Times(C1,Power(Sqrt(Plus(Plus($p("a",true),Times($p("b",true),$p("x"))),Times($p("c",true),Power($p("x"),C2)))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(ArcTan(Times(Times(Times(C2,Rt(Times(CN1,$s("c")),C2)),Sqrt(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))))),Power(Plus($s("b"),Times(Times(C2,$s("c")),$s("x"))),CN1))),Power(Rt(Times(CN1,$s("c")),C2),CN1)),And(And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),NegQ($s("c"))),NonzeroQ(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c")))))))),
SetDelayed(Int(Times(C1,Power(Times(Plus($p("d",true),Times($p("e",true),$p("x"))),Sqrt(Plus($p("a",true),Times($p("c",true),Power($p("x"),C2))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Module(List(Set($s("q"),Plus(Times($s("c"),Power($s("d"),C2)),Times($s("a"),Power($s("e"),C2))))),Condition(Times(Times(CN1,ArcTanh(Times(Times(Rt($s("q"),C2),Sqrt(Plus($s("a"),Times($s("c"),Power($s("x"),C2))))),Power(Plus(Times($s("a"),$s("e")),Times(CN1,Times(Times($s("c"),$s("d")),$s("x")))),CN1)))),Power(Rt($s("q"),C2),CN1)),PosQ($s("q")))),FreeQ(List($s("a"),$s("c"),$s("d"),$s("e")),$s("x")))),
SetDelayed(Int(Times(C1,Power(Times(Plus($p("d",true),Times($p("e",true),$p("x"))),Sqrt(Plus($p("a",true),Times($p("c",true),Power($p("x"),C2))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Module(List(Set($s("q"),Plus(Times($s("c"),Power($s("d"),C2)),Times($s("a"),Power($s("e"),C2))))),Condition(Times(Times(CN1,ArcTan(Times(Times(Rt(Times(CN1,$s("q")),C2),Sqrt(Plus($s("a"),Times($s("c"),Power($s("x"),C2))))),Power(Plus(Times($s("a"),$s("e")),Times(CN1,Times(Times($s("c"),$s("d")),$s("x")))),CN1)))),Power(Rt(Times(CN1,$s("q")),C2),CN1)),NegQ($s("q")))),FreeQ(List($s("a"),$s("c"),$s("d"),$s("e")),$s("x")))),
SetDelayed(Int(Times(C1,Power(Times(Plus($p("d",true),Times($p("e",true),$p("x"))),Sqrt(Plus(Plus($p("a",true),Times($p("b",true),$p("x"))),Times($p("c",true),Power($p("x"),C2))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Times(integer(-2L),$s("e")),Times(Sqrt(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2)))),Power(Times(Plus(Times($s("b"),$s("e")),Times(CN1,Times(Times(C2,$s("c")),$s("d")))),Plus($s("d"),Times($s("e"),$s("x")))),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e")),$s("x")),ZeroQ(Plus(Plus(Times($s("c"),Power($s("d"),C2)),Times(CN1,Times(Times($s("b"),$s("d")),$s("e")))),Times($s("a"),Power($s("e"),C2))))))),
SetDelayed(Int(Times(C1,Power(Times(Plus($p("d",true),Times($p("e",true),$p("x"))),Sqrt(Plus(Plus($p("a",true),Times($p("b",true),$p("x"))),Times($p("c",true),Power($p("x"),C2))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Module(List(Set($s("q"),Plus(Plus(Times($s("c"),Power($s("d"),C2)),Times(CN1,Times(Times($s("b"),$s("d")),$s("e")))),Times($s("a"),Power($s("e"),C2))))),Condition(Times(Times(CN1,ArcTanh(Times(Times(Times(C2,Rt($s("q"),C2)),Sqrt(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))))),Power(Plus(Plus(Times(Times(C2,$s("a")),$s("e")),Times(CN1,Times($s("b"),$s("d")))),Times(Plus(Times($s("b"),$s("e")),Times(CN1,Times(Times(C2,$s("c")),$s("d")))),$s("x"))),CN1)))),Power(Rt($s("q"),C2),CN1)),PosQ($s("q")))),FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e")),$s("x")))),
SetDelayed(Int(Times(C1,Power(Times(Plus($p("d",true),Times($p("e",true),$p("x"))),Sqrt(Plus(Plus($p("a",true),Times($p("b",true),$p("x"))),Times($p("c",true),Power($p("x"),C2))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Module(List(Set($s("q"),Plus(Plus(Times($s("c"),Power($s("d"),C2)),Times(CN1,Times(Times($s("b"),$s("d")),$s("e")))),Times($s("a"),Power($s("e"),C2))))),Condition(Times(Times(CN1,ArcTan(Times(Times(Times(C2,Rt(Times(CN1,$s("q")),C2)),Sqrt(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))))),Power(Plus(Plus(Times(Times(C2,$s("a")),$s("e")),Times(CN1,Times($s("b"),$s("d")))),Times(Plus(Times($s("b"),$s("e")),Times(CN1,Times(Times(C2,$s("c")),$s("d")))),$s("x"))),CN1)))),Power(Rt(Times(CN1,$s("q")),C2),CN1)),NegQ($s("q")))),FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e")),$s("x")))),
SetDelayed(Int(Power(Plus(Plus($p("a",true),Times($p("b",true),$p("x"))),Times($p("c",true),Power($p("x"),C2))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Plus($s("b"),Times(Times(C2,$s("c")),$s("x"))),Times(Power(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))),$s("n")),Power(Times(Times(C2,$s("c")),Plus(Times(C2,$s("n")),C1)),CN1))),Times(CN1,Dist(Times($s("n"),Times(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c")))),Power(Times(Times(C2,$s("c")),Plus(Times(C2,$s("n")),C1)),CN1))),Int(Power(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))),Plus($s("n"),Times(CN1,C1))),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),FractionQ($s("n"))),Greater($s("n"),C0)))),
SetDelayed(Int(Times(Power($p("x"),$p("m")),Power(Plus(Plus($p("a",true),Times($p("b",true),$p("x"))),Times($p("c",true),Power($p("x"),C2))),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus($s("m"),Times(CN1,C1))),Power(Times($s("c"),Plus($s("m"),Times(CN1,C1))),CN1)),Times(CN1,Dist(Times(C1,Power($s("c"),CN1)),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,C2))),Times(Plus($s("a"),Times($s("b"),$s("x"))),Power(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))),CN1))),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),FractionQ($s("m"))),Greater($s("m"),C1)))),
SetDelayed(Int(Times(Power($p("x"),$p("m")),Power(Plus(Times($p("b",true),$p("x")),Times($p("c",true),Power($p("x"),C2))),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),$s("m")),Power(Times($s("b"),$s("m")),CN1)),Times(CN1,Dist(Times($s("c"),Power($s("b"),CN1)),Int(Times(Power($s("x"),Plus($s("m"),C1)),Power(Plus(Times($s("b"),$s("x")),Times($s("c"),Power($s("x"),C2))),CN1)),$s("x"))))),And(And(FreeQ(List($s("b"),$s("c")),$s("x")),FractionQ($s("m"))),Less($s("m"),CN1)))),
SetDelayed(Int(Times(Power($p("x"),$p("m")),Power(Plus(Plus($p("a"),Times($p("b",true),$p("x"))),Times($p("c",true),Power($p("x"),C2))),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Power(Times($s("a"),Plus($s("m"),C1)),CN1)),Times(CN1,Dist(Times(C1,Power($s("a"),CN1)),Int(Times(Power($s("x"),Plus($s("m"),C1)),Times(Plus($s("b"),Times($s("c"),$s("x"))),Power(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))),CN1))),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),FractionQ($s("m"))),Less($s("m"),CN1)))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Times(Plus($p("d"),Times($p("e",true),$p("x"))),Power(Plus(Plus($p("a"),Times($p("b",true),$p("x"))),Times($p("c",true),Power($p("x"),C2))),CN1))),$p("x",$s("Symbol"))),
    Condition(Plus(Times($s("e"),Times(Power($s("x"),$s("m")),Power(Times($s("c"),$s("m")),CN1))),Times(CN1,Dist(Times(C1,Power($s("c"),CN1)),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,C1))),Times(Plus(Times($s("a"),$s("e")),Times(Plus(Times($s("b"),$s("e")),Times(CN1,Times($s("c"),$s("d")))),$s("x"))),Power(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))),CN1))),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e")),$s("x")),FractionQ($s("m"))),Greater($s("m"),C0)))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Times(Plus($p("d"),Times($p("e",true),$p("x"))),Power(Plus(Plus($p("a"),Times($p("b",true),$p("x"))),Times($p("c",true),Power($p("x"),C2))),CN1))),$p("x",$s("Symbol"))),
    Condition(Plus(Times($s("d"),Times(Power($s("x"),Plus($s("m"),C1)),Power(Times($s("a"),Plus($s("m"),C1)),CN1))),Times(CN1,Dist(Times(C1,Power($s("a"),CN1)),Int(Times(Power($s("x"),Plus($s("m"),C1)),Times(Plus(Plus(Times($s("b"),$s("d")),Times(CN1,Times($s("a"),$s("e")))),Times(Times($s("c"),$s("d")),$s("x"))),Power(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))),CN1))),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e")),$s("x")),FractionQ($s("m"))),Less($s("m"),CN1)))),
SetDelayed(Int(Times(Power(Plus(Plus($p("a",true),Times($p("b",true),$p("x"))),Times($p("c",true),Power($p("x"),C2))),$p("n")),Power(Plus($p("d",true),Times($p("e",true),$p("x"))),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))),$s("n")),Power(Times(Times(C2,$s("e")),$s("n")),CN1)),Dist(Times(Plus(Times($s("b"),$s("e")),Times(CN1,Times(Times(C2,$s("c")),$s("d")))),Power(Times(C2,Power($s("e"),C2)),CN1)),Int(Power(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))),Plus($s("n"),Times(CN1,C1))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e")),$s("x")),FractionQ($s("n"))),Greater($s("n"),C0)),ZeroQ(Plus(Plus(Times($s("c"),Power($s("d"),C2)),Times(CN1,Times(Times($s("b"),$s("d")),$s("e")))),Times($s("a"),Power($s("e"),C2))))))),
SetDelayed(Int(Times(Power(Plus(Plus($p("a",true),Times($p("b",true),$p("x"))),Times($p("c",true),Power($p("x"),C2))),$p("n")),Power(Plus($p("d",true),Times($p("e",true),$p("x"))),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))),$s("n")),Power(Times(Times(C2,$s("e")),$s("n")),CN1)),Dist(Times(Plus(Plus(Times($s("c"),Power($s("d"),C2)),Times(CN1,Times(Times($s("b"),$s("d")),$s("e")))),Times($s("a"),Power($s("e"),C2))),Power(Power($s("e"),C2),CN1)),Int(Times(Power(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))),Plus($s("n"),Times(CN1,C1))),Power(Plus($s("d"),Times($s("e"),$s("x"))),CN1)),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e")),$s("x")),FractionQ($s("n"))),Greater($s("n"),C0)),ZeroQ(Plus(Times($s("b"),$s("e")),Times(CN1,Times(Times(C2,$s("c")),$s("d")))))))),
SetDelayed(Int(Times(Power(Plus(Plus($p("a",true),Times($p("b",true),$p("x"))),Times($p("c",true),Power($p("x"),C2))),$p("n")),Power(Plus($p("d",true),Times($p("e",true),$p("x"))),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Power(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))),$s("n")),Power(Times(Times(C2,$s("e")),$s("n")),CN1)),Dist(Times(Plus(Times($s("b"),$s("e")),Times(CN1,Times(Times(C2,$s("c")),$s("d")))),Power(Times(C2,Power($s("e"),C2)),CN1)),Int(Power(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))),Plus($s("n"),Times(CN1,C1))),$s("x")))),Dist(Times(Plus(Plus(Times($s("c"),Power($s("d"),C2)),Times(CN1,Times(Times($s("b"),$s("d")),$s("e")))),Times($s("a"),Power($s("e"),C2))),Power(Power($s("e"),C2),CN1)),Int(Times(Power(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))),Plus($s("n"),Times(CN1,C1))),Power(Plus($s("d"),Times($s("e"),$s("x"))),CN1)),$s("x")))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e")),$s("x")),FractionQ($s("n"))),Greater($s("n"),C0)))),
SetDelayed(Int(Times(Power(Plus(Plus($p("a",true),Times($p("b",true),$p("x"))),Times($p("c",true),Power($p("x"),C2))),$p("n")),Power(Plus($p("d",true),Times($p("e",true),$p("x"))),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,$s("e")),Times(Power(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))),Plus($s("n"),C1)),Power(Times(Times(C2,Plus($s("n"),C1)),Plus(Plus(Times($s("c"),Power($s("d"),C2)),Times(CN1,Times(Times($s("b"),$s("d")),$s("e")))),Times($s("a"),Power($s("e"),C2)))),CN1))),Dist(Times(Power($s("e"),C2),Power(Plus(Plus(Times($s("c"),Power($s("d"),C2)),Times(CN1,Times(Times($s("b"),$s("d")),$s("e")))),Times($s("a"),Power($s("e"),C2))),CN1)),Int(Times(Power(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))),Plus($s("n"),C1)),Power(Plus($s("d"),Times($s("e"),$s("x"))),CN1)),$s("x")))),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e")),$s("x")),FractionQ($s("n"))),Less($s("n"),CN1)),NonzeroQ(Plus(Plus(Times($s("c"),Power($s("d"),C2)),Times(CN1,Times(Times($s("b"),$s("d")),$s("e")))),Times($s("a"),Power($s("e"),C2))))),ZeroQ(Plus(Times(Times(C2,$s("c")),$s("d")),Times(CN1,Times($s("b"),$s("e")))))))),
SetDelayed(Int(Times(Power(Plus(Plus($p("a",true),Times($p("b",true),$p("x"))),Times($p("c",true),Power($p("x"),C2))),$p("n")),Power(Plus($p("d",true),Times($p("e",true),$p("x"))),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(CN1,$s("e")),Times(Power(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))),Plus($s("n"),C1)),Power(Times(Times(C2,Plus($s("n"),C1)),Plus(Plus(Times($s("c"),Power($s("d"),C2)),Times(CN1,Times(Times($s("b"),$s("d")),$s("e")))),Times($s("a"),Power($s("e"),C2)))),CN1))),Dist(Times(Plus(Times(Times(C2,$s("c")),$s("d")),Times(CN1,Times($s("b"),$s("e")))),Power(Times(C2,Plus(Plus(Times($s("c"),Power($s("d"),C2)),Times(CN1,Times(Times($s("b"),$s("d")),$s("e")))),Times($s("a"),Power($s("e"),C2)))),CN1)),Int(Power(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))),$s("n")),$s("x")))),Dist(Times(Power($s("e"),C2),Power(Plus(Plus(Times($s("c"),Power($s("d"),C2)),Times(CN1,Times(Times($s("b"),$s("d")),$s("e")))),Times($s("a"),Power($s("e"),C2))),CN1)),Int(Times(Power(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))),Plus($s("n"),C1)),Power(Plus($s("d"),Times($s("e"),$s("x"))),CN1)),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e")),$s("x")),FractionQ($s("n"))),Less($s("n"),CN1)),NonzeroQ(Plus(Plus(Times($s("c"),Power($s("d"),C2)),Times(CN1,Times(Times($s("b"),$s("d")),$s("e")))),Times($s("a"),Power($s("e"),C2))))))),
SetDelayed(Int(Times(C1,Power(Sqrt(Plus(Plus($p("a"),Times($p("b",true),Power($p("x"),C2))),Times($p("c",true),Power($p("x"),C4)))),CN1)),$p("x",$s("Symbol"))),
    Condition(Module(List(Set($s("q"),Rt(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c")))),C2))),Times(Times(Sqrt(Plus(C1,Times(Times(C2,$s("c")),Times(Power($s("x"),C2),Power(Plus($s("b"),Times(CN1,$s("q"))),CN1))))),Times(Sqrt(Plus(C1,Times(Times(C2,$s("c")),Times(Power($s("x"),C2),Power(Plus($s("b"),$s("q")),CN1))))),Power(Sqrt(Plus(Plus($s("a"),Times($s("b"),Power($s("x"),C2))),Times($s("c"),Power($s("x"),C4)))),CN1))),Int(Times(C1,Power(Times(Sqrt(Plus(C1,Times(Times(C2,$s("c")),Times(Power($s("x"),C2),Power(Plus($s("b"),Times(CN1,$s("q"))),CN1))))),Sqrt(Plus(C1,Times(Times(C2,$s("c")),Times(Power($s("x"),C2),Power(Plus($s("b"),$s("q")),CN1)))))),CN1)),$s("x")))),And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),NonzeroQ(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c")))))))),
SetDelayed(Int(Times(Power($p("x"),C2),Power(Sqrt(Plus(Plus($p("a"),Times($p("b",true),Power($p("x"),C2))),Times($p("c",true),Power($p("x"),C4)))),CN1)),$p("x",$s("Symbol"))),
    Condition(Module(List(Set($s("q"),Rt(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c")))),C2))),Times(Times(Sqrt(Plus(C1,Times(Times(C2,$s("c")),Times(Power($s("x"),C2),Power(Plus($s("b"),Times(CN1,$s("q"))),CN1))))),Times(Sqrt(Plus(C1,Times(Times(C2,$s("c")),Times(Power($s("x"),C2),Power(Plus($s("b"),$s("q")),CN1))))),Power(Sqrt(Plus(Plus($s("a"),Times($s("b"),Power($s("x"),C2))),Times($s("c"),Power($s("x"),C4)))),CN1))),Int(Times(Power($s("x"),C2),Power(Times(Sqrt(Plus(C1,Times(Times(C2,$s("c")),Times(Power($s("x"),C2),Power(Plus($s("b"),Times(CN1,$s("q"))),CN1))))),Sqrt(Plus(C1,Times(Times(C2,$s("c")),Times(Power($s("x"),C2),Power(Plus($s("b"),$s("q")),CN1)))))),CN1)),$s("x")))),And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),NonzeroQ(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c")))))))),
SetDelayed(Int(Times(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("k")))),Power(Plus(Plus(Plus($p("c"),Times($p("d",true),Power($p("x"),C2))),Times($p("e",true),Power($p("x"),$p("k")))),Times($p("f",true),Power($p("x"),$p("j")))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Times($s("a"),Power(Rt(Times($s("c"),$s("d")),C2),CN1)),ArcTan(Times(Times(Times(Plus($s("k"),Times(CN1,C1)),$s("a")),Rt(Times($s("c"),$s("d")),C2)),Times($s("x"),Power(Times($s("c"),Plus(Times(Plus($s("k"),Times(CN1,C1)),$s("a")),Times(CN1,Times($s("b"),Power($s("x"),$s("k")))))),CN1))))),And(And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e"),$s("f"),$s("j"),$s("k")),$s("x")),Not(IntegerQ($s("k")))),SameQ($s("j"),Times(C2,$s("k")))),ZeroQ(Plus(Times(Times(Power(Plus($s("k"),Times(CN1,C1)),C2),Power($s("a"),C2)),$s("f")),Times(CN1,Times(Power($s("b"),C2),$s("c")))))),ZeroQ(Plus(Times($s("b"),$s("e")),Times(Times(Times(C2,Plus($s("k"),Times(CN1,C1))),$s("a")),$s("f"))))),PosQ(Times($s("c"),$s("d")))))),
SetDelayed(Int(Times(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("k")))),Power(Plus(Plus(Plus($p("c"),Times($p("d",true),Power($p("x"),C2))),Times($p("e",true),Power($p("x"),$p("k")))),Times($p("f",true),Power($p("x"),$p("j")))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Times($s("a"),Power(Rt(Times(Times(CN1,$s("c")),$s("d")),C2),CN1)),ArcTanh(Times(Times(Times(Plus($s("k"),Times(CN1,C1)),$s("a")),Rt(Times(Times(CN1,$s("c")),$s("d")),C2)),Times($s("x"),Power(Times($s("c"),Plus(Times(Plus($s("k"),Times(CN1,C1)),$s("a")),Times(CN1,Times($s("b"),Power($s("x"),$s("k")))))),CN1))))),And(And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e"),$s("f"),$s("j"),$s("k")),$s("x")),Not(IntegerQ($s("k")))),SameQ($s("j"),Times(C2,$s("k")))),ZeroQ(Plus(Times(Times(Power(Plus($s("k"),Times(CN1,C1)),C2),Power($s("a"),C2)),$s("f")),Times(CN1,Times(Power($s("b"),C2),$s("c")))))),ZeroQ(Plus(Times($s("b"),$s("e")),Times(Times(Times(C2,Plus($s("k"),Times(CN1,C1))),$s("a")),$s("f"))))),NegQ(Times($s("c"),$s("d")))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Times(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("n",true)))),Power(Plus(Plus(Plus($p("c"),Times($p("d",true),Power($p("x"),$p("k",true)))),Times($p("e",true),Power($p("x"),$p("n",true)))),Times($p("f",true),Power($p("x"),$p("j")))),CN1))),$p("x",$s("Symbol"))),
    Condition(Times($s("a"),Times(ArcTan(Times(Times(Times(Plus(Plus($s("m"),Times(CN1,$s("n"))),C1),$s("a")),Rt(Times($s("c"),$s("d")),C2)),Times(Power($s("x"),Plus($s("m"),C1)),Power(Times($s("c"),Plus(Times(Plus(Plus($s("m"),Times(CN1,$s("n"))),C1),$s("a")),Times(Times(Plus($s("m"),C1),$s("b")),Power($s("x"),$s("n"))))),CN1)))),Power(Times(Plus($s("m"),C1),Rt(Times($s("c"),$s("d")),C2)),CN1))),And(And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e"),$s("f"),$s("j"),$s("k"),$s("m"),$s("n")),$s("x")),ZeroQ(Plus($s("k"),Times(CN1,Times(C2,Plus($s("m"),C1)))))),ZeroQ(Plus($s("j"),Times(CN1,Times(C2,$s("n")))))),ZeroQ(Plus(Times(Times(Power(Plus(Plus($s("m"),Times(CN1,$s("n"))),C1),C2),Power($s("a"),C2)),$s("f")),Times(CN1,Times(Times(Power(Plus($s("m"),C1),C2),Power($s("b"),C2)),$s("c")))))),ZeroQ(Plus(Times(Times(Plus($s("m"),C1),$s("b")),$s("e")),Times(CN1,Times(Times(Times(C2,Plus(Plus($s("m"),Times(CN1,$s("n"))),C1)),$s("a")),$s("f")))))),PosQ(Times($s("c"),$s("d")))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Times(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("n",true)))),Power(Plus(Plus(Plus($p("c"),Times($p("d",true),Power($p("x"),$p("k",true)))),Times($p("e",true),Power($p("x"),$p("n",true)))),Times($p("f",true),Power($p("x"),$p("j")))),CN1))),$p("x",$s("Symbol"))),
    Condition(Times($s("a"),Times(ArcTanh(Times(Times(Times(Plus(Plus($s("m"),Times(CN1,$s("n"))),C1),$s("a")),Rt(Times(Times(CN1,$s("c")),$s("d")),C2)),Times(Power($s("x"),Plus($s("m"),C1)),Power(Times($s("c"),Plus(Times(Plus(Plus($s("m"),Times(CN1,$s("n"))),C1),$s("a")),Times(Times(Plus($s("m"),C1),$s("b")),Power($s("x"),$s("n"))))),CN1)))),Power(Times(Plus($s("m"),C1),Rt(Times(Times(CN1,$s("c")),$s("d")),C2)),CN1))),And(And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e"),$s("f"),$s("j"),$s("k"),$s("m"),$s("n")),$s("x")),ZeroQ(Plus($s("k"),Times(CN1,Times(C2,Plus($s("m"),C1)))))),ZeroQ(Plus($s("j"),Times(CN1,Times(C2,$s("n")))))),ZeroQ(Plus(Times(Times(Power(Plus(Plus($s("m"),Times(CN1,$s("n"))),C1),C2),Power($s("a"),C2)),$s("f")),Times(CN1,Times(Times(Power(Plus($s("m"),C1),C2),Power($s("b"),C2)),$s("c")))))),ZeroQ(Plus(Times(Times(Plus($s("m"),C1),$s("b")),$s("e")),Times(CN1,Times(Times(Times(C2,Plus(Plus($s("m"),Times(CN1,$s("n"))),C1)),$s("a")),$s("f")))))),NegQ(Times($s("c"),$s("d")))))),
SetDelayed(Int(Times(C1,Power(Plus(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("k")))),Times($p("c",true),Power($p("x"),$p("j",true)))),CN1)),$p("x",$s("Symbol"))),
    Condition(Module(List(Set($s("q"),Rt(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c")))),C2))),Plus(Dist(Times(C2,Times($s("c"),Power($s("q"),CN1))),Int(Times(C1,Power(Plus(Plus($s("b"),Times(CN1,$s("q"))),Times(Times(C2,$s("c")),Power($s("x"),$s("k")))),CN1)),$s("x"))),Times(CN1,Dist(Times(C2,Times($s("c"),Power($s("q"),CN1))),Int(Times(C1,Power(Plus(Plus($s("b"),$s("q")),Times(Times(C2,$s("c")),Power($s("x"),$s("k")))),CN1)),$s("x")))))),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("j"),$s("k")),$s("x")),Not(IntegerQ($s("k")))),SameQ($s("j"),Times(C2,$s("k")))),NonzeroQ(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c")))))),Not(NegativeQ(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c"))))))))),
SetDelayed(Int(Times(C1,Power(Plus(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("k")))),Times($p("c",true),Power($p("x"),$p("j")))),CN1)),$p("x",$s("Symbol"))),
    Condition(Module(List(Set($s("q"),Plus(Times(C2,Rt(Times($s("a"),Power($s("c"),CN1)),C2)),Times(CN1,Times($s("b"),Power($s("c"),CN1)))))),Condition(Plus(Dist(Times(C1,Power(Times(Times(Times(C2,$s("c")),Rt(Times($s("a"),Power($s("c"),CN1)),C2)),Rt($s("q"),C2)),CN1)),Int(Times(Plus(Rt($s("q"),C2),Power($s("x"),Times($s("k"),C1D2))),Power(Plus(Plus(Rt(Times($s("a"),Power($s("c"),CN1)),C2),Times(Rt($s("q"),C2),Power($s("x"),Times($s("k"),C1D2)))),Power($s("x"),$s("k"))),CN1)),$s("x"))),Dist(Times(C1,Power(Times(Times(Times(C2,$s("c")),Rt(Times($s("a"),Power($s("c"),CN1)),C2)),Rt($s("q"),C2)),CN1)),Int(Times(Plus(Rt($s("q"),C2),Times(CN1,Power($s("x"),Times($s("k"),C1D2)))),Power(Plus(Plus(Rt(Times($s("a"),Power($s("c"),CN1)),C2),Times(CN1,Times(Rt($s("q"),C2),Power($s("x"),Times($s("k"),C1D2))))),Power($s("x"),$s("k"))),CN1)),$s("x")))),PosQ($s("q")))),And(And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),EvenQ($s("k"))),Greater($s("k"),C0)),SameQ($s("j"),Times(C2,$s("k")))),PosQ(Times($s("a"),Power($s("c"),CN1)))),NegativeQ(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c")))))))),
SetDelayed(Int(Power(Plus(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("k")))),Times($p("c",true),Power($p("x"),$p("j",true)))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(Times(CN1,$s("x")),Plus(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C2,$s("a")),$s("c")))),Times(Times($s("b"),$s("c")),Power($s("x"),$s("k"))))),Times(Power(Plus(Plus($s("a"),Times($s("b"),Power($s("x"),$s("k")))),Times($s("c"),Power($s("x"),$s("j")))),Plus($s("n"),C1)),Power(Times(Times(Times($s("k"),$s("a")),Plus($s("n"),C1)),Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c"))))),CN1))),Dist(Times(Plus(Plus(Times(Times($s("k"),Plus($s("n"),C1)),Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c"))))),Power($s("b"),C2)),Times(CN1,Times(Times(C2,$s("a")),$s("c")))),Power(Times(Times(Times($s("k"),$s("a")),Plus($s("n"),C1)),Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c"))))),CN1)),Int(Power(Plus(Plus($s("a"),Times($s("b"),Power($s("x"),$s("k")))),Times($s("c"),Power($s("x"),$s("j")))),Plus($s("n"),C1)),$s("x")))),Dist(Times(Times(Plus(Times($s("k"),Plus(Times(C2,$s("n")),C3)),C1),$s("b")),Times($s("c"),Power(Times(Times(Times($s("k"),$s("a")),Plus($s("n"),C1)),Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c"))))),CN1))),Int(Times(Power($s("x"),$s("k")),Power(Plus(Plus($s("a"),Times($s("b"),Power($s("x"),$s("k")))),Times($s("c"),Power($s("x"),$s("j")))),Plus($s("n"),C1))),$s("x")))),And(And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("j"),$s("k")),$s("x")),RationalQ($s("n"))),Not(IntegerQ($s("k")))),SameQ($s("j"),Times(C2,$s("k")))),Less($s("n"),CN1)),NonzeroQ(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c")))))))),
SetDelayed(Int(Times(C1,Power(Times($p("x"),Sqrt(Plus(Times($p("b",true),Power($p("x"),$p("k",true))),Times($p("c",true),Power($p("x"),$p("j",true)))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(integer(-2L),Times(Sqrt(Plus(Times($s("b"),Power($s("x"),$s("k"))),Times($s("c"),Power($s("x"),$s("j"))))),Power(Times(Times($s("b"),$s("k")),Power($s("x"),$s("k"))),CN1))),And(FreeQ(List($s("b"),$s("c"),$s("j"),$s("k")),$s("x")),SameQ($s("j"),Times(C2,$s("k")))))),
SetDelayed(Int(Times(C1,Power(Times($p("x"),Sqrt(Plus(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("k",true)))),Times($p("c",true),Power($p("x"),$p("j",true)))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Times(CN1,ArcTanh(Times(Plus(Times(C2,$s("a")),Times($s("b"),Power($s("x"),$s("k")))),Power(Times(Times(C2,Rt($s("a"),C2)),Sqrt(Plus(Plus($s("a"),Times($s("b"),Power($s("x"),$s("k")))),Times($s("c"),Power($s("x"),$s("j")))))),CN1)))),Power(Times($s("k"),Rt($s("a"),C2)),CN1)),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("j"),$s("k")),$s("x")),SameQ($s("j"),Times(C2,$s("k")))),PosQ($s("a"))))),
SetDelayed(Int(Times(C1,Power(Times($p("x"),Sqrt(Plus(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("k",true)))),Times($p("c",true),Power($p("x"),$p("j",true)))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(ArcTan(Times(Plus(Times(C2,$s("a")),Times($s("b"),Power($s("x"),$s("k")))),Power(Times(Times(C2,Rt(Times(CN1,$s("a")),C2)),Sqrt(Plus(Plus($s("a"),Times($s("b"),Power($s("x"),$s("k")))),Times($s("c"),Power($s("x"),$s("j")))))),CN1))),Power(Times($s("k"),Rt(Times(CN1,$s("a")),C2)),CN1)),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("j"),$s("k")),$s("x")),SameQ($s("j"),Times(C2,$s("k")))),NegQ($s("a"))))),
SetDelayed(Int(Times(C1,Power(Times($p("x"),Plus(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("k")))),Times($p("c",true),Power($p("x"),$p("j",true))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Log($s("x")),Power($s("a"),CN1)),Times(CN1,Dist(Times(C1,Power(Times($s("a"),$s("k")),CN1)),Subst(Int(Times(Plus($s("b"),Times($s("c"),$s("x"))),Power(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))),CN1)),$s("x")),$s("x"),Power($s("x"),$s("k")))))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("j"),$s("k")),$s("x")),Not(IntegerQ($s("k")))),SameQ($s("j"),Times(C2,$s("k")))))),
SetDelayed(Int(Times(Power($p("x"),$p("k")),Power(Plus(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("k")))),Times($p("c",true),Power($p("x"),$p("j",true)))),CN1)),$p("x",$s("Symbol"))),
    Condition(Module(List(Set($s("q"),Rt(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c")))),C2))),Plus(Dist(Plus(C1,Times(CN1,Times($s("b"),Power($s("q"),CN1)))),Int(Times(C1,Power(Plus(Plus($s("b"),Times(CN1,$s("q"))),Times(Times(C2,$s("c")),Power($s("x"),$s("k")))),CN1)),$s("x"))),Dist(Plus(C1,Times($s("b"),Power($s("q"),CN1))),Int(Times(C1,Power(Plus(Plus($s("b"),$s("q")),Times(Times(C2,$s("c")),Power($s("x"),$s("k")))),CN1)),$s("x"))))),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("j"),$s("k")),$s("x")),Not(IntegerQ($s("k")))),SameQ($s("j"),Times(C2,$s("k")))),NonzeroQ(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c")))))),Not(NegativeQ(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c"))))))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Plus(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("k")))),Times($p("c",true),Power($p("x"),$p("j")))),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus(Plus($s("m"),Times(CN1,$s("j"))),C1)),Power(Times($s("c"),Plus(Plus($s("m"),Times(CN1,$s("j"))),C1)),CN1)),Times(CN1,Dist(Times(C1,Power($s("c"),CN1)),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,$s("j")))),Times(Plus($s("a"),Times($s("b"),Power($s("x"),$s("k")))),Power(Plus(Plus($s("a"),Times($s("b"),Power($s("x"),$s("k")))),Times($s("c"),Power($s("x"),$s("j")))),CN1))),$s("x"))))),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("j"),$s("k")),$s("x")),Not(IntegerQ($s("k")))),SameQ($s("j"),Times(C2,$s("k")))),RationalQ(List($s("m"),$s("k")))),Less(Less(C0,$s("j")),Plus($s("m"),C1))))),
SetDelayed(Int(Times(Power($p("x"),$p("m")),Power(Plus(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("k")))),Times($p("c",true),Power($p("x"),$p("j")))),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Power(Times($s("a"),Plus($s("m"),C1)),CN1)),Times(CN1,Dist(Times(C1,Power($s("a"),CN1)),Int(Times(Power($s("x"),Plus($s("m"),$s("k"))),Times(Plus($s("b"),Times($s("c"),Power($s("x"),$s("k")))),Power(Plus(Plus($s("a"),Times($s("b"),Power($s("x"),$s("k")))),Times($s("c"),Power($s("x"),$s("j")))),CN1))),$s("x"))))),And(And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("j"),$s("k")),$s("x")),Not(IntegerQ($s("k")))),SameQ($s("j"),Times(C2,$s("k")))),RationalQ(List($s("m"),$s("k")))),Less($s("m"),CN1)),Greater($s("k"),C0)))),
SetDelayed(Int(Times(Power($p("x"),$p("m")),Power(Plus(Plus($p("a",true),Times($p("b",true),$p("x"))),Times($p("c",true),Power($p("x"),C2))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(CN1,Power($s("x"),Plus($s("m"),Times(CN1,C1)))),Times(Power(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))),Plus($s("n"),C1)),Power(Times($s("c"),Plus($s("m"),Times(CN1,C1))),CN1))),Times(CN1,Dist(Times($s("b"),Power(Times(C2,$s("c")),CN1)),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,C1))),Power(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))),$s("n"))),$s("x"))))),Dist(Times(C1,Power($s("c"),CN1)),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,C2))),Power(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))),Plus($s("n"),C1))),$s("x")))),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),RationalQ(List($s("m"),$s("n")))),Less($s("n"),CN1)),ZeroQ(Plus(Plus($s("m"),Times(C2,$s("n"))),C1))),Not(IntegerQ(List($s("m"),$s("n"))))))),
SetDelayed(Int(Times(Power($p("x"),$p("m")),Power(Plus(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("k",true)))),Times($p("c",true),Power($p("x"),$p("j",true)))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Times(Power(Plus(Plus($s("a"),Times($s("b"),Power($s("x"),$s("k")))),Times($s("c"),Power($s("x"),$s("j")))),$s("n")),Power(Plus(Plus($s("m"),Times($s("j"),$s("n"))),C1),CN1))),Dist(Times(Times($s("a"),$s("j")),Times($s("n"),Power(Plus(Plus($s("m"),Times($s("j"),$s("n"))),C1),CN1))),Int(Times(Power($s("x"),$s("m")),Power(Plus(Plus($s("a"),Times($s("b"),Power($s("x"),$s("k")))),Times($s("c"),Power($s("x"),$s("j")))),Plus($s("n"),Times(CN1,C1)))),$s("x")))),Dist(Times(Times($s("b"),$s("k")),Times($s("n"),Power(Plus(Plus($s("m"),Times($s("j"),$s("n"))),C1),CN1))),Int(Times(Power($s("x"),Plus($s("m"),$s("k"))),Power(Plus(Plus($s("a"),Times($s("b"),Power($s("x"),$s("k")))),Times($s("c"),Power($s("x"),$s("j")))),Plus($s("n"),Times(CN1,C1)))),$s("x")))),And(And(And(And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),RationalQ(List($s("j"),$s("k"),$s("m"),$s("n")))),Equal($s("j"),Times(C2,$s("k")))),Greater($s("j"),C0)),Less($s("m"),CN1)),Greater($s("n"),C1)),NonzeroQ(Plus(Plus($s("m"),Times($s("j"),$s("n"))),C1))),Not(IntegerQ(List($s("j"),$s("k"),$s("m"),$s("n"))))))),
SetDelayed(Int(Times(Power($p("x"),$p("m")),Power(Plus(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("k",true)))),Times($p("c",true),Power($p("x"),$p("j",true)))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus(Plus($s("m"),Times(CN1,$s("j"))),C1)),Times(Power(Plus(Plus($s("a"),Times($s("b"),Power($s("x"),$s("k")))),Times($s("c"),Power($s("x"),$s("j")))),Plus($s("n"),C1)),Power(Times(Times($s("c"),$s("k")),Plus($s("n"),C1)),CN1))),Dist(Times($s("a"),Power($s("c"),CN1)),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,$s("j")))),Power(Plus(Plus($s("a"),Times($s("b"),Power($s("x"),$s("k")))),Times($s("c"),Power($s("x"),$s("j")))),$s("n"))),$s("x")))),And(And(And(And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("n")),$s("x")),FractionQ(List($s("j"),$s("k"),$s("m")))),SameQ($s("j"),Times(C2,$s("k")))),And(Less(C0,$s("j")),LessEqual($s("j"),$s("m")))),NonzeroQ(Plus($s("n"),C1))),ZeroQ(Plus(Plus($s("m"),Times($s("k"),Plus($s("n"),Times(CN1,C1)))),C1))),Not(And(IntegerQ($s("n")),GreaterEqual($s("n"),CN1)))),Not(IntegerQ(List($s("j"),$s("k"),$s("m"),$s("n"))))))),
SetDelayed(Int(Times(Power($p("x"),$p("m")),Power(Plus(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("k",true)))),Times($p("c",true),Power($p("x"),$p("j",true)))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Power($s("x"),Plus(Plus($s("m"),Times(CN1,$s("j"))),C1)),Times(Power(Plus(Plus($s("a"),Times($s("b"),Power($s("x"),$s("k")))),Times($s("c"),Power($s("x"),$s("j")))),Plus($s("n"),C1)),Power(Times($s("c"),Plus(Plus($s("m"),Times($s("j"),$s("n"))),C1)),CN1))),Times(CN1,Dist(Times($s("b"),Times(Plus(Plus($s("m"),Times($s("k"),Plus($s("n"),Times(CN1,C1)))),C1),Power(Times($s("c"),Plus(Plus($s("m"),Times($s("j"),$s("n"))),C1)),CN1))),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,$s("k")))),Power(Plus(Plus($s("a"),Times($s("b"),Power($s("x"),$s("k")))),Times($s("c"),Power($s("x"),$s("j")))),$s("n"))),$s("x"))))),Times(CN1,Dist(Times($s("a"),Times(Plus(Plus($s("m"),Times(CN1,$s("j"))),C1),Power(Times($s("c"),Plus(Plus($s("m"),Times($s("j"),$s("n"))),C1)),CN1))),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,$s("j")))),Power(Plus(Plus($s("a"),Times($s("b"),Power($s("x"),$s("k")))),Times($s("c"),Power($s("x"),$s("j")))),$s("n"))),$s("x"))))),And(And(And(And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("n")),$s("x")),RationalQ(List($s("j"),$s("k"),$s("m")))),Equal($s("j"),Times(C2,$s("k")))),And(Less(C0,$s("j")),LessEqual($s("j"),$s("m")))),NonzeroQ(Plus(Plus($s("m"),Times($s("j"),$s("n"))),C1))),NonzeroQ(Plus(Plus($s("m"),Times($s("k"),Plus($s("n"),Times(CN1,C1)))),C1))),Not(And(IntegerQ($s("n")),GreaterEqual($s("n"),CN1)))),Not(IntegerQ(List($s("j"),$s("k"),$s("m"),$s("n"))))))),
SetDelayed(Int(Times(Power($p("x"),$p("m")),Power(Plus(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("k",true)))),Times($p("c",true),Power($p("x"),$p("j",true)))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Times(Power(Plus(Plus($s("a"),Times($s("b"),Power($s("x"),$s("k")))),Times($s("c"),Power($s("x"),$s("j")))),Plus($s("n"),C1)),Power(Times($s("a"),Plus($s("m"),C1)),CN1))),Dist(Times($s("c"),Power($s("a"),CN1)),Int(Times(Power($s("x"),Plus($s("m"),$s("j"))),Power(Plus(Plus($s("a"),Times($s("b"),Power($s("x"),$s("k")))),Times($s("c"),Power($s("x"),$s("j")))),$s("n"))),$s("x")))),And(And(And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("n")),$s("x")),RationalQ(List($s("j"),$s("k"),$s("m")))),Equal($s("j"),Times(C2,$s("k")))),Greater($s("j"),C0)),Less($s("m"),CN1)),ZeroQ(Plus(Plus($s("m"),C1),Times($s("k"),Plus($s("n"),C1))))),Not(IntegerQ(List($s("j"),$s("k"),$s("m"),$s("n"))))))),
SetDelayed(Int(Times(Power($p("x"),$p("m")),Power(Plus(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("k",true)))),Times($p("c",true),Power($p("x"),$p("j",true)))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Times(Power(Plus(Plus($s("a"),Times($s("b"),Power($s("x"),$s("k")))),Times($s("c"),Power($s("x"),$s("j")))),Plus($s("n"),C1)),Power(Times($s("a"),Plus($s("m"),C1)),CN1))),Times(CN1,Dist(Times($s("b"),Power(Times(C2,$s("a")),CN1)),Int(Times(Power($s("x"),Plus($s("m"),$s("k"))),Power(Plus(Plus($s("a"),Times($s("b"),Power($s("x"),$s("k")))),Times($s("c"),Power($s("x"),$s("j")))),$s("n"))),$s("x"))))),And(And(And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("n")),$s("x")),RationalQ(List($s("j"),$s("k"),$s("m")))),Equal($s("j"),Times(C2,$s("k")))),Greater($s("j"),C0)),Less($s("m"),CN1)),ZeroQ(Plus(Plus($s("m"),C1),Times($s("j"),Plus($s("n"),C1))))),Not(IntegerQ(List($s("j"),$s("k"),$s("m"),$s("n"))))))),
SetDelayed(Int(Times(Power($p("x"),$p("m")),Power(Plus(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("k",true)))),Times($p("c",true),Power($p("x"),$p("j",true)))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Times(Power(Plus(Plus($s("a"),Times($s("b"),Power($s("x"),$s("k")))),Times($s("c"),Power($s("x"),$s("j")))),$s("n")),Power(Plus($s("m"),C1),CN1))),Times(CN1,Dist(Times(Times($s("b"),$s("k")),Times($s("n"),Power(Plus($s("m"),C1),CN1))),Int(Times(Power($s("x"),Plus($s("m"),$s("k"))),Power(Plus(Plus($s("a"),Times($s("b"),Power($s("x"),$s("k")))),Times($s("c"),Power($s("x"),$s("j")))),Plus($s("n"),Times(CN1,C1)))),$s("x"))))),Times(CN1,Dist(Times(Times($s("c"),$s("j")),Times($s("n"),Power(Plus($s("m"),C1),CN1))),Int(Times(Power($s("x"),Plus($s("m"),$s("j"))),Power(Plus(Plus($s("a"),Times($s("b"),Power($s("x"),$s("k")))),Times($s("c"),Power($s("x"),$s("j")))),Plus($s("n"),Times(CN1,C1)))),$s("x"))))),And(And(And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),RationalQ(List($s("j"),$s("k"),$s("m"),$s("n")))),Equal($s("j"),Times(C2,$s("k")))),Greater($s("j"),C0)),Less($s("m"),CN1)),Greater($s("n"),C1)),Not(IntegerQ(List($s("j"),$s("k"),$s("m"),$s("n"))))))),
SetDelayed(Int(Times(Power($p("x"),$p("m")),Power(Plus(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("k",true)))),Times($p("c",true),Power($p("x"),$p("j",true)))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Times(Power(Plus(Plus($s("a"),Times($s("b"),Power($s("x"),$s("k")))),Times($s("c"),Power($s("x"),$s("j")))),Plus($s("n"),C1)),Power(Times($s("a"),Plus($s("m"),C1)),CN1))),Times(CN1,Dist(Times($s("b"),Times(Plus(Plus($s("m"),C1),Times($s("k"),Plus($s("n"),C1))),Power(Times($s("a"),Plus($s("m"),C1)),CN1))),Int(Times(Power($s("x"),Plus($s("m"),$s("k"))),Power(Plus(Plus($s("a"),Times($s("b"),Power($s("x"),$s("k")))),Times($s("c"),Power($s("x"),$s("j")))),$s("n"))),$s("x"))))),Times(CN1,Dist(Times($s("c"),Times(Plus(Plus($s("m"),C1),Times($s("j"),Plus($s("n"),C1))),Power(Times($s("a"),Plus($s("m"),C1)),CN1))),Int(Times(Power($s("x"),Plus($s("m"),$s("j"))),Power(Plus(Plus($s("a"),Times($s("b"),Power($s("x"),$s("k")))),Times($s("c"),Power($s("x"),$s("j")))),$s("n"))),$s("x"))))),And(And(And(And(And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("n")),$s("x")),RationalQ(List($s("j"),$s("k"),$s("m")))),Equal($s("j"),Times(C2,$s("k")))),Greater($s("j"),C0)),Less($s("m"),CN1)),NonzeroQ(Plus(Plus($s("m"),C1),Times($s("k"),Plus($s("n"),C1))))),NonzeroQ(Plus(Plus($s("m"),C1),Times($s("j"),Plus($s("n"),C1))))),Not(And(RationalQ($s("n")),Greater($s("n"),C1)))),Not(IntegerQ(List($s("j"),$s("k"),$s("m"),$s("n"))))))),
SetDelayed(Int(Times(Power($p("x"),$p("k",true)),Power(Plus(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("k",true)))),Times($p("c",true),Power($p("x"),$p("j",true)))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times($s("x"),Plus($s("b"),Times(Times(C2,$s("c")),Power($s("x"),$s("k"))))),Times(Power(Plus(Plus($s("a"),Times($s("b"),Power($s("x"),$s("k")))),Times($s("c"),Power($s("x"),$s("j")))),$s("n")),Power(Times(Times(C2,$s("c")),Plus(Times($s("k"),Plus(Times(C2,$s("n")),C1)),C1)),CN1))),Times(CN1,Dist(Times($s("b"),Power(Times(Times(C2,$s("c")),Plus(Times($s("k"),Plus(Times(C2,$s("n")),C1)),C1)),CN1)),Int(Power(Plus(Plus($s("a"),Times($s("b"),Power($s("x"),$s("k")))),Times($s("c"),Power($s("x"),$s("j")))),$s("n")),$s("x"))))),Times(CN1,Dist(Times(Times($s("k"),$s("n")),Times(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c")))),Power(Times(Times(C2,$s("c")),Plus(Times($s("k"),Plus(Times(C2,$s("n")),C1)),C1)),CN1))),Int(Times(Power($s("x"),$s("k")),Power(Plus(Plus($s("a"),Times($s("b"),Power($s("x"),$s("k")))),Times($s("c"),Power($s("x"),$s("j")))),Plus($s("n"),Times(CN1,C1)))),$s("x"))))),And(And(And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("j"),$s("k")),$s("x")),RationalQ($s("n"))),Not(IntegerQ($s("k")))),SameQ($s("j"),Times(C2,$s("k")))),Greater($s("n"),C0)),NonzeroQ(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c")))))),NonzeroQ(Plus(Times($s("k"),Plus(Times(C2,$s("n")),C1)),C1))))),
SetDelayed(Int(Times(Power($p("x"),$p("k",true)),Power(Plus(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("k",true)))),Times($p("c",true),Power($p("x"),$p("j",true)))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times($s("x"),Plus($s("b"),Times(Times(C2,$s("c")),Power($s("x"),$s("k"))))),Times(Power(Plus(Plus($s("a"),Times($s("b"),Power($s("x"),$s("k")))),Times($s("c"),Power($s("x"),$s("j")))),Plus($s("n"),C1)),Power(Times(Times($s("k"),Plus($s("n"),C1)),Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c"))))),CN1))),Times(CN1,Dist(Times($s("b"),Power(Times(Times($s("k"),Plus($s("n"),C1)),Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c"))))),CN1)),Int(Power(Plus(Plus($s("a"),Times($s("b"),Power($s("x"),$s("k")))),Times($s("c"),Power($s("x"),$s("j")))),Plus($s("n"),C1)),$s("x"))))),Times(CN1,Dist(Times(Times(C2,$s("c")),Times(Plus(Times($s("k"),Plus(Times(C2,$s("n")),C3)),C1),Power(Times(Times($s("k"),Plus($s("n"),C1)),Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c"))))),CN1))),Int(Times(Power($s("x"),$s("k")),Power(Plus(Plus($s("a"),Times($s("b"),Power($s("x"),$s("k")))),Times($s("c"),Power($s("x"),$s("j")))),Plus($s("n"),C1))),$s("x"))))),And(And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("j"),$s("k")),$s("x")),RationalQ($s("n"))),Not(IntegerQ($s("k")))),SameQ($s("j"),Times(C2,$s("k")))),Less($s("n"),CN1)),NonzeroQ(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c")))))))),
SetDelayed(Int(Times(Plus($p("d"),Times($p("e",true),Power($p("x"),$p("k")))),Power(Plus(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("k")))),Times($p("c",true),Power($p("x"),$p("j",true)))),CN1)),$p("x",$s("Symbol"))),
    Condition(Module(List(Set($s("q"),Rt(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c")))),C2))),Plus(Dist(Plus($s("e"),Times(Plus(Times(Times(C2,$s("c")),$s("d")),Times(CN1,Times($s("b"),$s("e")))),Power($s("q"),CN1))),Int(Times(C1,Power(Plus(Plus($s("b"),Times(CN1,$s("q"))),Times(Times(C2,$s("c")),Power($s("x"),$s("k")))),CN1)),$s("x"))),Dist(Plus($s("e"),Times(CN1,Times(Plus(Times(Times(C2,$s("c")),$s("d")),Times(CN1,Times($s("b"),$s("e")))),Power($s("q"),CN1)))),Int(Times(C1,Power(Plus(Plus($s("b"),$s("q")),Times(Times(C2,$s("c")),Power($s("x"),$s("k")))),CN1)),$s("x"))))),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e"),$s("j"),$s("k")),$s("x")),Not(IntegerQ($s("k")))),SameQ($s("j"),Times(C2,$s("k")))),NonzeroQ(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c")))))),Not(NegativeQ(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c"))))))))),
SetDelayed(Int(Times(Plus($p("d",true),Times($p("e",true),Power($p("x"),$p("k")))),Power(Times($p("x"),Plus(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("k")))),Times($p("c",true),Power($p("x"),$p("j",true))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Times($s("d"),Times(Log($s("x")),Power($s("a"),CN1))),Times(CN1,Times(Times(C1,Power(Times($s("a"),$s("k")),CN1)),Subst(Int(Times(Plus(Plus(Times($s("b"),$s("d")),Times(CN1,Times($s("a"),$s("e")))),Times(Times($s("c"),$s("d")),$s("x"))),Power(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))),CN1)),$s("x")),$s("x"),Power($s("x"),$s("k")))))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e"),$s("j"),$s("k")),$s("x")),Not(IntegerQ($s("k")))),SameQ($s("j"),Times(C2,$s("k")))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Times(Plus($p("d",true),Times($p("e",true),Power($p("x"),$p("k")))),Power(Plus(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("k")))),Times($p("c",true),Power($p("x"),$p("j",true)))),CN1))),$p("x",$s("Symbol"))),
    Condition(Plus(Times($s("e"),Times(Power($s("x"),Plus(Plus($s("m"),Times(CN1,$s("k"))),C1)),Power(Times($s("c"),Plus(Plus($s("m"),Times(CN1,$s("k"))),C1)),CN1))),Times(CN1,Dist(Times(C1,Power($s("c"),CN1)),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,$s("k")))),Times(Plus(Times($s("a"),$s("e")),Times(Plus(Times($s("b"),$s("e")),Times(CN1,Times($s("c"),$s("d")))),Power($s("x"),$s("k")))),Power(Plus(Plus($s("a"),Times($s("b"),Power($s("x"),$s("k")))),Times($s("c"),Power($s("x"),$s("j")))),CN1))),$s("x"))))),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e"),$s("j"),$s("k")),$s("x")),Not(IntegerQ($s("k")))),SameQ($s("j"),Times(C2,$s("k")))),RationalQ(List($s("m"),$s("k")))),Less(Less(C0,$s("k")),Plus($s("m"),C1))))),
SetDelayed(Int(Times(Power($p("x"),$p("m")),Times(Plus($p("d",true),Times($p("e",true),Power($p("x"),$p("k")))),Power(Plus(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("k")))),Times($p("c",true),Power($p("x"),$p("j",true)))),CN1))),$p("x",$s("Symbol"))),
    Condition(Plus(Times($s("d"),Times(Power($s("x"),Plus($s("m"),C1)),Power(Times($s("a"),Plus($s("m"),C1)),CN1))),Times(CN1,Dist(Times(C1,Power($s("a"),CN1)),Int(Times(Power($s("x"),Plus($s("m"),$s("k"))),Times(Plus(Plus(Times($s("b"),$s("d")),Times(CN1,Times($s("a"),$s("e")))),Times(Times($s("c"),$s("d")),Power($s("x"),$s("k")))),Power(Plus(Plus($s("a"),Times($s("b"),Power($s("x"),$s("k")))),Times($s("c"),Power($s("x"),$s("j")))),CN1))),$s("x"))))),And(And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e"),$s("j"),$s("k")),$s("x")),Not(IntegerQ($s("k")))),SameQ($s("j"),Times(C2,$s("k")))),RationalQ(List($s("m"),$s("k")))),Less($s("m"),CN1)),Greater($s("k"),C0)))),
SetDelayed(Int(Sqrt(Plus(Times($p("a",true),$p("x")),Sqrt(Plus($p("b"),Times($p("c",true),Power($p("x"),C2)))))),$p("x",$s("Symbol"))),
    Condition(Times(Times(C2,Plus(Times(Times(C2,$s("a")),$s("x")),Times(CN1,Sqrt(Plus($s("b"),Times($s("c"),Power($s("x"),C2))))))),Times(Sqrt(Plus(Times($s("a"),$s("x")),Sqrt(Plus($s("b"),Times($s("c"),Power($s("x"),C2)))))),Power(Times(C3,$s("a")),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),SameQ($s("c"),Power($s("a"),C2))))),
SetDelayed(Int(Sqrt(Plus(Times($p("a",true),$p("x")),Times(CN1,Sqrt(Plus($p("b"),Times($p("c",true),Power($p("x"),C2))))))),$p("x",$s("Symbol"))),
    Condition(Times(Times(C2,Plus(Times(Times(C2,$s("a")),$s("x")),Sqrt(Plus($s("b"),Times($s("c"),Power($s("x"),C2)))))),Times(Sqrt(Plus(Times($s("a"),$s("x")),Times(CN1,Sqrt(Plus($s("b"),Times($s("c"),Power($s("x"),C2))))))),Power(Times(C3,$s("a")),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),SameQ($s("c"),Power($s("a"),C2))))),
SetDelayed(Int(Sqrt(Plus($p("a"),Sqrt(Plus($p("c"),Times($p("b",true),Power($p("x"),C2)))))),$p("x",$s("Symbol"))),
    Condition(Times(Times(C2,Sqrt(Plus($s("a"),Sqrt(Plus(Power($s("a"),C2),Times($s("b"),Power($s("x"),C2))))))),Times(Plus(Plus(Times(CN1,Power($s("a"),C2)),Times($s("b"),Power($s("x"),C2))),Times($s("a"),Sqrt(Plus(Power($s("a"),C2),Times($s("b"),Power($s("x"),C2)))))),Power(Times(Times(C3,$s("b")),$s("x")),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),SameQ($s("c"),Power($s("a"),C2))))),
SetDelayed(Int(Sqrt(Plus($p("a"),Times(CN1,Sqrt(Plus($p("c"),Times($p("b",true),Power($p("x"),C2))))))),$p("x",$s("Symbol"))),
    Condition(Times(Times(C2,Sqrt(Plus($s("a"),Times(CN1,Sqrt(Plus(Power($s("a"),C2),Times($s("b"),Power($s("x"),C2)))))))),Times(Plus(Plus(Times(CN1,Power($s("a"),C2)),Times($s("b"),Power($s("x"),C2))),Times(CN1,Times($s("a"),Sqrt(Plus(Power($s("a"),C2),Times($s("b"),Power($s("x"),C2))))))),Power(Times(Times(C3,$s("b")),$s("x")),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),SameQ($s("c"),Power($s("a"),C2))))),
SetDelayed(Int(Times($p("u",true),Power(Plus(Times($p("a",true),Power($p("x"),$p("m",true))),Times($p("b",true),Sqrt(Times($p("c",true),Power($p("x"),$p("n")))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Int(Times($s("u"),Times(Plus(Times($s("a"),Power($s("x"),$s("m"))),Times(CN1,Times($s("b"),Sqrt(Times($s("c"),Power($s("x"),$s("n"))))))),Power(Plus(Times(Power($s("a"),C2),Power($s("x"),Times(C2,$s("m")))),Times(CN1,Times(Times(Power($s("b"),C2),$s("c")),Power($s("x"),$s("n"))))),CN1))),$s("x")),FreeQ(List($s("a"),$s("b"),$s("c"),$s("m"),$s("n")),$s("x")))),
SetDelayed(Int(Times($p("u",true),Power(Plus(Times($p("e",true),Sqrt(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n",true)))))),Times($p("f",true),Sqrt(Plus($p("c",true),Times($p("d",true),Power($p("x"),$p("n",true))))))),$p("m"))),$p("x",$s("Symbol"))),
    Condition(Dist(Power(Plus(Times($s("a"),Power($s("e"),C2)),Times(CN1,Times($s("c"),Power($s("f"),C2)))),$s("m")),Int(Times($s("u"),Power(Plus(Times($s("e"),Sqrt(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))))),Times(CN1,Times($s("f"),Sqrt(Plus($s("c"),Times($s("d"),Power($s("x"),$s("n")))))))),Times(CN1,$s("m")))),$s("x"))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e"),$s("f"),$s("n")),$s("x")),IntegerQ($s("m"))),Less($s("m"),C0)),ZeroQ(Plus(Times($s("b"),Power($s("e"),C2)),Times(CN1,Times($s("d"),Power($s("f"),C2))))))))
  );
}
