package org.matheclipse.core.integrate.rubi;


import static org.matheclipse.core.expression.F.*;
import static org.matheclipse.core.integrate.rubi.UtilityFunctionCtors.*;
import static org.matheclipse.core.integrate.rubi.UtilityFunctions.*;
import org.matheclipse.core.interfaces.IAST;
import org.matheclipse.core.interfaces.IExpr;

/** 
 * IndefiniteIntegrationRules from the <a href="http://www.apmaths.uwo.ca/~arich/">Rubi -
 * rule-based integrator</a>.
 *  
 */
public class IndefiniteIntegrationRules4 { 
  public static IAST RULES = List( 
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Plus(Plus($p("a",true),Times($p("b",true),Power(Cos(Plus($p("d",true),Times($p("e",true),$p("x")))),C2))),Times($p("c",true),Power(Sin(Plus($p("d",true),Times($p("e",true),$p("x")))),C2))),CN1)),$p("x",$s("Symbol"))),
    Condition(Dist(C2,Int(Times(Power($s("x"),$s("m")),Power(Plus(Plus(Plus(Times(C2,$s("a")),$s("b")),$s("c")),Times(Plus($s("b"),Times(CN1,$s("c"))),Cos(Plus(Times(C2,$s("d")),Times(Times(C2,$s("e")),$s("x")))))),CN1)),$s("x"))),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e")),$s("x")),IntegerQ($s("m"))),Greater($s("m"),C0)),NonzeroQ(Plus($s("a"),$s("b")))),NonzeroQ(Plus($s("a"),$s("c")))))),
SetDelayed(Int(Power(Plus($p("a"),Times($p("b",true),Power(Sin(Plus($p("c",true),Times($p("d",true),$p("x")))),C2))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Dist(Times(C1,Power(Power(C2,$s("n")),CN1)),Int(Power(Plus(Plus(Times(C2,$s("a")),$s("b")),Times(CN1,Times($s("b"),Cos(Plus(Times(C2,$s("c")),Times(Times(C2,$s("d")),$s("x"))))))),$s("n")),$s("x"))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),NonzeroQ(Plus($s("a"),$s("b")))),HalfIntegerQ($s("n"))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Plus($p("a"),Times(Times($p("b",true),Sin(Plus($p("c",true),Times($p("d",true),$p("x"))))),Cos(Plus($p("c",true),Times($p("d",true),$p("x")))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Int(Times(Power($s("x"),$s("m")),Power(Plus($s("a"),Times($s("b"),Times(Sin(Plus(Times(C2,$s("c")),Times(Times(C2,$s("d")),$s("x")))),C1D2))),CN1)),$s("x")),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),IntegerQ($s("m"))),Greater($s("m"),C0)))),
SetDelayed(Int(Power(Plus($p("a"),Times(Times($p("b",true),Sin(Plus($p("c",true),Times($p("d",true),$p("x"))))),Cos(Plus($p("c",true),Times($p("d",true),$p("x")))))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Int(Power(Plus($s("a"),Times($s("b"),Times(Sin(Plus(Times(C2,$s("c")),Times(Times(C2,$s("d")),$s("x")))),C1D2))),$s("n")),$s("x")),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),HalfIntegerQ($s("n"))))),
SetDelayed(Int(Times(Power(Sin(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m",true)),Power(Cos(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Times(Power(Sin(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),C1)),Times(Power(Cos(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C1)),Power(Times($s("b"),Plus($s("m"),C1)),CN1))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("m"),$s("n")),$s("x")),ZeroQ(Plus(Plus($s("m"),$s("n")),C2))),NonzeroQ(Plus($s("m"),C1))),PosQ($s("m"))))),
SetDelayed(Int(Times(Power(Sin(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m")),Power(Cos(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Dist(Times(C1,Power($s("b"),CN1)),Subst(Int(Regularize(Times(Power($s("x"),$s("m")),Power(Plus(C1,Times(CN1,Power($s("x"),C2))),Times(Plus($s("n"),Times(CN1,C1)),C1D2))),$s("x")),$s("x")),$s("x"),Sin(Plus($s("a"),Times($s("b"),$s("x")))))),And(And(FreeQ(List($s("a"),$s("b"),$s("m")),$s("x")),OddQ($s("n"))),Not(And(OddQ($s("m")),Less(Less(C0,$s("m")),$s("n"))))))),
SetDelayed(Int(Times(Power(Sin(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m")),Power(Cos(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Power(Sin(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),Times(CN1,C1)))),Times(Power(Cos(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C1)),Power(Times($s("b"),Plus($s("n"),C1)),CN1))),Dist(Times(Plus($s("m"),Times(CN1,C1)),Power(Plus($s("n"),C1),CN1)),Int(Times(Power(Sin(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),Times(CN1,C2))),Power(Cos(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C2))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),RationalQ(List($s("m"),$s("n")))),Greater($s("m"),C1)),Less($s("n"),CN1)))),
SetDelayed(Int(Times(Power(Sin(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m")),Power(Cos(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Power(Sin(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),Times(CN1,C1)))),Times(Power(Cos(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C1)),Power(Times($s("b"),Plus($s("m"),$s("n"))),CN1))),Dist(Times(Plus($s("m"),Times(CN1,C1)),Power(Plus($s("m"),$s("n")),CN1)),Int(Times(Power(Sin(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),Times(CN1,C2))),Power(Cos(Plus($s("a"),Times($s("b"),$s("x")))),$s("n"))),$s("x")))),And(And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("n")),$s("x")),RationalQ($s("m"))),Greater($s("m"),C1)),Not(OddQ($s("m")))),NonzeroQ(Plus($s("m"),$s("n")))),Not(And(OddQ($s("n")),Greater($s("n"),C1)))))),
SetDelayed(Int(Times(Power(Sin(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m")),Power(Cos(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power(Sin(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),C1)),Times(Power(Cos(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C1)),Power(Times($s("b"),Plus($s("m"),C1)),CN1))),Dist(Times(Plus(Plus($s("m"),$s("n")),C2),Power(Plus($s("m"),C1),CN1)),Int(Times(Power(Sin(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),C2)),Power(Cos(Plus($s("a"),Times($s("b"),$s("x")))),$s("n"))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("n")),$s("x")),RationalQ($s("m"))),Less($s("m"),CN1)),NonzeroQ(Plus(Plus($s("m"),$s("n")),C2))))),
SetDelayed(Int(Times(Power(Sin(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m")),Power(Cos(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Dist(Times(C1,Power(Times($s("b"),$s("m")),CN1)),Subst(Int(Times(Power($s("x"),Times(C1,Power($s("m"),CN1))),Power(Plus(C1,Power($s("x"),Times(C2,Power($s("m"),CN1)))),CN1)),$s("x")),$s("x"),Times(Power(Sin(Plus($s("a"),Times($s("b"),$s("x")))),$s("m")),Power(Cos(Plus($s("a"),Times($s("b"),$s("x")))),$s("n"))))),And(And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),FractionQ(List($s("m"),$s("n")))),ZeroQ(Plus($s("m"),$s("n")))),IntegerQ(Times(C1,Power($s("m"),CN1)))),Greater($s("m"),C0)))),
SetDelayed(Int(Times(Sin(Plus($p("a",true),Times($p("b",true),$p("x")))),Tan(Plus($p("a",true),Times($p("b",true),$p("x"))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Sin(Plus($s("a"),Times($s("b"),$s("x"))))),Power($s("b"),CN1)),Int(Sec(Plus($s("a"),Times($s("b"),$s("x")))),$s("x"))),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(Times(Power(Sin(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m")),Power(Tan(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Times(Times(CN1,Power(Sin(Plus($s("a"),Times($s("b"),$s("x")))),$s("m"))),Times(Power(Tan(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C1))),Power(Times($s("b"),$s("m")),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("m"),$s("n")),$s("x")),ZeroQ(Plus(Plus($s("m"),$s("n")),Times(CN1,C1)))))),
SetDelayed(Int(Times(Power(Sin(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m",true)),Power(Tan(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Dist(Times(CN1,Power($s("b"),CN1)),Subst(Int(Regularize(Times(Power(Plus(C1,Times(CN1,Power($s("x"),C2))),Times(Plus(Plus($s("m"),$s("n")),Times(CN1,C1)),C1D2)),Power(Power($s("x"),$s("n")),CN1)),$s("x")),$s("x")),$s("x"),Cos(Plus($s("a"),Times($s("b"),$s("x")))))),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ(List($s("m"),$s("n")))),OddQ(Plus($s("m"),$s("n")))))),
SetDelayed(Int(Times(Power(Sin(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m")),Power(Tan(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power(Sin(Plus($s("a"),Times($s("b"),$s("x")))),$s("m")),Times(Power(Tan(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C1)),Power(Times($s("b"),$s("m")),CN1))),Times(CN1,Dist(Times(Plus($s("n"),C1),Power($s("m"),CN1)),Int(Times(Power(Sin(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),Times(CN1,C2))),Power(Tan(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C2))),$s("x"))))),And(And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),RationalQ(List($s("m"),$s("n")))),Greater($s("m"),C1)),Less($s("n"),CN1)),Not(And(OddQ($s("m")),EvenQ($s("n"))))))),
SetDelayed(Int(Times(Power(Sin(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m")),Power(Tan(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power(Sin(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),C2)),Times(Power(Tan(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C1))),Power(Times($s("b"),Plus($s("n"),Times(CN1,C1))),CN1))),Times(CN1,Dist(Times(Plus($s("m"),C2),Power(Plus($s("n"),Times(CN1,C1)),CN1)),Int(Times(Power(Sin(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),C2)),Power(Tan(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C2)))),$s("x"))))),And(And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),RationalQ(List($s("m"),$s("n")))),Less($s("m"),CN1)),Greater($s("n"),C1)),Not(And(OddQ($s("m")),EvenQ($s("n"))))))),
SetDelayed(Int(Times(Power(Sin(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m")),Power(Tan(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Power(Sin(Plus($s("a"),Times($s("b"),$s("x")))),$s("m"))),Times(Power(Tan(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C1))),Power(Times($s("b"),$s("m")),CN1))),Dist(Times(Plus(Plus($s("m"),$s("n")),Times(CN1,C1)),Power($s("m"),CN1)),Int(Times(Power(Sin(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),Times(CN1,C2))),Power(Tan(Plus($s("a"),Times($s("b"),$s("x")))),$s("n"))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("n")),$s("x")),RationalQ($s("m"))),Greater($s("m"),C1)),Not(And(OddQ($s("m")),EvenQ($s("n"))))))),
SetDelayed(Int(Times(Power(Sin(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m",true)),Power(Tan(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power(Sin(Plus($s("a"),Times($s("b"),$s("x")))),$s("m")),Times(Power(Tan(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C1))),Power(Times($s("b"),Plus($s("n"),Times(CN1,C1))),CN1))),Times(CN1,Dist(Times(Plus(Plus($s("m"),$s("n")),Times(CN1,C1)),Power(Plus($s("n"),Times(CN1,C1)),CN1)),Int(Times(Power(Sin(Plus($s("a"),Times($s("b"),$s("x")))),$s("m")),Power(Tan(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C2)))),$s("x"))))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("m")),$s("x")),RationalQ($s("n"))),Greater($s("n"),C1)),Not(And(OddQ($s("m")),EvenQ($s("n"))))))),
SetDelayed(Int(Times(Power(Sin(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m")),Power(Tan(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power(Sin(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),C2)),Times(Power(Tan(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C1))),Power(Times($s("b"),Plus(Plus($s("m"),$s("n")),C1)),CN1))),Dist(Times(Plus($s("m"),C2),Power(Plus(Plus($s("m"),$s("n")),C1),CN1)),Int(Times(Power(Sin(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),C2)),Power(Tan(Plus($s("a"),Times($s("b"),$s("x")))),$s("n"))),$s("x")))),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("n")),$s("x")),RationalQ($s("m"))),Less($s("m"),CN1)),NonzeroQ(Plus(Plus($s("m"),$s("n")),C1))),Not(And(OddQ($s("m")),EvenQ($s("n"))))))),
SetDelayed(Int(Times(Power(Sin(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m",true)),Power(Tan(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power(Sin(Plus($s("a"),Times($s("b"),$s("x")))),$s("m")),Times(Power(Tan(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C1)),Power(Times($s("b"),Plus(Plus($s("m"),$s("n")),C1)),CN1))),Times(CN1,Dist(Times(Plus($s("n"),C1),Power(Plus(Plus($s("m"),$s("n")),C1),CN1)),Int(Times(Power(Sin(Plus($s("a"),Times($s("b"),$s("x")))),$s("m")),Power(Tan(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C2))),$s("x"))))),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("m")),$s("x")),RationalQ($s("n"))),Less($s("n"),CN1)),NonzeroQ(Plus(Plus($s("m"),$s("n")),C1))),Not(And(OddQ($s("m")),EvenQ($s("n"))))))),
SetDelayed(Int(Sin(Times($p("b",true),Power($p("x"),C2))),$p("x",$s("Symbol"))),
    Condition(Times(Sqrt(Times(Pi,C1D2)),Times(FresnelS(Times(Rt($s("b"),C2),Times($s("x"),Power(Sqrt(Times(Pi,C1D2)),CN1)))),Power(Rt($s("b"),C2),CN1))),FreeQ($s("b"),$s("x")))),
SetDelayed(Int(Sin(Plus($p("a"),Times($p("b",true),Power($p("x"),C2)))),$p("x",$s("Symbol"))),
    Condition(Plus(Dist(Sin($s("a")),Int(Cos(Times($s("b"),Power($s("x"),C2))),$s("x"))),Dist(Cos($s("a")),Int(Sin(Times($s("b"),Power($s("x"),C2))),$s("x")))),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(Sin(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n"))))),$p("x",$s("Symbol"))),
    Condition(Plus(Dist(Times(CI,C1D2),Int(Power(E,Plus(Times(Times(CN1,$s("a")),CI),Times(CN1,Times(Times($s("b"),CI),Power($s("x"),$s("n")))))),$s("x"))),Times(CN1,Dist(Times(CI,C1D2),Int(Power(E,Plus(Times($s("a"),CI),Times(Times($s("b"),CI),Power($s("x"),$s("n"))))),$s("x"))))),And(FreeQ(List($s("a"),$s("b"),$s("n")),$s("x")),Not(FractionOrNegativeQ($s("n")))))),
SetDelayed(Int(Sin(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n"))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times($s("x"),Sin(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))))),Times(CN1,Dist(Times($s("b"),$s("n")),Int(Times(Power($s("x"),$s("n")),Cos(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))))),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ($s("n"))),Less($s("n"),C0)))),
SetDelayed(Int(Times(Sin(Times($p("a",true),Power($p("x"),$p("n",true)))),Power($p("x"),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(SinIntegral(Times($s("a"),Power($s("x"),$s("n")))),Power($s("n"),CN1)),FreeQ(List($s("a"),$s("n")),$s("x")))),
SetDelayed(Int(Times(Sin(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("n",true))))),Power($p("x"),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Dist(Sin($s("a")),Int(Times(Cos(Times($s("b"),Power($s("x"),$s("n")))),Power($s("x"),CN1)),$s("x"))),Dist(Cos($s("a")),Int(Times(Sin(Times($s("b"),Power($s("x"),$s("n")))),Power($s("x"),CN1)),$s("x")))),FreeQ(List($s("a"),$s("b"),$s("n")),$s("x")))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Sin(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n",true)))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Power($s("x"),Plus(Plus($s("m"),Times(CN1,$s("n"))),C1))),Times(Cos(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),Power(Times($s("b"),$s("n")),CN1))),Dist(Times(Plus(Plus($s("m"),Times(CN1,$s("n"))),C1),Power(Times($s("b"),$s("n")),CN1)),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,$s("n")))),Cos(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ($s("n"))),RationalQ($s("m"))),And(Less(C0,$s("n")),LessEqual($s("n"),$s("m")))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Sin(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n",true)))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Times(Sin(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),Power(Plus($s("m"),C1),CN1))),Times(CN1,Dist(Times($s("b"),Times($s("n"),Power(Plus($s("m"),C1),CN1))),Int(Times(Power($s("x"),Plus($s("m"),$s("n"))),Cos(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))))),$s("x"))))),And(FreeQ(List($s("a"),$s("b"),$s("m"),$s("n")),$s("x")),Or(ZeroQ(Plus(Plus($s("m"),$s("n")),C1)),And(And(IntegerQ($s("n")),RationalQ($s("m"))),Or(And(Greater($s("n"),C0),Less($s("m"),CN1)),Less(Less(C0,Times(CN1,$s("n"))),Plus($s("m"),C1)))))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Sin(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n",true)))))),$p("x",$s("Symbol"))),
    Condition(Plus(Dist(Times(CI,C1D2),Int(Times(Power($s("x"),$s("m")),Power(E,Plus(Times(Times(CN1,$s("a")),CI),Times(CN1,Times(Times($s("b"),CI),Power($s("x"),$s("n"))))))),$s("x"))),Times(CN1,Dist(Times(CI,C1D2),Int(Times(Power($s("x"),$s("m")),Power(E,Plus(Times($s("a"),CI),Times(Times($s("b"),CI),Power($s("x"),$s("n")))))),$s("x"))))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("m"),$s("n")),$s("x")),NonzeroQ(Plus($s("m"),C1))),NonzeroQ(Plus(Plus($s("m"),Times(CN1,$s("n"))),C1))),Not(Or(FractionQ($s("m")),FractionOrNegativeQ($s("n"))))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Sin(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n",true))))),$p("p"))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times($s("n"),Times(Power(Sin(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),$s("p")),Power(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Power($s("p"),C2)),CN1))),Times(CN1,Times(Times(Power($s("x"),$s("n")),Cos(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))))),Times(Power(Sin(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),Plus($s("p"),Times(CN1,C1))),Power(Times(Times($s("b"),$s("n")),$s("p")),CN1))))),Dist(Times(Plus($s("p"),Times(CN1,C1)),Power($s("p"),CN1)),Int(Times(Power($s("x"),$s("m")),Power(Sin(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),Plus($s("p"),Times(CN1,C2)))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("m"),$s("n")),$s("x")),RationalQ($s("p"))),Greater($s("p"),C1)),ZeroQ(Plus(Plus($s("m"),Times(CN1,Times(C2,$s("n")))),C1))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Sin(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n",true))))),$p("p"))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Plus(Times(Times(Plus(Plus($s("m"),Times(CN1,$s("n"))),C1),Power($s("x"),Plus(Plus($s("m"),Times(CN1,Times(C2,$s("n")))),C1))),Times(Power(Sin(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),$s("p")),Power(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Power($s("p"),C2)),CN1))),Times(CN1,Times(Times(Power($s("x"),Plus(Plus($s("m"),Times(CN1,$s("n"))),C1)),Cos(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))))),Times(Power(Sin(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),Plus($s("p"),Times(CN1,C1))),Power(Times(Times($s("b"),$s("n")),$s("p")),CN1))))),Dist(Times(Plus($s("p"),Times(CN1,C1)),Power($s("p"),CN1)),Int(Times(Power($s("x"),$s("m")),Power(Sin(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),Plus($s("p"),Times(CN1,C2)))),$s("x")))),Times(CN1,Dist(Times(Plus(Plus($s("m"),Times(CN1,$s("n"))),C1),Times(Plus(Plus($s("m"),Times(CN1,Times(C2,$s("n")))),C1),Power(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Power($s("p"),C2)),CN1))),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,Times(C2,$s("n"))))),Power(Sin(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),$s("p"))),$s("x"))))),And(And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ($s("n"))),RationalQ(List($s("m"),$s("p")))),Greater($s("p"),C1)),Less(Less(C0,Times(C2,$s("n"))),Plus($s("m"),C1))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Sin(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n",true))))),$p("p"))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(Power($s("x"),$s("n")),Cos(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))))),Times(Power(Sin(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),Plus($s("p"),C1)),Power(Times(Times($s("b"),$s("n")),Plus($s("p"),C1)),CN1))),Times(CN1,Times($s("n"),Times(Power(Sin(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),Plus($s("p"),C2)),Power(Times(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Plus($s("p"),C1)),Plus($s("p"),C2)),CN1))))),Dist(Times(Plus($s("p"),C2),Power(Plus($s("p"),C1),CN1)),Int(Times(Power($s("x"),$s("m")),Power(Sin(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),Plus($s("p"),C2))),$s("x")))),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("m"),$s("n")),$s("x")),RationalQ($s("p"))),Less($s("p"),CN1)),Unequal($s("p"),integer(-2L))),ZeroQ(Plus(Plus($s("m"),Times(CN1,Times(C2,$s("n")))),C1))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Sin(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n",true))))),$p("p"))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Plus(Times(Times(Power($s("x"),Plus(Plus($s("m"),Times(CN1,$s("n"))),C1)),Cos(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))))),Times(Power(Sin(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),Plus($s("p"),C1)),Power(Times(Times($s("b"),$s("n")),Plus($s("p"),C1)),CN1))),Times(CN1,Times(Times(Plus(Plus($s("m"),Times(CN1,$s("n"))),C1),Power($s("x"),Plus(Plus($s("m"),Times(CN1,Times(C2,$s("n")))),C1))),Times(Power(Sin(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),Plus($s("p"),C2)),Power(Times(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Plus($s("p"),C1)),Plus($s("p"),C2)),CN1))))),Dist(Times(Plus($s("p"),C2),Power(Plus($s("p"),C1),CN1)),Int(Times(Power($s("x"),$s("m")),Power(Sin(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),Plus($s("p"),C2))),$s("x")))),Dist(Times(Plus(Plus($s("m"),Times(CN1,$s("n"))),C1),Times(Plus(Plus($s("m"),Times(CN1,Times(C2,$s("n")))),C1),Power(Times(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Plus($s("p"),C1)),Plus($s("p"),C2)),CN1))),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,Times(C2,$s("n"))))),Power(Sin(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),Plus($s("p"),C2))),$s("x")))),And(And(And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ($s("n"))),RationalQ(List($s("m"),$s("p")))),Less($s("p"),CN1)),Unequal($s("p"),integer(-2L))),Less(Less(C0,Times(C2,$s("n"))),Plus($s("m"),C1))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Sin(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n",true))))),$p("p"))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Times(Power(Sin(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),$s("p")),Power(Plus($s("m"),C1),CN1))),Times(CN1,Times(Times(Times(Times(Times($s("b"),$s("n")),$s("p")),Power($s("x"),Plus(Plus($s("m"),$s("n")),C1))),Cos(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))))),Times(Power(Sin(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),Plus($s("p"),Times(CN1,C1))),Power(Times(Plus($s("m"),C1),Plus(Plus($s("m"),$s("n")),C1)),CN1))))),Times(CN1,Dist(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Times(Power($s("p"),C2),Power(Times(Plus($s("m"),C1),Plus(Plus($s("m"),$s("n")),C1)),CN1))),Int(Times(Power($s("x"),Plus($s("m"),Times(C2,$s("n")))),Power(Sin(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),$s("p"))),$s("x"))))),Dist(Times(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),$s("p")),Times(Plus($s("p"),Times(CN1,C1)),Power(Times(Plus($s("m"),C1),Plus(Plus($s("m"),$s("n")),C1)),CN1))),Int(Times(Power($s("x"),Plus($s("m"),Times(C2,$s("n")))),Power(Sin(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),Plus($s("p"),Times(CN1,C2)))),$s("x")))),And(And(And(And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ($s("n"))),RationalQ(List($s("m"),$s("p")))),Greater($s("p"),C1)),Less($s("m"),CN1)),Greater($s("n"),C0)),NonzeroQ(Plus(Plus($s("m"),$s("n")),C1))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Sin(Plus($p("a",true),Times($p("b",true),Power(Plus($p("c"),Times($p("d",true),$p("x"))),$p("n"))))),$p("p",true))),$p("x",$s("Symbol"))),
    Condition(Dist(Times(C1,Power($s("d"),CN1)),Subst(Int(Times(Power(Plus(Times(Times(CN1,$s("c")),Power($s("d"),CN1)),Times($s("x"),Power($s("d"),CN1))),$s("m")),Power(Sin(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),$s("p"))),$s("x")),$s("x"),Plus($s("c"),Times($s("d"),$s("x"))))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("n")),$s("x")),IntegerQ($s("m"))),Greater($s("m"),C0)),RationalQ($s("p"))))),
SetDelayed(Int(Sin(Plus(Plus($p("a",true),Times($p("b",true),$p("x"))),Times($p("c",true),Power($p("x"),C2)))),$p("x",$s("Symbol"))),
    Condition(Int(Sin(Times(Power(Plus($s("b"),Times(Times(C2,$s("c")),$s("x"))),C2),Power(Times(C4,$s("c")),CN1))),$s("x")),And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),ZeroQ(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c")))))))),
SetDelayed(Int(Sin(Plus(Plus($p("a",true),Times($p("b",true),$p("x"))),Times($p("c",true),Power($p("x"),C2)))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Cos(Times(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c")))),Power(Times(C4,$s("c")),CN1))),Int(Sin(Times(Power(Plus($s("b"),Times(Times(C2,$s("c")),$s("x"))),C2),Power(Times(C4,$s("c")),CN1))),$s("x"))),Times(CN1,Times(Sin(Times(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c")))),Power(Times(C4,$s("c")),CN1))),Int(Cos(Times(Power(Plus($s("b"),Times(Times(C2,$s("c")),$s("x"))),C2),Power(Times(C4,$s("c")),CN1))),$s("x"))))),And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),NonzeroQ(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c")))))))),
SetDelayed(Int(Times(Plus($p("d",true),Times($p("e",true),$p("x"))),Sin(Plus(Plus($p("a",true),Times($p("b",true),$p("x"))),Times($p("c",true),Power($p("x"),C2))))),$p("x",$s("Symbol"))),
    Condition(Times(Times(CN1,$s("e")),Times(Cos(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2)))),Power(Times(C2,$s("c")),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e")),$s("x")),ZeroQ(Plus(Times($s("b"),$s("e")),Times(CN1,Times(Times(C2,$s("c")),$s("d")))))))),
SetDelayed(Int(Times(Plus($p("d",true),Times($p("e",true),$p("x"))),Sin(Plus(Plus($p("a",true),Times($p("b",true),$p("x"))),Times($p("c",true),Power($p("x"),C2))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,$s("e")),Times(Cos(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2)))),Power(Times(C2,$s("c")),CN1))),Times(CN1,Dist(Times(Plus(Times($s("b"),$s("e")),Times(CN1,Times(Times(C2,$s("c")),$s("d")))),Power(Times(C2,$s("c")),CN1)),Int(Sin(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2)))),$s("x"))))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e")),$s("x")),NonzeroQ(Plus(Times($s("b"),$s("e")),Times(CN1,Times(Times(C2,$s("c")),$s("d")))))))),
SetDelayed(Int(Times(Power(Plus($p("d",true),Times($p("e",true),$p("x"))),$p("m")),Sin(Plus(Plus($p("a",true),Times($p("b",true),$p("x"))),Times($p("c",true),Power($p("x"),C2))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(Times(CN1,$s("e")),Power(Plus($s("d"),Times($s("e"),$s("x"))),Plus($s("m"),Times(CN1,C1)))),Times(Cos(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2)))),Power(Times(C2,$s("c")),CN1))),Dist(Times(Power($s("e"),C2),Times(Plus($s("m"),Times(CN1,C1)),Power(Times(C2,$s("c")),CN1))),Int(Times(Power(Plus($s("d"),Times($s("e"),$s("x"))),Plus($s("m"),Times(CN1,C2))),Cos(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e")),$s("x")),RationalQ($s("m"))),Greater($s("m"),C1)),ZeroQ(Plus(Times($s("b"),$s("e")),Times(CN1,Times(Times(C2,$s("c")),$s("d")))))))),
SetDelayed(Int(Times(Power(Plus($p("d",true),Times($p("e",true),$p("x"))),$p("m")),Sin(Plus(Plus($p("a",true),Times($p("b",true),$p("x"))),Times($p("c",true),Power($p("x"),C2))))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(Times(CN1,$s("e")),Power(Plus($s("d"),Times($s("e"),$s("x"))),Plus($s("m"),Times(CN1,C1)))),Times(Cos(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2)))),Power(Times(C2,$s("c")),CN1))),Times(CN1,Dist(Times(Plus(Times($s("b"),$s("e")),Times(CN1,Times(Times(C2,$s("c")),$s("d")))),Power(Times(C2,$s("c")),CN1)),Int(Times(Power(Plus($s("d"),Times($s("e"),$s("x"))),Plus($s("m"),Times(CN1,C1))),Sin(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))))),$s("x"))))),Dist(Times(Power($s("e"),C2),Times(Plus($s("m"),Times(CN1,C1)),Power(Times(C2,$s("c")),CN1))),Int(Times(Power(Plus($s("d"),Times($s("e"),$s("x"))),Plus($s("m"),Times(CN1,C2))),Cos(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e")),$s("x")),RationalQ($s("m"))),Greater($s("m"),C1)),NonzeroQ(Plus(Times($s("b"),$s("e")),Times(CN1,Times(Times(C2,$s("c")),$s("d")))))))),
SetDelayed(Int(Times(Power(Plus($p("d",true),Times($p("e",true),$p("x"))),$p("m")),Sin(Plus(Plus($p("a",true),Times($p("b",true),$p("x"))),Times($p("c",true),Power($p("x"),C2))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power(Plus($s("d"),Times($s("e"),$s("x"))),Plus($s("m"),C1)),Times(Sin(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2)))),Power(Times($s("e"),Plus($s("m"),C1)),CN1))),Times(CN1,Dist(Times(C2,Times($s("c"),Power(Times(Power($s("e"),C2),Plus($s("m"),C1)),CN1))),Int(Times(Power(Plus($s("d"),Times($s("e"),$s("x"))),Plus($s("m"),C2)),Cos(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))))),$s("x"))))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e")),$s("x")),RationalQ($s("m"))),Less($s("m"),CN1)),ZeroQ(Plus(Times($s("b"),$s("e")),Times(CN1,Times(Times(C2,$s("c")),$s("d")))))))),
SetDelayed(Int(Times(Power(Plus($p("d",true),Times($p("e",true),$p("x"))),$p("m")),Sin(Plus(Plus($p("a",true),Times($p("b",true),$p("x"))),Times($p("c",true),Power($p("x"),C2))))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Power(Plus($s("d"),Times($s("e"),$s("x"))),Plus($s("m"),C1)),Times(Sin(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2)))),Power(Times($s("e"),Plus($s("m"),C1)),CN1))),Times(CN1,Dist(Times(Plus(Times($s("b"),$s("e")),Times(CN1,Times(Times(C2,$s("c")),$s("d")))),Power(Times(Power($s("e"),C2),Plus($s("m"),C1)),CN1)),Int(Times(Power(Plus($s("d"),Times($s("e"),$s("x"))),Plus($s("m"),C1)),Cos(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))))),$s("x"))))),Times(CN1,Dist(Times(C2,Times($s("c"),Power(Times(Power($s("e"),C2),Plus($s("m"),C1)),CN1))),Int(Times(Power(Plus($s("d"),Times($s("e"),$s("x"))),Plus($s("m"),C2)),Cos(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))))),$s("x"))))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e")),$s("x")),RationalQ($s("m"))),Less($s("m"),CN1)),NonzeroQ(Plus(Times($s("b"),$s("e")),Times(CN1,Times(Times(C2,$s("c")),$s("d")))))))),
SetDelayed(Int(Sin(Plus($p("a",true),Times($p("b",true),Log(Times($p("c",true),Power($p("x"),$p("n",true))))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times($s("x"),Times(Sin(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Power(Plus(C1,Times(Power($s("b"),C2),Power($s("n"),C2))),CN1))),Times(CN1,Times(Times(Times($s("b"),$s("n")),$s("x")),Times(Cos(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Power(Plus(C1,Times(Power($s("b"),C2),Power($s("n"),C2))),CN1))))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("n")),$s("x")),NonzeroQ(Plus(C1,Times(Power($s("b"),C2),Power($s("n"),C2))))))),
SetDelayed(Int(Power(Sin(Plus($p("a",true),Times($p("b",true),Log(Times($p("c",true),Power($p("x"),$p("n",true))))))),$p("p")),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times($s("x"),Times(Power(Sin(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),$s("p")),Power(Plus(C1,Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Power($s("p"),C2))),CN1))),Times(CN1,Times(Times(Times(Times(Times($s("b"),$s("n")),$s("p")),$s("x")),Cos(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n")))))))),Times(Power(Sin(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),Times(CN1,C1))),Power(Plus(C1,Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Power($s("p"),C2))),CN1))))),Dist(Times(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),$s("p")),Times(Plus($s("p"),Times(CN1,C1)),Power(Plus(C1,Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Power($s("p"),C2))),CN1))),Int(Power(Sin(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),Times(CN1,C2))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("n")),$s("x")),RationalQ($s("p"))),Greater($s("p"),C1)),NonzeroQ(Plus(C1,Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Power($s("p"),C2))))))),
SetDelayed(Int(Power(Sin(Plus($p("a",true),Times($p("b",true),Log(Times($p("c",true),Power($p("x"),$p("n",true))))))),$p("p")),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times($s("x"),Cot(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n")))))))),Times(Power(Sin(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),C2)),Power(Times(Times($s("b"),$s("n")),Plus($s("p"),C1)),CN1))),Times(CN1,Times($s("x"),Times(Power(Sin(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),C2)),Power(Times(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Plus($s("p"),C1)),Plus($s("p"),C2)),CN1))))),Dist(Times(Plus(C1,Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Power(Plus($s("p"),C2),C2))),Power(Times(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Plus($s("p"),C1)),Plus($s("p"),C2)),CN1)),Int(Power(Sin(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),C2)),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("n")),$s("x")),RationalQ($s("p"))),Less($s("p"),CN1)),Unequal($s("p"),integer(-2L))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Sin(Plus($p("a",true),Times($p("b",true),Log(Times($p("c",true),Power($p("x"),$p("n",true)))))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(Plus($s("m"),C1),Power($s("x"),Plus($s("m"),C1))),Times(Sin(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Power(Plus(Times(Power($s("b"),C2),Power($s("n"),C2)),Power(Plus($s("m"),C1),C2)),CN1))),Times(CN1,Times(Times(Times($s("b"),$s("n")),Power($s("x"),Plus($s("m"),C1))),Times(Cos(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Power(Plus(Times(Power($s("b"),C2),Power($s("n"),C2)),Power(Plus($s("m"),C1),C2)),CN1))))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("m"),$s("n")),$s("x")),NonzeroQ(Plus(Times(Power($s("b"),C2),Power($s("n"),C2)),Power(Plus($s("m"),C1),C2)))),NonzeroQ(Plus($s("m"),C1))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Sin(Plus($p("a",true),Times($p("b",true),Log(Times($p("c",true),Power($p("x"),$p("n",true))))))),$p("p"))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(Plus($s("m"),C1),Power($s("x"),Plus($s("m"),C1))),Times(Power(Sin(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),$s("p")),Power(Plus(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Power($s("p"),C2)),Power(Plus($s("m"),C1),C2)),CN1))),Times(CN1,Times(Times(Times(Times(Times($s("b"),$s("n")),$s("p")),Power($s("x"),Plus($s("m"),C1))),Cos(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n")))))))),Times(Power(Sin(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),Times(CN1,C1))),Power(Plus(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Power($s("p"),C2)),Power(Plus($s("m"),C1),C2)),CN1))))),Dist(Times(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),$s("p")),Times(Plus($s("p"),Times(CN1,C1)),Power(Plus(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Power($s("p"),C2)),Power(Plus($s("m"),C1),C2)),CN1))),Int(Times(Power($s("x"),$s("m")),Power(Sin(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),Times(CN1,C2)))),$s("x")))),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("m"),$s("n")),$s("x")),RationalQ($s("p"))),Greater($s("p"),C1)),NonzeroQ(Plus(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Power($s("p"),C2)),Power(Plus($s("m"),C1),C2)))),NonzeroQ(Plus($s("m"),C1))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Sin(Plus($p("a",true),Times($p("b",true),Log(Times($p("c",true),Power($p("x"),$p("n",true))))))),$p("p"))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(Power($s("x"),Plus($s("m"),C1)),Cot(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n")))))))),Times(Power(Sin(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),C2)),Power(Times(Times($s("b"),$s("n")),Plus($s("p"),C1)),CN1))),Times(CN1,Times(Times(Plus($s("m"),C1),Power($s("x"),Plus($s("m"),C1))),Times(Power(Sin(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),C2)),Power(Times(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Plus($s("p"),C1)),Plus($s("p"),C2)),CN1))))),Dist(Times(Plus(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Power(Plus($s("p"),C2),C2)),Power(Plus($s("m"),C1),C2)),Power(Times(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Plus($s("p"),C1)),Plus($s("p"),C2)),CN1)),Int(Times(Power($s("x"),$s("m")),Power(Sin(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),C2))),$s("x")))),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("m"),$s("n")),$s("x")),RationalQ($s("p"))),Less($s("p"),CN1)),Unequal($s("p"),integer(-2L))),NonzeroQ(Plus($s("m"),C1))))),
SetDelayed(Int(Times(Sin(Times(Times($p("a",true),$p("x")),Power(Log(Times($p("b",true),$p("x"))),$p("p",true)))),Power(Log(Times($p("b",true),$p("x"))),$p("p",true))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Cos(Times(Times($s("a"),$s("x")),Power(Log(Times($s("b"),$s("x"))),$s("p"))))),Power($s("a"),CN1)),Times(CN1,Dist($s("p"),Int(Times(Sin(Times(Times($s("a"),$s("x")),Power(Log(Times($s("b"),$s("x"))),$s("p")))),Power(Log(Times($s("b"),$s("x"))),Plus($s("p"),Times(CN1,C1)))),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),RationalQ($s("p"))),Greater($s("p"),C0)))),
SetDelayed(Int(Times(Sin(Times(Times($p("a",true),Power($p("x"),$p("n"))),Power(Log(Times($p("b",true),$p("x"))),$p("p",true)))),Power(Log(Times($p("b",true),$p("x"))),$p("p",true))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(CN1,Cos(Times(Times($s("a"),Power($s("x"),$s("n"))),Power(Log(Times($s("b"),$s("x"))),$s("p"))))),Power(Times(Times($s("a"),$s("n")),Power($s("x"),Plus($s("n"),Times(CN1,C1)))),CN1)),Times(CN1,Dist(Times($s("p"),Power($s("n"),CN1)),Int(Times(Sin(Times(Times($s("a"),Power($s("x"),$s("n"))),Power(Log(Times($s("b"),$s("x"))),$s("p")))),Power(Log(Times($s("b"),$s("x"))),Plus($s("p"),Times(CN1,C1)))),$s("x"))))),Times(CN1,Dist(Times(Plus($s("n"),Times(CN1,C1)),Power(Times($s("a"),$s("n")),CN1)),Int(Times(Cos(Times(Times($s("a"),Power($s("x"),$s("n"))),Power(Log(Times($s("b"),$s("x"))),$s("p")))),Power(Power($s("x"),$s("n")),CN1)),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),RationalQ(List($s("n"),$s("p")))),Greater($s("p"),C0)))),
SetDelayed(Int(Times(Times(Power($p("x"),$p("m")),Sin(Times(Times($p("a",true),Power($p("x"),$p("n",true))),Power(Log(Times($p("b",true),$p("x"))),$p("p",true))))),Power(Log(Times($p("b",true),$p("x"))),$p("p",true))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(CN1,Power($s("x"),Plus(Plus($s("m"),Times(CN1,$s("n"))),C1))),Times(Cos(Times(Times($s("a"),Power($s("x"),$s("n"))),Power(Log(Times($s("b"),$s("x"))),$s("p")))),Power(Times($s("a"),$s("n")),CN1))),Times(CN1,Dist(Times($s("p"),Power($s("n"),CN1)),Int(Times(Times(Power($s("x"),$s("m")),Sin(Times(Times($s("a"),Power($s("x"),$s("n"))),Power(Log(Times($s("b"),$s("x"))),$s("p"))))),Power(Log(Times($s("b"),$s("x"))),Plus($s("p"),Times(CN1,C1)))),$s("x"))))),Dist(Times(Plus(Plus($s("m"),Times(CN1,$s("n"))),C1),Power(Times($s("a"),$s("n")),CN1)),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,$s("n")))),Cos(Times(Times($s("a"),Power($s("x"),$s("n"))),Power(Log(Times($s("b"),$s("x"))),$s("p"))))),$s("x")))),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),RationalQ(List($s("m"),$s("n"),$s("p")))),Greater($s("p"),C0)))),
SetDelayed(Int(Times($p("u"),Power(Sin($p("v")),C2)),$p("x",$s("Symbol"))),
    Condition(Plus(Dist(C1D2,Int($s("u"),$s("x"))),Times(CN1,Dist(C1D2,Int(Times($s("u"),Cos(Times(C2,$s("v")))),$s("x"))))),FunctionOfTrigQ($s("u"),Times(C2,$s("v")),$s("x")))),
SetDelayed(Int(Times(Times($p("u",true),Sin($p("v"))),Cos($p("w"))),$p("x",$s("Symbol"))),
    Condition(Plus(Dist(C1D2,Int(Times($s("u"),Regularize(Sin(Plus($s("v"),$s("w"))),$s("x"))),$s("x"))),Dist(C1D2,Int(Times($s("u"),Regularize(Sin(Plus($s("v"),Times(CN1,$s("w")))),$s("x"))),$s("x")))),And(Or(And(PolynomialQ($s("v"),$s("x")),PolynomialQ($s("w"),$s("x"))),IndependentQ(Cancel(Times($s("v"),Power($s("w"),CN1))),$s("x"))),PosQ(Plus($s("v"),Times(CN1,$s("w"))))))),
SetDelayed(Int(Times(Times($p("u",true),Sin($p("v"))),Sin($p("w"))),$p("x",$s("Symbol"))),
    Condition(Plus(Dist(C1D2,Int(Times($s("u"),Regularize(Cos(Plus($s("v"),Times(CN1,$s("w")))),$s("x"))),$s("x"))),Times(CN1,Dist(C1D2,Int(Times($s("u"),Regularize(Cos(Plus($s("v"),$s("w"))),$s("x"))),$s("x"))))),And(Or(And(PolynomialQ($s("v"),$s("x")),PolynomialQ($s("w"),$s("x"))),IndependentQ(Cancel(Times($s("v"),Power($s("w"),CN1))),$s("x"))),NonzeroQ(Plus($s("v"),Times(CN1,$s("w"))))))),
SetDelayed(Int(Times(Times($p("u",true),Sin($p("v"))),Power(Tan($p("w")),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(CN1,Int(Times(Times($s("u"),Cos($s("v"))),Power(Tan($s("w")),Plus($s("n"),Times(CN1,C1)))),$s("x"))),Times(Cos(Plus($s("v"),Times(CN1,$s("w")))),Int(Times(Times($s("u"),Sec($s("w"))),Power(Tan($s("w")),Plus($s("n"),Times(CN1,C1)))),$s("x")))),And(And(And(RationalQ($s("n")),Greater($s("n"),C0)),FreeQ(Plus($s("v"),Times(CN1,$s("w"))),$s("x"))),NonzeroQ(Plus($s("v"),Times(CN1,$s("w"))))))),
SetDelayed(Int(Times(Times($p("u",true),Sin($p("v"))),Power(Cot($p("w")),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Plus(Int(Times(Times($s("u"),Cos($s("v"))),Power(Cot($s("w")),Plus($s("n"),Times(CN1,C1)))),$s("x")),Times(Sin(Plus($s("v"),Times(CN1,$s("w")))),Int(Times(Times($s("u"),Csc($s("w"))),Power(Cot($s("w")),Plus($s("n"),Times(CN1,C1)))),$s("x")))),And(And(And(RationalQ($s("n")),Greater($s("n"),C0)),FreeQ(Plus($s("v"),Times(CN1,$s("w"))),$s("x"))),NonzeroQ(Plus($s("v"),Times(CN1,$s("w"))))))),
SetDelayed(Int(Times(Times($p("u",true),Sin($p("v"))),Power(Sec($p("w")),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Cos(Plus($s("v"),Times(CN1,$s("w")))),Int(Times(Times($s("u"),Tan($s("w"))),Power(Sec($s("w")),Plus($s("n"),Times(CN1,C1)))),$s("x"))),Times(Sin(Plus($s("v"),Times(CN1,$s("w")))),Int(Times($s("u"),Power(Sec($s("w")),Plus($s("n"),Times(CN1,C1)))),$s("x")))),And(And(And(RationalQ($s("n")),Greater($s("n"),C0)),FreeQ(Plus($s("v"),Times(CN1,$s("w"))),$s("x"))),NonzeroQ(Plus($s("v"),Times(CN1,$s("w"))))))),
SetDelayed(Int(Times(Times($p("u",true),Sin($p("v"))),Power(Csc($p("w")),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Sin(Plus($s("v"),Times(CN1,$s("w")))),Int(Times(Times($s("u"),Cot($s("w"))),Power(Csc($s("w")),Plus($s("n"),Times(CN1,C1)))),$s("x"))),Times(Cos(Plus($s("v"),Times(CN1,$s("w")))),Int(Times($s("u"),Power(Csc($s("w")),Plus($s("n"),Times(CN1,C1)))),$s("x")))),And(And(And(RationalQ($s("n")),Greater($s("n"),C0)),FreeQ(Plus($s("v"),Times(CN1,$s("w"))),$s("x"))),NonzeroQ(Plus($s("v"),Times(CN1,$s("w"))))))),
SetDelayed(Int(Cos(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("x",$s("Symbol"))),
    Condition(Times(Sin(Plus($s("a"),Times($s("b"),$s("x")))),Power($s("b"),CN1)),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(Power(Cos(Plus($p("a",true),Times($p("b",true),$p("x")))),C2),$p("x",$s("Symbol"))),
    Condition(Plus(Times($s("x"),C1D2),Times(Cos(Plus($s("a"),Times($s("b"),$s("x")))),Times(Sin(Plus($s("a"),Times($s("b"),$s("x")))),Power(Times(C2,$s("b")),CN1)))),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(Power(Cos(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Dist(Times(C1,Power($s("b"),CN1)),Subst(Int(Regularize(Power(Plus(C1,Times(CN1,Power($s("x"),C2))),Times(Plus($s("n"),Times(CN1,C1)),C1D2)),$s("x")),$s("x")),$s("x"),Sin(Plus($s("a"),Times($s("b"),$s("x")))))),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),OddQ($s("n"))),Greater($s("n"),C1)))),
SetDelayed(Int(Power(Times($p("c",true),Cos(Plus($p("a",true),Times($p("b",true),$p("x"))))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times($s("c"),Sin(Plus($s("a"),Times($s("b"),$s("x"))))),Times(Power(Times($s("c"),Cos(Plus($s("a"),Times($s("b"),$s("x"))))),Plus($s("n"),Times(CN1,C1))),Power(Times($s("b"),$s("n")),CN1))),Dist(Times(Plus($s("n"),Times(CN1,C1)),Times(Power($s("c"),C2),Power($s("n"),CN1))),Int(Power(Times($s("c"),Cos(Plus($s("a"),Times($s("b"),$s("x"))))),Plus($s("n"),Times(CN1,C2))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),RationalQ($s("n"))),Greater($s("n"),C1)),Not(OddQ($s("n")))))),
SetDelayed(Int(Power(Times($p("c",true),Cos(Plus($p("a",true),Times($p("b",true),$p("x"))))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Sin(Plus($s("a"),Times($s("b"),$s("x"))))),Times(Power(Times($s("c"),Cos(Plus($s("a"),Times($s("b"),$s("x"))))),Plus($s("n"),C1)),Power(Times(Times($s("c"),$s("b")),Plus($s("n"),C1)),CN1))),Dist(Times(Plus($s("n"),C2),Power(Times(Plus($s("n"),C1),Power($s("c"),C2)),CN1)),Int(Power(Times($s("c"),Cos(Plus($s("a"),Times($s("b"),$s("x"))))),Plus($s("n"),C2)),$s("x")))),And(And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),RationalQ($s("n"))),Less($s("n"),CN1)))),
SetDelayed(Int(Power(Times($p("c"),Cos(Plus($p("a",true),Times($p("b",true),$p("x"))))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Times(Times(Power(Times($s("c"),Cos(Plus($s("a"),Times($s("b"),$s("x"))))),$s("n")),Power(Power(Cos(Plus($s("a"),Times($s("b"),$s("x")))),$s("n")),CN1)),Int(Power(Cos(Plus($s("a"),Times($s("b"),$s("x")))),$s("n")),$s("x"))),And(And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),RationalQ($s("n"))),Less(Less(CN1,$s("n")),C1)))),
SetDelayed(Int(Times(C1,Power(Plus($p("a"),Times($p("b",true),Cos(Plus($p("c",true),Times($p("d",true),$p("x")))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Sin(Plus($s("c"),Times($s("d"),$s("x")))),Power(Times($s("d"),Plus($s("b"),Times($s("a"),Cos(Plus($s("c"),Times($s("d"),$s("x"))))))),CN1)),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),ZeroQ(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))))))),
SetDelayed(Int(Times(C1,Power(Plus($p("a"),Times($p("b",true),Cos(Plus($p("c",true),Times($p("d",true),$p("x")))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(C2,Times(ArcTan(Times(Times(Plus($s("a"),Times(CN1,$s("b"))),Tan(Times(Plus($s("c"),Times($s("d"),$s("x"))),C1D2))),Power(Rt(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))),C2),CN1))),Power(Times($s("d"),Rt(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))),C2)),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),PosQ(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))))))),
SetDelayed(Int(Times(C1,Power(Plus($p("a"),Times($p("b",true),Cos(Plus($p("c",true),Times($p("d",true),$p("x")))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(integer(-2L),Times(ArcTanh(Times(Times(Plus($s("a"),Times(CN1,$s("b"))),Tan(Times(Plus($s("c"),Times($s("d"),$s("x"))),C1D2))),Power(Rt(Plus(Power($s("b"),C2),Times(CN1,Power($s("a"),C2))),C2),CN1))),Power(Times($s("d"),Rt(Plus(Power($s("b"),C2),Times(CN1,Power($s("a"),C2))),C2)),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),NegQ(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))))))),
SetDelayed(Int(Sqrt(Plus($p("a"),Times($p("b",true),Cos(Plus($p("c",true),Times($p("d",true),$p("x"))))))),$p("x",$s("Symbol"))),
    Condition(Times(Times(C2,$s("b")),Times(Sin(Plus($s("c"),Times($s("d"),$s("x")))),Power(Times($s("d"),Sqrt(Plus($s("a"),Times($s("b"),Cos(Plus($s("c"),Times($s("d"),$s("x")))))))),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),ZeroQ(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))))))),
SetDelayed(Int(Sqrt(Plus($p("a",true),Times($p("b",true),Cos(Plus($p("c",true),Times($p("d",true),$p("x"))))))),$p("x",$s("Symbol"))),
    Condition(Times(Times(C2,Sqrt(Plus($s("a"),$s("b")))),Times(EllipticE(Times(Plus($s("c"),Times($s("d"),$s("x"))),C1D2),Times(C2,Times($s("b"),Power(Plus($s("a"),$s("b")),CN1)))),Power($s("d"),CN1))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),NonzeroQ(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))))),PositiveQ(Plus($s("a"),$s("b")))))),
SetDelayed(Int(Sqrt(Plus($p("a",true),Times($p("b",true),Cos(Plus($p("c",true),Times($p("d",true),$p("x"))))))),$p("x",$s("Symbol"))),
    Condition(Times(Times(Sqrt(Plus($s("a"),Times($s("b"),Cos(Plus($s("c"),Times($s("d"),$s("x"))))))),Power(Sqrt(Times(Plus($s("a"),Times($s("b"),Cos(Plus($s("c"),Times($s("d"),$s("x")))))),Power(Plus($s("a"),$s("b")),CN1))),CN1)),Int(Sqrt(Plus(Times($s("a"),Power(Plus($s("a"),$s("b")),CN1)),Times(Times($s("b"),Power(Plus($s("a"),$s("b")),CN1)),Cos(Plus($s("c"),Times($s("d"),$s("x"))))))),$s("x"))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),NonzeroQ(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))))),Not(PositiveQ(Plus($s("a"),$s("b"))))))),
SetDelayed(Int(Times(C1,Power(Sqrt(Plus($p("a"),Times($p("b",true),Cos(Plus($p("c",true),Times($p("d",true),$p("x"))))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Times(integer(-2L),ArcTanh(Cos(Times(Plus($s("c"),Times($s("d"),$s("x"))),C1D2)))),Times(Sin(Times(Plus($s("c"),Times($s("d"),$s("x"))),C1D2)),Power(Times($s("d"),Sqrt(Plus($s("a"),Times($s("b"),Cos(Plus($s("c"),Times($s("d"),$s("x")))))))),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),ZeroQ(Plus($s("a"),$s("b")))))),
SetDelayed(Int(Times(C1,Power(Sqrt(Plus($p("a"),Times($p("b",true),Cos(Plus($p("c",true),Times($p("d",true),$p("x"))))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Times(C2,ArcTanh(Sin(Times(Plus($s("c"),Times($s("d"),$s("x"))),C1D2)))),Times(Cos(Times(Plus($s("c"),Times($s("d"),$s("x"))),C1D2)),Power(Times($s("d"),Sqrt(Plus($s("a"),Times($s("b"),Cos(Plus($s("c"),Times($s("d"),$s("x")))))))),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),ZeroQ(Plus($s("a"),Times(CN1,$s("b"))))))),
SetDelayed(Int(Times(C1,Power(Sqrt(Plus($p("a",true),Times($p("b",true),Cos(Plus($p("c",true),Times($p("d",true),$p("x"))))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(C2,Times(EllipticF(Times(Plus($s("c"),Times($s("d"),$s("x"))),C1D2),Times(C2,Times($s("b"),Power(Plus($s("a"),$s("b")),CN1)))),Power(Times($s("d"),Sqrt(Plus($s("a"),$s("b")))),CN1))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),NonzeroQ(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))))),PositiveQ(Plus($s("a"),$s("b")))))),
SetDelayed(Int(Times(C1,Power(Sqrt(Plus($p("a"),Times($p("b",true),Cos(Plus($p("c",true),Times($p("d",true),$p("x"))))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Times(Sqrt(Times(Plus($s("a"),Times($s("b"),Cos(Plus($s("c"),Times($s("d"),$s("x")))))),Power(Plus($s("a"),$s("b")),CN1))),Power(Sqrt(Plus($s("a"),Times($s("b"),Cos(Plus($s("c"),Times($s("d"),$s("x"))))))),CN1)),Int(Times(C1,Power(Sqrt(Plus(Times($s("a"),Power(Plus($s("a"),$s("b")),CN1)),Times(Times($s("b"),Power(Plus($s("a"),$s("b")),CN1)),Cos(Plus($s("c"),Times($s("d"),$s("x"))))))),CN1)),$s("x"))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),NonzeroQ(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))))),Not(PositiveQ(Plus($s("a"),$s("b"))))))),
SetDelayed(Int(Power(Plus($p("a"),Times($p("b",true),Cos(Plus($p("c",true),Times($p("d",true),$p("x")))))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times($s("b"),Sin(Plus($s("c"),Times($s("d"),$s("x"))))),Times(Power(Plus($s("a"),Times($s("b"),Cos(Plus($s("c"),Times($s("d"),$s("x")))))),Plus($s("n"),Times(CN1,C1))),Power(Times($s("d"),$s("n")),CN1))),Dist(Times($s("a"),Times(Plus(Times(C2,$s("n")),Times(CN1,C1)),Power($s("n"),CN1))),Int(Power(Plus($s("a"),Times($s("b"),Cos(Plus($s("c"),Times($s("d"),$s("x")))))),Plus($s("n"),Times(CN1,C1))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),FractionQ($s("n"))),Greater($s("n"),C1)),ZeroQ(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))))))),
SetDelayed(Int(Power(Plus($p("a"),Times($p("b",true),Cos(Plus($p("c",true),Times($p("d",true),$p("x")))))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(Times(CN1,$s("b")),Sin(Plus($s("c"),Times($s("d"),$s("x"))))),Times(Power(Plus($s("a"),Times($s("b"),Cos(Plus($s("c"),Times($s("d"),$s("x")))))),$s("n")),Power(Times(Times($s("a"),$s("d")),Plus(Times(C2,$s("n")),C1)),CN1))),Dist(Times(Plus($s("n"),C1),Power(Times($s("a"),Plus(Times(C2,$s("n")),C1)),CN1)),Int(Power(Plus($s("a"),Times($s("b"),Cos(Plus($s("c"),Times($s("d"),$s("x")))))),Plus($s("n"),C1)),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),RationalQ($s("n"))),Less($s("n"),CN1)),ZeroQ(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))))))),
SetDelayed(Int(Times(C1,Power(Power(Plus($p("a"),Times($p("b",true),Cos(Plus($p("c",true),Times($p("d",true),$p("x")))))),C2),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,$s("b")),Times(Sin(Plus($s("c"),Times($s("d"),$s("x")))),Power(Times(Times($s("d"),Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2)))),Plus($s("a"),Times($s("b"),Cos(Plus($s("c"),Times($s("d"),$s("x"))))))),CN1))),Dist(Times($s("a"),Power(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))),CN1)),Int(Times(C1,Power(Plus($s("a"),Times($s("b"),Cos(Plus($s("c"),Times($s("d"),$s("x")))))),CN1)),$s("x")))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),NonzeroQ(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))))))),
SetDelayed(Int(Power(Plus($p("a"),Times($p("b",true),Cos(Plus($p("c",true),Times($p("d",true),$p("x")))))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times($s("b"),Sin(Plus($s("c"),Times($s("d"),$s("x"))))),Times(Power(Plus($s("a"),Times($s("b"),Cos(Plus($s("c"),Times($s("d"),$s("x")))))),Plus($s("n"),C1)),Power(Times(Times($s("d"),Plus($s("n"),C1)),Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2)))),CN1))),Dist(Times(C1,Power(Times(Plus($s("n"),C1),Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2)))),CN1)),Int(Times(Plus(Times($s("a"),Plus($s("n"),C1)),Times(CN1,Times(Times($s("b"),Plus($s("n"),C2)),Cos(Plus($s("c"),Times($s("d"),$s("x"))))))),Power(Plus($s("a"),Times($s("b"),Cos(Plus($s("c"),Times($s("d"),$s("x")))))),Plus($s("n"),C1))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),RationalQ($s("n"))),Less($s("n"),CN1)),NonzeroQ(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Plus($p("a"),Times($p("b",true),Cos(Plus($p("c",true),Times($p("d",true),$p("x")))))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Dist(Power(Times(C2,$s("a")),$s("n")),Int(Times(Power($s("x"),$s("m")),Power(Cos(Plus(Times($s("c"),C1D2),Times($s("d"),Times($s("x"),C1D2)))),Times(C2,$s("n")))),$s("x"))),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),RationalQ($s("m"))),IntegerQ($s("n"))),Less($s("n"),C0)),ZeroQ(Plus($s("a"),Times(CN1,$s("b"))))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Plus($p("a"),Times($p("b",true),Cos(Plus($p("c",true),Times($p("d",true),$p("x")))))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Dist(Power(C2,$s("n")),Int(Times(Power($s("x"),$s("m")),Power(Times($s("a"),Power(Cos(Plus(Times($s("c"),C1D2),Times($s("d"),Times($s("x"),C1D2)))),C2)),$s("n"))),$s("x"))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),RationalQ(List($s("m"),$s("n")))),ZeroQ(Plus($s("a"),Times(CN1,$s("b"))))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Plus($p("a"),Times($p("b",true),Cos(Plus($p("c",true),Times($p("d",true),$p("x")))))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Dist(Power(Times(C2,$s("a")),$s("n")),Int(Times(Power($s("x"),$s("m")),Power(Sin(Plus(Times($s("c"),C1D2),Times($s("d"),Times($s("x"),C1D2)))),Times(C2,$s("n")))),$s("x"))),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),RationalQ($s("m"))),IntegerQ($s("n"))),Less($s("n"),C0)),ZeroQ(Plus($s("a"),$s("b")))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Plus($p("a"),Times($p("b",true),Cos(Plus($p("c",true),Times($p("d",true),$p("x")))))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Dist(Power(C2,$s("n")),Int(Times(Power($s("x"),$s("m")),Power(Times($s("a"),Power(Sin(Plus(Times($s("c"),C1D2),Times($s("d"),Times($s("x"),C1D2)))),C2)),$s("n"))),$s("x"))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),RationalQ(List($s("m"),$s("n")))),ZeroQ(Plus($s("a"),$s("b")))))),
SetDelayed(Int(Times($p("x"),Power(Power(Plus($p("a"),Times($p("b",true),Cos(Plus($p("c",true),Times($p("d",true),$p("x")))))),C2),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Dist(Times($s("a"),Power(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))),CN1)),Int(Times($s("x"),Power(Plus($s("a"),Times($s("b"),Cos(Plus($s("c"),Times($s("d"),$s("x")))))),CN1)),$s("x"))),Times(CN1,Dist(Times($s("b"),Power(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))),CN1)),Int(Times($s("x"),Times(Plus($s("b"),Times($s("a"),Cos(Plus($s("c"),Times($s("d"),$s("x")))))),Power(Power(Plus($s("a"),Times($s("b"),Cos(Plus($s("c"),Times($s("d"),$s("x")))))),C2),CN1))),$s("x"))))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),NonzeroQ(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Plus($p("a"),Times($p("b",true),Cos(Plus($p("c",true),Times($p("d",true),$p("x")))))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Dist(Times(C1,Power(Power(C2,$s("n")),CN1)),Int(Times(Power($s("x"),$s("m")),Times(Power(Plus(Plus($s("b"),Times(Times(C2,$s("a")),Power(E,Plus(Times(CI,$s("c")),Times(Times(CI,$s("d")),$s("x")))))),Times($s("b"),Power(E,Times(C2,Plus(Times(CI,$s("c")),Times(Times(CI,$s("d")),$s("x"))))))),$s("n")),Power(Power(E,Times($s("n"),Plus(Times(CI,$s("c")),Times(Times(CI,$s("d")),$s("x"))))),CN1))),$s("x"))),And(And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),NonzeroQ(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))))),IntegerQ($s("n"))),Less($s("n"),C0)),RationalQ($s("m"))),Greater($s("m"),C0)))),
SetDelayed(Int(Times(Plus($p("A",true),Times($p("B",true),Cos(Plus($p("c",true),Times($p("d",true),$p("x")))))),Power(Sqrt(Plus($p("a"),Times($p("b",true),Cos(Plus($p("c",true),Times($p("d",true),$p("x"))))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Dist(Times(Plus(Times($s("b"),$s("A")),Times(CN1,Times($s("a"),$s("B")))),Power($s("b"),CN1)),Int(Times(C1,Power(Sqrt(Plus($s("a"),Times($s("b"),Cos(Plus($s("c"),Times($s("d"),$s("x"))))))),CN1)),$s("x"))),Dist(Times($s("B"),Power($s("b"),CN1)),Int(Sqrt(Plus($s("a"),Times($s("b"),Cos(Plus($s("c"),Times($s("d"),$s("x"))))))),$s("x")))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("A"),$s("B")),$s("x")),NonzeroQ(Plus(Times($s("b"),$s("A")),Times(CN1,Times($s("a"),$s("B")))))))),
SetDelayed(Int(Times(Plus($p("A",true),Times($p("B",true),Cos(Plus($p("c",true),Times($p("d",true),$p("x")))))),Power(Plus($p("a"),Times($p("b",true),Cos(Plus($p("c",true),Times($p("d",true),$p("x")))))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times($s("B"),Sin(Plus($s("c"),Times($s("d"),$s("x"))))),Times(Power(Plus($s("a"),Times($s("b"),Cos(Plus($s("c"),Times($s("d"),$s("x")))))),$s("n")),Power(Times($s("d"),Plus($s("n"),C1)),CN1))),Dist(Times(C1,Power(Plus($s("n"),C1),CN1)),Int(Times(Plus(Plus(Times(Times($s("b"),$s("B")),$s("n")),Times(Times($s("a"),$s("A")),Plus($s("n"),C1))),Times(Plus(Times(Times($s("a"),$s("B")),$s("n")),Times(Times($s("b"),$s("A")),Plus($s("n"),C1))),Cos(Plus($s("c"),Times($s("d"),$s("x")))))),Power(Plus($s("a"),Times($s("b"),Cos(Plus($s("c"),Times($s("d"),$s("x")))))),Plus($s("n"),Times(CN1,C1)))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("A"),$s("B")),$s("x")),RationalQ($s("n"))),Greater($s("n"),C1)),NonzeroQ(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))))))),
SetDelayed(Int(Times(Plus($p("A"),Times($p("B",true),Cos(Plus($p("c",true),Times($p("d",true),$p("x")))))),Power(Power(Plus($p("a"),Times($p("b",true),Cos(Plus($p("c",true),Times($p("d",true),$p("x")))))),C2),CN1)),$p("x",$s("Symbol"))),
    Condition(Times($s("B"),Times(Sin(Plus($s("c"),Times($s("d"),$s("x")))),Power(Times(Times($s("a"),$s("d")),Plus($s("a"),Times($s("b"),Cos(Plus($s("c"),Times($s("d"),$s("x"))))))),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("A"),$s("B")),$s("x")),ZeroQ(Plus(Times($s("a"),$s("A")),Times(CN1,Times($s("b"),$s("B")))))))),
SetDelayed(Int(Times($p("x"),Times(Plus($p("A"),Times($p("B",true),Cos(Plus($p("c",true),Times($p("d",true),$p("x")))))),Power(Power(Plus($p("a"),Times($p("b",true),Cos(Plus($p("c",true),Times($p("d",true),$p("x")))))),C2),CN1))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times($s("B"),$s("x")),Times(Sin(Plus($s("c"),Times($s("d"),$s("x")))),Power(Times(Times($s("a"),$s("d")),Plus($s("a"),Times($s("b"),Cos(Plus($s("c"),Times($s("d"),$s("x"))))))),CN1))),Times(CN1,Dist(Times($s("B"),Power(Times($s("a"),$s("d")),CN1)),Int(Times(Sin(Plus($s("c"),Times($s("d"),$s("x")))),Power(Plus($s("a"),Times($s("b"),Cos(Plus($s("c"),Times($s("d"),$s("x")))))),CN1)),$s("x"))))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("A"),$s("B")),$s("x")),ZeroQ(Plus(Times($s("a"),$s("A")),Times(CN1,Times($s("b"),$s("B")))))))),
SetDelayed(Int(Times(Plus($p("A",true),Times($p("B",true),Cos(Plus($p("c",true),Times($p("d",true),$p("x")))))),Power(Plus($p("a",true),Times($p("b",true),Cos(Plus($p("c",true),Times($p("d",true),$p("x")))))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(Times(CN1,Plus(Times($s("a"),$s("B")),Times(CN1,Times($s("b"),$s("A"))))),Sin(Plus($s("c"),Times($s("d"),$s("x"))))),Times(Power(Plus($s("a"),Times($s("b"),Cos(Plus($s("c"),Times($s("d"),$s("x")))))),Plus($s("n"),C1)),Power(Times(Times($s("d"),Plus($s("n"),C1)),Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2)))),CN1))),Dist(Times(C1,Power(Times(Plus($s("n"),C1),Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2)))),CN1)),Int(Times(Plus(Times(Plus($s("n"),C1),Plus(Times($s("a"),$s("A")),Times(CN1,Times($s("b"),$s("B"))))),Times(Times(Plus($s("n"),C2),Plus(Times($s("a"),$s("B")),Times(CN1,Times($s("b"),$s("A"))))),Cos(Plus($s("c"),Times($s("d"),$s("x")))))),Power(Plus($s("a"),Times($s("b"),Cos(Plus($s("c"),Times($s("d"),$s("x")))))),Plus($s("n"),C1))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("A"),$s("B")),$s("x")),RationalQ($s("n"))),Less($s("n"),CN1)),NonzeroQ(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Plus($p("a"),Times($p("b",true),Power(Cos(Plus($p("c",true),Times($p("d",true),$p("x")))),C2))),CN1)),$p("x",$s("Symbol"))),
    Condition(Dist(C2,Int(Times(Power($s("x"),$s("m")),Power(Plus(Plus(Times(C2,$s("a")),$s("b")),Times($s("b"),Cos(Plus(Times(C2,$s("c")),Times(Times(C2,$s("d")),$s("x")))))),CN1)),$s("x"))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),NonzeroQ(Plus($s("a"),$s("b")))),IntegerQ($s("m"))),Greater($s("m"),C0)))),
SetDelayed(Int(Power(Plus($p("a"),Times($p("b",true),Power(Cos(Plus($p("c",true),Times($p("d",true),$p("x")))),C2))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Dist(Times(C1,Power(Power(C2,$s("n")),CN1)),Int(Power(Plus(Plus(Times(C2,$s("a")),$s("b")),Times($s("b"),Cos(Plus(Times(C2,$s("c")),Times(Times(C2,$s("d")),$s("x")))))),$s("n")),$s("x"))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),NonzeroQ(Plus($s("a"),$s("b")))),HalfIntegerQ($s("n"))))),
SetDelayed(Int(Times(Power(Sin(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m")),Power(Cos(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Times(Times(CN1,Power(Sin(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),C1))),Times(Power(Cos(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C1)),Power(Times($s("b"),Plus($s("n"),C1)),CN1))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("m"),$s("n")),$s("x")),ZeroQ(Plus(Plus($s("m"),$s("n")),C2))),NonzeroQ(Plus($s("n"),C1))),PosQ($s("n"))))),
SetDelayed(Int(Times(Power(Sin(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m")),Power(Cos(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Dist(Times(CN1,Power($s("b"),CN1)),Subst(Int(Regularize(Times(Power($s("x"),$s("n")),Power(Plus(C1,Times(CN1,Power($s("x"),C2))),Times(Plus($s("m"),Times(CN1,C1)),C1D2))),$s("x")),$s("x")),$s("x"),Cos(Plus($s("a"),Times($s("b"),$s("x")))))),And(And(FreeQ(List($s("a"),$s("b"),$s("n")),$s("x")),OddQ($s("m"))),Not(And(OddQ($s("n")),And(Less(C0,$s("n")),LessEqual($s("n"),$s("m")))))))),
SetDelayed(Int(Times(Power(Sin(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m")),Power(Cos(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power(Sin(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),C1)),Times(Power(Cos(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C1))),Power(Times($s("b"),Plus($s("m"),C1)),CN1))),Dist(Times(Plus($s("n"),Times(CN1,C1)),Power(Plus($s("m"),C1),CN1)),Int(Times(Power(Sin(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),C2)),Power(Cos(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C2)))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),RationalQ(List($s("m"),$s("n")))),Less($s("m"),CN1)),Greater($s("n"),C1)))),
SetDelayed(Int(Times(Power(Sin(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m")),Power(Cos(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power(Sin(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),C1)),Times(Power(Cos(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C1))),Power(Times($s("b"),Plus($s("m"),$s("n"))),CN1))),Dist(Times(Plus($s("n"),Times(CN1,C1)),Power(Plus($s("m"),$s("n")),CN1)),Int(Times(Power(Sin(Plus($s("a"),Times($s("b"),$s("x")))),$s("m")),Power(Cos(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C2)))),$s("x")))),And(And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("m")),$s("x")),RationalQ($s("n"))),Greater($s("n"),C1)),Not(OddQ($s("n")))),NonzeroQ(Plus($s("m"),$s("n")))),Not(And(OddQ($s("m")),Greater($s("m"),C1)))))),
SetDelayed(Int(Times(Power(Sin(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m")),Power(Cos(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Power(Sin(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),C1))),Times(Power(Cos(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C1)),Power(Times($s("b"),Plus($s("n"),C1)),CN1))),Dist(Times(Plus(Plus($s("m"),$s("n")),C2),Power(Plus($s("n"),C1),CN1)),Int(Times(Power(Sin(Plus($s("a"),Times($s("b"),$s("x")))),$s("m")),Power(Cos(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C2))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("m")),$s("x")),RationalQ($s("n"))),Less($s("n"),CN1)),NonzeroQ(Plus(Plus($s("m"),$s("n")),C2))))),
SetDelayed(Int(Times(Power(Sin(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m")),Power(Cos(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Dist(Times(CN1,Power(Times($s("b"),$s("n")),CN1)),Subst(Int(Times(Power($s("x"),Times(C1,Power($s("n"),CN1))),Power(Plus(C1,Power($s("x"),Times(C2,Power($s("n"),CN1)))),CN1)),$s("x")),$s("x"),Times(Power(Sin(Plus($s("a"),Times($s("b"),$s("x")))),$s("m")),Power(Cos(Plus($s("a"),Times($s("b"),$s("x")))),$s("n"))))),And(And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),FractionQ(List($s("m"),$s("n")))),ZeroQ(Plus($s("m"),$s("n")))),IntegerQ(Times(C1,Power($s("n"),CN1)))),Greater($s("n"),C0)))),
SetDelayed(Int(Times(Cos(Plus($p("a",true),Times($p("b",true),$p("x")))),Cot(Plus($p("a",true),Times($p("b",true),$p("x"))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Cos(Plus($s("a"),Times($s("b"),$s("x")))),Power($s("b"),CN1)),Int(Csc(Plus($s("a"),Times($s("b"),$s("x")))),$s("x"))),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(Times(Power(Cos(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m")),Power(Cot(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Times(Power(Cos(Plus($s("a"),Times($s("b"),$s("x")))),$s("m")),Times(Power(Cot(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C1))),Power(Times($s("b"),$s("m")),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("m"),$s("n")),$s("x")),ZeroQ(Plus(Plus($s("m"),$s("n")),Times(CN1,C1)))))),
SetDelayed(Int(Times(Power(Cos(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m",true)),Power(Cot(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Dist(Times(C1,Power($s("b"),CN1)),Subst(Int(Regularize(Times(Power(Plus(C1,Times(CN1,Power($s("x"),C2))),Times(Plus(Plus($s("m"),$s("n")),Times(CN1,C1)),C1D2)),Power(Power($s("x"),$s("n")),CN1)),$s("x")),$s("x")),$s("x"),Sin(Plus($s("a"),Times($s("b"),$s("x")))))),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ(List($s("m"),$s("n")))),OddQ(Plus($s("m"),$s("n"))))))
  );
}
