package org.matheclipse.core.integrate.rubi;


import static org.matheclipse.core.expression.F.*;
import static org.matheclipse.core.integrate.rubi.UtilityFunctionCtors.*;
import static org.matheclipse.core.integrate.rubi.UtilityFunctions.*;
import org.matheclipse.core.interfaces.IAST;
import org.matheclipse.core.interfaces.IExpr;

/** 
 * IndefiniteIntegrationRules from the <a href="http://www.apmaths.uwo.ca/~arich/">Rubi -
 * rule-based integrator</a>.
 *  
 */
public class IndefiniteIntegrationRules5 { 
  public static IAST RULES = List( 
SetDelayed(Int(Times(Power(Cos(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m")),Power(Cot(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Power(Cos(Plus($s("a"),Times($s("b"),$s("x")))),$s("m"))),Times(Power(Cot(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C1)),Power(Times($s("b"),$s("m")),CN1))),Times(CN1,Dist(Times(Plus($s("n"),C1),Power($s("m"),CN1)),Int(Times(Power(Cos(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),Times(CN1,C2))),Power(Cot(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C2))),$s("x"))))),And(And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),RationalQ(List($s("m"),$s("n")))),Greater($s("m"),C1)),Less($s("n"),CN1)),Not(And(OddQ($s("m")),EvenQ($s("n"))))))),
SetDelayed(Int(Times(Power(Cos(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m")),Power(Cot(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Power(Cos(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),C2))),Times(Power(Cot(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C1))),Power(Times($s("b"),Plus($s("n"),Times(CN1,C1))),CN1))),Times(CN1,Dist(Times(Plus($s("m"),C2),Power(Plus($s("n"),Times(CN1,C1)),CN1)),Int(Times(Power(Cos(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),C2)),Power(Cot(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C2)))),$s("x"))))),And(And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),RationalQ(List($s("m"),$s("n")))),Less($s("m"),CN1)),Greater($s("n"),C1)),Not(And(OddQ($s("m")),EvenQ($s("n"))))))),
SetDelayed(Int(Times(Power(Cos(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m")),Power(Cot(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power(Cos(Plus($s("a"),Times($s("b"),$s("x")))),$s("m")),Times(Power(Cot(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C1))),Power(Times($s("b"),$s("m")),CN1))),Dist(Times(Plus(Plus($s("m"),$s("n")),Times(CN1,C1)),Power($s("m"),CN1)),Int(Times(Power(Cos(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),Times(CN1,C2))),Power(Cot(Plus($s("a"),Times($s("b"),$s("x")))),$s("n"))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("n")),$s("x")),RationalQ($s("m"))),Greater($s("m"),C1)),Not(And(OddQ($s("m")),EvenQ($s("n"))))))),
SetDelayed(Int(Times(Power(Cos(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m",true)),Power(Cot(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Power(Cos(Plus($s("a"),Times($s("b"),$s("x")))),$s("m"))),Times(Power(Cot(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C1))),Power(Times($s("b"),Plus($s("n"),Times(CN1,C1))),CN1))),Times(CN1,Dist(Times(Plus(Plus($s("m"),$s("n")),Times(CN1,C1)),Power(Plus($s("n"),Times(CN1,C1)),CN1)),Int(Times(Power(Cos(Plus($s("a"),Times($s("b"),$s("x")))),$s("m")),Power(Cot(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C2)))),$s("x"))))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("m")),$s("x")),RationalQ($s("n"))),Greater($s("n"),C1)),Not(And(OddQ($s("m")),EvenQ($s("n"))))))),
SetDelayed(Int(Times(Power(Cos(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m")),Power(Cot(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Power(Cos(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),C2))),Times(Power(Cot(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C1))),Power(Times($s("b"),Plus(Plus($s("m"),$s("n")),C1)),CN1))),Dist(Times(Plus($s("m"),C2),Power(Plus(Plus($s("m"),$s("n")),C1),CN1)),Int(Times(Power(Cos(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),C2)),Power(Cot(Plus($s("a"),Times($s("b"),$s("x")))),$s("n"))),$s("x")))),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("n")),$s("x")),RationalQ($s("m"))),Less($s("m"),CN1)),NonzeroQ(Plus(Plus($s("m"),$s("n")),C1))),Not(And(OddQ($s("m")),EvenQ($s("n"))))))),
SetDelayed(Int(Times(Power(Cos(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m",true)),Power(Cot(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Power(Cos(Plus($s("a"),Times($s("b"),$s("x")))),$s("m"))),Times(Power(Cot(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C1)),Power(Times($s("b"),Plus(Plus($s("m"),$s("n")),C1)),CN1))),Times(CN1,Dist(Times(Plus($s("n"),C1),Power(Plus(Plus($s("m"),$s("n")),C1),CN1)),Int(Times(Power(Cos(Plus($s("a"),Times($s("b"),$s("x")))),$s("m")),Power(Cot(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C2))),$s("x"))))),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("m")),$s("x")),RationalQ($s("n"))),Less($s("n"),CN1)),NonzeroQ(Plus(Plus($s("m"),$s("n")),C1))),Not(And(OddQ($s("m")),EvenQ($s("n"))))))),
SetDelayed(Int(Cos(Times($p("b",true),Power($p("x"),C2))),$p("x",$s("Symbol"))),
    Condition(Times(Sqrt(Times(Pi,C1D2)),Times(FresnelC(Times(Rt($s("b"),C2),Times($s("x"),Power(Sqrt(Times(Pi,C1D2)),CN1)))),Power(Rt($s("b"),C2),CN1))),FreeQ($s("b"),$s("x")))),
SetDelayed(Int(Cos(Plus($p("a"),Times($p("b",true),Power($p("x"),C2)))),$p("x",$s("Symbol"))),
    Condition(Plus(Dist(Cos($s("a")),Int(Cos(Times($s("b"),Power($s("x"),C2))),$s("x"))),Times(CN1,Dist(Sin($s("a")),Int(Sin(Times($s("b"),Power($s("x"),C2))),$s("x"))))),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(Cos(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n"))))),$p("x",$s("Symbol"))),
    Condition(Plus(Dist(C1D2,Int(Power(E,Plus(Times(Times(CN1,$s("a")),CI),Times(CN1,Times(Times($s("b"),CI),Power($s("x"),$s("n")))))),$s("x"))),Dist(C1D2,Int(Power(E,Plus(Times($s("a"),CI),Times(Times($s("b"),CI),Power($s("x"),$s("n"))))),$s("x")))),And(FreeQ(List($s("a"),$s("b"),$s("n")),$s("x")),Not(FractionOrNegativeQ($s("n")))))),
SetDelayed(Int(Cos(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n"))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times($s("x"),Cos(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))))),Dist(Times($s("b"),$s("n")),Int(Times(Power($s("x"),$s("n")),Sin(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))))),$s("x")))),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ($s("n"))),Less($s("n"),C0)))),
SetDelayed(Int(Times(Cos(Times($p("a",true),Power($p("x"),$p("n",true)))),Power($p("x"),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(CosIntegral(Times($s("a"),Power($s("x"),$s("n")))),Power($s("n"),CN1)),FreeQ(List($s("a"),$s("n")),$s("x")))),
SetDelayed(Int(Times(Cos(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("n",true))))),Power($p("x"),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Dist(Cos($s("a")),Int(Times(Cos(Times($s("b"),Power($s("x"),$s("n")))),Power($s("x"),CN1)),$s("x"))),Times(CN1,Dist(Sin($s("a")),Int(Times(Sin(Times($s("b"),Power($s("x"),$s("n")))),Power($s("x"),CN1)),$s("x"))))),FreeQ(List($s("a"),$s("b"),$s("n")),$s("x")))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Cos(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n",true)))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus(Plus($s("m"),Times(CN1,$s("n"))),C1)),Times(Sin(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),Power(Times($s("b"),$s("n")),CN1))),Times(CN1,Dist(Times(Plus(Plus($s("m"),Times(CN1,$s("n"))),C1),Power(Times($s("b"),$s("n")),CN1)),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,$s("n")))),Sin(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))))),$s("x"))))),And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ($s("n"))),RationalQ($s("m"))),And(Less(C0,$s("n")),LessEqual($s("n"),$s("m")))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Cos(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n",true)))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Times(Cos(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),Power(Plus($s("m"),C1),CN1))),Dist(Times($s("b"),Times($s("n"),Power(Plus($s("m"),C1),CN1))),Int(Times(Power($s("x"),Plus($s("m"),$s("n"))),Sin(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))))),$s("x")))),And(FreeQ(List($s("a"),$s("b"),$s("m"),$s("n")),$s("x")),Or(ZeroQ(Plus(Plus($s("m"),$s("n")),C1)),And(And(IntegerQ($s("n")),RationalQ($s("m"))),Or(And(Greater($s("n"),C0),Less($s("m"),CN1)),Less(Less(C0,Times(CN1,$s("n"))),Plus($s("m"),C1)))))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Cos(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n",true)))))),$p("x",$s("Symbol"))),
    Condition(Plus(Dist(C1D2,Int(Times(Power($s("x"),$s("m")),Power(E,Plus(Times(Times(CN1,$s("a")),CI),Times(CN1,Times(Times($s("b"),CI),Power($s("x"),$s("n"))))))),$s("x"))),Dist(C1D2,Int(Times(Power($s("x"),$s("m")),Power(E,Plus(Times($s("a"),CI),Times(Times($s("b"),CI),Power($s("x"),$s("n")))))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("m"),$s("n")),$s("x")),NonzeroQ(Plus($s("m"),C1))),NonzeroQ(Plus(Plus($s("m"),Times(CN1,$s("n"))),C1))),Not(Or(FractionQ($s("m")),FractionOrNegativeQ($s("n"))))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Cos(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n",true))))),$p("p"))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times($s("n"),Times(Power(Cos(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),$s("p")),Power(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Power($s("p"),C2)),CN1))),Times(Times(Power($s("x"),$s("n")),Sin(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))))),Times(Power(Cos(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),Plus($s("p"),Times(CN1,C1))),Power(Times(Times($s("b"),$s("n")),$s("p")),CN1)))),Dist(Times(Plus($s("p"),Times(CN1,C1)),Power($s("p"),CN1)),Int(Times(Power($s("x"),$s("m")),Power(Cos(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),Plus($s("p"),Times(CN1,C2)))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("m"),$s("n")),$s("x")),RationalQ($s("p"))),Greater($s("p"),C1)),ZeroQ(Plus(Plus($s("m"),Times(CN1,Times(C2,$s("n")))),C1))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Cos(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n",true))))),$p("p"))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Plus(Times(Times(Plus(Plus($s("m"),Times(CN1,$s("n"))),C1),Power($s("x"),Plus(Plus($s("m"),Times(CN1,Times(C2,$s("n")))),C1))),Times(Power(Cos(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),$s("p")),Power(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Power($s("p"),C2)),CN1))),Times(Times(Power($s("x"),Plus(Plus($s("m"),Times(CN1,$s("n"))),C1)),Sin(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))))),Times(Power(Cos(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),Plus($s("p"),Times(CN1,C1))),Power(Times(Times($s("b"),$s("n")),$s("p")),CN1)))),Dist(Times(Plus($s("p"),Times(CN1,C1)),Power($s("p"),CN1)),Int(Times(Power($s("x"),$s("m")),Power(Cos(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),Plus($s("p"),Times(CN1,C2)))),$s("x")))),Times(CN1,Dist(Times(Plus(Plus($s("m"),Times(CN1,$s("n"))),C1),Times(Plus(Plus($s("m"),Times(CN1,Times(C2,$s("n")))),C1),Power(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Power($s("p"),C2)),CN1))),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,Times(C2,$s("n"))))),Power(Cos(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),$s("p"))),$s("x"))))),And(And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ($s("n"))),RationalQ(List($s("m"),$s("p")))),Greater($s("p"),C1)),Less(Less(C0,Times(C2,$s("n"))),Plus($s("m"),C1))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Cos(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n",true))))),$p("p"))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(Times(CN1,Power($s("x"),$s("n"))),Sin(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))))),Times(Power(Cos(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),Plus($s("p"),C1)),Power(Times(Times($s("b"),$s("n")),Plus($s("p"),C1)),CN1))),Times(CN1,Times($s("n"),Times(Power(Cos(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),Plus($s("p"),C2)),Power(Times(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Plus($s("p"),C1)),Plus($s("p"),C2)),CN1))))),Dist(Times(Plus($s("p"),C2),Power(Plus($s("p"),C1),CN1)),Int(Times(Power($s("x"),$s("m")),Power(Cos(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),Plus($s("p"),C2))),$s("x")))),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("m"),$s("n")),$s("x")),RationalQ($s("p"))),Less($s("p"),CN1)),Unequal($s("p"),integer(-2L))),ZeroQ(Plus(Plus($s("m"),Times(CN1,Times(C2,$s("n")))),C1))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Cos(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n",true))))),$p("p"))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Plus(Times(Times(Times(CN1,Power($s("x"),Plus(Plus($s("m"),Times(CN1,$s("n"))),C1))),Sin(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))))),Times(Power(Cos(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),Plus($s("p"),C1)),Power(Times(Times($s("b"),$s("n")),Plus($s("p"),C1)),CN1))),Times(CN1,Times(Times(Plus(Plus($s("m"),Times(CN1,$s("n"))),C1),Power($s("x"),Plus(Plus($s("m"),Times(CN1,Times(C2,$s("n")))),C1))),Times(Power(Cos(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),Plus($s("p"),C2)),Power(Times(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Plus($s("p"),C1)),Plus($s("p"),C2)),CN1))))),Dist(Times(Plus($s("p"),C2),Power(Plus($s("p"),C1),CN1)),Int(Times(Power($s("x"),$s("m")),Power(Cos(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),Plus($s("p"),C2))),$s("x")))),Dist(Times(Plus(Plus($s("m"),Times(CN1,$s("n"))),C1),Times(Plus(Plus($s("m"),Times(CN1,Times(C2,$s("n")))),C1),Power(Times(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Plus($s("p"),C1)),Plus($s("p"),C2)),CN1))),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,Times(C2,$s("n"))))),Power(Cos(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),Plus($s("p"),C2))),$s("x")))),And(And(And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ($s("n"))),RationalQ(List($s("m"),$s("p")))),Less($s("p"),CN1)),Unequal($s("p"),integer(-2L))),Less(Less(C0,Times(C2,$s("n"))),Plus($s("m"),C1))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Cos(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n",true))))),$p("p"))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Times(Power(Cos(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),$s("p")),Power(Plus($s("m"),C1),CN1))),Times(Times(Times(Times(Times($s("b"),$s("n")),$s("p")),Power($s("x"),Plus(Plus($s("m"),$s("n")),C1))),Sin(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))))),Times(Power(Cos(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),Plus($s("p"),Times(CN1,C1))),Power(Times(Plus($s("m"),C1),Plus(Plus($s("m"),$s("n")),C1)),CN1)))),Times(CN1,Dist(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Times(Power($s("p"),C2),Power(Times(Plus($s("m"),C1),Plus(Plus($s("m"),$s("n")),C1)),CN1))),Int(Times(Power($s("x"),Plus($s("m"),Times(C2,$s("n")))),Power(Cos(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),$s("p"))),$s("x"))))),Dist(Times(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),$s("p")),Times(Plus($s("p"),Times(CN1,C1)),Power(Times(Plus($s("m"),C1),Plus(Plus($s("m"),$s("n")),C1)),CN1))),Int(Times(Power($s("x"),Plus($s("m"),Times(C2,$s("n")))),Power(Cos(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),Plus($s("p"),Times(CN1,C2)))),$s("x")))),And(And(And(And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ($s("n"))),RationalQ(List($s("m"),$s("p")))),Greater($s("p"),C1)),Less($s("m"),CN1)),Greater($s("n"),C0)),NonzeroQ(Plus(Plus($s("m"),$s("n")),C1))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Cos(Plus($p("a",true),Times($p("b",true),Power(Plus($p("c"),Times($p("d",true),$p("x"))),$p("n"))))),$p("p",true))),$p("x",$s("Symbol"))),
    Condition(Dist(Times(C1,Power($s("d"),CN1)),Subst(Int(Times(Power(Plus(Times(Times(CN1,$s("c")),Power($s("d"),CN1)),Times($s("x"),Power($s("d"),CN1))),$s("m")),Power(Cos(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),$s("p"))),$s("x")),$s("x"),Plus($s("c"),Times($s("d"),$s("x"))))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("n")),$s("x")),IntegerQ($s("m"))),Greater($s("m"),C0)),RationalQ($s("p"))))),
SetDelayed(Int(Cos(Plus(Plus($p("a",true),Times($p("b",true),$p("x"))),Times($p("c",true),Power($p("x"),C2)))),$p("x",$s("Symbol"))),
    Condition(Int(Cos(Times(Power(Plus($s("b"),Times(Times(C2,$s("c")),$s("x"))),C2),Power(Times(C4,$s("c")),CN1))),$s("x")),And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),ZeroQ(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c")))))))),
SetDelayed(Int(Cos(Plus(Plus($p("a",true),Times($p("b",true),$p("x"))),Times($p("c",true),Power($p("x"),C2)))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Cos(Times(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c")))),Power(Times(C4,$s("c")),CN1))),Int(Cos(Times(Power(Plus($s("b"),Times(Times(C2,$s("c")),$s("x"))),C2),Power(Times(C4,$s("c")),CN1))),$s("x"))),Times(Sin(Times(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c")))),Power(Times(C4,$s("c")),CN1))),Int(Sin(Times(Power(Plus($s("b"),Times(Times(C2,$s("c")),$s("x"))),C2),Power(Times(C4,$s("c")),CN1))),$s("x")))),And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),NonzeroQ(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c")))))))),
SetDelayed(Int(Times(Plus($p("d",true),Times($p("e",true),$p("x"))),Cos(Plus(Plus($p("a",true),Times($p("b",true),$p("x"))),Times($p("c",true),Power($p("x"),C2))))),$p("x",$s("Symbol"))),
    Condition(Times($s("e"),Times(Sin(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2)))),Power(Times(C2,$s("c")),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e")),$s("x")),ZeroQ(Plus(Times($s("b"),$s("e")),Times(CN1,Times(Times(C2,$s("c")),$s("d")))))))),
SetDelayed(Int(Times(Plus($p("d",true),Times($p("e",true),$p("x"))),Cos(Plus(Plus($p("a",true),Times($p("b",true),$p("x"))),Times($p("c",true),Power($p("x"),C2))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times($s("e"),Times(Sin(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2)))),Power(Times(C2,$s("c")),CN1))),Times(CN1,Dist(Times(Plus(Times($s("b"),$s("e")),Times(CN1,Times(Times(C2,$s("c")),$s("d")))),Power(Times(C2,$s("c")),CN1)),Int(Cos(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2)))),$s("x"))))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e")),$s("x")),NonzeroQ(Plus(Times($s("b"),$s("e")),Times(CN1,Times(Times(C2,$s("c")),$s("d")))))))),
SetDelayed(Int(Times(Power(Plus($p("d",true),Times($p("e",true),$p("x"))),$p("m")),Cos(Plus(Plus($p("a",true),Times($p("b",true),$p("x"))),Times($p("c",true),Power($p("x"),C2))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times($s("e"),Power(Plus($s("d"),Times($s("e"),$s("x"))),Plus($s("m"),Times(CN1,C1)))),Times(Sin(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2)))),Power(Times(C2,$s("c")),CN1))),Times(CN1,Dist(Times(Power($s("e"),C2),Times(Plus($s("m"),Times(CN1,C1)),Power(Times(C2,$s("c")),CN1))),Int(Times(Power(Plus($s("d"),Times($s("e"),$s("x"))),Plus($s("m"),Times(CN1,C2))),Sin(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))))),$s("x"))))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e")),$s("x")),RationalQ($s("m"))),Greater($s("m"),C1)),ZeroQ(Plus(Times($s("b"),$s("e")),Times(CN1,Times(Times(C2,$s("c")),$s("d")))))))),
SetDelayed(Int(Times(Power(Plus($p("d",true),Times($p("e",true),$p("x"))),$p("m")),Cos(Plus(Plus($p("a",true),Times($p("b",true),$p("x"))),Times($p("c",true),Power($p("x"),C2))))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times($s("e"),Power(Plus($s("d"),Times($s("e"),$s("x"))),Plus($s("m"),Times(CN1,C1)))),Times(Sin(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2)))),Power(Times(C2,$s("c")),CN1))),Times(CN1,Dist(Times(Plus(Times($s("b"),$s("e")),Times(CN1,Times(Times(C2,$s("c")),$s("d")))),Power(Times(C2,$s("c")),CN1)),Int(Times(Power(Plus($s("d"),Times($s("e"),$s("x"))),Plus($s("m"),Times(CN1,C1))),Cos(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))))),$s("x"))))),Times(CN1,Dist(Times(Power($s("e"),C2),Times(Plus($s("m"),Times(CN1,C1)),Power(Times(C2,$s("c")),CN1))),Int(Times(Power(Plus($s("d"),Times($s("e"),$s("x"))),Plus($s("m"),Times(CN1,C2))),Sin(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))))),$s("x"))))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e")),$s("x")),RationalQ($s("m"))),Greater($s("m"),C1)),NonzeroQ(Plus(Times($s("b"),$s("e")),Times(CN1,Times(Times(C2,$s("c")),$s("d")))))))),
SetDelayed(Int(Times(Power(Plus($p("d",true),Times($p("e",true),$p("x"))),$p("m")),Cos(Plus(Plus($p("a",true),Times($p("b",true),$p("x"))),Times($p("c",true),Power($p("x"),C2))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power(Plus($s("d"),Times($s("e"),$s("x"))),Plus($s("m"),C1)),Times(Cos(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2)))),Power(Times($s("e"),Plus($s("m"),C1)),CN1))),Dist(Times(C2,Times($s("c"),Power(Times(Power($s("e"),C2),Plus($s("m"),C1)),CN1))),Int(Times(Power(Plus($s("d"),Times($s("e"),$s("x"))),Plus($s("m"),C2)),Sin(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e")),$s("x")),RationalQ($s("m"))),Less($s("m"),CN1)),ZeroQ(Plus(Times($s("b"),$s("e")),Times(CN1,Times(Times(C2,$s("c")),$s("d")))))))),
SetDelayed(Int(Times(Power(Plus($p("d",true),Times($p("e",true),$p("x"))),$p("m")),Cos(Plus(Plus($p("a",true),Times($p("b",true),$p("x"))),Times($p("c",true),Power($p("x"),C2))))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Power(Plus($s("d"),Times($s("e"),$s("x"))),Plus($s("m"),C1)),Times(Cos(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2)))),Power(Times($s("e"),Plus($s("m"),C1)),CN1))),Dist(Times(Plus(Times($s("b"),$s("e")),Times(CN1,Times(Times(C2,$s("c")),$s("d")))),Power(Times(Power($s("e"),C2),Plus($s("m"),C1)),CN1)),Int(Times(Power(Plus($s("d"),Times($s("e"),$s("x"))),Plus($s("m"),C1)),Sin(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))))),$s("x")))),Dist(Times(C2,Times($s("c"),Power(Times(Power($s("e"),C2),Plus($s("m"),C1)),CN1))),Int(Times(Power(Plus($s("d"),Times($s("e"),$s("x"))),Plus($s("m"),C2)),Sin(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e")),$s("x")),RationalQ($s("m"))),Less($s("m"),CN1)),NonzeroQ(Plus(Times($s("b"),$s("e")),Times(CN1,Times(Times(C2,$s("c")),$s("d")))))))),
SetDelayed(Int(Cos(Plus($p("a",true),Times($p("b",true),Log(Times($p("c",true),Power($p("x"),$p("n",true))))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times($s("x"),Times(Cos(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Power(Plus(C1,Times(Power($s("b"),C2),Power($s("n"),C2))),CN1))),Times(Times(Times($s("b"),$s("n")),$s("x")),Times(Sin(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Power(Plus(C1,Times(Power($s("b"),C2),Power($s("n"),C2))),CN1)))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("n")),$s("x")),NonzeroQ(Plus(C1,Times(Power($s("b"),C2),Power($s("n"),C2))))))),
SetDelayed(Int(Power(Cos(Plus($p("a",true),Times($p("b",true),Log(Times($p("c",true),Power($p("x"),$p("n",true))))))),$p("p")),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times($s("x"),Times(Power(Cos(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),$s("p")),Power(Plus(C1,Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Power($s("p"),C2))),CN1))),Times(Times(Times(Times(Times($s("b"),$s("n")),$s("p")),$s("x")),Power(Cos(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),Times(CN1,C1)))),Times(Sin(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Power(Plus(C1,Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Power($s("p"),C2))),CN1)))),Dist(Times(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),$s("p")),Times(Plus($s("p"),Times(CN1,C1)),Power(Plus(C1,Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Power($s("p"),C2))),CN1))),Int(Power(Cos(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),Times(CN1,C2))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("n")),$s("x")),RationalQ($s("p"))),Greater($s("p"),C1)),NonzeroQ(Plus(C1,Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Power($s("p"),C2))))))),
SetDelayed(Int(Power(Cos(Plus($p("a",true),Times($p("b",true),Log(Times($p("c",true),Power($p("x"),$p("n",true))))))),$p("p")),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(Times(CN1,$s("x")),Tan(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n")))))))),Times(Power(Cos(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),C2)),Power(Times(Times($s("b"),$s("n")),Plus($s("p"),C1)),CN1))),Times(CN1,Times($s("x"),Times(Power(Cos(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),C2)),Power(Times(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Plus($s("p"),C1)),Plus($s("p"),C2)),CN1))))),Dist(Times(Plus(C1,Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Power(Plus($s("p"),C2),C2))),Power(Times(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Plus($s("p"),C1)),Plus($s("p"),C2)),CN1)),Int(Power(Cos(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),C2)),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("n")),$s("x")),RationalQ($s("p"))),Less($s("p"),CN1)),Unequal($s("p"),integer(-2L))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Cos(Plus($p("a",true),Times($p("b",true),Log(Times($p("c",true),Power($p("x"),$p("n",true)))))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(Plus($s("m"),C1),Power($s("x"),Plus($s("m"),C1))),Times(Cos(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Power(Plus(Times(Power($s("b"),C2),Power($s("n"),C2)),Power(Plus($s("m"),C1),C2)),CN1))),Times(Times(Times($s("b"),$s("n")),Power($s("x"),Plus($s("m"),C1))),Times(Sin(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Power(Plus(Times(Power($s("b"),C2),Power($s("n"),C2)),Power(Plus($s("m"),C1),C2)),CN1)))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("m"),$s("n")),$s("x")),NonzeroQ(Plus(Times(Power($s("b"),C2),Power($s("n"),C2)),Power(Plus($s("m"),C1),C2)))),NonzeroQ(Plus($s("m"),C1))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Cos(Plus($p("a",true),Times($p("b",true),Log(Times($p("c",true),Power($p("x"),$p("n",true))))))),$p("p"))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(Plus($s("m"),C1),Power($s("x"),Plus($s("m"),C1))),Times(Power(Cos(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),$s("p")),Power(Plus(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Power($s("p"),C2)),Power(Plus($s("m"),C1),C2)),CN1))),Times(Times(Times(Times(Times($s("b"),$s("n")),$s("p")),Power($s("x"),Plus($s("m"),C1))),Power(Cos(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),Times(CN1,C1)))),Times(Sin(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Power(Plus(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Power($s("p"),C2)),Power(Plus($s("m"),C1),C2)),CN1)))),Dist(Times(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),$s("p")),Times(Plus($s("p"),Times(CN1,C1)),Power(Plus(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Power($s("p"),C2)),Power(Plus($s("m"),C1),C2)),CN1))),Int(Times(Power($s("x"),$s("m")),Power(Cos(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),Times(CN1,C2)))),$s("x")))),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("m"),$s("n")),$s("x")),RationalQ($s("p"))),Greater($s("p"),C1)),NonzeroQ(Plus(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Power($s("p"),C2)),Power(Plus($s("m"),C1),C2)))),NonzeroQ(Plus($s("m"),C1))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Cos(Plus($p("a",true),Times($p("b",true),Log(Times($p("c",true),Power($p("x"),$p("n",true))))))),$p("p"))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(Times(CN1,Power($s("x"),Plus($s("m"),C1))),Tan(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n")))))))),Times(Power(Cos(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),C2)),Power(Times(Times($s("b"),$s("n")),Plus($s("p"),C1)),CN1))),Times(CN1,Times(Times(Plus($s("m"),C1),Power($s("x"),Plus($s("m"),C1))),Times(Power(Cos(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),C2)),Power(Times(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Plus($s("p"),C1)),Plus($s("p"),C2)),CN1))))),Dist(Times(Plus(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Power(Plus($s("p"),C2),C2)),Power(Plus($s("m"),C1),C2)),Power(Times(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Plus($s("p"),C1)),Plus($s("p"),C2)),CN1)),Int(Times(Power($s("x"),$s("m")),Power(Cos(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),C2))),$s("x")))),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("m"),$s("n")),$s("x")),RationalQ($s("p"))),Less($s("p"),CN1)),Unequal($s("p"),integer(-2L))),NonzeroQ(Plus($s("m"),C1))))),
SetDelayed(Int(Times(Cos(Times(Times($p("a",true),$p("x")),Power(Log(Times($p("b",true),$p("x"))),$p("p",true)))),Power(Log(Times($p("b",true),$p("x"))),$p("p",true))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Sin(Times(Times($s("a"),$s("x")),Power(Log(Times($s("b"),$s("x"))),$s("p")))),Power($s("a"),CN1)),Times(CN1,Dist($s("p"),Int(Times(Cos(Times(Times($s("a"),$s("x")),Power(Log(Times($s("b"),$s("x"))),$s("p")))),Power(Log(Times($s("b"),$s("x"))),Plus($s("p"),Times(CN1,C1)))),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),RationalQ($s("p"))),Greater($s("p"),C0)))),
SetDelayed(Int(Times(Cos(Times(Times($p("a",true),Power($p("x"),$p("n"))),Power(Log(Times($p("b",true),$p("x"))),$p("p",true)))),Power(Log(Times($p("b",true),$p("x"))),$p("p",true))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Sin(Times(Times($s("a"),Power($s("x"),$s("n"))),Power(Log(Times($s("b"),$s("x"))),$s("p")))),Power(Times(Times($s("a"),$s("n")),Power($s("x"),Plus($s("n"),Times(CN1,C1)))),CN1)),Times(CN1,Dist(Times($s("p"),Power($s("n"),CN1)),Int(Times(Cos(Times(Times($s("a"),Power($s("x"),$s("n"))),Power(Log(Times($s("b"),$s("x"))),$s("p")))),Power(Log(Times($s("b"),$s("x"))),Plus($s("p"),Times(CN1,C1)))),$s("x"))))),Dist(Times(Plus($s("n"),Times(CN1,C1)),Power(Times($s("a"),$s("n")),CN1)),Int(Times(Sin(Times(Times($s("a"),Power($s("x"),$s("n"))),Power(Log(Times($s("b"),$s("x"))),$s("p")))),Power(Power($s("x"),$s("n")),CN1)),$s("x")))),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),RationalQ(List($s("n"),$s("p")))),Greater($s("p"),C0)))),
SetDelayed(Int(Times(Times(Power($p("x"),$p("m")),Cos(Times(Times($p("a",true),Power($p("x"),$p("n",true))),Power(Log(Times($p("b",true),$p("x"))),$p("p",true))))),Power(Log(Times($p("b",true),$p("x"))),$p("p",true))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Power($s("x"),Plus(Plus($s("m"),Times(CN1,$s("n"))),C1)),Times(Sin(Times(Times($s("a"),Power($s("x"),$s("n"))),Power(Log(Times($s("b"),$s("x"))),$s("p")))),Power(Times($s("a"),$s("n")),CN1))),Times(CN1,Dist(Times($s("p"),Power($s("n"),CN1)),Int(Times(Times(Power($s("x"),$s("m")),Cos(Times(Times($s("a"),Power($s("x"),$s("n"))),Power(Log(Times($s("b"),$s("x"))),$s("p"))))),Power(Log(Times($s("b"),$s("x"))),Plus($s("p"),Times(CN1,C1)))),$s("x"))))),Times(CN1,Dist(Times(Plus(Plus($s("m"),Times(CN1,$s("n"))),C1),Power(Times($s("a"),$s("n")),CN1)),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,$s("n")))),Sin(Times(Times($s("a"),Power($s("x"),$s("n"))),Power(Log(Times($s("b"),$s("x"))),$s("p"))))),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),RationalQ(List($s("m"),$s("n"),$s("p")))),Greater($s("p"),C0)))),
SetDelayed(Int(Times($p("u"),Power(Cos($p("v")),C2)),$p("x",$s("Symbol"))),
    Condition(Plus(Dist(C1D2,Int($s("u"),$s("x"))),Dist(C1D2,Int(Times($s("u"),Cos(Times(C2,$s("v")))),$s("x")))),FunctionOfTrigQ($s("u"),Times(C2,$s("v")),$s("x")))),
SetDelayed(Int(Times(Times($p("u",true),Sin($p("v"))),Cos($p("w"))),$p("x",$s("Symbol"))),
    Condition(Plus(Dist(C1D2,Int(Times($s("u"),Regularize(Sin(Plus($s("w"),$s("v"))),$s("x"))),$s("x"))),Times(CN1,Dist(C1D2,Int(Times($s("u"),Regularize(Sin(Plus($s("w"),Times(CN1,$s("v")))),$s("x"))),$s("x"))))),And(Or(And(PolynomialQ($s("v"),$s("x")),PolynomialQ($s("w"),$s("x"))),IndependentQ(Cancel(Times($s("v"),Power($s("w"),CN1))),$s("x"))),PosQ(Plus($s("w"),Times(CN1,$s("v"))))))),
SetDelayed(Int(Times(Times($p("u",true),Cos($p("v"))),Cos($p("w"))),$p("x",$s("Symbol"))),
    Condition(Plus(Dist(C1D2,Int(Times($s("u"),Regularize(Cos(Plus($s("v"),Times(CN1,$s("w")))),$s("x"))),$s("x"))),Dist(C1D2,Int(Times($s("u"),Regularize(Cos(Plus($s("v"),$s("w"))),$s("x"))),$s("x")))),And(Or(And(PolynomialQ($s("v"),$s("x")),PolynomialQ($s("w"),$s("x"))),IndependentQ(Cancel(Times($s("v"),Power($s("w"),CN1))),$s("x"))),NonzeroQ(Plus($s("v"),Times(CN1,$s("w"))))))),
SetDelayed(Int(Times(Times($p("u",true),Cos($p("v"))),Power(Tan($p("w")),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Plus(Int(Times(Times($s("u"),Sin($s("v"))),Power(Tan($s("w")),Plus($s("n"),Times(CN1,C1)))),$s("x")),Times(CN1,Times(Sin(Plus($s("v"),Times(CN1,$s("w")))),Int(Times(Times($s("u"),Sec($s("w"))),Power(Tan($s("w")),Plus($s("n"),Times(CN1,C1)))),$s("x"))))),And(And(And(RationalQ($s("n")),Greater($s("n"),C0)),FreeQ(Plus($s("v"),Times(CN1,$s("w"))),$s("x"))),NonzeroQ(Plus($s("v"),Times(CN1,$s("w"))))))),
SetDelayed(Int(Times(Times($p("u",true),Cos($p("v"))),Power(Cot($p("w")),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(CN1,Int(Times(Times($s("u"),Sin($s("v"))),Power(Cot($s("w")),Plus($s("n"),Times(CN1,C1)))),$s("x"))),Times(Cos(Plus($s("v"),Times(CN1,$s("w")))),Int(Times(Times($s("u"),Csc($s("w"))),Power(Cot($s("w")),Plus($s("n"),Times(CN1,C1)))),$s("x")))),And(And(And(RationalQ($s("n")),Greater($s("n"),C0)),FreeQ(Plus($s("v"),Times(CN1,$s("w"))),$s("x"))),NonzeroQ(Plus($s("v"),Times(CN1,$s("w"))))))),
SetDelayed(Int(Times(Times($p("u",true),Cos($p("v"))),Power(Sec($p("w")),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Sin(Plus($s("v"),Times(CN1,$s("w"))))),Int(Times(Times($s("u"),Tan($s("w"))),Power(Sec($s("w")),Plus($s("n"),Times(CN1,C1)))),$s("x"))),Times(Cos(Plus($s("v"),Times(CN1,$s("w")))),Int(Times($s("u"),Power(Sec($s("w")),Plus($s("n"),Times(CN1,C1)))),$s("x")))),And(And(And(RationalQ($s("n")),Greater($s("n"),C0)),FreeQ(Plus($s("v"),Times(CN1,$s("w"))),$s("x"))),NonzeroQ(Plus($s("v"),Times(CN1,$s("w"))))))),
SetDelayed(Int(Times(Times($p("u",true),Cos($p("v"))),Power(Csc($p("w")),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Cos(Plus($s("v"),Times(CN1,$s("w")))),Int(Times(Times($s("u"),Cot($s("w"))),Power(Csc($s("w")),Plus($s("n"),Times(CN1,C1)))),$s("x"))),Times(CN1,Times(Sin(Plus($s("v"),Times(CN1,$s("w")))),Int(Times($s("u"),Power(Csc($s("w")),Plus($s("n"),Times(CN1,C1)))),$s("x"))))),And(And(And(RationalQ($s("n")),Greater($s("n"),C0)),FreeQ(Plus($s("v"),Times(CN1,$s("w"))),$s("x"))),NonzeroQ(Plus($s("v"),Times(CN1,$s("w"))))))),
SetDelayed(Int(Tan(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("x",$s("Symbol"))),
    Condition(Times(Times(CN1,Log(Cos(Plus($s("a"),Times($s("b"),$s("x")))))),Power($s("b"),CN1)),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(Power(Tan(Plus($p("a",true),Times($p("b",true),$p("x")))),C2),$p("x",$s("Symbol"))),
    Condition(Plus(Times(CN1,$s("x")),Times(Tan(Plus($s("a"),Times($s("b"),$s("x")))),Power($s("b"),CN1))),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(Power(Times($p("c",true),Tan(Plus($p("a",true),Times($p("b",true),$p("x"))))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Plus(Times($s("c"),Times(Power(Times($s("c"),Tan(Plus($s("a"),Times($s("b"),$s("x"))))),Plus($s("n"),Times(CN1,C1))),Power(Times($s("b"),Plus($s("n"),Times(CN1,C1))),CN1))),Times(CN1,Dist(Power($s("c"),C2),Int(Power(Times($s("c"),Tan(Plus($s("a"),Times($s("b"),$s("x"))))),Plus($s("n"),Times(CN1,C2))),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),RationalQ($s("n"))),Greater($s("n"),C1)))),
SetDelayed(Int(Power(Times($p("c",true),Tan(Plus($p("a",true),Times($p("b",true),$p("x"))))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power(Times($s("c"),Tan(Plus($s("a"),Times($s("b"),$s("x"))))),Plus($s("n"),C1)),Power(Times(Times($s("b"),$s("c")),Plus($s("n"),C1)),CN1)),Times(CN1,Dist(Times(C1,Power(Power($s("c"),C2),CN1)),Int(Power(Times($s("c"),Tan(Plus($s("a"),Times($s("b"),$s("x"))))),Plus($s("n"),C2)),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),RationalQ($s("n"))),Less($s("n"),CN1)))),
SetDelayed(Int(Sqrt(Plus($p("a"),Times($p("b",true),Tan(Plus($p("c",true),Times($p("d",true),$p("x"))))))),$p("x",$s("Symbol"))),
    Condition(Times(Times(CN1,Times(Times(Sqrt(C2),$s("b")),ArcTanh(Times(Sqrt(Plus($s("a"),Times($s("b"),Tan(Plus($s("c"),Times($s("d"),$s("x"))))))),Power(Times(Sqrt(C2),Rt($s("a"),C2)),CN1))))),Power(Times($s("d"),Rt($s("a"),C2)),CN1)),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),ZeroQ(Plus(Power($s("a"),C2),Power($s("b"),C2)))),PosQ($s("a"))))),
SetDelayed(Int(Sqrt(Plus($p("a"),Times($p("b",true),Tan(Plus($p("c",true),Times($p("d",true),$p("x"))))))),$p("x",$s("Symbol"))),
    Condition(Times(Times(Times(Sqrt(C2),$s("b")),ArcTan(Times(Sqrt(Plus($s("a"),Times($s("b"),Tan(Plus($s("c"),Times($s("d"),$s("x"))))))),Power(Times(Sqrt(C2),Rt(Times(CN1,$s("a")),C2)),CN1)))),Power(Times($s("d"),Rt(Times(CN1,$s("a")),C2)),CN1)),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),ZeroQ(Plus(Power($s("a"),C2),Power($s("b"),C2)))),NegQ($s("a"))))),
SetDelayed(Int(Power(Plus($p("a"),Times($p("b",true),Tan(Plus($p("c",true),Times($p("d",true),$p("x")))))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Power($s("a"),C2)),Times(Power(Plus($s("a"),Times($s("b"),Tan(Plus($s("c"),Times($s("d"),$s("x")))))),Plus($s("n"),Times(CN1,C1))),Power(Times(Times($s("b"),$s("d")),Plus($s("n"),Times(CN1,C1))),CN1))),Dist(Times(C2,$s("a")),Int(Power(Plus($s("a"),Times($s("b"),Tan(Plus($s("c"),Times($s("d"),$s("x")))))),Plus($s("n"),Times(CN1,C1))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),FractionQ($s("n"))),Greater($s("n"),C1)),ZeroQ(Plus(Power($s("a"),C2),Power($s("b"),C2)))))),
SetDelayed(Int(Times(C1,Power(Plus($p("a"),Times($p("b",true),Tan(Plus($p("c",true),Times($p("d",true),$p("x")))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Times($s("x"),Power(Times(C2,$s("a")),CN1)),Times(CN1,Times($s("a"),Power(Times(Times(Times(C2,$s("b")),$s("d")),Plus($s("a"),Times($s("b"),Tan(Plus($s("c"),Times($s("d"),$s("x"))))))),CN1)))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),ZeroQ(Plus(Power($s("a"),C2),Power($s("b"),C2)))))),
SetDelayed(Int(Power(Plus($p("a"),Times($p("b",true),Tan(Plus($p("c",true),Times($p("d",true),$p("x")))))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Plus(Times($s("a"),Times(Power(Plus($s("a"),Times($s("b"),Tan(Plus($s("c"),Times($s("d"),$s("x")))))),$s("n")),Power(Times(Times(Times(C2,$s("b")),$s("d")),$s("n")),CN1))),Dist(Times(C1,Power(Times(C2,$s("a")),CN1)),Int(Power(Plus($s("a"),Times($s("b"),Tan(Plus($s("c"),Times($s("d"),$s("x")))))),Plus($s("n"),C1)),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),RationalQ($s("n"))),Less($s("n"),C0)),ZeroQ(Plus(Power($s("a"),C2),Power($s("b"),C2)))))),
SetDelayed(Int(Times(C1,Power(Plus($p("a"),Times($p("b",true),Tan(Plus($p("c",true),Times($p("d",true),$p("x")))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Times($s("a"),Times($s("x"),Power(Plus(Power($s("a"),C2),Power($s("b"),C2)),CN1))),Times($s("b"),Times(Log(Plus(Times($s("a"),Cos(Plus($s("c"),Times($s("d"),$s("x"))))),Times($s("b"),Sin(Plus($s("c"),Times($s("d"),$s("x"))))))),Power(Times($s("d"),Plus(Power($s("a"),C2),Power($s("b"),C2))),CN1)))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),NonzeroQ(Plus(Power($s("a"),C2),Power($s("b"),C2)))))),
SetDelayed(Int(Times(C1,Power(Plus($p("a"),Times($p("b",true),Power(Tan(Plus($p("c",true),Times($p("d",true),$p("x")))),C2))),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Times($s("x"),Power(Plus($s("a"),Times(CN1,$s("b"))),CN1)),Times(CN1,Times(Sqrt($s("b")),Times(ArcTan(Times(Times(Sqrt($s("b")),Tan(Plus($s("c"),Times($s("d"),$s("x"))))),Power(Sqrt($s("a")),CN1))),Power(Times(Times(Sqrt($s("a")),$s("d")),Plus($s("a"),Times(CN1,$s("b")))),CN1))))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),NonzeroQ(Plus($s("a"),Times(CN1,$s("b"))))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Tan(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n",true)))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,CI),Times(Power($s("x"),Plus($s("m"),C1)),Power(Plus($s("m"),C1),CN1))),Dist(Times(C2,CI),Int(Times(Power($s("x"),$s("m")),Power(Plus(C1,Power(E,Plus(Times(Times(C2,CI),$s("a")),Times(Times(Times(C2,CI),$s("b")),Power($s("x"),$s("n")))))),CN1)),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("m"),$s("n")),$s("x")),NonzeroQ(Plus(Plus($s("m"),Times(CN1,$s("n"))),C1))),IntegerQ($s("m"))),Greater($s("m"),C0)))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Tan(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n",true))))),$p("p"))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Power($s("x"),Plus(Plus($s("m"),Times(CN1,$s("n"))),C1)),Times(Power(Tan(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),Plus($s("p"),Times(CN1,C1))),Power(Times(Times($s("b"),$s("n")),Plus($s("p"),Times(CN1,C1))),CN1))),Times(CN1,Dist(Times(Plus(Plus($s("m"),Times(CN1,$s("n"))),C1),Power(Times(Times($s("b"),$s("n")),Plus($s("p"),Times(CN1,C1))),CN1)),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,$s("n")))),Power(Tan(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),Plus($s("p"),Times(CN1,C1)))),$s("x"))))),Times(CN1,Int(Times(Power($s("x"),$s("m")),Power(Tan(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),Plus($s("p"),Times(CN1,C2)))),$s("x")))),And(And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),RationalQ(List($s("m"),$s("n"),$s("p")))),Greater($s("p"),C1)),NonzeroQ(Plus(Plus($s("m"),Times(CN1,$s("n"))),C1))),And(Less(C0,$s("n")),LessEqual($s("n"),$s("m")))))),
SetDelayed(Int(Times($p("x"),Tan(Plus(Plus($p("a",true),Times($p("b",true),$p("x"))),Times($p("c",true),Power($p("x"),C2))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Log(Cos(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2)))))),Power(Times(C2,$s("c")),CN1)),Times(CN1,Dist(Times($s("b"),Power(Times(C2,$s("c")),CN1)),Int(Tan(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2)))),$s("x"))))),FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")))),
SetDelayed(Int(Cot(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("x",$s("Symbol"))),
    Condition(Times(Log(Sin(Plus($s("a"),Times($s("b"),$s("x"))))),Power($s("b"),CN1)),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(Power(Cot(Plus($p("a",true),Times($p("b",true),$p("x")))),C2),$p("x",$s("Symbol"))),
    Condition(Plus(Times(CN1,$s("x")),Times(CN1,Times(Cot(Plus($s("a"),Times($s("b"),$s("x")))),Power($s("b"),CN1)))),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(Power(Times($p("c",true),Cot(Plus($p("a",true),Times($p("b",true),$p("x"))))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,$s("c")),Times(Power(Times($s("c"),Cot(Plus($s("a"),Times($s("b"),$s("x"))))),Plus($s("n"),Times(CN1,C1))),Power(Times($s("b"),Plus($s("n"),Times(CN1,C1))),CN1))),Times(CN1,Dist(Power($s("c"),C2),Int(Power(Times($s("c"),Cot(Plus($s("a"),Times($s("b"),$s("x"))))),Plus($s("n"),Times(CN1,C2))),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),RationalQ($s("n"))),Greater($s("n"),C1)))),
SetDelayed(Int(Power(Times($p("c",true),Cot(Plus($p("a",true),Times($p("b",true),$p("x"))))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Power(Times($s("c"),Cot(Plus($s("a"),Times($s("b"),$s("x"))))),Plus($s("n"),C1))),Power(Times(Times($s("b"),$s("c")),Plus($s("n"),C1)),CN1)),Times(CN1,Dist(Times(C1,Power(Power($s("c"),C2),CN1)),Int(Power(Times($s("c"),Cot(Plus($s("a"),Times($s("b"),$s("x"))))),Plus($s("n"),C2)),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),RationalQ($s("n"))),Less($s("n"),CN1)))),
SetDelayed(Int(Sqrt(Plus($p("a"),Times($p("b",true),Cot(Plus($p("c",true),Times($p("d",true),$p("x"))))))),$p("x",$s("Symbol"))),
    Condition(Times(Times(Times(Sqrt(C2),$s("b")),ArcCoth(Times(Sqrt(Plus($s("a"),Times($s("b"),Cot(Plus($s("c"),Times($s("d"),$s("x"))))))),Power(Times(Sqrt(C2),Rt($s("a"),C2)),CN1)))),Power(Times($s("d"),Rt($s("a"),C2)),CN1)),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),ZeroQ(Plus(Power($s("a"),C2),Power($s("b"),C2)))),PosQ($s("a"))))),
SetDelayed(Int(Sqrt(Plus($p("a"),Times($p("b",true),Cot(Plus($p("c",true),Times($p("d",true),$p("x"))))))),$p("x",$s("Symbol"))),
    Condition(Times(Times(Times(Sqrt(C2),$s("b")),ArcCot(Times(Sqrt(Plus($s("a"),Times($s("b"),Cot(Plus($s("c"),Times($s("d"),$s("x"))))))),Power(Times(Sqrt(C2),Rt(Times(CN1,$s("a")),C2)),CN1)))),Power(Times($s("d"),Rt(Times(CN1,$s("a")),C2)),CN1)),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),ZeroQ(Plus(Power($s("a"),C2),Power($s("b"),C2)))),NegQ($s("a"))))),
SetDelayed(Int(Power(Plus($p("a"),Times($p("b",true),Cot(Plus($p("c",true),Times($p("d",true),$p("x")))))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("a"),C2),Times(Power(Plus($s("a"),Times($s("b"),Cot(Plus($s("c"),Times($s("d"),$s("x")))))),Plus($s("n"),Times(CN1,C1))),Power(Times(Times($s("b"),$s("d")),Plus($s("n"),Times(CN1,C1))),CN1))),Dist(Times(C2,$s("a")),Int(Power(Plus($s("a"),Times($s("b"),Cot(Plus($s("c"),Times($s("d"),$s("x")))))),Plus($s("n"),Times(CN1,C1))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),FractionQ($s("n"))),Greater($s("n"),C1)),ZeroQ(Plus(Power($s("a"),C2),Power($s("b"),C2)))))),
SetDelayed(Int(Times(C1,Power(Plus($p("a"),Times($p("b",true),Cot(Plus($p("c",true),Times($p("d",true),$p("x")))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Times($s("x"),Power(Times(C2,$s("a")),CN1)),Times($s("a"),Power(Times(Times(Times(C2,$s("b")),$s("d")),Plus($s("a"),Times($s("b"),Cot(Plus($s("c"),Times($s("d"),$s("x"))))))),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),ZeroQ(Plus(Power($s("a"),C2),Power($s("b"),C2)))))),
SetDelayed(Int(Power(Plus($p("a"),Times($p("b",true),Cot(Plus($p("c",true),Times($p("d",true),$p("x")))))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,$s("a")),Times(Power(Plus($s("a"),Times($s("b"),Cot(Plus($s("c"),Times($s("d"),$s("x")))))),$s("n")),Power(Times(Times(Times(C2,$s("b")),$s("d")),$s("n")),CN1))),Dist(Times(C1,Power(Times(C2,$s("a")),CN1)),Int(Power(Plus($s("a"),Times($s("b"),Cot(Plus($s("c"),Times($s("d"),$s("x")))))),Plus($s("n"),C1)),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),RationalQ($s("n"))),Less($s("n"),C0)),ZeroQ(Plus(Power($s("a"),C2),Power($s("b"),C2)))))),
SetDelayed(Int(Times(C1,Power(Plus($p("a"),Times($p("b",true),Cot(Plus($p("c",true),Times($p("d",true),$p("x")))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Times($s("a"),Times($s("x"),Power(Plus(Power($s("a"),C2),Power($s("b"),C2)),CN1))),Times(CN1,Times($s("b"),Times(Log(Plus(Times($s("b"),Cos(Plus($s("c"),Times($s("d"),$s("x"))))),Times($s("a"),Sin(Plus($s("c"),Times($s("d"),$s("x"))))))),Power(Times($s("d"),Plus(Power($s("a"),C2),Power($s("b"),C2))),CN1))))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),NonzeroQ(Plus(Power($s("a"),C2),Power($s("b"),C2)))))),
SetDelayed(Int(Times(C1,Power(Plus($p("a"),Times($p("b",true),Power(Cot(Plus($p("c",true),Times($p("d",true),$p("x")))),C2))),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Times($s("x"),Power(Plus($s("a"),Times(CN1,$s("b"))),CN1)),Times(Sqrt($s("b")),Times(ArcTan(Times(Times(Sqrt($s("b")),Cot(Plus($s("c"),Times($s("d"),$s("x"))))),Power(Sqrt($s("a")),CN1))),Power(Times(Times(Sqrt($s("a")),$s("d")),Plus($s("a"),Times(CN1,$s("b")))),CN1)))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),NonzeroQ(Plus($s("a"),Times(CN1,$s("b"))))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Cot(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n",true)))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(CI,Times(Power($s("x"),Plus($s("m"),C1)),Power(Plus($s("m"),C1),CN1))),Times(CN1,Dist(Times(C2,CI),Int(Times(Power($s("x"),$s("m")),Power(Plus(C1,Times(CN1,Power(E,Plus(Times(Times(C2,CI),$s("a")),Times(Times(Times(C2,CI),$s("b")),Power($s("x"),$s("n"))))))),CN1)),$s("x"))))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("m"),$s("n")),$s("x")),NonzeroQ(Plus(Plus($s("m"),Times(CN1,$s("n"))),C1))),IntegerQ($s("m"))),Greater($s("m"),C0)))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Cot(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n",true))))),$p("p"))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(CN1,Power($s("x"),Plus(Plus($s("m"),Times(CN1,$s("n"))),C1))),Times(Power(Cot(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),Plus($s("p"),Times(CN1,C1))),Power(Times(Times($s("b"),$s("n")),Plus($s("p"),Times(CN1,C1))),CN1))),Dist(Times(Plus(Plus($s("m"),Times(CN1,$s("n"))),C1),Power(Times(Times($s("b"),$s("n")),Plus($s("p"),Times(CN1,C1))),CN1)),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,$s("n")))),Power(Cot(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),Plus($s("p"),Times(CN1,C1)))),$s("x")))),Times(CN1,Int(Times(Power($s("x"),$s("m")),Power(Cot(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),Plus($s("p"),Times(CN1,C2)))),$s("x")))),And(And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),RationalQ(List($s("m"),$s("n"),$s("p")))),Greater($s("p"),C1)),NonzeroQ(Plus(Plus($s("m"),Times(CN1,$s("n"))),C1))),And(Less(C0,$s("n")),LessEqual($s("n"),$s("m")))))),
SetDelayed(Int(Times($p("x"),Cot(Plus(Plus($p("a",true),Times($p("b",true),$p("x"))),Times($p("c",true),Power($p("x"),C2))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Log(Sin(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))))),Power(Times(C2,$s("c")),CN1)),Times(CN1,Dist(Times($s("b"),Power(Times(C2,$s("c")),CN1)),Int(Cot(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2)))),$s("x"))))),FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")))),
SetDelayed(Int(Sec(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("x",$s("Symbol"))),
    Condition(Times(ArcTanh(Sin(Plus($s("a"),Times($s("b"),$s("x"))))),Power($s("b"),CN1)),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(Times(C1,Power(Sqrt(Sec(Plus($p("a",true),Times($p("b",true),$p("x"))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Times(Sqrt(Cos(Plus($s("a"),Times($s("b"),$s("x"))))),Sqrt(Sec(Plus($s("a"),Times($s("b"),$s("x")))))),Int(Sqrt(Cos(Plus($s("a"),Times($s("b"),$s("x"))))),$s("x"))),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(Power(Times($p("c",true),Sec(Plus($p("a",true),Times($p("b",true),$p("x"))))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Times(Times(Power(Times($s("c"),Sec(Plus($s("a"),Times($s("b"),$s("x"))))),$s("n")),Power(Cos(Plus($s("a"),Times($s("b"),$s("x")))),$s("n"))),Int(Times(C1,Power(Power(Cos(Plus($s("a"),Times($s("b"),$s("x")))),$s("n")),CN1)),$s("x"))),And(And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),RationalQ($s("n"))),Less(Less(CN1,$s("n")),C1)))),
SetDelayed(Int(Power(Sec(Plus($p("a",true),Times($p("b",true),$p("x")))),C2),$p("x",$s("Symbol"))),
    Condition(Times(Tan(Plus($s("a"),Times($s("b"),$s("x")))),Power($s("b"),CN1)),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(Power(Sec(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Dist(Times(C1,Power($s("b"),CN1)),Subst(Int(Regularize(Power(Plus(C1,Power($s("x"),C2)),Times(Plus($s("n"),Times(CN1,C2)),C1D2)),$s("x")),$s("x")),$s("x"),Tan(Plus($s("a"),Times($s("b"),$s("x")))))),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),EvenQ($s("n"))),Greater($s("n"),C1)))),
SetDelayed(Int(Power(Times($p("c",true),Sec(Plus($p("a",true),Times($p("b",true),$p("x"))))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times($s("c"),Sin(Plus($s("a"),Times($s("b"),$s("x"))))),Times(Power(Times($s("c"),Sec(Plus($s("a"),Times($s("b"),$s("x"))))),Plus($s("n"),Times(CN1,C1))),Power(Times($s("b"),Plus($s("n"),Times(CN1,C1))),CN1))),Dist(Times(Plus($s("n"),Times(CN1,C2)),Times(Power($s("c"),C2),Power(Plus($s("n"),Times(CN1,C1)),CN1))),Int(Power(Times($s("c"),Sec(Plus($s("a"),Times($s("b"),$s("x"))))),Plus($s("n"),Times(CN1,C2))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),RationalQ($s("n"))),Greater($s("n"),C1)),Not(EvenQ($s("n")))))),
SetDelayed(Int(Power(Times($p("c",true),Sec(Plus($p("a",true),Times($p("b",true),$p("x"))))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Sin(Plus($s("a"),Times($s("b"),$s("x"))))),Times(Power(Times($s("c"),Sec(Plus($s("a"),Times($s("b"),$s("x"))))),Plus($s("n"),C1)),Power(Times(Times($s("b"),$s("c")),$s("n")),CN1))),Dist(Times(Plus($s("n"),C1),Power(Times(Power($s("c"),C2),$s("n")),CN1)),Int(Power(Times($s("c"),Sec(Plus($s("a"),Times($s("b"),$s("x"))))),Plus($s("n"),C2)),$s("x")))),And(And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),RationalQ($s("n"))),Less($s("n"),CN1)))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Sec(Plus($p("a",true),Times($p("b",true),$p("x"))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(Times(integer(-2L),CI),Power($s("x"),$s("m"))),Times(ArcTan(Power(E,Plus(Times(CI,$s("a")),Times(Times(CI,$s("b")),$s("x"))))),Power($s("b"),CN1))),Dist(Times(Times(C2,CI),Times($s("m"),Power($s("b"),CN1))),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,C1))),ArcTan(Power(E,Plus(Times(CI,$s("a")),Times(Times(CI,$s("b")),$s("x")))))),$s("x")))),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ($s("m"))),Greater($s("m"),C0)))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Sec(Plus($p("a",true),Times($p("b",true),$p("x")))),C2)),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),$s("m")),Times(Tan(Plus($s("a"),Times($s("b"),$s("x")))),Power($s("b"),CN1))),Times(CN1,Dist(Times($s("m"),Power($s("b"),CN1)),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,C1))),Tan(Plus($s("a"),Times($s("b"),$s("x"))))),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),RationalQ($s("m"))),Greater($s("m"),C0)))),
SetDelayed(Int(Times($p("x"),Power(Sec(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times($s("x"),Tan(Plus($s("a"),Times($s("b"),$s("x"))))),Times(Power(Sec(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C2))),Power(Times($s("b"),Plus($s("n"),Times(CN1,C1))),CN1))),Times(CN1,Times(Power(Sec(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C2))),Power(Times(Times(Power($s("b"),C2),Plus($s("n"),Times(CN1,C1))),Plus($s("n"),Times(CN1,C2))),CN1)))),Dist(Times(Plus($s("n"),Times(CN1,C2)),Power(Plus($s("n"),Times(CN1,C1)),CN1)),Int(Times($s("x"),Power(Sec(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C2)))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),RationalQ($s("n"))),Greater($s("n"),C1)),Unequal($s("n"),C2)))),
SetDelayed(Int(Times(Power($p("x"),$p("m")),Power(Sec(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Plus(Times(Times(Power($s("x"),$s("m")),Tan(Plus($s("a"),Times($s("b"),$s("x"))))),Times(Power(Sec(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C2))),Power(Times($s("b"),Plus($s("n"),Times(CN1,C1))),CN1))),Times(CN1,Times(Times($s("m"),Power($s("x"),Plus($s("m"),Times(CN1,C1)))),Times(Power(Sec(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C2))),Power(Times(Times(Power($s("b"),C2),Plus($s("n"),Times(CN1,C1))),Plus($s("n"),Times(CN1,C2))),CN1))))),Dist(Times(Plus($s("n"),Times(CN1,C2)),Power(Plus($s("n"),Times(CN1,C1)),CN1)),Int(Times(Power($s("x"),$s("m")),Power(Sec(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C2)))),$s("x")))),Dist(Times($s("m"),Times(Plus($s("m"),Times(CN1,C1)),Power(Times(Times(Power($s("b"),C2),Plus($s("n"),Times(CN1,C1))),Plus($s("n"),Times(CN1,C2))),CN1))),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,C2))),Power(Sec(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C2)))),$s("x")))),And(And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),RationalQ(List($s("m"),$s("n")))),Greater($s("n"),C1)),Unequal($s("n"),C2)),Greater($s("m"),C1)))),
SetDelayed(Int(Times($p("x"),Power(Sec(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Power(Sec(Plus($s("a"),Times($s("b"),$s("x")))),$s("n")),Power(Times(Power($s("b"),C2),Power($s("n"),C2)),CN1)),Times(CN1,Times(Times($s("x"),Sin(Plus($s("a"),Times($s("b"),$s("x"))))),Times(Power(Sec(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C1)),Power(Times($s("b"),$s("n")),CN1))))),Dist(Times(Plus($s("n"),C1),Power($s("n"),CN1)),Int(Times($s("x"),Power(Sec(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C2))),$s("x")))),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),RationalQ($s("n"))),Less($s("n"),CN1)))),
SetDelayed(Int(Times(Power($p("x"),$p("m")),Power(Sec(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Plus(Times(Times($s("m"),Power($s("x"),Plus($s("m"),Times(CN1,C1)))),Times(Power(Sec(Plus($s("a"),Times($s("b"),$s("x")))),$s("n")),Power(Times(Power($s("b"),C2),Power($s("n"),C2)),CN1))),Times(CN1,Times(Times(Power($s("x"),$s("m")),Sin(Plus($s("a"),Times($s("b"),$s("x"))))),Times(Power(Sec(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C1)),Power(Times($s("b"),$s("n")),CN1))))),Dist(Times(Plus($s("n"),C1),Power($s("n"),CN1)),Int(Times(Power($s("x"),$s("m")),Power(Sec(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C2))),$s("x")))),Times(CN1,Dist(Times($s("m"),Times(Plus($s("m"),Times(CN1,C1)),Power(Times(Power($s("b"),C2),Power($s("n"),C2)),CN1))),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,C2))),Power(Sec(Plus($s("a"),Times($s("b"),$s("x")))),$s("n"))),$s("x"))))),And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),RationalQ(List($s("m"),$s("n")))),Less($s("n"),CN1)),Greater($s("m"),C1)))),
SetDelayed(Int(Sqrt(Plus($p("a"),Times($p("b",true),Sec(Plus($p("c",true),Times($p("d",true),$p("x"))))))),$p("x",$s("Symbol"))),
    Condition(Times(Times(Times(C2,$s("a")),ArcTan(Sqrt(Plus(CN1,Times(Times($s("a"),Power($s("b"),CN1)),Sec(Plus($s("c"),Times($s("d"),$s("x"))))))))),Times(Tan(Plus($s("c"),Times($s("d"),$s("x")))),Power(Times(Times($s("d"),Sqrt(Plus(CN1,Times(Times($s("a"),Power($s("b"),CN1)),Sec(Plus($s("c"),Times($s("d"),$s("x")))))))),Sqrt(Plus($s("a"),Times($s("b"),Sec(Plus($s("c"),Times($s("d"),$s("x")))))))),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),ZeroQ(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))))))),
SetDelayed(Int(Times(C1,Power(Sqrt(Plus($p("a"),Times($p("b",true),Sec(Plus($p("c",true),Times($p("d",true),$p("x"))))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Times(Times(Plus(Times(Sqrt(C2),ArcTan(Times(Times(Sqrt(C2),Sqrt($s("a"))),Power(Sqrt(Plus(Times(CN1,$s("a")),Times($s("b"),Sec($s("x"))))),CN1)))),Times(C2,ArcTan(Times(Sqrt(Plus(Times(CN1,$s("a")),Times($s("b"),Sec($s("x"))))),Power(Sqrt($s("a")),CN1))))),Sqrt(Plus(Times(CN1,$s("a")),Times($s("b"),Sec($s("x")))))),Sqrt(Plus($s("a"),Times($s("b"),Sec($s("x")))))),Times(Cot($s("x")),Power(Power($s("a"),fraction(3L,2L)),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),ZeroQ(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))))))),
SetDelayed(Int(Power(Plus($p("a"),Times($p("b",true),Power(Sec($p("v")),$p("n",true)))),$p("m")),$p("x",$s("Symbol"))),
    Condition(Int(Times(Power(Plus($s("b"),Times($s("a"),Power(Cos($s("v")),$s("n")))),$s("m")),Power(Power(Cos($s("v")),Times($s("m"),$s("n"))),CN1)),$s("x")),And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ(List($s("m"),$s("n")))),Less($s("m"),C0)),Greater($s("n"),C0)))),
SetDelayed(Int(Times(Power(Cos($p("v")),$p("p",true)),Power(Plus($p("a"),Times($p("b",true),Power(Sec($p("v")),$p("n",true)))),$p("m"))),$p("x",$s("Symbol"))),
    Condition(Int(Times(Power(Cos($s("v")),Plus($s("p"),Times(CN1,Times($s("m"),$s("n"))))),Power(Plus($s("b"),Times($s("a"),Power(Cos($s("v")),$s("n")))),$s("m"))),$s("x")),And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ(List($s("m"),$s("n"),$s("p")))),Less($s("m"),C0)),Greater($s("n"),C0)))),
SetDelayed(Int(Times(Csc(Plus($p("a",true),Times($p("b",true),$p("x")))),Sec(Plus($p("a",true),Times($p("b",true),$p("x"))))),$p("x",$s("Symbol"))),
    Condition(Times(Log(Tan(Plus($s("a"),Times($s("b"),$s("x"))))),Power($s("b"),CN1)),And(FreeQ(List($s("a"),$s("b")),$s("x")),PosQ($s("b"))))),
SetDelayed(Int(Times(Power(Csc(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m")),Power(Sec(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Times(Power(Csc(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),Times(CN1,C1))),Times(Power(Sec(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C1))),Power(Times($s("b"),Plus($s("n"),Times(CN1,C1))),CN1))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("m"),$s("n")),$s("x")),ZeroQ(Plus(Plus($s("m"),$s("n")),Times(CN1,C2)))),NonzeroQ(Plus($s("n"),Times(CN1,C1)))),PosQ($s("n"))))),
SetDelayed(Int(Times(Power(Csc(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m",true)),Power(Sec(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Dist(Times(C1,Power($s("b"),CN1)),Subst(Int(Regularize(Times(Power(Plus(C1,Power($s("x"),C2)),Plus(Times(Plus($s("m"),$s("n")),C1D2),Times(CN1,C1))),Power(Power($s("x"),$s("m")),CN1)),$s("x")),$s("x")),$s("x"),Tan(Plus($s("a"),Times($s("b"),$s("x")))))),And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ(List($s("m"),$s("n")))),EvenQ(Plus($s("m"),$s("n")))),And(Less(C0,$s("m")),LessEqual($s("m"),$s("n")))))),
SetDelayed(Int(Times(Power(Csc(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m")),Power(Sec(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power(Csc(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),C1)),Times(Power(Sec(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C1))),Power(Times($s("b"),Plus($s("n"),Times(CN1,C1))),CN1))),Dist(Times(Plus($s("m"),C1),Power(Plus($s("n"),Times(CN1,C1)),CN1)),Int(Times(Power(Csc(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),C2)),Power(Sec(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C2)))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),RationalQ(List($s("m"),$s("n")))),Less($s("m"),CN1)),Greater($s("n"),C1)))),
SetDelayed(Int(Times(Power(Csc(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m",true)),Power(Sec(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power(Csc(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),Times(CN1,C1))),Times(Power(Sec(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C1))),Power(Times($s("b"),Plus($s("n"),Times(CN1,C1))),CN1))),Dist(Times(Plus(Plus($s("m"),$s("n")),Times(CN1,C2)),Power(Plus($s("n"),Times(CN1,C1)),CN1)),Int(Times(Power(Csc(Plus($s("a"),Times($s("b"),$s("x")))),$s("m")),Power(Sec(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C2)))),$s("x")))),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("m")),$s("x")),RationalQ($s("n"))),Greater($s("n"),C1)),Not(EvenQ(Plus($s("m"),$s("n"))))),Not(And(And(EvenQ($s("n")),OddQ($s("m"))),Greater($s("m"),C1)))))),
SetDelayed(Int(Times(Power(Csc(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m",true)),Power(Sec(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Power(Csc(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),Times(CN1,C1)))),Times(Power(Sec(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C1)),Power(Times($s("b"),Plus($s("m"),$s("n"))),CN1))),Dist(Times(Plus($s("n"),C1),Power(Plus($s("m"),$s("n")),CN1)),Int(Times(Power(Csc(Plus($s("a"),Times($s("b"),$s("x")))),$s("m")),Power(Sec(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C2))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("m")),$s("x")),RationalQ($s("n"))),Less($s("n"),CN1)),NonzeroQ(Plus($s("m"),$s("n")))))),
SetDelayed(Int(Times(Power(Sec(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m",true)),Power(Tan(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Times(Power(Sec(Plus($s("a"),Times($s("b"),$s("x")))),$s("m")),Power(Times($s("b"),$s("m")),CN1)),And(FreeQ(List($s("a"),$s("b"),$s("m")),$s("x")),SameQ($s("n"),C1)))),
SetDelayed(Int(Times(Power(Sec(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m")),Power(Tan(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Dist(Times(C1,Power($s("b"),CN1)),Subst(Int(Regularize(Times(Power($s("x"),$s("n")),Power(Plus(C1,Power($s("x"),C2)),Times(Plus($s("m"),Times(CN1,C2)),C1D2))),$s("x")),$s("x")),$s("x"),Tan(Plus($s("a"),Times($s("b"),$s("x")))))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("n")),$s("x")),EvenQ($s("m"))),Greater($s("m"),C2)),Not(And(OddQ($s("n")),Less(Less(C0,$s("n")),Plus($s("m"),Times(CN1,C1)))))))),
SetDelayed(Int(Times(Power(Sec(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m",true)),Power(Tan(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Dist(Times(C1,Power($s("b"),CN1)),Subst(Int(Regularize(Times(Power($s("x"),Plus($s("m"),Times(CN1,C1))),Power(Plus(CN1,Power($s("x"),C2)),Times(Plus($s("n"),Times(CN1,C1)),C1D2))),$s("x")),$s("x")),$s("x"),Sec(Plus($s("a"),Times($s("b"),$s("x")))))),And(And(FreeQ(List($s("a"),$s("b"),$s("m")),$s("x")),OddQ($s("n"))),Not(And(EvenQ($s("m")),And(Less(C0,$s("m")),LessEqual($s("m"),Plus($s("n"),C1)))))))),
SetDelayed(Int(Times(Power(Sec(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m")),Power(Tan(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power(Sec(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),Times(CN1,C2))),Times(Power(Tan(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C1)),Power(Times($s("b"),Plus($s("n"),C1)),CN1))),Times(CN1,Dist(Times(Plus($s("m"),Times(CN1,C2)),Power(Plus($s("n"),C1),CN1)),Int(Times(Power(Sec(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),Times(CN1,C2))),Power(Tan(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C2))),$s("x"))))),And(And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),RationalQ(List($s("m"),$s("n")))),Greater($s("m"),C1)),Less($s("n"),CN1)),Not(EvenQ($s("m"))))))
  );
}
