package org.matheclipse.core.integrate.rubi;


import static org.matheclipse.core.expression.F.*;
import static org.matheclipse.core.integrate.rubi.UtilityFunctionCtors.*;
import static org.matheclipse.core.integrate.rubi.UtilityFunctions.*;
import org.matheclipse.core.interfaces.IAST;
import org.matheclipse.core.interfaces.IExpr;

/** 
 * IndefiniteIntegrationRules from the <a href="http://www.apmaths.uwo.ca/~arich/">Rubi -
 * rule-based integrator</a>.
 *  
 */
public class IndefiniteIntegrationRules6 { 
  public static IAST RULES = List( 
SetDelayed(Int(Times(Power(Sec(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m")),Power(Tan(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power(Sec(Plus($s("a"),Times($s("b"),$s("x")))),$s("m")),Times(Power(Tan(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C1))),Power(Times($s("b"),$s("m")),CN1))),Times(CN1,Dist(Times(Plus($s("n"),Times(CN1,C1)),Power($s("m"),CN1)),Int(Times(Power(Sec(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),C2)),Power(Tan(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C2)))),$s("x"))))),And(And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),RationalQ(List($s("m"),$s("n")))),Less($s("m"),CN1)),Greater($s("n"),C1)),Not(EvenQ($s("m")))))),
SetDelayed(Int(Times(Power(Sec(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m")),Power(Tan(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Times(Times(CN1,Power(Sec(Plus($s("a"),Times($s("b"),$s("x")))),$s("m"))),Times(Power(Tan(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C1)),Power(Times($s("b"),$s("m")),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("m"),$s("n")),$s("x")),ZeroQ(Plus(Plus($s("m"),$s("n")),C1))))),
SetDelayed(Int(Times(Power(Sec(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m")),Power(Tan(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Power(Sec(Plus($s("a"),Times($s("b"),$s("x")))),$s("m"))),Times(Power(Tan(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C1)),Power(Times($s("b"),$s("m")),CN1))),Dist(Times(Plus(Plus($s("m"),$s("n")),C1),Power($s("m"),CN1)),Int(Times(Power(Sec(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),C2)),Power(Tan(Plus($s("a"),Times($s("b"),$s("x")))),$s("n"))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("n")),$s("x")),RationalQ($s("m"))),Less($s("m"),CN1)),Not(EvenQ($s("m")))))),
SetDelayed(Int(Times(Power(Sec(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m")),Power(Tan(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power(Sec(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),Times(CN1,C2))),Times(Power(Tan(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C1)),Power(Times($s("b"),Plus(Plus($s("m"),$s("n")),Times(CN1,C1))),CN1))),Dist(Times(Plus($s("m"),Times(CN1,C2)),Power(Plus(Plus($s("m"),$s("n")),Times(CN1,C1)),CN1)),Int(Times(Power(Sec(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),Times(CN1,C2))),Power(Tan(Plus($s("a"),Times($s("b"),$s("x")))),$s("n"))),$s("x")))),And(And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("n")),$s("x")),RationalQ($s("m"))),Greater($s("m"),C1)),NonzeroQ(Plus(Plus($s("m"),$s("n")),Times(CN1,C1)))),Not(EvenQ($s("m")))),Not(OddQ($s("n")))))),
SetDelayed(Int(Times(Power(Sec(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m",true)),Power(Tan(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power(Sec(Plus($s("a"),Times($s("b"),$s("x")))),$s("m")),Times(Power(Tan(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C1))),Power(Times($s("b"),Plus(Plus($s("m"),$s("n")),Times(CN1,C1))),CN1))),Times(CN1,Dist(Times(Plus($s("n"),Times(CN1,C1)),Power(Plus(Plus($s("m"),$s("n")),Times(CN1,C1)),CN1)),Int(Times(Power(Sec(Plus($s("a"),Times($s("b"),$s("x")))),$s("m")),Power(Tan(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C2)))),$s("x"))))),And(And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("m")),$s("x")),RationalQ($s("n"))),Greater($s("n"),C1)),NonzeroQ(Plus(Plus($s("m"),$s("n")),Times(CN1,C1)))),Not(EvenQ($s("m")))),Not(OddQ($s("n")))))),
SetDelayed(Int(Times(Power(Sec(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m")),Power(Tan(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power(Sec(Plus($s("a"),Times($s("b"),$s("x")))),$s("m")),Times(Power(Tan(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C1)),Power(Times($s("b"),Plus($s("n"),C1)),CN1))),Times(CN1,Dist(Times(Plus(Plus($s("m"),$s("n")),C1),Power(Plus($s("n"),C1),CN1)),Int(Times(Power(Sec(Plus($s("a"),Times($s("b"),$s("x")))),$s("m")),Power(Tan(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C2))),$s("x"))))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("m")),$s("x")),RationalQ($s("n"))),Less($s("n"),CN1)),Not(EvenQ($s("m")))))),
SetDelayed(Int(Times(Times(Power($p("x"),$p("m",true)),Power(Sec(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n",true))))),$p("p"))),Sin(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n",true)))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus(Plus($s("m"),Times(CN1,$s("n"))),C1)),Times(Power(Sec(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),Plus($s("p"),Times(CN1,C1))),Power(Times(Times($s("b"),$s("n")),Plus($s("p"),Times(CN1,C1))),CN1))),Times(CN1,Dist(Times(Plus(Plus($s("m"),Times(CN1,$s("n"))),C1),Power(Times(Times($s("b"),$s("n")),Plus($s("p"),Times(CN1,C1))),CN1)),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,$s("n")))),Power(Sec(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),Plus($s("p"),Times(CN1,C1)))),$s("x"))))),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("p")),$s("x")),RationalQ($s("m"))),IntegerQ($s("n"))),GreaterEqual(Plus($s("m"),Times(CN1,$s("n"))),C0)),NonzeroQ(Plus($s("p"),Times(CN1,C1)))))),
SetDelayed(Int(Times(Times(Power($p("x"),$p("m",true)),Power(Sec(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n",true))))),$p("p",true))),Power(Tan(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n",true))))),$p("q",true))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus(Plus($s("m"),Times(CN1,$s("n"))),C1)),Times(Power(Sec(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),$s("p")),Power(Times(Times($s("b"),$s("n")),$s("p")),CN1))),Times(CN1,Dist(Times(Plus(Plus($s("m"),Times(CN1,$s("n"))),C1),Power(Times(Times($s("b"),$s("n")),$s("p")),CN1)),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,$s("n")))),Power(Sec(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),$s("p"))),$s("x"))))),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("p")),$s("x")),RationalQ($s("m"))),IntegerQ($s("n"))),GreaterEqual(Plus($s("m"),Times(CN1,$s("n"))),C0)),SameQ($s("q"),C1)))),
SetDelayed(Int(Power(Sec(Plus($p("a",true),Times($p("b",true),Log(Times($p("c",true),Power($p("x"),$p("n",true))))))),$p("p")),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times($s("x"),Tan(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n")))))))),Times(Power(Sec(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),Times(CN1,C2))),Power(Times(Times($s("b"),$s("n")),Plus($s("p"),Times(CN1,C1))),CN1))),Times(CN1,Times($s("x"),Times(Power(Sec(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),Times(CN1,C2))),Power(Times(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Plus($s("p"),Times(CN1,C1))),Plus($s("p"),Times(CN1,C2))),CN1))))),Dist(Times(Plus(C1,Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Power(Plus($s("p"),Times(CN1,C2)),C2))),Power(Times(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Plus($s("p"),Times(CN1,C1))),Plus($s("p"),Times(CN1,C2))),CN1)),Int(Power(Sec(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),Times(CN1,C2))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("n")),$s("x")),RationalQ($s("p"))),Greater($s("p"),C1)),Unequal($s("p"),C2)))),
SetDelayed(Int(Power(Sec(Plus($p("a",true),Times($p("b",true),Log(Times($p("c",true),Power($p("x"),$p("n",true))))))),$p("p")),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times($s("x"),Times(Power(Sec(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),$s("p")),Power(Plus(C1,Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Power($s("p"),C2))),CN1))),Times(CN1,Times(Times(Times(Times(Times($s("b"),$s("n")),$s("p")),$s("x")),Power(Sec(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),C1))),Times(Sin(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Power(Plus(C1,Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Power($s("p"),C2))),CN1))))),Dist(Times(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),$s("p")),Times(Plus($s("p"),C1),Power(Plus(C1,Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Power($s("p"),C2))),CN1))),Int(Power(Sec(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),C2)),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("n")),$s("x")),RationalQ($s("p"))),Less($s("p"),CN1)),NonzeroQ(Plus(C1,Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Power($s("p"),C2))))))),
SetDelayed(Int(Times(Power(Sec(Plus($p("a",true),Times($p("b",true),Log(Times($p("c",true),Power($p("x"),$p("n",true))))))),C2),Power($p("x"),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Tan(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Power(Times($s("b"),$s("n")),CN1)),FreeQ(List($s("a"),$s("b"),$s("c"),$s("n")),$s("x")))),
SetDelayed(Int(Times(Power(Sec(Plus($p("a",true),Times($p("b",true),Log(Times($p("c",true),Power($p("x"),$p("n",true))))))),$p("p")),Power($p("x"),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Tan(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Times(Power(Sec(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),Times(CN1,C2))),Power(Times(Times($s("b"),$s("n")),Plus($s("p"),Times(CN1,C1))),CN1))),Dist(Times(Plus($s("p"),Times(CN1,C2)),Power(Plus($s("p"),Times(CN1,C1)),CN1)),Int(Times(Power(Sec(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),Times(CN1,C2))),Power($s("x"),CN1)),$s("x")))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("n")),$s("x")),RationalQ($s("p"))),Greater($s("p"),C1)))),
SetDelayed(Int(Times(Power(Sec(Plus($p("a",true),Times($p("b",true),Log(Times($p("c",true),Power($p("x"),$p("n",true))))))),$p("p")),Power($p("x"),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Power(Sec(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),C1))),Times(Sin(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Power(Times(Times($s("b"),$s("n")),$s("p")),CN1))),Dist(Times(Plus($s("p"),C1),Power($s("p"),CN1)),Int(Times(Power(Sec(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),C2)),Power($s("x"),CN1)),$s("x")))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("n")),$s("x")),RationalQ($s("p"))),Less($s("p"),CN1)))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Sec(Plus($p("a",true),Times($p("b",true),Log(Times($p("c",true),Power($p("x"),$p("n",true))))))),$p("p"))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(Power($s("x"),Plus($s("m"),C1)),Tan(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n")))))))),Times(Power(Sec(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),Times(CN1,C2))),Power(Times(Times($s("b"),$s("n")),Plus($s("p"),Times(CN1,C1))),CN1))),Times(CN1,Times(Times(Plus($s("m"),C1),Power($s("x"),Plus($s("m"),C1))),Times(Power(Sec(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),Times(CN1,C2))),Power(Times(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Plus($s("p"),Times(CN1,C1))),Plus($s("p"),Times(CN1,C2))),CN1))))),Dist(Times(Plus(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Power(Plus($s("p"),Times(CN1,C2)),C2)),Power(Plus($s("m"),C1),C2)),Power(Times(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Plus($s("p"),Times(CN1,C1))),Plus($s("p"),Times(CN1,C2))),CN1)),Int(Times(Power($s("x"),$s("m")),Power(Sec(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),Times(CN1,C2)))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("m"),$s("n")),$s("x")),RationalQ($s("p"))),Greater($s("p"),C1)),Unequal($s("p"),C2)))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Sec(Plus($p("a",true),Times($p("b",true),Log(Times($p("c",true),Power($p("x"),$p("n",true))))))),$p("p"))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(Plus($s("m"),C1),Power($s("x"),Plus($s("m"),C1))),Times(Power(Sec(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),$s("p")),Power(Plus(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Power($s("p"),C2)),Power(Plus($s("m"),C1),C2)),CN1))),Times(CN1,Times(Times(Times(Times(Times($s("b"),$s("n")),$s("p")),Power($s("x"),Plus($s("m"),C1))),Power(Sec(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),C1))),Times(Sin(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Power(Plus(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Power($s("p"),C2)),Power(Plus($s("m"),C1),C2)),CN1))))),Dist(Times(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),$s("p")),Times(Plus($s("p"),C1),Power(Plus(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Power($s("p"),C2)),Power(Plus($s("m"),C1),C2)),CN1))),Int(Times(Power($s("x"),$s("m")),Power(Sec(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),C2))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("m"),$s("n")),$s("x")),RationalQ($s("p"))),Less($s("p"),CN1)),NonzeroQ(Plus(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Power($s("p"),C2)),Power(Plus($s("m"),C1),C2)))))),
SetDelayed(Int(Csc(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("x",$s("Symbol"))),
    Condition(Times(Times(CN1,ArcTanh(Cos(Plus($s("a"),Times($s("b"),$s("x")))))),Power($s("b"),CN1)),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(Times(C1,Power(Sqrt(Csc(Plus($p("a",true),Times($p("b",true),$p("x"))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Times(Sqrt(Csc(Plus($s("a"),Times($s("b"),$s("x"))))),Sqrt(Sin(Plus($s("a"),Times($s("b"),$s("x")))))),Int(Sqrt(Sin(Plus($s("a"),Times($s("b"),$s("x"))))),$s("x"))),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(Power(Times($p("c",true),Csc(Plus($p("a",true),Times($p("b",true),$p("x"))))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Times(Times(Power(Times($s("c"),Csc(Plus($s("a"),Times($s("b"),$s("x"))))),$s("n")),Power(Sin(Plus($s("a"),Times($s("b"),$s("x")))),$s("n"))),Int(Times(C1,Power(Power(Sin(Plus($s("a"),Times($s("b"),$s("x")))),$s("n")),CN1)),$s("x"))),And(And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),RationalQ($s("n"))),Less(Less(CN1,$s("n")),C1)))),
SetDelayed(Int(Power(Csc(Plus($p("a",true),Times($p("b",true),$p("x")))),C2),$p("x",$s("Symbol"))),
    Condition(Times(Times(CN1,Cot(Plus($s("a"),Times($s("b"),$s("x"))))),Power($s("b"),CN1)),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(Power(Csc(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Dist(Times(CN1,Power($s("b"),CN1)),Subst(Int(Regularize(Power(Plus(C1,Power($s("x"),C2)),Times(Plus($s("n"),Times(CN1,C2)),C1D2)),$s("x")),$s("x")),$s("x"),Cot(Plus($s("a"),Times($s("b"),$s("x")))))),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),EvenQ($s("n"))),Greater($s("n"),C1)))),
SetDelayed(Int(Power(Times($p("c",true),Csc(Plus($p("a",true),Times($p("b",true),$p("x"))))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(Times(CN1,$s("c")),Cos(Plus($s("a"),Times($s("b"),$s("x"))))),Times(Power(Times($s("c"),Csc(Plus($s("a"),Times($s("b"),$s("x"))))),Plus($s("n"),Times(CN1,C1))),Power(Times($s("b"),Plus($s("n"),Times(CN1,C1))),CN1))),Dist(Times(Plus($s("n"),Times(CN1,C2)),Times(Power($s("c"),C2),Power(Plus($s("n"),Times(CN1,C1)),CN1))),Int(Power(Times($s("c"),Csc(Plus($s("a"),Times($s("b"),$s("x"))))),Plus($s("n"),Times(CN1,C2))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),RationalQ($s("n"))),Greater($s("n"),C1)),Not(EvenQ($s("n")))))),
SetDelayed(Int(Power(Times($p("c",true),Csc(Plus($p("a",true),Times($p("b",true),$p("x"))))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Cos(Plus($s("a"),Times($s("b"),$s("x")))),Times(Power(Times($s("c"),Csc(Plus($s("a"),Times($s("b"),$s("x"))))),Plus($s("n"),C1)),Power(Times(Times($s("b"),$s("c")),$s("n")),CN1))),Dist(Times(Plus($s("n"),C1),Power(Times(Power($s("c"),C2),$s("n")),CN1)),Int(Power(Times($s("c"),Csc(Plus($s("a"),Times($s("b"),$s("x"))))),Plus($s("n"),C2)),$s("x")))),And(And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),RationalQ($s("n"))),Less($s("n"),CN1)))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Csc(Plus($p("a",true),Times($p("b",true),$p("x"))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(integer(-2L),Power($s("x"),$s("m"))),Times(ArcTanh(Power(E,Plus(Times(CI,$s("a")),Times(Times(CI,$s("b")),$s("x"))))),Power($s("b"),CN1))),Dist(Times(C2,Times($s("m"),Power($s("b"),CN1))),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,C1))),ArcTanh(Power(E,Plus(Times(CI,$s("a")),Times(Times(CI,$s("b")),$s("x")))))),$s("x")))),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ($s("m"))),Greater($s("m"),C0)))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Csc(Plus($p("a",true),Times($p("b",true),$p("x")))),C2)),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Power($s("x"),$s("m"))),Times(Cot(Plus($s("a"),Times($s("b"),$s("x")))),Power($s("b"),CN1))),Dist(Times($s("m"),Power($s("b"),CN1)),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,C1))),Cot(Plus($s("a"),Times($s("b"),$s("x"))))),$s("x")))),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),RationalQ($s("m"))),Greater($s("m"),C0)))),
SetDelayed(Int(Times($p("x"),Power(Csc(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(Times(CN1,$s("x")),Cot(Plus($s("a"),Times($s("b"),$s("x"))))),Times(Power(Csc(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C2))),Power(Times($s("b"),Plus($s("n"),Times(CN1,C1))),CN1))),Times(CN1,Times(Power(Csc(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C2))),Power(Times(Times(Power($s("b"),C2),Plus($s("n"),Times(CN1,C1))),Plus($s("n"),Times(CN1,C2))),CN1)))),Dist(Times(Plus($s("n"),Times(CN1,C2)),Power(Plus($s("n"),Times(CN1,C1)),CN1)),Int(Times($s("x"),Power(Csc(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C2)))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),RationalQ($s("n"))),Greater($s("n"),C1)),Unequal($s("n"),C2)))),
SetDelayed(Int(Times(Power($p("x"),$p("m")),Power(Csc(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Plus(Times(Times(Times(CN1,Power($s("x"),$s("m"))),Cot(Plus($s("a"),Times($s("b"),$s("x"))))),Times(Power(Csc(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C2))),Power(Times($s("b"),Plus($s("n"),Times(CN1,C1))),CN1))),Times(CN1,Times(Times($s("m"),Power($s("x"),Plus($s("m"),Times(CN1,C1)))),Times(Power(Csc(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C2))),Power(Times(Times(Power($s("b"),C2),Plus($s("n"),Times(CN1,C1))),Plus($s("n"),Times(CN1,C2))),CN1))))),Dist(Times(Plus($s("n"),Times(CN1,C2)),Power(Plus($s("n"),Times(CN1,C1)),CN1)),Int(Times(Power($s("x"),$s("m")),Power(Csc(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C2)))),$s("x")))),Dist(Times($s("m"),Times(Plus($s("m"),Times(CN1,C1)),Power(Times(Times(Power($s("b"),C2),Plus($s("n"),Times(CN1,C1))),Plus($s("n"),Times(CN1,C2))),CN1))),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,C2))),Power(Csc(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C2)))),$s("x")))),And(And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),RationalQ(List($s("m"),$s("n")))),Greater($s("n"),C1)),Unequal($s("n"),C2)),Greater($s("m"),C1)))),
SetDelayed(Int(Times($p("x"),Power(Csc(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Power(Csc(Plus($s("a"),Times($s("b"),$s("x")))),$s("n")),Power(Times(Power($s("b"),C2),Power($s("n"),C2)),CN1)),Times(Times($s("x"),Cos(Plus($s("a"),Times($s("b"),$s("x"))))),Times(Power(Csc(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C1)),Power(Times($s("b"),$s("n")),CN1)))),Dist(Times(Plus($s("n"),C1),Power($s("n"),CN1)),Int(Times($s("x"),Power(Csc(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C2))),$s("x")))),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),RationalQ($s("n"))),Less($s("n"),CN1)))),
SetDelayed(Int(Times(Power($p("x"),$p("m")),Power(Csc(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Plus(Times(Times($s("m"),Power($s("x"),Plus($s("m"),Times(CN1,C1)))),Times(Power(Csc(Plus($s("a"),Times($s("b"),$s("x")))),$s("n")),Power(Times(Power($s("b"),C2),Power($s("n"),C2)),CN1))),Times(Times(Power($s("x"),$s("m")),Cos(Plus($s("a"),Times($s("b"),$s("x"))))),Times(Power(Csc(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C1)),Power(Times($s("b"),$s("n")),CN1)))),Dist(Times(Plus($s("n"),C1),Power($s("n"),CN1)),Int(Times(Power($s("x"),$s("m")),Power(Csc(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C2))),$s("x")))),Times(CN1,Dist(Times($s("m"),Times(Plus($s("m"),Times(CN1,C1)),Power(Times(Power($s("b"),C2),Power($s("n"),C2)),CN1))),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,C2))),Power(Csc(Plus($s("a"),Times($s("b"),$s("x")))),$s("n"))),$s("x"))))),And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),RationalQ(List($s("m"),$s("n")))),Less($s("n"),CN1)),Greater($s("m"),C1)))),
SetDelayed(Int(Sqrt(Plus($p("a"),Times($p("b",true),Csc(Plus($p("c",true),Times($p("d",true),$p("x"))))))),$p("x",$s("Symbol"))),
    Condition(Times(Times(Times(integer(-2L),$s("a")),ArcTan(Sqrt(Plus(CN1,Times(Times($s("a"),Power($s("b"),CN1)),Csc(Plus($s("c"),Times($s("d"),$s("x"))))))))),Times(Cot(Plus($s("c"),Times($s("d"),$s("x")))),Power(Times(Times($s("d"),Sqrt(Plus(CN1,Times(Times($s("a"),Power($s("b"),CN1)),Csc(Plus($s("c"),Times($s("d"),$s("x")))))))),Sqrt(Plus($s("a"),Times($s("b"),Csc(Plus($s("c"),Times($s("d"),$s("x")))))))),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),ZeroQ(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))))))),
SetDelayed(Int(Times(C1,Power(Sqrt(Plus($p("a"),Times($p("b",true),Csc(Plus($p("c",true),Times($p("d",true),$p("x"))))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Times(Times(Times(CN1,Plus(Times(Sqrt(C2),ArcTan(Times(Times(Sqrt(C2),Sqrt($s("a"))),Power(Sqrt(Plus(Times(CN1,$s("a")),Times($s("b"),Csc($s("x"))))),CN1)))),Times(C2,ArcTan(Times(Sqrt(Plus(Times(CN1,$s("a")),Times($s("b"),Csc($s("x"))))),Power(Sqrt($s("a")),CN1)))))),Sqrt(Plus(Times(CN1,$s("a")),Times($s("b"),Csc($s("x")))))),Sqrt(Plus($s("a"),Times($s("b"),Csc($s("x")))))),Times(Tan($s("x")),Power(Power($s("a"),fraction(3L,2L)),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),ZeroQ(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))))))),
SetDelayed(Int(Power(Plus($p("a"),Times($p("b",true),Power(Csc($p("v")),$p("n",true)))),$p("m")),$p("x",$s("Symbol"))),
    Condition(Int(Times(Power(Plus($s("b"),Times($s("a"),Power(Sin($s("v")),$s("n")))),$s("m")),Power(Power(Sin($s("v")),Times($s("m"),$s("n"))),CN1)),$s("x")),And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ(List($s("m"),$s("n")))),Less($s("m"),C0)),Greater($s("n"),C0)))),
SetDelayed(Int(Times(Power(Sin($p("v")),$p("p",true)),Power(Plus($p("a"),Times($p("b",true),Power(Csc($p("v")),$p("n",true)))),$p("m"))),$p("x",$s("Symbol"))),
    Condition(Int(Times(Power(Sin($s("v")),Plus($s("p"),Times(CN1,Times($s("m"),$s("n"))))),Power(Plus($s("b"),Times($s("a"),Power(Sin($s("v")),$s("n")))),$s("m"))),$s("x")),And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ(List($s("m"),$s("n"),$s("p")))),Less($s("m"),C0)),Greater($s("n"),C0)))),
SetDelayed(Int(Times(Csc(Plus($p("a",true),Times($p("b",true),$p("x")))),Sec(Plus($p("a",true),Times($p("b",true),$p("x"))))),$p("x",$s("Symbol"))),
    Condition(Times(Times(CN1,Log(Cot(Plus($s("a"),Times($s("b"),$s("x")))))),Power($s("b"),CN1)),And(FreeQ(List($s("a"),$s("b")),$s("x")),NegQ($s("b"))))),
SetDelayed(Int(Times(Power(Csc(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m")),Power(Sec(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Times(Times(CN1,Power(Csc(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),Times(CN1,C1)))),Times(Power(Sec(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C1))),Power(Times($s("b"),Plus($s("m"),Times(CN1,C1))),CN1))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("m"),$s("n")),$s("x")),ZeroQ(Plus(Plus($s("m"),$s("n")),Times(CN1,C2)))),NonzeroQ(Plus($s("m"),Times(CN1,C1)))),PosQ($s("m"))))),
SetDelayed(Int(Times(Power(Csc(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m")),Power(Sec(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Dist(Times(CN1,Power($s("b"),CN1)),Subst(Int(Regularize(Times(Power(Plus(C1,Power($s("x"),C2)),Plus(Times(Plus($s("m"),$s("n")),C1D2),Times(CN1,C1))),Power(Power($s("x"),$s("n")),CN1)),$s("x")),$s("x")),$s("x"),Cot(Plus($s("a"),Times($s("b"),$s("x")))))),And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ(List($s("m"),$s("n")))),EvenQ(Plus($s("m"),$s("n")))),Less(Less(C0,$s("n")),$s("m"))))),
SetDelayed(Int(Times(Power(Csc(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m")),Power(Sec(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Power(Csc(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),Times(CN1,C1)))),Times(Power(Sec(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C1)),Power(Times($s("b"),Plus($s("m"),Times(CN1,C1))),CN1))),Dist(Times(Plus($s("n"),C1),Power(Plus($s("m"),Times(CN1,C1)),CN1)),Int(Times(Power(Csc(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),Times(CN1,C2))),Power(Sec(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C2))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),RationalQ(List($s("m"),$s("n")))),Greater($s("m"),C1)),Less($s("n"),CN1)))),
SetDelayed(Int(Times(Power(Csc(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m")),Power(Sec(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Power(Csc(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),Times(CN1,C1)))),Times(Power(Sec(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C1))),Power(Times($s("b"),Plus($s("m"),Times(CN1,C1))),CN1))),Dist(Times(Plus(Plus($s("m"),$s("n")),Times(CN1,C2)),Power(Plus($s("m"),Times(CN1,C1)),CN1)),Int(Times(Power(Csc(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),Times(CN1,C2))),Power(Sec(Plus($s("a"),Times($s("b"),$s("x")))),$s("n"))),$s("x")))),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("n")),$s("x")),RationalQ($s("m"))),Greater($s("m"),C1)),Not(EvenQ(Plus($s("m"),$s("n"))))),Not(And(And(EvenQ($s("m")),OddQ($s("n"))),Greater($s("n"),C1)))))),
SetDelayed(Int(Times(Power(Csc(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m")),Power(Sec(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power(Csc(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),C1)),Times(Power(Sec(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C1))),Power(Times($s("b"),Plus($s("m"),$s("n"))),CN1))),Dist(Times(Plus($s("m"),C1),Power(Plus($s("m"),$s("n")),CN1)),Int(Times(Power(Csc(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),C2)),Power(Sec(Plus($s("a"),Times($s("b"),$s("x")))),$s("n"))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("n")),$s("x")),RationalQ($s("m"))),Less($s("m"),CN1)),NonzeroQ(Plus($s("m"),$s("n")))))),
SetDelayed(Int(Times(Power(Csc(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m",true)),Power(Cot(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Times(Times(CN1,Power(Csc(Plus($s("a"),Times($s("b"),$s("x")))),$s("m"))),Power(Times($s("b"),$s("m")),CN1)),And(FreeQ(List($s("a"),$s("b"),$s("m")),$s("x")),SameQ($s("n"),C1)))),
SetDelayed(Int(Times(Power(Csc(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m")),Power(Cot(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Dist(Times(CN1,Power($s("b"),CN1)),Subst(Int(Regularize(Times(Power($s("x"),$s("n")),Power(Plus(C1,Power($s("x"),C2)),Times(Plus($s("m"),Times(CN1,C2)),C1D2))),$s("x")),$s("x")),$s("x"),Cot(Plus($s("a"),Times($s("b"),$s("x")))))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("n")),$s("x")),EvenQ($s("m"))),Greater($s("m"),C2)),Not(And(OddQ($s("n")),Less(Less(C0,$s("n")),Plus($s("m"),Times(CN1,C1)))))))),
SetDelayed(Int(Times(Power(Csc(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m",true)),Power(Cot(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Dist(Times(CN1,Power($s("b"),CN1)),Subst(Int(Regularize(Times(Power($s("x"),Plus($s("m"),Times(CN1,C1))),Power(Plus(CN1,Power($s("x"),C2)),Times(Plus($s("n"),Times(CN1,C1)),C1D2))),$s("x")),$s("x")),$s("x"),Csc(Plus($s("a"),Times($s("b"),$s("x")))))),And(And(FreeQ(List($s("a"),$s("b"),$s("m")),$s("x")),OddQ($s("n"))),Not(And(EvenQ($s("m")),And(Less(C0,$s("m")),LessEqual($s("m"),Plus($s("n"),C1)))))))),
SetDelayed(Int(Times(Power(Csc(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m")),Power(Cot(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Power(Csc(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),Times(CN1,C2)))),Times(Power(Cot(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C1)),Power(Times($s("b"),Plus($s("n"),C1)),CN1))),Times(CN1,Dist(Times(Plus($s("m"),Times(CN1,C2)),Power(Plus($s("n"),C1),CN1)),Int(Times(Power(Csc(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),Times(CN1,C2))),Power(Cot(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C2))),$s("x"))))),And(And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),RationalQ(List($s("m"),$s("n")))),Greater($s("m"),C1)),Less($s("n"),CN1)),Not(EvenQ($s("m")))))),
SetDelayed(Int(Times(Power(Csc(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m")),Power(Cot(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Power(Csc(Plus($s("a"),Times($s("b"),$s("x")))),$s("m"))),Times(Power(Cot(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C1))),Power(Times($s("b"),$s("m")),CN1))),Times(CN1,Dist(Times(Plus($s("n"),Times(CN1,C1)),Power($s("m"),CN1)),Int(Times(Power(Csc(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),C2)),Power(Cot(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C2)))),$s("x"))))),And(And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),RationalQ(List($s("m"),$s("n")))),Less($s("m"),CN1)),Greater($s("n"),C1)),Not(EvenQ($s("m")))))),
SetDelayed(Int(Times(Power(Csc(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m",true)),Power(Cot(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Times(Power(Csc(Plus($s("a"),Times($s("b"),$s("x")))),$s("m")),Times(Power(Cot(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C1)),Power(Times($s("b"),$s("m")),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("m"),$s("n")),$s("x")),ZeroQ(Plus(Plus($s("m"),$s("n")),C1))))),
SetDelayed(Int(Times(Power(Csc(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m")),Power(Cot(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power(Csc(Plus($s("a"),Times($s("b"),$s("x")))),$s("m")),Times(Power(Cot(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C1)),Power(Times($s("b"),$s("m")),CN1))),Dist(Times(Plus(Plus($s("m"),$s("n")),C1),Power($s("m"),CN1)),Int(Times(Power(Csc(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),C2)),Power(Cot(Plus($s("a"),Times($s("b"),$s("x")))),$s("n"))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("n")),$s("x")),RationalQ($s("m"))),Less($s("m"),CN1)),Not(EvenQ($s("m")))))),
SetDelayed(Int(Times(Power(Csc(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m")),Power(Cot(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Power(Csc(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),Times(CN1,C2)))),Times(Power(Cot(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C1)),Power(Times($s("b"),Plus(Plus($s("m"),$s("n")),Times(CN1,C1))),CN1))),Dist(Times(Plus($s("m"),Times(CN1,C2)),Power(Plus(Plus($s("m"),$s("n")),Times(CN1,C1)),CN1)),Int(Times(Power(Csc(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),Times(CN1,C2))),Power(Cot(Plus($s("a"),Times($s("b"),$s("x")))),$s("n"))),$s("x")))),And(And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("n")),$s("x")),RationalQ($s("m"))),Greater($s("m"),C1)),NonzeroQ(Plus(Plus($s("m"),$s("n")),Times(CN1,C1)))),Not(EvenQ($s("m")))),Not(OddQ($s("n")))))),
SetDelayed(Int(Times(Power(Csc(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m",true)),Power(Cot(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Power(Csc(Plus($s("a"),Times($s("b"),$s("x")))),$s("m"))),Times(Power(Cot(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C1))),Power(Times($s("b"),Plus(Plus($s("m"),$s("n")),Times(CN1,C1))),CN1))),Times(CN1,Dist(Times(Plus($s("n"),Times(CN1,C1)),Power(Plus(Plus($s("m"),$s("n")),Times(CN1,C1)),CN1)),Int(Times(Power(Csc(Plus($s("a"),Times($s("b"),$s("x")))),$s("m")),Power(Cot(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C2)))),$s("x"))))),And(And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("m")),$s("x")),RationalQ($s("n"))),Greater($s("n"),C1)),NonzeroQ(Plus(Plus($s("m"),$s("n")),Times(CN1,C1)))),Not(EvenQ($s("m")))),Not(OddQ($s("n")))))),
SetDelayed(Int(Times(Power(Csc(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m",true)),Power(Cot(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Power(Csc(Plus($s("a"),Times($s("b"),$s("x")))),$s("m"))),Times(Power(Cot(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C1)),Power(Times($s("b"),Plus($s("n"),C1)),CN1))),Times(CN1,Dist(Times(Plus(Plus($s("m"),$s("n")),C1),Power(Plus($s("n"),C1),CN1)),Int(Times(Power(Csc(Plus($s("a"),Times($s("b"),$s("x")))),$s("m")),Power(Cot(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C2))),$s("x"))))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("m")),$s("x")),RationalQ($s("n"))),Less($s("n"),CN1)),Not(EvenQ($s("m")))))),
SetDelayed(Int(Times(Times(Power($p("x"),$p("m",true)),Power(Csc(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n",true))))),$p("p"))),Cos(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n",true)))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Power($s("x"),Plus(Plus($s("m"),Times(CN1,$s("n"))),C1))),Times(Power(Csc(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),Plus($s("p"),Times(CN1,C1))),Power(Times(Times($s("b"),$s("n")),Plus($s("p"),Times(CN1,C1))),CN1))),Dist(Times(Plus(Plus($s("m"),Times(CN1,$s("n"))),C1),Power(Times(Times($s("b"),$s("n")),Plus($s("p"),Times(CN1,C1))),CN1)),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,$s("n")))),Power(Csc(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),Plus($s("p"),Times(CN1,C1)))),$s("x")))),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("p")),$s("x")),RationalQ($s("m"))),IntegerQ($s("n"))),GreaterEqual(Plus($s("m"),Times(CN1,$s("n"))),C0)),NonzeroQ(Plus($s("p"),Times(CN1,C1)))))),
SetDelayed(Int(Times(Times(Power($p("x"),$p("m",true)),Power(Csc(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n",true))))),$p("p",true))),Power(Cot(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n",true))))),$p("q",true))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Power($s("x"),Plus(Plus($s("m"),Times(CN1,$s("n"))),C1))),Times(Power(Csc(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),$s("p")),Power(Times(Times($s("b"),$s("n")),$s("p")),CN1))),Dist(Times(Plus(Plus($s("m"),Times(CN1,$s("n"))),C1),Power(Times(Times($s("b"),$s("n")),$s("p")),CN1)),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,$s("n")))),Power(Csc(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),$s("p"))),$s("x")))),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("p")),$s("x")),RationalQ($s("m"))),IntegerQ($s("n"))),GreaterEqual(Plus($s("m"),Times(CN1,$s("n"))),C0)),SameQ($s("q"),C1)))),
SetDelayed(Int(Power(Csc(Plus($p("a",true),Times($p("b",true),Log(Times($p("c",true),Power($p("x"),$p("n",true))))))),$p("p")),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(Times(CN1,$s("x")),Cot(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n")))))))),Times(Power(Csc(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),Times(CN1,C2))),Power(Times(Times($s("b"),$s("n")),Plus($s("p"),Times(CN1,C1))),CN1))),Times(CN1,Times($s("x"),Times(Power(Csc(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),Times(CN1,C2))),Power(Times(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Plus($s("p"),Times(CN1,C1))),Plus($s("p"),Times(CN1,C2))),CN1))))),Dist(Times(Plus(C1,Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Power(Plus($s("p"),Times(CN1,C2)),C2))),Power(Times(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Plus($s("p"),Times(CN1,C1))),Plus($s("p"),Times(CN1,C2))),CN1)),Int(Power(Csc(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),Times(CN1,C2))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("n")),$s("x")),RationalQ($s("p"))),Greater($s("p"),C1)),Unequal($s("p"),C2)))),
SetDelayed(Int(Power(Csc(Plus($p("a",true),Times($p("b",true),Log(Times($p("c",true),Power($p("x"),$p("n",true))))))),$p("p")),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times($s("x"),Times(Power(Csc(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),$s("p")),Power(Plus(C1,Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Power($s("p"),C2))),CN1))),Times(Times(Times(Times(Times($s("b"),$s("n")),$s("p")),$s("x")),Cos(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n")))))))),Times(Power(Csc(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),C1)),Power(Plus(C1,Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Power($s("p"),C2))),CN1)))),Dist(Times(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),$s("p")),Times(Plus($s("p"),C1),Power(Plus(C1,Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Power($s("p"),C2))),CN1))),Int(Power(Csc(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),C2)),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("n")),$s("x")),RationalQ($s("p"))),Less($s("p"),CN1)),NonzeroQ(Plus(C1,Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Power($s("p"),C2))))))),
SetDelayed(Int(Times(Power(Csc(Plus($p("a",true),Times($p("b",true),Log(Times($p("c",true),Power($p("x"),$p("n",true))))))),C2),Power($p("x"),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Times(CN1,Cot(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n")))))))),Power(Times($s("b"),$s("n")),CN1)),FreeQ(List($s("a"),$s("b"),$s("c"),$s("n")),$s("x")))),
SetDelayed(Int(Times(Power(Csc(Plus($p("a",true),Times($p("b",true),Log(Times($p("c",true),Power($p("x"),$p("n",true))))))),$p("p")),Power($p("x"),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Cot(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n")))))))),Times(Power(Csc(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),Times(CN1,C2))),Power(Times(Times($s("b"),$s("n")),Plus($s("p"),Times(CN1,C1))),CN1))),Dist(Times(Plus($s("p"),Times(CN1,C2)),Power(Plus($s("p"),Times(CN1,C1)),CN1)),Int(Times(Power(Csc(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),Times(CN1,C2))),Power($s("x"),CN1)),$s("x")))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("n")),$s("x")),RationalQ($s("p"))),Greater($s("p"),C1)))),
SetDelayed(Int(Times(Power(Csc(Plus($p("a",true),Times($p("b",true),Log(Times($p("c",true),Power($p("x"),$p("n",true))))))),$p("p")),Power($p("x"),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Cos(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Times(Power(Csc(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),C1)),Power(Times(Times($s("b"),$s("n")),$s("p")),CN1))),Dist(Times(Plus($s("p"),C1),Power($s("p"),CN1)),Int(Times(Power(Csc(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),C2)),Power($s("x"),CN1)),$s("x")))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("n")),$s("x")),RationalQ($s("p"))),Less($s("p"),CN1)))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Csc(Plus($p("a",true),Times($p("b",true),Log(Times($p("c",true),Power($p("x"),$p("n",true))))))),$p("p"))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(Times(CN1,Power($s("x"),Plus($s("m"),C1))),Cot(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n")))))))),Times(Power(Csc(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),Times(CN1,C2))),Power(Times(Times($s("b"),$s("n")),Plus($s("p"),Times(CN1,C1))),CN1))),Times(CN1,Times(Times(Plus($s("m"),C1),Power($s("x"),Plus($s("m"),C1))),Times(Power(Csc(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),Times(CN1,C2))),Power(Times(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Plus($s("p"),Times(CN1,C1))),Plus($s("p"),Times(CN1,C2))),CN1))))),Dist(Times(Plus(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Power(Plus($s("p"),Times(CN1,C2)),C2)),Power(Plus($s("m"),C1),C2)),Power(Times(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Plus($s("p"),Times(CN1,C1))),Plus($s("p"),Times(CN1,C2))),CN1)),Int(Times(Power($s("x"),$s("m")),Power(Csc(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),Times(CN1,C2)))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("m"),$s("n")),$s("x")),RationalQ($s("p"))),Greater($s("p"),C1)),Unequal($s("p"),C2)))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Csc(Plus($p("a",true),Times($p("b",true),Log(Times($p("c",true),Power($p("x"),$p("n",true))))))),$p("p"))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(Plus($s("m"),C1),Power($s("x"),Plus($s("m"),C1))),Times(Power(Csc(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),$s("p")),Power(Plus(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Power($s("p"),C2)),Power(Plus($s("m"),C1),C2)),CN1))),Times(Times(Times(Times(Times($s("b"),$s("n")),$s("p")),Power($s("x"),Plus($s("m"),C1))),Cos(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n")))))))),Times(Power(Csc(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),C1)),Power(Plus(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Power($s("p"),C2)),Power(Plus($s("m"),C1),C2)),CN1)))),Dist(Times(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),$s("p")),Times(Plus($s("p"),C1),Power(Plus(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Power($s("p"),C2)),Power(Plus($s("m"),C1),C2)),CN1))),Int(Times(Power($s("x"),$s("m")),Power(Csc(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),C2))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("m"),$s("n")),$s("x")),RationalQ($s("p"))),Less($s("p"),CN1)),NonzeroQ(Plus(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Power($s("p"),C2)),Power(Plus($s("m"),C1),C2)))))),
SetDelayed(Int(Power(Plus(Times($p("a",true),Cos(Plus($p("c",true),Times($p("d",true),$p("x"))))),Times($p("b",true),Sin(Plus($p("c",true),Times($p("d",true),$p("x")))))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Times($s("a"),Times(Power(Plus(Times($s("a"),Cos(Plus($s("c"),Times($s("d"),$s("x"))))),Times($s("b"),Sin(Plus($s("c"),Times($s("d"),$s("x")))))),$s("n")),Power(Times(Times($s("b"),$s("d")),$s("n")),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("n")),$s("x")),ZeroQ(Plus(Power($s("a"),C2),Power($s("b"),C2)))))),
SetDelayed(Int(Times(C1,Power(Power(Plus(Times($p("a",true),Cos(Plus($p("c",true),Times($p("d",true),$p("x"))))),Times($p("b",true),Sin(Plus($p("c",true),Times($p("d",true),$p("x")))))),C2),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Sin(Plus($s("c"),Times($s("d"),$s("x")))),Power(Times(Times($s("a"),$s("d")),Plus(Times($s("a"),Cos(Plus($s("c"),Times($s("d"),$s("x"))))),Times($s("b"),Sin(Plus($s("c"),Times($s("d"),$s("x"))))))),CN1)),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),NonzeroQ(Plus(Power($s("a"),C2),Power($s("b"),C2)))))),
SetDelayed(Int(Sqrt(Plus(Times($p("a",true),Cos(Plus($p("c",true),Times($p("d",true),$p("x"))))),Times($p("b",true),Sin(Plus($p("c",true),Times($p("d",true),$p("x"))))))),$p("x",$s("Symbol"))),
    Condition(Times(Times(C2,EllipticE(Times(Plus(Plus($s("c"),Times($s("d"),$s("x"))),Times(CN1,ArcTan($s("a"),$s("b")))),C1D2),C2)),Times(Sqrt(Plus(Times($s("a"),Cos(Plus($s("c"),Times($s("d"),$s("x"))))),Times($s("b"),Sin(Plus($s("c"),Times($s("d"),$s("x"))))))),Power(Times($s("d"),Sqrt(Times(Plus(Times($s("a"),Cos(Plus($s("c"),Times($s("d"),$s("x"))))),Times($s("b"),Sin(Plus($s("c"),Times($s("d"),$s("x")))))),Power(Sqrt(Plus(Power($s("a"),C2),Power($s("b"),C2))),CN1)))),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),NonzeroQ(Plus(Power($s("a"),C2),Power($s("b"),C2)))))),
SetDelayed(Int(Times(C1,Power(Sqrt(Plus(Times($p("a",true),Cos(Plus($p("c",true),Times($p("d",true),$p("x"))))),Times($p("b",true),Sin(Plus($p("c",true),Times($p("d",true),$p("x"))))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Times(C2,EllipticF(Times(Plus(Plus($s("c"),Times($s("d"),$s("x"))),Times(CN1,ArcTan($s("a"),$s("b")))),C1D2),C2)),Times(Sqrt(Times(Plus(Times($s("a"),Cos(Plus($s("c"),Times($s("d"),$s("x"))))),Times($s("b"),Sin(Plus($s("c"),Times($s("d"),$s("x")))))),Power(Sqrt(Plus(Power($s("a"),C2),Power($s("b"),C2))),CN1))),Power(Times($s("d"),Sqrt(Plus(Times($s("a"),Cos(Plus($s("c"),Times($s("d"),$s("x"))))),Times($s("b"),Sin(Plus($s("c"),Times($s("d"),$s("x")))))))),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),NonzeroQ(Plus(Power($s("a"),C2),Power($s("b"),C2)))))),
SetDelayed(Int(Power(Plus(Times($p("a",true),Cos(Plus($p("c",true),Times($p("d",true),$p("x"))))),Times($p("b",true),Sin(Plus($p("c",true),Times($p("d",true),$p("x")))))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Dist(Times(C1,Power($s("d"),CN1)),Subst(Int(Regularize(Power(Plus(Plus(Power($s("a"),C2),Power($s("b"),C2)),Times(CN1,Power($s("x"),C2))),Times(Plus($s("n"),Times(CN1,C1)),C1D2)),$s("x")),$s("x")),$s("x"),Plus(Times(Times(CN1,$s("b")),Cos(Plus($s("c"),Times($s("d"),$s("x"))))),Times($s("a"),Sin(Plus($s("c"),Times($s("d"),$s("x")))))))),And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),OddQ($s("n"))),GreaterEqual($s("n"),CN1)),NonzeroQ(Plus(Power($s("a"),C2),Power($s("b"),C2)))))),
SetDelayed(Int(Power(Plus(Times($p("a",true),Cos(Plus($p("c",true),Times($p("d",true),$p("x"))))),Times($p("b",true),Sin(Plus($p("c",true),Times($p("d",true),$p("x")))))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Plus(Times($s("b"),Cos(Plus($s("c"),Times($s("d"),$s("x"))))),Times(CN1,Times($s("a"),Sin(Plus($s("c"),Times($s("d"),$s("x")))))))),Times(Power(Plus(Times($s("a"),Cos(Plus($s("c"),Times($s("d"),$s("x"))))),Times($s("b"),Sin(Plus($s("c"),Times($s("d"),$s("x")))))),Plus($s("n"),Times(CN1,C1))),Power(Times($s("d"),$s("n")),CN1))),Dist(Times(Plus($s("n"),Times(CN1,C1)),Times(Plus(Power($s("a"),C2),Power($s("b"),C2)),Power($s("n"),CN1))),Int(Power(Plus(Times($s("a"),Cos(Plus($s("c"),Times($s("d"),$s("x"))))),Times($s("b"),Sin(Plus($s("c"),Times($s("d"),$s("x")))))),Plus($s("n"),Times(CN1,C2))),$s("x")))),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),RationalQ($s("n"))),Greater($s("n"),C1)),NonzeroQ(Plus(Power($s("a"),C2),Power($s("b"),C2)))),Not(OddQ($s("n")))))),
SetDelayed(Int(Power(Plus(Times($p("a",true),Cos(Plus($p("c",true),Times($p("d",true),$p("x"))))),Times($p("b",true),Sin(Plus($p("c",true),Times($p("d",true),$p("x")))))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Plus(Times($s("b"),Cos(Plus($s("c"),Times($s("d"),$s("x"))))),Times(CN1,Times($s("a"),Sin(Plus($s("c"),Times($s("d"),$s("x"))))))),Times(Power(Plus(Times($s("a"),Cos(Plus($s("c"),Times($s("d"),$s("x"))))),Times($s("b"),Sin(Plus($s("c"),Times($s("d"),$s("x")))))),Plus($s("n"),C1)),Power(Times(Times($s("d"),Plus($s("n"),C1)),Plus(Power($s("a"),C2),Power($s("b"),C2))),CN1))),Dist(Times(Plus($s("n"),C2),Power(Times(Plus($s("n"),C1),Plus(Power($s("a"),C2),Power($s("b"),C2))),CN1)),Int(Power(Plus(Times($s("a"),Cos(Plus($s("c"),Times($s("d"),$s("x"))))),Times($s("b"),Sin(Plus($s("c"),Times($s("d"),$s("x")))))),Plus($s("n"),C2)),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),RationalQ($s("n"))),Less($s("n"),CN1)),NonzeroQ(Plus(Power($s("a"),C2),Power($s("b"),C2)))))),
SetDelayed(Int(Power(Plus(Times($p("a",true),Csc(Plus($p("c",true),Times($p("d",true),$p("x"))))),Times($p("b",true),Sin(Plus($p("c",true),Times($p("d",true),$p("x")))))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Int(Power(Times(Times($s("a"),Cos(Plus($s("c"),Times($s("d"),$s("x"))))),Cot(Plus($s("c"),Times($s("d"),$s("x"))))),$s("n")),$s("x")),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("n")),$s("x")),ZeroQ(Plus($s("a"),$s("b")))))),
SetDelayed(Int(Power(Plus(Times($p("a",true),Sec(Plus($p("c",true),Times($p("d",true),$p("x"))))),Times($p("b",true),Cos(Plus($p("c",true),Times($p("d",true),$p("x")))))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Int(Power(Times(Times($s("a"),Sin(Plus($s("c"),Times($s("d"),$s("x"))))),Tan(Plus($s("c"),Times($s("d"),$s("x"))))),$s("n")),$s("x")),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("n")),$s("x")),ZeroQ(Plus($s("a"),$s("b")))))),
SetDelayed(Int(Times($p("u",true),Times(Power(Sin(Plus($p("c",true),Times($p("d",true),$p("x")))),$p("n",true)),Power(Plus(Times($p("a",true),Cos(Plus($p("c",true),Times($p("d",true),$p("x"))))),Times($p("b",true),Sin(Plus($p("c",true),Times($p("d",true),$p("x")))))),CN1))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Dist(Times($s("b"),Power(Plus(Power($s("a"),C2),Power($s("b"),C2)),CN1)),Int(Times($s("u"),Power(Sin(Plus($s("c"),Times($s("d"),$s("x")))),Plus($s("n"),Times(CN1,C1)))),$s("x"))),Times(CN1,Dist(Times($s("a"),Power(Plus(Power($s("a"),C2),Power($s("b"),C2)),CN1)),Int(Times(Times($s("u"),Power(Sin(Plus($s("c"),Times($s("d"),$s("x")))),Plus($s("n"),Times(CN1,C2)))),Cos(Plus($s("c"),Times($s("d"),$s("x"))))),$s("x"))))),Dist(Times(Power($s("a"),C2),Power(Plus(Power($s("a"),C2),Power($s("b"),C2)),CN1)),Int(Times($s("u"),Times(Power(Sin(Plus($s("c"),Times($s("d"),$s("x")))),Plus($s("n"),Times(CN1,C2))),Power(Plus(Times($s("a"),Cos(Plus($s("c"),Times($s("d"),$s("x"))))),Times($s("b"),Sin(Plus($s("c"),Times($s("d"),$s("x")))))),CN1))),$s("x")))),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),NonzeroQ(Plus(Power($s("a"),C2),Power($s("b"),C2)))),IntegerQ($s("n"))),Greater($s("n"),C0)),Or(Greater($s("n"),C1),MatchQ($s("u"),Condition(Times($p("v",true),Power(Tan(Plus($s("c"),Times($s("d"),$s("x")))),$p("m",true))),And(IntegerQ($s("m")),Greater($s("m"),C0)))))))),
SetDelayed(Int(Times($p("u",true),Times(Power(Cos(Plus($p("c",true),Times($p("d",true),$p("x")))),$p("n",true)),Power(Plus(Times($p("a",true),Cos(Plus($p("c",true),Times($p("d",true),$p("x"))))),Times($p("b",true),Sin(Plus($p("c",true),Times($p("d",true),$p("x")))))),CN1))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Dist(Times($s("a"),Power(Plus(Power($s("a"),C2),Power($s("b"),C2)),CN1)),Int(Times($s("u"),Power(Cos(Plus($s("c"),Times($s("d"),$s("x")))),Plus($s("n"),Times(CN1,C1)))),$s("x"))),Times(CN1,Dist(Times($s("b"),Power(Plus(Power($s("a"),C2),Power($s("b"),C2)),CN1)),Int(Times(Times($s("u"),Power(Cos(Plus($s("c"),Times($s("d"),$s("x")))),Plus($s("n"),Times(CN1,C2)))),Sin(Plus($s("c"),Times($s("d"),$s("x"))))),$s("x"))))),Dist(Times(Power($s("b"),C2),Power(Plus(Power($s("a"),C2),Power($s("b"),C2)),CN1)),Int(Times($s("u"),Times(Power(Cos(Plus($s("c"),Times($s("d"),$s("x")))),Plus($s("n"),Times(CN1,C2))),Power(Plus(Times($s("a"),Cos(Plus($s("c"),Times($s("d"),$s("x"))))),Times($s("b"),Sin(Plus($s("c"),Times($s("d"),$s("x")))))),CN1))),$s("x")))),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),NonzeroQ(Plus(Power($s("a"),C2),Power($s("b"),C2)))),IntegerQ($s("n"))),Greater($s("n"),C0)),Or(Greater($s("n"),C1),MatchQ($s("u"),Condition(Times($p("v",true),Power(Cot(Plus($s("c"),Times($s("d"),$s("x")))),$p("m",true))),And(IntegerQ($s("m")),Greater($s("m"),C0)))))))),
SetDelayed(Int(Times(C1,Power(Plus(Plus($p("a"),Times($p("b",true),Cos(Plus($p("d",true),Times($p("e",true),$p("x")))))),Times($p("c",true),Sin(Plus($p("d",true),Times($p("e",true),$p("x")))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(integer(-2L),Power(Times($s("e"),Plus($s("c"),Times(Plus($s("a"),Times(CN1,$s("b"))),Tan(Times(Plus($s("d"),Times($s("e"),$s("x"))),C1D2))))),CN1)),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e")),$s("x")),ZeroQ(Plus(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))),Times(CN1,Power($s("c"),C2))))))),
SetDelayed(Int(Sqrt(Plus(Plus($p("a"),Times($p("b",true),Cos(Plus($p("d",true),Times($p("e",true),$p("x")))))),Times($p("c",true),Sin(Plus($p("d",true),Times($p("e",true),$p("x"))))))),$p("x",$s("Symbol"))),
    Condition(Times(integer(-2L),Times(Plus(Times($s("c"),Cos(Plus($s("d"),Times($s("e"),$s("x"))))),Times(CN1,Times($s("b"),Sin(Plus($s("d"),Times($s("e"),$s("x"))))))),Power(Times($s("e"),Sqrt(Plus(Plus($s("a"),Times($s("b"),Cos(Plus($s("d"),Times($s("e"),$s("x")))))),Times($s("c"),Sin(Plus($s("d"),Times($s("e"),$s("x")))))))),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e")),$s("x")),ZeroQ(Plus(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))),Times(CN1,Power($s("c"),C2))))))),
SetDelayed(Int(Power(Plus(Plus($p("a"),Times($p("b",true),Cos(Plus($p("d",true),Times($p("e",true),$p("x")))))),Times($p("c",true),Sin(Plus($p("d",true),Times($p("e",true),$p("x")))))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Plus(Times(Times(CN1,$s("c")),Cos(Plus($s("d"),Times($s("e"),$s("x"))))),Times($s("b"),Sin(Plus($s("d"),Times($s("e"),$s("x")))))),Times(Power(Plus(Plus($s("a"),Times($s("b"),Cos(Plus($s("d"),Times($s("e"),$s("x")))))),Times($s("c"),Sin(Plus($s("d"),Times($s("e"),$s("x")))))),Plus($s("n"),Times(CN1,C1))),Power(Times($s("e"),$s("n")),CN1))),Dist(Times($s("a"),Times(Plus(Times(C2,$s("n")),Times(CN1,C1)),Power($s("n"),CN1))),Int(Power(Plus(Plus($s("a"),Times($s("b"),Cos(Plus($s("d"),Times($s("e"),$s("x")))))),Times($s("c"),Sin(Plus($s("d"),Times($s("e"),$s("x")))))),Plus($s("n"),Times(CN1,C1))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e")),$s("x")),RationalQ($s("n"))),Greater($s("n"),C1)),ZeroQ(Plus(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))),Times(CN1,Power($s("c"),C2))))))),
SetDelayed(Int(Power(Plus(Plus($p("a"),Times($p("b",true),Cos(Plus($p("d",true),Times($p("e",true),$p("x")))))),Times($p("c",true),Sin(Plus($p("d",true),Times($p("e",true),$p("x")))))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Plus(Times($s("c"),Cos(Plus($s("d"),Times($s("e"),$s("x"))))),Times(CN1,Times($s("b"),Sin(Plus($s("d"),Times($s("e"),$s("x"))))))),Times(Power(Plus(Plus($s("a"),Times($s("b"),Cos(Plus($s("d"),Times($s("e"),$s("x")))))),Times($s("c"),Sin(Plus($s("d"),Times($s("e"),$s("x")))))),$s("n")),Power(Times(Times($s("a"),$s("e")),Plus(Times(C2,$s("n")),C1)),CN1))),Dist(Times(Plus($s("n"),C1),Power(Times($s("a"),Plus(Times(C2,$s("n")),C1)),CN1)),Int(Power(Plus(Plus($s("a"),Times($s("b"),Cos(Plus($s("d"),Times($s("e"),$s("x")))))),Times($s("c"),Sin(Plus($s("d"),Times($s("e"),$s("x")))))),Plus($s("n"),C1)),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e")),$s("x")),RationalQ($s("n"))),Less($s("n"),CN1)),ZeroQ(Plus(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))),Times(CN1,Power($s("c"),C2))))))),
SetDelayed(Int(Times(C1,Power(Plus(Plus($p("a"),Times($p("b",true),Cos(Plus($p("d",true),Times($p("e",true),$p("x")))))),Times($p("c",true),Sin(Plus($p("d",true),Times($p("e",true),$p("x")))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Log(Plus($s("a"),Times($s("c"),Tan(Times(Plus($s("d"),Times($s("e"),$s("x"))),C1D2))))),Power(Times($s("c"),$s("e")),CN1)),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e")),$s("x")),ZeroQ(Plus($s("a"),Times(CN1,$s("b"))))))),
SetDelayed(Int(Times(C1,Power(Plus(Plus($p("a"),Times($p("b",true),Cos(Plus($p("d",true),Times($p("e",true),$p("x")))))),Times($p("c",true),Sin(Plus($p("d",true),Times($p("e",true),$p("x")))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Times(CN1,Log(Plus($s("a"),Times($s("c"),Cot(Times(Plus($s("d"),Times($s("e"),$s("x"))),C1D2)))))),Power(Times($s("c"),$s("e")),CN1)),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e")),$s("x")),ZeroQ(Plus($s("a"),$s("b")))))),
SetDelayed(Int(Times(C1,Power(Plus(Plus($p("a"),Times($p("b",true),Cos(Plus($p("d",true),Times($p("e",true),$p("x")))))),Times($p("c",true),Sin(Plus($p("d",true),Times($p("e",true),$p("x")))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(C2,Times(ArcTan(Times(Plus($s("c"),Times(Plus($s("a"),Times(CN1,$s("b"))),Tan(Times(Plus($s("d"),Times($s("e"),$s("x"))),C1D2)))),Power(Rt(Plus(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))),Times(CN1,Power($s("c"),C2))),C2),CN1))),Power(Times($s("e"),Rt(Plus(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))),Times(CN1,Power($s("c"),C2))),C2)),CN1))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e")),$s("x")),NonzeroQ(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))))),PosQ(Plus(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))),Times(CN1,Power($s("c"),C2))))))),
SetDelayed(Int(Times(C1,Power(Plus(Plus($p("a"),Times($p("b",true),Cos(Plus($p("d",true),Times($p("e",true),$p("x")))))),Times($p("c",true),Sin(Plus($p("d",true),Times($p("e",true),$p("x")))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(integer(-2L),Times(ArcTanh(Times(Plus($s("c"),Times(Plus($s("a"),Times(CN1,$s("b"))),Tan(Times(Plus($s("d"),Times($s("e"),$s("x"))),C1D2)))),Power(Rt(Plus(Plus(Times(CN1,Power($s("a"),C2)),Power($s("b"),C2)),Power($s("c"),C2)),C2),CN1))),Power(Times($s("e"),Rt(Plus(Plus(Times(CN1,Power($s("a"),C2)),Power($s("b"),C2)),Power($s("c"),C2)),C2)),CN1))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e")),$s("x")),NonzeroQ(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))))),NegQ(Plus(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))),Times(CN1,Power($s("c"),C2))))))),
SetDelayed(Int(Sqrt(Plus(Plus($p("a",true),Times($p("b",true),Cos(Plus($p("d",true),Times($p("e",true),$p("x")))))),Times($p("c",true),Sin(Plus($p("d",true),Times($p("e",true),$p("x"))))))),$p("x",$s("Symbol"))),
    Condition(Times(Times(C2,EllipticE(Times(Plus(Plus($s("d"),Times($s("e"),$s("x"))),Times(CN1,ArcTan($s("b"),$s("c")))),C1D2),Times(C2,Power(Plus(C1,Times($s("a"),Power(Sqrt(Plus(Power($s("b"),C2),Power($s("c"),C2))),CN1))),CN1)))),Times(Sqrt(Plus(Plus($s("a"),Times($s("b"),Cos(Plus($s("d"),Times($s("e"),$s("x")))))),Times($s("c"),Sin(Plus($s("d"),Times($s("e"),$s("x"))))))),Power(Times($s("e"),Sqrt(Times(Plus(Plus($s("a"),Times($s("b"),Cos(Plus($s("d"),Times($s("e"),$s("x")))))),Times($s("c"),Sin(Plus($s("d"),Times($s("e"),$s("x")))))),Power(Plus($s("a"),Sqrt(Plus(Power($s("b"),C2),Power($s("c"),C2)))),CN1)))),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e")),$s("x")),NonzeroQ(Plus(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))),Times(CN1,Power($s("c"),C2))))))),
SetDelayed(Int(Times(C1,Power(Sqrt(Plus(Plus($p("a",true),Times($p("b",true),Cos(Plus($p("d",true),Times($p("e",true),$p("x")))))),Times($p("c",true),Sin(Plus($p("d",true),Times($p("e",true),$p("x"))))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Times(C2,EllipticF(Times(Plus(Plus($s("d"),Times($s("e"),$s("x"))),Times(CN1,ArcTan($s("b"),$s("c")))),C1D2),Times(C2,Power(Plus(C1,Times($s("a"),Power(Sqrt(Plus(Power($s("b"),C2),Power($s("c"),C2))),CN1))),CN1)))),Times(Sqrt(Times(Plus(Plus($s("a"),Times($s("b"),Cos(Plus($s("d"),Times($s("e"),$s("x")))))),Times($s("c"),Sin(Plus($s("d"),Times($s("e"),$s("x")))))),Power(Plus($s("a"),Sqrt(Plus(Power($s("b"),C2),Power($s("c"),C2)))),CN1))),Power(Times($s("e"),Sqrt(Plus(Plus($s("a"),Times($s("b"),Cos(Plus($s("d"),Times($s("e"),$s("x")))))),Times($s("c"),Sin(Plus($s("d"),Times($s("e"),$s("x")))))))),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e")),$s("x")),NonzeroQ(Plus(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))),Times(CN1,Power($s("c"),C2))))))),
SetDelayed(Int(Power(Plus(Plus($p("a"),Times($p("b",true),Cos(Plus($p("d",true),Times($p("e",true),$p("x")))))),Times($p("c",true),Sin(Plus($p("d",true),Times($p("e",true),$p("x")))))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Plus(Times(Times(CN1,$s("c")),Cos(Plus($s("d"),Times($s("e"),$s("x"))))),Times($s("b"),Sin(Plus($s("d"),Times($s("e"),$s("x")))))),Times(Power(Plus(Plus($s("a"),Times($s("b"),Cos(Plus($s("d"),Times($s("e"),$s("x")))))),Times($s("c"),Sin(Plus($s("d"),Times($s("e"),$s("x")))))),Plus($s("n"),C1)),Power(Times(Times($s("e"),Plus($s("n"),C1)),Plus(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))),Times(CN1,Power($s("c"),C2)))),CN1))),Dist(Times(C1,Power(Times(Plus($s("n"),C1),Plus(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))),Times(CN1,Power($s("c"),C2)))),CN1)),Int(Times(Plus(Plus(Times(Plus($s("n"),C1),$s("a")),Times(CN1,Times(Times(Plus($s("n"),C2),$s("b")),Cos(Plus($s("d"),Times($s("e"),$s("x"))))))),Times(CN1,Times(Times(Plus($s("n"),C2),$s("c")),Sin(Plus($s("d"),Times($s("e"),$s("x"))))))),Power(Plus(Plus($s("a"),Times($s("b"),Cos(Plus($s("d"),Times($s("e"),$s("x")))))),Times($s("c"),Sin(Plus($s("d"),Times($s("e"),$s("x")))))),Plus($s("n"),C1))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e")),$s("x")),RationalQ($s("n"))),Less($s("n"),CN1)),NonzeroQ(Plus(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))),Times(CN1,Power($s("c"),C2))))))),
SetDelayed(Int(Times(Plus($p("A",true),Times($p("C",true),Sin(Plus($p("d",true),Times($p("e",true),$p("x")))))),Power(Plus(Plus($p("a",true),Times($p("b",true),Cos(Plus($p("d",true),Times($p("e",true),$p("x")))))),Times($p("c",true),Sin(Plus($p("d",true),Times($p("e",true),$p("x")))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(Times(CN1,$s("b")),$s("C")),Times(Log(Plus(Plus($s("a"),Times($s("b"),Cos(Plus($s("d"),Times($s("e"),$s("x")))))),Times($s("c"),Sin(Plus($s("d"),Times($s("e"),$s("x"))))))),Power(Times($s("e"),Plus(Power($s("b"),C2),Power($s("c"),C2))),CN1))),Times(Times($s("c"),$s("C")),Times(Plus($s("d"),Times($s("e"),$s("x"))),Power(Times($s("e"),Plus(Power($s("b"),C2),Power($s("c"),C2))),CN1)))),Dist(Plus($s("A"),Times(CN1,Times(Times($s("a"),$s("c")),Times($s("C"),Power(Plus(Power($s("b"),C2),Power($s("c"),C2)),CN1))))),Int(Times(C1,Power(Plus(Plus($s("a"),Times($s("b"),Cos(Plus($s("d"),Times($s("e"),$s("x")))))),Times($s("c"),Sin(Plus($s("d"),Times($s("e"),$s("x")))))),CN1)),$s("x")))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e"),$s("A"),$s("C")),$s("x")),NonzeroQ(Plus(Power($s("b"),C2),Power($s("c"),C2)))),NonzeroQ(Plus($s("A"),Times(CN1,Times(Times($s("a"),$s("c")),Times($s("C"),Power(Plus(Power($s("b"),C2),Power($s("c"),C2)),CN1))))))))),
SetDelayed(Int(Times(Plus($p("A",true),Times($p("B",true),Cos(Plus($p("d",true),Times($p("e",true),$p("x")))))),Power(Plus(Plus($p("a",true),Times($p("b",true),Cos(Plus($p("d",true),Times($p("e",true),$p("x")))))),Times($p("c",true),Sin(Plus($p("d",true),Times($p("e",true),$p("x")))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times($s("c"),$s("B")),Times(Log(Plus(Plus($s("a"),Times($s("b"),Cos(Plus($s("d"),Times($s("e"),$s("x")))))),Times($s("c"),Sin(Plus($s("d"),Times($s("e"),$s("x"))))))),Power(Times($s("e"),Plus(Power($s("b"),C2),Power($s("c"),C2))),CN1))),Times(Times($s("b"),$s("B")),Times(Plus($s("d"),Times($s("e"),$s("x"))),Power(Times($s("e"),Plus(Power($s("b"),C2),Power($s("c"),C2))),CN1)))),Dist(Plus($s("A"),Times(CN1,Times(Times($s("a"),$s("b")),Times($s("B"),Power(Plus(Power($s("b"),C2),Power($s("c"),C2)),CN1))))),Int(Times(C1,Power(Plus(Plus($s("a"),Times($s("b"),Cos(Plus($s("d"),Times($s("e"),$s("x")))))),Times($s("c"),Sin(Plus($s("d"),Times($s("e"),$s("x")))))),CN1)),$s("x")))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e"),$s("A"),$s("B")),$s("x")),NonzeroQ(Plus(Power($s("b"),C2),Power($s("c"),C2)))),NonzeroQ(Plus($s("A"),Times(CN1,Times(Times($s("a"),$s("b")),Times($s("B"),Power(Plus(Power($s("b"),C2),Power($s("c"),C2)),CN1))))))))),
SetDelayed(Int(Times(Plus(Plus($p("A",true),Times($p("B",true),Cos(Plus($p("d",true),Times($p("e",true),$p("x")))))),Times($p("C",true),Sin(Plus($p("d",true),Times($p("e",true),$p("x")))))),Power(Plus(Plus($p("a",true),Times($p("b",true),Cos(Plus($p("d",true),Times($p("e",true),$p("x")))))),Times($p("c",true),Sin(Plus($p("d",true),Times($p("e",true),$p("x")))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Plus(Times($s("c"),$s("B")),Times(CN1,Times($s("b"),$s("C")))),Times(Log(Plus(Plus($s("a"),Times($s("b"),Cos(Plus($s("d"),Times($s("e"),$s("x")))))),Times($s("c"),Sin(Plus($s("d"),Times($s("e"),$s("x"))))))),Power(Times($s("e"),Plus(Power($s("b"),C2),Power($s("c"),C2))),CN1))),Times(Plus(Times($s("b"),$s("B")),Times($s("c"),$s("C"))),Times(Plus($s("d"),Times($s("e"),$s("x"))),Power(Times($s("e"),Plus(Power($s("b"),C2),Power($s("c"),C2))),CN1)))),Dist(Plus($s("A"),Times(CN1,Times($s("a"),Times(Plus(Times($s("b"),$s("B")),Times($s("c"),$s("C"))),Power(Plus(Power($s("b"),C2),Power($s("c"),C2)),CN1))))),Int(Times(C1,Power(Plus(Plus($s("a"),Times($s("b"),Cos(Plus($s("d"),Times($s("e"),$s("x")))))),Times($s("c"),Sin(Plus($s("d"),Times($s("e"),$s("x")))))),CN1)),$s("x")))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e"),$s("A"),$s("B"),$s("C")),$s("x")),NonzeroQ(Plus(Power($s("b"),C2),Power($s("c"),C2)))),NonzeroQ(Plus($s("A"),Times(CN1,Times($s("a"),Times(Plus(Times($s("b"),$s("B")),Times($s("c"),$s("C"))),Power(Plus(Power($s("b"),C2),Power($s("c"),C2)),CN1))))))))),
SetDelayed(Int(Times(Plus($p("A",true),Times($p("C",true),Sin(Plus($p("d",true),Times($p("e",true),$p("x")))))),Power(Plus(Plus($p("a",true),Times($p("b",true),Cos(Plus($p("d",true),Times($p("e",true),$p("x")))))),Times($p("c",true),Sin(Plus($p("d",true),Times($p("e",true),$p("x")))))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Plus(Plus(Times($s("b"),$s("C")),Times(Plus(Times($s("a"),$s("C")),Times(CN1,Times($s("c"),$s("A")))),Cos(Plus($s("d"),Times($s("e"),$s("x")))))),Times(Times($s("b"),$s("A")),Sin(Plus($s("d"),Times($s("e"),$s("x")))))),Times(Power(Plus(Plus($s("a"),Times($s("b"),Cos(Plus($s("d"),Times($s("e"),$s("x")))))),Times($s("c"),Sin(Plus($s("d"),Times($s("e"),$s("x")))))),Plus($s("n"),C1)),Power(Times(Times($s("e"),Plus($s("n"),C1)),Plus(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))),Times(CN1,Power($s("c"),C2)))),CN1))),Dist(Times(C1,Power(Times(Plus($s("n"),C1),Plus(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))),Times(CN1,Power($s("c"),C2)))),CN1)),Int(Times(Plus(Plus(Times(Plus($s("n"),C1),Plus(Times($s("a"),$s("A")),Times(CN1,Times($s("c"),$s("C"))))),Times(CN1,Times(Times(Times(Plus($s("n"),C2),$s("b")),$s("A")),Cos(Plus($s("d"),Times($s("e"),$s("x"))))))),Times(Times(Plus($s("n"),C2),Plus(Times($s("a"),$s("C")),Times(CN1,Times($s("c"),$s("A"))))),Sin(Plus($s("d"),Times($s("e"),$s("x")))))),Power(Plus(Plus($s("a"),Times($s("b"),Cos(Plus($s("d"),Times($s("e"),$s("x")))))),Times($s("c"),Sin(Plus($s("d"),Times($s("e"),$s("x")))))),Plus($s("n"),C1))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e"),$s("A"),$s("C")),$s("x")),RationalQ($s("n"))),Less($s("n"),CN1)),NonzeroQ(Plus(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))),Times(CN1,Power($s("c"),C2))))))),
SetDelayed(Int(Times(Plus($p("A",true),Times($p("B",true),Cos(Plus($p("d",true),Times($p("e",true),$p("x")))))),Power(Plus(Plus($p("a",true),Times($p("b",true),Cos(Plus($p("d",true),Times($p("e",true),$p("x")))))),Times($p("c",true),Sin(Plus($p("d",true),Times($p("e",true),$p("x")))))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Plus(Plus(Times($s("c"),$s("B")),Times(Times($s("c"),$s("A")),Cos(Plus($s("d"),Times($s("e"),$s("x")))))),Times(Plus(Times($s("a"),$s("B")),Times(CN1,Times($s("b"),$s("A")))),Sin(Plus($s("d"),Times($s("e"),$s("x"))))))),Times(Power(Plus(Plus($s("a"),Times($s("b"),Cos(Plus($s("d"),Times($s("e"),$s("x")))))),Times($s("c"),Sin(Plus($s("d"),Times($s("e"),$s("x")))))),Plus($s("n"),C1)),Power(Times(Times($s("e"),Plus($s("n"),C1)),Plus(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))),Times(CN1,Power($s("c"),C2)))),CN1))),Dist(Times(C1,Power(Times(Plus($s("n"),C1),Plus(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))),Times(CN1,Power($s("c"),C2)))),CN1)),Int(Times(Plus(Plus(Times(Plus($s("n"),C1),Plus(Times($s("a"),$s("A")),Times(CN1,Times($s("b"),$s("B"))))),Times(Times(Plus($s("n"),C2),Plus(Times($s("a"),$s("B")),Times(CN1,Times($s("b"),$s("A"))))),Cos(Plus($s("d"),Times($s("e"),$s("x")))))),Times(CN1,Times(Times(Times(Plus($s("n"),C2),$s("c")),$s("A")),Sin(Plus($s("d"),Times($s("e"),$s("x"))))))),Power(Plus(Plus($s("a"),Times($s("b"),Cos(Plus($s("d"),Times($s("e"),$s("x")))))),Times($s("c"),Sin(Plus($s("d"),Times($s("e"),$s("x")))))),Plus($s("n"),C1))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e"),$s("A"),$s("B")),$s("x")),RationalQ($s("n"))),Less($s("n"),CN1)),NonzeroQ(Plus(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))),Times(CN1,Power($s("c"),C2))))))),
SetDelayed(Int(Times(Plus(Plus($p("A",true),Times($p("B",true),Cos(Plus($p("d",true),Times($p("e",true),$p("x")))))),Times($p("C",true),Sin(Plus($p("d",true),Times($p("e",true),$p("x")))))),Power(Plus(Plus($p("a",true),Times($p("b",true),Cos(Plus($p("d",true),Times($p("e",true),$p("x")))))),Times($p("c",true),Sin(Plus($p("d",true),Times($p("e",true),$p("x")))))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Plus(Plus(Plus(Times($s("c"),$s("B")),Times(CN1,Times($s("b"),$s("C")))),Times(CN1,Times(Plus(Times($s("a"),$s("C")),Times(CN1,Times($s("c"),$s("A")))),Cos(Plus($s("d"),Times($s("e"),$s("x"))))))),Times(Plus(Times($s("a"),$s("B")),Times(CN1,Times($s("b"),$s("A")))),Sin(Plus($s("d"),Times($s("e"),$s("x"))))))),Times(Power(Plus(Plus($s("a"),Times($s("b"),Cos(Plus($s("d"),Times($s("e"),$s("x")))))),Times($s("c"),Sin(Plus($s("d"),Times($s("e"),$s("x")))))),Plus($s("n"),C1)),Power(Times(Times($s("e"),Plus($s("n"),C1)),Plus(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))),Times(CN1,Power($s("c"),C2)))),CN1))),Dist(Times(C1,Power(Times(Plus($s("n"),C1),Plus(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))),Times(CN1,Power($s("c"),C2)))),CN1)),Int(Times(Plus(Plus(Times(Plus($s("n"),C1),Plus(Plus(Times($s("a"),$s("A")),Times(CN1,Times($s("b"),$s("B")))),Times(CN1,Times($s("c"),$s("C"))))),Times(Times(Plus($s("n"),C2),Plus(Times($s("a"),$s("B")),Times(CN1,Times($s("b"),$s("A"))))),Cos(Plus($s("d"),Times($s("e"),$s("x")))))),Times(Times(Plus($s("n"),C2),Plus(Times($s("a"),$s("C")),Times(CN1,Times($s("c"),$s("A"))))),Sin(Plus($s("d"),Times($s("e"),$s("x")))))),Power(Plus(Plus($s("a"),Times($s("b"),Cos(Plus($s("d"),Times($s("e"),$s("x")))))),Times($s("c"),Sin(Plus($s("d"),Times($s("e"),$s("x")))))),Plus($s("n"),C1))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e"),$s("A"),$s("B"),$s("C")),$s("x")),RationalQ($s("n"))),Less($s("n"),CN1)),NonzeroQ(Plus(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))),Times(CN1,Power($s("c"),C2))))))),
SetDelayed(Int(Times(Power(Sec($p("v")),$p("m",true)),Power(Plus($p("a"),Times($p("b",true),Tan($p("v")))),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Int(Power(Plus(Times($s("a"),Cos($s("v"))),Times($s("b"),Sin($s("v")))),$s("n")),$s("x")),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ(List($s("m"),$s("n")))),Equal(Plus($s("m"),$s("n")),C0)))),
SetDelayed(Int(Times(Power(Csc($p("v")),$p("m",true)),Power(Plus($p("a"),Times($p("b",true),Cot($p("v")))),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Int(Power(Plus(Times($s("b"),Cos($s("v"))),Times($s("a"),Sin($s("v")))),$s("n")),$s("x")),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ(List($s("m"),$s("n")))),Equal(Plus($s("m"),$s("n")),C0)))),
SetDelayed(Int(Times(Power(E,Plus($p("a",true),Times($p("b",true),$p("x")))),Sin(Plus($p("c",true),Times($p("d",true),$p("x"))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(Times(CN1,$s("d")),Power(E,Plus($s("a"),Times($s("b"),$s("x"))))),Times(Cos(Plus($s("c"),Times($s("d"),$s("x")))),Power(Plus(Power($s("b"),C2),Power($s("d"),C2)),CN1))),Times(Times($s("b"),Power(E,Plus($s("a"),Times($s("b"),$s("x"))))),Times(Sin(Plus($s("c"),Times($s("d"),$s("x")))),Power(Plus(Power($s("b"),C2),Power($s("d"),C2)),CN1)))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),NonzeroQ(Plus(Power($s("b"),C2),Power($s("d"),C2)))))),
SetDelayed(Int(Times(Power(E,Plus($p("a",true),Times($p("b",true),$p("x")))),Power(Sin(Plus($p("c",true),Times($p("d",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times($s("b"),Power(E,Plus($s("a"),Times($s("b"),$s("x"))))),Times(Power(Sin(Plus($s("c"),Times($s("d"),$s("x")))),$s("n")),Power(Plus(Power($s("b"),C2),Times(Power($s("d"),C2),Power($s("n"),C2))),CN1))),Times(CN1,Times(Times(Times(Times($s("d"),$s("n")),Power(E,Plus($s("a"),Times($s("b"),$s("x"))))),Cos(Plus($s("c"),Times($s("d"),$s("x"))))),Times(Power(Sin(Plus($s("c"),Times($s("d"),$s("x")))),Plus($s("n"),Times(CN1,C1))),Power(Plus(Power($s("b"),C2),Times(Power($s("d"),C2),Power($s("n"),C2))),CN1))))),Dist(Times(Times($s("n"),Plus($s("n"),Times(CN1,C1))),Times(Power($s("d"),C2),Power(Plus(Power($s("b"),C2),Times(Power($s("d"),C2),Power($s("n"),C2))),CN1))),Int(Times(Power(E,Plus($s("a"),Times($s("b"),$s("x")))),Power(Sin(Plus($s("c"),Times($s("d"),$s("x")))),Plus($s("n"),Times(CN1,C2)))),$s("x")))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),RationalQ($s("n"))),Greater($s("n"),C1)))),
SetDelayed(Int(Times(Power(E,Plus($p("a",true),Times($p("b",true),$p("x")))),Cos(Plus($p("c",true),Times($p("d",true),$p("x"))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times($s("b"),Power(E,Plus($s("a"),Times($s("b"),$s("x"))))),Times(Cos(Plus($s("c"),Times($s("d"),$s("x")))),Power(Plus(Power($s("b"),C2),Power($s("d"),C2)),CN1))),Times(Times($s("d"),Power(E,Plus($s("a"),Times($s("b"),$s("x"))))),Times(Sin(Plus($s("c"),Times($s("d"),$s("x")))),Power(Plus(Power($s("b"),C2),Power($s("d"),C2)),CN1)))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),NonzeroQ(Plus(Power($s("b"),C2),Power($s("d"),C2)))))),
SetDelayed(Int(Times(Power(E,Plus($p("a",true),Times($p("b",true),$p("x")))),Power(Cos(Plus($p("c",true),Times($p("d",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times($s("b"),Power(E,Plus($s("a"),Times($s("b"),$s("x"))))),Times(Power(Cos(Plus($s("c"),Times($s("d"),$s("x")))),$s("n")),Power(Plus(Power($s("b"),C2),Times(Power($s("d"),C2),Power($s("n"),C2))),CN1))),Times(Times(Times(Times($s("d"),$s("n")),Power(E,Plus($s("a"),Times($s("b"),$s("x"))))),Power(Cos(Plus($s("c"),Times($s("d"),$s("x")))),Plus($s("n"),Times(CN1,C1)))),Times(Sin(Plus($s("c"),Times($s("d"),$s("x")))),Power(Plus(Power($s("b"),C2),Times(Power($s("d"),C2),Power($s("n"),C2))),CN1)))),Dist(Times(Times($s("n"),Plus($s("n"),Times(CN1,C1))),Times(Power($s("d"),C2),Power(Plus(Power($s("b"),C2),Times(Power($s("d"),C2),Power($s("n"),C2))),CN1))),Int(Times(Power(E,Plus($s("a"),Times($s("b"),$s("x")))),Power(Cos(Plus($s("c"),Times($s("d"),$s("x")))),Plus($s("n"),Times(CN1,C2)))),$s("x")))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),RationalQ($s("n"))),Greater($s("n"),C1)))),
SetDelayed(Int(Times(Power(E,Plus($p("a",true),Times($p("b",true),$p("x")))),Power(Sec(Plus($p("c",true),Times($p("d",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(Times(CN1,$s("b")),Power(E,Plus($s("a"),Times($s("b"),$s("x"))))),Times(Power(Sec(Plus($s("c"),Times($s("d"),$s("x")))),Plus($s("n"),Times(CN1,C2))),Power(Times(Times(Power($s("d"),C2),Plus($s("n"),Times(CN1,C1))),Plus($s("n"),Times(CN1,C2))),CN1))),Times(Times(Power(E,Plus($s("a"),Times($s("b"),$s("x")))),Power(Sec(Plus($s("c"),Times($s("d"),$s("x")))),Plus($s("n"),Times(CN1,C1)))),Times(Sin(Plus($s("c"),Times($s("d"),$s("x")))),Power(Times($s("d"),Plus($s("n"),Times(CN1,C1))),CN1)))),Dist(Times(Plus(Power($s("b"),C2),Times(Power($s("d"),C2),Power(Plus($s("n"),Times(CN1,C2)),C2))),Power(Times(Times(Power($s("d"),C2),Plus($s("n"),Times(CN1,C1))),Plus($s("n"),Times(CN1,C2))),CN1)),Int(Times(Power(E,Plus($s("a"),Times($s("b"),$s("x")))),Power(Sec(Plus($s("c"),Times($s("d"),$s("x")))),Plus($s("n"),Times(CN1,C2)))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),RationalQ($s("n"))),Greater($s("n"),C1)),Unequal($s("n"),C2)))),
SetDelayed(Int(Times(Power(E,Plus($p("a",true),Times($p("b",true),$p("x")))),Power(Csc(Plus($p("c",true),Times($p("d",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(Times(CN1,$s("b")),Power(E,Plus($s("a"),Times($s("b"),$s("x"))))),Times(Power(Csc(Plus($s("c"),Times($s("d"),$s("x")))),Plus($s("n"),Times(CN1,C2))),Power(Times(Times(Power($s("d"),C2),Plus($s("n"),Times(CN1,C1))),Plus($s("n"),Times(CN1,C2))),CN1))),Times(CN1,Times(Times(Power(E,Plus($s("a"),Times($s("b"),$s("x")))),Cos(Plus($s("c"),Times($s("d"),$s("x"))))),Times(Power(Csc(Plus($s("c"),Times($s("d"),$s("x")))),Plus($s("n"),Times(CN1,C1))),Power(Times($s("d"),Plus($s("n"),Times(CN1,C1))),CN1))))),Dist(Times(Plus(Power($s("b"),C2),Times(Power($s("d"),C2),Power(Plus($s("n"),Times(CN1,C2)),C2))),Power(Times(Times(Power($s("d"),C2),Plus($s("n"),Times(CN1,C1))),Plus($s("n"),Times(CN1,C2))),CN1)),Int(Times(Power(E,Plus($s("a"),Times($s("b"),$s("x")))),Power(Csc(Plus($s("c"),Times($s("d"),$s("x")))),Plus($s("n"),Times(CN1,C2)))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),RationalQ($s("n"))),Greater($s("n"),C1)),Unequal($s("n"),C2)))),
SetDelayed(Int(Times(Times(Power($p("x"),$p("m",true)),Power(E,Plus($p("a",true),Times($p("b",true),$p("x"))))),Power(Sin(Plus($p("c",true),Times($p("d",true),$p("x")))),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Module(List(Set($s("u"),Block(List(Set($s("ShowSteps"),False),Set($s("StepCounter"),$s("Null"))),Int(Times(Power(E,Plus($s("a"),Times($s("b"),$s("x")))),Power(Sin(Plus($s("c"),Times($s("d"),$s("x")))),$s("n"))),$s("x"))))),Plus(Times(Power($s("x"),$s("m")),$s("u")),Times(CN1,Dist($s("m"),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,C1))),$s("u")),$s("x")))))),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),RationalQ($s("m"))),IntegerQ($s("n"))),Greater($s("m"),C0)),Greater($s("n"),C0)))),
SetDelayed(Int(Times(Times(Power($p("x"),$p("m",true)),Power(E,Plus($p("a",true),Times($p("b",true),$p("x"))))),Power(Cos(Plus($p("c",true),Times($p("d",true),$p("x")))),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Module(List(Set($s("u"),Block(List(Set($s("ShowSteps"),False),Set($s("StepCounter"),$s("Null"))),Int(Times(Power(E,Plus($s("a"),Times($s("b"),$s("x")))),Power(Cos(Plus($s("c"),Times($s("d"),$s("x")))),$s("n"))),$s("x"))))),Plus(Times(Power($s("x"),$s("m")),$s("u")),Times(CN1,Dist($s("m"),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,C1))),$s("u")),$s("x")))))),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),RationalQ($s("m"))),IntegerQ($s("n"))),Greater($s("m"),C0)),Greater($s("n"),C0)))),
SetDelayed(Int(Times(Power($p("f"),$p("v")),Sin($p("w"))),$p("x",$s("Symbol"))),
    Condition(Plus(Dist(Times(CI,C1D2),Int(Times(Power($s("f"),$s("v")),Power(Power(E,Times(CI,$s("w"))),CN1)),$s("x"))),Times(CN1,Dist(Times(CI,C1D2),Int(Times(Power($s("f"),$s("v")),Power(E,Times(CI,$s("w")))),$s("x"))))),And(And(And(And(FreeQ($s("f"),$s("x")),PolynomialQ($s("v"),$s("x"))),LessEqual(Exponent($s("v"),$s("x")),C2)),PolynomialQ($s("w"),$s("x"))),LessEqual(Exponent($s("w"),$s("x")),C2)))),
SetDelayed(Int(Times(Power($p("f"),$p("v")),Power(Sin($p("w")),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Dist(Power(Times(CI,C1D2),$s("n")),Int(Times(Power($s("f"),$s("v")),Power(Plus(Times(C1,Power(Power(E,Times(CI,$s("w"))),CN1)),Times(CN1,Power(E,Times(CI,$s("w"))))),$s("n"))),$s("x"))),And(And(And(And(And(And(FreeQ($s("f"),$s("x")),IntegerQ($s("n"))),Greater($s("n"),C0)),PolynomialQ($s("v"),$s("x"))),LessEqual(Exponent($s("v"),$s("x")),C2)),PolynomialQ($s("w"),$s("x"))),LessEqual(Exponent($s("w"),$s("x")),C2)))),
SetDelayed(Int(Times(Power($p("f"),$p("v")),Cos($p("w"))),$p("x",$s("Symbol"))),
    Condition(Plus(Dist(C1D2,Int(Times(Power($s("f"),$s("v")),Power(E,Times(CI,$s("w")))),$s("x"))),Dist(C1D2,Int(Times(Power($s("f"),$s("v")),Power(Power(E,Times(CI,$s("w"))),CN1)),$s("x")))),And(And(And(And(FreeQ($s("f"),$s("x")),PolynomialQ($s("v"),$s("x"))),LessEqual(Exponent($s("v"),$s("x")),C2)),PolynomialQ($s("w"),$s("x"))),LessEqual(Exponent($s("w"),$s("x")),C2)))),
SetDelayed(Int(Times(Power($p("f"),$p("v")),Power(Cos($p("w")),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Dist(Times(C1,Power(Power(C2,$s("n")),CN1)),Int(Times(Power($s("f"),$s("v")),Power(Plus(Power(E,Times(CI,$s("w"))),Times(C1,Power(Power(E,Times(CI,$s("w"))),CN1))),$s("n"))),$s("x"))),And(And(And(And(And(And(FreeQ($s("f"),$s("x")),IntegerQ($s("n"))),Greater($s("n"),C0)),PolynomialQ($s("v"),$s("x"))),LessEqual(Exponent($s("v"),$s("x")),C2)),PolynomialQ($s("w"),$s("x"))),LessEqual(Exponent($s("w"),$s("x")),C2)))),
SetDelayed(Int(Times($p("u",true),Power(Plus($p("a"),Times($p("b",true),Power(Sin($p("v")),C2))),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Dist(Power($s("a"),$s("n")),Int(Times($s("u"),Power(Cos($s("v")),Times(C2,$s("n")))),$s("x"))),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ($s("n"))),ZeroQ(Plus($s("a"),$s("b"))))))
  );
}
