package org.matheclipse.core.integrate.rubi;


import static org.matheclipse.core.expression.F.*;
import static org.matheclipse.core.integrate.rubi.UtilityFunctionCtors.*;
import static org.matheclipse.core.integrate.rubi.UtilityFunctions.*;
import org.matheclipse.core.interfaces.IAST;
import org.matheclipse.core.interfaces.IExpr;

/** 
 * IndefiniteIntegrationRules from the <a href="http://www.apmaths.uwo.ca/~arich/">Rubi -
 * rule-based integrator</a>.
 *  
 */
public class IndefiniteIntegrationRules7 { 
  public static IAST RULES = List( 
SetDelayed(Int(Times($p("u",true),Power(Plus($p("a"),Times($p("b",true),Power(Cos($p("v")),C2))),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Dist(Power($s("a"),$s("n")),Int(Times($s("u"),Power(Sin($s("v")),Times(C2,$s("n")))),$s("x"))),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ($s("n"))),ZeroQ(Plus($s("a"),$s("b")))))),
SetDelayed(Int(Times($p("u",true),Power(Plus($p("a"),Times($p("b",true),Power(Tan($p("v")),C2))),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Dist(Power($s("a"),$s("n")),Int(Times($s("u"),Power(Sec($s("v")),Times(C2,$s("n")))),$s("x"))),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ($s("n"))),ZeroQ(Plus($s("a"),Times(CN1,$s("b"))))))),
SetDelayed(Int(Times($p("u",true),Power(Plus($p("a"),Times($p("b",true),Power(Cot($p("v")),C2))),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Dist(Power($s("a"),$s("n")),Int(Times($s("u"),Power(Csc($s("v")),Times(C2,$s("n")))),$s("x"))),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ($s("n"))),ZeroQ(Plus($s("a"),Times(CN1,$s("b"))))))),
SetDelayed(Int(Times($p("u",true),Power(Plus($p("a"),Times($p("b",true),Power(Sec($p("v")),C2))),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Dist(Power($s("b"),$s("n")),Int(Times($s("u"),Power(Tan($s("v")),Times(C2,$s("n")))),$s("x"))),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ($s("n"))),ZeroQ(Plus($s("a"),$s("b")))))),
SetDelayed(Int(Times($p("u",true),Power(Plus($p("a"),Times($p("b",true),Power(Csc($p("v")),C2))),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Dist(Power($s("b"),$s("n")),Int(Times($s("u"),Power(Cot($s("v")),Times(C2,$s("n")))),$s("x"))),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ($s("n"))),ZeroQ(Plus($s("a"),$s("b")))))),
SetDelayed(Int(Power(Plus(Times($p("a",true),Tan($p("v"))),Times($p("b",true),Sec($p("v")))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Dist(Power($s("a"),$s("n")),Int(Power(Tan(Plus(Times($s("v"),C1D2),Times(Times($s("a"),Power($s("b"),CN1)),Times(Pi,C1D4)))),$s("n")),$s("x"))),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),ZeroQ(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))))),EvenQ($s("n"))))),
SetDelayed(Int(Times($p("u",true),Power(Plus(Times($p("a",true),Power(Sec($p("v")),$p("m",true))),Times($p("b",true),Power(Tan($p("v")),$p("m",true)))),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Int(Times($s("u"),Times(Power(Plus($s("a"),Times($s("b"),Power(Sin($s("v")),$s("m")))),$s("n")),Power(Power(Cos($s("v")),Times($s("m"),$s("n"))),CN1))),$s("x")),And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ(List($s("m"),$s("n")))),Or(OddQ(Times($s("m"),$s("n"))),Less(Times($s("m"),$s("n")),C0))),Not(And(Equal($s("m"),C2),ZeroQ(Plus($s("a"),$s("b")))))))),
SetDelayed(Int(Power(Plus(Times($p("a",true),Cot($p("v"))),Times($p("b",true),Csc($p("v")))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Dist(Power($s("a"),$s("n")),Int(Power(Cot(Plus(Times($s("v"),C1D2),Times(Plus(Times($s("a"),Power($s("b"),CN1)),Times(CN1,C1)),Times(Pi,C1D4)))),$s("n")),$s("x"))),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),ZeroQ(Plus(Power($s("a"),C2),Times(CN1,Power($s("b"),C2))))),EvenQ($s("n"))))),
SetDelayed(Int(Times($p("u",true),Power(Plus(Times($p("a",true),Power(Csc($p("v")),$p("m",true))),Times($p("b",true),Power(Cot($p("v")),$p("m",true)))),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Int(Times($s("u"),Times(Power(Plus($s("a"),Times($s("b"),Power(Cos($s("v")),$s("m")))),$s("n")),Power(Power(Sin($s("v")),Times($s("m"),$s("n"))),CN1))),$s("x")),And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ(List($s("m"),$s("n")))),Or(OddQ(Times($s("m"),$s("n"))),Less(Times($s("m"),$s("n")),C0))),Not(And(Equal($s("m"),C2),ZeroQ(Plus($s("a"),$s("b")))))))),
SetDelayed(Int(Times(Times(Power($p("x"),$p("m",true)),Power(Sec($p("v")),$p("n",true))),Power(Csc($p("v")),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Dist(Power(C2,$s("n")),Int(Times(Power($s("x"),$s("m")),Power(Csc(Dist(C2,$s("v"))),$s("n"))),$s("x"))),And(IntegerQ(List($s("m"),$s("n"))),Greater($s("m"),C0)))),
SetDelayed(Int(Times($p("u"),Cos(Times($p("c",true),Plus($p("a",true),Times($p("b",true),$p("x")))))),$p("x",$s("Symbol"))),
    Condition(Dist(Times(C1,Power(Times($s("b"),$s("c")),CN1)),Subst(Int(Regularize(SubstFor(Sin(Times($s("c"),Plus($s("a"),Times($s("b"),$s("x"))))),$s("u"),$s("x")),$s("x")),$s("x")),$s("x"),Sin(Times($s("c"),Plus($s("a"),Times($s("b"),$s("x"))))))),And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),FunctionOfQ(Sin(Times($s("c"),Plus($s("a"),Times($s("b"),$s("x"))))),$s("u"),$s("x"),True)))),
SetDelayed(Int(Times($p("u"),Cot(Times($p("c",true),Plus($p("a",true),Times($p("b",true),$p("x")))))),$p("x",$s("Symbol"))),
    Condition(Dist(Times(C1,Power(Times($s("b"),$s("c")),CN1)),Subst(Int(Regularize(Times(SubstFor(Sin(Times($s("c"),Plus($s("a"),Times($s("b"),$s("x"))))),$s("u"),$s("x")),Power($s("x"),CN1)),$s("x")),$s("x")),$s("x"),Sin(Times($s("c"),Plus($s("a"),Times($s("b"),$s("x"))))))),And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),FunctionOfQ(Sin(Times($s("c"),Plus($s("a"),Times($s("b"),$s("x"))))),$s("u"),$s("x"),True)))),
SetDelayed(Int(Times($p("u"),Sin(Times($p("c",true),Plus($p("a",true),Times($p("b",true),$p("x")))))),$p("x",$s("Symbol"))),
    Condition(Dist(Times(C4,Power(Times($s("b"),$s("c")),CN1)),Subst(Int(Regularize(Times($s("x"),SubstFor(Sin(Times($s("c"),Times(Plus($s("a"),Times($s("b"),$s("x"))),C1D2))),$s("u"),$s("x"))),$s("x")),$s("x")),$s("x"),Sin(Times($s("c"),Times(Plus($s("a"),Times($s("b"),$s("x"))),C1D2))))),And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),FunctionOfQ(Sin(Times($s("c"),Times(Plus($s("a"),Times($s("b"),$s("x"))),C1D2))),$s("u"),$s("x"),True)))),
SetDelayed(Int(Times($p("u"),Sin(Times($p("c",true),Plus($p("a",true),Times($p("b",true),$p("x")))))),$p("x",$s("Symbol"))),
    Condition(Times(CN1,Dist(Times(C1,Power(Times($s("b"),$s("c")),CN1)),Subst(Int(Regularize(SubstFor(Cos(Times($s("c"),Plus($s("a"),Times($s("b"),$s("x"))))),$s("u"),$s("x")),$s("x")),$s("x")),$s("x"),Cos(Times($s("c"),Plus($s("a"),Times($s("b"),$s("x")))))))),And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),FunctionOfQ(Cos(Times($s("c"),Plus($s("a"),Times($s("b"),$s("x"))))),$s("u"),$s("x"),True)))),
SetDelayed(Int(Times($p("u"),Tan(Times($p("c",true),Plus($p("a",true),Times($p("b",true),$p("x")))))),$p("x",$s("Symbol"))),
    Condition(Times(CN1,Dist(Times(C1,Power(Times($s("b"),$s("c")),CN1)),Subst(Int(Regularize(Times(SubstFor(Cos(Times($s("c"),Plus($s("a"),Times($s("b"),$s("x"))))),$s("u"),$s("x")),Power($s("x"),CN1)),$s("x")),$s("x")),$s("x"),Cos(Times($s("c"),Plus($s("a"),Times($s("b"),$s("x")))))))),And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),FunctionOfQ(Cos(Times($s("c"),Plus($s("a"),Times($s("b"),$s("x"))))),$s("u"),$s("x"),True)))),
SetDelayed(Int(Times($p("u"),Sin(Times($p("c",true),Plus($p("a",true),Times($p("b",true),$p("x")))))),$p("x",$s("Symbol"))),
    Condition(Times(CN1,Dist(Times(C4,Power(Times($s("b"),$s("c")),CN1)),Subst(Int(Regularize(Times($s("x"),SubstFor(Cos(Times($s("c"),Times(Plus($s("a"),Times($s("b"),$s("x"))),C1D2))),$s("u"),$s("x"))),$s("x")),$s("x")),$s("x"),Cos(Times($s("c"),Times(Plus($s("a"),Times($s("b"),$s("x"))),C1D2)))))),And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),FunctionOfQ(Cos(Times($s("c"),Times(Plus($s("a"),Times($s("b"),$s("x"))),C1D2))),$s("u"),$s("x"),True)))),
SetDelayed(Int(Times($p("u"),Power(Tan(Times($p("c",true),Plus($p("a",true),Times($p("b",true),$p("x"))))),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Times(CN1,Dist(Times(C1,Power(Times($s("b"),$s("c")),CN1)),Subst(Int(Regularize(Times(SubstFor(Cot(Times($s("c"),Plus($s("a"),Times($s("b"),$s("x"))))),$s("u"),$s("x")),Power(Times(Power($s("x"),$s("n")),Plus(C1,Power($s("x"),C2))),CN1)),$s("x")),$s("x")),$s("x"),Cot(Times($s("c"),Plus($s("a"),Times($s("b"),$s("x")))))))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),IntegerQ($s("n"))),FunctionOfQ(Cot(Times($s("c"),Plus($s("a"),Times($s("b"),$s("x"))))),$s("u"),$s("x"),True)),TryPureTanSubst(Times($s("u"),Power(Tan(Times($s("c"),Plus($s("a"),Times($s("b"),$s("x"))))),$s("n"))),$s("x"))))),
SetDelayed(Int($p("u"),$p("x",$s("Symbol"))),
    Module(List(Set($s("v"),FunctionOfTrig($s("u"),$s("x")))),Condition(Dist(Times(CN1,Power(Coefficient($s("v"),$s("x"),C1),CN1)),Subst(Int(Regularize(Times(SubstFor(Cot($s("v")),$s("u"),$s("x")),Power(Plus(C1,Power($s("x"),C2)),CN1)),$s("x")),$s("x")),$s("x"),Cot($s("v")))),And(And(NotFalseQ($s("v")),FunctionOfQ(Cot($s("v")),$s("u"),$s("x"),True)),TryPureTanSubst($s("u"),$s("x")))))),
SetDelayed(Int(Times($p("u"),Power(Cot(Times($p("c",true),Plus($p("a",true),Times($p("b",true),$p("x"))))),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Dist(Times(C1,Power(Times($s("b"),$s("c")),CN1)),Subst(Int(Regularize(Times(SubstFor(Tan(Times($s("c"),Plus($s("a"),Times($s("b"),$s("x"))))),$s("u"),$s("x")),Power(Times(Power($s("x"),$s("n")),Plus(C1,Power($s("x"),C2))),CN1)),$s("x")),$s("x")),$s("x"),Tan(Times($s("c"),Plus($s("a"),Times($s("b"),$s("x"))))))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),IntegerQ($s("n"))),FunctionOfQ(Tan(Times($s("c"),Plus($s("a"),Times($s("b"),$s("x"))))),$s("u"),$s("x"),True)),TryPureTanSubst(Times($s("u"),Power(Cot(Times($s("c"),Plus($s("a"),Times($s("b"),$s("x"))))),$s("n"))),$s("x"))))),
SetDelayed(Int($p("u"),$p("x",$s("Symbol"))),
    Module(List(Set($s("v"),FunctionOfTrig($s("u"),$s("x")))),Condition(Dist(Times(C1,Power(Coefficient($s("v"),$s("x"),C1),CN1)),Subst(Int(Regularize(Times(SubstFor(Tan($s("v")),$s("u"),$s("x")),Power(Plus(C1,Power($s("x"),C2)),CN1)),$s("x")),$s("x")),$s("x"),Tan($s("v")))),And(And(NotFalseQ($s("v")),FunctionOfQ(Tan($s("v")),$s("u"),$s("x"),True)),TryPureTanSubst($s("u"),$s("x")))))),
SetDelayed(TryPureTanSubst($p("u"),$p("x",$s("Symbol"))),
    And(And(And(And(Not(MatchQ($s("u"),Condition(ArcTan(Times($p("a",true),Tan($p("v")))),FreeQ($s("a"),$s("x"))))),Not(MatchQ($s("u"),Condition(ArcTan(Times($p("a",true),Cot($p("v")))),FreeQ($s("a"),$s("x")))))),Not(MatchQ($s("u"),Condition(ArcCot(Times($p("a",true),Tan($p("v")))),FreeQ($s("a"),$s("x")))))),Not(MatchQ($s("u"),Condition(ArcCot(Times($p("a",true),Cot($p("v")))),FreeQ($s("a"),$s("x")))))),SameQ($s("u"),ExpnExpand($s("u"),$s("x"))))),
SetDelayed(Int(Sinh(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("x",$s("Symbol"))),
    Condition(Times(Cosh(Plus($s("a"),Times($s("b"),$s("x")))),Power($s("b"),CN1)),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(Power(Sinh(Plus($p("a",true),Times($p("b",true),$p("x")))),C2),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,$s("x")),C1D2),Times(Cosh(Plus($s("a"),Times($s("b"),$s("x")))),Times(Sinh(Plus($s("a"),Times($s("b"),$s("x")))),Power(Times(C2,$s("b")),CN1)))),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(Power(Sinh(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Dist(Times(C1,Power($s("b"),CN1)),Subst(Int(Regularize(Power(Plus(CN1,Power($s("x"),C2)),Times(Plus($s("n"),Times(CN1,C1)),C1D2)),$s("x")),$s("x")),$s("x"),Cosh(Plus($s("a"),Times($s("b"),$s("x")))))),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),OddQ($s("n"))),Greater($s("n"),C1)))),
SetDelayed(Int(Times(C1,Power(Plus($p("a"),Times($p("b",true),Sinh(Plus($p("c",true),Times($p("d",true),$p("x")))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Times(CN1,Cosh(Plus($s("c"),Times($s("d"),$s("x"))))),Power(Times($s("d"),Plus($s("b"),Times(CN1,Times($s("a"),Sinh(Plus($s("c"),Times($s("d"),$s("x")))))))),CN1)),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),ZeroQ(Plus(Power($s("a"),C2),Power($s("b"),C2)))))),
SetDelayed(Int(Times(C1,Power(Plus($p("a"),Times($p("b",true),Sinh(Plus($p("c",true),Times($p("d",true),$p("x")))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(integer(-2L),Times(ArcTanh(Times(Plus($s("b"),Times(CN1,Times($s("a"),Tanh(Times(Plus($s("c"),Times($s("d"),$s("x"))),C1D2))))),Power(Rt(Plus(Power($s("a"),C2),Power($s("b"),C2)),C2),CN1))),Power(Times($s("d"),Rt(Plus(Power($s("a"),C2),Power($s("b"),C2)),C2)),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),PosQ(Plus(Power($s("a"),C2),Power($s("b"),C2)))))),
SetDelayed(Int(Times(C1,Power(Plus($p("a"),Times($p("b",true),Sinh(Plus($p("c",true),Times($p("d",true),$p("x")))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(C2,Times(ArcTan(Times(Plus($s("b"),Times(CN1,Times($s("a"),Tanh(Times(Plus($s("c"),Times($s("d"),$s("x"))),C1D2))))),Power(Rt(Plus(Times(CN1,Power($s("a"),C2)),Times(CN1,Power($s("b"),C2))),C2),CN1))),Power(Times($s("d"),Rt(Plus(Times(CN1,Power($s("a"),C2)),Times(CN1,Power($s("b"),C2))),C2)),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),NegQ(Plus(Power($s("a"),C2),Power($s("b"),C2)))))),
SetDelayed(Int(Sqrt(Plus($p("a"),Times($p("b",true),Sinh(Plus($p("c",true),Times($p("d",true),$p("x"))))))),$p("x",$s("Symbol"))),
    Condition(Times(Times(C2,$s("b")),Times(Cosh(Plus($s("c"),Times($s("d"),$s("x")))),Power(Times($s("d"),Sqrt(Plus($s("a"),Times($s("b"),Sinh(Plus($s("c"),Times($s("d"),$s("x")))))))),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),ZeroQ(Plus(Power($s("a"),C2),Power($s("b"),C2)))))),
SetDelayed(Int(Sqrt(Plus($p("a",true),Times($p("b",true),Sinh(Plus($p("c",true),Times($p("d",true),$p("x"))))))),$p("x",$s("Symbol"))),
    Condition(Times(Times(Times(C2,CI),Sqrt(Plus($s("a"),Times(CN1,Times(CI,$s("b")))))),Times(EllipticE(Times(Plus(Times(Pi,C1D2),Times(CN1,Times(CI,Plus($s("c"),Times($s("d"),$s("x")))))),C1D2),Times(C2,Times($s("b"),Power(Plus(Times($s("a"),CI),$s("b")),CN1)))),Power($s("d"),CN1))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),NonzeroQ(Plus(Power($s("a"),C2),Power($s("b"),C2)))),PositiveQ(Plus($s("a"),Times(CN1,Times(CI,$s("b")))))))),
SetDelayed(Int(Sqrt(Plus($p("a",true),Times($p("b",true),Sinh(Plus($p("c",true),Times($p("d",true),$p("x"))))))),$p("x",$s("Symbol"))),
    Condition(Times(Times(Sqrt(Plus($s("a"),Times($s("b"),Sinh(Plus($s("c"),Times($s("d"),$s("x"))))))),Power(Sqrt(Times(Plus($s("a"),Times($s("b"),Sinh(Plus($s("c"),Times($s("d"),$s("x")))))),Power(Plus($s("a"),Times(CN1,Times(CI,$s("b")))),CN1))),CN1)),Int(Sqrt(Plus(Times($s("a"),Power(Plus($s("a"),Times(CN1,Times(CI,$s("b")))),CN1)),Times(Times($s("b"),Power(Plus($s("a"),Times(CN1,Times(CI,$s("b")))),CN1)),Sinh(Plus($s("c"),Times($s("d"),$s("x"))))))),$s("x"))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),NonzeroQ(Plus(Power($s("a"),C2),Power($s("b"),C2)))),Not(PositiveQ(Plus($s("a"),Times(CN1,Times(CI,$s("b"))))))))),
SetDelayed(Int(Times(C1,Power(Sqrt(Plus($p("a"),Times($p("b",true),Sinh(Plus($p("c",true),Times($p("d",true),$p("x"))))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Times(integer(-2L),ArcTanh(Cosh(Times(Plus(Plus($s("c"),Times(Pi,Times(CI,C1D2))),Times($s("d"),$s("x"))),C1D2)))),Times(Sinh(Times(Plus(Plus($s("c"),Times(Pi,Times(CI,C1D2))),Times($s("d"),$s("x"))),C1D2)),Power(Times($s("d"),Sqrt(Plus($s("a"),Times($s("b"),Sinh(Plus($s("c"),Times($s("d"),$s("x")))))))),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),ZeroQ(Plus($s("a"),Times(CN1,Times($s("b"),CI))))))),
SetDelayed(Int(Times(C1,Power(Sqrt(Plus($p("a"),Times($p("b",true),Sinh(Plus($p("c",true),Times($p("d",true),$p("x"))))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Times(C2,ArcTan(Sinh(Times(Plus(Plus($s("c"),Times(Pi,Times(CI,C1D2))),Times($s("d"),$s("x"))),C1D2)))),Times(Cosh(Times(Plus(Plus($s("c"),Times(Pi,Times(CI,C1D2))),Times($s("d"),$s("x"))),C1D2)),Power(Times($s("d"),Sqrt(Plus($s("a"),Times($s("b"),Sinh(Plus($s("c"),Times($s("d"),$s("x")))))))),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),ZeroQ(Plus($s("a"),Times($s("b"),CI)))))),
SetDelayed(Int(Times(C1,Power(Sqrt(Plus($p("a",true),Times($p("b",true),Sinh(Plus($p("c",true),Times($p("d",true),$p("x"))))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Times(C2,CI),Times(EllipticF(Times(Plus(Times(Pi,C1D2),Times(CN1,Times(CI,Plus($s("c"),Times($s("d"),$s("x")))))),C1D2),Times(C2,Times($s("b"),Power(Plus(Times($s("a"),CI),$s("b")),CN1)))),Power(Times($s("d"),Sqrt(Plus($s("a"),Times(CN1,Times(CI,$s("b")))))),CN1))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),NonzeroQ(Plus(Power($s("a"),C2),Power($s("b"),C2)))),PositiveQ(Plus($s("a"),Times(CN1,Times(CI,$s("b")))))))),
SetDelayed(Int(Times(C1,Power(Sqrt(Plus($p("a",true),Times($p("b",true),Sinh(Plus($p("c",true),Times($p("d",true),$p("x"))))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(Times(Sqrt(Times(Plus($s("a"),Times($s("b"),Sinh(Plus($s("c"),Times($s("d"),$s("x")))))),Power(Plus($s("a"),Times(CN1,Times(CI,$s("b")))),CN1))),Power(Sqrt(Plus($s("a"),Times($s("b"),Sinh(Plus($s("c"),Times($s("d"),$s("x"))))))),CN1)),Int(Times(C1,Power(Sqrt(Plus(Times($s("a"),Power(Plus($s("a"),Times(CN1,Times(CI,$s("b")))),CN1)),Times(Times($s("b"),Power(Plus($s("a"),Times(CN1,Times(CI,$s("b")))),CN1)),Sinh(Plus($s("c"),Times($s("d"),$s("x"))))))),CN1)),$s("x"))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),NonzeroQ(Plus(Power($s("a"),C2),Power($s("b"),C2)))),Not(PositiveQ(Plus($s("a"),Times(CN1,Times(CI,$s("b"))))))))),
SetDelayed(Int(Power(Plus($p("a"),Times($p("b",true),Sinh(Plus($p("c",true),Times($p("d",true),$p("x")))))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times($s("b"),Cosh(Plus($s("c"),Times($s("d"),$s("x"))))),Times(Power(Plus($s("a"),Times($s("b"),Sinh(Plus($s("c"),Times($s("d"),$s("x")))))),Plus($s("n"),Times(CN1,C1))),Power(Times($s("d"),$s("n")),CN1))),Dist(Times($s("a"),Times(Plus(Times(C2,$s("n")),Times(CN1,C1)),Power($s("n"),CN1))),Int(Power(Plus($s("a"),Times($s("b"),Sinh(Plus($s("c"),Times($s("d"),$s("x")))))),Plus($s("n"),Times(CN1,C1))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),FractionQ($s("n"))),Greater($s("n"),C1)),ZeroQ(Plus(Power($s("a"),C2),Power($s("b"),C2)))))),
SetDelayed(Int(Power(Plus($p("a"),Times($p("b",true),Sinh(Plus($p("c",true),Times($p("d",true),$p("x")))))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(Times(CN1,$s("b")),Cosh(Plus($s("c"),Times($s("d"),$s("x"))))),Times(Power(Plus($s("a"),Times($s("b"),Sinh(Plus($s("c"),Times($s("d"),$s("x")))))),$s("n")),Power(Times(Times($s("a"),$s("d")),Plus(Times(C2,$s("n")),C1)),CN1))),Dist(Times(Plus($s("n"),C1),Power(Times($s("a"),Plus(Times(C2,$s("n")),C1)),CN1)),Int(Power(Plus($s("a"),Times($s("b"),Sinh(Plus($s("c"),Times($s("d"),$s("x")))))),Plus($s("n"),C1)),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),RationalQ($s("n"))),Less($s("n"),CN1)),ZeroQ(Plus(Power($s("a"),C2),Power($s("b"),C2)))))),
SetDelayed(Int(Times(C1,Power(Power(Plus($p("a"),Times($p("b",true),Sinh(Plus($p("c",true),Times($p("d",true),$p("x")))))),C2),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,$s("b")),Times(Cosh(Plus($s("c"),Times($s("d"),$s("x")))),Power(Times(Times($s("d"),Plus(Power($s("a"),C2),Power($s("b"),C2))),Plus($s("a"),Times($s("b"),Sinh(Plus($s("c"),Times($s("d"),$s("x"))))))),CN1))),Dist(Times($s("a"),Power(Plus(Power($s("a"),C2),Power($s("b"),C2)),CN1)),Int(Times(C1,Power(Plus($s("a"),Times($s("b"),Sinh(Plus($s("c"),Times($s("d"),$s("x")))))),CN1)),$s("x")))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),NonzeroQ(Plus(Power($s("a"),C2),Power($s("b"),C2)))))),
SetDelayed(Int(Power(Plus($p("a"),Times($p("b",true),Sinh(Plus($p("c",true),Times($p("d",true),$p("x")))))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times($s("b"),Cosh(Plus($s("c"),Times($s("d"),$s("x"))))),Times(Power(Plus($s("a"),Times($s("b"),Sinh(Plus($s("c"),Times($s("d"),$s("x")))))),Plus($s("n"),C1)),Power(Times(Times($s("d"),Plus($s("n"),C1)),Plus(Power($s("a"),C2),Power($s("b"),C2))),CN1))),Dist(Times(C1,Power(Times(Plus($s("n"),C1),Plus(Power($s("a"),C2),Power($s("b"),C2))),CN1)),Int(Times(Plus(Times($s("a"),Plus($s("n"),C1)),Times(CN1,Times(Times($s("b"),Plus($s("n"),C2)),Sinh(Plus($s("c"),Times($s("d"),$s("x"))))))),Power(Plus($s("a"),Times($s("b"),Sinh(Plus($s("c"),Times($s("d"),$s("x")))))),Plus($s("n"),C1))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),RationalQ($s("n"))),Less($s("n"),CN1)),NonzeroQ(Plus(Power($s("a"),C2),Power($s("b"),C2)))))),
SetDelayed(Int(Power(Times($p("c",true),Sinh(Plus($p("a",true),Times($p("b",true),$p("x"))))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times($s("c"),Cosh(Plus($s("a"),Times($s("b"),$s("x"))))),Times(Power(Times($s("c"),Sinh(Plus($s("a"),Times($s("b"),$s("x"))))),Plus($s("n"),Times(CN1,C1))),Power(Times($s("b"),$s("n")),CN1))),Times(CN1,Dist(Times(Plus($s("n"),Times(CN1,C1)),Times(Power($s("c"),C2),Power($s("n"),CN1))),Int(Power(Times($s("c"),Sinh(Plus($s("a"),Times($s("b"),$s("x"))))),Plus($s("n"),Times(CN1,C2))),$s("x"))))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),RationalQ($s("n"))),Greater($s("n"),C1)),Not(OddQ($s("n")))))),
SetDelayed(Int(Power(Times($p("c",true),Sinh(Plus($p("a",true),Times($p("b",true),$p("x"))))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Cosh(Plus($s("a"),Times($s("b"),$s("x")))),Times(Power(Times($s("c"),Sinh(Plus($s("a"),Times($s("b"),$s("x"))))),Plus($s("n"),C1)),Power(Times(Times($s("c"),$s("b")),Plus($s("n"),C1)),CN1))),Times(CN1,Dist(Times(Plus($s("n"),C2),Power(Times(Plus($s("n"),C1),Power($s("c"),C2)),CN1)),Int(Power(Times($s("c"),Sinh(Plus($s("a"),Times($s("b"),$s("x"))))),Plus($s("n"),C2)),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),RationalQ($s("n"))),Less($s("n"),CN1)))),
SetDelayed(Int(Power(Times($p("c"),Sinh(Plus($p("a",true),Times($p("b",true),$p("x"))))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Times(Times(Power(Times($s("c"),Sinh(Plus($s("a"),Times($s("b"),$s("x"))))),$s("n")),Power(Power(Sinh(Plus($s("a"),Times($s("b"),$s("x")))),$s("n")),CN1)),Int(Power(Sinh(Plus($s("a"),Times($s("b"),$s("x")))),$s("n")),$s("x"))),And(And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),RationalQ($s("n"))),Less(Less(CN1,$s("n")),C1)))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Plus($p("a"),Times($p("b",true),Sinh(Plus($p("c",true),Times($p("d",true),$p("x")))))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Dist(Power(Times(C2,$s("a")),$s("n")),Int(Times(Power($s("x"),$s("m")),Power(Cosh(Plus(Plus(Times(Times(CN1,Pi),Times(CI,C1D4)),Times($s("c"),C1D2)),Times($s("d"),Times($s("x"),C1D2)))),Times(C2,$s("n")))),$s("x"))),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),RationalQ($s("m"))),IntegerQ($s("n"))),Less($s("n"),C0)),ZeroQ(Plus($s("a"),Times(CN1,Times($s("b"),CI))))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Plus($p("a"),Times($p("b",true),Sinh(Plus($p("c",true),Times($p("d",true),$p("x")))))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Dist(Power(C2,$s("n")),Int(Times(Power($s("x"),$s("m")),Power(Times($s("a"),Power(Cosh(Plus(Plus(Times(Times(CN1,Pi),Times(CI,C1D4)),Times($s("c"),C1D2)),Times($s("d"),Times($s("x"),C1D2)))),C2)),$s("n"))),$s("x"))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),RationalQ(List($s("m"),$s("n")))),ZeroQ(Plus($s("a"),Times(CN1,Times($s("b"),CI))))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Plus($p("a"),Times($p("b",true),Sinh(Plus($p("c",true),Times($p("d",true),$p("x")))))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Dist(Power(Times(C2,$s("a")),$s("n")),Int(Times(Power($s("x"),$s("m")),Power(Cosh(Plus(Plus(Times(Pi,Times(CI,C1D4)),Times($s("c"),C1D2)),Times($s("d"),Times($s("x"),C1D2)))),Times(C2,$s("n")))),$s("x"))),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),RationalQ($s("m"))),IntegerQ($s("n"))),Less($s("n"),C0)),ZeroQ(Plus($s("a"),Times($s("b"),CI)))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Plus($p("a"),Times($p("b",true),Sinh(Plus($p("c",true),Times($p("d",true),$p("x")))))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Dist(Power(C2,$s("n")),Int(Times(Power($s("x"),$s("m")),Power(Times($s("a"),Power(Cosh(Plus(Plus(Times(Pi,Times(CI,C1D4)),Times($s("c"),C1D2)),Times($s("d"),Times($s("x"),C1D2)))),C2)),$s("n"))),$s("x"))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),RationalQ(List($s("m"),$s("n")))),ZeroQ(Plus($s("a"),Times($s("b"),CI)))))),
SetDelayed(Int(Times($p("x"),Power(Power(Plus($p("a"),Times($p("b",true),Sinh(Plus($p("c",true),Times($p("d",true),$p("x")))))),C2),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Dist(Times($s("a"),Power(Plus(Power($s("a"),C2),Power($s("b"),C2)),CN1)),Int(Times($s("x"),Power(Plus($s("a"),Times($s("b"),Sinh(Plus($s("c"),Times($s("d"),$s("x")))))),CN1)),$s("x"))),Dist(Times($s("b"),Power(Plus(Power($s("a"),C2),Power($s("b"),C2)),CN1)),Int(Times($s("x"),Times(Plus($s("b"),Times(CN1,Times($s("a"),Sinh(Plus($s("c"),Times($s("d"),$s("x"))))))),Power(Power(Plus($s("a"),Times($s("b"),Sinh(Plus($s("c"),Times($s("d"),$s("x")))))),C2),CN1))),$s("x")))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),NonzeroQ(Plus(Power($s("a"),C2),Power($s("b"),C2)))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Plus($p("a"),Times($p("b",true),Sinh(Plus($p("c",true),Times($p("d",true),$p("x")))))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Dist(Times(C1,Power(Power(C2,$s("n")),CN1)),Int(Times(Power($s("x"),$s("m")),Times(Power(Plus(Plus(Times(CN1,$s("b")),Times(Times(C2,$s("a")),Power(E,Plus($s("c"),Times($s("d"),$s("x")))))),Times($s("b"),Power(E,Times(C2,Plus($s("c"),Times($s("d"),$s("x"))))))),$s("n")),Power(Power(E,Times($s("n"),Plus($s("c"),Times($s("d"),$s("x"))))),CN1))),$s("x"))),And(And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),NonzeroQ(Plus(Power($s("a"),C2),Power($s("b"),C2)))),IntegerQ($s("n"))),Less($s("n"),C0)),RationalQ($s("m"))),Greater($s("m"),C0)))),
SetDelayed(Int(Times(Plus($p("A",true),Times($p("B",true),Sinh(Plus($p("c",true),Times($p("d",true),$p("x")))))),Power(Sqrt(Plus($p("a"),Times($p("b",true),Sinh(Plus($p("c",true),Times($p("d",true),$p("x"))))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Dist(Times(Plus(Times($s("b"),$s("A")),Times(CN1,Times($s("a"),$s("B")))),Power($s("b"),CN1)),Int(Times(C1,Power(Sqrt(Plus($s("a"),Times($s("b"),Sinh(Plus($s("c"),Times($s("d"),$s("x"))))))),CN1)),$s("x"))),Dist(Times($s("B"),Power($s("b"),CN1)),Int(Sqrt(Plus($s("a"),Times($s("b"),Sinh(Plus($s("c"),Times($s("d"),$s("x"))))))),$s("x")))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("A"),$s("B")),$s("x")),NonzeroQ(Plus(Times($s("b"),$s("A")),Times(CN1,Times($s("a"),$s("B")))))))),
SetDelayed(Int(Times(Plus($p("A",true),Times($p("B",true),Sinh(Plus($p("c",true),Times($p("d",true),$p("x")))))),Power(Plus($p("a"),Times($p("b",true),Sinh(Plus($p("c",true),Times($p("d",true),$p("x")))))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times($s("B"),Cosh(Plus($s("c"),Times($s("d"),$s("x"))))),Times(Power(Plus($s("a"),Times($s("b"),Sinh(Plus($s("c"),Times($s("d"),$s("x")))))),$s("n")),Power(Times($s("d"),Plus($s("n"),C1)),CN1))),Dist(Times(C1,Power(Plus($s("n"),C1),CN1)),Int(Times(Plus(Plus(Times(Times(Times(CN1,$s("b")),$s("B")),$s("n")),Times(Times($s("a"),$s("A")),Plus($s("n"),C1))),Times(Plus(Times(Times($s("a"),$s("B")),$s("n")),Times(Times($s("b"),$s("A")),Plus($s("n"),C1))),Sinh(Plus($s("c"),Times($s("d"),$s("x")))))),Power(Plus($s("a"),Times($s("b"),Sinh(Plus($s("c"),Times($s("d"),$s("x")))))),Plus($s("n"),Times(CN1,C1)))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("A"),$s("B")),$s("x")),RationalQ($s("n"))),Greater($s("n"),C1)),NonzeroQ(Plus(Power($s("a"),C2),Power($s("b"),C2)))))),
SetDelayed(Int(Times(Plus($p("A"),Times($p("B",true),Sinh(Plus($p("c",true),Times($p("d",true),$p("x")))))),Power(Power(Plus($p("a"),Times($p("b",true),Sinh(Plus($p("c",true),Times($p("d",true),$p("x")))))),C2),CN1)),$p("x",$s("Symbol"))),
    Condition(Times($s("B"),Times(Cosh(Plus($s("c"),Times($s("d"),$s("x")))),Power(Times(Times($s("a"),$s("d")),Plus($s("a"),Times($s("b"),Sinh(Plus($s("c"),Times($s("d"),$s("x"))))))),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("A"),$s("B")),$s("x")),ZeroQ(Plus(Times($s("a"),$s("A")),Times($s("b"),$s("B"))))))),
SetDelayed(Int(Times($p("x"),Times(Plus($p("A"),Times($p("B",true),Sinh(Plus($p("c",true),Times($p("d",true),$p("x")))))),Power(Power(Plus($p("a"),Times($p("b",true),Sinh(Plus($p("c",true),Times($p("d",true),$p("x")))))),C2),CN1))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times($s("B"),$s("x")),Times(Cosh(Plus($s("c"),Times($s("d"),$s("x")))),Power(Times(Times($s("a"),$s("d")),Plus($s("a"),Times($s("b"),Sinh(Plus($s("c"),Times($s("d"),$s("x"))))))),CN1))),Times(CN1,Dist(Times($s("B"),Power(Times($s("a"),$s("d")),CN1)),Int(Times(Cosh(Plus($s("c"),Times($s("d"),$s("x")))),Power(Plus($s("a"),Times($s("b"),Sinh(Plus($s("c"),Times($s("d"),$s("x")))))),CN1)),$s("x"))))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("A"),$s("B")),$s("x")),ZeroQ(Plus(Times($s("a"),$s("A")),Times($s("b"),$s("B"))))))),
SetDelayed(Int(Times(Plus($p("A",true),Times($p("B",true),Sinh(Plus($p("c",true),Times($p("d",true),$p("x")))))),Power(Plus($p("a",true),Times($p("b",true),Sinh(Plus($p("c",true),Times($p("d",true),$p("x")))))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(Times(CN1,Plus(Times($s("a"),$s("B")),Times(CN1,Times($s("b"),$s("A"))))),Cosh(Plus($s("c"),Times($s("d"),$s("x"))))),Times(Power(Plus($s("a"),Times($s("b"),Sinh(Plus($s("c"),Times($s("d"),$s("x")))))),Plus($s("n"),C1)),Power(Times(Times($s("d"),Plus($s("n"),C1)),Plus(Power($s("a"),C2),Power($s("b"),C2))),CN1))),Dist(Times(C1,Power(Times(Plus($s("n"),C1),Plus(Power($s("a"),C2),Power($s("b"),C2))),CN1)),Int(Times(Plus(Times(Plus($s("n"),C1),Plus(Times($s("a"),$s("A")),Times($s("b"),$s("B")))),Times(Times(Plus($s("n"),C2),Plus(Times($s("a"),$s("B")),Times(CN1,Times($s("b"),$s("A"))))),Sinh(Plus($s("c"),Times($s("d"),$s("x")))))),Power(Plus($s("a"),Times($s("b"),Sinh(Plus($s("c"),Times($s("d"),$s("x")))))),Plus($s("n"),C1))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("A"),$s("B")),$s("x")),RationalQ($s("n"))),Less($s("n"),CN1)),NonzeroQ(Plus(Power($s("a"),C2),Power($s("b"),C2)))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Plus($p("a"),Times($p("b",true),Power(Sinh(Plus($p("c",true),Times($p("d",true),$p("x")))),C2))),CN1)),$p("x",$s("Symbol"))),
    Condition(Dist(C2,Int(Times(Power($s("x"),$s("m")),Power(Plus(Plus(Times(C2,$s("a")),Times(CN1,$s("b"))),Times($s("b"),Cosh(Plus(Times(C2,$s("c")),Times(Times(C2,$s("d")),$s("x")))))),CN1)),$s("x"))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),IntegerQ($s("m"))),Greater($s("m"),C0)),NonzeroQ(Plus($s("a"),Times(CN1,$s("b"))))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Plus(Plus($p("a",true),Times($p("b",true),Power(Cosh(Plus($p("d",true),Times($p("e",true),$p("x")))),C2))),Times($p("c",true),Power(Sinh(Plus($p("d",true),Times($p("e",true),$p("x")))),C2))),CN1)),$p("x",$s("Symbol"))),
    Condition(Dist(C2,Int(Times(Power($s("x"),$s("m")),Power(Plus(Plus(Plus(Times(C2,$s("a")),$s("b")),Times(CN1,$s("c"))),Times(Plus($s("b"),$s("c")),Cosh(Plus(Times(C2,$s("d")),Times(Times(C2,$s("e")),$s("x")))))),CN1)),$s("x"))),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e")),$s("x")),IntegerQ($s("m"))),Greater($s("m"),C0)),NonzeroQ(Plus($s("a"),$s("b")))),NonzeroQ(Plus($s("a"),Times(CN1,$s("c"))))))),
SetDelayed(Int(Power(Plus($p("a"),Times($p("b",true),Power(Sinh(Plus($p("c",true),Times($p("d",true),$p("x")))),C2))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Dist(Times(C1,Power(Power(C2,$s("n")),CN1)),Int(Power(Plus(Plus(Times(C2,$s("a")),Times(CN1,$s("b"))),Times($s("b"),Cosh(Plus(Times(C2,$s("c")),Times(Times(C2,$s("d")),$s("x")))))),$s("n")),$s("x"))),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),NonzeroQ(Plus($s("a"),Times(CN1,$s("b"))))),HalfIntegerQ($s("n"))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Plus($p("a"),Times(Times($p("b",true),Sinh(Plus($p("c",true),Times($p("d",true),$p("x"))))),Cosh(Plus($p("c",true),Times($p("d",true),$p("x")))))),CN1)),$p("x",$s("Symbol"))),
    Condition(Int(Times(Power($s("x"),$s("m")),Power(Plus($s("a"),Times($s("b"),Times(Sinh(Plus(Times(C2,$s("c")),Times(Times(C2,$s("d")),$s("x")))),C1D2))),CN1)),$s("x")),And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),IntegerQ($s("m"))),Greater($s("m"),C0)))),
SetDelayed(Int(Power(Plus($p("a"),Times(Times($p("b",true),Sinh(Plus($p("c",true),Times($p("d",true),$p("x"))))),Cosh(Plus($p("c",true),Times($p("d",true),$p("x")))))),$p("n")),$p("x",$s("Symbol"))),
    Condition(Int(Power(Plus($s("a"),Times($s("b"),Times(Sinh(Plus(Times(C2,$s("c")),Times(Times(C2,$s("d")),$s("x")))),C1D2))),$s("n")),$s("x")),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d")),$s("x")),HalfIntegerQ($s("n"))))),
SetDelayed(Int(Times(Power(Sinh(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m",true)),Power(Cosh(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Times(Power(Sinh(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),C1)),Times(Power(Cosh(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C1)),Power(Times($s("b"),Plus($s("m"),C1)),CN1))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("m"),$s("n")),$s("x")),ZeroQ(Plus(Plus($s("m"),$s("n")),C2))),NonzeroQ(Plus($s("m"),C1))),PosQ($s("m"))))),
SetDelayed(Int(Times(Power(Sinh(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m")),Power(Cosh(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Dist(Times(C1,Power($s("b"),CN1)),Subst(Int(Regularize(Times(Power($s("x"),$s("m")),Power(Plus(C1,Power($s("x"),C2)),Times(Plus($s("n"),Times(CN1,C1)),C1D2))),$s("x")),$s("x")),$s("x"),Sinh(Plus($s("a"),Times($s("b"),$s("x")))))),And(And(FreeQ(List($s("a"),$s("b"),$s("m")),$s("x")),OddQ($s("n"))),Not(And(OddQ($s("m")),Less(Less(C0,$s("m")),$s("n"))))))),
SetDelayed(Int(Times(Power(Sinh(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m")),Power(Cosh(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power(Sinh(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),Times(CN1,C1))),Times(Power(Cosh(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C1)),Power(Times($s("b"),Plus($s("n"),C1)),CN1))),Times(CN1,Dist(Times(Plus($s("m"),Times(CN1,C1)),Power(Plus($s("n"),C1),CN1)),Int(Times(Power(Sinh(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),Times(CN1,C2))),Power(Cosh(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C2))),$s("x"))))),And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),RationalQ(List($s("m"),$s("n")))),Greater($s("m"),C1)),Less($s("n"),CN1)))),
SetDelayed(Int(Times(Power(Sinh(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m")),Power(Cosh(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power(Sinh(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),Times(CN1,C1))),Times(Power(Cosh(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C1)),Power(Times($s("b"),Plus($s("m"),$s("n"))),CN1))),Times(CN1,Dist(Times(Plus($s("m"),Times(CN1,C1)),Power(Plus($s("m"),$s("n")),CN1)),Int(Times(Power(Sinh(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),Times(CN1,C2))),Power(Cosh(Plus($s("a"),Times($s("b"),$s("x")))),$s("n"))),$s("x"))))),And(And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("n")),$s("x")),RationalQ($s("m"))),Greater($s("m"),C1)),Not(OddQ($s("m")))),NonzeroQ(Plus($s("m"),$s("n")))),Not(And(OddQ($s("n")),Greater($s("n"),C1)))))),
SetDelayed(Int(Times(Power(Sinh(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m")),Power(Cosh(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power(Sinh(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),C1)),Times(Power(Cosh(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C1)),Power(Times($s("b"),Plus($s("m"),C1)),CN1))),Times(CN1,Dist(Times(Plus(Plus($s("m"),$s("n")),C2),Power(Plus($s("m"),C1),CN1)),Int(Times(Power(Sinh(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),C2)),Power(Cosh(Plus($s("a"),Times($s("b"),$s("x")))),$s("n"))),$s("x"))))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("n")),$s("x")),RationalQ($s("m"))),Less($s("m"),CN1)),NonzeroQ(Plus(Plus($s("m"),$s("n")),C2))))),
SetDelayed(Int(Times(Power(Sinh(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m")),Power(Cosh(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Dist(Times(C1,Power(Times($s("b"),$s("m")),CN1)),Subst(Int(Times(Power($s("x"),Times(C1,Power($s("m"),CN1))),Power(Plus(C1,Times(CN1,Power($s("x"),Times(C2,Power($s("m"),CN1))))),CN1)),$s("x")),$s("x"),Times(Power(Sinh(Plus($s("a"),Times($s("b"),$s("x")))),$s("m")),Power(Cosh(Plus($s("a"),Times($s("b"),$s("x")))),$s("n"))))),And(And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),FractionQ(List($s("m"),$s("n")))),ZeroQ(Plus($s("m"),$s("n")))),IntegerQ(Times(C1,Power($s("m"),CN1)))),Greater($s("m"),C0)))),
SetDelayed(Int(Times(Sinh(Plus($p("a",true),Times($p("b",true),$p("x")))),Tanh(Plus($p("a",true),Times($p("b",true),$p("x"))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Sinh(Plus($s("a"),Times($s("b"),$s("x")))),Power($s("b"),CN1)),Times(CN1,Int(Sech(Plus($s("a"),Times($s("b"),$s("x")))),$s("x")))),FreeQ(List($s("a"),$s("b")),$s("x")))),
SetDelayed(Int(Times(Power(Sinh(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m")),Power(Tanh(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Times(Power(Sinh(Plus($s("a"),Times($s("b"),$s("x")))),$s("m")),Times(Power(Tanh(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C1))),Power(Times($s("b"),$s("m")),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("m"),$s("n")),$s("x")),ZeroQ(Plus(Plus($s("m"),$s("n")),Times(CN1,C1)))))),
SetDelayed(Int(Times(Power(Sinh(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m",true)),Power(Tanh(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Dist(Times(C1,Power($s("b"),CN1)),Subst(Int(Regularize(Times(Power(Plus(CN1,Power($s("x"),C2)),Times(Plus(Plus($s("m"),$s("n")),Times(CN1,C1)),C1D2)),Power(Power($s("x"),$s("n")),CN1)),$s("x")),$s("x")),$s("x"),Cosh(Plus($s("a"),Times($s("b"),$s("x")))))),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ(List($s("m"),$s("n")))),OddQ(Plus($s("m"),$s("n")))))),
SetDelayed(Int(Times(Power(Sinh(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m")),Power(Tanh(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power(Sinh(Plus($s("a"),Times($s("b"),$s("x")))),$s("m")),Times(Power(Tanh(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C1)),Power(Times($s("b"),$s("m")),CN1))),Times(CN1,Dist(Times(Plus($s("n"),C1),Power($s("m"),CN1)),Int(Times(Power(Sinh(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),Times(CN1,C2))),Power(Tanh(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C2))),$s("x"))))),And(And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),RationalQ(List($s("m"),$s("n")))),Greater($s("m"),C1)),Less($s("n"),CN1)),Not(And(OddQ($s("m")),EvenQ($s("n"))))))),
SetDelayed(Int(Times(Power(Sinh(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m")),Power(Tanh(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power(Sinh(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),C2)),Times(Power(Tanh(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C1))),Power(Times($s("b"),Plus($s("n"),Times(CN1,C1))),CN1))),Times(CN1,Dist(Times(Plus($s("m"),C2),Power(Plus($s("n"),Times(CN1,C1)),CN1)),Int(Times(Power(Sinh(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),C2)),Power(Tanh(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C2)))),$s("x"))))),And(And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),RationalQ(List($s("m"),$s("n")))),Less($s("m"),CN1)),Greater($s("n"),C1)),Not(And(OddQ($s("m")),EvenQ($s("n"))))))),
SetDelayed(Int(Times(Power(Sinh(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m")),Power(Tanh(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power(Sinh(Plus($s("a"),Times($s("b"),$s("x")))),$s("m")),Times(Power(Tanh(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C1))),Power(Times($s("b"),$s("m")),CN1))),Times(CN1,Dist(Times(Plus(Plus($s("m"),$s("n")),Times(CN1,C1)),Power($s("m"),CN1)),Int(Times(Power(Sinh(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),Times(CN1,C2))),Power(Tanh(Plus($s("a"),Times($s("b"),$s("x")))),$s("n"))),$s("x"))))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("n")),$s("x")),RationalQ($s("m"))),Greater($s("m"),C1)),Not(And(OddQ($s("m")),EvenQ($s("n"))))))),
SetDelayed(Int(Times(Power(Sinh(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m",true)),Power(Tanh(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times(CN1,Power(Sinh(Plus($s("a"),Times($s("b"),$s("x")))),$s("m"))),Times(Power(Tanh(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C1))),Power(Times($s("b"),Plus($s("n"),Times(CN1,C1))),CN1))),Dist(Times(Plus(Plus($s("m"),$s("n")),Times(CN1,C1)),Power(Plus($s("n"),Times(CN1,C1)),CN1)),Int(Times(Power(Sinh(Plus($s("a"),Times($s("b"),$s("x")))),$s("m")),Power(Tanh(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C2)))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("m")),$s("x")),RationalQ($s("n"))),Greater($s("n"),C1)),Not(And(OddQ($s("m")),EvenQ($s("n"))))))),
SetDelayed(Int(Times(Power(Sinh(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m")),Power(Tanh(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n",true))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power(Sinh(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),C2)),Times(Power(Tanh(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),Times(CN1,C1))),Power(Times($s("b"),Plus(Plus($s("m"),$s("n")),C1)),CN1))),Times(CN1,Dist(Times(Plus($s("m"),C2),Power(Plus(Plus($s("m"),$s("n")),C1),CN1)),Int(Times(Power(Sinh(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("m"),C2)),Power(Tanh(Plus($s("a"),Times($s("b"),$s("x")))),$s("n"))),$s("x"))))),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("n")),$s("x")),RationalQ($s("m"))),Less($s("m"),CN1)),NonzeroQ(Plus(Plus($s("m"),$s("n")),C1))),Not(And(OddQ($s("m")),EvenQ($s("n"))))))),
SetDelayed(Int(Times(Power(Sinh(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("m",true)),Power(Tanh(Plus($p("a",true),Times($p("b",true),$p("x")))),$p("n"))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power(Sinh(Plus($s("a"),Times($s("b"),$s("x")))),$s("m")),Times(Power(Tanh(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C1)),Power(Times($s("b"),Plus(Plus($s("m"),$s("n")),C1)),CN1))),Dist(Times(Plus($s("n"),C1),Power(Plus(Plus($s("m"),$s("n")),C1),CN1)),Int(Times(Power(Sinh(Plus($s("a"),Times($s("b"),$s("x")))),$s("m")),Power(Tanh(Plus($s("a"),Times($s("b"),$s("x")))),Plus($s("n"),C2))),$s("x")))),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("m")),$s("x")),RationalQ($s("n"))),Less($s("n"),CN1)),NonzeroQ(Plus(Plus($s("m"),$s("n")),C1))),Not(And(OddQ($s("m")),EvenQ($s("n"))))))),
SetDelayed(Int(Sinh(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n"))))),$p("x",$s("Symbol"))),
    Condition(Plus(Dist(C1D2,Int(Power(E,Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),$s("x"))),Times(CN1,Dist(C1D2,Int(Power(E,Plus(Times(CN1,$s("a")),Times(CN1,Times($s("b"),Power($s("x"),$s("n")))))),$s("x"))))),And(FreeQ(List($s("a"),$s("b"),$s("n")),$s("x")),Not(FractionOrNegativeQ($s("n")))))),
SetDelayed(Int(Sinh(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n"))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times($s("x"),Sinh(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))))),Times(CN1,Dist(Times($s("b"),$s("n")),Int(Times(Power($s("x"),$s("n")),Cosh(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))))),$s("x"))))),And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ($s("n"))),Less($s("n"),C0)))),
SetDelayed(Int(Times(Sinh(Times($p("a",true),Power($p("x"),$p("n",true)))),Power($p("x"),CN1)),$p("x",$s("Symbol"))),
    Condition(Times(SinhIntegral(Times($s("a"),Power($s("x"),$s("n")))),Power($s("n"),CN1)),FreeQ(List($s("a"),$s("n")),$s("x")))),
SetDelayed(Int(Times(Sinh(Plus($p("a"),Times($p("b",true),Power($p("x"),$p("n",true))))),Power($p("x"),CN1)),$p("x",$s("Symbol"))),
    Condition(Plus(Dist(Sinh($s("a")),Int(Times(Cosh(Times($s("b"),Power($s("x"),$s("n")))),Power($s("x"),CN1)),$s("x"))),Dist(Cosh($s("a")),Int(Times(Sinh(Times($s("b"),Power($s("x"),$s("n")))),Power($s("x"),CN1)),$s("x")))),FreeQ(List($s("a"),$s("b"),$s("n")),$s("x")))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Sinh(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n",true)))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus(Plus($s("m"),Times(CN1,$s("n"))),C1)),Times(Cosh(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),Power(Times($s("b"),$s("n")),CN1))),Times(CN1,Dist(Times(Plus(Plus($s("m"),Times(CN1,$s("n"))),C1),Power(Times($s("b"),$s("n")),CN1)),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,$s("n")))),Cosh(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))))),$s("x"))))),And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ($s("n"))),RationalQ($s("m"))),And(Less(C0,$s("n")),LessEqual($s("n"),$s("m")))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Sinh(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n",true)))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Times(Sinh(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),Power(Plus($s("m"),C1),CN1))),Times(CN1,Dist(Times($s("b"),Times($s("n"),Power(Plus($s("m"),C1),CN1))),Int(Times(Power($s("x"),Plus($s("m"),$s("n"))),Cosh(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))))),$s("x"))))),And(FreeQ(List($s("a"),$s("b"),$s("m"),$s("n")),$s("x")),Or(ZeroQ(Plus(Plus($s("m"),$s("n")),C1)),And(And(IntegerQ($s("n")),RationalQ($s("m"))),Or(And(Greater($s("n"),C0),Less($s("m"),CN1)),Less(Less(C0,Times(CN1,$s("n"))),Plus($s("m"),C1)))))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Sinh(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n",true)))))),$p("x",$s("Symbol"))),
    Condition(Plus(Dist(C1D2,Int(Times(Power($s("x"),$s("m")),Power(E,Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))))),$s("x"))),Times(CN1,Dist(C1D2,Int(Times(Power($s("x"),$s("m")),Power(E,Plus(Times(CN1,$s("a")),Times(CN1,Times($s("b"),Power($s("x"),$s("n"))))))),$s("x"))))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("m"),$s("n")),$s("x")),NonzeroQ(Plus($s("m"),C1))),NonzeroQ(Plus(Plus($s("m"),Times(CN1,$s("n"))),C1))),Not(Or(FractionQ($s("m")),FractionOrNegativeQ($s("n"))))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Sinh(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n",true))))),$p("p"))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(CN1,$s("n")),Times(Power(Sinh(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),$s("p")),Power(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Power($s("p"),C2)),CN1))),Times(Times(Power($s("x"),$s("n")),Cosh(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))))),Times(Power(Sinh(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),Plus($s("p"),Times(CN1,C1))),Power(Times(Times($s("b"),$s("n")),$s("p")),CN1)))),Times(CN1,Dist(Times(Plus($s("p"),Times(CN1,C1)),Power($s("p"),CN1)),Int(Times(Power($s("x"),$s("m")),Power(Sinh(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),Plus($s("p"),Times(CN1,C2)))),$s("x"))))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("m"),$s("n")),$s("x")),RationalQ($s("p"))),Greater($s("p"),C1)),ZeroQ(Plus(Plus($s("m"),Times(CN1,Times(C2,$s("n")))),C1))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Sinh(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n",true))))),$p("p"))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Plus(Times(Times(Times(CN1,Plus(Plus($s("m"),Times(CN1,$s("n"))),C1)),Power($s("x"),Plus(Plus($s("m"),Times(CN1,Times(C2,$s("n")))),C1))),Times(Power(Sinh(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),$s("p")),Power(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Power($s("p"),C2)),CN1))),Times(Times(Power($s("x"),Plus(Plus($s("m"),Times(CN1,$s("n"))),C1)),Cosh(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))))),Times(Power(Sinh(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),Plus($s("p"),Times(CN1,C1))),Power(Times(Times($s("b"),$s("n")),$s("p")),CN1)))),Times(CN1,Dist(Times(Plus($s("p"),Times(CN1,C1)),Power($s("p"),CN1)),Int(Times(Power($s("x"),$s("m")),Power(Sinh(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),Plus($s("p"),Times(CN1,C2)))),$s("x"))))),Dist(Times(Plus(Plus($s("m"),Times(CN1,$s("n"))),C1),Times(Plus(Plus($s("m"),Times(CN1,Times(C2,$s("n")))),C1),Power(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Power($s("p"),C2)),CN1))),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,Times(C2,$s("n"))))),Power(Sinh(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),$s("p"))),$s("x")))),And(And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ($s("n"))),RationalQ(List($s("m"),$s("p")))),Greater($s("p"),C1)),Less(Less(C0,Times(C2,$s("n"))),Plus($s("m"),C1))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Sinh(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n",true))))),$p("p"))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times(Power($s("x"),$s("n")),Cosh(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))))),Times(Power(Sinh(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),Plus($s("p"),C1)),Power(Times(Times($s("b"),$s("n")),Plus($s("p"),C1)),CN1))),Times(CN1,Times($s("n"),Times(Power(Sinh(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),Plus($s("p"),C2)),Power(Times(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Plus($s("p"),C1)),Plus($s("p"),C2)),CN1))))),Times(CN1,Dist(Times(Plus($s("p"),C2),Power(Plus($s("p"),C1),CN1)),Int(Times(Power($s("x"),$s("m")),Power(Sinh(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),Plus($s("p"),C2))),$s("x"))))),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("m"),$s("n")),$s("x")),RationalQ($s("p"))),Less($s("p"),CN1)),Unequal($s("p"),integer(-2L))),ZeroQ(Plus(Plus($s("m"),Times(CN1,Times(C2,$s("n")))),C1))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Sinh(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n",true))))),$p("p"))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Plus(Times(Times(Power($s("x"),Plus(Plus($s("m"),Times(CN1,$s("n"))),C1)),Cosh(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))))),Times(Power(Sinh(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),Plus($s("p"),C1)),Power(Times(Times($s("b"),$s("n")),Plus($s("p"),C1)),CN1))),Times(CN1,Times(Times(Plus(Plus($s("m"),Times(CN1,$s("n"))),C1),Power($s("x"),Plus(Plus($s("m"),Times(CN1,Times(C2,$s("n")))),C1))),Times(Power(Sinh(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),Plus($s("p"),C2)),Power(Times(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Plus($s("p"),C1)),Plus($s("p"),C2)),CN1))))),Times(CN1,Dist(Times(Plus($s("p"),C2),Power(Plus($s("p"),C1),CN1)),Int(Times(Power($s("x"),$s("m")),Power(Sinh(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),Plus($s("p"),C2))),$s("x"))))),Dist(Times(Plus(Plus($s("m"),Times(CN1,$s("n"))),C1),Times(Plus(Plus($s("m"),Times(CN1,Times(C2,$s("n")))),C1),Power(Times(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Plus($s("p"),C1)),Plus($s("p"),C2)),CN1))),Int(Times(Power($s("x"),Plus($s("m"),Times(CN1,Times(C2,$s("n"))))),Power(Sinh(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),Plus($s("p"),C2))),$s("x")))),And(And(And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ($s("n"))),RationalQ(List($s("m"),$s("p")))),Less($s("p"),CN1)),Unequal($s("p"),integer(-2L))),Less(Less(C0,Times(C2,$s("n"))),Plus($s("m"),C1))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Sinh(Plus($p("a",true),Times($p("b",true),Power($p("x"),$p("n",true))))),$p("p"))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Plus(Times(Power($s("x"),Plus($s("m"),C1)),Times(Power(Sinh(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),$s("p")),Power(Plus($s("m"),C1),CN1))),Times(CN1,Times(Times(Times(Times(Times($s("b"),$s("n")),$s("p")),Power($s("x"),Plus(Plus($s("m"),$s("n")),C1))),Cosh(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n")))))),Times(Power(Sinh(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),Plus($s("p"),Times(CN1,C1))),Power(Times(Plus($s("m"),C1),Plus(Plus($s("m"),$s("n")),C1)),CN1))))),Dist(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Times(Power($s("p"),C2),Power(Times(Plus($s("m"),C1),Plus(Plus($s("m"),$s("n")),C1)),CN1))),Int(Times(Power($s("x"),Plus($s("m"),Times(C2,$s("n")))),Power(Sinh(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),$s("p"))),$s("x")))),Dist(Times(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),$s("p")),Times(Plus($s("p"),Times(CN1,C1)),Power(Times(Plus($s("m"),C1),Plus(Plus($s("m"),$s("n")),C1)),CN1))),Int(Times(Power($s("x"),Plus($s("m"),Times(C2,$s("n")))),Power(Sinh(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),Plus($s("p"),Times(CN1,C2)))),$s("x")))),And(And(And(And(And(And(FreeQ(List($s("a"),$s("b")),$s("x")),IntegerQ($s("n"))),RationalQ(List($s("m"),$s("p")))),Greater($s("p"),C1)),Less($s("m"),CN1)),Greater($s("n"),C0)),NonzeroQ(Plus(Plus($s("m"),$s("n")),C1))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Sinh(Plus($p("a",true),Times($p("b",true),Power(Plus($p("c"),Times($p("d",true),$p("x"))),$p("n"))))),$p("p",true))),$p("x",$s("Symbol"))),
    Condition(Dist(Times(C1,Power($s("d"),CN1)),Subst(Int(Times(Power(Plus(Times(Times(CN1,$s("c")),Power($s("d"),CN1)),Times($s("x"),Power($s("d"),CN1))),$s("m")),Power(Sinh(Plus($s("a"),Times($s("b"),Power($s("x"),$s("n"))))),$s("p"))),$s("x")),$s("x"),Plus($s("c"),Times($s("d"),$s("x"))))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("n")),$s("x")),IntegerQ($s("m"))),Greater($s("m"),C0)),RationalQ($s("p"))))),
SetDelayed(Int(Sinh(Plus(Plus($p("a",true),Times($p("b",true),$p("x"))),Times($p("c",true),Power($p("x"),C2)))),$p("x",$s("Symbol"))),
    Condition(Int(Sinh(Times(Power(Plus($s("b"),Times(Times(C2,$s("c")),$s("x"))),C2),Power(Times(C4,$s("c")),CN1))),$s("x")),And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),ZeroQ(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c")))))))),
SetDelayed(Int(Sinh(Plus(Plus($p("a",true),Times($p("b",true),$p("x"))),Times($p("c",true),Power($p("x"),C2)))),$p("x",$s("Symbol"))),
    Condition(Plus(Dist(C1D2,Int(Power(E,Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2)))),$s("x"))),Times(CN1,Dist(C1D2,Int(Power(E,Plus(Plus(Times(CN1,$s("a")),Times(CN1,Times($s("b"),$s("x")))),Times(CN1,Times($s("c"),Power($s("x"),C2))))),$s("x"))))),And(FreeQ(List($s("a"),$s("b"),$s("c")),$s("x")),NonzeroQ(Plus(Power($s("b"),C2),Times(CN1,Times(Times(C4,$s("a")),$s("c")))))))),
SetDelayed(Int(Times(Plus($p("d",true),Times($p("e",true),$p("x"))),Sinh(Plus(Plus($p("a",true),Times($p("b",true),$p("x"))),Times($p("c",true),Power($p("x"),C2))))),$p("x",$s("Symbol"))),
    Condition(Times($s("e"),Times(Cosh(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2)))),Power(Times(C2,$s("c")),CN1))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e")),$s("x")),ZeroQ(Plus(Times($s("b"),$s("e")),Times(CN1,Times(Times(C2,$s("c")),$s("d")))))))),
SetDelayed(Int(Times(Plus($p("d",true),Times($p("e",true),$p("x"))),Sinh(Plus(Plus($p("a",true),Times($p("b",true),$p("x"))),Times($p("c",true),Power($p("x"),C2))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times($s("e"),Times(Cosh(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2)))),Power(Times(C2,$s("c")),CN1))),Times(CN1,Dist(Times(Plus(Times($s("b"),$s("e")),Times(CN1,Times(Times(C2,$s("c")),$s("d")))),Power(Times(C2,$s("c")),CN1)),Int(Sinh(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2)))),$s("x"))))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e")),$s("x")),NonzeroQ(Plus(Times($s("b"),$s("e")),Times(CN1,Times(Times(C2,$s("c")),$s("d")))))))),
SetDelayed(Int(Times(Power(Plus($p("d",true),Times($p("e",true),$p("x"))),$p("m")),Sinh(Plus(Plus($p("a",true),Times($p("b",true),$p("x"))),Times($p("c",true),Power($p("x"),C2))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times($s("e"),Power(Plus($s("d"),Times($s("e"),$s("x"))),Plus($s("m"),Times(CN1,C1)))),Times(Cosh(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2)))),Power(Times(C2,$s("c")),CN1))),Times(CN1,Dist(Times(Power($s("e"),C2),Times(Plus($s("m"),Times(CN1,C1)),Power(Times(C2,$s("c")),CN1))),Int(Times(Power(Plus($s("d"),Times($s("e"),$s("x"))),Plus($s("m"),Times(CN1,C2))),Cosh(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))))),$s("x"))))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e")),$s("x")),RationalQ($s("m"))),Greater($s("m"),C1)),ZeroQ(Plus(Times($s("b"),$s("e")),Times(CN1,Times(Times(C2,$s("c")),$s("d")))))))),
SetDelayed(Int(Times(Power(Plus($p("d",true),Times($p("e",true),$p("x"))),$p("m")),Sinh(Plus(Plus($p("a",true),Times($p("b",true),$p("x"))),Times($p("c",true),Power($p("x"),C2))))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times($s("e"),Power(Plus($s("d"),Times($s("e"),$s("x"))),Plus($s("m"),Times(CN1,C1)))),Times(Cosh(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2)))),Power(Times(C2,$s("c")),CN1))),Times(CN1,Dist(Times(Plus(Times($s("b"),$s("e")),Times(CN1,Times(Times(C2,$s("c")),$s("d")))),Power(Times(C2,$s("c")),CN1)),Int(Times(Power(Plus($s("d"),Times($s("e"),$s("x"))),Plus($s("m"),Times(CN1,C1))),Sinh(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))))),$s("x"))))),Times(CN1,Dist(Times(Power($s("e"),C2),Times(Plus($s("m"),Times(CN1,C1)),Power(Times(C2,$s("c")),CN1))),Int(Times(Power(Plus($s("d"),Times($s("e"),$s("x"))),Plus($s("m"),Times(CN1,C2))),Cosh(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))))),$s("x"))))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e")),$s("x")),RationalQ($s("m"))),Greater($s("m"),C1)),NonzeroQ(Plus(Times($s("b"),$s("e")),Times(CN1,Times(Times(C2,$s("c")),$s("d")))))))),
SetDelayed(Int(Times(Power(Plus($p("d",true),Times($p("e",true),$p("x"))),$p("m")),Sinh(Plus(Plus($p("a",true),Times($p("b",true),$p("x"))),Times($p("c",true),Power($p("x"),C2))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Power(Plus($s("d"),Times($s("e"),$s("x"))),Plus($s("m"),C1)),Times(Sinh(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2)))),Power(Times($s("e"),Plus($s("m"),C1)),CN1))),Times(CN1,Dist(Times(C2,Times($s("c"),Power(Times(Power($s("e"),C2),Plus($s("m"),C1)),CN1))),Int(Times(Power(Plus($s("d"),Times($s("e"),$s("x"))),Plus($s("m"),C2)),Cosh(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))))),$s("x"))))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e")),$s("x")),RationalQ($s("m"))),Less($s("m"),CN1)),ZeroQ(Plus(Times($s("b"),$s("e")),Times(CN1,Times(Times(C2,$s("c")),$s("d")))))))),
SetDelayed(Int(Times(Power(Plus($p("d",true),Times($p("e",true),$p("x"))),$p("m")),Sinh(Plus(Plus($p("a",true),Times($p("b",true),$p("x"))),Times($p("c",true),Power($p("x"),C2))))),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Power(Plus($s("d"),Times($s("e"),$s("x"))),Plus($s("m"),C1)),Times(Sinh(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2)))),Power(Times($s("e"),Plus($s("m"),C1)),CN1))),Times(CN1,Dist(Times(Plus(Times($s("b"),$s("e")),Times(CN1,Times(Times(C2,$s("c")),$s("d")))),Power(Times(Power($s("e"),C2),Plus($s("m"),C1)),CN1)),Int(Times(Power(Plus($s("d"),Times($s("e"),$s("x"))),Plus($s("m"),C1)),Cosh(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))))),$s("x"))))),Times(CN1,Dist(Times(C2,Times($s("c"),Power(Times(Power($s("e"),C2),Plus($s("m"),C1)),CN1))),Int(Times(Power(Plus($s("d"),Times($s("e"),$s("x"))),Plus($s("m"),C2)),Cosh(Plus(Plus($s("a"),Times($s("b"),$s("x"))),Times($s("c"),Power($s("x"),C2))))),$s("x"))))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("d"),$s("e")),$s("x")),RationalQ($s("m"))),Less($s("m"),CN1)),NonzeroQ(Plus(Times($s("b"),$s("e")),Times(CN1,Times(Times(C2,$s("c")),$s("d")))))))),
SetDelayed(Int(Power(Sinh(Times($p("b",true),Log(Times($p("c",true),Power($p("x"),$p("n",true)))))),$p("p",true)),$p("x",$s("Symbol"))),
    Condition(Int(Power(Plus(Times(Power(Times($s("c"),Power($s("x"),$s("n"))),$s("b")),C1D2),Times(CN1,Times(C1,Power(Times(C2,Power(Times($s("c"),Power($s("x"),$s("n"))),$s("b"))),CN1)))),$s("p")),$s("x")),And(FreeQ($s("c"),$s("x")),RationalQ(List($s("b"),$s("n"),$s("p")))))),
SetDelayed(Int(Sinh(Plus($p("a",true),Times($p("b",true),Log(Times($p("c",true),Power($p("x"),$p("n",true))))))),$p("x",$s("Symbol"))),
    Condition(Plus(Times($s("x"),Times(Sinh(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Power(Plus(C1,Times(CN1,Times(Power($s("b"),C2),Power($s("n"),C2)))),CN1))),Times(CN1,Times(Times(Times($s("b"),$s("n")),$s("x")),Times(Cosh(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Power(Plus(C1,Times(CN1,Times(Power($s("b"),C2),Power($s("n"),C2)))),CN1))))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("n")),$s("x")),NonzeroQ(Plus(C1,Times(CN1,Times(Power($s("b"),C2),Power($s("n"),C2)))))))),
SetDelayed(Int(Sqrt(Sinh(Plus($p("a",true),Times($p("b",true),Log(Times($p("c",true),Power($p("x"),$p("n",true)))))))),$p("x",$s("Symbol"))),
    Condition(Times(Times($s("x"),Times(Sqrt(Sinh(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n")))))))),Power(Sqrt(Plus(CN1,Times(Power(E,Times(C2,$s("a"))),Power(Times($s("c"),Power($s("x"),$s("n"))),Times(C4,Power($s("n"),CN1)))))),CN1))),Int(Times(Sqrt(Plus(CN1,Times(Power(E,Times(C2,$s("a"))),Power(Times($s("c"),Power($s("x"),$s("n"))),Times(C4,Power($s("n"),CN1)))))),Power($s("x"),CN1)),$s("x"))),And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("n")),$s("x")),ZeroQ(Plus(Times($s("b"),$s("n")),Times(CN1,C2)))))),
SetDelayed(Int(Power(Sinh(Plus($p("a",true),Times($p("b",true),Log(Times($p("c",true),Power($p("x"),$p("n",true))))))),$p("p")),$p("x",$s("Symbol"))),
    Condition(Plus(Times(Times($s("x"),Coth(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n")))))))),Times(Power(Sinh(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),C2)),Power(Times(Times($s("b"),$s("n")),Plus($s("p"),C1)),CN1))),Times(CN1,Times($s("x"),Times(Power(Sinh(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),C2)),Power(Times(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Plus($s("p"),C1)),Plus($s("p"),C2)),CN1))))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("n"),$s("p")),$s("x")),NonzeroQ(Plus($s("p"),C1))),NonzeroQ(Plus($s("p"),C2))),ZeroQ(Plus(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Power(Plus($s("p"),C2),C2)),Times(CN1,C1)))))),
SetDelayed(Int(Power(Sinh(Plus($p("a",true),Times($p("b",true),Log(Times($p("c",true),Power($p("x"),$p("n",true))))))),$p("p")),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times($s("x"),Times(Power(Sinh(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),$s("p")),Power(Plus(C1,Times(CN1,Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Power($s("p"),C2)))),CN1))),Times(CN1,Times(Times(Times(Times(Times($s("b"),$s("n")),$s("p")),$s("x")),Cosh(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n")))))))),Times(Power(Sinh(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),Times(CN1,C1))),Power(Plus(C1,Times(CN1,Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Power($s("p"),C2)))),CN1))))),Dist(Times(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),$s("p")),Times(Plus($s("p"),Times(CN1,C1)),Power(Plus(C1,Times(CN1,Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Power($s("p"),C2)))),CN1))),Int(Power(Sinh(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),Times(CN1,C2))),$s("x")))),And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("n")),$s("x")),RationalQ($s("p"))),Greater($s("p"),C1)),NonzeroQ(Plus(C1,Times(CN1,Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Power($s("p"),C2)))))))),
SetDelayed(Int(Power(Sinh(Plus($p("a",true),Times($p("b",true),Log(Times($p("c",true),Power($p("x"),$p("n",true))))))),$p("p")),$p("x",$s("Symbol"))),
    Condition(Plus(Plus(Times(Times($s("x"),Coth(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n")))))))),Times(Power(Sinh(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),C2)),Power(Times(Times($s("b"),$s("n")),Plus($s("p"),C1)),CN1))),Times(CN1,Times($s("x"),Times(Power(Sinh(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),C2)),Power(Times(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Plus($s("p"),C1)),Plus($s("p"),C2)),CN1))))),Times(CN1,Dist(Times(Plus(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Power(Plus($s("p"),C2),C2)),Times(CN1,C1)),Power(Times(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Plus($s("p"),C1)),Plus($s("p"),C2)),CN1)),Int(Power(Sinh(Plus($s("a"),Times($s("b"),Log(Times($s("c"),Power($s("x"),$s("n"))))))),Plus($s("p"),C2)),$s("x"))))),And(And(And(And(FreeQ(List($s("a"),$s("b"),$s("c"),$s("n")),$s("x")),RationalQ($s("p"))),Less($s("p"),CN1)),Unequal($s("p"),integer(-2L))),NonzeroQ(Plus(Times(Times(Power($s("b"),C2),Power($s("n"),C2)),Power(Plus($s("p"),C2),C2)),Times(CN1,C1)))))),
SetDelayed(Int(Times(Power($p("x"),$p("m",true)),Power(Sinh(Times($p("b",true),Log(Times($p("c",true),Power($p("x"),$p("n",true)))))),$p("p",true))),$p("x",$s("Symbol"))),
    Condition(Int(Times(Power($s("x"),$s("m")),Power(Plus(Times(Power(Times($s("c"),Power($s("x"),$s("n"))),$s("b")),C1D2),Times(CN1,Times(C1,Power(Times(C2,Power(Times($s("c"),Power($s("x"),$s("n"))),$s("b"))),CN1)))),$s("p"))),$s("x")),And(FreeQ($s("c"),$s("x")),RationalQ(List($s("b"),$s("m"),$s("n"),$s("p"))))))
  );
}
